class
	S_DIRENT_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	scandir (a___dir: CE_POINTER [INTEGER_8]; a___namelist: CE_POINTER [CE_POINTER [CE_POINTER [SD_DIRENT]]]; a___selector, a___cmp: CE_ROUTINE): INTEGER_32
		require
			not a___dir.is_void
			not a___namelist.is_void
		do
			Result := c_scandir (a___dir.c_pointer, a___namelist.c_pointer, a___selector.c_pointer, a___cmp.c_pointer)
		end

	c_scandir (a___dir: POINTER; a___namelist: POINTER; a___selector: POINTER; a___cmp: POINTER): INTEGER_32
		external
			"C inline use <micro_httpd.h>"
		alias
			"return scandir($a___dir, $a___namelist, $a___selector, $a___cmp);"
		end

	alphasort (a___e1, a___e2: CE_POINTER [CE_POINTER [SD_DIRENT]]): INTEGER_32
		require
			not a___e1.is_void
			not a___e2.is_void
		do
			Result := c_alphasort (a___e1.c_pointer, a___e2.c_pointer)
		end

	c_alphasort (a___e1: POINTER; a___e2: POINTER): INTEGER_32
		external
			"C inline use <micro_httpd.h>"
		alias
			"return alphasort($a___e1, $a___e2);"
		end

feature {ANY} -- routine addresses

	alphasort_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent alphasort)
		end

end
