class
	S_STRING_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	strcmp (a___s1, a___s2: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a___s1.is_void
			not a___s2.is_void
		do
			Result := c_strcmp (a___s1.c_pointer, a___s2.c_pointer)
		end

	c_strcmp (a___s1: POINTER; a___s2: POINTER): INTEGER_32
		external
			"C inline use <micro_httpd.h>"
		alias
			"return strcmp($a___s1, $a___s2);"
		end

	strncmp (a___s1, a___s2: CE_POINTER [INTEGER_8]; a___n: NATURAL_32): INTEGER_32
		require
			not a___s1.is_void
			not a___s2.is_void
		do
			Result := c_strncmp (a___s1.c_pointer, a___s2.c_pointer, a___n)
		end

	c_strncmp (a___s1: POINTER; a___s2: POINTER; a___n: NATURAL_32): INTEGER_32
		external
			"C inline use <micro_httpd.h>"
		alias
			"return strncmp($a___s1, $a___s2, $a___n);"
		end

	strchr (a___s: CE_POINTER [INTEGER_8]; a___c: INTEGER_32): CE_POINTER [INTEGER_8]
		require
			not a___s.is_void
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_strchr (a___s.c_pointer, a___c))
		end

	c_strchr (a___s: POINTER; a___c: INTEGER_32): POINTER
		external
			"C inline use <micro_httpd.h>"
		alias
			"return (EIF_POINTER)strchr($a___s, $a___c);"
		end

	strrchr (a___s: CE_POINTER [INTEGER_8]; a___c: INTEGER_32): CE_POINTER [INTEGER_8]
		require
			not a___s.is_void
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_strrchr (a___s.c_pointer, a___c))
		end

	c_strrchr (a___s: POINTER; a___c: INTEGER_32): POINTER
		external
			"C inline use <micro_httpd.h>"
		alias
			"return (EIF_POINTER)strrchr($a___s, $a___c);"
		end

	strstr (a___haystack, a___needle: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a___haystack.is_void
			not a___needle.is_void
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_strstr (a___haystack.c_pointer, a___needle.c_pointer))
		end

	c_strstr (a___haystack: POINTER; a___needle: POINTER): POINTER
		external
			"C inline use <micro_httpd.h>"
		alias
			"return (EIF_POINTER)strstr($a___haystack, $a___needle);"
		end

	strlen (a___s: CE_POINTER [INTEGER_8]): NATURAL_32
		require
			not a___s.is_void
		do
			Result := c_strlen (a___s.c_pointer)
		end

	c_strlen (a___s: POINTER): NATURAL_32
		external
			"C inline use <micro_httpd.h>"
		alias
			"return strlen($a___s);"
		end

	strcasecmp (a___s1, a___s2: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a___s1.is_void
			not a___s2.is_void
		do
			Result := c_strcasecmp (a___s1.c_pointer, a___s2.c_pointer)
		end

	c_strcasecmp (a___s1: POINTER; a___s2: POINTER): INTEGER_32
		external
			"C inline use <micro_httpd.h>"
		alias
			"return strcasecmp($a___s1, $a___s2);"
		end

end
