class
	SD_WIDGETCLASSREC

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create core_class.make
		end

feature {ANY} -- fields

	core_class: SD_CORECLASSPART assign set_core_class

feature {ANY} -- field setters

	set_core_class (a_core_class: SD_CORECLASSPART)
		do
			core_class := a_core_class
			update_memory_field ("core_class")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			core_class := a_other.core_class.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				core_class.is_equal (a_other.core_class)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("core_class")
				>>)
			init_structure_info
		end

end
