class
	SD_XRMVALUE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} addr.make
		end

feature {ANY} -- fields

	size: NATURAL_32 assign set_size

	addr: CE_POINTER [INTEGER_8] assign set_addr

feature {ANY} -- field setters

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_addr (a_addr: CE_POINTER [INTEGER_8])
		do
			addr := a_addr
			update_memory_field ("addr")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			size := a_other.size
			addr := a_other.addr
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				size = a_other.size and
				addr.is_equal (a_other.addr)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("addr")
				>>)
			init_structure_info
		end

end
