class
	P_TTYIN_STATIC

inherit
	CE_UTILITIES
	S_FCNTL_STATIC

feature {ANY} -- public routines

	open_getchr
		do
			(create {P_SCREEN_STATIC}).tty.item := open ([ce_string ("/dev/tty"), 0])
			if (create {P_SCREEN_STATIC}).tty.item < 0 then
				(create {P_SCREEN_STATIC}).tty.item := 2
			end
		end

	close_getchr
		do
		end

	getchr: INTEGER_32
		local
			l_c: CE_ARRAY [INTEGER_8]
			l_result: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_8_ARRAY} l_c.make (<<1>>)

			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_result := (create {P_OS_STATIC}).iread ((create {P_SCREEN_STATIC}).tty.item, l_c, {PLATFORM}.Integer_8_bytes.to_natural_32)
				if l_result = -2 then
					Result := (-2)
					l_return := True
				end
				if not l_return then
					if l_result < 0 then
						(create {P_MAIN_STATIC}).quit (1)
					end
					if (l_c.item).to_integer_32 = 0 then
						l_c.item := (('%/224/').code).to_integer_8
					end
					if l_result = 1 then
						l_break := True
					end
				end
			end
			if not l_return then
				l_break := False
				Result := (((l_c.item).to_integer_32).bit_and (255))
			end
		end

end
