class
	PD_OPTNAME

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} oname.make
			create {CE_CLASS_POINTER [PD_OPTNAME]} onext.make
		end

feature {ANY} -- fields

	oname: CE_POINTER [INTEGER_8] assign set_oname

	onext: CE_POINTER [PD_OPTNAME] assign set_onext

feature {ANY} -- field setters

	set_oname (a_oname: CE_POINTER [INTEGER_8])
		do
			oname := a_oname
			update_memory_field ("oname")
		end

	set_onext (a_onext: CE_POINTER [PD_OPTNAME])
		do
			onext := a_onext
			update_memory_field ("onext")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			oname := a_other.oname
			onext := a_other.onext
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				oname.is_equal (a_other.oname) and
				onext.is_equal (a_other.onext)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("oname"),
					create {CE_STRUCTURE_FIELD}.make ("onext")
				>>)
			init_structure_info
		end

end
