class
	P_LOCALCHARSET_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_STRING_STATIC
	S_STDIO_STATIC
	S_LANGINFO_STATIC

feature {ANY} -- public attributes

	charset_aliases: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

feature {ANY} -- public routines

	get_charset_aliases: CE_POINTER [INTEGER_8]
		local
			l_cp: CE_POINTER [INTEGER_8]
			l_fp: CE_POINTER [SD_IO_FILE]
			l_dir: CE_POINTER [INTEGER_8]
			l_base: CE_POINTER [INTEGER_8]
			l_file_name: CE_POINTER [INTEGER_8]
			l_dir_len: NATURAL_32
			l_base_len: NATURAL_32
			l_add_slash: INTEGER_32
			l_tmp___2: INTEGER_32
			l_res_ptr: CE_POINTER [INTEGER_8]
			l_res_size: NATURAL_32
			l_c: INTEGER_32
			l_buf1: CE_ARRAY [INTEGER_8]
			l_buf2: CE_ARRAY [INTEGER_8]
			l_l1: NATURAL_32
			l_l2: NATURAL_32
			l_old_res_ptr: CE_POINTER [INTEGER_8]
			l_return, l_break, l_continue: BOOLEAN
		do
			create {CE_INTEGER_8_ARRAY} l_buf1.make (<<51>>)
			create {CE_INTEGER_8_ARRAY} l_buf2.make (<<51>>)

			l_cp := charset_aliases.item
			if l_cp.is_void then
				l_base := ce_string ("charset.alias")
				l_dir := (getenv (ce_string ("CHARSETALIASDIR")))
				if l_dir.is_void then
					l_dir := ce_string ("/usr/local/lib")
				elseif (l_dir[0]).to_integer_32 = 0 then
					l_dir := ce_string ("/usr/local/lib")
				end
				l_dir_len := (strlen (l_dir))
				l_base_len := (strlen (l_base))
				if l_dir_len > {NATURAL_32} 0 then
					if (l_dir[(l_dir_len - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 47 then
						l_tmp___2 := 1
					else
						l_tmp___2 := 0
					end
				else
					l_tmp___2 := 0
				end
				l_add_slash := l_tmp___2
				l_file_name := create {CE_INTEGER_8_POINTER}.make_cast ((malloc (((l_dir_len + l_add_slash.to_natural_32) + l_base_len) + {NATURAL_32} 1)))
				if not l_file_name.is_void then
					memcpy (create {CE_VOID_POINTER}.make_cast (l_file_name), create {CE_VOID_POINTER}.make_cast (l_dir), l_dir_len).do_nothing
					if l_add_slash.to_boolean then
						l_file_name[l_dir_len.to_integer_32] := (('/').code).to_integer_8
					end
					memcpy (create {CE_VOID_POINTER}.make_cast (((l_file_name + l_dir_len.to_integer_32) + l_add_slash)), create {CE_VOID_POINTER}.make_cast (l_base), l_base_len + {NATURAL_32} 1).do_nothing
				end
				if l_file_name.is_void then
					l_cp := ce_string ("")
				else
					l_fp := fopen (l_file_name, ce_string ("r"))
					if l_fp.is_void then
						l_cp := ce_string ("")
					else
						l_res_ptr := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						l_res_size := (0).to_natural_32
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_continue := False
							l_c := getc_unlocked (l_fp)
							if l_c = -1 then
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								if l_c = 10 then
									l_continue := True
								elseif l_c = 32 then
									l_continue := True
								elseif l_c = 9 then
									l_continue := True
								end
							end
							if not (l_return or l_break or l_continue) and then (l_c = 35) then
								from
								until
									(l_break)
								loop
									l_break := False
									l_c := getc_unlocked (l_fp)
									if l_c = -1 then
										l_break := True
									elseif l_c = 10 then
										l_break := True
									end
								end
								l_break := False
								if l_c = -1 then
									l_break := True
								end
								if not (l_return or l_break or l_continue) then
									l_continue := True
								end
							end
							if not (l_return or l_break or l_continue) then
								ungetc (l_c, l_fp).do_nothing
								if (fscanf ([l_fp, ce_string ("%%50s %%50s"), l_buf1, l_buf2])) < 2 then
									l_break := True
								end
							end
							if not (l_return or l_break or l_continue) then
								l_l1 := strlen (l_buf1)
								l_l2 := strlen (l_buf2)
								l_old_res_ptr := l_res_ptr
								if l_res_size = {NATURAL_32} 0 then
									l_res_size := ((l_l1 + {NATURAL_32} 1) + l_l2) + {NATURAL_32} 1
									l_res_ptr := create {CE_INTEGER_8_POINTER}.make_cast ((malloc (l_res_size + {NATURAL_32} 1)))
								else
									l_res_size := l_res_size + (((l_l1 + {NATURAL_32} 1) + l_l2) + {NATURAL_32} 1)
									l_res_ptr := create {CE_INTEGER_8_POINTER}.make_cast ((realloc (create {CE_VOID_POINTER}.make_cast (l_res_ptr), l_res_size + {NATURAL_32} 1)))
								end
								if l_res_ptr.is_void then
									l_res_size := (0).to_natural_32
									if not l_old_res_ptr.is_void then
										free (create {CE_VOID_POINTER}.make_cast (l_old_res_ptr))
									end
									l_break := True
								end
							end
							if not (l_return or l_break or l_continue) then
								strcpy ((((l_res_ptr + l_res_size.to_integer_32) - (l_l2 + {NATURAL_32} 1).to_integer_32) - (l_l1 + {NATURAL_32} 1).to_integer_32), l_buf1).do_nothing
								strcpy (((l_res_ptr + l_res_size.to_integer_32) - (l_l2 + {NATURAL_32} 1).to_integer_32), l_buf2).do_nothing
							end
							if (not l_return and not l_break) then
								
							end
						end
						l_break := False
						l_continue := False
						fclose (l_fp).do_nothing
						if l_res_size = {NATURAL_32} 0 then
							l_cp := ce_string ("")
						else
							l_res_ptr[l_res_size.to_integer_32] := (('%/0/').code).to_integer_8
							l_cp := l_res_ptr
						end
					end
				end
				if not l_file_name.is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_file_name))
				end
				charset_aliases.item := l_cp
			end
			Result := l_cp
		end

	locale_charset: CE_POINTER [INTEGER_8]
		local
			l_codeset: CE_POINTER [INTEGER_8]
			l_aliases: CE_POINTER [INTEGER_8]
			l_tmp___2: NATURAL_32
			l_break: BOOLEAN
		do
			l_codeset := (nl_langinfo (14))
			if l_codeset.is_void then
				l_codeset := ce_string ("")
			end
			l_aliases := get_charset_aliases
			from
			until
				not (not (l_break) and then ((l_aliases[0]).to_integer_32 /= 0))
			loop
				l_break := False
				if (strcmp (l_codeset, l_aliases)) = 0 then
					l_tmp___2 := strlen (l_aliases)
					l_codeset := (l_aliases + l_tmp___2.to_integer_32) + 1
					l_break := True
				elseif (l_aliases[0]).to_integer_32 = 42 then
					if (l_aliases[1]).to_integer_32 = 0 then
						l_tmp___2 := strlen (l_aliases)
						l_codeset := (l_aliases + l_tmp___2.to_integer_32) + 1
						l_break := True
					end
				end
				if not (l_break) then
					l_aliases := l_aliases + ((strlen (l_aliases)) + {NATURAL_32} 1).to_integer_32
					l_aliases := l_aliases + ((strlen (l_aliases)) + {NATURAL_32} 1).to_integer_32
				end
			end
			l_break := False
			if (l_codeset[0]).to_integer_32 = 0 then
				l_codeset := ce_string ("ASCII")
			end
			Result := l_codeset
		end

end
