class
	P_XALLOC_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	xnmalloc (a_n, a_s: NATURAL_32): CE_POINTER [ANY]
		local
			l_tmp: INTEGER_32
		do
			if {PLATFORM}.Integer_32_bytes.to_natural_32 <= {PLATFORM}.Natural_32_bytes.to_natural_32 then
				l_tmp := -1
			else
				l_tmp := -2
			end
			if l_tmp.to_natural_32 // a_s < a_n then
				(create {P_XALLOC_DIE_STATIC}).xalloc_die
			end
			Result := ((create {P_XMALLOC_STATIC}).xmalloc (a_n * a_s))
		end

	xcharalloc (a_n: NATURAL_32): CE_POINTER [INTEGER_8]
		local
			l_tmp___1: CE_POINTER [ANY]
		do
			if {PLATFORM}.Integer_8_bytes.to_natural_32 = {NATURAL_32} 1 then
				l_tmp___1 := ((create {P_XMALLOC_STATIC}).xmalloc (a_n))
			else
				l_tmp___1 := (xnmalloc (a_n, {PLATFORM}.Integer_8_bytes.to_natural_32))
			end
			Result := (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___1))
		end

	x2nrealloc (a_p___0: CE_POINTER [ANY]; a_pn: CE_POINTER [NATURAL_32]; a_s: NATURAL_32): CE_POINTER [ANY]
		require
			not a_pn.is_void
		local
			l_n: NATURAL_32
		do
			l_n := a_pn.item
			if a_p___0.is_void then
				if not l_n.to_boolean then
					l_n := {NATURAL_32} 64 // a_s
					l_n := l_n + (not l_n.to_boolean).to_integer.to_natural_32
				end
			else
				if {NATURAL_32} 2_863_311_530 // a_s <= l_n then
					(create {P_XALLOC_DIE_STATIC}).xalloc_die
				end
				l_n := l_n + ((l_n + {NATURAL_32} 1) // {NATURAL_32} 2)
			end
			a_pn.item := l_n
			Result := ((create {P_XMALLOC_STATIC}).xrealloc (a_p___0, l_n * a_s))
		end

end
