class
	PD_POINT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

feature {ANY} -- field setters

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			x := a_other.x
			y := a_other.y
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				x = a_other.x and
				y = a_other.y
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y")
				>>)
			init_structure_info
		end

end
