class
	PD_S_MSG_DSC

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} msg.make
		end

feature {ANY} -- fields

	n: INTEGER_32 assign set_n

	msg: CE_POINTER [NATURAL_8] assign set_msg

feature {ANY} -- field setters

	set_n (a_n: INTEGER_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_msg (a_msg: CE_POINTER [NATURAL_8])
		do
			msg := a_msg
			update_memory_field ("msg")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			n := a_other.n
			msg := a_other.msg
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				n = a_other.n and
				msg.is_equal (a_other.msg)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make ("msg")
				>>)
			init_structure_info
		end

end
