class
	PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_PART]} p.make
			create {CE_INTEGER_32_POINTER} min_c.make
			create {CE_INTEGER_32_POINTER} max_c.make
			create {CE_INTEGER_32_POINTER} w_c.make
			create {CE_CLASS_POINTER [PD_TABLE_CELL]} cells.make
			create {CE_CLASS_POINTER [PD_TABLE_COLUMN]} cols.make
			create {CE_INTEGER_32_POINTER} xcols.make
			create {CE_INTEGER_32_POINTER} r_heights.make
			Precursor
		end

feature {ANY} -- fields

	p: CE_POINTER [PD_PART] assign set_p

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	rx: INTEGER_32 assign set_rx

	ry: INTEGER_32 assign set_ry

	border: INTEGER_32 assign set_border

	cellpd: INTEGER_32 assign set_cellpd

	vcellpd: INTEGER_32 assign set_vcellpd

	cellsp: INTEGER_32 assign set_cellsp

	frame: INTEGER_32 assign set_frame

	rules: INTEGER_32 assign set_rules

	width: INTEGER_32 assign set_width

	wf: INTEGER_32 assign set_wf

	min_c: CE_POINTER [INTEGER_32] assign set_min_c

	max_c: CE_POINTER [INTEGER_32] assign set_max_c

	w_c: CE_POINTER [INTEGER_32] assign set_w_c

	rw: INTEGER_32 assign set_rw

	min_t: INTEGER_32 assign set_min_t

	max_t: INTEGER_32 assign set_max_t

	cells: CE_POINTER [PD_TABLE_CELL] assign set_cells

	c: INTEGER_32 assign set_c

	rc: INTEGER_32 assign set_rc

	cols: CE_POINTER [PD_TABLE_COLUMN] assign set_cols

	xc: INTEGER_32 assign set_xc

	xcols: CE_POINTER [INTEGER_32] assign set_xcols

	r_heights: CE_POINTER [INTEGER_32] assign set_r_heights

	rh: INTEGER_32 assign set_rh

	link_num: INTEGER_32 assign set_link_num

feature {ANY} -- field setters

	set_p (a_p: CE_POINTER [PD_PART])
		do
			p := a_p
			update_memory_field ("p")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_rx (a_rx: INTEGER_32)
		do
			rx := a_rx
			update_memory_field ("rx")
		end

	set_ry (a_ry: INTEGER_32)
		do
			ry := a_ry
			update_memory_field ("ry")
		end

	set_border (a_border: INTEGER_32)
		do
			border := a_border
			update_memory_field ("border")
		end

	set_cellpd (a_cellpd: INTEGER_32)
		do
			cellpd := a_cellpd
			update_memory_field ("cellpd")
		end

	set_vcellpd (a_vcellpd: INTEGER_32)
		do
			vcellpd := a_vcellpd
			update_memory_field ("vcellpd")
		end

	set_cellsp (a_cellsp: INTEGER_32)
		do
			cellsp := a_cellsp
			update_memory_field ("cellsp")
		end

	set_frame (a_frame: INTEGER_32)
		do
			frame := a_frame
			update_memory_field ("frame")
		end

	set_rules (a_rules: INTEGER_32)
		do
			rules := a_rules
			update_memory_field ("rules")
		end

	set_width (a_width: INTEGER_32)
		do
			width := a_width
			update_memory_field ("width")
		end

	set_wf (a_wf: INTEGER_32)
		do
			wf := a_wf
			update_memory_field ("wf")
		end

	set_min_c (a_min_c: CE_POINTER [INTEGER_32])
		do
			min_c := a_min_c
			update_memory_field ("min_c")
		end

	set_max_c (a_max_c: CE_POINTER [INTEGER_32])
		do
			max_c := a_max_c
			update_memory_field ("max_c")
		end

	set_w_c (a_w_c: CE_POINTER [INTEGER_32])
		do
			w_c := a_w_c
			update_memory_field ("w_c")
		end

	set_rw (a_rw: INTEGER_32)
		do
			rw := a_rw
			update_memory_field ("rw")
		end

	set_min_t (a_min_t: INTEGER_32)
		do
			min_t := a_min_t
			update_memory_field ("min_t")
		end

	set_max_t (a_max_t: INTEGER_32)
		do
			max_t := a_max_t
			update_memory_field ("max_t")
		end

	set_cells (a_cells: CE_POINTER [PD_TABLE_CELL])
		do
			cells := a_cells
			update_memory_field ("cells")
		end

	set_c (a_c: INTEGER_32)
		do
			c := a_c
			update_memory_field ("c")
		end

	set_rc (a_rc: INTEGER_32)
		do
			rc := a_rc
			update_memory_field ("rc")
		end

	set_cols (a_cols: CE_POINTER [PD_TABLE_COLUMN])
		do
			cols := a_cols
			update_memory_field ("cols")
		end

	set_xc (a_xc: INTEGER_32)
		do
			xc := a_xc
			update_memory_field ("xc")
		end

	set_xcols (a_xcols: CE_POINTER [INTEGER_32])
		do
			xcols := a_xcols
			update_memory_field ("xcols")
		end

	set_r_heights (a_r_heights: CE_POINTER [INTEGER_32])
		do
			r_heights := a_r_heights
			update_memory_field ("r_heights")
		end

	set_rh (a_rh: INTEGER_32)
		do
			rh := a_rh
			update_memory_field ("rh")
		end

	set_link_num (a_link_num: INTEGER_32)
		do
			link_num := a_link_num
			update_memory_field ("link_num")
		end

feature {PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS} -- private attributes

	frame_table: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					0, 179, 186, 196, 192, 211, 205, 212, 200, 196, 217, 189, 196, 193, 208, 205, 212, 200, 205, 190,
					188, 205, 190, 188, 205, 207, 202, 179, 179, 186, 218, 195, 211, 213, 198, 200, 191, 180, 189, 194,
					197, 208, 213, 198, 200, 184, 181, 188, 184, 181, 188, 209, 216, 202, 186, 186, 186, 214, 214, 199,
					201, 201, 204, 183, 183, 182, 210, 210, 215, 201, 201, 204, 187, 187, 185, 187, 187, 185, 203, 203,
					206
				>>)
		end

	hline_table: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					32, 196, 205
				>>)
		end

	vline_table: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					32, 179, 186
				>>)
		end

feature {ANY} -- public routines

	free_table
		do
			if (not min_c.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 164, create {CE_VOID_POINTER}.make_cast (min_c))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not max_c.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 165, create {CE_VOID_POINTER}.make_cast (max_c))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not w_c.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 166, create {CE_VOID_POINTER}.make_cast (w_c))
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 167, create {CE_VOID_POINTER}.make_cast (r_heights))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 168, create {CE_VOID_POINTER}.make_cast (cols))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 169, create {CE_VOID_POINTER}.make_cast (xcols))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 170, create {CE_VOID_POINTER}.make_cast (cells))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 171, create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

	expand_cells (a_x, a_y: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_return: BOOLEAN
		do
			if a_x >= x then
				if x.to_boolean then
					l_i := 0
					from
					until
						not (not (l_return) and then (l_i < y))
					loop
						if (cells + (l_i * rx + (x - 1))).item.colspan = -1 then
							l_j := x
							from
							until
								not (l_j <= a_x)
							loop
								(cells + (l_i * rx + l_j)).item.used := 1
								update_class_fields; -- Current might have been changed; synchronize
								(cells + (l_i * rx + l_j)).item.spanned := 1
								update_class_fields; -- Current might have been changed; synchronize
								(cells + (l_i * rx + l_j)).item.rowspan := (cells + (l_i * rx + (x - 1))).item.rowspan
								update_class_fields; -- Current might have been changed; synchronize
								(cells + (l_i * rx + l_j)).item.colspan := -1
								update_class_fields; -- Current might have been changed; synchronize
								(cells + (l_i * rx + l_j)).item.mx := (cells + (l_i * rx + (x - 1))).item.mx
								update_class_fields; -- Current might have been changed; synchronize
								(cells + (l_i * rx + l_j)).item.my := (cells + (l_i * rx + (x - 1))).item.my
								update_class_fields -- Current might have been changed; synchronize
								l_j := l_j + 1
							end
						end
						l_i := l_i + 1
					end
				end
				Current.x := a_x + 1
				update_class_fields -- Current might have been changed; synchronize
			end
			if a_y >= y then
				if y.to_boolean then
					l_i := 0
					from
					until
						not (not (l_return) and then (l_i < x))
					loop
						if (cells + ((y - 1) * rx + l_i)).item.rowspan = -1 then
							l_j := y
							from
							until
								not (l_j <= a_y)
							loop
								(cells + (l_j * rx + l_i)).item.used := 1
								update_class_fields; -- Current might have been changed; synchronize
								(cells + (l_j * rx + l_i)).item.spanned := 1
								update_class_fields; -- Current might have been changed; synchronize
								(cells + (l_j * rx + l_i)).item.rowspan := -1
								update_class_fields; -- Current might have been changed; synchronize
								(cells + (l_j * rx + l_i)).item.colspan := (cells + ((y - 1) * rx + l_i)).item.colspan
								update_class_fields; -- Current might have been changed; synchronize
								(cells + (l_j * rx + l_i)).item.mx := (cells + ((y - 1) * rx + l_i)).item.mx
								update_class_fields; -- Current might have been changed; synchronize
								(cells + (l_j * rx + l_i)).item.my := (cells + ((y - 1) * rx + l_i)).item.my
								update_class_fields -- Current might have been changed; synchronize
								l_j := l_j + 1
							end
						end
						l_i := l_i + 1
					end
				end
				Current.y := a_y + 1
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	new_cell (a_x, a_y: INTEGER_32): CE_POINTER [PD_TABLE_CELL]
		local
			l_nt: PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_tmp: CE_POINTER [ANY]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create l_nt.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_x < x then
						if a_y < y then
							l_pos := -1 + 3 -- goto ret
						end
					end
				when 1 then -- rep:
					if a_x < rx then
						if a_y < ry then
							((create {CE_CLASS_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]}.make_shared (c_pointer))).item.expand_cells (a_x, a_y)
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 3 -- goto ret
						end
					end
				when 2 then
					l_nt.rx := rx
					update_class_fields -- Current might have been changed; synchronize
					l_nt.ry := ry
					update_class_fields -- Current might have been changed; synchronize
					from
					until
						not (not (l_return) and then (a_x >= l_nt.rx))
					loop
						if (l_nt.rx).to_natural_32 > {NATURAL_32} 1_073_741_823 then
							from
							until
								False
							loop
								(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 222])
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_KBD_STATIC}).fatal_tty_exit
								update_class_fields -- Current might have been changed; synchronize
								exit (4)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_nt.rx := l_nt.rx * (2)
						update_class_fields -- Current might have been changed; synchronize
					end
					from
					until
						not (not (l_return) and then (a_y >= l_nt.ry))
					loop
						if (l_nt.ry).to_natural_32 > {NATURAL_32} 1_073_741_823 then
							from
							until
								False
							loop
								(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 226])
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_KBD_STATIC}).fatal_tty_exit
								update_class_fields -- Current might have been changed; synchronize
								exit (4)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_nt.ry := l_nt.ry * (2)
						update_class_fields -- Current might have been changed; synchronize
					end
					if ((l_nt.rx).to_natural_32 * (l_nt.ry).to_natural_32) // (l_nt.rx).to_natural_32 /= (l_nt.ry).to_natural_32 then
						from
						until
							False
						loop
							(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 229])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_KBD_STATIC}).fatal_tty_exit
							update_class_fields -- Current might have been changed; synchronize
							exit (4)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if (l_nt.rx).to_natural_32 * (l_nt.ry).to_natural_32 > {NATURAL_32} 2_147_483_647 // (create {PD_TABLE_CELL}.make).structure_size.to_natural_32 then
						from
						until
							False
						loop
							(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 230])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_KBD_STATIC}).fatal_tty_exit
							update_class_fields -- Current might have been changed; synchronize
							exit (4)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 231, (l_nt.rx * l_nt.ry).to_natural_32 * (create {PD_TABLE_CELL}.make).structure_size.to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_nt.cells := create {CE_CLASS_POINTER [PD_TABLE_CELL]}.make_cast (l_tmp)
					update_class_fields -- Current might have been changed; synchronize
					memset (create {CE_VOID_POINTER}.make_cast (l_nt.cells), 0, (l_nt.rx * l_nt.ry).to_natural_32 * (create {PD_TABLE_CELL}.make).structure_size.to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_i := 0
					from
					until
						not (not (l_return) and then (l_i < x))
					loop
						l_j := 0
						from
						until
							not (l_j < y)
						loop
							memcpy (create {CE_VOID_POINTER}.make_cast ((l_nt.cells + (l_j * l_nt.rx + l_i))), create {CE_VOID_POINTER}.make_cast ((cells + (l_j * rx + l_i))), (create {PD_TABLE_CELL}.make).structure_size.to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_j := l_j + 1
						end
						l_i := l_i + 1
					end
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 236, create {CE_VOID_POINTER}.make_cast (cells))
					update_class_fields -- Current might have been changed; synchronize
					Current.cells := l_nt.cells
					update_class_fields -- Current might have been changed; synchronize
					Current.rx := l_nt.rx
					update_class_fields -- Current might have been changed; synchronize
					Current.ry := l_nt.ry
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 1 -- goto rep
				when 3 then -- ret:
					Result := (cells + (a_y * rx + a_x))
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	new_columns (a_span, a_width, a_align, a_valign, a_group: INTEGER_32)
		local
			l_span: INTEGER_32
			l_group: INTEGER_32
			l_n: INTEGER_32
			l_nc: CE_POINTER [PD_TABLE_COLUMN]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_span := a_span
			l_group := a_group
			if c.to_natural_32 + l_span.to_natural_32 > {NATURAL_32} 2_147_483_647 then
				from
				until
					False
				loop
					(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 248])
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_KBD_STATIC}).fatal_tty_exit
					update_class_fields -- Current might have been changed; synchronize
					exit (4)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if c + l_span > rc then
				l_n := rc
				from
				until
					not (not (l_return) and then (c + l_span > l_n))
				loop
					if l_n.to_natural_32 > {NATURAL_32} 1_073_741_823 then
						from
						until
							False
						loop
							(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 253])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_KBD_STATIC}).fatal_tty_exit
							update_class_fields -- Current might have been changed; synchronize
							exit (4)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					l_n := l_n * (2)
				end
				if l_n.to_natural_32 > {NATURAL_32} 2_147_483_647 // (create {PD_TABLE_COLUMN}.make).structure_size.to_natural_32 then
					from
					until
						False
					loop
						(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 256])
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_KBD_STATIC}).fatal_tty_exit
						update_class_fields -- Current might have been changed; synchronize
						exit (4)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				l_tmp := (create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 257, create {CE_VOID_POINTER}.make_cast (cols), l_n.to_natural_32 * (create {PD_TABLE_COLUMN}.make).structure_size.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_nc := create {CE_CLASS_POINTER [PD_TABLE_COLUMN]}.make_cast (l_tmp)
				Current.rc := l_n
				update_class_fields -- Current might have been changed; synchronize
				Current.cols := l_nc
				update_class_fields -- Current might have been changed; synchronize
			end
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp___1 := l_span
				l_span := l_span - 1
				if not l_tmp___1.to_boolean then
					l_break := True
				end
				if not (l_return or l_break) then
					(cols + c).item.align := a_align
					update_class_fields; -- Current might have been changed; synchronize
					(cols + c).item.valign := a_valign
					update_class_fields; -- Current might have been changed; synchronize
					(cols + c).item.width := a_width
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___0 := c
					Current.c := c + 1
					update_class_fields; -- Current might have been changed; synchronize
					(cols + l_tmp___0).item.group := l_group
					update_class_fields -- Current might have been changed; synchronize
					l_group := 0
				end
			end
			l_break := False
		end

	set_td_width (a_x, a_width, a_f: INTEGER_32)
		local
			l_n: INTEGER_32
			l_tmp: INTEGER_32
			l_i: INTEGER_32
			l_nc: CE_POINTER [INTEGER_32]
			l_tmp___0: CE_POINTER [ANY]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_x >= xc then
						if xc.to_boolean then
							l_tmp := xc
						else
							l_tmp := 1
						end
						l_n := l_tmp
						from
						until
							not (not (l_return) and then (a_x >= l_n))
						loop
							if l_n.to_natural_32 > {NATURAL_32} 1_073_741_823 then
								from
								until
									False
								loop
									(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 277])
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_KBD_STATIC}).fatal_tty_exit
									update_class_fields -- Current might have been changed; synchronize
									exit (4)
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							l_n := l_n * (2)
						end
						if l_n.to_natural_32 > {NATURAL_32} 2_147_483_647 // {PLATFORM}.Integer_32_bytes.to_natural_32 then
							from
							until
								False
							loop
								(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 280])
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_KBD_STATIC}).fatal_tty_exit
								update_class_fields -- Current might have been changed; synchronize
								exit (4)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_tmp___0 := (create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 281, create {CE_VOID_POINTER}.make_cast (xcols), l_n.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_nc := create {CE_INTEGER_32_POINTER}.make_cast (l_tmp___0)
						l_i := xc
						from
						until
							not (l_i < l_n)
						loop
							l_nc[l_i] := -1
							update_class_fields -- Current might have been changed; synchronize
							l_i := l_i + 1
						end
						Current.xc := l_n
						update_class_fields -- Current might have been changed; synchronize
						Current.xcols := l_nc
						update_class_fields -- Current might have been changed; synchronize
					end
					if xcols[a_x] /= -1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto set
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (a_f.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | set:
						xcols[a_x] := a_width
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
				when 5 then -- if done
					if not l_return and then (a_width = -1) then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 6 then -- if:
						if a_width < 0 then
							if xcols[a_x] >= 0 then
								l_pos := -1 + 4 -- goto set
							end
						end
				when 7 then
						if a_width >= 0 then
							if xcols[a_x] < 0 then
								l_return := True
							end
						end
				when 8 then -- if done
					if not l_return then
						xcols[a_x] := (xcols[a_x] + a_width) // 2
						update_class_fields -- Current might have been changed; synchronize
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_cell_widths
		local
			l_nl: CE_ARRAY [INTEGER_32]
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_c: CE_POINTER [PD_TABLE_CELL]
			l_c___0: CE_POINTER [PD_TABLE_CELL]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_nl.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_nl.item := p.item.link_num
					update_class_fields -- Current might have been changed; synchronize
					if ((create {P_LINKS_STATIC}).d_opt.item.item.table_order).to_boolean then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						l_j := 0
				when 2 then -- loop condition:
						if not (not (l_return) and then (l_j < y)) then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						l_i := 0
				when 4 then -- loop condition:
						if not (not (l_return) and then (l_i < x)) then
							l_pos := -1 + 9 -- skip loop
						end
				when 5 then -- loop body: | loop condition:
						if (l_break) then
							l_pos := -1 + 8 -- skip loop
						end
				when 6 then -- loop body:
						l_break := False
						l_continue := False
						l_c := cells + (l_j * rx + l_i)
						if (l_c.item.start).is_void then
							l_continue := True
						end
						if not (l_break or l_continue) then
							l_c.item.link_num := l_nl.item
							update_class_fields -- Current might have been changed; synchronize
							get_cell_width (create {CE_INTEGER_8_POINTER}.make_cast (l_c.item.start), create {CE_INTEGER_8_POINTER}.make_cast (l_c.item.end2), cellpd, 0, 0, create {CE_INTEGER_32_POINTER}.make_shared (l_c.c_pointer + (create {PD_TABLE_CELL}.make).offset_of ("min_width")), create {CE_INTEGER_32_POINTER}.make_shared (l_c.c_pointer + (create {PD_TABLE_CELL}.make).offset_of ("max_width")), l_nl.item, l_nl)
							update_class_fields -- Current might have been changed; synchronize
						end
						if (not l_break) then
							l_pos := -1 + 8 -- break
						end
				when 7 then
						l_pos := -1 + 5 -- back to loop condition
				when 8 then -- loop done
						l_break := False
						l_continue := False
						l_i := l_i + 1
						l_pos := -1 + 4 -- back to loop condition
				when 9 then -- loop done
						l_j := l_j + 1
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done | if block done, skip else block:
						l_pos := -1 + 20
				when 11 then -- else:
						l_i := 0
				when 12 then -- loop condition:
						if not (not (l_return) and then (l_i < x)) then
							l_pos := -1 + 20 -- skip loop
						end
				when 13 then -- loop body:
						l_j := 0
				when 14 then -- loop condition:
						if not (not (l_return) and then (l_j < y)) then
							l_pos := -1 + 19 -- skip loop
						end
				when 15 then -- loop body: | loop condition:
						if (l_break) then
							l_pos := -1 + 18 -- skip loop
						end
				when 16 then -- loop body:
						l_break := False
						l_continue := False
						l_c___0 := cells + (l_j * rx + l_i)
						if (l_c___0.item.start).is_void then
							l_continue := True
						end
						if not (l_return or l_break or l_continue) then
							l_c___0.item.link_num := l_nl.item
							update_class_fields -- Current might have been changed; synchronize
							get_cell_width (create {CE_INTEGER_8_POINTER}.make_cast (l_c___0.item.start), create {CE_INTEGER_8_POINTER}.make_cast (l_c___0.item.end2), cellpd, 0, 0, create {CE_INTEGER_32_POINTER}.make_shared (l_c___0.c_pointer + (create {PD_TABLE_CELL}.make).offset_of ("min_width")), create {CE_INTEGER_32_POINTER}.make_shared (l_c___0.c_pointer + (create {PD_TABLE_CELL}.make).offset_of ("max_width")), l_nl.item, l_nl)
							update_class_fields -- Current might have been changed; synchronize
						end
						if (not l_break) then
							l_pos := -1 + 18 -- break
						end
				when 17 then
						l_pos := -1 + 15 -- back to loop condition
				when 18 then -- loop done
						l_break := False
						l_continue := False
						l_j := l_j + 1
						l_pos := -1 + 14 -- back to loop condition
				when 19 then -- loop done
						l_i := l_i + 1
						l_pos := -1 + 12 -- back to loop condition
				when 20 then -- loop done | if done
					Current.link_num := l_nl.item
					update_class_fields -- Current might have been changed; synchronize
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_vline_width (a_col: INTEGER_32): INTEGER_32
		local
			l_w: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_w := 0
			if not a_col.to_boolean then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				if rules = 2 then
					l_w := cellsp
				elseif rules = 3 then
					l_w := cellsp
				elseif rules = 4 then
					if a_col < c then
						if ((cols + a_col).item.group).to_boolean then
							l_tmp := 1
						else
							l_tmp := 0
						end
					else
						l_tmp := 0
					end
					l_w := l_tmp
				end
				if not l_w.to_boolean then
					if cellpd.to_boolean then
						l_w := -1
					end
				end
				Result := l_w
			end
		end

	get_column_widths: INTEGER_32
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_s: INTEGER_32
			l_ns: INTEGER_32
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [ANY]
			l_tmp___1: CE_POINTER [ANY]
			l_c: CE_POINTER [PD_TABLE_CELL]
			l_k: INTEGER_32
			l_p: INTEGER_32
			l_m: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			if x.to_natural_32 > {NATURAL_32} 2_147_483_647 // {PLATFORM}.Integer_32_bytes.to_natural_32 then
				from
				until
					False
				loop
					(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 632])
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_KBD_STATIC}).fatal_tty_exit
					update_class_fields -- Current might have been changed; synchronize
					exit (4)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if min_c.is_void then
				l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 633, x.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				Current.min_c := create {CE_INTEGER_32_POINTER}.make_cast (l_tmp)
				update_class_fields -- Current might have been changed; synchronize
			end
			if max_c.is_void then
				l_tmp___0 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 634, x.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				Current.max_c := create {CE_INTEGER_32_POINTER}.make_cast (l_tmp___0)
				update_class_fields -- Current might have been changed; synchronize
			end
			if w_c.is_void then
				l_tmp___1 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 635, x.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				Current.w_c := create {CE_INTEGER_32_POINTER}.make_cast (l_tmp___1)
				update_class_fields -- Current might have been changed; synchronize
			end
			memset (create {CE_VOID_POINTER}.make_cast (min_c), 0, x.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			memset (create {CE_VOID_POINTER}.make_cast (max_c), 0, x.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_s := 1
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_ns := 2_147_483_647
				l_i := 0
				from
				until
					not (not (l_return) and then (l_i < x))
				loop
					l_j := 0
					from
					until
						not (not (l_return) and then (l_j < y))
					loop
						l_continue := False
						l_c := cells + (l_j * rx + l_i)
						if (l_c.item.spanned).to_boolean then
							l_continue := True
						elseif not (l_c.item.used).to_boolean then
							l_continue := True
						end
						if not (l_return or l_continue) and then (l_c.item.colspan + l_i > x) then
							l_continue := True
						end
						if not (l_return or l_continue) then
							if l_c.item.colspan = l_s then
								l_p := 0
								l_m := 0
								l_k := 1
								from
								until
									not (l_k < l_s)
								loop
									l_tmp___2 := ((create {CE_CLASS_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]}.make_shared (c_pointer))).item.get_vline_width (l_i + l_k)
									update_class_fields -- Current might have been changed; synchronize
									l_p := l_p + (l_tmp___2 >= 0).to_integer
									l_k := l_k + 1
								end
								dst_width (min_c + l_i, l_s, l_c.item.min_width - l_p, max_c + l_i)
								update_class_fields -- Current might have been changed; synchronize
								dst_width (max_c + l_i, l_s, (l_c.item.max_width - l_p) - l_m, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
								update_class_fields -- Current might have been changed; synchronize
								l_k := 0
								from
								until
									not (l_k < l_s)
								loop
									if min_c[(l_i + l_k)] > max_c[(l_i + l_k)] then
										max_c[(l_i + l_k)] := min_c[(l_i + l_k)]
										update_class_fields -- Current might have been changed; synchronize
									end
									l_k := l_k + 1
								end
							elseif l_c.item.colspan > l_s then
								if l_c.item.colspan < l_ns then
									l_ns := l_c.item.colspan
								end
							end
						end
						if (not l_return) then
							l_j := l_j + 1
						end
					end
					l_continue := False
					l_i := l_i + 1
				end
				l_s := l_ns
				if l_s = 2_147_483_647 then
					l_break := True
				end
			end
			l_break := False
			Result := 0
		end

	get_table_width
		local
			l_i: INTEGER_32
			l_vl: INTEGER_32
			l_min: INTEGER_32
			l_max: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_min := 0
			l_max := 0
			l_i := 0
			from
			until
				not (l_i < x)
			loop
				l_tmp := ((create {CE_CLASS_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]}.make_shared (c_pointer))).item.get_vline_width (l_i)
				update_class_fields -- Current might have been changed; synchronize
				l_vl := (l_tmp >= 0).to_integer
				l_min := l_min + l_vl
				l_max := l_max + l_vl
				l_min := l_min + (min_c[l_i])
				if xcols[l_i] > max_c[l_i] then
					l_max := l_max + (xcols[l_i])
				end
				l_max := l_max + (max_c[l_i])
				l_i := l_i + 1
			end
			l_vl := ((((frame).bit_and (4)).to_boolean).to_integer + (((frame).bit_and (8)).to_boolean).to_integer) * (border.to_boolean).to_integer
			l_min := l_min + l_vl
			l_max := l_max + l_vl
			Current.min_t := l_min
			update_class_fields -- Current might have been changed; synchronize
			Current.max_t := l_max
			update_class_fields -- Current might have been changed; synchronize
		end

	distribute_widths (a_width: INTEGER_32)
		local
			l_i: INTEGER_32
			l_d: INTEGER_32
			l_om: INTEGER_32
			l_u: CE_POINTER [INTEGER_8]
			l_w: CE_POINTER [INTEGER_32]
			l_mx: CE_POINTER [INTEGER_32]
			l_mmax_c: INTEGER_32
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [ANY]
			l_tmp___1: CE_POINTER [ANY]
			l_mss: INTEGER_32
			l_mii: INTEGER_32
			l_p: INTEGER_32
			l_wq: INTEGER_32
			l_dd: INTEGER_32
			l_tmp___2: INTEGER_32
			l_ss: INTEGER_32
			l_q: INTEGER_32
			l_return, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_d := a_width - min_t
					l_om := 0
					l_mmax_c := 0
					if not x.to_boolean then
						l_return := True
					end
					if not l_return and then (l_d < 0) then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 26 -- skip if block
					end
				when 1 then -- if:
						l_i := 0
						from
						until
							not (l_i < x)
						loop
							if max_c[l_i] > l_mmax_c then
								l_mmax_c := max_c[l_i]
							end
							l_i := l_i + 1
						end
						memcpy (create {CE_VOID_POINTER}.make_cast (w_c), create {CE_VOID_POINTER}.make_cast (min_c), x.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						Current.rw := a_width
						update_class_fields -- Current might have been changed; synchronize
						if x.to_natural_32 > {NATURAL_32} 2_147_483_647 // {PLATFORM}.Integer_32_bytes.to_natural_32 then
							from
							until
								False
							loop
								(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 711])
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_KBD_STATIC}).fatal_tty_exit
								update_class_fields -- Current might have been changed; synchronize
								exit (4)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 712, x.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_u := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp)
						l_tmp___0 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 713, x.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_w := create {CE_INTEGER_32_POINTER}.make_cast (l_tmp___0)
						l_tmp___1 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 714, x.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_mx := create {CE_INTEGER_32_POINTER}.make_cast (l_tmp___1)
				when 2 then -- loop condition:
						if not (not (l_return) and then (l_d.to_boolean)) then
							l_pos := -1 + 24 -- skip loop
						end
				when 3 then -- loop body:
						l_continue := False
						l_p := 0
						memset (create {CE_VOID_POINTER}.make_cast (l_w), 0, x.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						memset (create {CE_VOID_POINTER}.make_cast (l_mx), 0, x.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_i := 0
				when 4 then -- loop condition:
						if not (l_i < x) then
							l_pos := -1 + 20 -- skip loop
						end
				when 5 then -- loop body:
						inspect l_om -- switch 1 head
						when 0 then l_pos := -1 + 6
						when 1 then l_pos := -1 + 7
						when 2 then l_pos := -1 + 8
						when 3 then l_pos := -1 + 8
						when 4 then l_pos := -1 + 15
						when 5 then l_pos := -1 + 16
						when 6 then l_pos := -1 + 17
						else l_pos := -1 + 18
						end
				when 6 then -- switch 1, case 0
						if w_c[l_i] < xcols[l_i] then
							l_w[l_i] := 1
							update_class_fields -- Current might have been changed; synchronize
							if xcols[l_i] > max_c[l_i] then
								l_tmp___2 := max_c[l_i]
							else
								l_tmp___2 := xcols[l_i]
							end
							l_mx[l_i] := l_tmp___2 - w_c[l_i]
							update_class_fields -- Current might have been changed; synchronize
							if l_mx[l_i] <= 0 then
								l_w[l_i] := 0
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_pos := -1 + 19 -- switch 1; break
				when 7 then -- switch 1, case 1
						if xcols[l_i] < -1 then
							if xcols[l_i] /= -2 then
								if xcols[l_i] <= -2 then
									l_w[l_i] := -2 - xcols[l_i]
									update_class_fields -- Current might have been changed; synchronize
								else
									l_w[l_i] := 1
									update_class_fields -- Current might have been changed; synchronize
								end
								l_mx[l_i] := max_c[l_i] - w_c[l_i]
								update_class_fields -- Current might have been changed; synchronize
								if l_mx[l_i] <= 0 then
									l_w[l_i] := 0
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						l_pos := -1 + 19 -- switch 1; break
				when 8 then -- switch 1, case 2 | switch 1, case 3
						if not (w_c[l_i] < max_c[l_i]) then
							l_pos := -1 + 14 -- skip if block
						end
				when 9 then -- if:
						if l_om /= 3 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 12 then -- else:
						if xcols[l_i] /= -1 then
							l_pos := -1 + 14 -- skip if block
						end
				when 13 then -- if: | _L:
						l_mx[l_i] := max_c[l_i] - w_c[l_i]
						update_class_fields -- Current might have been changed; synchronize
						if l_mmax_c.to_boolean then
							l_w[l_i] := 5 + (max_c[l_i] * 10) // l_mmax_c
							update_class_fields -- Current might have been changed; synchronize
						else
							l_w[l_i] := 1
							update_class_fields -- Current might have been changed; synchronize
						end
				when 14 then -- if done | if done
						l_pos := -1 + 19 -- switch 1; break
				when 15 then -- switch 1, case 4
						if xcols[l_i] >= 0 then
							l_w[l_i] := 1
							update_class_fields -- Current might have been changed; synchronize
							l_mx[l_i] := xcols[l_i] - w_c[l_i]
							update_class_fields -- Current might have been changed; synchronize
							if l_mx[l_i] <= 0 then
								l_w[l_i] := 0
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_pos := -1 + 19 -- switch 1; break
				when 16 then -- switch 1, case 5
						if xcols[l_i] < 0 then
							if xcols[l_i] <= -2 then
								l_w[l_i] := -2 - xcols[l_i]
								update_class_fields -- Current might have been changed; synchronize
							else
								l_w[l_i] := 1
								update_class_fields -- Current might have been changed; synchronize
							end
							l_mx[l_i] := 2_147_483_647
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 19 -- switch 1; break
				when 17 then -- switch 1, case 6
						l_w[l_i] := 1
						update_class_fields -- Current might have been changed; synchronize
						l_mx[l_i] := 2_147_483_647
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 19 -- switch 1; break
				when 18 then -- switch 1, default:
						l_pos := -1 + 25 -- goto end2
				when 19 then -- switch 1, done:
						l_p := l_p + (l_w[l_i])
						l_i := l_i + 1
						l_pos := -1 + 4 -- back to loop condition
				when 20 then -- loop done
						if not l_p.to_boolean then
							l_om := l_om + 1
							l_continue := True
						end
						if (l_return or l_continue) then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_wq := 0
						if (not l_u.is_void) then
							memset (create {CE_VOID_POINTER}.make_cast (l_u), 0, x.to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						l_dd := l_d
				when 22 then -- a:
						l_mss := 0
						l_mii := -1
						l_i := 0
						from
						until
							not (l_i < x)
						loop
							l_continue := False
							if (l_w[l_i]).to_boolean then
								if (not l_u.is_void) then
									if (l_u[l_i]).to_boolean then
										l_continue := True
									end
								end
								if not (l_continue) then
									l_ss := (l_dd * l_w[l_i]) // l_p
									if not l_ss.to_boolean then
										l_ss := 1
									end
									if l_ss > l_mx[l_i] then
										l_ss := l_mx[l_i]
									end
									if l_ss > l_mss then
										l_mss := l_ss
										l_mii := l_i
									end
								end
							end
							l_i := l_i + 1
						end
						l_continue := False
						if l_mii /= -1 then
							l_q := w_c[l_mii]
							if (not l_u.is_void) then
								l_u[l_mii] := (1).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
							end
							w_c[l_mii] := w_c[l_mii] + l_mss
							update_class_fields -- Current might have been changed; synchronize
							l_d := l_d - (w_c[l_mii] - l_q)
							from
							until
								not (l_d < 0)
							loop
								w_c[l_mii] := (w_c[l_mii]) - 1
								update_class_fields -- Current might have been changed; synchronize
								l_d := l_d + 1
							end
							if w_c[l_mii] < l_q then
								w_c[l_mii] := l_q
								update_class_fields -- Current might have been changed; synchronize
							end
							l_wq := 1
							if l_d.to_boolean then
								l_pos := -1 + 22 -- goto a
							end
						elseif not l_wq.to_boolean then
							l_om := l_om + 1
						end
				when 23 then
						l_pos := -1 + 2 -- back to loop condition
				when 24 then -- loop done
						l_continue := False
				when 25 then -- end2:;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 794, create {CE_VOID_POINTER}.make_cast (l_mx))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 795, create {CE_VOID_POINTER}.make_cast (l_w))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_u.is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 796, create {CE_VOID_POINTER}.make_cast (l_u))
							update_class_fields -- Current might have been changed; synchronize
						end
				when 26 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_table_widths
		local
			l_w: CE_POINTER [INTEGER_32]
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_s: INTEGER_32
			l_ns: INTEGER_32
			l_m: INTEGER_32
			l_mi: INTEGER_32
			l_tmp: CE_POINTER [ANY]
			l_c: CE_POINTER [PD_TABLE_CELL]
			l_k: INTEGER_32
			l_p: INTEGER_32
			l_tmp___0: INTEGER_32
			l_c___0: CE_POINTER [PD_TABLE_CELL]
			l_k___0: INTEGER_32
			l_p___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			l_mi := 0
			if x.to_natural_32 > {NATURAL_32} 2_147_483_647 // {PLATFORM}.Integer_32_bytes.to_natural_32 then
				from
				until
					False
				loop
					(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 806])
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_KBD_STATIC}).fatal_tty_exit
					update_class_fields -- Current might have been changed; synchronize
					exit (4)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 807, x.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_w := create {CE_INTEGER_32_POINTER}.make_cast (l_tmp)
			memset (create {CE_VOID_POINTER}.make_cast (l_w), 0, x.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_j := 0
			from
			until
				not (not (l_return) and then (l_j < y))
			loop
				l_i := 0
				from
				until
					not (not (l_return) and then (l_i < x))
				loop
					l_continue := False
					l_c := cells + (l_j * rx + l_i)
					l_p := 0
					if (l_c.item.start).is_void then
						l_continue := True
					end
					if not (l_return or l_continue) then
						l_k := 1
						from
						until
							not (l_k < l_c.item.colspan)
						loop
							l_tmp___0 := ((create {CE_CLASS_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]}.make_shared (c_pointer))).item.get_vline_width (l_i + l_k)
							update_class_fields -- Current might have been changed; synchronize
							l_p := l_p + (l_tmp___0 >= 0).to_integer
							l_k := l_k + 1
						end
						l_k := 0
						from
						until
							not (l_k < l_c.item.colspan)
						loop
							l_p := l_p + (w_c[(l_i + l_k)])
							l_k := l_k + 1
						end
						get_cell_width (create {CE_INTEGER_8_POINTER}.make_cast (l_c.item.start), create {CE_INTEGER_8_POINTER}.make_cast (l_c.item.end2), cellpd, l_p, 1, create {CE_INTEGER_32_POINTER}.make_shared (l_c.c_pointer + (create {PD_TABLE_CELL}.make).offset_of ("x_width")), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_c.item.link_num, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if l_c.item.x_width > l_p then
							l_c.item.x_width := l_p
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if (not l_return) then
						l_i := l_i + 1
					end
				end
				l_continue := False
				l_j := l_j + 1
			end
			l_s := 1
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_ns := 2_147_483_647
				l_i := 0
				from
				until
					not (not (l_return) and then (l_i < x))
				loop
					l_j := 0
					from
					until
						not (not (l_return) and then (l_j < y))
					loop
						l_continue := False
						l_c___0 := cells + (l_j * rx + l_i)
						if (l_c___0.item.start).is_void then
							l_continue := True
						end
						if not (l_return or l_continue) then
							if l_c___0.item.colspan + l_i > x then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 832, create {CE_VOID_POINTER}.make_cast (l_w))
								update_class_fields -- Current might have been changed; synchronize
								l_return := True
							end
							if not l_return then
								if l_c___0.item.colspan = l_s then
									l_p___0 := 0
									l_k___0 := 1
									from
									until
										not (l_k___0 < l_s)
									loop
										l_tmp___1 := ((create {CE_CLASS_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]}.make_shared (c_pointer))).item.get_vline_width (l_i + l_k___0)
										update_class_fields -- Current might have been changed; synchronize
										l_p___0 := l_p___0 + (l_tmp___1 >= 0).to_integer
										l_k___0 := l_k___0 + 1
									end
									dst_width (l_w + l_i, l_s, l_c___0.item.x_width - l_p___0, max_c + l_i)
									update_class_fields -- Current might have been changed; synchronize
								elseif l_c___0.item.colspan > l_s then
									if l_c___0.item.colspan < l_ns then
										l_ns := l_c___0.item.colspan
									end
								end
							end
						end
						if (not l_return) then
							l_j := l_j + 1
						end
					end
					if not l_return then
						l_continue := False
						l_i := l_i + 1
					end
				end
				if not l_return then
					l_s := l_ns
					if l_s = 2_147_483_647 then
						l_break := True
					end
				end
			end
			if not l_return then
				l_break := False
				l_s := 0
				l_ns := 0
				l_i := 0
				from
				until
					not (l_i < x)
				loop
					l_s := l_s + (w_c[l_i])
					l_ns := l_ns + (l_w[l_i])
					l_i := l_i + 1
				end
				if l_ns > l_s then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 865, create {CE_VOID_POINTER}.make_cast (l_w))
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
			end
			if not l_return then
				l_m := -1
				l_i := 0
				from
				until
					not (l_i < x)
				loop
					if max_c[l_i] > l_m then
						l_m := max_c[l_i]
						l_mi := l_i
					end
					l_i := l_i + 1
				end
				if l_m /= -1 then
					l_w[l_mi] := l_w[l_mi] + (l_s - l_ns)
					update_class_fields -- Current might have been changed; synchronize
					if l_w[l_mi] <= max_c[l_mi] then
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 877, create {CE_VOID_POINTER}.make_cast (w_c))
						update_class_fields -- Current might have been changed; synchronize
						Current.w_c := l_w
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
				end
			end
			if not l_return then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 882, create {CE_VOID_POINTER}.make_cast (l_w))
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	get_table_heights
		local
			l_s: INTEGER_32
			l_ns: INTEGER_32
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_cell: CE_POINTER [PD_TABLE_CELL]
			l_p: CE_POINTER [PD_PART]
			l_xw: INTEGER_32
			l_sp: INTEGER_32
			l_tmp: INTEGER_32
			l_cell___0: CE_POINTER [PD_TABLE_CELL]
			l_k: INTEGER_32
			l_p___0: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			l_j := 0
			from
			until
				not (not (l_return) and then (l_j < y))
			loop
				l_i := 0
				from
				until
					not (not (l_return) and then (l_i < x))
				loop
					l_continue := False
					l_cell := cells + (l_j * rx + l_i)
					l_xw := 0
					if not (l_cell.item.used).to_boolean then
						l_continue := True
					elseif (l_cell.item.spanned).to_boolean then
						l_continue := True
					end
					if not (l_return or l_continue) then
						l_sp := 0
						from
						until
							not (l_sp < l_cell.item.colspan)
						loop
							l_xw := l_xw + (w_c[(l_i + l_sp)])
							if l_sp < l_cell.item.colspan - 1 then
								l_tmp := ((create {CE_CLASS_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]}.make_shared (c_pointer))).item.get_vline_width ((l_i + l_sp) + 1)
								update_class_fields -- Current might have been changed; synchronize
								l_xw := l_xw + (l_tmp >= 0).to_integer
							end
							l_sp := l_sp + 1
						end
						l_p := (create {P_HTML_R_STATIC}).format_html_part (l_cell.item.start, l_cell.item.end2, l_cell.item.align, cellpd, l_xw, create {CE_CLASS_POINTER [PD_F_DATA]}.make_shared (default_pointer), 2, 2, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_cell.item.link_num)
						update_class_fields -- Current might have been changed; synchronize
						if l_p.is_void then
							l_return := True
						end
						if not l_return then
							l_cell.item.height := l_p.item.y
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 903, create {CE_VOID_POINTER}.make_cast (l_p))
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if (not l_return) then
						l_i := l_i + 1
					end
				end
				if not l_return then
					l_continue := False
					l_j := l_j + 1
				end
			end
			if not l_return then
				l_s := 1
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_ns := 2_147_483_647
					l_j := 0
					from
					until
						not (not (l_return) and then (l_j < y))
					loop
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < x))
						loop
							l_continue := False
							l_cell___0 := cells + (l_j * rx + l_i)
							if not (l_cell___0.item.used).to_boolean then
								l_continue := True
							elseif (l_cell___0.item.spanned).to_boolean then
								l_continue := True
							end
							if not (l_return or l_continue) then
								if l_cell___0.item.rowspan = l_s then
									l_p___0 := 0
									l_k := 1
									from
									until
										not (l_k < l_s)
									loop
										l_tmp___0 := get_hline_width ((create {CE_CLASS_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]}.make_shared (c_pointer)), l_j + l_k)
										update_class_fields -- Current might have been changed; synchronize
										l_p___0 := l_p___0 + (l_tmp___0 >= 0).to_integer
										l_k := l_k + 1
									end
									dst_width (r_heights + l_j, l_s, l_cell___0.item.height - l_p___0, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
									update_class_fields -- Current might have been changed; synchronize
								elseif l_cell___0.item.rowspan > l_s then
									if l_cell___0.item.rowspan < l_ns then
										l_ns := l_cell___0.item.rowspan
									end
								end
							end
							if (not l_return) then
								l_i := l_i + 1
							end
						end
						l_continue := False
						l_j := l_j + 1
					end
					l_s := l_ns
					if l_s = 2_147_483_647 then
						l_break := True
					end
				end
				l_break := False
				Current.rh := ((((frame).bit_and (1)).to_boolean).to_integer + (((frame).bit_and (2)).to_boolean).to_integer) * (border.to_boolean).to_integer
				update_class_fields -- Current might have been changed; synchronize
				l_j := 0
				from
				until
					not (l_j < y)
				loop
					Current.rh := rh + (r_heights[l_j])
					update_class_fields -- Current might have been changed; synchronize
					if l_j.to_boolean then
						l_tmp___1 := get_hline_width ((create {CE_CLASS_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]}.make_shared (c_pointer)), l_j)
						update_class_fields -- Current might have been changed; synchronize
						Current.rh := rh + (l_tmp___1 >= 0).to_integer
						update_class_fields -- Current might have been changed; synchronize
					end
					l_j := l_j + 1
				end
			end
		end

	display_complicated_table (a_x, a_y: INTEGER_32; a_yy: CE_POINTER [INTEGER_32])
		require
			not a_yy.is_void
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_f: CE_POINTER [PD_F_DATA]
			l_yp: INTEGER_32
			l_xp: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_cell: CE_POINTER [PD_TABLE_CELL]
			l_yt: INTEGER_32
			l_p: CE_POINTER [PD_PART]
			l_xw: INTEGER_32
			l_yw: INTEGER_32
			l_s: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_f := p.item.data
					if ((frame).bit_and (4)).to_boolean then
						if border.to_boolean then
							l_tmp := 1
						else
							l_tmp := 0
						end
					else
						l_tmp := 0
					end
					l_xp := a_x + l_tmp
					l_i := 0
				when 1 then -- loop condition:
					if not (not (l_return) and then (l_i < x)) then
						l_pos := -1 + 12 -- skip loop
					end
				when 2 then -- loop body:
						if ((frame).bit_and (1)).to_boolean then
							if border.to_boolean then
								l_tmp___0 := 1
							else
								l_tmp___0 := 0
							end
						else
							l_tmp___0 := 0
						end
						l_yp := a_y + l_tmp___0
						l_j := 0
				when 3 then -- loop condition:
						if not (not (l_return) and then (l_j < y)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 4 then -- loop body:
						l_cell := cells + (l_j * rx + l_i)
						if (l_cell.item.start).is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						l_p := create {CE_CLASS_POINTER [PD_PART]}.make_shared (default_pointer)
						l_xw := 0
						l_yw := 0
						l_s := 0
						from
						until
							not (l_s < l_cell.item.colspan)
						loop
							l_xw := l_xw + (w_c[(l_i + l_s)])
							if l_s < l_cell.item.colspan - 1 then
								l_tmp___1 := ((create {CE_CLASS_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]}.make_shared (c_pointer))).item.get_vline_width ((l_i + l_s) + 1)
								update_class_fields -- Current might have been changed; synchronize
								l_xw := l_xw + (l_tmp___1 >= 0).to_integer
							end
							l_s := l_s + 1
						end
						l_s := 0
						from
						until
							not (l_s < l_cell.item.rowspan)
						loop
							l_yw := l_yw + (r_heights[(l_j + l_s)])
							if l_s < l_cell.item.rowspan - 1 then
								l_tmp___2 := get_hline_width ((create {CE_CLASS_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]}.make_shared (c_pointer)), (l_j + l_s) + 1)
								update_class_fields -- Current might have been changed; synchronize
								l_yw := l_yw + (l_tmp___2 >= 0).to_integer
							end
							l_s := l_s + 1
						end
						(create {P_HTML_STATIC}).html_stack_dup
						update_class_fields; -- Current might have been changed; synchronize
						(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.dontkill := 1
						update_class_fields -- Current might have been changed; synchronize
						if (l_cell.item.b).to_boolean then
							(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.attr := ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.attr).bit_or ((1))
							update_class_fields -- Current might have been changed; synchronize
						end
						memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).c_pointer + (create {PD_HTML_ELEMENT}.make).offset_of ("attr") + (create {PD_TEXT_ATTRIB}.make).offset_of ("bg")))), create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared (l_cell.c_pointer + (create {PD_TABLE_CELL}.make).offset_of ("bgcolor")))), (create {PD_RGB}.make).structure_size.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).c_pointer + (create {PD_HTML_ELEMENT}.make).offset_of ("parattr") + (create {PD_PAR_ATTRIB}.make).offset_of ("bgcolor")))), create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared (l_cell.c_pointer + (create {PD_TABLE_CELL}.make).offset_of ("bgcolor")))), (create {PD_RGB}.make).structure_size.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if l_cell.item.valign = 1 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if l_cell.item.valign /= 2 then
							l_tmp___4 := 0
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if l_cell.item.valign = 1 then
							l_tmp___3 := 2
						else
							l_tmp___3 := 1
						end
						l_tmp___4 := (l_yw - l_cell.item.height) // l_tmp___3
				when 9 then
						l_p := (create {P_HTML_R_STATIC}).format_html_part (l_cell.item.start, l_cell.item.end2, l_cell.item.align, cellpd, l_xw, l_f, p.item.xp + l_xp, (p.item.yp + l_yp) + l_tmp___4, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_cell.item.link_num)
						update_class_fields -- Current might have been changed; synchronize
						l_cell.item.xpos := l_xp
						update_class_fields -- Current might have been changed; synchronize
						l_cell.item.ypos := l_yp
						update_class_fields -- Current might have been changed; synchronize
						l_cell.item.xw := l_xw
						update_class_fields -- Current might have been changed; synchronize
						l_cell.item.yw := l_yw
						update_class_fields -- Current might have been changed; synchronize
						l_yt := 0
						from
						until
							not (l_yt < l_p.item.y)
						loop
							xxpand_lines (p, l_yp + l_yt)
							update_class_fields -- Current might have been changed; synchronize
							xxpand_line (p, l_yp + l_yt, l_xp + w_c[l_i])
							update_class_fields -- Current might have been changed; synchronize
							l_yt := l_yt + 1
						end
						(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.kill_html_stack_item
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 964, create {CE_VOID_POINTER}.make_cast (l_p))
						update_class_fields -- Current might have been changed; synchronize
				when 10 then -- if done
						l_cell.item.xpos := l_xp
						update_class_fields -- Current might have been changed; synchronize
						l_cell.item.ypos := l_yp
						update_class_fields -- Current might have been changed; synchronize
						l_cell.item.xw := w_c[l_i]
						update_class_fields -- Current might have been changed; synchronize
						l_yp := l_yp + (r_heights[l_j])
						if l_j < y - 1 then
							l_tmp___5 := get_hline_width ((create {CE_CLASS_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]}.make_shared (c_pointer)), l_j + 1)
							update_class_fields -- Current might have been changed; synchronize
							l_yp := l_yp + (l_tmp___5 >= 0).to_integer
						end
						l_j := l_j + 1
						l_pos := -1 + 3 -- back to loop condition
				when 11 then -- loop done
						if l_i < x - 1 then
							l_tmp___6 := ((create {CE_CLASS_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]}.make_shared (c_pointer))).item.get_vline_width (l_i + 1)
							update_class_fields -- Current might have been changed; synchronize
							l_xp := l_xp + (w_c[l_i] + (l_tmp___6 >= 0).to_integer)
						end
						l_i := l_i + 1
						l_pos := -1 + 1 -- back to loop condition
				when 12 then -- loop done
					l_yp := a_y
					l_j := 0
					from
					until
						not (l_j < y)
					loop
						l_yp := l_yp + (r_heights[l_j])
						if l_j < y - 1 then
							l_tmp___7 := get_hline_width ((create {CE_CLASS_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]}.make_shared (c_pointer)), l_j + 1)
							update_class_fields -- Current might have been changed; synchronize
							l_yp := l_yp + (l_tmp___7 >= 0).to_integer
						end
						l_j := l_j + 1
					end
					a_yy.item := l_yp + ((((frame).bit_and (1)).to_boolean).to_integer + (((frame).bit_and (2)).to_boolean).to_integer) * (border.to_boolean).to_integer
					update_class_fields -- Current might have been changed; synchronize
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	display_table_frames (a_x, a_y: INTEGER_32)
		local
			l_fh: CE_POINTER [INTEGER_8]
			l_fv: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_cx: INTEGER_32
			l_cy: INTEGER_32
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [ANY]
			l_x___0: INTEGER_32
			l_y___0: INTEGER_32
			l_xsp: INTEGER_32
			l_ysp: INTEGER_32
			l_cell: CE_POINTER [PD_TABLE_CELL]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_w: INTEGER_32
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___13: INTEGER_32
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_tmp___17: INTEGER_32
			l_tmp___18: CE_POINTER [INTEGER_8]
			l_tmp___20: CE_POINTER [INTEGER_8]
			l_tmp___21: INTEGER_32
			l_tmp___22: CE_POINTER [INTEGER_8]
			l_tmp___24: CE_POINTER [INTEGER_8]
			l_tmp___25: INTEGER_32
			l_tmp___26: CE_POINTER [INTEGER_8]
			l_tmp___27: CE_POINTER [INTEGER_8]
			l_tmp___28: CE_POINTER [INTEGER_8]
			l_tmp___29: CE_POINTER [INTEGER_8]
			l_tmp___30: CE_POINTER [INTEGER_8]
			l_qq: INTEGER_32
			l_tmp___32: CE_POINTER [INTEGER_8]
			l_tmp___33: INTEGER_32
			l_tmp___34: CE_POINTER [INTEGER_8]
			l_tmp___35: CE_POINTER [INTEGER_8]
			l_tmp___37: CE_POINTER [INTEGER_8]
			l_tmp___38: INTEGER_32
			l_tmp___39: CE_POINTER [INTEGER_8]
			l_tmp___40: CE_POINTER [INTEGER_8]
			l_tmp___42: CE_POINTER [INTEGER_8]
			l_tmp___43: INTEGER_32
			l_tmp___44: CE_POINTER [INTEGER_8]
			l_tmp___46: CE_POINTER [INTEGER_8]
			l_tmp___47: INTEGER_32
			l_tmp___48: CE_POINTER [INTEGER_8]
			l_tmp___50: CE_POINTER [INTEGER_8]
			l_tmp___51: INTEGER_32
			l_tmp___52: CE_POINTER [INTEGER_8]
			l_tmp___54: CE_POINTER [INTEGER_8]
			l_tmp___55: INTEGER_32
			l_tmp___56: CE_POINTER [INTEGER_8]
			l_tmp___57: CE_POINTER [INTEGER_8]
			l_tmp___58: CE_POINTER [INTEGER_8]
			l_tmp___59: CE_POINTER [INTEGER_8]
			l_tmp___60: CE_POINTER [INTEGER_8]
			l_qq___0: INTEGER_32
			l_tmp___62: CE_POINTER [INTEGER_8]
			l_tmp___63: INTEGER_32
			l_tmp___64: CE_POINTER [INTEGER_8]
			l_tmp___65: CE_POINTER [INTEGER_8]
			l_qq___1: INTEGER_32
			l_tmp___67: CE_POINTER [INTEGER_8]
			l_tmp___68: INTEGER_32
			l_tmp___69: CE_POINTER [INTEGER_8]
			l_tmp___70: CE_POINTER [INTEGER_8]
			l_tmp___71: INTEGER_32
			l_tmp___72: INTEGER_32
			l_return, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if x.to_natural_32 > {NATURAL_32} 2_147_483_647 then
						from
						until
							False
						loop
							(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 999])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_KBD_STATIC}).fatal_tty_exit
							update_class_fields -- Current might have been changed; synchronize
							exit (4)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if y.to_natural_32 > {NATURAL_32} 2_147_483_647 then
						from
						until
							False
						loop
							(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 1_000])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_KBD_STATIC}).fatal_tty_exit
							update_class_fields -- Current might have been changed; synchronize
							exit (4)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if ((x.to_natural_32 + {NATURAL_32} 2) * (y.to_natural_32 + {NATURAL_32} 2)) // (x.to_natural_32 + {NATURAL_32} 2) /= y.to_natural_32 + {NATURAL_32} 2 then
						from
						until
							False
						loop
							(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 1_001])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_KBD_STATIC}).fatal_tty_exit
							update_class_fields -- Current might have been changed; synchronize
							exit (4)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if (x.to_natural_32 + {NATURAL_32} 2) * (y.to_natural_32 + {NATURAL_32} 2) > {NATURAL_32} 2_147_483_647 then
						from
						until
							False
						loop
							(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 1_002])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_KBD_STATIC}).fatal_tty_exit
							update_class_fields -- Current might have been changed; synchronize
							exit (4)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 1_003, ((x + 2) * (y + 1)).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_fh := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp)
					memset (create {CE_VOID_POINTER}.make_cast (l_fh), -1, ((x + 2) * (y + 1)).to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___0 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 1_005, ((x + 1) * (y + 2)).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_fv := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___0)
					memset (create {CE_VOID_POINTER}.make_cast (l_fv), -1, ((x + 1) * (y + 2)).to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_j := 0
					from
					until
						not (not (l_return) and then (l_j < y))
					loop
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < x))
						loop
							l_continue := False
							l_cell := cells + (l_j * rx + l_i)
							if not (l_cell.item.used).to_boolean then
								l_continue := True
							elseif (l_cell.item.spanned).to_boolean then
								l_continue := True
							end
							if not (l_return or l_continue) then
								l_xsp := l_cell.item.colspan
								if l_xsp = 0 then
									l_xsp := x - l_i
								end
								l_ysp := l_cell.item.rowspan
								if l_ysp = 0 then
									l_ysp := y - l_j
								end
								if rules /= 0 then
									if rules /= 2 then
										l_x___0 := 0
										from
										until
											not (l_x___0 < l_xsp)
										loop
											if l_i + l_x___0 < -1 then
												l_tmp___1 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
											elseif l_i + l_x___0 > x + 1 then
												l_tmp___1 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
											elseif l_j < 0 then
												l_tmp___1 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
											elseif l_j > y then
												l_tmp___1 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
											else
												l_tmp___1 := l_fh + (((l_i + l_x___0) + 1) + (x + 2) * l_j)
											end
											l_tmp___1[0] := cellsp.to_integer_8
											update_class_fields -- Current might have been changed; synchronize
											if l_i + l_x___0 < -1 then
												l_tmp___2 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
											elseif l_i + l_x___0 > x + 1 then
												l_tmp___2 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
											elseif l_j + l_ysp < 0 then
												l_tmp___2 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
											elseif l_j + l_ysp > y then
												l_tmp___2 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
											else
												l_tmp___2 := l_fh + (((l_i + l_x___0) + 1) + (x + 2) * (l_j + l_ysp))
											end
											l_tmp___2[0] := cellsp.to_integer_8
											update_class_fields -- Current might have been changed; synchronize
											l_x___0 := l_x___0 + 1
										end
									end
								end
								if rules /= 0 then
									if rules /= 1 then
										l_y___0 := 0
										from
										until
											not (l_y___0 < l_ysp)
										loop
											if l_i < 0 then
												l_tmp___3 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
											elseif l_i > x then
												l_tmp___3 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
											elseif l_j + l_y___0 < -1 then
												l_tmp___3 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
											elseif l_j + l_y___0 > y + 1 then
												l_tmp___3 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
											else
												l_tmp___3 := l_fv + (((l_j + l_y___0) + 1) + (y + 2) * l_i)
											end
											l_tmp___3[0] := cellsp.to_integer_8
											update_class_fields -- Current might have been changed; synchronize
											if l_i + l_xsp < 0 then
												l_tmp___4 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
											elseif l_i + l_xsp > x then
												l_tmp___4 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
											elseif l_j + l_y___0 < -1 then
												l_tmp___4 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
											elseif l_j + l_y___0 > y + 1 then
												l_tmp___4 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
											else
												l_tmp___4 := l_fv + (((l_j + l_y___0) + 1) + (y + 2) * (l_i + l_xsp))
											end
											l_tmp___4[0] := cellsp.to_integer_8
											update_class_fields -- Current might have been changed; synchronize
											l_y___0 := l_y___0 + 1
										end
									end
								end
							end
							if (not l_return) then
								l_i := l_i + 1
							end
						end
						l_continue := False
						l_j := l_j + 1
					end
					if rules /= 4 then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						l_i := 1
						from
						until
							not (not (l_return) and then (l_i < x))
						loop
							l_continue := False
							if (xcols[l_i]).to_boolean then
								l_continue := True
							end
							if not (l_return or l_continue) then
								l_j := 0
								from
								until
									not (l_j < y)
								loop
									if l_i < 0 then
										l_tmp___5 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
									elseif l_i > x then
										l_tmp___5 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
									elseif l_j < -1 then
										l_tmp___5 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
									elseif l_j > y + 1 then
										l_tmp___5 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
									else
										l_tmp___5 := l_fv + ((l_j + 1) + (y + 2) * l_i)
									end
									l_tmp___5[0] := (0).to_integer_8
									update_class_fields -- Current might have been changed; synchronize
									l_j := l_j + 1
								end
							end
							if (not l_return) then
								l_i := l_i + 1
							end
						end
						l_continue := False
						l_j := 1
				when 2 then -- loop condition:
						if not (not (l_return) and then (l_j < y)) then
							l_pos := -1 + 9 -- skip loop
						end
				when 3 then -- loop body:
						l_i := 0
				when 4 then -- loop condition:
						if not (l_i < x) then
							l_pos := -1 + 7 -- skip loop
						end
				when 5 then -- loop body:
						if ((cells + (l_j * rx + l_i)).item.group).to_boolean then
							l_pos := -1 + 8 -- goto c
						end
				when 6 then
						l_i := l_i + 1
						l_pos := -1 + 4 -- back to loop condition
				when 7 then -- loop done
						l_i := 0
						from
						until
							not (l_i < x)
						loop
							if l_i < -1 then
								l_tmp___6 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_i > x + 1 then
								l_tmp___6 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_j < 0 then
								l_tmp___6 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_j > y then
								l_tmp___6 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							else
								l_tmp___6 := l_fh + ((l_i + 1) + (x + 2) * l_j)
							end
							l_tmp___6[0] := (0).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
							l_i := l_i + 1
						end
				when 8 then -- c:
						l_j := l_j + 1
						l_pos := -1 + 2 -- back to loop condition
				when 9 then -- loop done | if done
					l_i := 0
					from
					until
						not (l_i < x)
					loop
						if l_i < -1 then
							l_tmp___7 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_i > x + 1 then
							l_tmp___7 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif 0 > y then
							l_tmp___7 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							l_tmp___7 := l_fh + (l_i + 1)
						end
						l_tmp___7[0] := (border * (((frame).bit_and (1)).to_boolean).to_integer).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						if l_i < -1 then
							l_tmp___8 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_i > x + 1 then
							l_tmp___8 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif y < 0 then
							l_tmp___8 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif y > y then
							l_tmp___8 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							l_tmp___8 := l_fh + ((l_i + 1) + (x + 2) * y)
						end
						l_tmp___8[0] := (border * (((frame).bit_and (2)).to_boolean).to_integer).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						l_i := l_i + 1
					end
					l_j := 0
					from
					until
						not (l_j < y)
					loop
						if 0 > x then
							l_tmp___9 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j < -1 then
							l_tmp___9 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j > y + 1 then
							l_tmp___9 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							l_tmp___9 := l_fv + (l_j + 1)
						end
						l_tmp___9[0] := (border * (((frame).bit_and (4)).to_boolean).to_integer).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						if x < 0 then
							l_tmp___10 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif x > x then
							l_tmp___10 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j < -1 then
							l_tmp___10 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j > y + 1 then
							l_tmp___10 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							l_tmp___10 := l_fv + ((l_j + 1) + (y + 2) * x)
						end
						l_tmp___10[0] := (border * (((frame).bit_and (8)).to_boolean).to_integer).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						l_j := l_j + 1
					end
					l_cy := a_y
					l_j := 0
				when 10 then -- loop condition:
					if not (not (l_return) and then (l_j <= y)) then
						l_pos := -1 + 71 -- skip loop
					end
				when 11 then -- loop body:
						l_cx := a_x
						if not (l_j > 0) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if l_j < y then
							l_tmp___72 := get_hline_width ((create {CE_CLASS_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]}.make_shared (c_pointer)), l_j)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___72 >= 0 then
								l_pos := -1 + 20 -- goto _L___6
							else
								l_pos := -1 + 14 -- goto _L___12
							end
						else
							l_pos := -1 + 14 -- goto _L___12
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 70
				when 14 then -- else: | _L___12:
						if l_j /= 0 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if border.to_boolean then
							if ((frame).bit_and (1)).to_boolean then
								l_pos := -1 + 20 -- goto _L___6
							else
								l_pos := -1 + 17 -- goto _L___10
							end
						else
							l_pos := -1 + 17 -- goto _L___10
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 70
				when 17 then -- else: | _L___10:
						if l_j /= y then
							l_pos := -1 + 56 -- skip if block
						end
				when 18 then -- if:
						if not (border.to_boolean) then
							l_pos := -1 + 54 -- skip if block
						end
				when 19 then -- if:
						if not (((frame).bit_and (2)).to_boolean) then
							l_pos := -1 + 52 -- skip if block
						end
				when 20 then -- if: | _L___6:
						l_i := 0
				when 21 then -- loop condition:
						if not (not (l_return) and then (l_i < x)) then
							l_pos := -1 + 36 -- skip loop
						end
				when 22 then -- loop body:
						if l_i > 0 then
							l_w := ((create {CE_CLASS_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]}.make_shared (c_pointer))).item.get_vline_width (l_i)
							update_class_fields -- Current might have been changed; synchronize
						elseif border.to_boolean then
							if ((frame).bit_and (4)).to_boolean then
								l_w := border
							else
								l_w := -1
							end
						else
							l_w := -1
						end
						if not (l_w >= 0) then
							l_pos := -1 + 35 -- skip if block
						end
				when 23 then -- if:
						if l_i - 1 < -1 then
							l_tmp___27 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_i - 1 > x + 1 then
							l_tmp___27 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j < 0 then
							l_tmp___27 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j > y then
							l_tmp___27 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							l_tmp___27 := l_fh + (((l_i - 1) + 1) + (x + 2) * l_j)
						end
						if not ((l_tmp___27[0]).to_integer_32 >= 0) then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_pos := -1 + 33 -- goto _L
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 26 then -- else:
						if l_i < -1 then
							l_tmp___28 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_i > x + 1 then
							l_tmp___28 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j < 0 then
							l_tmp___28 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j > y then
							l_tmp___28 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							l_tmp___28 := l_fh + ((l_i + 1) + (x + 2) * l_j)
						end
						if not ((l_tmp___28[0]).to_integer_32 >= 0) then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						l_pos := -1 + 33 -- goto _L
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 29 then -- else:
						if l_i < 0 then
							l_tmp___29 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_i > x then
							l_tmp___29 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j - 1 < -1 then
							l_tmp___29 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j - 1 > y + 1 then
							l_tmp___29 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							l_tmp___29 := l_fv + (((l_j - 1) + 1) + (y + 2) * l_i)
						end
						if not ((l_tmp___29[0]).to_integer_32 >= 0) then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						l_pos := -1 + 33 -- goto _L
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 32 then -- else:
						if l_i < 0 then
							l_tmp___30 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_i > x then
							l_tmp___30 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j < -1 then
							l_tmp___30 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j > y + 1 then
							l_tmp___30 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							l_tmp___30 := l_fv + ((l_j + 1) + (y + 2) * l_i)
						end
						if not ((l_tmp___30[0]).to_integer_32 >= 0) then
							l_pos := -1 + 34 -- skip if block
						end
				when 33 then -- if: | _L:
						if l_i < 0 then
							l_tmp___14 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_i > x then
							l_tmp___14 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j - 1 < -1 then
							l_tmp___14 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j - 1 > y + 1 then
							l_tmp___14 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							l_tmp___14 := l_fv + (((l_j - 1) + 1) + (y + 2) * l_i)
						end
						if (l_tmp___14[0]).to_integer_32 = -1 then
							l_tmp___13 := 0
						else
							if l_i < 0 then
								l_tmp___12 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_i > x then
								l_tmp___12 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_j - 1 < -1 then
								l_tmp___12 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_j - 1 > y + 1 then
								l_tmp___12 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							else
								l_tmp___12 := l_fv + (((l_j - 1) + 1) + (y + 2) * l_i)
							end
							l_tmp___13 := (l_tmp___12[0]).to_integer_32
						end
						if l_i < -1 then
							l_tmp___18 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_i > x + 1 then
							l_tmp___18 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j < 0 then
							l_tmp___18 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j > y then
							l_tmp___18 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							l_tmp___18 := l_fh + ((l_i + 1) + (x + 2) * l_j)
						end
						if (l_tmp___18[0]).to_integer_32 = -1 then
							l_tmp___17 := 0
						else
							if l_i < -1 then
								l_tmp___16 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_i > x + 1 then
								l_tmp___16 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_j < 0 then
								l_tmp___16 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_j > y then
								l_tmp___16 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							else
								l_tmp___16 := l_fh + ((l_i + 1) + (x + 2) * l_j)
							end
							l_tmp___17 := (l_tmp___16[0]).to_integer_32
						end
						if l_i - 1 < -1 then
							l_tmp___22 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_i - 1 > x + 1 then
							l_tmp___22 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j < 0 then
							l_tmp___22 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j > y then
							l_tmp___22 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							l_tmp___22 := l_fh + (((l_i - 1) + 1) + (x + 2) * l_j)
						end
						if (l_tmp___22[0]).to_integer_32 = -1 then
							l_tmp___21 := 0
						else
							if l_i - 1 < -1 then
								l_tmp___20 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_i - 1 > x + 1 then
								l_tmp___20 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_j < 0 then
								l_tmp___20 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_j > y then
								l_tmp___20 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							else
								l_tmp___20 := l_fh + (((l_i - 1) + 1) + (x + 2) * l_j)
							end
							l_tmp___21 := (l_tmp___20[0]).to_integer_32
						end
						if l_i < 0 then
							l_tmp___26 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_i > x then
							l_tmp___26 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j < -1 then
							l_tmp___26 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j > y + 1 then
							l_tmp___26 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							l_tmp___26 := l_fv + ((l_j + 1) + (y + 2) * l_i)
						end
						if (l_tmp___26[0]).to_integer_32 = -1 then
							l_tmp___25 := 0
						else
							if l_i < 0 then
								l_tmp___24 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_i > x then
								l_tmp___24 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_j < -1 then
								l_tmp___24 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_j > y + 1 then
								l_tmp___24 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							else
								l_tmp___24 := l_fv + ((l_j + 1) + (y + 2) * l_i)
							end
							l_tmp___25 := (l_tmp___24[0]).to_integer_32
						end
						xset_hchar (p, l_cx, l_cy, (((frame_table.item[((l_tmp___13 + 3 * l_tmp___17) + 9 * l_tmp___21) + 27 * l_tmp___25]).to_integer_32).bit_or (32_768)).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
				when 34 then -- if done | if done | if done
						if l_j < y then
							if l_i < 0 then
								l_tmp___35 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_i > x then
								l_tmp___35 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_j < -1 then
								l_tmp___35 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_j > y + 1 then
								l_tmp___35 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							else
								l_tmp___35 := l_fv + ((l_j + 1) + (y + 2) * l_i)
							end
							if (l_tmp___35[0]).to_integer_32 >= 0 then
								l_qq := 0
								from
								until
									not (l_qq < r_heights[l_j])
								loop
									if l_i < 0 then
										l_tmp___34 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
									elseif l_i > x then
										l_tmp___34 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
									elseif l_j < -1 then
										l_tmp___34 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
									elseif l_j > y + 1 then
										l_tmp___34 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
									else
										l_tmp___34 := l_fv + ((l_j + 1) + (y + 2) * l_i)
									end
									if (l_tmp___34[0]).to_integer_32 = -1 then
										l_tmp___33 := 0
									else
										if l_i < 0 then
											l_tmp___32 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
										elseif l_i > x then
											l_tmp___32 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
										elseif l_j < -1 then
											l_tmp___32 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
										elseif l_j > y + 1 then
											l_tmp___32 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
										else
											l_tmp___32 := l_fv + ((l_j + 1) + (y + 2) * l_i)
										end
										l_tmp___33 := (l_tmp___32[0]).to_integer_32
									end
									xset_hchar (p, l_cx, (l_cy + 1) + l_qq, (((vline_table.item[l_tmp___33]).to_integer_32).bit_or (32_768)).to_natural_32)
									update_class_fields -- Current might have been changed; synchronize
									l_qq := l_qq + 1
								end
							end
						end
						l_cx := l_cx + 1
				when 35 then -- if done
						l_w := w_c[l_i]
						if l_i < -1 then
							l_tmp___40 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_i > x + 1 then
							l_tmp___40 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j < 0 then
							l_tmp___40 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j > y then
							l_tmp___40 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							l_tmp___40 := l_fh + ((l_i + 1) + (x + 2) * l_j)
						end
						if (l_tmp___40[0]).to_integer_32 >= 0 then
							if l_i < -1 then
								l_tmp___39 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_i > x + 1 then
								l_tmp___39 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_j < 0 then
								l_tmp___39 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_j > y then
								l_tmp___39 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							else
								l_tmp___39 := l_fh + ((l_i + 1) + (x + 2) * l_j)
							end
							if (l_tmp___39[0]).to_integer_32 = -1 then
								l_tmp___38 := 0
							else
								if l_i < -1 then
									l_tmp___37 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								elseif l_i > x + 1 then
									l_tmp___37 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								elseif l_j < 0 then
									l_tmp___37 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								elseif l_j > y then
									l_tmp___37 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								else
									l_tmp___37 := l_fh + ((l_i + 1) + (x + 2) * l_j)
								end
								l_tmp___38 := (l_tmp___37[0]).to_integer_32
							end
							xset_hchars (p, l_cx, l_cy, l_w, (((hline_table.item[l_tmp___38]).to_integer_32).bit_or (32_768)).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_cx := l_cx + l_w
						l_i := l_i + 1
						l_pos := -1 + 21 -- back to loop condition
				when 36 then -- loop done
						if not (border.to_boolean) then
							l_pos := -1 + 50 -- skip if block
						end
				when 37 then -- if:
						if not (((frame).bit_and (8)).to_boolean) then
							l_pos := -1 + 50 -- skip if block
						end
				when 38 then -- if:
						if l_i - 1 < -1 then
							l_tmp___57 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_i - 1 > x + 1 then
							l_tmp___57 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j < 0 then
							l_tmp___57 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j > y then
							l_tmp___57 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							l_tmp___57 := l_fh + (((l_i - 1) + 1) + (x + 2) * l_j)
						end
						if not ((l_tmp___57[0]).to_integer_32 >= 0) then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						l_pos := -1 + 48 -- goto _L___0
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 41 then -- else:
						if l_i < -1 then
							l_tmp___58 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_i > x + 1 then
							l_tmp___58 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j < 0 then
							l_tmp___58 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j > y then
							l_tmp___58 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							l_tmp___58 := l_fh + ((l_i + 1) + (x + 2) * l_j)
						end
						if not ((l_tmp___58[0]).to_integer_32 >= 0) then
							l_pos := -1 + 44 -- skip if block
						end
				when 42 then -- if:
						l_pos := -1 + 48 -- goto _L___0
				when 43 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 44 then -- else:
						if l_i < 0 then
							l_tmp___59 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_i > x then
							l_tmp___59 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j - 1 < -1 then
							l_tmp___59 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j - 1 > y + 1 then
							l_tmp___59 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							l_tmp___59 := l_fv + (((l_j - 1) + 1) + (y + 2) * l_i)
						end
						if not ((l_tmp___59[0]).to_integer_32 >= 0) then
							l_pos := -1 + 47 -- skip if block
						end
				when 45 then -- if:
						l_pos := -1 + 48 -- goto _L___0
				when 46 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 47 then -- else:
						if l_i < 0 then
							l_tmp___60 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_i > x then
							l_tmp___60 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j < -1 then
							l_tmp___60 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j > y + 1 then
							l_tmp___60 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							l_tmp___60 := l_fv + ((l_j + 1) + (y + 2) * l_i)
						end
						if not ((l_tmp___60[0]).to_integer_32 >= 0) then
							l_pos := -1 + 49 -- skip if block
						end
				when 48 then -- if: | _L___0:
						if l_i < 0 then
							l_tmp___44 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_i > x then
							l_tmp___44 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j - 1 < -1 then
							l_tmp___44 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j - 1 > y + 1 then
							l_tmp___44 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							l_tmp___44 := l_fv + (((l_j - 1) + 1) + (y + 2) * l_i)
						end
						if (l_tmp___44[0]).to_integer_32 = -1 then
							l_tmp___43 := 0
						else
							if l_i < 0 then
								l_tmp___42 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_i > x then
								l_tmp___42 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_j - 1 < -1 then
								l_tmp___42 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_j - 1 > y + 1 then
								l_tmp___42 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							else
								l_tmp___42 := l_fv + (((l_j - 1) + 1) + (y + 2) * l_i)
							end
							l_tmp___43 := (l_tmp___42[0]).to_integer_32
						end
						if l_i < -1 then
							l_tmp___48 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_i > x + 1 then
							l_tmp___48 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j < 0 then
							l_tmp___48 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j > y then
							l_tmp___48 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							l_tmp___48 := l_fh + ((l_i + 1) + (x + 2) * l_j)
						end
						if (l_tmp___48[0]).to_integer_32 = -1 then
							l_tmp___47 := 0
						else
							if l_i < -1 then
								l_tmp___46 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_i > x + 1 then
								l_tmp___46 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_j < 0 then
								l_tmp___46 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_j > y then
								l_tmp___46 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							else
								l_tmp___46 := l_fh + ((l_i + 1) + (x + 2) * l_j)
							end
							l_tmp___47 := (l_tmp___46[0]).to_integer_32
						end
						if l_i - 1 < -1 then
							l_tmp___52 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_i - 1 > x + 1 then
							l_tmp___52 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j < 0 then
							l_tmp___52 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j > y then
							l_tmp___52 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							l_tmp___52 := l_fh + (((l_i - 1) + 1) + (x + 2) * l_j)
						end
						if (l_tmp___52[0]).to_integer_32 = -1 then
							l_tmp___51 := 0
						else
							if l_i - 1 < -1 then
								l_tmp___50 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_i - 1 > x + 1 then
								l_tmp___50 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_j < 0 then
								l_tmp___50 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_j > y then
								l_tmp___50 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							else
								l_tmp___50 := l_fh + (((l_i - 1) + 1) + (x + 2) * l_j)
							end
							l_tmp___51 := (l_tmp___50[0]).to_integer_32
						end
						if l_i < 0 then
							l_tmp___56 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_i > x then
							l_tmp___56 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j < -1 then
							l_tmp___56 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j > y + 1 then
							l_tmp___56 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							l_tmp___56 := l_fv + ((l_j + 1) + (y + 2) * l_i)
						end
						if (l_tmp___56[0]).to_integer_32 = -1 then
							l_tmp___55 := 0
						else
							if l_i < 0 then
								l_tmp___54 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_i > x then
								l_tmp___54 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_j < -1 then
								l_tmp___54 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_j > y + 1 then
								l_tmp___54 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							else
								l_tmp___54 := l_fv + ((l_j + 1) + (y + 2) * l_i)
							end
							l_tmp___55 := (l_tmp___54[0]).to_integer_32
						end
						xset_hchar (p, l_cx, l_cy, (((frame_table.item[((l_tmp___43 + 3 * l_tmp___47) + 9 * l_tmp___51) + 27 * l_tmp___55]).to_integer_32).bit_or (32_768)).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
				when 49 then -- if done | if done | if done
						if l_j < y then
							if l_i < 0 then
								l_tmp___65 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_i > x then
								l_tmp___65 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_j < -1 then
								l_tmp___65 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							elseif l_j > y + 1 then
								l_tmp___65 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							else
								l_tmp___65 := l_fv + ((l_j + 1) + (y + 2) * l_i)
							end
							if (l_tmp___65[0]).to_integer_32 >= 0 then
								l_qq___0 := 0
								from
								until
									not (l_qq___0 < r_heights[l_j])
								loop
									if l_i < 0 then
										l_tmp___64 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
									elseif l_i > x then
										l_tmp___64 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
									elseif l_j < -1 then
										l_tmp___64 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
									elseif l_j > y + 1 then
										l_tmp___64 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
									else
										l_tmp___64 := l_fv + ((l_j + 1) + (y + 2) * l_i)
									end
									if (l_tmp___64[0]).to_integer_32 = -1 then
										l_tmp___63 := 0
									else
										if l_i < 0 then
											l_tmp___62 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
										elseif l_i > x then
											l_tmp___62 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
										elseif l_j < -1 then
											l_tmp___62 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
										elseif l_j > y + 1 then
											l_tmp___62 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
										else
											l_tmp___62 := l_fv + ((l_j + 1) + (y + 2) * l_i)
										end
										l_tmp___63 := (l_tmp___62[0]).to_integer_32
									end
									xset_hchar (p, l_cx, (l_cy + 1) + l_qq___0, (((vline_table.item[l_tmp___63]).to_integer_32).bit_or (32_768)).to_natural_32)
									update_class_fields -- Current might have been changed; synchronize
									l_qq___0 := l_qq___0 + 1
								end
							end
						end
						l_cx := l_cx + 1
				when 50 then -- if done | if done
						l_cy := l_cy + 1
				when 51 then -- if block done, skip else block:
						l_pos := -1 + 53
				when 52 then -- else:
						l_pos := -1 + 56 -- goto _L___8
				when 53 then -- if done | if block done, skip else block:
						l_pos := -1 + 55
				when 54 then -- else:
						l_pos := -1 + 56 -- goto _L___8
				when 55 then -- if done | if block done, skip else block:
						l_pos := -1 + 70
				when 56 then -- else: | _L___8:
						if not (l_j < y) then
							l_pos := -1 + 70 -- skip if block
						end
				when 57 then -- if:
						l_i := 0
				when 58 then -- loop condition:
						if not (not (l_return) and then (l_i <= x)) then
							l_pos := -1 + 70 -- skip loop
						end
				when 59 then -- loop body:
						if not (l_i > 0) then
							l_pos := -1 + 62 -- skip if block
						end
				when 60 then -- if:
						if l_i < x then
							l_tmp___71 := ((create {CE_CLASS_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]}.make_shared (c_pointer))).item.get_vline_width (l_i)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___71 >= 0 then
								l_pos := -1 + 68 -- goto _L___1
							else
								l_pos := -1 + 62 -- goto _L___5
							end
						else
							l_pos := -1 + 62 -- goto _L___5
						end
				when 61 then -- if block done, skip else block:
						l_pos := -1 + 69
				when 62 then -- else: | _L___5:
						if l_i /= 0 then
							l_pos := -1 + 65 -- skip if block
						end
				when 63 then -- if:
						if border.to_boolean then
							if ((frame).bit_and (4)).to_boolean then
								l_pos := -1 + 68 -- goto _L___1
							else
								l_pos := -1 + 65 -- goto _L___3
							end
						else
							l_pos := -1 + 65 -- goto _L___3
						end
				when 64 then -- if block done, skip else block:
						l_pos := -1 + 69
				when 65 then -- else: | _L___3:
						if l_i /= x then
							l_pos := -1 + 69 -- skip if block
						end
				when 66 then -- if:
						if not (border.to_boolean) then
							l_pos := -1 + 69 -- skip if block
						end
				when 67 then -- if:
						if not (((frame).bit_and (8)).to_boolean) then
							l_pos := -1 + 69 -- skip if block
						end
				when 68 then -- if: | _L___1:
						if l_i < 0 then
							l_tmp___70 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_i > x then
							l_tmp___70 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j < -1 then
							l_tmp___70 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						elseif l_j > y + 1 then
							l_tmp___70 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							l_tmp___70 := l_fv + ((l_j + 1) + (y + 2) * l_i)
						end
						if (l_tmp___70[0]).to_integer_32 >= 0 then
							l_qq___1 := 0
							from
							until
								not (l_qq___1 < r_heights[l_j])
							loop
								if l_i < 0 then
									l_tmp___69 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								elseif l_i > x then
									l_tmp___69 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								elseif l_j < -1 then
									l_tmp___69 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								elseif l_j > y + 1 then
									l_tmp___69 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								else
									l_tmp___69 := l_fv + ((l_j + 1) + (y + 2) * l_i)
								end
								if (l_tmp___69[0]).to_integer_32 = -1 then
									l_tmp___68 := 0
								else
									if l_i < 0 then
										l_tmp___67 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
									elseif l_i > x then
										l_tmp___67 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
									elseif l_j < -1 then
										l_tmp___67 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
									elseif l_j > y + 1 then
										l_tmp___67 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
									else
										l_tmp___67 := l_fv + ((l_j + 1) + (y + 2) * l_i)
									end
									l_tmp___68 := (l_tmp___67[0]).to_integer_32
								end
								xset_hchar (p, l_cx, l_cy + l_qq___1, (((vline_table.item[l_tmp___68]).to_integer_32).bit_or (32_768)).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								l_qq___1 := l_qq___1 + 1
							end
						end
						l_cx := l_cx + 1
				when 69 then -- if done | if done | if done | if done
						if l_i < x then
							l_cx := l_cx + (w_c[l_i])
						end
						l_i := l_i + 1
						l_pos := -1 + 58 -- back to loop condition
				when 70 then -- loop done | if done | if done | if done
						if l_j < y then
							l_cy := l_cy + (r_heights[l_j])
						end
						l_j := l_j + 1
						l_pos := -1 + 10 -- back to loop condition
				when 71 then -- loop done;
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 1_081, create {CE_VOID_POINTER}.make_cast (l_fh))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 1_082, create {CE_VOID_POINTER}.make_cast (l_fv))
					update_class_fields -- Current might have been changed; synchronize
				when 72 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS} -- private routines

	dst_width (a_p: CE_POINTER [INTEGER_32]; a_n, a_w: INTEGER_32; a_lim: CE_POINTER [INTEGER_32])
		local
			l_w: INTEGER_32
			l_lim: CE_POINTER [INTEGER_32]
			l_i: INTEGER_32
			l_s: INTEGER_32
			l_d: INTEGER_32
			l_r: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_w := a_w
					l_lim := a_lim
					l_s := 0
					l_i := 0
					from
					until
						not (l_i < a_n)
					loop
						l_s := l_s + (a_p[l_i])
						l_i := l_i + 1
					end
					if l_s >= l_w then
						l_return := True
					end
					if not l_return and then (not a_n.to_boolean) then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 2 -- skip if block
					end
				when 1 then -- if: | again:
						l_d := (l_w - l_s) // a_n
						l_r := (l_w - l_s) \\ a_n
						l_w := 0
						l_i := 0
						from
						until
							not (l_i < a_n)
						loop
							a_p[l_i] := a_p[l_i] + (l_d + (l_i < l_r).to_integer)
							if (not l_lim.is_void) then
								if a_p[l_i] > l_lim[l_i] then
									l_w := l_w + (a_p[l_i] - l_lim[l_i])
									a_p[l_i] := l_lim[l_i]
								end
							end
							l_i := l_i + 1
						end
						if l_w.to_boolean then
							l_lim := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
							l_s := 0
							l_pos := -1 + 1 -- goto again
						end
				when 2 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_hline_width (a_t: CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]; a_row: INTEGER_32): INTEGER_32
		local
			l_w: INTEGER_32
			l_q: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_w := 0
					if not a_row.to_boolean then
						Result := (-1)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						if a_t.item.rules /= 1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto x
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 4 then -- else:
						if a_t.item.rules /= 3 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | x:
						if (a_t.item.cellsp).to_boolean then
							Result := (a_t.item.cellsp)
							l_return := True
						elseif (a_t.item.vcellpd).to_boolean then
							Result := (a_t.item.cellsp)
							l_return := True
						end
						if not l_return then
							Result := (-1)
							l_return := True
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 7 then -- else:
						if a_t.item.rules /= 4 then
							l_pos := -1 + 13 -- skip if block
						end
				when 8 then -- if:
						l_q := 0
				when 9 then -- loop condition:
						if not (l_q < a_t.item.x) then
							l_pos := -1 + 12 -- skip loop
						end
				when 10 then -- loop body:
						if ((a_t.item.cells + (a_row * a_t.item.rx + l_q)).item.group).to_boolean then
							l_pos := -1 + 5 -- goto x
						end
				when 11 then
						l_q := l_q + 1
						l_pos := -1 + 9 -- back to loop condition
				when 12 then -- loop done
						if (a_t.item.vcellpd).to_boolean then
							l_tmp := 0
						else
							l_tmp := -1
						end
						Result := l_tmp
						l_return := True
				when 13 then -- if done | if done | if done
					if not l_return then
						if not l_w.to_boolean then
							if not (a_t.item.vcellpd).to_boolean then
								l_w := -1
							end
						end
						Result := l_w
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_cell_width (a_start, a_end: CE_POINTER [INTEGER_8]; a_cellpd, a_w, a_a: INTEGER_32; a_min, a_max: CE_POINTER [INTEGER_32]; a_n_link: INTEGER_32; a_n_links: CE_POINTER [INTEGER_32])
		local
			l_p: CE_POINTER [PD_PART]
			l_return: BOOLEAN
		do
			if (not a_min.is_void) then
				a_min.item := -1
			end
			if (not a_max.is_void) then
				a_max.item := -1
			end
			if (not a_n_links.is_void) then
				a_n_links.item := a_n_link
			end
			l_p := (create {P_HTML_R_STATIC}).format_html_part (create {CE_NATURAL_8_POINTER}.make_cast (a_start), create {CE_NATURAL_8_POINTER}.make_cast (a_end), 0, a_cellpd, a_w, create {CE_CLASS_POINTER [PD_F_DATA]}.make_shared (default_pointer), (a_a.to_boolean).to_integer, (a_a.to_boolean).to_integer, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), a_n_link)
			if l_p.is_void then
				l_return := True
			end
			if not l_return then
				if (not a_min.is_void) then
					a_min.item := l_p.item.x
				end
				if (not a_max.is_void) then
					a_max.item := l_p.item.xmax
				end
				if (not a_n_links.is_void) then
					a_n_links.item := l_p.item.link_num
				end
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 545, create {CE_VOID_POINTER}.make_cast (l_p))
			end
		end

	xset_hchar (a_p: CE_POINTER [PD_PART]; a_x, a_y: INTEGER_32; a_c: NATURAL_32)
		require
			not a_p.is_void
		do
			set_hchar (a_p, a_x, a_y, a_c)
		end

	set_hchar (a_p: CE_POINTER [PD_PART]; a_x, a_y: INTEGER_32; a_c: NATURAL_32)
		require
			not a_p.is_void
		do
			a_p.item.xpand_lines (a_y)
			a_p.item.xpand_line (a_y, a_x);
			((a_p.item.data).item.data + (a_p.item.yp + a_y)).item.d[(a_p.item.xp + a_x)] := a_c.to_natural_16
		end

	xset_hchars (a_p: CE_POINTER [PD_PART]; a_x, a_y, a_xl: INTEGER_32; a_c: NATURAL_32)
		require
			not a_p.is_void
		do
			a_p.item.set_hchars (a_x, a_y, a_xl, a_c)
		end

	xxpand_lines (a_p: CE_POINTER [PD_PART]; a_y: INTEGER_32)
		require
			not a_p.is_void
		do
			a_p.item.xpand_lines (a_y)
		end

	xxpand_line (a_p: CE_POINTER [PD_PART]; a_y, a_x: INTEGER_32)
		require
			not a_p.is_void
		do
			a_p.item.xpand_line (a_y, a_x)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			p := a_other.p
			x := a_other.x
			y := a_other.y
			rx := a_other.rx
			ry := a_other.ry
			border := a_other.border
			cellpd := a_other.cellpd
			vcellpd := a_other.vcellpd
			cellsp := a_other.cellsp
			frame := a_other.frame
			rules := a_other.rules
			width := a_other.width
			wf := a_other.wf
			min_c := a_other.min_c
			max_c := a_other.max_c
			w_c := a_other.w_c
			rw := a_other.rw
			min_t := a_other.min_t
			max_t := a_other.max_t
			cells := a_other.cells
			c := a_other.c
			rc := a_other.rc
			cols := a_other.cols
			xc := a_other.xc
			xcols := a_other.xcols
			r_heights := a_other.r_heights
			rh := a_other.rh
			link_num := a_other.link_num
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				p.is_equal (a_other.p) and
				x = a_other.x and
				y = a_other.y and
				rx = a_other.rx and
				ry = a_other.ry and
				border = a_other.border and
				cellpd = a_other.cellpd and
				vcellpd = a_other.vcellpd and
				cellsp = a_other.cellsp and
				frame = a_other.frame and
				rules = a_other.rules and
				width = a_other.width and
				wf = a_other.wf and
				min_c.is_equal (a_other.min_c) and
				max_c.is_equal (a_other.max_c) and
				w_c.is_equal (a_other.w_c) and
				rw = a_other.rw and
				min_t = a_other.min_t and
				max_t = a_other.max_t and
				cells.is_equal (a_other.cells) and
				c = a_other.c and
				rc = a_other.rc and
				cols.is_equal (a_other.cols) and
				xc = a_other.xc and
				xcols.is_equal (a_other.xcols) and
				r_heights.is_equal (a_other.r_heights) and
				rh = a_other.rh and
				link_num = a_other.link_num
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("p"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("rx"),
					create {CE_STRUCTURE_FIELD}.make ("ry"),
					create {CE_STRUCTURE_FIELD}.make ("border"),
					create {CE_STRUCTURE_FIELD}.make ("cellpd"),
					create {CE_STRUCTURE_FIELD}.make ("vcellpd"),
					create {CE_STRUCTURE_FIELD}.make ("cellsp"),
					create {CE_STRUCTURE_FIELD}.make ("frame"),
					create {CE_STRUCTURE_FIELD}.make ("rules"),
					create {CE_STRUCTURE_FIELD}.make ("width"),
					create {CE_STRUCTURE_FIELD}.make ("wf"),
					create {CE_STRUCTURE_FIELD}.make ("min_c"),
					create {CE_STRUCTURE_FIELD}.make ("max_c"),
					create {CE_STRUCTURE_FIELD}.make ("w_c"),
					create {CE_STRUCTURE_FIELD}.make ("rw"),
					create {CE_STRUCTURE_FIELD}.make ("min_t"),
					create {CE_STRUCTURE_FIELD}.make ("max_t"),
					create {CE_STRUCTURE_FIELD}.make ("cells"),
					create {CE_STRUCTURE_FIELD}.make ("c"),
					create {CE_STRUCTURE_FIELD}.make ("rc"),
					create {CE_STRUCTURE_FIELD}.make ("cols"),
					create {CE_STRUCTURE_FIELD}.make ("xc"),
					create {CE_STRUCTURE_FIELD}.make ("xcols"),
					create {CE_STRUCTURE_FIELD}.make ("r_heights"),
					create {CE_STRUCTURE_FIELD}.make ("rh"),
					create {CE_STRUCTURE_FIELD}.make ("link_num")
				>>)
			init_structure_info
		end

end
