class
	PD_TABLE_ENTRY

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	c: NATURAL_8 assign set_c

	u: INTEGER_32 assign set_u

feature {ANY} -- field setters

	set_c (a_c: NATURAL_8)
		do
			c := a_c
			update_memory_field ("c")
		end

	set_u (a_u: INTEGER_32)
		do
			u := a_u
			update_memory_field ("u")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			c := a_other.c
			u := a_other.u
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				c = a_other.c and
				u = a_other.u
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("c"),
					create {CE_STRUCTURE_FIELD}.make ("u")
				>>)
			init_structure_info
		end

end
