class
	PD_TERMINAL_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- routine addresses

	cache_inf_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_term: CE_POINTER [PD_TERMINAL]; a_d: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
				do
					a_term.item.cache_inf (a_d, a_ses)
				end)
		end

	list_cache_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_term: CE_POINTER [PD_TERMINAL]; a_d: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
				do
					a_term.item.list_cache (a_d, a_ses)
				end)
		end

	memory_info_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_term: CE_POINTER [PD_TERMINAL]; a_d: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
				do
					a_term.item.memory_info (a_d, a_ses)
				end)
		end

	display_codepage_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_term: CE_POINTER [PD_TERMINAL]; a_pcp: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
				do
					a_term.item.display_codepage (a_pcp, a_ses)
				end)
		end

	terminal_options_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
				do
					a_term.item.terminal_options (a_xxx, a_ses)
				end)
		end

	dlg_resize_terminal_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
				do
					a_term.item.dlg_resize_terminal (a_xxx, a_ses)
				end)
		end

	do_file_menu_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
				do
					a_term.item.do_file_menu (a_xxx, a_ses)
				end)
		end

	in_term_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_term: CE_POINTER [PD_TERMINAL])
				do
					a_term.item.in_term
				end)
		end

	destroy_terminal_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_term: CE_POINTER [PD_TERMINAL])
				do
					a_term.item.destroy_terminal
				end)
		end

	unblock_terminal_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_term: CE_POINTER [PD_TERMINAL])
				do
					a_term.item.unblock_terminal
				end)
		end

	open_in_new_window_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_ROUTINE; a_ses: CE_POINTER [PD_SESSION])
				do
					a_term.item.open_in_new_window (a_xxx, a_ses)
				end)
		end

	do_menu_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_term: CE_POINTER [PD_TERMINAL]; a_items: CE_POINTER [PD_MENU_ITEM]; a_data: CE_POINTER [ANY])
				do
					a_term.item.do_menu (a_items, a_data)
				end)
		end

	menu_bookmark_manager_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_term: CE_POINTER [PD_TERMINAL]; a_fcp: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
				do
					a_term.item.menu_bookmark_manager (a_fcp, a_ses)
				end)
		end

	do_select_submenu_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_term: CE_POINTER [PD_TERMINAL]; a_menu: CE_POINTER [PD_MENU_ITEM]; a_ses: CE_POINTER [PD_SESSION])
				do
					a_term.item.do_select_submenu (a_menu, a_ses)
				end)
		end

	menu_about_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_term: CE_POINTER [PD_TERMINAL]; a_d: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
				do
					a_term.item.menu_about (a_d, a_ses)
				end)
		end

	menu_keys_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_term: CE_POINTER [PD_TERMINAL]; a_d: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
				do
					a_term.item.menu_keys (a_d, a_ses)
				end)
		end

	menu_copying_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_term: CE_POINTER [PD_TERMINAL]; a_d: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
				do
					a_term.item.menu_copying (a_d, a_ses)
				end)
		end

	net_options_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_term: CE_POINTER [PD_TERMINAL]; a_xxx, a_yyy: CE_POINTER [ANY])
				do
					a_term.item.net_options (a_xxx, a_yyy)
				end)
		end

	net_programs_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_term: CE_POINTER [PD_TERMINAL]; a_xxx, a_yyy: CE_POINTER [ANY])
				do
					a_term.item.net_programs (a_xxx, a_yyy)
				end)
		end

	cache_opt_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_term: CE_POINTER [PD_TERMINAL]; a_xxx, a_yyy: CE_POINTER [ANY])
				do
					a_term.item.cache_opt (a_xxx, a_yyy)
				end)
		end

	menu_html_options_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
				do
					a_term.item.menu_html_options (a_xxx, a_ses)
				end)
		end

	do_view_menu_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
				do
					a_term.item.do_view_menu (a_xxx, a_ses)
				end)
		end

	do_setup_menu_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
				do
					a_term.item.do_setup_menu (a_xxx, a_ses)
				end)
		end

	launch_bm_add_doc_dialog_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_term: CE_POINTER [PD_TERMINAL]; a_parent: CE_POINTER [PD_DIALOG_DATA]; a_ses: CE_POINTER [PD_SESSION])
				do
					a_term.item.launch_bm_add_doc_dialog (a_parent, a_ses)
				end)
		end

end
