class
	S_DIRENT_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	opendir (a___name: CE_POINTER [INTEGER_8]): CE_POINTER [ANY]
		require
			not a___name.is_void
		do
			create {CE_VOID_POINTER} Result.make_shared (c_opendir (a___name.c_pointer))
		end

	c_opendir (a___name: POINTER): POINTER
		external
			"C inline use <links.h>"
		alias
			"return (EIF_POINTER)opendir($a___name);"
		end

	closedir (a___dirp: CE_POINTER [ANY]): INTEGER_32
		require
			not a___dirp.is_void
		do
			Result := c_closedir (a___dirp.c_pointer)
		end

	c_closedir (a___dirp: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return closedir($a___dirp);"
		end

	readdir (a___dirp: CE_POINTER [ANY]): CE_POINTER [SD_DIRENT]
		require
			not a___dirp.is_void
		do
			create {CE_CLASS_POINTER [SD_DIRENT]} Result.make_shared (c_readdir (a___dirp.c_pointer))
		end

	c_readdir (a___dirp: POINTER): POINTER
		external
			"C inline use <links.h>"
		alias
			"return (EIF_POINTER)readdir($a___dirp);"
		end

end
