class
	P_GUI_BEVAL_STATIC

inherit
	CE_UTILITIES
	S_LIBINTL_STATIC
	S_GTK_GTK_STATIC
	S_GLIB_OBJECT_STATIC
	S_GDK_GDK_STATIC

feature {ANY} -- public attributes

	result___1: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	recursive___11: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	general_beval_cb (a_beval: CE_POINTER [PD_BALLOONEVALSTRUCT]; a_state: INTEGER_32)
		local
			l_wp___0: CE_ARRAY [CE_POINTER [PD_WINDOW_S]]
			l_col: CE_ARRAY [INTEGER_32]
			l_use_sandbox: INTEGER_32
			l_lnum: CE_ARRAY [INTEGER_32]
			l_text: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_winnr: INTEGER_32
			l_bexpr: CE_POINTER [NATURAL_8]
			l_save_curbuf: CE_POINTER [PD_FILE_BUFFER]
			l_cw: CE_POINTER [PD_WINDOW_S]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_WINDOW_S]} l_wp___0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_col.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_lnum.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_text.make (<<1>>)

			l_winnr := 0
			if not ((create {P_OPTION_STATIC}).p_beval.item.item).to_boolean then
				l_return := True
			elseif ((create {P_GLOBALS_STATIC}).balloonEval.item).is_void then
				l_return := True
			elseif (create {P_GLOBALS_STATIC}).msg_scrolled.item > 0 then
				l_return := True
			end
			if not l_return and then (recursive___11.item.to_boolean) then
				l_return := True
			end
			if not l_return then
				recursive___11.item := 1
				if (((create {P_GLOBALS_STATIC}).balloonEval.item).item.get_beval_info (1, l_wp___0, l_lnum, l_text, l_col)) = 1 then
					if (((l_wp___0.item.item.w_buffer).item.b_p_bexpr).item).to_integer_32 = 0 then
						l_bexpr := (create {P_OPTION_STATIC}).p_bexpr.item.item
					else
						l_bexpr := (l_wp___0.item.item.w_buffer).item.b_p_bexpr
					end
					if (l_bexpr.item).to_integer_32 /= 0 then
						l_cw := (create {P_GLOBALS_STATIC}).firstwin.item
						from
						until
							l_cw.is_equal (l_wp___0.item)
						loop
							l_winnr := l_winnr + 1
							l_cw := l_cw.item.w_next
						end
						(create {P_EVAL_STATIC}).set_vim_var_nr (39, ((l_wp___0.item.item.w_buffer).item.b_fnum).to_integer_32);
						(create {P_EVAL_STATIC}).set_vim_var_nr (40, l_winnr);
						(create {P_EVAL_STATIC}).set_vim_var_nr (41, l_lnum.item);
						(create {P_EVAL_STATIC}).set_vim_var_nr (42, (l_col.item + 1).to_integer_32);
						(create {P_EVAL_STATIC}).set_vim_var_string (43, l_text.item, -1);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_text.item))
						l_save_curbuf := (create {P_GLOBALS_STATIC}).curbuf.item;
						(create {P_GLOBALS_STATIC}).curbuf.item := l_wp___0.item.item.w_buffer
						if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bexpr).item).to_integer_32 = 0 then
							l_tmp := 0
						else
							l_tmp := 4
						end
						l_use_sandbox := (create {P_OPTION_STATIC}).was_set_insecurely (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("balloonexpr")), l_tmp);
						(create {P_GLOBALS_STATIC}).curbuf.item := l_save_curbuf
						if l_use_sandbox.to_boolean then
							(create {P_GLOBALS_STATIC}).sandbox.item := (create {P_GLOBALS_STATIC}).sandbox.item + 1
						end
						(create {P_GLOBALS_STATIC}).textlock.item := (create {P_GLOBALS_STATIC}).textlock.item + 1;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (result___1.item))
						result___1.item := (create {P_EVAL_STATIC}).eval_to_string (l_bexpr, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), 1)
						if l_use_sandbox.to_boolean then
							(create {P_GLOBALS_STATIC}).sandbox.item := (create {P_GLOBALS_STATIC}).sandbox.item - 1
						end
						(create {P_GLOBALS_STATIC}).textlock.item := (create {P_GLOBALS_STATIC}).textlock.item - 1;
						(create {P_EVAL_STATIC}).set_vim_var_string (43, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), -1)
						if not result___1.item.is_void then
							if (result___1.item[0]).to_integer_32 /= 0 then
								a_beval.item.gui_mch_post_balloon (result___1.item)
								recursive___11.item := 0
								l_return := True
							end
						end
					end
				end
			end
			if not l_return then
				if (((create {P_GLOBALS_STATIC}).bevalServers.item).bit_and (1)).to_boolean then
					(create {P_NETBEANS_STATIC}).netbeans_beval_cb (a_beval, a_state)
				end
				recursive___11.item := 0
			end
		end

	gui_mch_create_beval_area (a_target: CE_POINTER [ANY]; a_mesg: CE_POINTER [NATURAL_8]; a_mesgCB: CE_ROUTINE; a_clientData: CE_POINTER [ANY]): CE_POINTER [PD_BALLOONEVALSTRUCT]
		local
			l_beval: CE_POINTER [PD_BALLOONEVALSTRUCT]
			l_return: BOOLEAN
		do
			if not a_mesg.is_void then
				if not a_mesgCB.is_void then
					(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E232: Cannot create BalloonEval with both message and callback"))))).do_nothing
					Result := (create {CE_CLASS_POINTER [PD_BALLOONEVALSTRUCT]}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				l_beval := create {CE_CLASS_POINTER [PD_BALLOONEVALSTRUCT]}.make_cast (((create {P_MISC2_STATIC}).alloc ((create {PD_BALLOONEVALSTRUCT}.make).structure_size.to_natural_32)))
				if not l_beval.is_void then
					l_beval.item.target := create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_target), (gtk_widget_get_type))))
					l_beval.item.balloonShell := create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer)
					l_beval.item.timerID := {NATURAL_32} 0
					l_beval.item.showState := {PC_BESTATE}.ShS_NEUTRAL
					l_beval.item.x := 0
					l_beval.item.y := 0
					l_beval.item.msg := a_mesg
					l_beval.item.msgCB := a_mesgCB
					l_beval.item.clientData := a_clientData
					addEventHandler (l_beval.item.target, l_beval)
					l_beval.item.createBalloonEvalWindow
				end
				Result := l_beval
			end
		end

	gui_mch_enable_beval_area (a_beval: CE_POINTER [PD_BALLOONEVALSTRUCT])
		do
			if not a_beval.is_void then
				addEventHandler (a_beval.item.target, a_beval)
			end
		end

	gui_mch_disable_beval_area (a_beval: CE_POINTER [PD_BALLOONEVALSTRUCT])
		do
			if not a_beval.is_void then
				a_beval.item.removeEventHandler
			end
		end

	addEventHandler (a_target: CE_POINTER [SD_GTKWIDGET]; a_beval: CE_POINTER [PD_BALLOONEVALSTRUCT])
		do
			gtk_signal_connect_full (create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast (a_target), ce_string ("event"), (target_event_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_cast (a_beval), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
			if (create {P_GLOBALS_STATIC}).gtk_socket_id.item = {NATURAL_32} 0 then
				if not ((create {P_GUI_STATIC}).gui.item.item.mainwin).is_void then
					if (gtk_widget_is_ancestor (a_target, (create {P_GUI_STATIC}).gui.item.item.mainwin)).to_boolean then
						gtk_signal_connect_full (create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast ((create {P_GUI_STATIC}).gui.item.item.mainwin), ce_string ("event"), (mainwin_event_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_cast (a_beval), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
					end
				end
			end
		end

	target_event_cb (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENT]; a_data: CE_POINTER [ANY]): INTEGER_32
		require
			not a_event.is_void
		local
			l_beval: CE_POINTER [PD_BALLOONEVALSTRUCT]
			l_x___0: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
			l_state: CE_ARRAY [NATURAL_32]
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_x___0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_y.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_state.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_beval := create {CE_CLASS_POINTER [PD_BALLOONEVALSTRUCT]}.make_cast (a_data)
					inspect a_event.item.type -- switch 1 head
					when 10 then l_pos := -1 + 1
					when 3 then l_pos := -1 + 2
					when 11 then l_pos := -1 + 3
					when 4 then l_pos := -1 + 4
					when 31 then l_pos := -1 + 4
					when 8 then l_pos := -1 + 5
					when 9 then l_pos := -1 + 6
					else l_pos := -1 + 7
					end
				when 1 then -- switch 1, case 10
					l_beval.item.pointer_event ((a_event.item.crossing.x).truncated_to_integer, (a_event.item.crossing.y).truncated_to_integer, a_event.item.crossing.state)
					l_pos := -1 + 8 -- switch 1; break
				when 2 then -- switch 1, case 3
					if (a_event.item.motion.is_hint).to_boolean then
						gdk_window_get_pointer (a_widget.item.window, l_x___0, l_y, l_state).do_nothing
						l_beval.item.pointer_event (l_x___0.item, l_y.item, l_state.item)
					else
						l_beval.item.pointer_event ((a_event.item.motion.x).truncated_to_integer, (a_event.item.motion.y).truncated_to_integer, a_event.item.motion.state)
					end
					l_pos := -1 + 8 -- switch 1; break
				when 3 then -- switch 1, case 11
					if a_event.item.crossing.mode = {NATURAL_32} 0 then
						l_beval.item.cancelBalloon
					end
					l_pos := -1 + 8 -- switch 1; break
				when 4 then -- switch 1, case 4 | switch 1, case 31
					l_beval.item.cancelBalloon
					l_pos := -1 + 8 -- switch 1; break
				when 5 then -- switch 1, case 8
					l_beval.item.key_event (a_event.item.key.keyval, 1)
					l_pos := -1 + 8 -- switch 1; break
				when 6 then -- switch 1, case 9
					l_beval.item.key_event (a_event.item.key.keyval, 0)
					l_pos := -1 + 8 -- switch 1; break
				when 7 then -- switch 1, default:
					l_pos := -1 + 8 -- switch 1; break
				when 8 then -- switch 1, done:
					Result := 0
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mainwin_event_cb (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENT]; a_data: CE_POINTER [ANY]): INTEGER_32
		require
			not a_event.is_void
		local
			l_beval: CE_POINTER [PD_BALLOONEVALSTRUCT]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_beval := create {CE_CLASS_POINTER [PD_BALLOONEVALSTRUCT]}.make_cast (a_data)
					inspect a_event.item.type -- switch 1 head
					when 8 then l_pos := -1 + 1
					when 9 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 8
					l_beval.item.key_event (a_event.item.key.keyval, 1)
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 9
					l_beval.item.key_event (a_event.item.key.keyval, 0)
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					Result := 0
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	timeout_cb (a_data: CE_POINTER [ANY]): INTEGER_32
		local
			l_beval: CE_POINTER [PD_BALLOONEVALSTRUCT]
		do
			l_beval := create {CE_CLASS_POINTER [PD_BALLOONEVALSTRUCT]}.make_cast (a_data)
			l_beval.item.timerID := {NATURAL_32} 0
			l_beval.item.requestBalloon
			Result := 0
		end

	balloon_expose_event_cb (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTEXPOSE]; a_data: CE_POINTER [ANY]): INTEGER_32
		require
			not a_widget.is_void
		do
			gtk_paint_flat_box (a_widget.item.style, a_widget.item.window, {SC_GTKSTATETYPE}.GTK_STATE_NORMAL, {SC_GTKSHADOWTYPE}.GTK_SHADOW_OUT, (create {CE_CLASS_POINTER [SD_GDKRECTANGLE]}.make_shared (a_event.c_pointer + (create {SD_GDKEVENTEXPOSE}.make).offset_of ("area"))), a_widget, ce_string ("tooltip"), 0, 0, -1, -1)
			Result := 0
		end

feature {ANY} -- routine addresses

	general_beval_cb_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent general_beval_cb)
		end

	target_event_cb_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent target_event_cb)
		end

	mainwin_event_cb_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent mainwin_event_cb)
		end

	timeout_cb_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent timeout_cb)
		end

	balloon_expose_event_cb_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent balloon_expose_event_cb)
		end

end
