class
	P_HARDCOPY_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_STDIO_STATIC
	S_LIBINTL_STATIC

feature {ANY} -- public attributes

	mbfont_opts: CE_STATIC [CE_ARRAY [PD_OPTION_TABLE_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_OPTION_TABLE_T]}.make_initialized (<<
					create {PD_OPTION_TABLE_T}.make_initialized ([ce_string ("c"), 0, 0, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_OPTION_TABLE_T}.make_initialized ([ce_string ("a"), 0, 0, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_OPTION_TABLE_T}.make_initialized ([ce_string ("r"), 0, 0, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_OPTION_TABLE_T}.make_initialized ([ce_string ("b"), 0, 0, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_OPTION_TABLE_T}.make_initialized ([ce_string ("i"), 0, 0, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_OPTION_TABLE_T}.make_initialized ([ce_string ("o"), 0, 0, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, 0])
				>>)
		end

	units: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("pc"),
					ce_string ("in"),
					ce_string ("mm"),
					ce_string ("pt")
				>>)
		end

	prt_mediasize: CE_STATIC [CE_ARRAY [PD_PRT_MEDIASIZE_S]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_PRT_MEDIASIZE_S]}.make_initialized (<<
					create {PD_PRT_MEDIASIZE_S}.make_initialized ([ce_string ("A4"), (595.0).truncated_to_real, (842.0).truncated_to_real]),
					create {PD_PRT_MEDIASIZE_S}.make_initialized ([ce_string ("letter"), (612.0).truncated_to_real, (792.0).truncated_to_real]),
					create {PD_PRT_MEDIASIZE_S}.make_initialized ([ce_string ("10x14"), (720.0).truncated_to_real, (1008.0).truncated_to_real]),
					create {PD_PRT_MEDIASIZE_S}.make_initialized ([ce_string ("A3"), (842.0).truncated_to_real, (1191.0).truncated_to_real]),
					create {PD_PRT_MEDIASIZE_S}.make_initialized ([ce_string ("A5"), (420.0).truncated_to_real, (595.0).truncated_to_real]),
					create {PD_PRT_MEDIASIZE_S}.make_initialized ([ce_string ("B4"), (729.0).truncated_to_real, (1032.0).truncated_to_real]),
					create {PD_PRT_MEDIASIZE_S}.make_initialized ([ce_string ("B5"), (516.0).truncated_to_real, (729.0).truncated_to_real]),
					create {PD_PRT_MEDIASIZE_S}.make_initialized ([ce_string ("executive"), (522.0).truncated_to_real, (756.0).truncated_to_real]),
					create {PD_PRT_MEDIASIZE_S}.make_initialized ([ce_string ("folio"), (595.0).truncated_to_real, (935.0).truncated_to_real]),
					create {PD_PRT_MEDIASIZE_S}.make_initialized ([ce_string ("ledger"), (1224.0).truncated_to_real, (792.0).truncated_to_real]),
					create {PD_PRT_MEDIASIZE_S}.make_initialized ([ce_string ("legal"), (612.0).truncated_to_real, (1008.0).truncated_to_real]),
					create {PD_PRT_MEDIASIZE_S}.make_initialized ([ce_string ("quarto"), (610.0).truncated_to_real, (780.0).truncated_to_real]),
					create {PD_PRT_MEDIASIZE_S}.make_initialized ([ce_string ("statement"), (396.0).truncated_to_real, (612.0).truncated_to_real]),
					create {PD_PRT_MEDIASIZE_S}.make_initialized ([ce_string ("tabloid"), (792.0).truncated_to_real, (1224.0).truncated_to_real])
				>>)
		end

	prt_ps_courier_font: CE_STATIC [CE_ARRAY [PD_PRT_PS_FONT_S]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_PRT_PS_FONT_S]}.make_initialized (<<
					create {PD_PRT_PS_FONT_S}.make_initialized ([600, -100, 50, -250, 805, create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
							ce_string ("Courier"),
							ce_string ("Courier-Bold"),
							ce_string ("Courier-Oblique"),
							ce_string ("Courier-BoldOblique")
						>>)])
				>>)
		end

	prt_ps_mb_font: CE_STATIC [CE_ARRAY [PD_PRT_PS_FONT_S]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_PRT_PS_FONT_S]}.make_initialized (<<
					create {PD_PRT_PS_FONT_S}.make_initialized ([1_000, -100, 50, -250, 805, create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
							create {CE_INTEGER_8_POINTER}.make_shared (default_pointer),
							create {CE_INTEGER_8_POINTER}.make_shared (default_pointer),
							create {CE_INTEGER_8_POINTER}.make_shared (default_pointer),
							create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						>>)])
				>>)
		end

	prt_ps_font: CE_STATIC [CE_POINTER [PD_PRT_PS_FONT_S]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_PRT_PS_FONT_S]}.make
		end

	prt_ps_fd: CE_STATIC [CE_POINTER [SD_IO_FILE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [SD_IO_FILE]}.make
		end

	prt_file_error: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	prt_line_height: CE_STATIC [REAL_32]
		once ("PROCESS")
		end

	prt_char_width: CE_STATIC [REAL_32]
		once ("PROCESS")
		end

	prt_bgcol_offset: CE_STATIC [REAL_32]
		once ("PROCESS")
		end

	prt_media: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	prt_portrait: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	prt_num_copies: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	prt_duplex: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	prt_tumble: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	prt_collate: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	prt_line_buffer: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make (<<257>>)
		end

	prt_do_conv: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	prt_conv: CE_STATIC [CE_ARRAY [PD_VIMCONV_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_VIMCONV_T]}.make (<<1>>)
		end

	prt_out_mbyte: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	prt_custom_cmap: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	prt_cmap: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<80>>)
		end

	prt_use_courier: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	prt_ascii_encoding: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

feature {ANY} -- public routines

	parse_printoptions: CE_POINTER [NATURAL_8]
		do
			Result := (parse_list_options ((create {P_OPTION_STATIC}).p_popt.item.item, (create {P_GLOBALS_STATIC}).printer_opts.item, 14))
		end

	parse_printmbfont: CE_POINTER [NATURAL_8]
		do
			Result := (parse_list_options ((create {P_OPTION_STATIC}).p_pmfn.item.item, mbfont_opts.item, 6))
		end

	parse_list_options (a_option_str: CE_POINTER [NATURAL_8]; a_table: CE_POINTER [PD_OPTION_TABLE_T]; a_table_size: INTEGER_32): CE_POINTER [NATURAL_8]
		require
			not a_option_str.is_void
		local
			l_stringp: CE_POINTER [NATURAL_8]
			l_colonp: CE_POINTER [NATURAL_8]
			l_commap: CE_POINTER [NATURAL_8]
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_idx: INTEGER_32
			l_len: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			l_idx := 0
			l_idx := 0
			from
			until
				not (l_idx < a_table_size)
			loop
				(a_table + l_idx).item.present := 0
				l_idx := l_idx + 1
			end
			l_stringp := a_option_str
			from
			until
				not (not (l_return) and then ((l_stringp.item).to_boolean))
			loop
				l_colonp := (create {P_MISC2_STATIC}).vim_strchr (l_stringp, (':').code)
				if l_colonp.is_void then
					Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E550: Missing colon")))
					l_return := True
				end
				if not l_return then
					l_commap := (create {P_MISC2_STATIC}).vim_strchr (l_stringp, (',').code)
					if l_commap.is_void then
						l_commap := a_option_str + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_option_str))).to_integer_32
					end
					l_len := l_colonp.distance (l_stringp)
					l_idx := 0
					from
					until
						not (not (l_break) and then (l_idx < a_table_size))
					loop
						l_break := False
						if (strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_stringp), (a_table + l_idx).item.name, l_len.to_natural_32)) = 0 then
							l_break := True
						end
						if not (l_break) then
							l_idx := l_idx + 1
						end
					end
					l_break := False
					if l_idx = a_table_size then
						Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E551: Illegal component")))
						l_return := True
					end
				end
				if not l_return then
					l_p___0.item := l_colonp + 1;
					(a_table + l_idx).item.present := 1
					if ((a_table + l_idx).item.hasnum).to_boolean then
						if (l_p___0.item.item).to_integer_32 >= 48 then
							if not ((l_p___0.item.item).to_integer_32 <= 57) then
								Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E552: digit expected")))
								l_return := True
							end
						else
							Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E552: digit expected")))
							l_return := True
						end
						if not l_return then
							(a_table + l_idx).item.number := (create {P_CHARSET_STATIC}).getdigits (l_p___0)
						end
					end
				end
				if not l_return then
					(a_table + l_idx).item.string := l_p___0.item;
					(a_table + l_idx).item.strlen := l_commap.distance ((l_p___0.item))
					l_stringp := l_commap
					if (l_stringp.item).to_integer_32 = 44 then
						l_stringp := l_stringp + 1
					end
				end
			end
			if not l_return then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
			end
		end

	prt_header_height: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).printer_opts.item[4].present).to_boolean then
				Result := ((create {P_GLOBALS_STATIC}).printer_opts.item[4].number).to_integer_32
				l_return := True
			end
			if not l_return then
				Result := 2
			end
		end

	prt_get_unit (a_idx: INTEGER_32): INTEGER_32
		local
			l_u: INTEGER_32
			l_i___0: INTEGER_32
			l_break: BOOLEAN
		do
			l_u := -1
			if ((create {P_GLOBALS_STATIC}).printer_opts.item[a_idx].present).to_boolean then
				l_i___0 := 0
				from
				until
					not (not (l_break) and then (l_i___0 < 4))
				loop
					l_break := False
					if (strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).printer_opts.item[a_idx].string), units.item[l_i___0], (2).to_natural_32)) = 0 then
						l_u := l_i___0
						l_break := True
					end
					if not (l_break) then
						l_i___0 := l_i___0 + 1
					end
				end
				l_break := False
			end
			Result := l_u
		end

	prt_write_file_raw_len (a_buffer: CE_POINTER [NATURAL_8]; a_bytes___0: INTEGER_32)
		do
			if not prt_file_error.item.to_boolean then
				if (fwrite (create {CE_VOID_POINTER}.make_cast (a_buffer), {PLATFORM}.Natural_8_bytes.to_natural_32, a_bytes___0.to_natural_32, prt_ps_fd.item)) /= a_bytes___0.to_natural_32 then
					(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E455: Error writing to PostScript output file"))))).do_nothing
					prt_file_error.item := 1
				end
			end
		end

	prt_write_file (a_buffer: CE_POINTER [NATURAL_8])
		do
			prt_write_file_len (a_buffer, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_buffer))).to_integer_32)
		end

	prt_write_file_len (a_buffer: CE_POINTER [NATURAL_8]; a_bytes___0: INTEGER_32)
		do
			prt_write_file_raw_len (a_buffer, a_bytes___0)
		end

	prt_write_string (a_s: CE_POINTER [INTEGER_8])
		do
			(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (prt_line_buffer.item), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("%%s"), a_s]).do_nothing
			prt_write_file (prt_line_buffer.item)
		end

	prt_write_int (a_i___0: INTEGER_32)
		do
			sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (prt_line_buffer.item), ce_string ("%%d "), a_i___0]).do_nothing
			prt_write_file (prt_line_buffer.item)
		end

	prt_real_bits (a_real: REAL_64; a_precision: INTEGER_32; a_pinteger, a_pfraction: CE_POINTER [INTEGER_32])
		require
			not a_pinteger.is_void
			not a_pfraction.is_void
		local
			l_i___0: INTEGER_32
			l_integer: INTEGER_32
			l_fraction: REAL_32
		do
			l_integer := a_real.truncated_to_integer
			l_fraction := (a_real - l_integer.to_double).truncated_to_real
			if a_real < l_integer.to_double then
				l_fraction := -l_fraction
			end
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_precision)
			loop
				l_fraction := (l_fraction.to_double * 10.0).truncated_to_real
				l_i___0 := l_i___0 + 1
			end
			a_pinteger.item := l_integer
			a_pfraction.item := (l_fraction.to_double + 0.5).truncated_to_integer
		end

	prt_write_real (a_val___0: REAL_64; a_prec: INTEGER_32)
		local
			l_prec: INTEGER_32
			l_integer: CE_ARRAY [INTEGER_32]
			l_fraction: CE_ARRAY [INTEGER_32]
		do
			create {CE_INTEGER_32_ARRAY} l_integer.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_fraction.make (<<1>>)

			l_prec := a_prec
			prt_real_bits (a_val___0, l_prec, l_integer, l_fraction)
			sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (prt_line_buffer.item), ce_string ("%%d"), l_integer.item]).do_nothing
			prt_write_file (prt_line_buffer.item)
			if l_fraction.item /= 0 then
				from
				until
					l_fraction.item \\ 10 /= 0
				loop
					l_prec := l_prec - 1
					l_fraction.item := l_fraction.item // (10)
				end
				sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (prt_line_buffer.item), ce_string (".%%0*d"), l_prec, l_fraction.item]).do_nothing
				prt_write_file (prt_line_buffer.item)
			end
			sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (prt_line_buffer.item), ce_string (" ")]).do_nothing
			prt_write_file (prt_line_buffer.item)
		end

	prt_resource_name (a_filename: CE_POINTER [NATURAL_8]; a_cookie: CE_POINTER [ANY])
		local
			l_resource_filename: CE_POINTER [NATURAL_8]
		do
			l_resource_filename := create {CE_NATURAL_8_POINTER}.make_cast (a_cookie)
			if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_filename))) >= {NATURAL_32} 4_096 then
				l_resource_filename.item := (('%/0/').code).to_natural_8
			else
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_resource_filename), create {CE_INTEGER_8_POINTER}.make_cast (a_filename)).do_nothing
			end
		end

	prt_dsc_noarg (a_comment: CE_POINTER [INTEGER_8])
		do
			(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (prt_line_buffer.item), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("%%%%%%%%%%s%N"), a_comment]).do_nothing
			prt_write_file (prt_line_buffer.item)
		end

	prt_dsc_textline (a_comment, a_text: CE_POINTER [INTEGER_8])
		do
			(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (prt_line_buffer.item), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("%%%%%%%%%%s: %%s%N"), a_comment, a_text]).do_nothing
			prt_write_file (prt_line_buffer.item)
		end

	prt_dsc_ints (a_comment: CE_POINTER [INTEGER_8]; a_count___2: INTEGER_32; a_ints: CE_POINTER [INTEGER_32])
		local
			l_i___0: INTEGER_32
		do
			(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (prt_line_buffer.item), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("%%%%%%%%%%s:"), a_comment]).do_nothing
			prt_write_file (prt_line_buffer.item)
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_count___2)
			loop
				sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (prt_line_buffer.item), ce_string (" %%d"), a_ints[l_i___0]]).do_nothing
				prt_write_file (prt_line_buffer.item)
				l_i___0 := l_i___0 + 1
			end
			prt_write_string (ce_string ("%N"))
		end

	prt_dsc_resources (a_comment, a_type, a_string___0: CE_POINTER [INTEGER_8])
		do
			if not a_comment.is_void then
				(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (prt_line_buffer.item), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("%%%%%%%%%%s: %%s"), a_comment, a_type]).do_nothing
			else
				(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (prt_line_buffer.item), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("%%%%%%%%+ %%s"), a_type]).do_nothing
			end
			prt_write_file (prt_line_buffer.item);
			(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (prt_line_buffer.item), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string (" %%s%N"), a_string___0]).do_nothing
			prt_write_file (prt_line_buffer.item)
		end

	to_device_units (a_idx: INTEGER_32; a_physsize: REAL_64; a_def_number: INTEGER_32): REAL_32
		local
			l_ret: REAL_32
			l_u: INTEGER_32
			l_nr: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_u := prt_get_unit (a_idx)
					if l_u = -1 then
						l_u := 0
						l_nr := a_def_number
					else
						l_nr := ((create {P_GLOBALS_STATIC}).printer_opts.item[a_idx].number).to_integer_32
					end
					inspect l_u -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 1
					l_ret := (l_nr * 72).to_real
					l_pos := -1 + 5 -- switch 1; break
				when 2 then -- switch 1, case 2
					l_ret := (l_nr * 72).to_real / (25.4).truncated_to_real
					l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case 3
					l_ret := l_nr.to_real
					l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, default:
					l_ret := (a_physsize * l_nr.to_double).truncated_to_real / (100).to_real
					l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done:
					Result := l_ret
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	prt_page_margins (a_width, a_height: REAL_64; a_left, a_right, a_top, a_bottom: CE_POINTER [REAL_64])
		require
			not a_left.is_void
			not a_right.is_void
			not a_top.is_void
			not a_bottom.is_void
		do
			a_left.item := (to_device_units (2, a_width, 10)).to_double
			a_right.item := a_width - (to_device_units (3, a_width, 5)).to_double
			a_top.item := a_height - (to_device_units (0, a_height, 5)).to_double
			a_bottom.item := (to_device_units (1, a_height, 5)).to_double
		end

feature {ANY} -- routine addresses

	prt_resource_name_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent prt_resource_name)
		end

end
