class
	PD_SPECIAL_KEY

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	key_sym: NATURAL_32 assign set_key_sym

	code0: NATURAL_8 assign set_code0

	code1: NATURAL_8 assign set_code1

feature {ANY} -- field setters

	set_key_sym (a_key_sym: NATURAL_32)
		do
			key_sym := a_key_sym
			update_memory_field ("key_sym")
		end

	set_code0 (a_code0: NATURAL_8)
		do
			code0 := a_code0
			update_memory_field ("code0")
		end

	set_code1 (a_code1: NATURAL_8)
		do
			code1 := a_code1
			update_memory_field ("code1")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			key_sym := a_other.key_sym
			code0 := a_other.code0
			code1 := a_other.code1
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				key_sym = a_other.key_sym and
				code0 = a_other.code0 and
				code1 = a_other.code1
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("key_sym"),
					create {CE_STRUCTURE_FIELD}.make ("code0"),
					create {CE_STRUCTURE_FIELD}.make ("code1")
				>>)
			init_structure_info
		end

end
