class
	PD_WINOPT_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} wo_fdi.make
			create {CE_NATURAL_8_POINTER} wo_fdm.make
			create {CE_NATURAL_8_POINTER} wo_fde.make
			create {CE_NATURAL_8_POINTER} wo_fdt.make
			create {CE_NATURAL_8_POINTER} wo_fmr.make
			create {CE_NATURAL_8_POINTER} wo_cc.make
			create {CE_NATURAL_8_POINTER} wo_stl.make
			create {CE_INTEGER_32_ARRAY} wo_scriptID.make (<<28>>)
		end

feature {ANY} -- fields

	wo_diff: INTEGER_32 assign set_wo_diff

	wo_fdc: INTEGER_32 assign set_wo_fdc

	wo_fen: INTEGER_32 assign set_wo_fen

	wo_fdi: CE_POINTER [NATURAL_8] assign set_wo_fdi

	wo_fdl: INTEGER_32 assign set_wo_fdl

	wo_fdm: CE_POINTER [NATURAL_8] assign set_wo_fdm

	wo_fml: INTEGER_32 assign set_wo_fml

	wo_fdn: INTEGER_32 assign set_wo_fdn

	wo_fde: CE_POINTER [NATURAL_8] assign set_wo_fde

	wo_fdt: CE_POINTER [NATURAL_8] assign set_wo_fdt

	wo_fmr: CE_POINTER [NATURAL_8] assign set_wo_fmr

	wo_lbr: INTEGER_32 assign set_wo_lbr

	wo_list: INTEGER_32 assign set_wo_list

	wo_nu: INTEGER_32 assign set_wo_nu

	wo_rnu: INTEGER_32 assign set_wo_rnu

	wo_nuw: INTEGER_32 assign set_wo_nuw

	wo_wfh: INTEGER_32 assign set_wo_wfh

	wo_wfw: INTEGER_32 assign set_wo_wfw

	wo_pvw: INTEGER_32 assign set_wo_pvw

	wo_scr: INTEGER_32 assign set_wo_scr

	wo_spell: INTEGER_32 assign set_wo_spell

	wo_cuc: INTEGER_32 assign set_wo_cuc

	wo_cul: INTEGER_32 assign set_wo_cul

	wo_cc: CE_POINTER [NATURAL_8] assign set_wo_cc

	wo_stl: CE_POINTER [NATURAL_8] assign set_wo_stl

	wo_scb: INTEGER_32 assign set_wo_scb

	wo_wrap: INTEGER_32 assign set_wo_wrap

	wo_crb: INTEGER_32 assign set_wo_crb

	wo_scriptID: CE_ARRAY [INTEGER_32]

feature {ANY} -- field setters

	set_wo_diff (a_wo_diff: INTEGER_32)
		do
			wo_diff := a_wo_diff
			update_memory_field ("wo_diff")
		end

	set_wo_fdc (a_wo_fdc: INTEGER_32)
		do
			wo_fdc := a_wo_fdc
			update_memory_field ("wo_fdc")
		end

	set_wo_fen (a_wo_fen: INTEGER_32)
		do
			wo_fen := a_wo_fen
			update_memory_field ("wo_fen")
		end

	set_wo_fdi (a_wo_fdi: CE_POINTER [NATURAL_8])
		do
			wo_fdi := a_wo_fdi
			update_memory_field ("wo_fdi")
		end

	set_wo_fdl (a_wo_fdl: INTEGER_32)
		do
			wo_fdl := a_wo_fdl
			update_memory_field ("wo_fdl")
		end

	set_wo_fdm (a_wo_fdm: CE_POINTER [NATURAL_8])
		do
			wo_fdm := a_wo_fdm
			update_memory_field ("wo_fdm")
		end

	set_wo_fml (a_wo_fml: INTEGER_32)
		do
			wo_fml := a_wo_fml
			update_memory_field ("wo_fml")
		end

	set_wo_fdn (a_wo_fdn: INTEGER_32)
		do
			wo_fdn := a_wo_fdn
			update_memory_field ("wo_fdn")
		end

	set_wo_fde (a_wo_fde: CE_POINTER [NATURAL_8])
		do
			wo_fde := a_wo_fde
			update_memory_field ("wo_fde")
		end

	set_wo_fdt (a_wo_fdt: CE_POINTER [NATURAL_8])
		do
			wo_fdt := a_wo_fdt
			update_memory_field ("wo_fdt")
		end

	set_wo_fmr (a_wo_fmr: CE_POINTER [NATURAL_8])
		do
			wo_fmr := a_wo_fmr
			update_memory_field ("wo_fmr")
		end

	set_wo_lbr (a_wo_lbr: INTEGER_32)
		do
			wo_lbr := a_wo_lbr
			update_memory_field ("wo_lbr")
		end

	set_wo_list (a_wo_list: INTEGER_32)
		do
			wo_list := a_wo_list
			update_memory_field ("wo_list")
		end

	set_wo_nu (a_wo_nu: INTEGER_32)
		do
			wo_nu := a_wo_nu
			update_memory_field ("wo_nu")
		end

	set_wo_rnu (a_wo_rnu: INTEGER_32)
		do
			wo_rnu := a_wo_rnu
			update_memory_field ("wo_rnu")
		end

	set_wo_nuw (a_wo_nuw: INTEGER_32)
		do
			wo_nuw := a_wo_nuw
			update_memory_field ("wo_nuw")
		end

	set_wo_wfh (a_wo_wfh: INTEGER_32)
		do
			wo_wfh := a_wo_wfh
			update_memory_field ("wo_wfh")
		end

	set_wo_wfw (a_wo_wfw: INTEGER_32)
		do
			wo_wfw := a_wo_wfw
			update_memory_field ("wo_wfw")
		end

	set_wo_pvw (a_wo_pvw: INTEGER_32)
		do
			wo_pvw := a_wo_pvw
			update_memory_field ("wo_pvw")
		end

	set_wo_scr (a_wo_scr: INTEGER_32)
		do
			wo_scr := a_wo_scr
			update_memory_field ("wo_scr")
		end

	set_wo_spell (a_wo_spell: INTEGER_32)
		do
			wo_spell := a_wo_spell
			update_memory_field ("wo_spell")
		end

	set_wo_cuc (a_wo_cuc: INTEGER_32)
		do
			wo_cuc := a_wo_cuc
			update_memory_field ("wo_cuc")
		end

	set_wo_cul (a_wo_cul: INTEGER_32)
		do
			wo_cul := a_wo_cul
			update_memory_field ("wo_cul")
		end

	set_wo_cc (a_wo_cc: CE_POINTER [NATURAL_8])
		do
			wo_cc := a_wo_cc
			update_memory_field ("wo_cc")
		end

	set_wo_stl (a_wo_stl: CE_POINTER [NATURAL_8])
		do
			wo_stl := a_wo_stl
			update_memory_field ("wo_stl")
		end

	set_wo_scb (a_wo_scb: INTEGER_32)
		do
			wo_scb := a_wo_scb
			update_memory_field ("wo_scb")
		end

	set_wo_wrap (a_wo_wrap: INTEGER_32)
		do
			wo_wrap := a_wo_wrap
			update_memory_field ("wo_wrap")
		end

	set_wo_crb (a_wo_crb: INTEGER_32)
		do
			wo_crb := a_wo_crb
			update_memory_field ("wo_crb")
		end

feature {ANY} -- public routines

	copy_winopt (a_to: CE_POINTER [PD_WINOPT_T])
		require
			not a_to.is_void
		do
			a_to.item.wo_list := wo_list
			update_class_fields -- Current might have been changed; synchronize
			a_to.item.wo_nu := wo_nu
			update_class_fields -- Current might have been changed; synchronize
			a_to.item.wo_rnu := wo_rnu
			update_class_fields -- Current might have been changed; synchronize
			a_to.item.wo_nuw := wo_nuw
			update_class_fields -- Current might have been changed; synchronize
			a_to.item.wo_stl := (create {P_MISC2_STATIC}).vim_strsave (wo_stl)
			update_class_fields -- Current might have been changed; synchronize
			a_to.item.wo_wrap := wo_wrap
			update_class_fields -- Current might have been changed; synchronize
			a_to.item.wo_lbr := wo_lbr
			update_class_fields -- Current might have been changed; synchronize
			a_to.item.wo_scb := wo_scb
			update_class_fields -- Current might have been changed; synchronize
			a_to.item.wo_spell := wo_spell
			update_class_fields -- Current might have been changed; synchronize
			a_to.item.wo_cuc := wo_cuc
			update_class_fields -- Current might have been changed; synchronize
			a_to.item.wo_cul := wo_cul
			update_class_fields -- Current might have been changed; synchronize
			a_to.item.wo_cc := (create {P_MISC2_STATIC}).vim_strsave (wo_cc)
			update_class_fields -- Current might have been changed; synchronize
			a_to.item.wo_diff := wo_diff
			update_class_fields -- Current might have been changed; synchronize
			a_to.item.wo_fdc := wo_fdc
			update_class_fields -- Current might have been changed; synchronize
			a_to.item.wo_fen := wo_fen
			update_class_fields -- Current might have been changed; synchronize
			a_to.item.wo_fdi := (create {P_MISC2_STATIC}).vim_strsave (wo_fdi)
			update_class_fields -- Current might have been changed; synchronize
			a_to.item.wo_fml := wo_fml
			update_class_fields -- Current might have been changed; synchronize
			a_to.item.wo_fdl := wo_fdl
			update_class_fields -- Current might have been changed; synchronize
			a_to.item.wo_fdm := (create {P_MISC2_STATIC}).vim_strsave (wo_fdm)
			update_class_fields -- Current might have been changed; synchronize
			a_to.item.wo_fdn := wo_fdn
			update_class_fields -- Current might have been changed; synchronize
			a_to.item.wo_fde := (create {P_MISC2_STATIC}).vim_strsave (wo_fde)
			update_class_fields -- Current might have been changed; synchronize
			a_to.item.wo_fdt := (create {P_MISC2_STATIC}).vim_strsave (wo_fdt)
			update_class_fields -- Current might have been changed; synchronize
			a_to.item.wo_fmr := (create {P_MISC2_STATIC}).vim_strsave (wo_fmr)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_OPTION_STATIC}).check_winopt (a_to)
			update_class_fields -- Current might have been changed; synchronize
		end

feature {ANY}

	copy (a_other: like Current)
		do
			wo_diff := a_other.wo_diff
			wo_fdc := a_other.wo_fdc
			wo_fen := a_other.wo_fen
			wo_fdi := a_other.wo_fdi
			wo_fdl := a_other.wo_fdl
			wo_fdm := a_other.wo_fdm
			wo_fml := a_other.wo_fml
			wo_fdn := a_other.wo_fdn
			wo_fde := a_other.wo_fde
			wo_fdt := a_other.wo_fdt
			wo_fmr := a_other.wo_fmr
			wo_lbr := a_other.wo_lbr
			wo_list := a_other.wo_list
			wo_nu := a_other.wo_nu
			wo_rnu := a_other.wo_rnu
			wo_nuw := a_other.wo_nuw
			wo_wfh := a_other.wo_wfh
			wo_wfw := a_other.wo_wfw
			wo_pvw := a_other.wo_pvw
			wo_scr := a_other.wo_scr
			wo_spell := a_other.wo_spell
			wo_cuc := a_other.wo_cuc
			wo_cul := a_other.wo_cul
			wo_cc := a_other.wo_cc
			wo_stl := a_other.wo_stl
			wo_scb := a_other.wo_scb
			wo_wrap := a_other.wo_wrap
			wo_crb := a_other.wo_crb
			wo_scriptID := a_other.wo_scriptID.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				wo_diff = a_other.wo_diff and
				wo_fdc = a_other.wo_fdc and
				wo_fen = a_other.wo_fen and
				wo_fdi.is_equal (a_other.wo_fdi) and
				wo_fdl = a_other.wo_fdl and
				wo_fdm.is_equal (a_other.wo_fdm) and
				wo_fml = a_other.wo_fml and
				wo_fdn = a_other.wo_fdn and
				wo_fde.is_equal (a_other.wo_fde) and
				wo_fdt.is_equal (a_other.wo_fdt) and
				wo_fmr.is_equal (a_other.wo_fmr) and
				wo_lbr = a_other.wo_lbr and
				wo_list = a_other.wo_list and
				wo_nu = a_other.wo_nu and
				wo_rnu = a_other.wo_rnu and
				wo_nuw = a_other.wo_nuw and
				wo_wfh = a_other.wo_wfh and
				wo_wfw = a_other.wo_wfw and
				wo_pvw = a_other.wo_pvw and
				wo_scr = a_other.wo_scr and
				wo_spell = a_other.wo_spell and
				wo_cuc = a_other.wo_cuc and
				wo_cul = a_other.wo_cul and
				wo_cc.is_equal (a_other.wo_cc) and
				wo_stl.is_equal (a_other.wo_stl) and
				wo_scb = a_other.wo_scb and
				wo_wrap = a_other.wo_wrap and
				wo_crb = a_other.wo_crb and
				wo_scriptID.is_equal (a_other.wo_scriptID)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("wo_diff"),
					create {CE_STRUCTURE_FIELD}.make ("wo_fdc"),
					create {CE_STRUCTURE_FIELD}.make ("wo_fen"),
					create {CE_STRUCTURE_FIELD}.make ("wo_fdi"),
					create {CE_STRUCTURE_FIELD}.make ("wo_fdl"),
					create {CE_STRUCTURE_FIELD}.make ("wo_fdm"),
					create {CE_STRUCTURE_FIELD}.make ("wo_fml"),
					create {CE_STRUCTURE_FIELD}.make ("wo_fdn"),
					create {CE_STRUCTURE_FIELD}.make ("wo_fde"),
					create {CE_STRUCTURE_FIELD}.make ("wo_fdt"),
					create {CE_STRUCTURE_FIELD}.make ("wo_fmr"),
					create {CE_STRUCTURE_FIELD}.make ("wo_lbr"),
					create {CE_STRUCTURE_FIELD}.make ("wo_list"),
					create {CE_STRUCTURE_FIELD}.make ("wo_nu"),
					create {CE_STRUCTURE_FIELD}.make ("wo_rnu"),
					create {CE_STRUCTURE_FIELD}.make ("wo_nuw"),
					create {CE_STRUCTURE_FIELD}.make ("wo_wfh"),
					create {CE_STRUCTURE_FIELD}.make ("wo_wfw"),
					create {CE_STRUCTURE_FIELD}.make ("wo_pvw"),
					create {CE_STRUCTURE_FIELD}.make ("wo_scr"),
					create {CE_STRUCTURE_FIELD}.make ("wo_spell"),
					create {CE_STRUCTURE_FIELD}.make ("wo_cuc"),
					create {CE_STRUCTURE_FIELD}.make ("wo_cul"),
					create {CE_STRUCTURE_FIELD}.make ("wo_cc"),
					create {CE_STRUCTURE_FIELD}.make ("wo_stl"),
					create {CE_STRUCTURE_FIELD}.make ("wo_scb"),
					create {CE_STRUCTURE_FIELD}.make ("wo_wrap"),
					create {CE_STRUCTURE_FIELD}.make ("wo_crb"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("wo_scriptID", <<28>>)
				>>)
			init_structure_info
		end

end
