class
	S_GTK_GTK_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gtk_menu_shell_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_menu_shell_get_type();"
		end

	gtk_menu_shell_select_first (a_menu_shell: CE_POINTER [SD_GTKMENUSHELL]; a_search_sensitive: INTEGER_32)
		do
			c_gtk_menu_shell_select_first (a_menu_shell.c_pointer, a_search_sensitive)
		end

	c_gtk_menu_shell_select_first (a_menu_shell: POINTER; a_search_sensitive: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_menu_shell_select_first($a_menu_shell, $a_search_sensitive);"
		end

	gtk_disable_setlocale
		external
			"C inline use <vim.h>"
		alias
			"gtk_disable_setlocale();"
		end

	gtk_im_context_set_client_window (a_context: CE_POINTER [SD_GTKIMCONTEXT]; a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_gtk_im_context_set_client_window (a_context.c_pointer, a_window.c_pointer)
		end

	c_gtk_im_context_set_client_window (a_context: POINTER; a_window: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_im_context_set_client_window($a_context, $a_window);"
		end

	gtk_im_context_get_preedit_string (a_context: CE_POINTER [SD_GTKIMCONTEXT]; a_str: CE_POINTER [CE_POINTER [INTEGER_8]]; a_attrs: CE_POINTER [CE_POINTER [ANY]]; a_cursor_pos: CE_POINTER [INTEGER_32])
		do
			c_gtk_im_context_get_preedit_string (a_context.c_pointer, a_str.c_pointer, a_attrs.c_pointer, a_cursor_pos.c_pointer)
		end

	c_gtk_im_context_get_preedit_string (a_context: POINTER; a_str: POINTER; a_attrs: POINTER; a_cursor_pos: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_im_context_get_preedit_string($a_context, $a_str, $a_attrs, $a_cursor_pos);"
		end

	gtk_im_context_filter_keypress (a_context: CE_POINTER [SD_GTKIMCONTEXT]; a_event: CE_POINTER [SD_GDKEVENTKEY]): INTEGER_32
		do
			Result := c_gtk_im_context_filter_keypress (a_context.c_pointer, a_event.c_pointer)
		end

	c_gtk_im_context_filter_keypress (a_context: POINTER; a_event: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_im_context_filter_keypress($a_context, $a_event);"
		end

	gtk_im_context_focus_in (a_context: CE_POINTER [SD_GTKIMCONTEXT])
		do
			c_gtk_im_context_focus_in (a_context.c_pointer)
		end

	c_gtk_im_context_focus_in (a_context: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_im_context_focus_in($a_context);"
		end

	gtk_im_context_focus_out (a_context: CE_POINTER [SD_GTKIMCONTEXT])
		do
			c_gtk_im_context_focus_out (a_context.c_pointer)
		end

	c_gtk_im_context_focus_out (a_context: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_im_context_focus_out($a_context);"
		end

	gtk_im_context_reset (a_context: CE_POINTER [SD_GTKIMCONTEXT])
		do
			c_gtk_im_context_reset (a_context.c_pointer)
		end

	c_gtk_im_context_reset (a_context: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_im_context_reset($a_context);"
		end

	gtk_im_context_set_cursor_location (a_context: CE_POINTER [SD_GTKIMCONTEXT]; a_area: CE_POINTER [SD_GDKRECTANGLE])
		do
			c_gtk_im_context_set_cursor_location (a_context.c_pointer, a_area.c_pointer)
		end

	c_gtk_im_context_set_cursor_location (a_context: POINTER; a_area: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_im_context_set_cursor_location($a_context, $a_area);"
		end

	gtk_im_context_set_use_preedit (a_context: CE_POINTER [SD_GTKIMCONTEXT]; a_use_preedit: INTEGER_32)
		do
			c_gtk_im_context_set_use_preedit (a_context.c_pointer, a_use_preedit)
		end

	c_gtk_im_context_set_use_preedit (a_context: POINTER; a_use_preedit: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_im_context_set_use_preedit($a_context, $a_use_preedit);"
		end

	gtk_im_multicontext_new: CE_POINTER [SD_GTKIMCONTEXT]
		do
			create {CE_CLASS_POINTER [SD_GTKIMCONTEXT]} Result.make_shared (c_gtk_im_multicontext_new)
		end

	c_gtk_im_multicontext_new: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_im_multicontext_new();"
		end

	gtk_main_level: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_main_level();"
		end

	gtk_main_quit
		external
			"C inline use <vim.h>"
		alias
			"gtk_main_quit();"
		end

	gtk_accelerator_get_default_mod_mask: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_accelerator_get_default_mod_mask();"
		end

	gtk_object_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_object_get_type();"
		end

	gtk_adjustment_changed (a_adjustment: CE_POINTER [SD_GTKADJUSTMENT])
		do
			c_gtk_adjustment_changed (a_adjustment.c_pointer)
		end

	c_gtk_adjustment_changed (a_adjustment: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_adjustment_changed($a_adjustment);"
		end

	gtk_widget_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_widget_get_type();"
		end

	gtk_widget_destroy (a_widget: CE_POINTER [SD_GTKWIDGET])
		do
			c_gtk_widget_destroy (a_widget.c_pointer)
		end

	c_gtk_widget_destroy (a_widget: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_widget_destroy($a_widget);"
		end

	gtk_widget_show (a_widget: CE_POINTER [SD_GTKWIDGET])
		do
			c_gtk_widget_show (a_widget.c_pointer)
		end

	c_gtk_widget_show (a_widget: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_widget_show($a_widget);"
		end

	gtk_widget_hide (a_widget: CE_POINTER [SD_GTKWIDGET])
		do
			c_gtk_widget_hide (a_widget.c_pointer)
		end

	c_gtk_widget_hide (a_widget: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_widget_hide($a_widget);"
		end

	gtk_widget_show_all (a_widget: CE_POINTER [SD_GTKWIDGET])
		do
			c_gtk_widget_show_all (a_widget.c_pointer)
		end

	c_gtk_widget_show_all (a_widget: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_widget_show_all($a_widget);"
		end

	gtk_widget_grab_focus (a_widget: CE_POINTER [SD_GTKWIDGET])
		do
			c_gtk_widget_grab_focus (a_widget.c_pointer)
		end

	c_gtk_widget_grab_focus (a_widget: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_widget_grab_focus($a_widget);"
		end

	gtk_widget_grab_default (a_widget: CE_POINTER [SD_GTKWIDGET])
		do
			c_gtk_widget_grab_default (a_widget.c_pointer)
		end

	c_gtk_widget_grab_default (a_widget: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_widget_grab_default($a_widget);"
		end

	gtk_widget_set_sensitive (a_widget: CE_POINTER [SD_GTKWIDGET]; a_sensitive: INTEGER_32)
		do
			c_gtk_widget_set_sensitive (a_widget.c_pointer, a_sensitive)
		end

	c_gtk_widget_set_sensitive (a_widget: POINTER; a_sensitive: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_widget_set_sensitive($a_widget, $a_sensitive);"
		end

	gtk_widget_hide_on_delete (a_widget: CE_POINTER [SD_GTKWIDGET]): INTEGER_32
		do
			Result := c_gtk_widget_hide_on_delete (a_widget.c_pointer)
		end

	c_gtk_widget_hide_on_delete (a_widget: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_widget_hide_on_delete($a_widget);"
		end

	gtk_container_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_container_get_type();"
		end

	gtk_container_set_border_width (a_container: CE_POINTER [SD_GTKCONTAINER]; a_border_width: NATURAL_32)
		do
			c_gtk_container_set_border_width (a_container.c_pointer, a_border_width)
		end

	c_gtk_container_set_border_width (a_container: POINTER; a_border_width: NATURAL_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_container_set_border_width($a_container, $a_border_width);"
		end

	gtk_container_add (a_container: CE_POINTER [SD_GTKCONTAINER]; a_widget: CE_POINTER [SD_GTKWIDGET])
		do
			c_gtk_container_add (a_container.c_pointer, a_widget.c_pointer)
		end

	c_gtk_container_add (a_container: POINTER; a_widget: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_container_add($a_container, $a_widget);"
		end

	gtk_window_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_window_get_type();"
		end

	gtk_window_set_title (a_window: CE_POINTER [SD_GTKWINDOW]; a_title: CE_POINTER [INTEGER_8])
		do
			c_gtk_window_set_title (a_window.c_pointer, a_title.c_pointer)
		end

	c_gtk_window_set_title (a_window: POINTER; a_title: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_window_set_title($a_window, $a_title);"
		end

	gtk_window_set_transient_for (a_window, a_parent: CE_POINTER [SD_GTKWINDOW])
		do
			c_gtk_window_set_transient_for (a_window.c_pointer, a_parent.c_pointer)
		end

	c_gtk_window_set_transient_for (a_window: POINTER; a_parent: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_window_set_transient_for($a_window, $a_parent);"
		end

	gtk_window_set_destroy_with_parent (a_window: CE_POINTER [SD_GTKWINDOW]; a_setting: INTEGER_32)
		do
			c_gtk_window_set_destroy_with_parent (a_window.c_pointer, a_setting)
		end

	c_gtk_window_set_destroy_with_parent (a_window: POINTER; a_setting: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_window_set_destroy_with_parent($a_window, $a_setting);"
		end

	gtk_window_mnemonic_activate (a_window: CE_POINTER [SD_GTKWINDOW]; a_keyval, a_modifier: NATURAL_32): INTEGER_32
		do
			Result := c_gtk_window_mnemonic_activate (a_window.c_pointer, a_keyval, a_modifier)
		end

	c_gtk_window_mnemonic_activate (a_window: POINTER; a_keyval: NATURAL_32; a_modifier: NATURAL_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_window_mnemonic_activate($a_window, $a_keyval, $a_modifier);"
		end

	gtk_window_get_mnemonic_modifier (a_window: CE_POINTER [SD_GTKWINDOW]): NATURAL_32
		do
			Result := c_gtk_window_get_mnemonic_modifier (a_window.c_pointer)
		end

	c_gtk_window_get_mnemonic_modifier (a_window: POINTER): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_window_get_mnemonic_modifier($a_window);"
		end

	gtk_window_present (a_window: CE_POINTER [SD_GTKWINDOW])
		do
			c_gtk_window_present (a_window.c_pointer)
		end

	c_gtk_window_present (a_window: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_window_present($a_window);"
		end

	gtk_dialog_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_dialog_get_type();"
		end

	gtk_dialog_new: CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_dialog_new)
		end

	c_gtk_dialog_new: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_dialog_new();"
		end

	gtk_dialog_add_button (a_dialog: CE_POINTER [SD_GTKDIALOG]; a_button_text: CE_POINTER [INTEGER_8]; a_response_id: INTEGER_32): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_dialog_add_button (a_dialog.c_pointer, a_button_text.c_pointer, a_response_id))
		end

	c_gtk_dialog_add_button (a_dialog: POINTER; a_button_text: POINTER; a_response_id: INTEGER_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_dialog_add_button($a_dialog, $a_button_text, $a_response_id);"
		end

	gtk_dialog_set_default_response (a_dialog: CE_POINTER [SD_GTKDIALOG]; a_response_id: INTEGER_32)
		do
			c_gtk_dialog_set_default_response (a_dialog.c_pointer, a_response_id)
		end

	c_gtk_dialog_set_default_response (a_dialog: POINTER; a_response_id: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_dialog_set_default_response($a_dialog, $a_response_id);"
		end

	gtk_dialog_set_has_separator (a_dialog: CE_POINTER [SD_GTKDIALOG]; a_setting: INTEGER_32)
		do
			c_gtk_dialog_set_has_separator (a_dialog.c_pointer, a_setting)
		end

	c_gtk_dialog_set_has_separator (a_dialog: POINTER; a_setting: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_dialog_set_has_separator($a_dialog, $a_setting);"
		end

	gtk_dialog_response (a_dialog: CE_POINTER [SD_GTKDIALOG]; a_response_id: INTEGER_32)
		do
			c_gtk_dialog_response (a_dialog.c_pointer, a_response_id)
		end

	c_gtk_dialog_response (a_dialog: POINTER; a_response_id: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_dialog_response($a_dialog, $a_response_id);"
		end

	gtk_dialog_run (a_dialog: CE_POINTER [SD_GTKDIALOG]): INTEGER_32
		do
			Result := c_gtk_dialog_run (a_dialog.c_pointer)
		end

	c_gtk_dialog_run (a_dialog: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_dialog_run($a_dialog);"
		end

	gtk_misc_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_misc_get_type();"
		end

	gtk_misc_set_alignment (a_misc: CE_POINTER [SD_GTKMISC]; a_xalign, a_yalign: REAL_32)
		do
			c_gtk_misc_set_alignment (a_misc.c_pointer, a_xalign, a_yalign)
		end

	c_gtk_misc_set_alignment (a_misc: POINTER; a_xalign: REAL_32; a_yalign: REAL_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_misc_set_alignment($a_misc, $a_xalign, $a_yalign);"
		end

	gtk_menu_shell_append (a_menu_shell: CE_POINTER [SD_GTKMENUSHELL]; a_child: CE_POINTER [SD_GTKWIDGET])
		do
			c_gtk_menu_shell_append (a_menu_shell.c_pointer, a_child.c_pointer)
		end

	c_gtk_menu_shell_append (a_menu_shell: POINTER; a_child: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_menu_shell_append($a_menu_shell, $a_child);"
		end

	gtk_menu_shell_prepend (a_menu_shell: CE_POINTER [SD_GTKMENUSHELL]; a_child: CE_POINTER [SD_GTKWIDGET])
		do
			c_gtk_menu_shell_prepend (a_menu_shell.c_pointer, a_child.c_pointer)
		end

	c_gtk_menu_shell_prepend (a_menu_shell: POINTER; a_child: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_menu_shell_prepend($a_menu_shell, $a_child);"
		end

	gtk_menu_shell_insert (a_menu_shell: CE_POINTER [SD_GTKMENUSHELL]; a_child: CE_POINTER [SD_GTKWIDGET]; a_position: INTEGER_32)
		do
			c_gtk_menu_shell_insert (a_menu_shell.c_pointer, a_child.c_pointer, a_position)
		end

	c_gtk_menu_shell_insert (a_menu_shell: POINTER; a_child: POINTER; a_position: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_menu_shell_insert($a_menu_shell, $a_child, $a_position);"
		end

	gtk_menu_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_menu_get_type();"
		end

	gtk_menu_new: CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_menu_new)
		end

	c_gtk_menu_new: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_menu_new();"
		end

	gtk_menu_popup (a_menu: CE_POINTER [SD_GTKMENU]; a_parent_menu_shell, a_parent_menu_item: CE_POINTER [SD_GTKWIDGET]; a_func: CE_ROUTINE; a_data: CE_POINTER [ANY]; a_button, a_activate_time: NATURAL_32)
		do
			c_gtk_menu_popup (a_menu.c_pointer, a_parent_menu_shell.c_pointer, a_parent_menu_item.c_pointer, a_func.c_pointer, a_data.c_pointer, a_button, a_activate_time)
		end

	c_gtk_menu_popup (a_menu: POINTER; a_parent_menu_shell: POINTER; a_parent_menu_item: POINTER; a_func: POINTER; a_data: POINTER; a_button: NATURAL_32; a_activate_time: NATURAL_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_menu_popup($a_menu, $a_parent_menu_shell, $a_parent_menu_item, $a_func, $a_data, $a_button, $a_activate_time);"
		end

	gtk_menu_set_accel_group (a_menu: CE_POINTER [SD_GTKMENU]; a_accel_group: CE_POINTER [SD_GTKACCELGROUP])
		do
			c_gtk_menu_set_accel_group (a_menu.c_pointer, a_accel_group.c_pointer)
		end

	c_gtk_menu_set_accel_group (a_menu: POINTER; a_accel_group: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_menu_set_accel_group($a_menu, $a_accel_group);"
		end

	gtk_label_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_label_get_type();"
		end

	gtk_label_new (a_str: CE_POINTER [INTEGER_8]): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_label_new (a_str.c_pointer))
		end

	c_gtk_label_new (a_str: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_label_new($a_str);"
		end

	gtk_label_new_with_mnemonic (a_str: CE_POINTER [INTEGER_8]): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_label_new_with_mnemonic (a_str.c_pointer))
		end

	c_gtk_label_new_with_mnemonic (a_str: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_label_new_with_mnemonic($a_str);"
		end

	gtk_label_set_text_with_mnemonic (a_label: CE_POINTER [SD_GTKLABEL]; a_str: CE_POINTER [INTEGER_8])
		do
			c_gtk_label_set_text_with_mnemonic (a_label.c_pointer, a_str.c_pointer)
		end

	c_gtk_label_set_text_with_mnemonic (a_label: POINTER; a_str: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_label_set_text_with_mnemonic($a_label, $a_str);"
		end

	gtk_alignment_new (a_xalign, a_yalign, a_xscale, a_yscale: REAL_32): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_alignment_new (a_xalign, a_yalign, a_xscale, a_yscale))
		end

	c_gtk_alignment_new (a_xalign: REAL_32; a_yalign: REAL_32; a_xscale: REAL_32; a_yscale: REAL_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_alignment_new($a_xalign, $a_yalign, $a_xscale, $a_yscale);"
		end

	gtk_frame_new (a_label: CE_POINTER [INTEGER_8]): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_frame_new (a_label.c_pointer))
		end

	c_gtk_frame_new (a_label: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_frame_new($a_label);"
		end

	gtk_box_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_box_get_type();"
		end

	gtk_box_pack_start (a_box: CE_POINTER [SD_GTKBOX]; a_child: CE_POINTER [SD_GTKWIDGET]; a_expand, a_fill: INTEGER_32; a_padding: NATURAL_32)
		do
			c_gtk_box_pack_start (a_box.c_pointer, a_child.c_pointer, a_expand, a_fill, a_padding)
		end

	c_gtk_box_pack_start (a_box: POINTER; a_child: POINTER; a_expand: INTEGER_32; a_fill: INTEGER_32; a_padding: NATURAL_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_box_pack_start($a_box, $a_child, $a_expand, $a_fill, $a_padding);"
		end

	gtk_box_pack_end (a_box: CE_POINTER [SD_GTKBOX]; a_child: CE_POINTER [SD_GTKWIDGET]; a_expand, a_fill: INTEGER_32; a_padding: NATURAL_32)
		do
			c_gtk_box_pack_end (a_box.c_pointer, a_child.c_pointer, a_expand, a_fill, a_padding)
		end

	c_gtk_box_pack_end (a_box: POINTER; a_child: POINTER; a_expand: INTEGER_32; a_fill: INTEGER_32; a_padding: NATURAL_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_box_pack_end($a_box, $a_child, $a_expand, $a_fill, $a_padding);"
		end

	gtk_image_new_from_stock (a_stock_id: CE_POINTER [INTEGER_8]; a_size: NATURAL_32): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_image_new_from_stock (a_stock_id.c_pointer, a_size))
		end

	c_gtk_image_new_from_stock (a_stock_id: POINTER; a_size: NATURAL_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_image_new_from_stock($a_stock_id, $a_size);"
		end

	gtk_image_new_from_icon_set (a_icon_set: CE_POINTER [ANY]; a_size: NATURAL_32): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_image_new_from_icon_set (a_icon_set.c_pointer, a_size))
		end

	c_gtk_image_new_from_icon_set (a_icon_set: POINTER; a_size: NATURAL_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_image_new_from_icon_set($a_icon_set, $a_size);"
		end

	gtk_button_new: CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_button_new)
		end

	c_gtk_button_new: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_button_new();"
		end

	gtk_button_new_from_stock (a_stock_id: CE_POINTER [INTEGER_8]): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_button_new_from_stock (a_stock_id.c_pointer))
		end

	c_gtk_button_new_from_stock (a_stock_id: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_button_new_from_stock($a_stock_id);"
		end

	gtk_signal_connect_full (a_object: CE_POINTER [SD_GTKOBJECT]; a_name: CE_POINTER [INTEGER_8]; a_func, a_unsupported: CE_ROUTINE; a_data: CE_POINTER [ANY]; a_destroy_func: CE_ROUTINE; a_object_signal, a_after: INTEGER_32): NATURAL_32
		do
			Result := c_gtk_signal_connect_full (a_object.c_pointer, a_name.c_pointer, a_func.c_pointer, a_unsupported.c_pointer, a_data.c_pointer, a_destroy_func.c_pointer, a_object_signal, a_after)
		end

	c_gtk_signal_connect_full (a_object: POINTER; a_name: POINTER; a_func: POINTER; a_unsupported: POINTER; a_data: POINTER; a_destroy_func: POINTER; a_object_signal: INTEGER_32; a_after: INTEGER_32): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_signal_connect_full($a_object, $a_name, $a_func, $a_unsupported, $a_data, $a_destroy_func, $a_object_signal, $a_after);"
		end

	gtk_toggle_button_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_toggle_button_get_type();"
		end

	gtk_toggle_button_set_active (a_toggle_button: CE_POINTER [SD_GTKTOGGLEBUTTON]; a_is_active: INTEGER_32)
		do
			c_gtk_toggle_button_set_active (a_toggle_button.c_pointer, a_is_active)
		end

	c_gtk_toggle_button_set_active (a_toggle_button: POINTER; a_is_active: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_toggle_button_set_active($a_toggle_button, $a_is_active);"
		end

	gtk_check_button_new_with_label (a_label: CE_POINTER [INTEGER_8]): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_check_button_new_with_label (a_label.c_pointer))
		end

	c_gtk_check_button_new_with_label (a_label: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_check_button_new_with_label($a_label);"
		end

	gtk_menu_item_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_menu_item_get_type();"
		end

	gtk_menu_item_new: CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_menu_item_new)
		end

	c_gtk_menu_item_new: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_menu_item_new();"
		end

	gtk_menu_item_new_with_mnemonic (a_label: CE_POINTER [INTEGER_8]): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_menu_item_new_with_mnemonic (a_label.c_pointer))
		end

	c_gtk_menu_item_new_with_mnemonic (a_label: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_menu_item_new_with_mnemonic($a_label);"
		end

	gtk_menu_item_set_submenu (a_menu_item: CE_POINTER [SD_GTKMENUITEM]; a_submenu: CE_POINTER [SD_GTKWIDGET])
		do
			c_gtk_menu_item_set_submenu (a_menu_item.c_pointer, a_submenu.c_pointer)
		end

	c_gtk_menu_item_set_submenu (a_menu_item: POINTER; a_submenu: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_menu_item_set_submenu($a_menu_item, $a_submenu);"
		end

	gtk_vbox_new (a_homogeneous, a_spacing: INTEGER_32): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_vbox_new (a_homogeneous, a_spacing))
		end

	c_gtk_vbox_new (a_homogeneous: INTEGER_32; a_spacing: INTEGER_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_vbox_new($a_homogeneous, $a_spacing);"
		end

	gtk_entry_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_entry_get_type();"
		end

	gtk_entry_new: CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_entry_new)
		end

	c_gtk_entry_new: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_entry_new();"
		end

	gtk_entry_set_text (a_entry: CE_POINTER [SD_GTKENTRY]; a_text: CE_POINTER [INTEGER_8])
		do
			c_gtk_entry_set_text (a_entry.c_pointer, a_text.c_pointer)
		end

	c_gtk_entry_set_text (a_entry: POINTER; a_text: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_entry_set_text($a_entry, $a_text);"
		end

	gtk_entry_get_text (a_entry: CE_POINTER [SD_GTKENTRY]): CE_POINTER [INTEGER_8]
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_gtk_entry_get_text (a_entry.c_pointer))
		end

	c_gtk_entry_get_text (a_entry: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_entry_get_text($a_entry);"
		end

	gtk_file_chooser_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_file_chooser_get_type();"
		end

	gtk_file_chooser_set_current_name (a_chooser: CE_POINTER [ANY]; a_name: CE_POINTER [INTEGER_8])
		do
			c_gtk_file_chooser_set_current_name (a_chooser.c_pointer, a_name.c_pointer)
		end

	c_gtk_file_chooser_set_current_name (a_chooser: POINTER; a_name: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_file_chooser_set_current_name($a_chooser, $a_name);"
		end

	gtk_file_chooser_get_filename (a_chooser: CE_POINTER [ANY]): CE_POINTER [INTEGER_8]
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_gtk_file_chooser_get_filename (a_chooser.c_pointer))
		end

	c_gtk_file_chooser_get_filename (a_chooser: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_file_chooser_get_filename($a_chooser);"
		end

	gtk_file_chooser_set_filename (a_chooser: CE_POINTER [ANY]; a_filename: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_gtk_file_chooser_set_filename (a_chooser.c_pointer, a_filename.c_pointer)
		end

	c_gtk_file_chooser_set_filename (a_chooser: POINTER; a_filename: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_file_chooser_set_filename($a_chooser, $a_filename);"
		end

	gtk_file_chooser_set_current_folder (a_chooser: CE_POINTER [ANY]; a_filename: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_gtk_file_chooser_set_current_folder (a_chooser.c_pointer, a_filename.c_pointer)
		end

	c_gtk_file_chooser_set_current_folder (a_chooser: POINTER; a_filename: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_file_chooser_set_current_folder($a_chooser, $a_filename);"
		end

	gtk_hbox_new (a_homogeneous, a_spacing: INTEGER_32): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_hbox_new (a_homogeneous, a_spacing))
		end

	c_gtk_hbox_new (a_homogeneous: INTEGER_32; a_spacing: INTEGER_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_hbox_new($a_homogeneous, $a_spacing);"
		end

	gtk_file_chooser_dialog_new (a_args: TUPLE [a_title: CE_POINTER [INTEGER_8]; a_parent: CE_POINTER [SD_GTKWINDOW]; a_action: NATURAL_32; a_first_button_text: CE_POINTER [INTEGER_8]]): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared ((create {CE_ROUTINE}.make_shared (c_gtk_file_chooser_dialog_new)).pointer_item (a_args).c_pointer)
		end

	c_gtk_file_chooser_dialog_new: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)&gtk_file_chooser_dialog_new;"
		end

	gtk_range_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_range_get_type();"
		end

	gtk_range_get_adjustment (a_range: CE_POINTER [SD_GTKRANGE]): CE_POINTER [SD_GTKADJUSTMENT]
		do
			create {CE_CLASS_POINTER [SD_GTKADJUSTMENT]} Result.make_shared (c_gtk_range_get_adjustment (a_range.c_pointer))
		end

	c_gtk_range_get_adjustment (a_range: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_range_get_adjustment($a_range);"
		end

	gtk_hscrollbar_new (a_adjustment: CE_POINTER [SD_GTKADJUSTMENT]): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_hscrollbar_new (a_adjustment.c_pointer))
		end

	c_gtk_hscrollbar_new (a_adjustment: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_hscrollbar_new($a_adjustment);"
		end

	gtk_icon_factory_new: CE_POINTER [SD_GTKICONFACTORY]
		do
			create {CE_CLASS_POINTER [SD_GTKICONFACTORY]} Result.make_shared (c_gtk_icon_factory_new)
		end

	c_gtk_icon_factory_new: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_icon_factory_new();"
		end

	gtk_icon_factory_add (a_factory: CE_POINTER [SD_GTKICONFACTORY]; a_stock_id: CE_POINTER [INTEGER_8]; a_icon_set: CE_POINTER [ANY])
		do
			c_gtk_icon_factory_add (a_factory.c_pointer, a_stock_id.c_pointer, a_icon_set.c_pointer)
		end

	c_gtk_icon_factory_add (a_factory: POINTER; a_stock_id: POINTER; a_icon_set: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_icon_factory_add($a_factory, $a_stock_id, $a_icon_set);"
		end

	gtk_icon_factory_add_default (a_factory: CE_POINTER [SD_GTKICONFACTORY])
		do
			c_gtk_icon_factory_add_default (a_factory.c_pointer)
		end

	c_gtk_icon_factory_add_default (a_factory: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_icon_factory_add_default($a_factory);"
		end

	gtk_icon_set_new: CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_gtk_icon_set_new)
		end

	c_gtk_icon_set_new: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_icon_set_new();"
		end

	gtk_icon_set_new_from_pixbuf (a_pixbuf: CE_POINTER [ANY]): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_gtk_icon_set_new_from_pixbuf (a_pixbuf.c_pointer))
		end

	c_gtk_icon_set_new_from_pixbuf (a_pixbuf: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_icon_set_new_from_pixbuf($a_pixbuf);"
		end

	gtk_icon_set_unref (a_icon_set: CE_POINTER [ANY])
		do
			c_gtk_icon_set_unref (a_icon_set.c_pointer)
		end

	c_gtk_icon_set_unref (a_icon_set: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_icon_set_unref($a_icon_set);"
		end

	gtk_icon_set_add_source (a_icon_set, a_source: CE_POINTER [ANY])
		do
			c_gtk_icon_set_add_source (a_icon_set.c_pointer, a_source.c_pointer)
		end

	c_gtk_icon_set_add_source (a_icon_set: POINTER; a_source: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_icon_set_add_source($a_icon_set, $a_source);"
		end

	gtk_icon_source_new: CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_gtk_icon_source_new)
		end

	c_gtk_icon_source_new: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_icon_source_new();"
		end

	gtk_icon_source_free (a_source: CE_POINTER [ANY])
		do
			c_gtk_icon_source_free (a_source.c_pointer)
		end

	c_gtk_icon_source_free (a_source: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_icon_source_free($a_source);"
		end

	gtk_icon_source_set_filename (a_source: CE_POINTER [ANY]; a_filename: CE_POINTER [INTEGER_8])
		do
			c_gtk_icon_source_set_filename (a_source.c_pointer, a_filename.c_pointer)
		end

	c_gtk_icon_source_set_filename (a_source: POINTER; a_filename: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_icon_source_set_filename($a_source, $a_filename);"
		end

	gtk_im_multicontext_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_im_multicontext_get_type();"
		end

	gtk_im_multicontext_append_menuitems (a_context: CE_POINTER [SD_GTKIMMULTICONTEXT]; a_menushell: CE_POINTER [SD_GTKMENUSHELL])
		do
			c_gtk_im_multicontext_append_menuitems (a_context.c_pointer, a_menushell.c_pointer)
		end

	c_gtk_im_multicontext_append_menuitems (a_context: POINTER; a_menushell: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_im_multicontext_append_menuitems($a_context, $a_menushell);"
		end

	gtk_menu_bar_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_menu_bar_get_type();"
		end

	gtk_tooltips_set_tip (a_tooltips: CE_POINTER [SD_GTKTOOLTIPS]; a_widget: CE_POINTER [SD_GTKWIDGET]; a_tip_text, a_tip_private: CE_POINTER [INTEGER_8])
		do
			c_gtk_tooltips_set_tip (a_tooltips.c_pointer, a_widget.c_pointer, a_tip_text.c_pointer, a_tip_private.c_pointer)
		end

	c_gtk_tooltips_set_tip (a_tooltips: POINTER; a_widget: POINTER; a_tip_text: POINTER; a_tip_private: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_tooltips_set_tip($a_tooltips, $a_widget, $a_tip_text, $a_tip_private);"
		end

	gtk_message_dialog_new (a_args: TUPLE [a_parent: CE_POINTER [SD_GTKWINDOW]; a_flags, a_type, a_buttons: NATURAL_32; a_message_format: CE_POINTER [INTEGER_8]]): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared ((create {CE_ROUTINE}.make_shared (c_gtk_message_dialog_new)).pointer_item (a_args).c_pointer)
		end

	c_gtk_message_dialog_new: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)&gtk_message_dialog_new;"
		end

	gtk_radio_button_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_radio_button_get_type();"
		end

	gtk_radio_button_new_with_label (a_group: CE_POINTER [SD_GSLIST]; a_label: CE_POINTER [INTEGER_8]): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_radio_button_new_with_label (a_group.c_pointer, a_label.c_pointer))
		end

	c_gtk_radio_button_new_with_label (a_group: POINTER; a_label: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_radio_button_new_with_label($a_group, $a_label);"
		end

	gtk_radio_button_get_group (a_radio_button: CE_POINTER [SD_GTKRADIOBUTTON]): CE_POINTER [SD_GSLIST]
		do
			create {CE_CLASS_POINTER [SD_GSLIST]} Result.make_shared (c_gtk_radio_button_get_group (a_radio_button.c_pointer))
		end

	c_gtk_radio_button_get_group (a_radio_button: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_radio_button_get_group($a_radio_button);"
		end

	gtk_vscrollbar_new (a_adjustment: CE_POINTER [SD_GTKADJUSTMENT]): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_vscrollbar_new (a_adjustment.c_pointer))
		end

	c_gtk_vscrollbar_new (a_adjustment: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_vscrollbar_new($a_adjustment);"
		end

	gtk_separator_menu_item_new: CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_separator_menu_item_new)
		end

	c_gtk_separator_menu_item_new: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_separator_menu_item_new();"
		end

	gtk_table_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_table_get_type();"
		end

	gtk_table_new (a_rows, a_columns: NATURAL_32; a_homogeneous: INTEGER_32): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_table_new (a_rows, a_columns, a_homogeneous))
		end

	c_gtk_table_new (a_rows: NATURAL_32; a_columns: NATURAL_32; a_homogeneous: INTEGER_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_table_new($a_rows, $a_columns, $a_homogeneous);"
		end

	gtk_table_attach (a_table: CE_POINTER [SD_GTKTABLE]; a_child: CE_POINTER [SD_GTKWIDGET]; a_left_attach, a_right_attach, a_top_attach, a_bottom_attach, a_xoptions, a_yoptions, a_xpadding, a_ypadding: NATURAL_32)
		do
			c_gtk_table_attach (a_table.c_pointer, a_child.c_pointer, a_left_attach, a_right_attach, a_top_attach, a_bottom_attach, a_xoptions, a_yoptions, a_xpadding, a_ypadding)
		end

	c_gtk_table_attach (a_table: POINTER; a_child: POINTER; a_left_attach: NATURAL_32; a_right_attach: NATURAL_32; a_top_attach: NATURAL_32; a_bottom_attach: NATURAL_32; a_xoptions: NATURAL_32; a_yoptions: NATURAL_32; a_xpadding: NATURAL_32; a_ypadding: NATURAL_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_table_attach($a_table, $a_child, $a_left_attach, $a_right_attach, $a_top_attach, $a_bottom_attach, $a_xoptions, $a_yoptions, $a_xpadding, $a_ypadding);"
		end

	gtk_tearoff_menu_item_new: CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_tearoff_menu_item_new)
		end

	c_gtk_tearoff_menu_item_new: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_tearoff_menu_item_new();"
		end

	gtk_toolbar_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_toolbar_get_type();"
		end

	gtk_toolbar_get_icon_size (a_toolbar: CE_POINTER [SD_GTKTOOLBAR]): NATURAL_32
		do
			Result := c_gtk_toolbar_get_icon_size (a_toolbar.c_pointer)
		end

	c_gtk_toolbar_get_icon_size (a_toolbar: POINTER): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_toolbar_get_icon_size($a_toolbar);"
		end

	gtk_toolbar_insert_item (a_toolbar: CE_POINTER [SD_GTKTOOLBAR]; a_text, a_tooltip_text, a_tooltip_private_text: CE_POINTER [INTEGER_8]; a_icon: CE_POINTER [SD_GTKWIDGET]; a_callback: CE_ROUTINE; a_user_data: CE_POINTER [ANY]; a_position: INTEGER_32): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_toolbar_insert_item (a_toolbar.c_pointer, a_text.c_pointer, a_tooltip_text.c_pointer, a_tooltip_private_text.c_pointer, a_icon.c_pointer, a_callback.c_pointer, a_user_data.c_pointer, a_position))
		end

	c_gtk_toolbar_insert_item (a_toolbar: POINTER; a_text: POINTER; a_tooltip_text: POINTER; a_tooltip_private_text: POINTER; a_icon: POINTER; a_callback: POINTER; a_user_data: POINTER; a_position: INTEGER_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_toolbar_insert_item($a_toolbar, $a_text, $a_tooltip_text, $a_tooltip_private_text, $a_icon, $a_callback, $a_user_data, $a_position);"
		end

	gtk_toolbar_insert_space (a_toolbar: CE_POINTER [SD_GTKTOOLBAR]; a_position: INTEGER_32)
		do
			c_gtk_toolbar_insert_space (a_toolbar.c_pointer, a_position)
		end

	c_gtk_toolbar_insert_space (a_toolbar: POINTER; a_position: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_toolbar_insert_space($a_toolbar, $a_position);"
		end

	gtk_toolbar_remove_space (a_toolbar: CE_POINTER [SD_GTKTOOLBAR]; a_position: INTEGER_32)
		do
			c_gtk_toolbar_remove_space (a_toolbar.c_pointer, a_position)
		end

	c_gtk_toolbar_remove_space (a_toolbar: POINTER; a_position: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_toolbar_remove_space($a_toolbar, $a_position);"
		end

	gtk_vbutton_box_new: CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_vbutton_box_new)
		end

	c_gtk_vbutton_box_new: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_vbutton_box_new();"
		end

	gtk_vseparator_new: CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_vseparator_new)
		end

	c_gtk_vseparator_new: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_vseparator_new();"
		end

	gtk_accel_group_new: CE_POINTER [SD_GTKACCELGROUP]
		do
			create {CE_CLASS_POINTER [SD_GTKACCELGROUP]} Result.make_shared (c_gtk_accel_group_new)
		end

	c_gtk_accel_group_new: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_accel_group_new();"
		end

	gtk_object_set_user_data (a_object: CE_POINTER [SD_GTKOBJECT]; a_data: CE_POINTER [ANY])
		do
			c_gtk_object_set_user_data (a_object.c_pointer, a_data.c_pointer)
		end

	c_gtk_object_set_user_data (a_object: POINTER; a_data: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_object_set_user_data($a_object, $a_data);"
		end

	gtk_object_get_user_data (a_object: CE_POINTER [SD_GTKOBJECT]): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_gtk_object_get_user_data (a_object.c_pointer))
		end

	c_gtk_object_get_user_data (a_object: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_object_get_user_data($a_object);"
		end

	gtk_rc_parse_string (a_rc_string: CE_POINTER [INTEGER_8])
		do
			c_gtk_rc_parse_string (a_rc_string.c_pointer)
		end

	c_gtk_rc_parse_string (a_rc_string: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_rc_parse_string($a_rc_string);"
		end

	gtk_settings_get_for_screen (a_screen: CE_POINTER [SD_GDKSCREEN]): CE_POINTER [SD_GTKSETTINGS]
		do
			create {CE_CLASS_POINTER [SD_GTKSETTINGS]} Result.make_shared (c_gtk_settings_get_for_screen (a_screen.c_pointer))
		end

	c_gtk_settings_get_for_screen (a_screen: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_settings_get_for_screen($a_screen);"
		end

	gtk_widget_set_name (a_widget: CE_POINTER [SD_GTKWIDGET]; a_name: CE_POINTER [INTEGER_8])
		do
			c_gtk_widget_set_name (a_widget.c_pointer, a_name.c_pointer)
		end

	c_gtk_widget_set_name (a_widget: POINTER; a_name: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_widget_set_name($a_widget, $a_name);"
		end

	gtk_widget_set_events (a_widget: CE_POINTER [SD_GTKWIDGET]; a_events: INTEGER_32)
		do
			c_gtk_widget_set_events (a_widget.c_pointer, a_events)
		end

	c_gtk_widget_set_events (a_widget: POINTER; a_events: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_widget_set_events($a_widget, $a_events);"
		end

	gtk_widget_add_events (a_widget: CE_POINTER [SD_GTKWIDGET]; a_events: INTEGER_32)
		do
			c_gtk_widget_add_events (a_widget.c_pointer, a_events)
		end

	c_gtk_widget_add_events (a_widget: POINTER; a_events: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_widget_add_events($a_widget, $a_events);"
		end

	gtk_widget_get_colormap (a_widget: CE_POINTER [SD_GTKWIDGET]): CE_POINTER [SD_GDKCOLORMAP]
		do
			create {CE_CLASS_POINTER [SD_GDKCOLORMAP]} Result.make_shared (c_gtk_widget_get_colormap (a_widget.c_pointer))
		end

	c_gtk_widget_get_colormap (a_widget: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_widget_get_colormap($a_widget);"
		end

	gtk_widget_get_screen (a_widget: CE_POINTER [SD_GTKWIDGET]): CE_POINTER [SD_GDKSCREEN]
		do
			create {CE_CLASS_POINTER [SD_GDKSCREEN]} Result.make_shared (c_gtk_widget_get_screen (a_widget.c_pointer))
		end

	c_gtk_widget_get_screen (a_widget: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_widget_get_screen($a_widget);"
		end

	gtk_widget_has_screen (a_widget: CE_POINTER [SD_GTKWIDGET]): INTEGER_32
		do
			Result := c_gtk_widget_has_screen (a_widget.c_pointer)
		end

	c_gtk_widget_has_screen (a_widget: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_widget_has_screen($a_widget);"
		end

	gtk_widget_get_display (a_widget: CE_POINTER [SD_GTKWIDGET]): CE_POINTER [SD_GDKDISPLAY]
		do
			create {CE_CLASS_POINTER [SD_GDKDISPLAY]} Result.make_shared (c_gtk_widget_get_display (a_widget.c_pointer))
		end

	c_gtk_widget_get_display (a_widget: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_widget_get_display($a_widget);"
		end

	gtk_widget_get_root_window (a_widget: CE_POINTER [SD_GTKWIDGET]): CE_POINTER [SD_GDKDRAWABLE]
		do
			create {CE_CLASS_POINTER [SD_GDKDRAWABLE]} Result.make_shared (c_gtk_widget_get_root_window (a_widget.c_pointer))
		end

	c_gtk_widget_get_root_window (a_widget: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_widget_get_root_window($a_widget);"
		end

	gtk_widget_create_pango_context (a_widget: CE_POINTER [SD_GTKWIDGET]): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_gtk_widget_create_pango_context (a_widget.c_pointer))
		end

	c_gtk_widget_create_pango_context (a_widget: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_widget_create_pango_context($a_widget);"
		end

	gtk_container_foreach (a_container: CE_POINTER [SD_GTKCONTAINER]; a_callback: CE_ROUTINE; a_callback_data: CE_POINTER [ANY])
		do
			c_gtk_container_foreach (a_container.c_pointer, a_callback.c_pointer, a_callback_data.c_pointer)
		end

	c_gtk_container_foreach (a_container: POINTER; a_callback: POINTER; a_callback_data: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_container_foreach($a_container, $a_callback, $a_callback_data);"
		end

	gtk_bin_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_bin_get_type();"
		end

	gtk_window_new (a_type: NATURAL_32): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_window_new (a_type))
		end

	c_gtk_window_new (a_type: NATURAL_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_window_new($a_type);"
		end

	gtk_window_set_role (a_window: CE_POINTER [SD_GTKWINDOW]; a_role: CE_POINTER [INTEGER_8])
		do
			c_gtk_window_set_role (a_window.c_pointer, a_role.c_pointer)
		end

	c_gtk_window_set_role (a_window: POINTER; a_role: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_window_set_role($a_window, $a_role);"
		end

	gtk_window_add_accel_group (a_window: CE_POINTER [SD_GTKWINDOW]; a_accel_group: CE_POINTER [SD_GTKACCELGROUP])
		do
			c_gtk_window_add_accel_group (a_window.c_pointer, a_accel_group.c_pointer)
		end

	c_gtk_window_add_accel_group (a_window: POINTER; a_accel_group: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_window_add_accel_group($a_window, $a_accel_group);"
		end

	gtk_window_set_geometry_hints (a_window: CE_POINTER [SD_GTKWINDOW]; a_geometry_widget: CE_POINTER [SD_GTKWIDGET]; a_geometry: CE_POINTER [SD_GDKGEOMETRY]; a_geom_mask: NATURAL_32)
		do
			c_gtk_window_set_geometry_hints (a_window.c_pointer, a_geometry_widget.c_pointer, a_geometry.c_pointer, a_geom_mask)
		end

	c_gtk_window_set_geometry_hints (a_window: POINTER; a_geometry_widget: POINTER; a_geometry: POINTER; a_geom_mask: NATURAL_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_window_set_geometry_hints($a_window, $a_geometry_widget, $a_geometry, $a_geom_mask);"
		end

	gtk_window_set_icon_list (a_window: CE_POINTER [SD_GTKWINDOW]; a_list: CE_POINTER [SD_GLIST])
		do
			c_gtk_window_set_icon_list (a_window.c_pointer, a_list.c_pointer)
		end

	c_gtk_window_set_icon_list (a_window: POINTER; a_list: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_window_set_icon_list($a_window, $a_list);"
		end

	gtk_window_iconify (a_window: CE_POINTER [SD_GTKWINDOW])
		do
			c_gtk_window_iconify (a_window.c_pointer)
		end

	c_gtk_window_iconify (a_window: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_window_iconify($a_window);"
		end

	gtk_window_unmaximize (a_window: CE_POINTER [SD_GTKWINDOW])
		do
			c_gtk_window_unmaximize (a_window.c_pointer)
		end

	c_gtk_window_unmaximize (a_window: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_window_unmaximize($a_window);"
		end

	gtk_window_resize (a_window: CE_POINTER [SD_GTKWINDOW]; a_width, a_height: INTEGER_32)
		do
			c_gtk_window_resize (a_window.c_pointer, a_width, a_height)
		end

	c_gtk_window_resize (a_window: POINTER; a_width: INTEGER_32; a_height: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_window_resize($a_window, $a_width, $a_height);"
		end

	gtk_window_get_size (a_window: CE_POINTER [SD_GTKWINDOW]; a_width, a_height: CE_POINTER [INTEGER_32])
		do
			c_gtk_window_get_size (a_window.c_pointer, a_width.c_pointer, a_height.c_pointer)
		end

	c_gtk_window_get_size (a_window: POINTER; a_width: POINTER; a_height: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_window_get_size($a_window, $a_width, $a_height);"
		end

	gtk_window_move (a_window: CE_POINTER [SD_GTKWINDOW]; a_x, a_y: INTEGER_32)
		do
			c_gtk_window_move (a_window.c_pointer, a_x, a_y)
		end

	c_gtk_window_move (a_window: POINTER; a_x: INTEGER_32; a_y: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_window_move($a_window, $a_x, $a_y);"
		end

	gtk_window_get_position (a_window: CE_POINTER [SD_GTKWINDOW]; a_root_x, a_root_y: CE_POINTER [INTEGER_32])
		do
			c_gtk_window_get_position (a_window.c_pointer, a_root_x.c_pointer, a_root_y.c_pointer)
		end

	c_gtk_window_get_position (a_window: POINTER; a_root_x: POINTER; a_root_y: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_window_get_position($a_window, $a_root_x, $a_root_y);"
		end

	gtk_misc_set_padding (a_misc: CE_POINTER [SD_GTKMISC]; a_xpad, a_ypad: INTEGER_32)
		do
			c_gtk_misc_set_padding (a_misc.c_pointer, a_xpad, a_ypad)
		end

	c_gtk_misc_set_padding (a_misc: POINTER; a_xpad: INTEGER_32; a_ypad: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_misc_set_padding($a_misc, $a_xpad, $a_ypad);"
		end

	gtk_label_set_text (a_label: CE_POINTER [SD_GTKLABEL]; a_str: CE_POINTER [INTEGER_8])
		do
			c_gtk_label_set_text (a_label.c_pointer, a_str.c_pointer)
		end

	c_gtk_label_set_text (a_label: POINTER; a_str: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_label_set_text($a_label, $a_str);"
		end

	gtk_image_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_image_get_type();"
		end

	gtk_image_set_from_icon_set (a_image: CE_POINTER [SD_GTKIMAGE]; a_icon_set: CE_POINTER [ANY]; a_size: NATURAL_32)
		do
			c_gtk_image_set_from_icon_set (a_image.c_pointer, a_icon_set.c_pointer, a_size)
		end

	c_gtk_image_set_from_icon_set (a_image: POINTER; a_icon_set: POINTER; a_size: NATURAL_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_image_set_from_icon_set($a_image, $a_icon_set, $a_size);"
		end

	gtk_image_get_storage_type (a_image: CE_POINTER [SD_GTKIMAGE]): NATURAL_32
		do
			Result := c_gtk_image_get_storage_type (a_image.c_pointer)
		end

	c_gtk_image_get_storage_type (a_image: POINTER): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_image_get_storage_type($a_image);"
		end

	gtk_image_get_icon_set (a_image: CE_POINTER [SD_GTKIMAGE]; a_icon_set: CE_POINTER [CE_POINTER [ANY]]; a_size: CE_POINTER [NATURAL_32])
		do
			c_gtk_image_get_icon_set (a_image.c_pointer, a_icon_set.c_pointer, a_size.c_pointer)
		end

	c_gtk_image_get_icon_set (a_image: POINTER; a_icon_set: POINTER; a_size: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_image_get_icon_set($a_image, $a_icon_set, $a_size);"
		end

	gtk_menu_item_new_with_label (a_label: CE_POINTER [INTEGER_8]): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_menu_item_new_with_label (a_label.c_pointer))
		end

	c_gtk_menu_item_new_with_label (a_label: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_menu_item_new_with_label($a_label);"
		end

	gtk_selection_owner_set (a_widget: CE_POINTER [SD_GTKWIDGET]; a_selection: CE_POINTER [ANY]; a_time_: NATURAL_32): INTEGER_32
		do
			Result := c_gtk_selection_owner_set (a_widget.c_pointer, a_selection.c_pointer, a_time_)
		end

	c_gtk_selection_owner_set (a_widget: POINTER; a_selection: POINTER; a_time_: NATURAL_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_selection_owner_set($a_widget, $a_selection, $a_time_);"
		end

	gtk_selection_add_targets (a_widget: CE_POINTER [SD_GTKWIDGET]; a_selection: CE_POINTER [ANY]; a_targets: CE_POINTER [SD_GTKTARGETENTRY]; a_ntargets: NATURAL_32)
		do
			c_gtk_selection_add_targets (a_widget.c_pointer, a_selection.c_pointer, a_targets.c_pointer, a_ntargets)
		end

	c_gtk_selection_add_targets (a_widget: POINTER; a_selection: POINTER; a_targets: POINTER; a_ntargets: NATURAL_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_selection_add_targets($a_widget, $a_selection, $a_targets, $a_ntargets);"
		end

	gtk_selection_clear_targets (a_widget: CE_POINTER [SD_GTKWIDGET]; a_selection: CE_POINTER [ANY])
		do
			c_gtk_selection_clear_targets (a_widget.c_pointer, a_selection.c_pointer)
		end

	c_gtk_selection_clear_targets (a_widget: POINTER; a_selection: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_selection_clear_targets($a_widget, $a_selection);"
		end

	gtk_selection_convert (a_widget: CE_POINTER [SD_GTKWIDGET]; a_selection, a_target: CE_POINTER [ANY]; a_time_: NATURAL_32): INTEGER_32
		do
			Result := c_gtk_selection_convert (a_widget.c_pointer, a_selection.c_pointer, a_target.c_pointer, a_time_)
		end

	c_gtk_selection_convert (a_widget: POINTER; a_selection: POINTER; a_target: POINTER; a_time_: NATURAL_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_selection_convert($a_widget, $a_selection, $a_target, $a_time_);"
		end

	gtk_selection_data_set (a_selection_data: CE_POINTER [SD_GTKSELECTIONDATA]; a_type: CE_POINTER [ANY]; a_format: INTEGER_32; a_data: CE_POINTER [NATURAL_8]; a_length: INTEGER_32)
		do
			c_gtk_selection_data_set (a_selection_data.c_pointer, a_type.c_pointer, a_format, a_data.c_pointer, a_length)
		end

	c_gtk_selection_data_set (a_selection_data: POINTER; a_type: POINTER; a_format: INTEGER_32; a_data: POINTER; a_length: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_selection_data_set($a_selection_data, $a_type, $a_format, $a_data, $a_length);"
		end

	gtk_selection_data_set_text (a_selection_data: CE_POINTER [SD_GTKSELECTIONDATA]; a_str: CE_POINTER [INTEGER_8]; a_len: INTEGER_32): INTEGER_32
		do
			Result := c_gtk_selection_data_set_text (a_selection_data.c_pointer, a_str.c_pointer, a_len)
		end

	c_gtk_selection_data_set_text (a_selection_data: POINTER; a_str: POINTER; a_len: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_selection_data_set_text($a_selection_data, $a_str, $a_len);"
		end

	gtk_selection_data_get_text (a_selection_data: CE_POINTER [SD_GTKSELECTIONDATA]): CE_POINTER [NATURAL_8]
		do
			create {CE_NATURAL_8_POINTER} Result.make_shared (c_gtk_selection_data_get_text (a_selection_data.c_pointer))
		end

	c_gtk_selection_data_get_text (a_selection_data: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_selection_data_get_text($a_selection_data);"
		end

	gtk_drag_finish (a_context: CE_POINTER [SD_GDKDRAGCONTEXT]; a_success, a_del: INTEGER_32; a_time_: NATURAL_32)
		do
			c_gtk_drag_finish (a_context.c_pointer, a_success, a_del, a_time_)
		end

	c_gtk_drag_finish (a_context: POINTER; a_success: INTEGER_32; a_del: INTEGER_32; a_time_: NATURAL_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_drag_finish($a_context, $a_success, $a_del, $a_time_);"
		end

	gtk_drag_dest_set (a_widget: CE_POINTER [SD_GTKWIDGET]; a_flags: NATURAL_32; a_targets: CE_POINTER [SD_GTKTARGETENTRY]; a_n_targets: INTEGER_32; a_actions: NATURAL_32)
		do
			c_gtk_drag_dest_set (a_widget.c_pointer, a_flags, a_targets.c_pointer, a_n_targets, a_actions)
		end

	c_gtk_drag_dest_set (a_widget: POINTER; a_flags: NATURAL_32; a_targets: POINTER; a_n_targets: INTEGER_32; a_actions: NATURAL_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_drag_dest_set($a_widget, $a_flags, $a_targets, $a_n_targets, $a_actions);"
		end

	gtk_drag_dest_unset (a_widget: CE_POINTER [SD_GTKWIDGET])
		do
			c_gtk_drag_dest_unset (a_widget.c_pointer)
		end

	c_gtk_drag_dest_unset (a_widget: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_drag_dest_unset($a_widget);"
		end

	gtk_drawing_area_new: CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_drawing_area_new)
		end

	c_gtk_drawing_area_new: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_drawing_area_new();"
		end

	gtk_event_box_new: CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_event_box_new)
		end

	c_gtk_event_box_new: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_event_box_new();"
		end

	gtk_font_selection_dialog_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_font_selection_dialog_get_type();"
		end

	gtk_font_selection_dialog_new (a_title: CE_POINTER [INTEGER_8]): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_font_selection_dialog_new (a_title.c_pointer))
		end

	c_gtk_font_selection_dialog_new (a_title: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_font_selection_dialog_new($a_title);"
		end

	gtk_font_selection_dialog_get_font_name (a_fsd: CE_POINTER [SD_GTKFONTSELECTIONDIALOG]): CE_POINTER [INTEGER_8]
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_gtk_font_selection_dialog_get_font_name (a_fsd.c_pointer))
		end

	c_gtk_font_selection_dialog_get_font_name (a_fsd: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_font_selection_dialog_get_font_name($a_fsd);"
		end

	gtk_font_selection_dialog_set_font_name (a_fsd: CE_POINTER [SD_GTKFONTSELECTIONDIALOG]; a_fontname: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_gtk_font_selection_dialog_set_font_name (a_fsd.c_pointer, a_fontname.c_pointer)
		end

	c_gtk_font_selection_dialog_set_font_name (a_fsd: POINTER; a_fontname: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_font_selection_dialog_set_font_name($a_fsd, $a_fontname);"
		end

	gtk_icon_set_ref (a_icon_set: CE_POINTER [ANY]): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_gtk_icon_set_ref (a_icon_set.c_pointer))
		end

	c_gtk_icon_set_ref (a_icon_set: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_icon_set_ref($a_icon_set);"
		end

	gtk_init_check (a_argc: CE_POINTER [INTEGER_32]; a_argv: CE_POINTER [CE_POINTER [CE_POINTER [INTEGER_8]]]): INTEGER_32
		do
			Result := c_gtk_init_check (a_argc.c_pointer, a_argv.c_pointer)
		end

	c_gtk_init_check (a_argc: POINTER; a_argv: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_init_check($a_argc, $a_argv);"
		end

	gtk_timeout_add (a_interval: NATURAL_32; a_function: CE_ROUTINE; a_data: CE_POINTER [ANY]): NATURAL_32
		do
			Result := c_gtk_timeout_add (a_interval, a_function.c_pointer, a_data.c_pointer)
		end

	c_gtk_timeout_add (a_interval: NATURAL_32; a_function: POINTER; a_data: POINTER): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_timeout_add($a_interval, $a_function, $a_data);"
		end

	gtk_timeout_remove (a_timeout_handler_id: NATURAL_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_timeout_remove($a_timeout_handler_id);"
		end

	gtk_menu_bar_new: CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_menu_bar_new)
		end

	c_gtk_menu_bar_new: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_menu_bar_new();"
		end

	gtk_tooltips_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_tooltips_get_type();"
		end

	gtk_tooltips_new: CE_POINTER [SD_GTKTOOLTIPS]
		do
			create {CE_CLASS_POINTER [SD_GTKTOOLTIPS]} Result.make_shared (c_gtk_tooltips_new)
		end

	c_gtk_tooltips_new: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_tooltips_new();"
		end

	gtk_tooltips_enable (a_tooltips: CE_POINTER [SD_GTKTOOLTIPS])
		do
			c_gtk_tooltips_enable (a_tooltips.c_pointer)
		end

	c_gtk_tooltips_enable (a_tooltips: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_tooltips_enable($a_tooltips);"
		end

	gtk_notebook_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_notebook_get_type();"
		end

	gtk_notebook_new: CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_notebook_new)
		end

	c_gtk_notebook_new: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_notebook_new();"
		end

	gtk_notebook_insert_page (a_notebook: CE_POINTER [SD_GTKNOTEBOOK]; a_child, a_tab_label: CE_POINTER [SD_GTKWIDGET]; a_position: INTEGER_32): INTEGER_32
		do
			Result := c_gtk_notebook_insert_page (a_notebook.c_pointer, a_child.c_pointer, a_tab_label.c_pointer, a_position)
		end

	c_gtk_notebook_insert_page (a_notebook: POINTER; a_child: POINTER; a_tab_label: POINTER; a_position: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_notebook_insert_page($a_notebook, $a_child, $a_tab_label, $a_position);"
		end

	gtk_notebook_remove_page (a_notebook: CE_POINTER [SD_GTKNOTEBOOK]; a_page_num: INTEGER_32)
		do
			c_gtk_notebook_remove_page (a_notebook.c_pointer, a_page_num)
		end

	c_gtk_notebook_remove_page (a_notebook: POINTER; a_page_num: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_notebook_remove_page($a_notebook, $a_page_num);"
		end

	gtk_notebook_get_current_page (a_notebook: CE_POINTER [SD_GTKNOTEBOOK]): INTEGER_32
		do
			Result := c_gtk_notebook_get_current_page (a_notebook.c_pointer)
		end

	c_gtk_notebook_get_current_page (a_notebook: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_notebook_get_current_page($a_notebook);"
		end

	gtk_notebook_get_nth_page (a_notebook: CE_POINTER [SD_GTKNOTEBOOK]; a_page_num: INTEGER_32): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_notebook_get_nth_page (a_notebook.c_pointer, a_page_num))
		end

	c_gtk_notebook_get_nth_page (a_notebook: POINTER; a_page_num: INTEGER_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_notebook_get_nth_page($a_notebook, $a_page_num);"
		end

	gtk_notebook_set_current_page (a_notebook: CE_POINTER [SD_GTKNOTEBOOK]; a_page_num: INTEGER_32)
		do
			c_gtk_notebook_set_current_page (a_notebook.c_pointer, a_page_num)
		end

	c_gtk_notebook_set_current_page (a_notebook: POINTER; a_page_num: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_notebook_set_current_page($a_notebook, $a_page_num);"
		end

	gtk_notebook_set_show_border (a_notebook: CE_POINTER [SD_GTKNOTEBOOK]; a_show_border: INTEGER_32)
		do
			c_gtk_notebook_set_show_border (a_notebook.c_pointer, a_show_border)
		end

	c_gtk_notebook_set_show_border (a_notebook: POINTER; a_show_border: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_notebook_set_show_border($a_notebook, $a_show_border);"
		end

	gtk_notebook_set_show_tabs (a_notebook: CE_POINTER [SD_GTKNOTEBOOK]; a_show_tabs: INTEGER_32)
		do
			c_gtk_notebook_set_show_tabs (a_notebook.c_pointer, a_show_tabs)
		end

	c_gtk_notebook_set_show_tabs (a_notebook: POINTER; a_show_tabs: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_notebook_set_show_tabs($a_notebook, $a_show_tabs);"
		end

	gtk_notebook_get_show_tabs (a_notebook: CE_POINTER [SD_GTKNOTEBOOK]): INTEGER_32
		do
			Result := c_gtk_notebook_get_show_tabs (a_notebook.c_pointer)
		end

	c_gtk_notebook_get_show_tabs (a_notebook: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_notebook_get_show_tabs($a_notebook);"
		end

	gtk_notebook_set_tab_border (a_notebook: CE_POINTER [SD_GTKNOTEBOOK]; a_border_width: NATURAL_32)
		do
			c_gtk_notebook_set_tab_border (a_notebook.c_pointer, a_border_width)
		end

	c_gtk_notebook_set_tab_border (a_notebook: POINTER; a_border_width: NATURAL_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_notebook_set_tab_border($a_notebook, $a_border_width);"
		end

	gtk_notebook_set_scrollable (a_notebook: CE_POINTER [SD_GTKNOTEBOOK]; a_scrollable: INTEGER_32)
		do
			c_gtk_notebook_set_scrollable (a_notebook.c_pointer, a_scrollable)
		end

	c_gtk_notebook_set_scrollable (a_notebook: POINTER; a_scrollable: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_notebook_set_scrollable($a_notebook, $a_scrollable);"
		end

	gtk_notebook_get_tab_label (a_notebook: CE_POINTER [SD_GTKNOTEBOOK]; a_child: CE_POINTER [SD_GTKWIDGET]): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_notebook_get_tab_label (a_notebook.c_pointer, a_child.c_pointer))
		end

	c_gtk_notebook_get_tab_label (a_notebook: POINTER; a_child: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_notebook_get_tab_label($a_notebook, $a_child);"
		end

	gtk_notebook_set_tab_label (a_notebook: CE_POINTER [SD_GTKNOTEBOOK]; a_child, a_tab_label: CE_POINTER [SD_GTKWIDGET])
		do
			c_gtk_notebook_set_tab_label (a_notebook.c_pointer, a_child.c_pointer, a_tab_label.c_pointer)
		end

	c_gtk_notebook_set_tab_label (a_notebook: POINTER; a_child: POINTER; a_tab_label: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_notebook_set_tab_label($a_notebook, $a_child, $a_tab_label);"
		end

	gtk_plug_get_type: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_plug_get_type();"
		end

	gtk_plug_new_for_display (a_display: CE_POINTER [SD_GDKDISPLAY]; a_socket_id: NATURAL_32): CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_plug_new_for_display (a_display.c_pointer, a_socket_id))
		end

	c_gtk_plug_new_for_display (a_display: POINTER; a_socket_id: NATURAL_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_plug_new_for_display($a_display, $a_socket_id);"
		end

	gtk_toolbar_new: CE_POINTER [SD_GTKWIDGET]
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} Result.make_shared (c_gtk_toolbar_new)
		end

	c_gtk_toolbar_new: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_toolbar_new();"
		end

	gtk_toolbar_set_style (a_toolbar: CE_POINTER [SD_GTKTOOLBAR]; a_style: NATURAL_32)
		do
			c_gtk_toolbar_set_style (a_toolbar.c_pointer, a_style)
		end

	c_gtk_toolbar_set_style (a_toolbar: POINTER; a_style: NATURAL_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_toolbar_set_style($a_toolbar, $a_style);"
		end

	gtk_toolbar_set_icon_size (a_toolbar: CE_POINTER [SD_GTKTOOLBAR]; a_icon_size: NATURAL_32)
		do
			c_gtk_toolbar_set_icon_size (a_toolbar.c_pointer, a_icon_size)
		end

	c_gtk_toolbar_set_icon_size (a_toolbar: POINTER; a_icon_size: NATURAL_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_toolbar_set_icon_size($a_toolbar, $a_icon_size);"
		end

	gtk_toolbar_unset_icon_size (a_toolbar: CE_POINTER [SD_GTKTOOLBAR])
		do
			c_gtk_toolbar_unset_icon_size (a_toolbar.c_pointer)
		end

	c_gtk_toolbar_unset_icon_size (a_toolbar: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_toolbar_unset_icon_size($a_toolbar);"
		end

	gtk_toolbar_set_tooltips (a_toolbar: CE_POINTER [SD_GTKTOOLBAR]; a_enable: INTEGER_32)
		do
			c_gtk_toolbar_set_tooltips (a_toolbar.c_pointer, a_enable)
		end

	c_gtk_toolbar_set_tooltips (a_toolbar: POINTER; a_enable: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_toolbar_set_tooltips($a_toolbar, $a_enable);"
		end

	gtk_type_unique (a_parent_type: NATURAL_32; a_gtkinfo: CE_POINTER [SD_GTKTYPEINFO]): NATURAL_32
		do
			Result := c_gtk_type_unique (a_parent_type, a_gtkinfo.c_pointer)
		end

	c_gtk_type_unique (a_parent_type: NATURAL_32; a_gtkinfo: POINTER): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_type_unique($a_parent_type, $a_gtkinfo);"
		end

	gtk_type_class (a_type: NATURAL_32): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_gtk_type_class (a_type))
		end

	c_gtk_type_class (a_type: NATURAL_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_type_class($a_type);"
		end

	gtk_type_new (a_type: NATURAL_32): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_gtk_type_new (a_type))
		end

	c_gtk_type_new (a_type: NATURAL_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_type_new($a_type);"
		end

	gtk_style_attach (a_style: CE_POINTER [SD_GTKSTYLE]; a_window: CE_POINTER [SD_GDKDRAWABLE]): CE_POINTER [SD_GTKSTYLE]
		do
			create {CE_CLASS_POINTER [SD_GTKSTYLE]} Result.make_shared (c_gtk_style_attach (a_style.c_pointer, a_window.c_pointer))
		end

	c_gtk_style_attach (a_style: POINTER; a_window: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_style_attach($a_style, $a_window);"
		end

	gtk_style_set_background (a_style: CE_POINTER [SD_GTKSTYLE]; a_window: CE_POINTER [SD_GDKDRAWABLE]; a_state_type: NATURAL_32)
		do
			c_gtk_style_set_background (a_style.c_pointer, a_window.c_pointer, a_state_type)
		end

	c_gtk_style_set_background (a_style: POINTER; a_window: POINTER; a_state_type: NATURAL_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_style_set_background($a_style, $a_window, $a_state_type);"
		end

	gtk_widget_unparent (a_widget: CE_POINTER [SD_GTKWIDGET])
		do
			c_gtk_widget_unparent (a_widget.c_pointer)
		end

	c_gtk_widget_unparent (a_widget: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_widget_unparent($a_widget);"
		end

	gtk_widget_map (a_widget: CE_POINTER [SD_GTKWIDGET])
		do
			c_gtk_widget_map (a_widget.c_pointer)
		end

	c_gtk_widget_map (a_widget: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_widget_map($a_widget);"
		end

	gtk_widget_unmap (a_widget: CE_POINTER [SD_GTKWIDGET])
		do
			c_gtk_widget_unmap (a_widget.c_pointer)
		end

	c_gtk_widget_unmap (a_widget: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_widget_unmap($a_widget);"
		end

	gtk_widget_realize (a_widget: CE_POINTER [SD_GTKWIDGET])
		do
			c_gtk_widget_realize (a_widget.c_pointer)
		end

	c_gtk_widget_realize (a_widget: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_widget_realize($a_widget);"
		end

	gtk_widget_queue_draw (a_widget: CE_POINTER [SD_GTKWIDGET])
		do
			c_gtk_widget_queue_draw (a_widget.c_pointer)
		end

	c_gtk_widget_queue_draw (a_widget: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_widget_queue_draw($a_widget);"
		end

	gtk_widget_size_request (a_widget: CE_POINTER [SD_GTKWIDGET]; a_requisition: CE_POINTER [SD_GTKREQUISITION])
		do
			c_gtk_widget_size_request (a_widget.c_pointer, a_requisition.c_pointer)
		end

	c_gtk_widget_size_request (a_widget: POINTER; a_requisition: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_widget_size_request($a_widget, $a_requisition);"
		end

	gtk_widget_size_allocate (a_widget: CE_POINTER [SD_GTKWIDGET]; a_allocation: CE_POINTER [SD_GDKRECTANGLE])
		do
			c_gtk_widget_size_allocate (a_widget.c_pointer, a_allocation.c_pointer)
		end

	c_gtk_widget_size_allocate (a_widget: POINTER; a_allocation: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_widget_size_allocate($a_widget, $a_allocation);"
		end

	gtk_widget_send_expose (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENT]): INTEGER_32
		do
			Result := c_gtk_widget_send_expose (a_widget.c_pointer, a_event.c_pointer)
		end

	c_gtk_widget_send_expose (a_widget: POINTER; a_event: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_widget_send_expose($a_widget, $a_event);"
		end

	gtk_widget_region_intersect (a_widget: CE_POINTER [SD_GTKWIDGET]; a_region: CE_POINTER [ANY]): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_gtk_widget_region_intersect (a_widget.c_pointer, a_region.c_pointer))
		end

	c_gtk_widget_region_intersect (a_widget: POINTER; a_region: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_widget_region_intersect($a_widget, $a_region);"
		end

	gtk_widget_set_parent (a_widget, a_parent: CE_POINTER [SD_GTKWIDGET])
		do
			c_gtk_widget_set_parent (a_widget.c_pointer, a_parent.c_pointer)
		end

	c_gtk_widget_set_parent (a_widget: POINTER; a_parent: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_widget_set_parent($a_widget, $a_parent);"
		end

	gtk_widget_set_parent_window (a_widget: CE_POINTER [SD_GTKWIDGET]; a_parent_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_gtk_widget_set_parent_window (a_widget.c_pointer, a_parent_window.c_pointer)
		end

	c_gtk_widget_set_parent_window (a_widget: POINTER; a_parent_window: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_widget_set_parent_window($a_widget, $a_parent_window);"
		end

	gtk_widget_get_parent_window (a_widget: CE_POINTER [SD_GTKWIDGET]): CE_POINTER [SD_GDKDRAWABLE]
		do
			create {CE_CLASS_POINTER [SD_GDKDRAWABLE]} Result.make_shared (c_gtk_widget_get_parent_window (a_widget.c_pointer))
		end

	c_gtk_widget_get_parent_window (a_widget: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_widget_get_parent_window($a_widget);"
		end

	gtk_widget_get_visual (a_widget: CE_POINTER [SD_GTKWIDGET]): CE_POINTER [SD_GDKVISUAL]
		do
			create {CE_CLASS_POINTER [SD_GDKVISUAL]} Result.make_shared (c_gtk_widget_get_visual (a_widget.c_pointer))
		end

	c_gtk_widget_get_visual (a_widget: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_widget_get_visual($a_widget);"
		end

	gtk_widget_get_events (a_widget: CE_POINTER [SD_GTKWIDGET]): INTEGER_32
		do
			Result := c_gtk_widget_get_events (a_widget.c_pointer)
		end

	c_gtk_widget_get_events (a_widget: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_widget_get_events($a_widget);"
		end

	gtk_signal_compat_matched (a_object: CE_POINTER [SD_GTKOBJECT]; a_func: CE_ROUTINE; a_data: CE_POINTER [ANY]; a_match, a_action: NATURAL_32)
		do
			c_gtk_signal_compat_matched (a_object.c_pointer, a_func.c_pointer, a_data.c_pointer, a_match, a_action)
		end

	c_gtk_signal_compat_matched (a_object: POINTER; a_func: POINTER; a_data: POINTER; a_match: NATURAL_32; a_action: NATURAL_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_signal_compat_matched($a_object, $a_func, $a_data, $a_match, $a_action);"
		end

	gtk_main_do_event (a_event: CE_POINTER [SD_GDKEVENT])
		do
			c_gtk_main_do_event (a_event.c_pointer)
		end

	c_gtk_main_do_event (a_event: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_main_do_event($a_event);"
		end

	gtk_paint_flat_box (a_style: CE_POINTER [SD_GTKSTYLE]; a_window: CE_POINTER [SD_GDKDRAWABLE]; a_state_type, a_shadow_type: NATURAL_32; a_area: CE_POINTER [SD_GDKRECTANGLE]; a_widget: CE_POINTER [SD_GTKWIDGET]; a_detail: CE_POINTER [INTEGER_8]; a_x, a_y, a_width, a_height: INTEGER_32)
		do
			c_gtk_paint_flat_box (a_style.c_pointer, a_window.c_pointer, a_state_type, a_shadow_type, a_area.c_pointer, a_widget.c_pointer, a_detail.c_pointer, a_x, a_y, a_width, a_height)
		end

	c_gtk_paint_flat_box (a_style: POINTER; a_window: POINTER; a_state_type: NATURAL_32; a_shadow_type: NATURAL_32; a_area: POINTER; a_widget: POINTER; a_detail: POINTER; a_x: INTEGER_32; a_y: INTEGER_32; a_width: INTEGER_32; a_height: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_paint_flat_box($a_style, $a_window, $a_state_type, $a_shadow_type, $a_area, $a_widget, $a_detail, $a_x, $a_y, $a_width, $a_height);"
		end

	gtk_widget_set_app_paintable (a_widget: CE_POINTER [SD_GTKWIDGET]; a_app_paintable: INTEGER_32)
		do
			c_gtk_widget_set_app_paintable (a_widget.c_pointer, a_app_paintable)
		end

	c_gtk_widget_set_app_paintable (a_widget: POINTER; a_app_paintable: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_widget_set_app_paintable($a_widget, $a_app_paintable);"
		end

	gtk_widget_set_uposition (a_widget: CE_POINTER [SD_GTKWIDGET]; a_x, a_y: INTEGER_32)
		do
			c_gtk_widget_set_uposition (a_widget.c_pointer, a_x, a_y)
		end

	c_gtk_widget_set_uposition (a_widget: POINTER; a_x: INTEGER_32; a_y: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_widget_set_uposition($a_widget, $a_x, $a_y);"
		end

	gtk_widget_is_ancestor (a_widget, a_ancestor: CE_POINTER [SD_GTKWIDGET]): INTEGER_32
		do
			Result := c_gtk_widget_is_ancestor (a_widget.c_pointer, a_ancestor.c_pointer)
		end

	c_gtk_widget_is_ancestor (a_widget: POINTER; a_ancestor: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gtk_widget_is_ancestor($a_widget, $a_ancestor);"
		end

	gtk_widget_ensure_style (a_widget: CE_POINTER [SD_GTKWIDGET])
		do
			c_gtk_widget_ensure_style (a_widget.c_pointer)
		end

	c_gtk_widget_ensure_style (a_widget: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_widget_ensure_style($a_widget);"
		end

	gtk_window_set_screen (a_window: CE_POINTER [SD_GTKWINDOW]; a_screen: CE_POINTER [SD_GDKSCREEN])
		do
			c_gtk_window_set_screen (a_window.c_pointer, a_screen.c_pointer)
		end

	c_gtk_window_set_screen (a_window: POINTER; a_screen: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_window_set_screen($a_window, $a_screen);"
		end

	gtk_window_set_policy (a_window: CE_POINTER [SD_GTKWINDOW]; a_allow_shrink, a_allow_grow, a_auto_shrink: INTEGER_32)
		do
			c_gtk_window_set_policy (a_window.c_pointer, a_allow_shrink, a_allow_grow, a_auto_shrink)
		end

	c_gtk_window_set_policy (a_window: POINTER; a_allow_shrink: INTEGER_32; a_allow_grow: INTEGER_32; a_auto_shrink: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_window_set_policy($a_window, $a_allow_shrink, $a_allow_grow, $a_auto_shrink);"
		end

	gtk_label_set_attributes (a_label: CE_POINTER [SD_GTKLABEL]; a_attrs: CE_POINTER [ANY])
		do
			c_gtk_label_set_attributes (a_label.c_pointer, a_attrs.c_pointer)
		end

	c_gtk_label_set_attributes (a_label: POINTER; a_attrs: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gtk_label_set_attributes($a_label, $a_attrs);"
		end

	gtk_label_set_justify (a_label: CE_POINTER [SD_GTKLABEL]; a_jtype: NATURAL_32)
		do
			c_gtk_label_set_justify (a_label.c_pointer, a_jtype)
		end

	c_gtk_label_set_justify (a_label: POINTER; a_jtype: NATURAL_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_label_set_justify($a_label, $a_jtype);"
		end

	gtk_label_set_line_wrap (a_label: CE_POINTER [SD_GTKLABEL]; a_wrap: INTEGER_32)
		do
			c_gtk_label_set_line_wrap (a_label.c_pointer, a_wrap)
		end

	c_gtk_label_set_line_wrap (a_label: POINTER; a_wrap: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gtk_label_set_line_wrap($a_label, $a_wrap);"
		end

	gtk_label_get_layout (a_label: CE_POINTER [SD_GTKLABEL]): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_gtk_label_get_layout (a_label.c_pointer))
		end

	c_gtk_label_get_layout (a_label: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)gtk_label_get_layout($a_label);"
		end

feature {ANY} -- routine addresses

	gtk_widget_hide_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent gtk_widget_hide)
		end

	gtk_widget_hide_on_delete_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent gtk_widget_hide_on_delete)
		end

end
