class
	P_CURL_MEMRCHR_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	Curl_memrchr (a_s: CE_POINTER [ANY]; a_c: INTEGER_32; a_n: NATURAL_32): CE_POINTER [ANY]
		local
			l_p: CE_POINTER [NATURAL_8]
			l_q: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_p := create {CE_NATURAL_8_POINTER}.make_cast (a_s)
			l_q := create {CE_NATURAL_8_POINTER}.make_cast (a_s)
			l_p := l_p + (a_n - {NATURAL_32} 1).to_integer_32
			from
			until
				not (not (l_return) and then ((l_p.c_pointer.to_integer_32).to_natural_32 >= (l_q.c_pointer.to_integer_32).to_natural_32))
			loop
				if (l_p.item).to_integer_32 = (a_c.to_natural_8).to_integer_32 then
					Result := (create {CE_VOID_POINTER}.make_cast (l_p))
					l_return := True
				end
				if not l_return then
					l_p := l_p - 1
				end
			end
			if not l_return then
				Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
			end
		end

end
