class
	P_WILDCARD_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	Curl_wildcard_dtor (a_wc: CE_POINTER [PD_WILDCARDDATA])
		local
			l_return: BOOLEAN
		do
			if a_wc.is_void then
				l_return := True
			end
			if not l_return then
				if (not (a_wc.item.tmp_dtor).is_void) then
					(a_wc.item.tmp_dtor).call ([a_wc.item.tmp])
					a_wc.item.tmp_dtor := create {CE_ROUTINE}.make_shared (default_pointer)
					a_wc.item.tmp := create {CE_VOID_POINTER}.make_shared (default_pointer)
				end
				if (not (a_wc.item.filelist).is_void) then
					(create {P_LLIST_STATIC}).Curl_llist_destroy (a_wc.item.filelist, create {CE_VOID_POINTER}.make_shared (default_pointer))
					a_wc.item.filelist := create {CE_CLASS_POINTER [PD_CURL_LLIST]}.make_shared (default_pointer)
				end
				if (not (a_wc.item.path).is_void) then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_wc.item.path)])
					a_wc.item.path := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				end
				if (not (a_wc.item.pattern).is_void) then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_wc.item.pattern)])
					a_wc.item.pattern := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				end
				a_wc.item.customptr := create {CE_VOID_POINTER}.make_shared (default_pointer)
				a_wc.item.state := {PC_CURL_WILDCARD_STATES}.CURLWC_INIT
			end
		end

end
