class
	PD_SSH_CONN

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} authlist.make
		end

feature {ANY} -- fields

	authlist: CE_POINTER [INTEGER_8] assign set_authlist

feature {ANY} -- field setters

	set_authlist (a_authlist: CE_POINTER [INTEGER_8])
		do
			authlist := a_authlist
			update_memory_field ("authlist")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			authlist := a_other.authlist
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				authlist.is_equal (a_other.authlist)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("authlist")
				>>)
			init_structure_info
		end

end
