class
	S_NETDB_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	getaddrinfo (a___name, a___service: CE_POINTER [INTEGER_8]; a___req: CE_POINTER [SD_ADDRINFO]; a___pai: CE_POINTER [CE_POINTER [SD_ADDRINFO]]): INTEGER_32
		do
			Result := c_getaddrinfo (a___name.c_pointer, a___service.c_pointer, a___req.c_pointer, a___pai.c_pointer)
		end

	c_getaddrinfo (a___name: POINTER; a___service: POINTER; a___req: POINTER; a___pai: POINTER): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return getaddrinfo($a___name, $a___service, $a___req, $a___pai);"
		end

	freeaddrinfo (a___ai: CE_POINTER [SD_ADDRINFO])
		do
			c_freeaddrinfo (a___ai.c_pointer)
		end

	c_freeaddrinfo (a___ai: POINTER)
		external
			"C inline use <libcurl.h>"
		alias
			"freeaddrinfo($a___ai);"
		end

end
