class
	S_UNISTD_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	lseek (a___fd: INTEGER_32; a___offset: INTEGER_32; a___whence: INTEGER_32): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return lseek($a___fd, $a___offset, $a___whence);"
		end

	close (a___fd: INTEGER_32): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return close($a___fd);"
		end

	read (a___fd: INTEGER_32; a___buf: CE_POINTER [ANY]; a___nbytes: NATURAL_32): INTEGER_32
		do
			Result := c_read (a___fd, a___buf.c_pointer, a___nbytes)
		end

	c_read (a___fd: INTEGER_32; a___buf: POINTER; a___nbytes: NATURAL_32): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return read($a___fd, $a___buf, $a___nbytes);"
		end

	alarm (a___seconds: NATURAL_32): NATURAL_32
		external
			"C inline use <libcurl.h>"
		alias
			"return alarm($a___seconds);"
		end

	geteuid: NATURAL_32
		external
			"C inline use <libcurl.h>"
		alias
			"return geteuid();"
		end

	gethostname (a___name: CE_POINTER [INTEGER_8]; a___len: NATURAL_32): INTEGER_32
		require
			not a___name.is_void
		do
			Result := c_gethostname (a___name.c_pointer, a___len)
		end

	c_gethostname (a___name: POINTER; a___len: NATURAL_32): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return gethostname($a___name, $a___len);"
		end

end
