class
	P_AORS_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpq_aors (a_fun: CE_ROUTINE; a_rop, a_op1, a_op2: CE_POINTER [PD_MPQ_STRUCT])
		require
			not a_fun.is_void
			not a_op1.is_void
			not a_op2.is_void
		local
			l_gcd: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp1: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp2: CE_ARRAY [PD_MPZ_STRUCT]
			l_op1_num_size: INTEGER_32
			l_tmp: INTEGER_32
			l_op1_den_size: INTEGER_32
			l_op2_num_size: INTEGER_32
			l_tmp___0: INTEGER_32
			l_op2_den_size: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l___x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___3: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___7: CE_POINTER [ANY]
			l_tmp___8: INTEGER_32
			l___x___0: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___13: CE_POINTER [ANY]
			l___x___1: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___18: CE_POINTER [ANY]
			l_t: CE_ARRAY [PD_MPZ_STRUCT]
			l___x___2: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___22: INTEGER_32
			l_tmp___23: INTEGER_32
			l_tmp___24: INTEGER_32
			l_tmp___25: INTEGER_32
			l_tmp___26: INTEGER_32
			l_tmp___37: INTEGER_32
			l_tmp___38: INTEGER_32
			l_tmp___39: INTEGER_32
			l_tmp___40: INTEGER_32
			l_tmp___41: INTEGER_32
			l_tmp___45: INTEGER_32
			l_tmp___46: INTEGER_32
			l_tmp___47: INTEGER_32
			l_tmp___48: INTEGER_32
			l_tmp___49: INTEGER_32
			l_tmp___51: CE_POINTER [ANY]
			l_tmp___54: INTEGER_32
			l_tmp___55: INTEGER_32
			l_tmp___56: INTEGER_32
			l_tmp___57: INTEGER_32
			l_tmp___58: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_gcd.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_tmp1.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_tmp2.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_t.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_op1.item.mp_num.mp_size >= 0 then
						l_tmp := a_op1.item.mp_num.mp_size
					else
						l_tmp := -a_op1.item.mp_num.mp_size
					end
					l_op1_num_size := l_tmp.to_integer_32
					l_op1_den_size := (a_op1.item.mp_den.mp_size).to_integer_32
					if a_op2.item.mp_num.mp_size >= 0 then
						l_tmp___0 := a_op2.item.mp_num.mp_size
					else
						l_tmp___0 := -a_op2.item.mp_num.mp_size
					end
					l_op2_num_size := l_tmp___0.to_integer_32
					l_op2_den_size := (a_op2.item.mp_den.mp_size).to_integer_32
					l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l___x := l_gcd
						if l_op1_den_size < l_op2_den_size then
							l___x.item.mp_alloc := l_op1_den_size.to_integer_32
						else
							l___x.item.mp_alloc := l_op2_den_size.to_integer_32
						end
						if l_op1_den_size < l_op2_den_size then
							l_tmp___8 := l_op1_den_size
						else
							l_tmp___8 := l_op2_den_size
						end
						if (builtin_expect ((l_tmp___8.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							if l_op1_den_size < l_op2_den_size then
								l_tmp___3 := l_op1_den_size
							else
								l_tmp___3 := l_op2_den_size
							end
							l_tmp___7 := (l_aaf.new ((l_tmp___3.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							if l_op1_den_size < l_op2_den_size then
								l_tmp___5 := l_op1_den_size
							else
								l_tmp___5 := l_op2_den_size
							end
							l_tmp___7 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_tmp___5.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l___x.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___7)
						l_break := True
					end
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l___x___0 := l_tmp1
						l___x___0.item.mp_alloc := (l_op1_num_size + l_op2_den_size).to_integer_32
						if (builtin_expect (((l_op1_num_size + l_op2_den_size).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___13 := (l_aaf.new (((l_op1_num_size + l_op2_den_size).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___13 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_op1_num_size + l_op2_den_size).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l___x___0.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___13)
						l_break := True
					end
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l___x___1 := l_tmp2
						l___x___1.item.mp_alloc := (l_op2_num_size + l_op1_den_size).to_integer_32
						if (builtin_expect (((l_op2_num_size + l_op1_den_size).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___18 := (l_aaf.new (((l_op2_num_size + l_op1_den_size).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___18 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_op2_num_size + l_op1_den_size).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l___x___1.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___18)
						l_break := True
					end
					l_break := False
					l_gcd.item.gmpz_gcd (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")))
					if l_gcd[0].mp_size /= 1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_gcd[0].mp_d[0] = {NATURAL_32} 1 then
							l_tmp1.item.gmpz_mul (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")))
							l_tmp2.item.gmpz_mul (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")))
							a_fun.call ([create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_rop.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp1), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp2)]);
							(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_rop.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den"))).item.gmpz_mul (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")))
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:;
						(create {P_DIVEGCD_STATIC}).gmpz_divexact_gcd (l_tmp1, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd))
						l_tmp1.item.gmpz_mul (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp1));
						(create {P_DIVEGCD_STATIC}).gmpz_divexact_gcd (l_tmp2, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd))
						l_tmp2.item.gmpz_mul (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp2))
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l___x___2 := l_t
							if l_tmp1[0].mp_size >= 0 then
								l_tmp___25 := l_tmp1[0].mp_size
							else
								l_tmp___25 := -l_tmp1[0].mp_size
							end
							if l_tmp2[0].mp_size >= 0 then
								l_tmp___26 := l_tmp2[0].mp_size
							else
								l_tmp___26 := -l_tmp2[0].mp_size
							end
							if l_tmp___25 > l_tmp___26 then
								if l_tmp1[0].mp_size >= 0 then
									l_tmp___22 := l_tmp1[0].mp_size
								else
									l_tmp___22 := -l_tmp1[0].mp_size
								end
								l_tmp___24 := l_tmp___22
							else
								if l_tmp2[0].mp_size >= 0 then
									l_tmp___23 := l_tmp2[0].mp_size
								else
									l_tmp___23 := -l_tmp2[0].mp_size
								end
								l_tmp___24 := l_tmp___23
							end
							l___x___2.item.mp_alloc := l_tmp___24 + 1
							if l_tmp1[0].mp_size >= 0 then
								l_tmp___57 := l_tmp1[0].mp_size
							else
								l_tmp___57 := -l_tmp1[0].mp_size
							end
							if l_tmp2[0].mp_size >= 0 then
								l_tmp___58 := l_tmp2[0].mp_size
							else
								l_tmp___58 := -l_tmp2[0].mp_size
							end
							if l_tmp___57 > l_tmp___58 then
								if l_tmp1[0].mp_size >= 0 then
									l_tmp___54 := l_tmp1[0].mp_size
								else
									l_tmp___54 := -l_tmp1[0].mp_size
								end
								l_tmp___56 := l_tmp___54
							else
								if l_tmp2[0].mp_size >= 0 then
									l_tmp___55 := l_tmp2[0].mp_size
								else
									l_tmp___55 := -l_tmp2[0].mp_size
								end
								l_tmp___56 := l_tmp___55
							end
							if (builtin_expect (((l_tmp___56 + 1).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								if l_tmp1[0].mp_size >= 0 then
									l_tmp___40 := l_tmp1[0].mp_size
								else
									l_tmp___40 := -l_tmp1[0].mp_size
								end
								if l_tmp2[0].mp_size >= 0 then
									l_tmp___41 := l_tmp2[0].mp_size
								else
									l_tmp___41 := -l_tmp2[0].mp_size
								end
								if l_tmp___40 > l_tmp___41 then
									if l_tmp1[0].mp_size >= 0 then
										l_tmp___37 := l_tmp1[0].mp_size
									else
										l_tmp___37 := -l_tmp1[0].mp_size
									end
									l_tmp___39 := l_tmp___37
								else
									if l_tmp2[0].mp_size >= 0 then
										l_tmp___38 := l_tmp2[0].mp_size
									else
										l_tmp___38 := -l_tmp2[0].mp_size
									end
									l_tmp___39 := l_tmp___38
								end
								l_tmp___51 := (l_aaf.new ((l_tmp___39 + 1).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32))
							else
								if l_tmp1[0].mp_size >= 0 then
									l_tmp___48 := l_tmp1[0].mp_size
								else
									l_tmp___48 := -l_tmp1[0].mp_size
								end
								if l_tmp2[0].mp_size >= 0 then
									l_tmp___49 := l_tmp2[0].mp_size
								else
									l_tmp___49 := -l_tmp2[0].mp_size
								end
								if l_tmp___48 > l_tmp___49 then
									if l_tmp1[0].mp_size >= 0 then
										l_tmp___45 := l_tmp1[0].mp_size
									else
										l_tmp___45 := -l_tmp1[0].mp_size
									end
									l_tmp___47 := l_tmp___45
								else
									if l_tmp2[0].mp_size >= 0 then
										l_tmp___46 := l_tmp2[0].mp_size
									else
										l_tmp___46 := -l_tmp2[0].mp_size
									end
									l_tmp___47 := l_tmp___46
								end
								l_tmp___51 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_tmp___47 + 1).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32))
							end
							l___x___2.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___51)
							l_break := True
						end
						l_break := False
						a_fun.call ([l_t, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp1), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp2)]);
						(create {P_DIVEGCD_STATIC}).gmpz_divexact_gcd (l_tmp2, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd))
						l_gcd.item.gmpz_gcd (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd))
						if l_gcd[0].mp_size = 1 then
							if l_gcd[0].mp_d[0] = {NATURAL_32} 1 then
								(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_rop.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num"))).item.gmpz_set (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t));
								(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_rop.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den"))).item.gmpz_mul (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp2))
							else
								(create {P_DIVEGCD_STATIC}).gmpz_divexact_gcd (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_rop.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd));
								(create {P_DIVEGCD_STATIC}).gmpz_divexact_gcd (l_tmp1, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd));
								(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_rop.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den"))).item.gmpz_mul (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp1), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp2))
							end
						else
							(create {P_DIVEGCD_STATIC}).gmpz_divexact_gcd (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_rop.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd));
							(create {P_DIVEGCD_STATIC}).gmpz_divexact_gcd (l_tmp1, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd));
							(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_rop.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den"))).item.gmpz_mul (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp1), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp2))
						end
				when 4 then
					from
					until
						(l_break)
					loop
						l_break := False
						if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
							(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						end
						l_break := True
					end
					l_break := False
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpq_add (a_rop, a_op1, a_op2: CE_POINTER [PD_MPQ_STRUCT])
		require
			not a_op1.is_void
			not a_op2.is_void
		do
			gmpq_aors ((create {PD_MPZ_STRUCT_STATIC}).gmpz_add_address, a_rop, a_op1, a_op2)
		end

	gmpq_sub (a_rop, a_op1, a_op2: CE_POINTER [PD_MPQ_STRUCT])
		require
			not a_op1.is_void
			not a_op2.is_void
		do
			gmpq_aors ((create {PD_MPZ_STRUCT_STATIC}).gmpz_sub_address, a_rop, a_op1, a_op2)
		end

end
