class
	P_DIVEGCD_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_divexact_gcd (a_q, a_a, a_d: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_d.is_void
		local
			l_dl: NATURAL_32
			l_twos: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if a_d.item.mp_size = 1 then
				l_dl := a_d.item.mp_d[0]
				if l_dl = {NATURAL_32} 1 then
					if not a_q.is_equal (a_a) then
						a_q.item.gmpz_set (a_a)
					end
					l_return := True
				end
				if not l_return and then (l_dl = {NATURAL_32} 3) then
					a_q.item.mpz_divexact_by3 (a_a)
					l_return := True
				end
				if not l_return then
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_twos := builtin_ctzl (l_dl)
						l_break := True
					end
					l_break := False
					l_dl := (l_dl).bit_shift_right (l_twos)
					if l_dl = {NATURAL_32} 1 then
						a_q.item.gmpz_tdiv_q_2exp (a_a, l_twos.to_natural_32)
						l_return := True
					end
				end
				if not l_return and then (l_dl = {NATURAL_32} 3) then
					a_q.item.gmpz_tdiv_q_2exp (a_a, l_twos.to_natural_32)
					a_q.item.mpz_divexact_by3 (a_q)
					l_return := True
				end
			end
			if not l_return then
				a_q.item.gmpz_divexact (a_a, a_d)
			end
		end

end
