class
	P_DOSCAN_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_CTYPE_STATIC

feature {ANY} -- public routines

	gmp_doscan (a_funs: CE_POINTER [PD_GMP_DOSCAN_FUNS_T]; a_data: CE_POINTER [ANY]; a_orig_fmt: CE_POINTER [INTEGER_8]; a_orig_ap: CE_VA_LIST): INTEGER_32
		require
			not a_orig_fmt.is_void
		local
			l_orig_ap: CE_VA_LIST
			l_param: CE_ARRAY [PD_GMP_DOSCAN_PARAMS_T]
			l_ap: CE_VA_LIST
			l_alloc_fmt: CE_POINTER [INTEGER_8]
			l_fmt: CE_POINTER [INTEGER_8]
			l_this_fmt: CE_POINTER [INTEGER_8]
			l_end_fmt: CE_POINTER [INTEGER_8]
			l_orig_fmt_len: NATURAL_32
			l_alloc_fmt_size: NATURAL_32
			l_len: NATURAL_32
			l_new_fields: INTEGER_32
			l_new_chars: CE_ARRAY [INTEGER_32]
			l_fchar: INTEGER_8
			l_fields: INTEGER_32
			l_chars: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_c: INTEGER_32
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: NATURAL_32
			l_tmp___9: NATURAL_32
			l_arg: CE_POINTER [ANY]
			l_tmp___13: CE_POINTER [ANY]
			l_p: CE_POINTER [ANY]
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GMP_DOSCAN_PARAMS_T]} l_param.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_new_chars.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_orig_ap := a_orig_ap.twin
					l_fields := 0
					l_chars := 0
					l_ap := l_orig_ap.twin
					l_orig_fmt_len := strlen (a_orig_fmt)
					l_alloc_fmt_size := l_orig_fmt_len + {NATURAL_32} 4
					l_alloc_fmt := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([l_alloc_fmt_size * {PLATFORM}.Integer_8_bytes.to_natural_32]))))
					l_fmt := a_orig_fmt
					l_end_fmt := a_orig_fmt + l_orig_fmt_len.to_integer_32
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 64 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_continue := False
				when 3 then -- next:
						l_tmp___0 := l_fmt
						l_fmt := l_fmt + 1
						l_fchar := l_tmp___0[0]
						if l_fchar.to_integer_32 = 0 then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							if ((((ctype_b_loc).item[l_fchar.to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
								l_chars := l_chars + (a_funs.item.skip_white (a_data))
								l_continue := True
							end
						end
						if not (not (l_return or l_break or l_continue) and then (l_fchar.to_integer_32 /= 37)) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if: | literal:
						l_c := (a_funs.item.get).integer_32_item ([a_data])
						if l_c = l_fchar.to_integer_32 then
							l_pos := -1 + 8 -- skip if block
						end
				when 5 then -- if:;
						(a_funs.item.unget).call ([l_c, a_data])
						if l_c /= -1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | eof_no_match:
						if l_fields = 0 then
							l_fields := -1
						end
				when 7 then -- if done
						l_pos := -1 + 65 -- goto done
				when 8 then
						l_chars := l_chars + 1
						l_continue := True
				when 9 then -- if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 63 -- skip if block
						end
				when 10 then -- if:
						l_param.item.type := (('%/0/').code).to_integer_8
						l_param.item.base := 0
						l_param.item.ignore := 0
						l_param.item.width := 0
						l_this_fmt := l_fmt - 1
				when 11 then -- loop condition:
						if (l_return) then
							l_pos := -1 + 63 -- skip loop
						end
				when 12 then -- loop body:
						l_tmp___3 := l_fmt
						l_fmt := l_fmt + 1
						l_fchar := l_tmp___3[0]
						inspect l_fchar.to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 13
						when 37 then l_pos := -1 + 14
						when 91 then l_pos := -1 + 15
						when 99 then l_pos := -1 + 20
						when 115 then l_pos := -1 + 20
						when 112 then l_pos := -1 + 20
						when 100 then l_pos := -1 + 29
						when 117 then l_pos := -1 + 29
						when 101 then l_pos := -1 + 30
						when 69 then l_pos := -1 + 30
						when 102 then l_pos := -1 + 30
						when 103 then l_pos := -1 + 30
						when 71 then l_pos := -1 + 30
						when 105 then l_pos := -1 + 30
						when 97 then l_pos := -1 + 34
						when 39 then l_pos := -1 + 34
						when 70 then l_pos := -1 + 35
						when 106 then l_pos := -1 + 35
						when 76 then l_pos := -1 + 35
						when 113 then l_pos := -1 + 35
						when 81 then l_pos := -1 + 35
						when 116 then l_pos := -1 + 35
						when 122 then l_pos := -1 + 35
						when 90 then l_pos := -1 + 35
						when 104 then l_pos := -1 + 36
						when 108 then l_pos := -1 + 39
						when 110 then l_pos := -1 + 41
						when 111 then l_pos := -1 + 57
						when 120 then l_pos := -1 + 58
						when 88 then l_pos := -1 + 58
						when 48 then l_pos := -1 + 59
						when 49 then l_pos := -1 + 59
						when 50 then l_pos := -1 + 59
						when 51 then l_pos := -1 + 59
						when 52 then l_pos := -1 + 59
						when 53 then l_pos := -1 + 59
						when 54 then l_pos := -1 + 59
						when 55 then l_pos := -1 + 59
						when 56 then l_pos := -1 + 59
						when 57 then l_pos := -1 + 59
						when 42 then l_pos := -1 + 60
						else l_pos := -1 + 61
						end
				when 13 then -- switch 1, case 0
						l_pos := -1 + 65 -- goto done
				when 14 then -- switch 1, case 37
						l_pos := -1 + 4 -- goto literal
				when 15 then -- switch 1, case 91
						l_tmp___4 := l_fmt
						l_fmt := l_fmt + 1
						l_fchar := l_tmp___4[0]
						if l_fchar.to_integer_32 = 94 then
							l_tmp___5 := l_fmt
							l_fmt := l_fmt + 1
							l_fchar := l_tmp___5[0]
						end
						if l_fchar.to_integer_32 = 93 then
							l_tmp___6 := l_fmt
							l_fmt := l_fmt + 1
							l_fchar := l_tmp___6[0]
						end
				when 16 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 19 -- skip loop
						end
				when 17 then -- loop body:
						l_break := False
						if l_fchar.to_integer_32 = 0 then
							l_pos := -1 + 65 -- goto done
						end
				when 18 then
						if l_fchar.to_integer_32 = 93 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_tmp___7 := l_fmt
							l_fmt := l_fmt + 1
							l_fchar := l_tmp___7[0]
						end
						l_pos := -1 + 16 -- back to loop condition
				when 19 then -- loop done
						l_break := False
				when 20 then -- libc_type: | switch 1, case 99 | switch 1, case 115 | switch 1, case 112
						l_len := (l_fmt.distance (l_this_fmt)).to_natural_32
						memcpy (create {CE_VOID_POINTER}.make_cast (l_alloc_fmt), create {CE_VOID_POINTER}.make_cast (l_this_fmt), l_len).do_nothing
						l_tmp___8 := l_len
						l_len := l_len + 1
						l_alloc_fmt[l_tmp___8.to_integer_32] := (('%%').code).to_integer_8
						l_tmp___9 := l_len
						l_len := l_len + 1
						l_alloc_fmt[l_tmp___9.to_integer_32] := (('n').code).to_integer_8
						l_alloc_fmt[l_len.to_integer_32] := (('%/0/').code).to_integer_8
						l_new_chars.item := -1
						if not ((l_param.item.ignore).to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_new_fields := (a_funs.item.scan).integer_32_item ([a_data, l_alloc_fmt, l_new_chars, create {CE_VOID_POINTER}.make_shared (default_pointer)])
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 23 then -- else:
						l_arg := (create {CE_VOID_POINTER}.make_cast (l_ap.pointer_item))
						l_new_fields := (a_funs.item.scan).integer_32_item ([a_data, l_alloc_fmt, l_arg, l_new_chars])
						if l_new_fields = 0 then
							l_pos := -1 + 65 -- goto done
						end
				when 24 then
						if l_new_fields = 1 then
						end
				when 25 then -- if done
						if l_new_fields = -1 then
							l_pos := -1 + 6 -- goto eof_no_match
						end
				when 26 then
						if l_new_chars.item = -1 then
							l_pos := -1 + 65 -- goto done
						end
				when 27 then
						l_chars := l_chars + (l_new_chars.item);
						(a_funs.item.step).call ([a_data, l_new_chars.item])
				when 28 then -- increment_fields:
						if not (l_param.item.ignore).to_boolean then
							l_fields := l_fields + 1
						end
						l_pos := -1 + 3 -- goto next
				when 29 then -- switch 1, case 100 | switch 1, case 117
						l_param.item.base := 10
						l_pos := -1 + 30 -- goto numeric
				when 30 then -- numeric: | switch 1, case 101 | switch 1, case 69 | switch 1, case 102 | switch 1, case 103 | switch 1, case 71 | switch 1, case 105
						if (l_param.item.type).to_integer_32 /= 70 then
							if (l_param.item.type).to_integer_32 /= 81 then
								if (l_param.item.type).to_integer_32 /= 90 then
									l_pos := -1 + 20 -- goto libc_type
								end
							end
						end
				when 31 then
						l_chars := l_chars + (a_funs.item.skip_white (a_data))
						if (l_param.item.ignore).to_boolean then
							l_tmp___13 := create {CE_VOID_POINTER}.make_shared (default_pointer)
						else
							l_tmp___13 := (create {CE_VOID_POINTER}.make_cast (l_ap.pointer_item))
						end
						l_new_chars.item := a_funs.item.gmpscan (a_data, l_param, l_tmp___13)
						if l_new_chars.item = -2 then
							l_pos := -1 + 6 -- goto eof_no_match
						end
				when 32 then
						if l_new_chars.item = -1 then
							l_pos := -1 + 65 -- goto done
						end
				when 33 then
						l_chars := l_chars + (l_new_chars.item)
						l_pos := -1 + 28 -- goto increment_fields
				when 34 then -- switch 1, case 97 | switch 1, case 39
						l_pos := -1 + 62 -- switch 1; break
				when 35 then -- set_type: | switch 1, case 70 | switch 1, case 106 | switch 1, case 76 | switch 1, case 113 | switch 1, case 81 | switch 1, case 116 | switch 1, case 122 | switch 1, case 90
						l_param.item.type := l_fchar
						l_pos := -1 + 62 -- switch 1; break
				when 36 then -- switch 1, case 104
						if (l_param.item.type).to_integer_32 /= 104 then
							l_pos := -1 + 35 -- goto set_type
						end
				when 37 then
						l_param.item.type := (('H').code).to_integer_8
						l_pos := -1 + 62 -- switch 1; break
				when 38 then
						l_pos := -1 + 30 -- goto numeric
				when 39 then -- switch 1, case 108
						if (l_param.item.type).to_integer_32 /= 108 then
							l_pos := -1 + 35 -- goto set_type
						end
				when 40 then
						l_param.item.type := (('L').code).to_integer_8
						l_pos := -1 + 62 -- switch 1; break
				when 41 then -- switch 1, case 110
						if (l_param.item.ignore).to_boolean then
							l_pos := -1 + 56 -- skip if block
						end
				when 42 then -- if:
						l_p := (create {CE_VOID_POINTER}.make_cast (l_ap.pointer_item))
						inspect (l_param.item.type).to_integer_32 -- switch 2 head
						when 0 then l_pos := -1 + 43
						when 70 then l_pos := -1 + 44
						when 72 then l_pos := -1 + 45
						when 104 then l_pos := -1 + 46
						when 106 then l_pos := -1 + 47
						when 108 then l_pos := -1 + 48
						when 113 then l_pos := -1 + 49
						when 76 then l_pos := -1 + 50
						when 81 then l_pos := -1 + 51
						when 116 then l_pos := -1 + 52
						when 122 then l_pos := -1 + 53
						when 90 then l_pos := -1 + 54
						else l_pos := -1 + 55
						end
				when 43 then -- switch 2, case 0;
						(create {CE_INTEGER_32_POINTER}.make_cast (l_p)).item := l_chars
						l_pos := -1 + 56 -- switch 2; break
				when 44 then -- switch 2, case 70;
						(create {CE_CLASS_POINTER [PD_MPF_STRUCT]}.make_cast (l_p)).item.gmpf_set_si (l_chars.to_integer_32)
						l_pos := -1 + 56 -- switch 2; break
				when 45 then -- switch 2, case 72;
						(create {CE_INTEGER_8_POINTER}.make_cast (l_p)).item := l_chars.to_integer_8
						l_pos := -1 + 56 -- switch 2; break
				when 46 then -- switch 2, case 104;
						(create {CE_INTEGER_16_POINTER}.make_cast (l_p)).item := l_chars.to_integer_16
						l_pos := -1 + 56 -- switch 2; break
				when 47 then -- switch 2, case 106;
						(create {CE_INTEGER_64_POINTER}.make_cast (l_p)).item := l_chars.to_integer_64
						l_pos := -1 + 56 -- switch 2; break
				when 48 then -- switch 2, case 108;
						(create {CE_INTEGER_32_POINTER}.make_cast (l_p)).item := l_chars.to_integer_32
						l_pos := -1 + 56 -- switch 2; break
				when 49 then -- switch 2, case 113
						from
						until
							(l_break)
						loop
							l_break := False
							if {PLATFORM}.Integer_64_bytes.to_natural_32 /= {PLATFORM}.Integer_64_bytes.to_natural_32 then
								(create {P_ASSERT_STATIC}).gmp_assert_fail (ce_string ("doscan.c"), 705, ce_string ("sizeof (quad_t) == sizeof (long long)"))
							end
							l_break := True
						end
						l_break := False
				when 50 then -- switch 2, case 76;
						(create {CE_INTEGER_64_POINTER}.make_cast (l_p)).item := l_chars.to_integer_64
						l_pos := -1 + 56 -- switch 2; break
				when 51 then -- switch 2, case 81;
						(create {CE_CLASS_POINTER [PD_MPQ_STRUCT]}.make_cast (l_p)).item.gmpq_set_si (l_chars.to_integer_32, {NATURAL_32} 1)
						l_pos := -1 + 56 -- switch 2; break
				when 52 then -- switch 2, case 116;
						(create {CE_INTEGER_32_POINTER}.make_cast (l_p)).item := l_chars
						l_pos := -1 + 56 -- switch 2; break
				when 53 then -- switch 2, case 122;
						(create {CE_NATURAL_32_POINTER}.make_cast (l_p)).item := l_chars.to_natural_32
						l_pos := -1 + 56 -- switch 2; break
				when 54 then -- switch 2, case 90;
						(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_p)).item.gmpz_set_si (l_chars.to_integer_32)
						l_pos := -1 + 56 -- switch 2; break
				when 55 then -- switch 2, default:
						l_pos := -1 + 56 -- switch 2; break
				when 56 then -- switch 2, done: | if done
						l_pos := -1 + 3 -- goto next
				when 57 then -- switch 1, case 111
						l_param.item.base := 8
						l_pos := -1 + 30 -- goto numeric
				when 58 then -- switch 1, case 120 | switch 1, case 88
						l_param.item.base := 16
						l_pos := -1 + 30 -- goto numeric
				when 59 then -- switch 1, case 48 | switch 1, case 49 | switch 1, case 50 | switch 1, case 51 | switch 1, case 52 | switch 1, case 53 | switch 1, case 54 | switch 1, case 55 | switch 1, case 56 | switch 1, case 57
						l_param.item.width := 0
						from
						until
							(l_break)
						loop
							l_break := False
							l_param.item.width := l_param.item.width * 10 + (l_fchar.to_integer_32 - 48)
							l_tmp___14 := l_fmt
							l_fmt := l_fmt + 1
							l_fchar := l_tmp___14[0]
							if not ((((ctype_b_loc).item[l_fchar.to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
								l_break := True
							end
						end
						l_break := False
						l_fmt := l_fmt - 1
						l_pos := -1 + 62 -- switch 1; break
				when 60 then -- switch 1, case 42
						l_param.item.ignore := 1
						l_pos := -1 + 62 -- switch 1; break
				when 61 then -- switch 1, default:
						l_pos := -1 + 3 -- goto next
				when 62 then -- switch 1, done:
						l_pos := -1 + 11 -- back to loop condition
				when 63 then -- loop done | if done
						if (not l_return and not l_break) then
							
						end
						l_pos := -1 + 1 -- back to loop condition
				when 64 then -- loop done
					l_break := False
					l_continue := False
				when 65 then -- done:;
					(create {P_MEMORY_STATIC}).gmp_free_func.item.call ([create {CE_VOID_POINTER}.make_cast (l_alloc_fmt), l_alloc_fmt_size])
					Result := l_fields
				when 66 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
