class
	P_GCD_UI_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_gcd_ui (a_w, a_u: CE_POINTER [PD_MPZ_STRUCT]; a_v: NATURAL_32): NATURAL_32
		require
			not a_u.is_void
		local
			l_un: INTEGER_32
			l_res: NATURAL_32
			l_tmp___0: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_u.item.mp_size >= 0 then
				l_un := (a_u.item.mp_size).to_integer_32
			else
				l_un := (-a_u.item.mp_size).to_integer_32
			end
			if l_un = 0 then
				l_res := a_v
			elseif a_v = {NATURAL_32} 0 then
				if not a_w.is_void then
					if not a_u.is_equal (a_w) then
						if (builtin_expect ((l_un > (a_w.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
							a_w.item.gmpz_realloc (l_un).do_nothing
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (a_w.item.mp_d, a_u.item.mp_d, l_un)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
					end
					a_w.item.mp_size := l_un.to_integer_32
				end
				l_res := a_u.item.mp_d[0]
				if l_un = 1 then
					if l_res <= {NATURAL_32} 4_294_967_295 then
						l_tmp___0 := l_res
					else
						l_tmp___0 := (0).to_natural_32
					end
				else
					l_tmp___0 := (0).to_natural_32
				end
				Result := l_tmp___0
				l_return := True
			else
				l_res := (create {P_GCD_1_STATIC}).gmpn_gcd_1 (a_u.item.mp_d, l_un, a_v)
			end
			if not l_return then
				if not a_w.is_void then
					a_w.item.mp_d[0] := l_res
					a_w.item.mp_size := (l_res /= {NATURAL_32} 0).to_integer
				end
				Result := l_res
			end
		end

end
