class
	P_SBPI1_BDIV_QR_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpn_sbpi1_bdiv_qr (a_qp, a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_dinv: NATURAL_32): NATURAL_32
		require
			not a_qp.is_void
		local
			l_qp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_nn: INTEGER_32
			l_qn: INTEGER_32
			l_i: INTEGER_32
			l_rh: NATURAL_32
			l_ql: NATURAL_32
			l_q: NATURAL_32
			l_q___0: NATURAL_32
			l_cy: NATURAL_32
			l_return: BOOLEAN
		do
			l_qp := a_qp
			l_np := a_np
			l_nn := a_nn
			l_qn := l_nn - a_dn
			l_rh := (0).to_natural_32
			l_ql := (1).to_natural_32
			from
			until
				not (not (l_return) and then (l_qn > a_dn))
			loop
				l_i := (0).to_integer_32
				from
				until
					not (l_i < a_dn)
				loop
					l_q := a_dinv * l_np[l_i]
					l_qp[l_i] := (l_q).bit_not
					l_np[l_i] := (create {P_GMP_STATIC}).gmpn_addmul_1 (l_np + l_i, a_dp, a_dn, l_q)
					l_i := l_i + 1
				end
				l_rh := l_rh + ((create {P_GMP_STATIC}).gmpn_add (l_np + a_dn, (l_np + a_dn), l_qn, l_np, a_dn))
				l_ql := (create {P_GMP_STATIC}).gmpn_add_1 (l_qp, l_qp, a_dn, l_ql)
				l_qp := l_qp + a_dn
				l_qn := l_qn - a_dn
				l_np := l_np + a_dn
				l_nn := l_nn - a_dn
			end
			l_i := (0).to_integer_32
			from
			until
				not (l_i < l_qn)
			loop
				l_q___0 := a_dinv * l_np[l_i]
				l_qp[l_i] := (l_q___0).bit_not
				l_np[l_i] := (create {P_GMP_STATIC}).gmpn_addmul_1 (l_np + l_i, a_dp, a_dn, l_q___0)
				l_i := l_i + 1
			end
			l_rh := l_rh + ((create {P_GMP_STATIC}).gmpn_add_n (l_np + a_dn, (l_np + a_dn), l_np, l_qn))
			l_ql := (create {P_GMP_STATIC}).gmpn_add_1 (l_qp, l_qp, l_qn, l_ql)
			if (builtin_expect ((l_ql > {NATURAL_32} 0).to_integer, 0)).to_boolean then
				Result := (0).to_natural_32
			else
				l_cy := (create {P_GMP_STATIC}).gmpn_sub_n (l_np + l_qn, (l_np + l_qn), a_dp, a_dn)
				Result := (l_cy - l_rh)
			end
		end

end
