class
	P_TOOM42_MUL_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpn_toom42_mul (a_pp, a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		require
			not a_scratch.is_void
		local
			l_n: INTEGER_32
			l_s: INTEGER_32
			l_t: INTEGER_32
			l_vm1_neg: INTEGER_32
			l_cy: NATURAL_32
			l_vinf0: NATURAL_32
			l_a0_a2: CE_POINTER [NATURAL_32]
			l_a1_a3: CE_POINTER [NATURAL_32]
			l_as1: CE_POINTER [NATURAL_32]
			l_asm1: CE_POINTER [NATURAL_32]
			l_as2: CE_POINTER [NATURAL_32]
			l_bs1: CE_POINTER [NATURAL_32]
			l_bsm1: CE_POINTER [NATURAL_32]
			l_bs2: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___12: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			if a_an >= 2 * a_bn then
				l_n := ((a_an + 3)).bit_shift_right (2)
			else
				l_n := ((a_bn + 1)).bit_shift_right (1)
			end
			l_s := a_an - 3 * l_n
			l_t := a_bn - l_n
			l___tmp_marker := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			l_as1 := create {CE_NATURAL_32_POINTER}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			l_asm1 := create {CE_NATURAL_32_POINTER}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			l_as2 := create {CE_NATURAL_32_POINTER}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			l_bs1 := create {CE_NATURAL_32_POINTER}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			l_bsm1 := create {CE_NATURAL_32_POINTER}.make_cast ((l_aaf.new ((l_n.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			l_bs2 := create {CE_NATURAL_32_POINTER}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			l_a0_a2 := a_pp
			l_a1_a3 := (a_pp + l_n) + 1
			l_vm1_neg := (((create {P_TOOM_EVAL_DGR3_PM1_STATIC}).gmpn_toom_eval_dgr3_pm1 (l_as1, l_asm1, a_ap, l_n, l_s, l_a0_a2))).bit_and (1)
			l_cy := (create {P_GMP_STATIC}).gmpn_lshift (l_as2, a_ap + 3 * l_n, l_s, {NATURAL_32} 1)
			l_cy := l_cy + ((create {P_GMP_STATIC}).gmpn_add_n (l_as2, a_ap + 2 * l_n, l_as2, l_s))
			if l_s /= l_n then
				l_cy := (create {P_GMP_STATIC}).gmpn_add_1 (l_as2 + l_s, (a_ap + 2 * l_n) + l_s, l_n - l_s, l_cy)
			end
			l_cy := {NATURAL_32} 2 * l_cy + ((create {P_GMP_STATIC}).gmpn_lshift (l_as2, l_as2, l_n, {NATURAL_32} 1))
			l_cy := l_cy + ((create {P_GMP_STATIC}).gmpn_add_n (l_as2, a_ap + l_n, l_as2, l_n))
			l_cy := {NATURAL_32} 2 * l_cy + ((create {P_GMP_STATIC}).gmpn_lshift (l_as2, l_as2, l_n, {NATURAL_32} 1))
			l_cy := l_cy + ((create {P_GMP_STATIC}).gmpn_add_n (l_as2, a_ap, l_as2, l_n))
			l_as2[l_n] := l_cy
			if l_t = l_n then
				l_bs1[l_n] := (create {P_GMP_STATIC}).gmpn_add_n (l_bs1, a_bp, a_bp + l_n, l_n)
				if ((create {P_GMP_STATIC}).gmpn_cmp (a_bp, a_bp + l_n, l_n)) < 0 then
					(create {P_GMP_STATIC}).gmpn_sub_n (l_bsm1, a_bp + l_n, a_bp, l_n).do_nothing
					l_vm1_neg := (l_vm1_neg).bit_xor ((1))
				else
					(create {P_GMP_STATIC}).gmpn_sub_n (l_bsm1, a_bp, a_bp + l_n, l_n).do_nothing
				end
			else
				l_bs1[l_n] := (create {P_GMP_STATIC}).gmpn_add (l_bs1, a_bp, l_n, a_bp + l_n, l_t)
				if ((create {P_GMP_IMPL_STATIC}).mpn_zero_p (a_bp + l_t, l_n - l_t)).to_boolean then
					if ((create {P_GMP_STATIC}).gmpn_cmp (a_bp, a_bp + l_n, l_t)) < 0 then
						(create {P_GMP_STATIC}).gmpn_sub_n (l_bsm1, a_bp + l_n, a_bp, l_t).do_nothing
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_n - l_t /= 0 then
								l___dst := l_bsm1 + l_t
								l___n := l_n - l_t
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___12 := l___dst
									l___dst := l___dst + 1
									l_tmp___12.item := (0).to_natural_32
									l___n := l___n - 1
									if not l___n.to_boolean then
										l_break := True
									end
								end
								l_break := False
							end
							l_break := True
						end
						l_break := False
						l_vm1_neg := (l_vm1_neg).bit_xor ((1))
					else
						(create {P_GMP_STATIC}).gmpn_sub (l_bsm1, a_bp, l_n, a_bp + l_n, l_t).do_nothing
					end
				else
					(create {P_GMP_STATIC}).gmpn_sub (l_bsm1, a_bp, l_n, a_bp + l_n, l_t).do_nothing
				end
			end
			(create {P_GMP_STATIC}).gmpn_add (l_bs2, l_bs1, l_n + 1, a_bp + l_n, l_t).do_nothing
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_MUL_N_STATIC}).gmpn_mul_n (a_scratch, l_asm1, l_bsm1, l_n)
				l_break := True
			end
			l_break := False
			l_cy := (0).to_natural_32
			if l_asm1[l_n] /= {NATURAL_32} 0 then
				l_cy := (create {P_GMP_STATIC}).gmpn_add_n (a_scratch + l_n, (a_scratch + l_n), l_bsm1, l_n)
			end
			a_scratch[2 * l_n] := l_cy
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_MUL_N_STATIC}).gmpn_mul_n ((a_scratch + 2 * l_n) + 1, l_as2, l_bs2, l_n + 1)
				l_break := True
			end
			l_break := False
			if l_s > l_t then
				(create {P_MUL_STATIC}).gmpn_mul (a_pp + 4 * l_n, a_ap + 3 * l_n, l_s, a_bp + l_n, l_t).do_nothing
			else
				(create {P_MUL_STATIC}).gmpn_mul (a_pp + 4 * l_n, a_bp + l_n, l_t, a_ap + 3 * l_n, l_s).do_nothing
			end
			l_vinf0 := (a_pp + 4 * l_n)[0]
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_MUL_N_STATIC}).gmpn_mul_n (a_pp + 2 * l_n, l_as1, l_bs1, l_n)
				l_break := True
			end
			l_break := False
			if l_as1[l_n] = {NATURAL_32} 1 then
				l_cy := l_bs1[l_n] + ((create {P_GMP_STATIC}).gmpn_add_n ((a_pp + 2 * l_n) + l_n, ((a_pp + 2 * l_n) + l_n), l_bs1, l_n))
			elseif l_as1[l_n] = {NATURAL_32} 2 then
				l_cy := {NATURAL_32} 2 * l_bs1[l_n] + ((create {P_GMP_STATIC}).gmpn_addmul_1 ((a_pp + 2 * l_n) + l_n, l_bs1, l_n, (2).to_natural_32))
			elseif l_as1[l_n] = {NATURAL_32} 3 then
				l_cy := {NATURAL_32} 3 * l_bs1[l_n] + ((create {P_GMP_STATIC}).gmpn_addmul_1 ((a_pp + 2 * l_n) + l_n, l_bs1, l_n, (3).to_natural_32))
			else
				l_cy := (0).to_natural_32
			end
			if l_bs1[l_n] /= {NATURAL_32} 0 then
				l_cy := l_cy + ((create {P_GMP_STATIC}).gmpn_add_n ((a_pp + 2 * l_n) + l_n, ((a_pp + 2 * l_n) + l_n), l_as1, l_n))
			end
			(a_pp + 2 * l_n)[2 * l_n] := l_cy
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_MUL_N_STATIC}).gmpn_mul_n (a_pp, a_ap, a_bp, l_n)
				l_break := True
			end
			l_break := False;
			(create {P_TOOM_INTERPOLATE_5PTS_STATIC}).gmpn_toom_interpolate_5pts (a_pp, (a_scratch + 2 * l_n) + 1, a_scratch, l_n, l_s + l_t, l_vm1_neg, l_vinf0)
			from
			until
				(l_break)
			loop
				l_break := False
				if (builtin_expect ((not l___tmp_marker.is_void).to_integer, 0)).to_boolean then
					(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker)
				end
				l_break := True
			end
			l_break := False
		end

end
