class
	P_TOOM43_MUL_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpn_toom43_mul (a_pp, a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		require
			not a_pp.is_void
			not a_scratch.is_void
		local
			l_n: INTEGER_32
			l_s: INTEGER_32
			l_t: INTEGER_32
			l_flags: NATURAL_32
			l_cy: NATURAL_32
			l_tmp: NATURAL_32
			l_tmp___5: NATURAL_32
		do
			if 3 * a_an >= 4 * a_bn then
				l_tmp := (((a_an - 1)).bit_shift_right (2)).to_natural_32
			else
				l_tmp := (a_bn - 1).to_natural_32 // {NATURAL_32} 3
			end
			l_n := ({NATURAL_32} 1 + l_tmp).to_integer_32
			l_s := a_an - 3 * l_n
			l_t := a_bn - 2 * l_n
			l_flags := ((2).bit_and (((create {P_TOOM_EVAL_DGR3_PM2_STATIC}).gmpn_toom_eval_dgr3_pm2 ((a_pp + 3 * l_n) + 3, (a_scratch + 4 * l_n) + 4, a_ap, l_n, l_s, (a_scratch + 3 * l_n) + 3)))).to_natural_32;
			((a_scratch + 2 * l_n) + 2)[l_n] := (create {P_GMP_STATIC}).gmpn_lshift ((a_scratch + 2 * l_n) + 2, a_bp + l_n, l_n, {NATURAL_32} 1)
			l_cy := (create {P_GMP_STATIC}).gmpn_lshift (a_scratch, a_bp + 2 * l_n, l_t, {NATURAL_32} 2)
			l_cy := l_cy + ((create {P_GMP_STATIC}).gmpn_add_n (a_scratch, a_scratch, a_bp, l_t))
			if l_t /= l_n then
				l_cy := (create {P_GMP_STATIC}).gmpn_add_1 (a_scratch + l_t, a_bp + l_t, l_n - l_t, l_cy)
			end
			a_scratch[l_n] := l_cy;
			(create {P_GMP_STATIC}).gmpn_add_n ((a_pp + 2 * l_n) + 2, a_scratch, ((a_scratch + 2 * l_n) + 2), l_n + 1).do_nothing
			if ((create {P_GMP_STATIC}).gmpn_cmp (a_scratch, ((a_scratch + 2 * l_n) + 2), l_n + 1)) < 0 then
				(create {P_GMP_STATIC}).gmpn_sub_n ((a_pp + l_n) + 1, ((a_scratch + 2 * l_n) + 2), a_scratch, l_n + 1).do_nothing
				l_flags := ((l_flags).bit_xor ({NATURAL_32} 2))
			else
				(create {P_GMP_STATIC}).gmpn_sub_n ((a_pp + l_n) + 1, a_scratch, ((a_scratch + 2 * l_n) + 2), l_n + 1).do_nothing
			end
			l_flags := ((l_flags).bit_xor (((1).bit_and (((create {P_TOOM_EVAL_DGR3_PM1_STATIC}).gmpn_toom_eval_dgr3_pm1 ((a_pp + 4 * l_n) + 4, (a_scratch + 3 * l_n) + 3, a_ap, l_n, l_s, a_scratch)))).to_natural_32));
			((a_scratch + 2 * l_n) + 2)[l_n] := (create {P_GMP_STATIC}).gmpn_add ((a_scratch + 2 * l_n) + 2, a_bp, l_n, a_bp + 2 * l_n, l_t)
			a_pp[l_n] := ((a_scratch + 2 * l_n) + 2)[l_n] + ((create {P_GMP_STATIC}).gmpn_add_n (a_pp, ((a_scratch + 2 * l_n) + 2), a_bp + l_n, l_n))
			if ((a_scratch + 2 * l_n) + 2)[l_n] = {NATURAL_32} 0 then
				if ((create {P_GMP_STATIC}).gmpn_cmp (((a_scratch + 2 * l_n) + 2), a_bp + l_n, l_n)) < 0 then
					(create {P_GMP_STATIC}).gmpn_sub_n ((a_scratch + 2 * l_n) + 2, a_bp + l_n, ((a_scratch + 2 * l_n) + 2), l_n).do_nothing
					l_flags := ((l_flags).bit_xor ({NATURAL_32} 1))
				else
					l_tmp___5 := (create {P_GMP_STATIC}).gmpn_sub_n ((a_scratch + 2 * l_n) + 2, ((a_scratch + 2 * l_n) + 2), a_bp + l_n, l_n);
					((a_scratch + 2 * l_n) + 2)[l_n] := ((a_scratch + 2 * l_n) + 2)[l_n] - l_tmp___5
				end
			else
				l_tmp___5 := (create {P_GMP_STATIC}).gmpn_sub_n ((a_scratch + 2 * l_n) + 2, ((a_scratch + 2 * l_n) + 2), a_bp + l_n, l_n);
				((a_scratch + 2 * l_n) + 2)[l_n] := ((a_scratch + 2 * l_n) + 2)[l_n] - l_tmp___5
			end
			(create {P_MUL_N_STATIC}).gmpn_mul_n (a_scratch, ((a_scratch + 3 * l_n) + 3), ((a_scratch + 2 * l_n) + 2), l_n + 1);
			(create {P_MUL_N_STATIC}).gmpn_mul_n ((a_scratch + 2 * l_n) + 1, ((a_scratch + 4 * l_n) + 4), ((a_pp + l_n) + 1), l_n + 1);
			(create {P_MUL_N_STATIC}).gmpn_mul_n ((a_scratch + 4 * l_n) + 2, ((a_pp + 3 * l_n) + 3), ((a_pp + 2 * l_n) + 2), l_n + 1);
			(create {P_MUL_N_STATIC}).gmpn_mul_n (a_pp + 2 * l_n, ((a_pp + 4 * l_n) + 4), a_pp, l_n + 1)
			if l_s > l_t then
				(create {P_MUL_STATIC}).gmpn_mul (a_pp + 5 * l_n, a_ap + 3 * l_n, l_s, a_bp + 2 * l_n, l_t).do_nothing
			else
				(create {P_MUL_STATIC}).gmpn_mul (a_pp + 5 * l_n, a_bp + 2 * l_n, l_t, a_ap + 3 * l_n, l_s).do_nothing
			end
			(create {P_MUL_N_STATIC}).gmpn_mul_n (a_pp, a_ap, a_bp, l_n);
			(create {P_TOOM_INTERPOLATE_6PTS_STATIC}).gmpn_toom_interpolate_6pts (a_pp, l_n, l_flags, a_scratch, (a_scratch + 2 * l_n) + 1, (a_scratch + 4 * l_n) + 2, l_t + l_s)
		end

end
