class
	P_TOOM_EVAL_PM1_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpn_toom_eval_pm1 (a_xp1, a_xm1: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_xp: CE_POINTER [NATURAL_32]; a_n, a_hn: INTEGER_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		require
			not a_xp1.is_void
			not a_tp.is_void
		local
			l_i: NATURAL_32
			l_neg: INTEGER_32
		do
			a_xp1[a_n] := (create {P_GMP_STATIC}).gmpn_add_n (a_xp1, a_xp, a_xp + 2 * a_n, a_n)
			l_i := {NATURAL_32} 4
			from
			until
				not (l_i < a_k)
			loop
				(create {P_GMP_STATIC}).gmpn_add (a_xp1, a_xp1, a_n + 1, a_xp + (l_i.to_natural_32 * a_n.to_natural_32).to_integer_32, a_n).do_nothing
				l_i := l_i + ({NATURAL_32} 2)
			end
			a_tp[a_n] := (create {P_GMP_STATIC}).gmpn_add_n (a_tp, a_xp + a_n, a_xp + 3 * a_n, a_n)
			l_i := {NATURAL_32} 5
			from
			until
				not (l_i < a_k)
			loop
				(create {P_GMP_STATIC}).gmpn_add (a_tp, a_tp, a_n + 1, a_xp + (l_i.to_natural_32 * a_n.to_natural_32).to_integer_32, a_n).do_nothing
				l_i := l_i + ({NATURAL_32} 2)
			end
			if ((a_k).bit_and ({NATURAL_32} 1)).to_boolean then
				(create {P_GMP_STATIC}).gmpn_add (a_tp, a_tp, a_n + 1, a_xp + (a_k.to_natural_32 * a_n.to_natural_32).to_integer_32, a_hn).do_nothing
			else
				(create {P_GMP_STATIC}).gmpn_add (a_xp1, a_xp1, a_n + 1, a_xp + (a_k.to_natural_32 * a_n.to_natural_32).to_integer_32, a_hn).do_nothing
			end
			if ((create {P_GMP_STATIC}).gmpn_cmp (a_xp1, a_tp, a_n + 1)) < 0 then
				l_neg := (0).bit_not
			else
				l_neg := 0
			end
			if l_neg.to_boolean then
				(create {P_GMP_STATIC}).gmpn_sub_n (a_xm1, a_tp, a_xp1, a_n + 1).do_nothing
			else
				(create {P_GMP_STATIC}).gmpn_sub_n (a_xm1, a_xp1, a_tp, a_n + 1).do_nothing
			end
			(create {P_GMP_STATIC}).gmpn_add_n (a_xp1, a_xp1, a_tp, a_n + 1).do_nothing
			Result := l_neg
		end

end
