class
	P_XNOR_N_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpn_xnor_n (a_rp, a_up, a_vp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32)
		require
			not a_rp.is_void
			not a_up.is_void
			not a_vp.is_void
		local
			l___up: CE_POINTER [NATURAL_32]
			l___vp: CE_POINTER [NATURAL_32]
			l___rp: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l___a: NATURAL_32
			l___b: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l___up := a_up
				l___vp := a_vp
				l___rp := a_rp
				l___n := a_n
				l___up := l___up + l___n
				l___vp := l___vp + l___n
				l___rp := l___rp + l___n
				l___n := -l___n
				from
				until
					(l_break)
				loop
					l_break := False
					l___a := l___up[l___n]
					l___b := l___vp[l___n]
					l___rp[l___n] := ((((l___a).bit_xor (l___b))).bit_not).bit_and ({NATURAL_32} 4_294_967_295)
					l___n := l___n + 1
					if not l___n.to_boolean then
						l_break := True
					end
				end
				l_break := False
				l_break := True
			end
			l_break := False
		end

end
