class
	P_BOROSH13_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	ran_type___0: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("borosh13"), {NATURAL_32} 4_294_967_295, {NATURAL_32} 1, (create {PD_RAN_STATE_T}.make).structure_size.to_natural_32, ran_set___0_address, ran_get___0_address, ran_get_double___0_address])
				>>)
		end

	gsl_rng_borosh13: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := ran_type___0.item
		end

feature {ANY} -- public routines

	ran_get___0 (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RAN_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate)
			l_state.item.x := ({NATURAL_32} 1_812_433_253 * l_state.item.x).bit_and ({NATURAL_32} 4_294_967_295)
			Result := (l_state.item.x)
		end

	ran_get_double___0 (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_state: CE_POINTER [PD_RAN_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate)
			Result := ((ran_get___0 (create {CE_VOID_POINTER}.make_cast (l_state))).to_real_64 / 4294967296.0)
		end

	ran_set___0 (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RAN_STATE_T]
		do
			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.x := (l_s).bit_and ({NATURAL_32} 4_294_967_295)
		end

feature {ANY} -- routine addresses

	ran_get___0_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran_get___0)
		end

	ran_get_double___0_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran_get_double___0)
		end

	ran_set___0_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran_set___0)
		end

end
