class
	P_DTBSV_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	cblas_dtbsv (a_order, a_Uplo, a_TransA, a_Diag: NATURAL_32; a_N, a_K: INTEGER_32; a_A___0: CE_POINTER [REAL_64]; a_lda: INTEGER_32; a_X: CE_POINTER [REAL_64]; a_incX: INTEGER_32)
		local
			l_nonunit: INTEGER_32
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_Trans: INTEGER_32
			l_tmp: NATURAL_32
			l_ix: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: REAL_64
			l_j_min: INTEGER_32
			l_j_max: INTEGER_32
			l_tmp___2: INTEGER_32
			l_jx: INTEGER_32
			l_tmp___3: INTEGER_32
			l_Aij: REAL_64
			l_tmp___4: INTEGER_32
			l_ix___0: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: REAL_64
			l_j_min___0: INTEGER_32
			l_tmp___7: INTEGER_32
			l_j_max___0: INTEGER_32
			l_jx___0: INTEGER_32
			l_tmp___8: INTEGER_32
			l_Aij___0: REAL_64
			l_ix___1: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: REAL_64
			l_j_min___1: INTEGER_32
			l_tmp___11: INTEGER_32
			l_j_max___1: INTEGER_32
			l_jx___1: INTEGER_32
			l_tmp___12: INTEGER_32
			l_Aji: REAL_64
			l_ix___2: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: REAL_64
			l_j_min___2: INTEGER_32
			l_j_max___2: INTEGER_32
			l_tmp___15: INTEGER_32
			l_jx___2: INTEGER_32
			l_tmp___16: INTEGER_32
			l_Aji___0: REAL_64
			l_tmp___17: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_nonunit := (a_Diag = {NATURAL_32} 131).to_integer
					if a_TransA /= {NATURAL_32} 113 then
						l_tmp := a_TransA
					else
						l_tmp := {NATURAL_32} 112
					end
					l_Trans := l_tmp.to_integer_32
					if a_N = 0 then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 50 -- skip if block
					end
				when 1 then -- if:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_Trans = 111 then
							if a_Uplo = {NATURAL_32} 121 then
								l_pos := -1 + 7 -- goto _L___12
							else
								l_pos := -1 + 4 -- goto _L___16
							end
						else
							l_pos := -1 + 4 -- goto _L___16
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 4 then -- else: | _L___16:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 13 -- skip if block
						end
				when 5 then -- if:
						if l_Trans /= 112 then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if:
						if a_Uplo /= {NATURAL_32} 122 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___12:
						if a_incX > 0 then
							l_tmp___0 := 0
						else
							l_tmp___0 := (a_N - 1) * -a_incX
						end
						l_ix := l_tmp___0 + a_incX * (a_N - 1)
						l_i := a_N
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_i > 0 then
								l_tmp___4 := l_i
								l_i := l_i - 1
								if not l_tmp___4.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_tmp___1 := a_X[l_ix]
								l_j_min := l_i + 1
								if a_N < (l_i + a_K) + 1 then
									l_tmp___2 := a_N
								else
									l_tmp___2 := (l_i + a_K) + 1
								end
								l_j_max := l_tmp___2
								if a_incX > 0 then
									l_tmp___3 := 0
								else
									l_tmp___3 := (a_N - 1) * -a_incX
								end
								l_jx := l_tmp___3 + l_j_min * a_incX
								l_j := l_j_min
								from
								until
									not (l_j < l_j_max)
								loop
									l_Aij := a_A___0[(a_lda * l_i + (l_j - l_i))]
									l_tmp___1 := l_tmp___1 - (l_Aij * a_X[l_jx])
									l_jx := l_jx + a_incX
									l_j := l_j + 1
								end
								if l_nonunit.to_boolean then
									a_X[l_ix] := l_tmp___1 / a_A___0[a_lda * l_i]
								else
									a_X[l_ix] := l_tmp___1
								end
								l_ix := l_ix - a_incX
							end
						end
						l_break := False
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_pos := -1 + 13 -- goto _L___14
				when 10 then -- if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_pos := -1 + 13 -- goto _L___14
				when 12 then -- if done | if block done, skip else block:
						l_pos := -1 + 50
				when 13 then -- else: | _L___14:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if l_Trans = 111 then
							if a_Uplo = {NATURAL_32} 122 then
								l_pos := -1 + 19 -- goto _L___7
							else
								l_pos := -1 + 16 -- goto _L___11
							end
						else
							l_pos := -1 + 16 -- goto _L___11
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 16 then -- else: | _L___11:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 25 -- skip if block
						end
				when 17 then -- if:
						if l_Trans /= 112 then
							l_pos := -1 + 23 -- skip if block
						end
				when 18 then -- if:
						if a_Uplo /= {NATURAL_32} 121 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if: | _L___7:
						if a_incX > 0 then
							l_tmp___5 := 0
						else
							l_tmp___5 := (a_N - 1) * -a_incX
						end
						l_ix___0 := l_tmp___5
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < a_N))
						loop
							l_tmp___6 := a_X[l_ix___0]
							if l_i > a_K then
								l_tmp___7 := l_i - a_K
							else
								l_tmp___7 := 0
							end
							l_j_min___0 := l_tmp___7
							l_j_max___0 := l_i
							if a_incX > 0 then
								l_tmp___8 := 0
							else
								l_tmp___8 := (a_N - 1) * -a_incX
							end
							l_jx___0 := l_tmp___8 + l_j_min___0 * a_incX
							l_j := l_j_min___0
							from
							until
								not (l_j < l_j_max___0)
							loop
								l_Aij___0 := a_A___0[(a_lda * l_i + ((a_K + l_j) - l_i))]
								l_tmp___6 := l_tmp___6 - (l_Aij___0 * a_X[l_jx___0])
								l_jx___0 := l_jx___0 + a_incX
								l_j := l_j + 1
							end
							if l_nonunit.to_boolean then
								a_X[l_ix___0] := l_tmp___6 / a_A___0[(a_lda * l_i + a_K)]
							else
								a_X[l_ix___0] := l_tmp___6
							end
							l_ix___0 := l_ix___0 + a_incX
							l_i := l_i + 1
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:
						l_pos := -1 + 25 -- goto _L___9
				when 22 then -- if done | if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else:
						l_pos := -1 + 25 -- goto _L___9
				when 24 then -- if done | if block done, skip else block:
						l_pos := -1 + 50
				when 25 then -- else: | _L___9:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						if l_Trans = 112 then
							if a_Uplo = {NATURAL_32} 121 then
								l_pos := -1 + 31 -- goto _L___2
							else
								l_pos := -1 + 28 -- goto _L___6
							end
						else
							l_pos := -1 + 28 -- goto _L___6
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 28 then -- else: | _L___6:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 37 -- skip if block
						end
				when 29 then -- if:
						if l_Trans /= 111 then
							l_pos := -1 + 35 -- skip if block
						end
				when 30 then -- if:
						if a_Uplo /= {NATURAL_32} 122 then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if: | _L___2:
						if a_incX > 0 then
							l_tmp___9 := 0
						else
							l_tmp___9 := (a_N - 1) * -a_incX
						end
						l_ix___1 := l_tmp___9
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < a_N))
						loop
							l_tmp___10 := a_X[l_ix___1]
							if a_K > l_i then
								l_tmp___11 := 0
							else
								l_tmp___11 := l_i - a_K
							end
							l_j_min___1 := l_tmp___11
							l_j_max___1 := l_i
							if a_incX > 0 then
								l_tmp___12 := 0
							else
								l_tmp___12 := (a_N - 1) * -a_incX
							end
							l_jx___1 := l_tmp___12 + l_j_min___1 * a_incX
							l_j := l_j_min___1
							from
							until
								not (l_j < l_j_max___1)
							loop
								l_Aji := a_A___0[((l_i - l_j) + a_lda * l_j)]
								l_tmp___10 := l_tmp___10 - (l_Aji * a_X[l_jx___1])
								l_jx___1 := l_jx___1 + a_incX
								l_j := l_j + 1
							end
							if l_nonunit.to_boolean then
								a_X[l_ix___1] := l_tmp___10 / a_A___0[a_lda * l_i]
							else
								a_X[l_ix___1] := l_tmp___10
							end
							l_ix___1 := l_ix___1 + a_incX
							l_i := l_i + 1
						end
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 33 then -- else:
						l_pos := -1 + 37 -- goto _L___4
				when 34 then -- if done | if block done, skip else block:
						l_pos := -1 + 36
				when 35 then -- else:
						l_pos := -1 + 37 -- goto _L___4
				when 36 then -- if done | if block done, skip else block:
						l_pos := -1 + 50
				when 37 then -- else: | _L___4:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						if l_Trans = 112 then
							if a_Uplo = {NATURAL_32} 122 then
								l_pos := -1 + 43 -- goto _L
							else
								l_pos := -1 + 40 -- goto _L___1
							end
						else
							l_pos := -1 + 40 -- goto _L___1
						end
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 40 then -- else: | _L___1:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 49 -- skip if block
						end
				when 41 then -- if:
						if l_Trans /= 111 then
							l_pos := -1 + 47 -- skip if block
						end
				when 42 then -- if:
						if a_Uplo /= {NATURAL_32} 121 then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if: | _L:
						if a_incX > 0 then
							l_tmp___13 := 0
						else
							l_tmp___13 := (a_N - 1) * -a_incX
						end
						l_ix___2 := l_tmp___13 + (a_N - 1) * a_incX
						l_i := a_N
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_i > 0 then
								l_tmp___17 := l_i
								l_i := l_i - 1
								if not l_tmp___17.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_tmp___14 := a_X[l_ix___2]
								l_j_min___2 := l_i + 1
								if a_N < (l_i + a_K) + 1 then
									l_tmp___15 := a_N
								else
									l_tmp___15 := (l_i + a_K) + 1
								end
								l_j_max___2 := l_tmp___15
								if a_incX > 0 then
									l_tmp___16 := 0
								else
									l_tmp___16 := (a_N - 1) * -a_incX
								end
								l_jx___2 := l_tmp___16 + l_j_min___2 * a_incX
								l_j := l_j_min___2
								from
								until
									not (l_j < l_j_max___2)
								loop
									l_Aji___0 := a_A___0[(((a_K + l_i) - l_j) + a_lda * l_j)]
									l_tmp___14 := l_tmp___14 - (l_Aji___0 * a_X[l_jx___2])
									l_jx___2 := l_jx___2 + a_incX
									l_j := l_j + 1
								end
								if l_nonunit.to_boolean then
									a_X[l_ix___2] := l_tmp___14 / a_A___0[(a_K + a_lda * l_i)]
								else
									a_X[l_ix___2] := l_tmp___14
								end
								l_ix___2 := l_ix___2 - a_incX
							end
						end
						l_break := False
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 45 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_tbsv_r.h"), ce_string ("unrecognized operation")])
				when 46 then -- if done | if block done, skip else block:
						l_pos := -1 + 48
				when 47 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_tbsv_r.h"), ce_string ("unrecognized operation")])
				when 48 then -- if done | if block done, skip else block:
						l_pos := -1 + 50
				when 49 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_tbsv_r.h"), ce_string ("unrecognized operation")])
				when 50 then -- if done | if done | if done | if done | if done | if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
