class
	P_GOLDEN_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	goldensection_type: CE_STATIC [CE_ARRAY [PD_GSL_MIN_FMINIMIZER_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_MIN_FMINIMIZER_TYPE]}.make_initialized (<<
					create {PD_GSL_MIN_FMINIMIZER_TYPE}.make_initialized ([ce_string ("goldensection"), (create {PD_GOLDENSECTION_STATE_T}.make).structure_size.to_natural_32, goldensection_init_address, (create {PD_GSL_FUNCTION_STRUCT_STATIC}).goldensection_iterate_address])
				>>)
		end

	gsl_min_fminimizer_goldensection: CE_STATIC [CE_POINTER [PD_GSL_MIN_FMINIMIZER_TYPE]]
		once ("PROCESS")
			Result.item := goldensection_type.item
		end

feature {ANY} -- public routines

	goldensection_init (a_vstate: CE_POINTER [ANY]; a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_x_minimum, a_f_minimum, a_x_lower, a_f_lower, a_x_upper, a_f_upper: REAL_64): INTEGER_32
		local
			l_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]
			l_x_minimum: REAL_64
			l_f_minimum: REAL_64
			l_x_lower: REAL_64
			l_f_lower: REAL_64
			l_x_upper: REAL_64
			l_f_upper: REAL_64
			l_state: CE_POINTER [PD_GOLDENSECTION_STATE_T]
		do
			l_f := a_f
			l_x_minimum := a_x_minimum
			l_f_minimum := a_f_minimum
			l_x_lower := a_x_lower
			l_f_lower := a_f_lower
			l_x_upper := a_x_upper
			l_f_upper := a_f_upper
			l_state := create {CE_CLASS_POINTER [PD_GOLDENSECTION_STATE_T]}.make_cast (a_vstate)
			l_state := create {CE_CLASS_POINTER [PD_GOLDENSECTION_STATE_T]}.make_shared (default_pointer)
			l_f := create {CE_CLASS_POINTER [PD_GSL_FUNCTION_STRUCT]}.make_shared (default_pointer)
			l_x_minimum := (0).to_double
			l_f_minimum := (0).to_double
			l_x_lower := (0).to_double
			l_f_lower := (0).to_double
			l_x_upper := (0).to_double
			l_f_upper := (0).to_double
			Result := 0
		end

feature {ANY} -- routine addresses

	goldensection_init_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent goldensection_init)
		end

end
