class
	P_HYPERG_U_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gsl_sf_hyperg_U_int_e (a_a___5, a_b___0: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		require
			not a_result.is_void
		local
			l_re: CE_ARRAY [PD_GSL_SF_RESULT_E10_STRUCT]
			l_stat_U: INTEGER_32
			l_stat_c: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_E10_STRUCT]} l_re.make (<<1>>)

			l_stat_U := (l_re.item.gsl_sf_hyperg_U_int_e10_e (a_a___5, a_b___0, a_x))
			l_stat_c := (l_re.item.gsl_sf_result_smash_e (a_result))
			if l_stat_c /= 0 then
				l_tmp___2 := l_stat_c
			else
				if l_stat_U /= 0 then
					l_tmp___1 := l_stat_U
				else
					l_tmp___1 := 0
				end
				l_tmp___2 := l_tmp___1
			end
			Result := l_tmp___2
		end

	gsl_sf_hyperg_U_e (a_a___5, a_b___0, a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		require
			not a_result.is_void
		local
			l_re: CE_ARRAY [PD_GSL_SF_RESULT_E10_STRUCT]
			l_stat_U: INTEGER_32
			l_stat_c: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_E10_STRUCT]} l_re.make (<<1>>)

			l_stat_U := (l_re.item.gsl_sf_hyperg_U_e10_e (a_a___5, a_b___0, a_x))
			l_stat_c := (l_re.item.gsl_sf_result_smash_e (a_result))
			if l_stat_c /= 0 then
				l_tmp___2 := l_stat_c
			else
				if l_stat_U /= 0 then
					l_tmp___1 := l_stat_U
				else
					l_tmp___1 := 0
				end
				l_tmp___2 := l_tmp___1
			end
			Result := l_tmp___2
		end

	gsl_sf_hyperg_U_int (a_a___5, a_b___0: INTEGER_32; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (gsl_sf_hyperg_U_int_e (a_a___5, a_b___0, a_x, l_result))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_hyperg_U_int_e(a, b, x, &result)"), ce_string ("hyperg_U.c"), 1_740, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_hyperg_U (a_a___5, a_b___0, a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (gsl_sf_hyperg_U_e (a_a___5, a_b___0, a_x, l_result))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_hyperg_U_e(a, b, x, &result)"), ce_string ("hyperg_U.c"), 1_745, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

end
