class
	P_LOGARITHMIC_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_ran_logarithmic_pdf (a_k: NATURAL_32; a_p: REAL_64): REAL_64
		local
			l_P___2: REAL_64
			l_tmp: REAL_64
		do
			if a_k = {NATURAL_32} 0 then
				Result := (0).to_double
			else
				l_tmp := pow (a_p, a_k.to_real_64)
				l_P___2 := (l_tmp / a_k.to_real_64) / (log ((1).to_double / ((1).to_double - a_p)))
				Result := l_P___2
			end
		end

end
