class
	P_LQ_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gsl_linalg_LQ_LQsolve (a_Q___1, a_L: CE_POINTER [PD_GSL_MATRIX]; a_b___0, a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		require
			not a_L.is_void
		local
			l_N: NATURAL_32
			l_M: NATURAL_32
		do
			l_N := a_L.item.size1
			l_M := a_L.item.size2
			if l_M /= l_N then
				Result := 20
			elseif a_Q___1.item.size1 /= l_M then
				Result := 19
			elseif a_b___0.item.size /= l_M then
				Result := 19
			elseif a_x.item.size /= l_M then
				Result := 19
			else
				a_Q___1.item.gsl_blas_dgemv ({PC_CBLAS_TRANSPOSE}.CblasNoTrans, 1.0, a_b___0, 0.0, a_x).do_nothing
				a_L.item.gsl_blas_dtrsv ({PC_CBLAS_UPLO}.CblasLower, {PC_CBLAS_TRANSPOSE}.CblasTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_x).do_nothing
				Result := 0
			end
		end

end
