class
	P_MINSTD_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	m___2: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (2_147_483_647).to_integer_32
		end

	a___3: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (16_807).to_integer_32
		end

	q___2: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (127_773).to_integer_32
		end

	r___2: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (2_836).to_integer_32
		end

	minstd_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("minstd"), {NATURAL_32} 2_147_483_646, {NATURAL_32} 1, (create {PD_MINSTD_STATE_T}.make).structure_size.to_natural_32, minstd_set_address, minstd_get_address, minstd_get_double_address])
				>>)
		end

	gsl_rng_minstd: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := minstd_type.item
		end

feature {ANY} -- public routines

	minstd_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_MINSTD_STATE_T]
			l_x: NATURAL_32
			l_h: INTEGER_32
			l_t: INTEGER_32
		do
			l_state := create {CE_CLASS_POINTER [PD_MINSTD_STATE_T]}.make_cast (a_vstate)
			l_x := l_state.item.x
			l_h := (l_x // q___2.item.to_natural_32).to_integer_32
			l_t := (a___3.item.to_natural_32 * (l_x - (l_h * q___2.item).to_natural_32) - (l_h * r___2.item).to_natural_32).to_integer_32
			if l_t < 0 then
				l_state.item.x := (l_t + m___2.item).to_natural_32
			else
				l_state.item.x := l_t.to_natural_32
			end
			Result := (l_state.item.x)
		end

	minstd_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((minstd_get (a_vstate)).to_real_64 / 2147483647.0)
		end

	minstd_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_MINSTD_STATE_T]
		do
			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_MINSTD_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.x := l_s
		end

feature {ANY} -- routine addresses

	minstd_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent minstd_get)
		end

	minstd_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent minstd_get_double)
		end

	minstd_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent minstd_set)
		end

end
