class
	P_SCHRAGE_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	schrage (a_a___5, a_b___0, a_m___4: NATURAL_32): NATURAL_32
		local
			l_q___3: NATURAL_32
			l_t: NATURAL_32
			l_tmp: NATURAL_32
			l_return: BOOLEAN
		do
			if a_a___5 = {NATURAL_32} 0 then
				Result := {NATURAL_32} 0
				l_return := True
			end
			if not l_return then
				l_q___3 := a_m___4 // a_a___5
				l_t := {NATURAL_32} 2 * a_m___4 - (a_m___4 \\ a_a___5) * (a_b___0 // l_q___3)
				if l_t >= a_m___4 then
					l_t := l_t - a_m___4
				end
				l_t := l_t + (a_a___5 * (a_b___0 \\ l_q___3))
				if l_t >= a_m___4 then
					l_tmp := l_t - a_m___4
				else
					l_tmp := l_t
				end
				Result := l_tmp
			end
		end

	schrage_mult (a_a___5, a_b___0, a_m___4, a_sqrtm: NATURAL_32): NATURAL_32
		local
			l_t0: NATURAL_32
			l_t1: NATURAL_32
			l_t2: NATURAL_32
			l_t: NATURAL_32
			l_tmp___2: NATURAL_32
		do
			l_t0 := (schrage (a_sqrtm, a_b___0, a_m___4))
			l_t1 := (schrage (a_a___5 // a_sqrtm, l_t0, a_m___4))
			l_t2 := (schrage (a_a___5 \\ a_sqrtm, a_b___0, a_m___4))
			l_t := l_t1 + l_t2
			if l_t >= a_m___4 then
				l_tmp___2 := l_t - a_m___4
			else
				l_tmp___2 := l_t
			end
			Result := l_tmp___2
		end

end
