class
	P_ZTPSV_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	cblas_ztpsv (a_order, a_Uplo, a_TransA, a_Diag: NATURAL_32; a_N: INTEGER_32; a_Ap, a_X: CE_POINTER [ANY]; a_incX: INTEGER_32)
		local
			l_conj: INTEGER_32
			l_tmp: INTEGER_32
			l_Trans: INTEGER_32
			l_tmp___0: NATURAL_32
			l_nonunit: INTEGER_32
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_ix: INTEGER_32
			l_tmp___1: INTEGER_32
			l_a_real: REAL_64
			l_a_imag: REAL_64
			l_x_real: REAL_64
			l_x_imag: REAL_64
			l_s: REAL_64
			l_b_real: REAL_64
			l_b_imag: REAL_64
			l_tmp_real: REAL_64
			l_tmp_imag: REAL_64
			l_jx: INTEGER_32
			l_Aij_real: REAL_64
			l_Aij_imag: REAL_64
			l_x_real___0: REAL_64
			l_x_imag___0: REAL_64
			l_a_real___0: REAL_64
			l_a_imag___0: REAL_64
			l_s___0: REAL_64
			l_b_real___0: REAL_64
			l_b_imag___0: REAL_64
			l_tmp___4: INTEGER_32
			l_ix___0: INTEGER_32
			l_tmp___5: INTEGER_32
			l_a_real___1: REAL_64
			l_a_imag___1: REAL_64
			l_x_real___1: REAL_64
			l_x_imag___1: REAL_64
			l_s___1: REAL_64
			l_b_real___1: REAL_64
			l_b_imag___1: REAL_64
			l_tmp_real___0: REAL_64
			l_tmp_imag___0: REAL_64
			l_jx___0: INTEGER_32
			l_tmp___7: INTEGER_32
			l_Aij_real___0: REAL_64
			l_Aij_imag___0: REAL_64
			l_x_real___2: REAL_64
			l_x_imag___2: REAL_64
			l_a_real___2: REAL_64
			l_a_imag___2: REAL_64
			l_s___2: REAL_64
			l_b_real___2: REAL_64
			l_b_imag___2: REAL_64
			l_ix___1: INTEGER_32
			l_tmp___9: INTEGER_32
			l_a_real___3: REAL_64
			l_a_imag___3: REAL_64
			l_x_real___3: REAL_64
			l_x_imag___3: REAL_64
			l_s___3: REAL_64
			l_b_real___3: REAL_64
			l_b_imag___3: REAL_64
			l_tmp_real___1: REAL_64
			l_tmp_imag___1: REAL_64
			l_jx___1: INTEGER_32
			l_tmp___11: INTEGER_32
			l_Aij_real___1: REAL_64
			l_Aij_imag___1: REAL_64
			l_x_real___4: REAL_64
			l_x_imag___4: REAL_64
			l_a_real___4: REAL_64
			l_a_imag___4: REAL_64
			l_s___4: REAL_64
			l_b_real___4: REAL_64
			l_b_imag___4: REAL_64
			l_ix___2: INTEGER_32
			l_tmp___13: INTEGER_32
			l_a_real___5: REAL_64
			l_a_imag___5: REAL_64
			l_x_real___5: REAL_64
			l_x_imag___5: REAL_64
			l_s___5: REAL_64
			l_b_real___5: REAL_64
			l_b_imag___5: REAL_64
			l_tmp_real___2: REAL_64
			l_tmp_imag___2: REAL_64
			l_jx___2: INTEGER_32
			l_Aij_real___2: REAL_64
			l_Aij_imag___2: REAL_64
			l_x_real___6: REAL_64
			l_x_imag___6: REAL_64
			l_a_real___6: REAL_64
			l_a_imag___6: REAL_64
			l_s___6: REAL_64
			l_b_real___6: REAL_64
			l_b_imag___6: REAL_64
			l_tmp___16: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_TransA = {NATURAL_32} 113 then
						l_tmp := -1
					else
						l_tmp := 1
					end
					l_conj := l_tmp
					if a_TransA /= {NATURAL_32} 113 then
						l_tmp___0 := a_TransA
					else
						l_tmp___0 := {NATURAL_32} 112
					end
					l_Trans := l_tmp___0.to_integer_32
					l_nonunit := (a_Diag = {NATURAL_32} 131).to_integer
					if a_N = 0 then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 50 -- skip if block
					end
				when 1 then -- if:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_Trans = 111 then
							if a_Uplo = {NATURAL_32} 121 then
								l_pos := -1 + 7 -- goto _L___12
							else
								l_pos := -1 + 4 -- goto _L___16
							end
						else
							l_pos := -1 + 4 -- goto _L___16
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 4 then -- else: | _L___16:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 13 -- skip if block
						end
				when 5 then -- if:
						if l_Trans /= 112 then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if:
						if a_Uplo /= {NATURAL_32} 122 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___12:
						if a_incX > 0 then
							l_tmp___1 := 0
						else
							l_tmp___1 := (a_N - 1) * -a_incX
						end
						l_ix := l_tmp___1 + a_incX * (a_N - 1)
						if l_nonunit.to_boolean then
							l_a_real := create {CE_REAL_64_POINTER}.make_cast (a_Ap)[2 * ((((((a_N - 1) - 1) + 1) * (2 * a_N - ((a_N - 1) - 1))) // 2 + (a_N - 1)) - (a_N - 1))]
							l_a_imag := (l_conj.to_double * create {CE_REAL_64_POINTER}.make_cast (a_Ap)[(2 * ((((((a_N - 1) - 1) + 1) * (2 * a_N - ((a_N - 1) - 1))) // 2 + (a_N - 1)) - (a_N - 1)) + 1)])
							l_x_real := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix]
							l_x_imag := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
							l_s := ((create {P_HYPOT_STATIC}).xhypot___4 (l_a_real, l_a_imag))
							l_b_real := l_a_real / l_s
							l_b_imag := l_a_imag / l_s
							create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix] := (l_x_real * l_b_real + l_x_imag * l_b_imag) / l_s
							create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] := (l_x_imag * l_b_real - l_b_imag * l_x_real) / l_s
						end
						l_ix := l_ix - a_incX
						l_i := a_N - 1
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_i > 0 then
								l_tmp___4 := l_i
								l_i := l_i - 1
								if not l_tmp___4.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_tmp_real := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix]
								l_tmp_imag := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
								l_jx := l_ix + a_incX
								l_j := l_i + 1
								from
								until
									not (l_j < a_N)
								loop
									l_Aij_real := create {CE_REAL_64_POINTER}.make_cast (a_Ap)[2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_j) - l_i)]
									l_Aij_imag := (l_conj.to_double * create {CE_REAL_64_POINTER}.make_cast (a_Ap)[(2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_j) - l_i) + 1)])
									l_x_real___0 := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_jx]
									l_x_imag___0 := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_jx + 1)]
									l_tmp_real := l_tmp_real - (l_Aij_real * l_x_real___0 - l_Aij_imag * l_x_imag___0)
									l_tmp_imag := l_tmp_imag - (l_Aij_real * l_x_imag___0 + l_Aij_imag * l_x_real___0)
									l_jx := l_jx + a_incX
									l_j := l_j + 1
								end
								if l_nonunit.to_boolean then
									l_a_real___0 := create {CE_REAL_64_POINTER}.make_cast (a_Ap)[2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_i) - l_i)]
									l_a_imag___0 := (l_conj.to_double * create {CE_REAL_64_POINTER}.make_cast (a_Ap)[(2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_i) - l_i) + 1)])
									l_s___0 := ((create {P_HYPOT_STATIC}).xhypot___4 (l_a_real___0, l_a_imag___0))
									l_b_real___0 := l_a_real___0 / l_s___0
									l_b_imag___0 := l_a_imag___0 / l_s___0
									create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix] := (l_tmp_real * l_b_real___0 + l_tmp_imag * l_b_imag___0) / l_s___0
									create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] := (l_tmp_imag * l_b_real___0 - l_tmp_real * l_b_imag___0) / l_s___0
								else
									create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix] := l_tmp_real
									create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] := l_tmp_imag
								end
								l_ix := l_ix - a_incX
							end
						end
						l_break := False
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_pos := -1 + 13 -- goto _L___14
				when 10 then -- if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_pos := -1 + 13 -- goto _L___14
				when 12 then -- if done | if block done, skip else block:
						l_pos := -1 + 50
				when 13 then -- else: | _L___14:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if l_Trans = 111 then
							if a_Uplo = {NATURAL_32} 122 then
								l_pos := -1 + 19 -- goto _L___7
							else
								l_pos := -1 + 16 -- goto _L___11
							end
						else
							l_pos := -1 + 16 -- goto _L___11
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 16 then -- else: | _L___11:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 25 -- skip if block
						end
				when 17 then -- if:
						if l_Trans /= 112 then
							l_pos := -1 + 23 -- skip if block
						end
				when 18 then -- if:
						if a_Uplo /= {NATURAL_32} 121 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if: | _L___7:
						if a_incX > 0 then
							l_tmp___5 := 0
						else
							l_tmp___5 := (a_N - 1) * -a_incX
						end
						l_ix___0 := l_tmp___5
						if l_nonunit.to_boolean then
							l_a_real___1 := create {CE_REAL_64_POINTER}.make_cast (a_Ap)[0]
							l_a_imag___1 := (l_conj.to_double * create {CE_REAL_64_POINTER}.make_cast (a_Ap)[1])
							l_x_real___1 := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___0]
							l_x_imag___1 := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___0 + 1)]
							l_s___1 := ((create {P_HYPOT_STATIC}).xhypot___4 (l_a_real___1, l_a_imag___1))
							l_b_real___1 := l_a_real___1 / l_s___1
							l_b_imag___1 := l_a_imag___1 / l_s___1
							create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___0] := (l_x_real___1 * l_b_real___1 + l_x_imag___1 * l_b_imag___1) / l_s___1
							create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___0 + 1)] := (l_x_imag___1 * l_b_real___1 - l_b_imag___1 * l_x_real___1) / l_s___1
						end
						l_ix___0 := l_ix___0 + a_incX
						l_i := 1
						from
						until
							not (not (l_return) and then (l_i < a_N))
						loop
							l_tmp_real___0 := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___0]
							l_tmp_imag___0 := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___0 + 1)]
							if a_incX > 0 then
								l_tmp___7 := 0
							else
								l_tmp___7 := (a_N - 1) * -a_incX
							end
							l_jx___0 := l_tmp___7
							l_j := 0
							from
							until
								not (l_j < l_i)
							loop
								l_Aij_real___0 := create {CE_REAL_64_POINTER}.make_cast (a_Ap)[2 * ((l_i * (l_i + 1)) // 2 + l_j)]
								l_Aij_imag___0 := (l_conj.to_double * create {CE_REAL_64_POINTER}.make_cast (a_Ap)[(2 * ((l_i * (l_i + 1)) // 2 + l_j) + 1)])
								l_x_real___2 := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_jx___0]
								l_x_imag___2 := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_jx___0 + 1)]
								l_tmp_real___0 := l_tmp_real___0 - (l_Aij_real___0 * l_x_real___2 - l_Aij_imag___0 * l_x_imag___2)
								l_tmp_imag___0 := l_tmp_imag___0 - (l_Aij_real___0 * l_x_imag___2 + l_Aij_imag___0 * l_x_real___2)
								l_jx___0 := l_jx___0 + a_incX
								l_j := l_j + 1
							end
							if l_nonunit.to_boolean then
								l_a_real___2 := create {CE_REAL_64_POINTER}.make_cast (a_Ap)[2 * ((l_i * (l_i + 1)) // 2 + l_i)]
								l_a_imag___2 := (l_conj.to_double * create {CE_REAL_64_POINTER}.make_cast (a_Ap)[(2 * ((l_i * (l_i + 1)) // 2 + l_i) + 1)])
								l_s___2 := ((create {P_HYPOT_STATIC}).xhypot___4 (l_a_real___2, l_a_imag___2))
								l_b_real___2 := l_a_real___2 / l_s___2
								l_b_imag___2 := l_a_imag___2 / l_s___2
								create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___0] := (l_tmp_real___0 * l_b_real___2 + l_tmp_imag___0 * l_b_imag___2) / l_s___2
								create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___0 + 1)] := (l_tmp_imag___0 * l_b_real___2 - l_tmp_real___0 * l_b_imag___2) / l_s___2
							else
								create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___0] := l_tmp_real___0
								create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___0 + 1)] := l_tmp_imag___0
							end
							l_ix___0 := l_ix___0 + a_incX
							l_i := l_i + 1
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:
						l_pos := -1 + 25 -- goto _L___9
				when 22 then -- if done | if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else:
						l_pos := -1 + 25 -- goto _L___9
				when 24 then -- if done | if block done, skip else block:
						l_pos := -1 + 50
				when 25 then -- else: | _L___9:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						if l_Trans = 112 then
							if a_Uplo = {NATURAL_32} 121 then
								l_pos := -1 + 31 -- goto _L___2
							else
								l_pos := -1 + 28 -- goto _L___6
							end
						else
							l_pos := -1 + 28 -- goto _L___6
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 28 then -- else: | _L___6:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 37 -- skip if block
						end
				when 29 then -- if:
						if l_Trans /= 111 then
							l_pos := -1 + 35 -- skip if block
						end
				when 30 then -- if:
						if a_Uplo /= {NATURAL_32} 122 then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if: | _L___2:
						if a_incX > 0 then
							l_tmp___9 := 0
						else
							l_tmp___9 := (a_N - 1) * -a_incX
						end
						l_ix___1 := l_tmp___9
						if l_nonunit.to_boolean then
							l_a_real___3 := create {CE_REAL_64_POINTER}.make_cast (a_Ap)[0]
							l_a_imag___3 := (l_conj.to_double * create {CE_REAL_64_POINTER}.make_cast (a_Ap)[1])
							l_x_real___3 := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___1]
							l_x_imag___3 := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___1 + 1)]
							l_s___3 := ((create {P_HYPOT_STATIC}).xhypot___4 (l_a_real___3, l_a_imag___3))
							l_b_real___3 := l_a_real___3 / l_s___3
							l_b_imag___3 := l_a_imag___3 / l_s___3
							create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___1] := (l_x_real___3 * l_b_real___3 + l_x_imag___3 * l_b_imag___3) / l_s___3
							create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___1 + 1)] := (l_x_imag___3 * l_b_real___3 - l_b_imag___3 * l_x_real___3) / l_s___3
						end
						l_ix___1 := l_ix___1 + a_incX
						l_i := 1
						from
						until
							not (not (l_return) and then (l_i < a_N))
						loop
							l_tmp_real___1 := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___1]
							l_tmp_imag___1 := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___1 + 1)]
							if a_incX > 0 then
								l_tmp___11 := 0
							else
								l_tmp___11 := (a_N - 1) * -a_incX
							end
							l_jx___1 := l_tmp___11
							l_j := 0
							from
							until
								not (l_j < l_i)
							loop
								l_Aij_real___1 := create {CE_REAL_64_POINTER}.make_cast (a_Ap)[2 * (((((l_j - 1) + 1) * (2 * a_N - (l_j - 1))) // 2 + l_i) - l_j)]
								l_Aij_imag___1 := (l_conj.to_double * create {CE_REAL_64_POINTER}.make_cast (a_Ap)[(2 * (((((l_j - 1) + 1) * (2 * a_N - (l_j - 1))) // 2 + l_i) - l_j) + 1)])
								l_x_real___4 := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_jx___1]
								l_x_imag___4 := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_jx___1 + 1)]
								l_tmp_real___1 := l_tmp_real___1 - (l_Aij_real___1 * l_x_real___4 - l_Aij_imag___1 * l_x_imag___4)
								l_tmp_imag___1 := l_tmp_imag___1 - (l_Aij_real___1 * l_x_imag___4 + l_Aij_imag___1 * l_x_real___4)
								l_jx___1 := l_jx___1 + a_incX
								l_j := l_j + 1
							end
							if l_nonunit.to_boolean then
								l_a_real___4 := create {CE_REAL_64_POINTER}.make_cast (a_Ap)[2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_i) - l_i)]
								l_a_imag___4 := (l_conj.to_double * create {CE_REAL_64_POINTER}.make_cast (a_Ap)[(2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_i) - l_i) + 1)])
								l_s___4 := ((create {P_HYPOT_STATIC}).xhypot___4 (l_a_real___4, l_a_imag___4))
								l_b_real___4 := l_a_real___4 / l_s___4
								l_b_imag___4 := l_a_imag___4 / l_s___4
								create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___1] := (l_tmp_real___1 * l_b_real___4 + l_tmp_imag___1 * l_b_imag___4) / l_s___4
								create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___1 + 1)] := (l_tmp_imag___1 * l_b_real___4 - l_tmp_real___1 * l_b_imag___4) / l_s___4
							else
								create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___1] := l_tmp_real___1
								create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___1 + 1)] := l_tmp_imag___1
							end
							l_ix___1 := l_ix___1 + a_incX
							l_i := l_i + 1
						end
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 33 then -- else:
						l_pos := -1 + 37 -- goto _L___4
				when 34 then -- if done | if block done, skip else block:
						l_pos := -1 + 36
				when 35 then -- else:
						l_pos := -1 + 37 -- goto _L___4
				when 36 then -- if done | if block done, skip else block:
						l_pos := -1 + 50
				when 37 then -- else: | _L___4:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						if l_Trans = 112 then
							if a_Uplo = {NATURAL_32} 122 then
								l_pos := -1 + 43 -- goto _L
							else
								l_pos := -1 + 40 -- goto _L___1
							end
						else
							l_pos := -1 + 40 -- goto _L___1
						end
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 40 then -- else: | _L___1:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 49 -- skip if block
						end
				when 41 then -- if:
						if l_Trans /= 111 then
							l_pos := -1 + 47 -- skip if block
						end
				when 42 then -- if:
						if a_Uplo /= {NATURAL_32} 121 then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if: | _L:
						if a_incX > 0 then
							l_tmp___13 := 0
						else
							l_tmp___13 := (a_N - 1) * -a_incX
						end
						l_ix___2 := l_tmp___13 + a_incX * (a_N - 1)
						if l_nonunit.to_boolean then
							l_a_real___5 := create {CE_REAL_64_POINTER}.make_cast (a_Ap)[2 * (((a_N - 1) * ((a_N - 1) + 1)) // 2 + (a_N - 1))]
							l_a_imag___5 := (l_conj.to_double * create {CE_REAL_64_POINTER}.make_cast (a_Ap)[(2 * (((a_N - 1) * ((a_N - 1) + 1)) // 2 + (a_N - 1)) + 1)])
							l_x_real___5 := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___2]
							l_x_imag___5 := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___2 + 1)]
							l_s___5 := ((create {P_HYPOT_STATIC}).xhypot___4 (l_a_real___5, l_a_imag___5))
							l_b_real___5 := l_a_real___5 / l_s___5
							l_b_imag___5 := l_a_imag___5 / l_s___5
							create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___2] := (l_x_real___5 * l_b_real___5 + l_x_imag___5 * l_b_imag___5) / l_s___5
							create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___2 + 1)] := (l_x_imag___5 * l_b_real___5 - l_b_imag___5 * l_x_real___5) / l_s___5
						end
						l_ix___2 := l_ix___2 - a_incX
						l_i := a_N - 1
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_i > 0 then
								l_tmp___16 := l_i
								l_i := l_i - 1
								if not l_tmp___16.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_tmp_real___2 := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___2]
								l_tmp_imag___2 := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___2 + 1)]
								l_jx___2 := l_ix___2 + a_incX
								l_j := l_i + 1
								from
								until
									not (l_j < a_N)
								loop
									l_Aij_real___2 := create {CE_REAL_64_POINTER}.make_cast (a_Ap)[2 * ((l_j * (l_j + 1)) // 2 + l_i)]
									l_Aij_imag___2 := (l_conj.to_double * create {CE_REAL_64_POINTER}.make_cast (a_Ap)[(2 * ((l_j * (l_j + 1)) // 2 + l_i) + 1)])
									l_x_real___6 := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_jx___2]
									l_x_imag___6 := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_jx___2 + 1)]
									l_tmp_real___2 := l_tmp_real___2 - (l_Aij_real___2 * l_x_real___6 - l_Aij_imag___2 * l_x_imag___6)
									l_tmp_imag___2 := l_tmp_imag___2 - (l_Aij_real___2 * l_x_imag___6 + l_Aij_imag___2 * l_x_real___6)
									l_jx___2 := l_jx___2 + a_incX
									l_j := l_j + 1
								end
								if l_nonunit.to_boolean then
									l_a_real___6 := create {CE_REAL_64_POINTER}.make_cast (a_Ap)[2 * ((l_i * (l_i + 1)) // 2 + l_i)]
									l_a_imag___6 := (l_conj.to_double * create {CE_REAL_64_POINTER}.make_cast (a_Ap)[(2 * ((l_i * (l_i + 1)) // 2 + l_i) + 1)])
									l_s___6 := ((create {P_HYPOT_STATIC}).xhypot___4 (l_a_real___6, l_a_imag___6))
									l_b_real___6 := l_a_real___6 / l_s___6
									l_b_imag___6 := l_a_imag___6 / l_s___6
									create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___2] := (l_tmp_real___2 * l_b_real___6 + l_tmp_imag___2 * l_b_imag___6) / l_s___6
									create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___2 + 1)] := (l_tmp_imag___2 * l_b_real___6 - l_tmp_real___2 * l_b_imag___6) / l_s___6
								else
									create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___2] := l_tmp_real___2
									create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___2 + 1)] := l_tmp_imag___2
								end
								l_ix___2 := l_ix___2 - a_incX
							end
						end
						l_break := False
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 45 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_tpsv_c.h"), ce_string ("unrecognized operation")])
				when 46 then -- if done | if block done, skip else block:
						l_pos := -1 + 48
				when 47 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_tpsv_c.h"), ce_string ("unrecognized operation")])
				when 48 then -- if done | if block done, skip else block:
						l_pos := -1 + 50
				when 49 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_tpsv_c.h"), ce_string ("unrecognized operation")])
				when 50 then -- if done | if done | if done | if done | if done | if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
