class
	PD_RANDOM8_STATE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	x: INTEGER_32 assign set_x

feature {ANY} -- field setters

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			x := a_other.x
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				x = a_other.x
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("x")
				>>)
			init_structure_info
		end

end
