class
	PD_SLATEC_STATE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	x0: INTEGER_32 assign set_x0

	x1: INTEGER_32 assign set_x1

feature {ANY} -- field setters

	set_x0 (a_x0: INTEGER_32)
		do
			x0 := a_x0
			update_memory_field ("x0")
		end

	set_x1 (a_x1: INTEGER_32)
		do
			x1 := a_x1
			update_memory_field ("x1")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			x0 := a_other.x0
			x1 := a_other.x1
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				x0 = a_other.x0 and
				x1 = a_other.x1
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("x0"),
					create {CE_STRUCTURE_FIELD}.make ("x1")
				>>)
			init_structure_info
		end

end
