class
	PD_ZUF_STATE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_32_ARRAY} u.make (<<607>>)
		end

feature {ANY} -- fields

	n: INTEGER_32 assign set_n

	u: CE_ARRAY [NATURAL_32]

feature {ANY} -- field setters

	set_n (a_n: INTEGER_32)
		do
			n := a_n
			update_memory_field ("n")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			n := a_other.n
			u := a_other.u.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				n = a_other.n and
				u.is_equal (a_other.u)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("u", <<607>>)
				>>)
			init_structure_info
		end

end
