class
	PD_EYESCLASSREC

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	SD_WIDGETCLASSREC
		redefine
			make,
			copy,
			is_equal,
			structure_info
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create eyes_class.make
			Precursor
		end

feature {ANY} -- fields

	eyes_class: PD_EYESCLASSPART assign set_eyes_class

feature {ANY} -- field setters

	set_eyes_class (a_eyes_class: PD_EYESCLASSPART)
		do
			eyes_class := a_eyes_class
			update_memory_field ("eyes_class")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			Precursor {SD_WIDGETCLASSREC} (a_other)
			eyes_class := a_other.eyes_class.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				Precursor {SD_WIDGETCLASSREC} (a_other) and
				eyes_class.is_equal (a_other.eyes_class)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("eyes_class")
				>>)
			Result.set_superclasses (<<{SD_WIDGETCLASSREC}>>)
			init_structure_info
		end

end
