class
	P_OPTION_STATIC

inherit
	CE_UTILITIES
	S_CTYPE_STATIC
	S_STDIO_STATIC
	S_STRING_STATIC

feature {ANY} -- public attributes

	pendopt: CE_STATIC [CE_POINTER [PD_LOPTION]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_LOPTION]}.make
		end

	plusoption: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	buf___0: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<8>>)
		end

feature {ANY} -- public routines

	scan_option (a_s: CE_POINTER [INTEGER_8])
		local
			l_s: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_o: CE_POINTER [PD_LOPTION]
			l_optc: INTEGER_32
			l_optname: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_printopt: CE_POINTER [INTEGER_8]
			l_str: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_set_default: INTEGER_32
			l_lc: INTEGER_32
			l_err: CE_ARRAY [INTEGER_32]
			l_parg: CE_ARRAY [PD_PARG]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_s.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_optname.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_str.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_err.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_PARG]} l_parg.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s.item := a_s
					if (l_s.item).is_void then
						l_return := True
					end
					if not (not l_return and then (not pendopt.item.is_void)) then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						inspect (pendopt.item.item.otype).bit_and (31) -- switch 1 head
						when 8 then l_pos := -1 + 2
						when 4 then l_pos := -1 + 3
						else l_pos := -1 + 4
						end
				when 2 then -- switch 1, case 8;
						(pendopt.item.item.ofunc).call ([0, l_s.item])
						l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, case 4
						l_printopt := propt ((pendopt.item.item.oletter).to_integer_32);
						(pendopt.item.item.ovar).item := getnum (l_s, l_printopt, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
						pendopt.item := create {CE_CLASS_POINTER [PD_LOPTION]}.make_shared (default_pointer)
						l_return := True
				when 5 then -- if done
					if l_return then
						l_pos := -1 + 23 -- skip if block
					end
				when 6 then -- if:
						l_set_default := 0
						l_optname.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				when 7 then -- loop condition:
						if not (not (l_return) and then ((l_s.item[0]).to_integer_32 /= 0)) then
							l_pos := -1 + 23 -- skip loop
						end
				when 8 then -- loop body:
						l_continue := False
						l_tmp := l_s.item
						l_s.item := l_s.item + 1
						l_optc := (l_tmp[0]).to_integer_32
						inspect l_optc -- switch 2 head
						when 32 then l_pos := -1 + 9
						when 9 then l_pos := -1 + 9
						when 36 then l_pos := -1 + 9
						when 45 then l_pos := -1 + 10
						when 43 then l_pos := -1 + 13
						when 48 then l_pos := -1 + 14
						when 49 then l_pos := -1 + 14
						when 50 then l_pos := -1 + 14
						when 51 then l_pos := -1 + 14
						when 52 then l_pos := -1 + 14
						when 53 then l_pos := -1 + 14
						when 54 then l_pos := -1 + 14
						when 55 then l_pos := -1 + 14
						when 56 then l_pos := -1 + 14
						when 57 then l_pos := -1 + 14
						else l_pos := -1 + 15
						end
				when 9 then -- switch 2, case 32 | switch 2, case 9 | switch 2, case 36
						l_continue := True
				when 10 then -- switch 2, case 45
						if (l_return or l_continue) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if (l_s.item[0]).to_integer_32 = 45 then
							l_s.item := l_s.item + 1
							l_optname.item := l_s.item
							l_pos := -1 + 15 -- switch 2; break
						end
				when 12 then
						l_set_default := ((l_s.item[0]).to_integer_32 = 43).to_integer
						if l_set_default.to_boolean then
							l_s.item := l_s.item + 1
						end
						l_continue := True
				when 13 then -- switch 2, case 43
						if not (l_return or l_continue) then
							plusoption.item := 1
							l_s.item := optstring (l_s.item, l_str, (propt (('+').code)), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
							if (l_str.item[0]).to_integer_32 = 43 then
								l_str.item := l_str.item + 1;
								(create {P_MAIN_STATIC}).every_first_cmd.item := (create {P_MAIN_STATIC}).save (l_str.item)
							else
								(create {P_COMMAND_STATIC}).ungetsc (l_str.item)
							end
							l_continue := True
						end
				when 14 then -- switch 2, case 48 | switch 2, case 49 | switch 2, case 50 | switch 2, case 51 | switch 2, case 52 | switch 2, case 53 | switch 2, case 54 | switch 2, case 55 | switch 2, case 56 | switch 2, case 57
						if not (l_return or l_continue) then
							l_s.item := l_s.item - 1
							l_optc := ('z').code
						end
						l_pos := -1 + 15 -- switch 2; break
				when 15 then -- switch 2, done:
						if (l_return or l_continue) then
							l_pos := -1 + 22 -- skip if block
						end
				when 16 then -- if:
						l_err.item := 0
						if (l_optname.item).is_void then
							l_printopt := propt (l_optc)
							if l_optc >= 97 then
								if l_optc <= 122 then
									l_tmp___1 := 1
								else
									l_tmp___1 := 0
								end
							else
								l_tmp___1 := 0
							end
							l_lc := l_tmp___1
							l_o := (create {P_OPTTBL_STATIC}).findopt (l_optc)
						else
							l_printopt := l_optname.item
							if (l_optname.item[0]).to_integer_32 >= 97 then
								if (l_optname.item[0]).to_integer_32 <= 122 then
									l_tmp___2 := 1
								else
									l_tmp___2 := 0
								end
							else
								l_tmp___2 := 0
							end
							l_lc := l_tmp___2
							l_o := (create {P_OPTTBL_STATIC}).findopt_name (l_optname, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), l_err)
							l_s.item := l_optname.item
							l_optname.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							if (l_s.item[0]).to_integer_32 /= 0 then
								if (l_s.item[0]).to_integer_32 /= 32 then
									if (l_s.item[0]).to_integer_32 = 61 then
										if not l_o.is_void then
											if ((l_o.item.otype).bit_and (31)) /= 8 then
												if ((l_o.item.otype).bit_and (31)) /= 4 then
													l_parg.item.p_string := l_printopt;
													(create {P_OUTPUT_STATIC}).error (ce_string ("The %%s option should not be followed by ="), l_parg);
													(create {P_MAIN_STATIC}).quit (1)
												end
											end
										end
										l_s.item := l_s.item + 1
									else
										l_o := create {CE_CLASS_POINTER [PD_LOPTION]}.make_shared (default_pointer)
									end
								end
							end
						end
						if l_o.is_void then
							l_parg.item.p_string := l_printopt
							if l_err.item = 1 then
								(create {P_OUTPUT_STATIC}).error (ce_string ("%%s is an ambiguous abbreviation (%"less --help%" for help)"), l_parg)
							else
								(create {P_OUTPUT_STATIC}).error (ce_string ("There is no %%s option (%"less --help%" for help)"), l_parg)
							end
							(create {P_MAIN_STATIC}).quit (1)
						end
						l_str.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						inspect (l_o.item.otype).bit_and (31) -- switch 3 head
						when 1 then l_pos := -1 + 17
						when 2 then l_pos := -1 + 18
						when 8 then l_pos := -1 + 19
						when 4 then l_pos := -1 + 20
						else l_pos := -1 + 21
						end
				when 17 then -- switch 3, case 1
						if l_set_default.to_boolean then
							(l_o.item.ovar).item := l_o.item.odefault
						else
							(l_o.item.ovar).item := (not (l_o.item.odefault).to_boolean).to_integer
						end
						l_pos := -1 + 21 -- switch 3; break
				when 18 then -- switch 3, case 2
						if l_set_default.to_boolean then
							(l_o.item.ovar).item := l_o.item.odefault
						else
							(l_o.item.ovar).item := flip_triple (l_o.item.odefault, l_lc)
						end
						l_pos := -1 + 21 -- switch 3; break
				when 19 then -- switch 3, case 8
						if (l_s.item[0]).to_integer_32 = 0 then
							pendopt.item := l_o
							l_return := True
						end
						if not l_return then
							from
							until
								(l_s.item[0]).to_integer_32 /= 32
							loop
								l_s.item := l_s.item + 1
							end
							l_s.item := optstring (l_s.item, l_str, l_printopt, l_o.item.odesc[1])
						end
						l_pos := -1 + 21 -- switch 3; break
				when 20 then -- switch 3, case 4
						if (l_s.item[0]).to_integer_32 = 0 then
							pendopt.item := l_o
							l_return := True
						end
						if not l_return then
							(l_o.item.ovar).item := getnum (l_s, l_printopt, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						end
						l_pos := -1 + 21 -- switch 3; break
				when 21 then -- switch 3, done:
						if not l_return and then (not (l_o.item.ofunc).is_void) then
							(l_o.item.ofunc).call ([0, l_str.item])
						end
				when 22 then -- if done
						l_pos := -1 + 7 -- back to loop condition
				when 23 then -- loop done | if done
					if not l_return then
						l_continue := False
					end
				when 24 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	toggle_option (a_c: INTEGER_32; a_s: CE_POINTER [INTEGER_8]; a_how_toggle: INTEGER_32)
		local
			l_s: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_how_toggle: INTEGER_32
			l_o: CE_POINTER [PD_LOPTION]
			l_num: INTEGER_32
			l_no_prompt: INTEGER_32
			l_err: CE_ARRAY [INTEGER_32]
			l_parg: CE_ARRAY [PD_PARG]
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_s.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_err.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_PARG]} l_parg.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s.item := a_s
					l_how_toggle := a_how_toggle
					l_no_prompt := (l_how_toggle).bit_and (64)
					l_how_toggle := (l_how_toggle).bit_and ((-65))
					l_o := (create {P_OPTTBL_STATIC}).findopt (a_c)
					if l_o.is_void then
						l_parg.item.p_string := propt (a_c);
						(create {P_OUTPUT_STATIC}).error (ce_string ("There is no %%s option"), l_parg)
						l_return := True
					end
					if not l_return and then (l_how_toggle = 1) then
						if ((l_o.item.otype).bit_and (64)).to_boolean then
							l_parg.item.p_string := propt (a_c);
							(create {P_OUTPUT_STATIC}).error (ce_string ("Cannot change the %%s option"), l_parg)
							l_return := True
						end
					end
					if not l_return and then (l_how_toggle = 0) then
						if ((l_o.item.otype).bit_and (256)).to_boolean then
							l_parg.item.p_string := propt (a_c);
							(create {P_OUTPUT_STATIC}).error (ce_string ("Cannot query the %%s option"), l_parg)
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 23 -- skip if block
					end
				when 1 then -- if:
						inspect (l_o.item.otype).bit_and (31) -- switch 1 head
						when 8 then l_pos := -1 + 2
						when 4 then l_pos := -1 + 2
						else l_pos := -1 + 3
						end
				when 2 then -- switch 1, case 8 | switch 1, case 4
						if l_how_toggle = 1 then
							if (l_s.item[0]).to_integer_32 = 0 then
								l_how_toggle := 0
							end
						end
						l_pos := -1 + 3 -- switch 1; break
				when 3 then -- switch 1, done:
						if l_how_toggle /= 0 then
							if ((l_o.item.otype).bit_and (128)).to_boolean then
								(create {P_SEARCH_STATIC}).repaint_hilite (0)
							end
						end
						if l_how_toggle = 0 then
							l_pos := -1 + 23 -- skip if block
						end
				when 4 then -- if:
						inspect (l_o.item.otype).bit_and (31) -- switch 2 head
						when 1 then l_pos := -1 + 5
						when 2 then l_pos := -1 + 10
						when 8 then l_pos := -1 + 15
						when 4 then l_pos := -1 + 18
						else l_pos := -1 + 23
						end
				when 5 then -- switch 2, case 1
						inspect l_how_toggle -- switch 3 head
						when 1 then l_pos := -1 + 6
						when 2 then l_pos := -1 + 7
						when 3 then l_pos := -1 + 8
						else l_pos := -1 + 9
						end
				when 6 then -- switch 3, case 1;
						(l_o.item.ovar).item := (not ((l_o.item.ovar).item).to_boolean).to_integer
						l_pos := -1 + 9 -- switch 3; break
				when 7 then -- switch 3, case 2;
						(l_o.item.ovar).item := l_o.item.odefault
						l_pos := -1 + 9 -- switch 3; break
				when 8 then -- switch 3, case 3;
						(l_o.item.ovar).item := (not (l_o.item.odefault).to_boolean).to_integer
						l_pos := -1 + 9 -- switch 3; break
				when 9 then -- switch 3, done:
						l_pos := -1 + 23 -- switch 2; break
				when 10 then -- switch 2, case 2
						inspect l_how_toggle -- switch 4 head
						when 1 then l_pos := -1 + 11
						when 2 then l_pos := -1 + 12
						when 3 then l_pos := -1 + 13
						else l_pos := -1 + 14
						end
				when 11 then -- switch 4, case 1;
						(l_o.item.ovar).item := flip_triple ((l_o.item.ovar).item, ((((ctype_b_loc).item[a_c]).to_integer_32).bit_and (512)))
						l_pos := -1 + 14 -- switch 4; break
				when 12 then -- switch 4, case 2;
						(l_o.item.ovar).item := l_o.item.odefault
						l_pos := -1 + 14 -- switch 4; break
				when 13 then -- switch 4, case 3;
						(l_o.item.ovar).item := flip_triple (l_o.item.odefault, ((((ctype_b_loc).item[a_c]).to_integer_32).bit_and (512)))
						l_pos := -1 + 14 -- switch 4; break
				when 14 then -- switch 4, done:
						l_pos := -1 + 23 -- switch 2; break
				when 15 then -- switch 2, case 8
						inspect l_how_toggle -- switch 5 head
						when 3 then l_pos := -1 + 16
						when 2 then l_pos := -1 + 16
						else l_pos := -1 + 17
						end
				when 16 then -- switch 5, case 3 | switch 5, case 2;
						(create {P_OUTPUT_STATIC}).error (ce_string ("Cannot use %"-+%" or %"--%" for a string option"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
						l_return := True
				when 17 then -- switch 5, done:
						l_pos := -1 + 23 -- switch 2; break
				when 18 then -- switch 2, case 4
						inspect l_how_toggle -- switch 6 head
						when 1 then l_pos := -1 + 19
						when 2 then l_pos := -1 + 20
						when 3 then l_pos := -1 + 21
						else l_pos := -1 + 22
						end
				when 19 then -- switch 6, case 1
						l_num := getnum (l_s, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), l_err)
						if not (l_err.item).to_boolean then
							(l_o.item.ovar).item := l_num
						end
						l_pos := -1 + 22 -- switch 6; break
				when 20 then -- switch 6, case 2;
						(l_o.item.ovar).item := l_o.item.odefault
						l_pos := -1 + 22 -- switch 6; break
				when 21 then -- switch 6, case 3;
						(create {P_OUTPUT_STATIC}).error (ce_string ("Can%'t use %"-!%" for a numeric option"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
						l_return := True
				when 22 then -- switch 6, done:
						l_pos := -1 + 23 -- switch 2; break
				when 23 then -- switch 2, done: | if done | if done
					if l_return then
						l_pos := -1 + 30 -- skip if block
					end
				when 24 then -- if:
						if not (l_o.item.ofunc).is_void then
							if l_how_toggle = 0 then
								l_tmp___1 := 1
							else
								l_tmp___1 := 2
							end
							(l_o.item.ofunc).call ([l_tmp___1, l_s.item])
						end
						if l_how_toggle /= 0 then
							if ((l_o.item.otype).bit_and (128)).to_boolean then
								(create {P_SEARCH_STATIC}).chg_hilite
							end
						end
						if l_no_prompt.to_boolean then
							l_pos := -1 + 29 -- skip if block
						end
				when 25 then -- if:
						inspect (l_o.item.otype).bit_and (31) -- switch 7 head
						when 1 then l_pos := -1 + 26
						when 2 then l_pos := -1 + 26
						when 4 then l_pos := -1 + 27
						when 8 then l_pos := -1 + 28
						else l_pos := -1 + 29
						end
				when 26 then -- switch 7, case 1 | switch 7, case 2;
						(create {P_OUTPUT_STATIC}).error (l_o.item.odesc[(l_o.item.ovar).item], create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
						l_pos := -1 + 29 -- switch 7; break
				when 27 then -- switch 7, case 4
						l_parg.item.p_int := (l_o.item.ovar).item;
						(create {P_OUTPUT_STATIC}).error (l_o.item.odesc[1], l_parg)
						l_pos := -1 + 29 -- switch 7; break
				when 28 then -- switch 7, case 8
						l_pos := -1 + 29 -- switch 7; break
				when 29 then -- switch 7, done: | if done
						if l_how_toggle /= 0 then
							if ((l_o.item.otype).bit_and (32)).to_boolean then
								(create {P_COMMAND_STATIC}).screen_trashed.item := 1
							end
						end
				when 30 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	flip_triple (a_val, a_lc: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			if a_lc.to_boolean then
				if a_val = 1 then
					l_tmp := 0
				else
					l_tmp := 1
				end
				Result := l_tmp
			else
				if a_val = 2 then
					l_tmp___0 := 0
				else
					l_tmp___0 := 2
				end
				Result := l_tmp___0
			end
		end

	propt (a_c: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			sprintf ([buf___0.item, ce_string ("-%%s"), ((create {P_CHARSET_STATIC}).prchar (a_c))]).do_nothing
			Result := buf___0.item
		end

	single_char_option (a_c: INTEGER_32): INTEGER_32
		local
			l_o: CE_POINTER [PD_LOPTION]
			l_return: BOOLEAN
		do
			l_o := (create {P_OPTTBL_STATIC}).findopt (a_c)
			if l_o.is_void then
				Result := 1
				l_return := True
			end
			if not l_return then
				Result := (((l_o.item.otype).bit_and (83)) /= 0).to_integer
			end
		end

	opt_prompt (a_c: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_o: CE_POINTER [PD_LOPTION]
			l_return: BOOLEAN
		do
			l_o := (create {P_OPTTBL_STATIC}).findopt (a_c)
			if l_o.is_void then
				Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
				l_return := True
			elseif ((l_o.item.otype).bit_and (12)) = 0 then
				Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := (l_o.item.odesc[0])
			end
		end

	isoptpending: INTEGER_32
		do
			Result := (not pendopt.item.is_void).to_integer
		end

	nostring (a_printopt: CE_POINTER [INTEGER_8])
		local
			l_parg: CE_ARRAY [PD_PARG]
		do
			create {CE_CLASS_ARRAY [PD_PARG]} l_parg.make (<<1>>)

			l_parg.item.p_string := a_printopt;
			(create {P_OUTPUT_STATIC}).error (ce_string ("Value is required after %%s"), l_parg)
		end

	nopendopt
		do
			nostring ((propt ((pendopt.item.item.oletter).to_integer_32)))
		end

	optstring (a_s: CE_POINTER [INTEGER_8]; a_p_str: CE_POINTER [CE_POINTER [INTEGER_8]]; a_printopt, a_validchars: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_s.is_void
			not a_p_str.is_void
		local
			l_p: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_s[0]).to_integer_32 = 0 then
						nostring (a_printopt);
						(create {P_MAIN_STATIC}).quit (1)
					end
					a_p_str.item := a_s
					l_p := a_s
				when 1 then -- loop condition:
					if not (not (l_break) and then ((l_p[0]).to_integer_32 /= 0)) then
						l_pos := -1 + 12 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if (l_p[0]).to_integer_32 /= 36 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 5 then -- else:
						if a_validchars.is_void then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if:
						if not ((strchr (a_validchars, (l_p[0]).to_integer_32)).is_void) then
							l_pos := -1 + 11 -- skip if block
						end
				when 7 then -- if: | _L:
						inspect (l_p[0]).to_integer_32 -- switch 1 head
						when 36 then l_pos := -1 + 8
						when 32 then l_pos := -1 + 8
						when 9 then l_pos := -1 + 8
						when 45 then l_pos := -1 + 8
						else l_pos := -1 + 9
						end
				when 8 then -- switch 1, case 36 | switch 1, case 32 | switch 1, case 9 | switch 1, case 45
						l_tmp := l_p
						l_p := l_p + 1
						l_tmp[0] := (('%/0/').code).to_integer_8
						l_pos := -1 + 10 -- switch 1; break
				when 9 then -- switch 1, default:
						a_p_str.item := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MAIN_STATIC}).ecalloc ((l_p.distance (a_s)) + 1, {PLATFORM}.Integer_8_bytes.to_natural_32)))
						strncpy (a_p_str.item, a_s, (l_p.distance (a_s)).to_natural_32).do_nothing
						a_p_str.item[(l_p.distance (a_s))] := (('%/0/').code).to_integer_8
						l_pos := -1 + 10 -- switch 1; break
				when 10 then -- switch 1, done:
						l_break := True
				when 11 then -- if done | if done
						if not (l_break) then
							l_p := l_p + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 12 then -- loop done
					l_break := False
					Result := l_p
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	getnum (a_sp: CE_POINTER [CE_POINTER [INTEGER_8]]; a_printopt: CE_POINTER [INTEGER_8]; a_errp: CE_POINTER [INTEGER_32]): INTEGER_32
		require
			not a_sp.is_void
		local
			l_s: CE_POINTER [INTEGER_8]
			l_n: INTEGER_32
			l_neg: INTEGER_32
			l_parg: CE_ARRAY [PD_PARG]
			l_tmp: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_PARG]} l_parg.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := (create {P_MAIN_STATIC}).skipsp (a_sp.item)
					l_neg := 0
					if (l_s[0]).to_integer_32 = 45 then
						l_neg := 1
						l_s := l_s + 1
					end
					if not ((l_s[0]).to_integer_32 < 48) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((l_s[0]).to_integer_32 > 57) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if not a_errp.is_void then
							a_errp.item := 1
							Result := (-1)
							l_return := True
						end
						if not l_return then
							if not a_printopt.is_void then
								l_parg.item.p_string := a_printopt;
								(create {P_OUTPUT_STATIC}).error (ce_string ("Number is required after %%s"), l_parg)
							end
							(create {P_MAIN_STATIC}).quit (1)
						end
				when 5 then -- if done
					if not l_return then
						l_n := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_s[0]).to_integer_32 >= 48 then
								if not ((l_s[0]).to_integer_32 <= 57) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_tmp := l_s
								l_s := l_s + 1
								l_n := (10 * l_n + (l_tmp[0]).to_integer_32) - 48
							end
						end
						l_break := False
						a_sp.item := l_s
						if not a_errp.is_void then
							a_errp.item := 0
						end
						if l_neg.to_boolean then
							l_n := -l_n
						end
						Result := l_n
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
