class
	P_SCREEN_STATIC

inherit
	CE_UTILITIES
	S_TERMIOS_STATIC
	S_TERMCAP_STATIC
	S_UNISTD_STATIC
	S_STRING_STATIC
	S_STDLIB_STATIC
	S_SYS_IOCTL_STATIC

feature {ANY} -- public attributes

	sc_pad: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

	sc_home: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

	sc_addline: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

	sc_lower_left: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

	sc_move: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

	sc_clear: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

	sc_eol_clear: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

	sc_eos_clear: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

	sc_s_in: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make (<<1>>)
		end

	sc_s_out: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make (<<1>>)
		end

	sc_u_in: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make (<<1>>)
		end

	sc_u_out: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make (<<1>>)
		end

	sc_b_in: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make (<<1>>)
		end

	sc_b_out: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make (<<1>>)
		end

	sc_bl_in: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make (<<1>>)
		end

	sc_bl_out: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make (<<1>>)
		end

	sc_visual_bell: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

	sc_backspace: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

	sc_s_keypad: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

	sc_e_keypad: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

	sc_init: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

	sc_deinit: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

	init_done: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	auto_wrap: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	ignaw: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	erase_char: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	kill_char: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	werase_char: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	sc_width: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	sc_height: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	bo_s_width: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	bo_e_width: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	ul_s_width: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	ul_e_width: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	so_s_width: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	so_e_width: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	bl_s_width: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	bl_e_width: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	above_mem: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	below_mem: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	can_goto_line: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	clear_bg: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	missing_cap: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	attrmode: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	quiet: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	no_init: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	no_keypad: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	tty: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	hilite_search: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	curr_on: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	save_term: CE_STATIC [SD_TERMIOS]
		once ("PROCESS")
			Result.item := create {SD_TERMIOS}.make
		end

	saved_term: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	hardcopy: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	tbuf: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<40>>)
		end

	sbuf: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<1_024>>)
		end

	costcount: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

feature {ANY} -- public routines

	raw_mode (a_on: INTEGER_32)
		local
			l_s: CE_ARRAY [SD_TERMIOS]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_TERMIOS]} l_s.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_on = curr_on.item then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 26 -- skip if block
					end
				when 1 then -- if:
						if not (a_on.to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 2 then -- if:
						tcgetattr (tty.item, l_s).do_nothing
						if not saved_term.item.to_boolean then
							save_term.item := (l_s.item).twin
							saved_term.item := 1
						end
						inspect (cfgetospeed (l_s)).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 3
						when 1 then l_pos := -1 + 4
						when 2 then l_pos := -1 + 5
						when 3 then l_pos := -1 + 6
						when 4 then l_pos := -1 + 7
						when 5 then l_pos := -1 + 8
						when 6 then l_pos := -1 + 9
						when 7 then l_pos := -1 + 10
						when 8 then l_pos := -1 + 11
						when 9 then l_pos := -1 + 12
						when 10 then l_pos := -1 + 13
						when 11 then l_pos := -1 + 14
						when 12 then l_pos := -1 + 15
						when 13 then l_pos := -1 + 16
						when 14 then l_pos := -1 + 17
						when 15 then l_pos := -1 + 18
						when 4097 then l_pos := -1 + 19
						when 4098 then l_pos := -1 + 20
						else l_pos := -1 + 21
						end
				when 3 then -- switch 1, case 0
						Current.ospeed := (0).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 4 then -- switch 1, case 1
						Current.ospeed := (1).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 5 then -- switch 1, case 2
						Current.ospeed := (2).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 6 then -- switch 1, case 3
						Current.ospeed := (3).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 7 then -- switch 1, case 4
						Current.ospeed := (4).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 8 then -- switch 1, case 5
						Current.ospeed := (5).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 9 then -- switch 1, case 6
						Current.ospeed := (6).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 10 then -- switch 1, case 7
						Current.ospeed := (7).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 11 then -- switch 1, case 8
						Current.ospeed := (8).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 12 then -- switch 1, case 9
						Current.ospeed := (9).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 13 then -- switch 1, case 10
						Current.ospeed := (10).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 14 then -- switch 1, case 11
						Current.ospeed := (11).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 15 then -- switch 1, case 12
						Current.ospeed := (12).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 16 then -- switch 1, case 13
						Current.ospeed := (13).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 17 then -- switch 1, case 14
						Current.ospeed := (14).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 18 then -- switch 1, case 15
						Current.ospeed := (15).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 19 then -- switch 1, case 4097
						Current.ospeed := (16).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 20 then -- switch 1, case 4098
						Current.ospeed := (17).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 21 then -- switch 1, default:
						
				when 22 then -- switch 1, done:
						erase_char.item := (l_s.item.c2_cc[2]).to_integer_32
						kill_char.item := (l_s.item.c2_cc[3]).to_integer_32
						werase_char.item := (l_s.item.c2_cc[14]).to_integer_32
						l_s.item.c2_lflag := (l_s.item.c2_lflag).bit_and (({NATURAL_32} 4_294_967_173))
						l_s.item.c2_oflag := (l_s.item.c2_oflag).bit_or (({NATURAL_32} 6_149))
						l_s.item.c2_oflag := (l_s.item.c2_oflag).bit_and (({NATURAL_32} 4_294_967_239))
						l_s.item.c2_cc[6] := (1).to_natural_8
						l_s.item.c2_cc[5] := (0).to_natural_8
						l_s.item.c2_cc[15] := (0).to_natural_8
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else:
						l_s.item := save_term.item.twin
				when 25 then -- if done
						fsync (tty.item).do_nothing
						tcsetattr (tty.item, 1, l_s).do_nothing
						curr_on.item := a_on
				when 26 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ltget_env (a_capname: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_capname.is_void
		local
			l_name: CE_ARRAY [INTEGER_8]
		do
			create {CE_INTEGER_8_ARRAY} l_name.make (<<16>>)

			strcpy (l_name, ce_string ("LESS_TERMCAP_")).do_nothing
			strcat (l_name, a_capname).do_nothing
			Result := ((create {P_DECODE_STATIC}).lgetenv (l_name))
		end

	ltgetflag (a_capname: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_capname.is_void
		local
			l_s: CE_POINTER [INTEGER_8]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_s := ltget_env (a_capname)
			if not l_s.is_void then
				if (l_s[0]).to_integer_32 /= 0 then
					if (l_s[0]).to_integer_32 /= 48 then
						l_tmp := 1
					else
						l_tmp := 0
					end
				else
					l_tmp := 0
				end
				Result := l_tmp
				l_return := True
			end
			if not l_return and then (hardcopy.item.to_boolean) then
				Result := 0
				l_return := True
			end
			if not l_return then
				Result := (tgetflag (a_capname))
			end
		end

	ltgetnum (a_capname: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_capname.is_void
		local
			l_s: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_s := ltget_env (a_capname)
			if not l_s.is_void then
				Result := (atoi (l_s))
				l_return := True
			end
			if not l_return and then (hardcopy.item.to_boolean) then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				Result := (tgetnum (a_capname))
			end
		end

	ltgetstr (a_capname: CE_POINTER [INTEGER_8]; a_pp: CE_POINTER [CE_POINTER [INTEGER_8]]): CE_POINTER [INTEGER_8]
		require
			not a_capname.is_void
		local
			l_s: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_s := ltget_env (a_capname)
			if not l_s.is_void then
				Result := l_s
				l_return := True
			end
			if not l_return and then (hardcopy.item.to_boolean) then
				Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := (tgetstr (a_capname, a_pp))
			end
		end

	scrsize
		local
			l_s: CE_POINTER [INTEGER_8]
			l_sys_height: INTEGER_32
			l_sys_width: INTEGER_32
			l_n: INTEGER_32
			l_w: CE_ARRAY [SD_WINSIZE]
		do
			create {CE_CLASS_ARRAY [SD_WINSIZE]} l_w.make (<<1>>)

			l_sys_height := 0
			l_sys_width := l_sys_height
			if (ioctl ([2, {NATURAL_32} 21_523, l_w])) = 0 then
				if (l_w.item.ws_row).to_integer_32 > 0 then
					l_sys_height := (l_w.item.ws_row).to_integer_32
				end
				if (l_w.item.ws_col).to_integer_32 > 0 then
					l_sys_width := (l_w.item.ws_col).to_integer_32
				end
			end
			if l_sys_height > 0 then
				sc_height.item := l_sys_height
			else
				l_s := (create {P_DECODE_STATIC}).lgetenv (ce_string ("LINES"))
				if not l_s.is_void then
					sc_height.item := atoi (l_s)
				else
					l_n := ltgetnum (ce_string ("li"))
					if l_n > 0 then
						sc_height.item := l_n
					else
						sc_height.item := 24
					end
				end
			end
			if l_sys_width > 0 then
				sc_width.item := l_sys_width
			else
				l_s := (create {P_DECODE_STATIC}).lgetenv (ce_string ("COLUMNS"))
				if not l_s.is_void then
					sc_width.item := atoi (l_s)
				else
					l_n := ltgetnum (ce_string ("co"))
					if l_n > 0 then
						sc_width.item := l_n
					else
						sc_width.item := 80
					end
				end
			end
		end

	special_key_str (a_key: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_s: CE_POINTER [INTEGER_8]
			l_sp: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_sp.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sp.item := tbuf.item
					inspect a_key -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					when 4 then l_pos := -1 + 4
					when 5 then l_pos := -1 + 5
					when 6 then l_pos := -1 + 6
					when 7 then l_pos := -1 + 7
					when 8 then l_pos := -1 + 8
					when 9 then l_pos := -1 + 9
					when 40 then l_pos := -1 + 10
					else l_pos := -1 + 11
					end
				when 1 then -- switch 1, case 1
					l_s := ltgetstr (ce_string ("kr"), l_sp)
					l_pos := -1 + 12 -- switch 1; break
				when 2 then -- switch 1, case 2
					l_s := ltgetstr (ce_string ("kl"), l_sp)
					l_pos := -1 + 12 -- switch 1; break
				when 3 then -- switch 1, case 3
					l_s := ltgetstr (ce_string ("ku"), l_sp)
					l_pos := -1 + 12 -- switch 1; break
				when 4 then -- switch 1, case 4
					l_s := ltgetstr (ce_string ("kd"), l_sp)
					l_pos := -1 + 12 -- switch 1; break
				when 5 then -- switch 1, case 5
					l_s := ltgetstr (ce_string ("kP"), l_sp)
					l_pos := -1 + 12 -- switch 1; break
				when 6 then -- switch 1, case 6
					l_s := ltgetstr (ce_string ("kN"), l_sp)
					l_pos := -1 + 12 -- switch 1; break
				when 7 then -- switch 1, case 7
					l_s := ltgetstr (ce_string ("kh"), l_sp)
					l_pos := -1 + 12 -- switch 1; break
				when 8 then -- switch 1, case 8
					l_s := ltgetstr (ce_string ("@7"), l_sp)
					l_pos := -1 + 12 -- switch 1; break
				when 9 then -- switch 1, case 9
					l_s := ltgetstr (ce_string ("kD"), l_sp)
					if l_s.is_void then
						tbuf.item[0] := (('%/127/').code).to_integer_8
						tbuf.item[1] := (('%/0/').code).to_integer_8
						l_s := tbuf.item
					end
					l_pos := -1 + 12 -- switch 1; break
				when 10 then -- switch 1, case 40
					tbuf.item[0] := (11).to_integer_8
					tbuf.item[1] := (('%/0/').code).to_integer_8
					l_s := tbuf.item
					l_pos := -1 + 12 -- switch 1; break
				when 11 then -- switch 1, default:
					Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
					l_return := True
				when 12 then -- switch 1, done:
					if not l_return then
						Result := l_s
					end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_term
		local
			l_sp: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_t1: CE_POINTER [INTEGER_8]
			l_t2: CE_POINTER [INTEGER_8]
			l_term: CE_POINTER [INTEGER_8]
			l_termbuf: CE_ARRAY [INTEGER_8]
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_sp.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_termbuf.make (<<2_048>>)

			l_term := (create {P_DECODE_STATIC}).lgetenv (ce_string ("TERM"))
			if l_term.is_void then
				l_term := ce_string ("unknown")
			end
			hardcopy.item := 0
			if (tgetent (l_termbuf, l_term)) <= 0 then
				hardcopy.item := 1
			end
			if (ltgetflag (ce_string ("hc"))).to_boolean then
				hardcopy.item := 1
			end
			scrsize;
			(create {P_POSITION_STATIC}).pos_init
			auto_wrap.item := ltgetflag (ce_string ("am"))
			ignaw.item := ltgetflag (ce_string ("xn"))
			above_mem.item := ltgetflag (ce_string ("da"))
			below_mem.item := ltgetflag (ce_string ("db"))
			clear_bg.item := ltgetflag (ce_string ("ut"))
			so_s_width.item := ltgetnum (ce_string ("sg"))
			if so_s_width.item < 0 then
				so_s_width.item := 0
			end
			so_e_width.item := so_s_width.item
			bo_e_width.item := so_s_width.item
			bo_s_width.item := bo_e_width.item
			ul_e_width.item := so_s_width.item
			ul_s_width.item := ul_e_width.item
			bl_e_width.item := so_s_width.item
			bl_s_width.item := bl_e_width.item
			if so_s_width.item > 0 then
				hilite_search.item.item := 0
			elseif so_e_width.item > 0 then
				hilite_search.item.item := 0
			end
			l_sp.item := sbuf.item
			sc_pad.item := ltgetstr (ce_string ("pc"), l_sp)
			if not sc_pad.item.is_void then
				Current.PC := sc_pad.item[0]
			end
			sc_s_keypad.item := ltgetstr (ce_string ("ks"), l_sp)
			if sc_s_keypad.item.is_void then
				sc_s_keypad.item := ce_string ("")
			end
			sc_e_keypad.item := ltgetstr (ce_string ("ke"), l_sp)
			if sc_e_keypad.item.is_void then
				sc_e_keypad.item := ce_string ("")
			end
			sc_init.item := ltgetstr (ce_string ("ti"), l_sp)
			if sc_init.item.is_void then
				sc_init.item := ce_string ("")
			end
			sc_deinit.item := ltgetstr (ce_string ("te"), l_sp)
			if sc_deinit.item.is_void then
				sc_deinit.item := ce_string ("")
			end
			sc_eol_clear.item := ltgetstr (ce_string ("ce"), l_sp)
			if sc_eol_clear.item.is_void then
				missing_cap.item := 1
				sc_eol_clear.item := ce_string ("")
			elseif (sc_eol_clear.item[0]).to_integer_32 = 0 then
				missing_cap.item := 1
				sc_eol_clear.item := ce_string ("")
			end
			sc_eos_clear.item := ltgetstr (ce_string ("cd"), l_sp)
			if below_mem.item.to_boolean then
				if sc_eos_clear.item.is_void then
					missing_cap.item := 1
					sc_eol_clear.item := ce_string ("")
				elseif (sc_eos_clear.item[0]).to_integer_32 = 0 then
					missing_cap.item := 1
					sc_eol_clear.item := ce_string ("")
				end
			end
			sc_clear.item := ltgetstr (ce_string ("cl"), l_sp)
			if sc_clear.item.is_void then
				missing_cap.item := 1
				sc_clear.item := ce_string ("%N%N")
			elseif (sc_clear.item[0]).to_integer_32 = 0 then
				missing_cap.item := 1
				sc_clear.item := ce_string ("%N%N")
			end
			sc_move.item := ltgetstr (ce_string ("cm"), l_sp)
			if sc_move.item.is_void then
				sc_move.item := ce_string ("")
				can_goto_line.item := 0
			elseif (sc_move.item[0]).to_integer_32 = 0 then
				sc_move.item := ce_string ("")
				can_goto_line.item := 0
			else
				can_goto_line.item := 1
			end
			tmodes (ce_string ("so"), ce_string ("se"), sc_s_in.item, sc_s_out.item, ce_string (""), ce_string (""), l_sp)
			tmodes (ce_string ("us"), ce_string ("ue"), sc_u_in.item, sc_u_out.item, sc_s_in.item.item, sc_s_out.item.item, l_sp)
			tmodes (ce_string ("md"), ce_string ("me"), sc_b_in.item, sc_b_out.item, sc_s_in.item.item, sc_s_out.item.item, l_sp)
			tmodes (ce_string ("mb"), ce_string ("me"), sc_bl_in.item, sc_bl_out.item, sc_s_in.item.item, sc_s_out.item.item, l_sp)
			sc_visual_bell.item := ltgetstr (ce_string ("vb"), l_sp)
			if sc_visual_bell.item.is_void then
				sc_visual_bell.item := ce_string ("")
			end
			if (ltgetflag (ce_string ("bs"))).to_boolean then
				sc_backspace.item := ce_string ("%B")
			else
				sc_backspace.item := ltgetstr (ce_string ("bc"), l_sp)
				if sc_backspace.item.is_void then
					sc_backspace.item := ce_string ("%B")
				elseif (sc_backspace.item[0]).to_integer_32 = 0 then
					sc_backspace.item := ce_string ("%B")
				end
			end
			l_t1 := ltgetstr (ce_string ("ho"), l_sp)
			if l_t1.is_void then
				l_t1 := ce_string ("")
			end
			if (sc_move.item[0]).to_integer_32 = 0 then
				l_t2 := ce_string ("")
			else
				strcpy (l_sp.item, (tgoto (sc_move.item, 0, 0))).do_nothing
				l_t2 := l_sp.item
				l_sp.item := l_sp.item + ((strlen (l_sp.item)) + {NATURAL_32} 1).to_integer_32
			end
			sc_home.item := cheaper (l_t1, l_t2, ce_string ("|%B^"))
			l_t1 := ltgetstr (ce_string ("ll"), l_sp)
			if l_t1.is_void then
				l_t1 := ce_string ("")
			end
			if (sc_move.item[0]).to_integer_32 = 0 then
				l_t2 := ce_string ("")
			else
				strcpy (l_sp.item, (tgoto (sc_move.item, 0, sc_height.item - 1))).do_nothing
				l_t2 := l_sp.item
				l_sp.item := l_sp.item + ((strlen (l_sp.item)) + {NATURAL_32} 1).to_integer_32
			end
			sc_lower_left.item := cheaper (l_t1, l_t2, ce_string ("%R"))
			l_t1 := ltgetstr (ce_string ("al"), l_sp)
			if l_t1.is_void then
				l_t1 := ce_string ("")
			end
			l_t2 := ltgetstr (ce_string ("sr"), l_sp)
			if l_t2.is_void then
				l_t2 := ce_string ("")
			end
			if above_mem.item.to_boolean then
				sc_addline.item := l_t1
			else
				sc_addline.item := cheaper (l_t1, l_t2, ce_string (""))
			end
			if (sc_addline.item[0]).to_integer_32 = 0 then
				(create {P_FORWBACK_STATIC}).no_back_scroll.item := 1
			end
		end

	inc_costcount (a_c: INTEGER_32): INTEGER_32
		do
			costcount.item := costcount.item + 1
			Result := a_c
		end

	cost (a_t: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			costcount.item := 0
			tputs (a_t, sc_height.item, inc_costcount_address).do_nothing
			Result := costcount.item
		end

	cheaper (a_t1, a_t2, a_def: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_t1.is_void
		local
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			if (a_t1[0]).to_integer_32 = 0 then
				if (a_t2[0]).to_integer_32 = 0 then
					missing_cap.item := 1
					Result := a_def
					l_return := True
				end
			end
			if not l_return and then ((a_t1[0]).to_integer_32 = 0) then
				Result := a_t2
				l_return := True
			end
			if not l_return and then ((a_t2[0]).to_integer_32 = 0) then
				Result := a_t1
				l_return := True
			end
			if not l_return then
				l_tmp := cost (a_t1)
				if l_tmp < (cost (a_t2)) then
					Result := a_t1
					l_return := True
				end
			end
			if not l_return then
				Result := a_t2
			end
		end

	tmodes (a_incap, a_outcap: CE_POINTER [INTEGER_8]; a_instr, a_outstr: CE_POINTER [CE_POINTER [INTEGER_8]]; a_def_instr, a_def_outstr: CE_POINTER [INTEGER_8]; a_spp: CE_POINTER [CE_POINTER [INTEGER_8]])
		require
			not a_incap.is_void
			not a_instr.is_void
			not a_outstr.is_void
		local
			l_return: BOOLEAN
		do
			a_instr.item := ltgetstr (a_incap, a_spp)
			if (a_instr.item).is_void then
				a_instr.item := a_def_instr
				a_outstr.item := a_def_outstr
				l_return := True
			end
			if not l_return then
				a_outstr.item := ltgetstr (a_outcap, a_spp)
				if (a_outstr.item).is_void then
					a_outstr.item := ltgetstr (ce_string ("me"), a_spp)
				end
				if (a_outstr.item).is_void then
					a_outstr.item := ce_string ("")
				end
			end
		end

	init
		do
			if not (no_init.item.item).to_boolean then
				tputs (sc_init.item, sc_height.item, (create {P_OUTPUT_STATIC}).putchr_address).do_nothing
			end
			if not (no_keypad.item.item).to_boolean then
				tputs (sc_s_keypad.item, sc_height.item, (create {P_OUTPUT_STATIC}).putchr_address).do_nothing
			end
			init_done.item := 1
		end

	deinit
		local
			l_return: BOOLEAN
		do
			if not init_done.item.to_boolean then
				l_return := True
			end
			if not l_return then
				if not (no_keypad.item.item).to_boolean then
					tputs (sc_e_keypad.item, sc_height.item, (create {P_OUTPUT_STATIC}).putchr_address).do_nothing
				end
				if not (no_init.item.item).to_boolean then
					tputs (sc_deinit.item, sc_height.item, (create {P_OUTPUT_STATIC}).putchr_address).do_nothing
				end
				init_done.item := 0
			end
		end

	home
		do
			tputs (sc_home.item, 1, (create {P_OUTPUT_STATIC}).putchr_address).do_nothing
		end

	add_line
		do
			tputs (sc_addline.item, sc_height.item, (create {P_OUTPUT_STATIC}).putchr_address).do_nothing
		end

	lower_left
		do
			tputs (sc_lower_left.item, 1, (create {P_OUTPUT_STATIC}).putchr_address).do_nothing
		end

	check_winch
		do
		end

	goto_line (a_slinenum: INTEGER_32)
		do
			tputs ((tgoto (sc_move.item, 0, a_slinenum)), 1, (create {P_OUTPUT_STATIC}).putchr_address).do_nothing
		end

	vbell
		local
			l_return: BOOLEAN
		do
			if (sc_visual_bell.item[0]).to_integer_32 = 0 then
				l_return := True
			end
			if not l_return then
				tputs (sc_visual_bell.item, sc_height.item, (create {P_OUTPUT_STATIC}).putchr_address).do_nothing
			end
		end

	beep
		do
			(create {P_OUTPUT_STATIC}).putchr (7).do_nothing
		end

	bell
		do
			if quiet.item.item = 2 then
				vbell
			else
				beep
			end
		end

	clear
		do
			tputs (sc_clear.item, sc_height.item, (create {P_OUTPUT_STATIC}).putchr_address).do_nothing
		end

	clear_eol
		do
			tputs (sc_eol_clear.item, 1, (create {P_OUTPUT_STATIC}).putchr_address).do_nothing
		end

	clear_eol_bot
		do
			if below_mem.item.to_boolean then
				tputs (sc_eos_clear.item, 1, (create {P_OUTPUT_STATIC}).putchr_address).do_nothing
			else
				tputs (sc_eol_clear.item, 1, (create {P_OUTPUT_STATIC}).putchr_address).do_nothing
			end
		end

	clear_bot
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					lower_left
					inspect attrmode.item -- switch 1 head
					when 5 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					when 3 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 5
					so_exit
					clear_eol_bot
					so_enter
					l_pos := -1 + 6 -- switch 1; break
				when 2 then -- switch 1, case 1
					ul_exit
					clear_eol_bot
					ul_enter
					l_pos := -1 + 6 -- switch 1; break
				when 3 then -- switch 1, case 2
					bo_exit
					clear_eol_bot
					bo_enter
					l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 3
					bl_exit
					clear_eol_bot
					bl_enter
					l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, default:
					clear_eol_bot
					l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	so_enter
		do
			tputs (sc_s_in.item.item, 1, (create {P_OUTPUT_STATIC}).putchr_address).do_nothing
			attrmode.item := 5
		end

	so_exit
		do
			tputs (sc_s_out.item.item, 1, (create {P_OUTPUT_STATIC}).putchr_address).do_nothing
			attrmode.item := 0
		end

	ul_enter
		do
			tputs (sc_u_in.item.item, 1, (create {P_OUTPUT_STATIC}).putchr_address).do_nothing
			attrmode.item := 1
		end

	ul_exit
		do
			tputs (sc_u_out.item.item, 1, (create {P_OUTPUT_STATIC}).putchr_address).do_nothing
			attrmode.item := 0
		end

	bo_enter
		do
			tputs (sc_b_in.item.item, 1, (create {P_OUTPUT_STATIC}).putchr_address).do_nothing
			attrmode.item := 2
		end

	bo_exit
		do
			tputs (sc_b_out.item.item, 1, (create {P_OUTPUT_STATIC}).putchr_address).do_nothing
			attrmode.item := 0
		end

	bl_enter
		do
			tputs (sc_bl_in.item.item, 1, (create {P_OUTPUT_STATIC}).putchr_address).do_nothing
			attrmode.item := 3
		end

	bl_exit
		do
			tputs (sc_bl_out.item.item, 1, (create {P_OUTPUT_STATIC}).putchr_address).do_nothing
			attrmode.item := 0
		end

	putbs
		do
			tputs (sc_backspace.item, 1, (create {P_OUTPUT_STATIC}).putchr_address).do_nothing
		end

feature {ANY} -- routine addresses

	inc_costcount_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent inc_costcount)
		end

end
