class
	S_TERMIOS_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	cfgetospeed (a___termios_p: CE_POINTER [SD_TERMIOS]): NATURAL_32
		do
			Result := c_cfgetospeed (a___termios_p.c_pointer)
		end

	c_cfgetospeed (a___termios_p: POINTER): NATURAL_32
		external
			"C inline use <less.h>"
		alias
			"return cfgetospeed($a___termios_p);"
		end

	tcgetattr (a___fd: INTEGER_32; a___termios_p: CE_POINTER [SD_TERMIOS]): INTEGER_32
		do
			Result := c_tcgetattr (a___fd, a___termios_p.c_pointer)
		end

	c_tcgetattr (a___fd: INTEGER_32; a___termios_p: POINTER): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return tcgetattr($a___fd, $a___termios_p);"
		end

	tcsetattr (a___fd, a___optional_actions: INTEGER_32; a___termios_p: CE_POINTER [SD_TERMIOS]): INTEGER_32
		do
			Result := c_tcsetattr (a___fd, a___optional_actions, a___termios_p.c_pointer)
		end

	c_tcsetattr (a___fd: INTEGER_32; a___optional_actions: INTEGER_32; a___termios_p: POINTER): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return tcsetattr($a___fd, $a___optional_actions, $a___termios_p);"
		end

end
