class
	P_COOKIES_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_STDIO_STATIC
	S_BITS_ERRNO_STATIC
	S_LIBINTL_STATIC
	S_TIME_STATIC
	S_STDLIB_STATIC
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public attributes

	cookies_now: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

feature {ANY} -- public routines

	cookie_jar_new: CE_POINTER [PD_COOKIE_JAR]
		local
			l_jar: CE_POINTER [PD_COOKIE_JAR]
		do
			l_jar := create {CE_CLASS_POINTER [PD_COOKIE_JAR]}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc ((create {PD_COOKIE_JAR}.make).structure_size.to_natural_32)))
			l_jar.item.chains := (create {P_HASH_STATIC}).make_nocase_string_hash_table (0)
			l_jar.item.cookie_count := 0
			Result := l_jar
		end

	cookie_new: CE_POINTER [PD_COOKIE]
		local
			l_cookie: CE_POINTER [PD_COOKIE]
		do
			l_cookie := create {CE_CLASS_POINTER [PD_COOKIE]}.make_cast (((create {P_XMALLOC_STATIC}).xcalloc ((1).to_natural_32, (create {PD_COOKIE}.make).structure_size.to_natural_32)))
			l_cookie.item.port := -1
			Result := l_cookie
		end

	numeric_address_p (a_addr: CE_POINTER [INTEGER_8]): BOOLEAN
		require
			not a_addr.is_void
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			l_p___0 := a_addr
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_p___0[0]).to_integer_32)) then
					Result := (0).to_boolean
					l_return := True
				end
				if not l_return then
					l_p___0 := l_p___0 + 1
					from
					until
						(l_break)
					loop
						l_break := False
						if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_p___0[0]).to_integer_32)) then
							l_break := True
						end
						if not (l_break) then
							l_p___0 := l_p___0 + 1
						end
					end
					l_break := False
					l_break := True
				end
			end
			if not l_return then
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_tmp___1 := l_p___0
					l_p___0 := l_p___0 + 1
					if (l_tmp___1[0]).to_integer_32 /= 46 then
						Result := (0).to_boolean
						l_return := True
					end
					if not l_return then
						l_break := True
					end
				end
			end
			if not l_return then
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_p___0[0]).to_integer_32)) then
						Result := (0).to_boolean
						l_return := True
					end
					if not l_return then
						l_p___0 := l_p___0 + 1
						from
						until
							(l_break)
						loop
							l_break := False
							if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_p___0[0]).to_integer_32)) then
								l_break := True
							end
							if not (l_return or l_break) then
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
						l_break := True
					end
				end
			end
			if not l_return then
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_tmp___4 := l_p___0
					l_p___0 := l_p___0 + 1
					if (l_tmp___4[0]).to_integer_32 /= 46 then
						Result := (0).to_boolean
						l_return := True
					end
					if not l_return then
						l_break := True
					end
				end
			end
			if not l_return then
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_p___0[0]).to_integer_32)) then
						Result := (0).to_boolean
						l_return := True
					end
					if not l_return then
						l_p___0 := l_p___0 + 1
						from
						until
							(l_break)
						loop
							l_break := False
							if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_p___0[0]).to_integer_32)) then
								l_break := True
							end
							if not (l_return or l_break) then
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
						l_break := True
					end
				end
			end
			if not l_return then
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_tmp___7 := l_p___0
					l_p___0 := l_p___0 + 1
					if (l_tmp___7[0]).to_integer_32 /= 46 then
						Result := (0).to_boolean
						l_return := True
					end
					if not l_return then
						l_break := True
					end
				end
			end
			if not l_return then
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_p___0[0]).to_integer_32)) then
						Result := (0).to_boolean
						l_return := True
					end
					if not l_return then
						l_p___0 := l_p___0 + 1
						from
						until
							(l_break)
						loop
							l_break := False
							if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_p___0[0]).to_integer_32)) then
								l_break := True
							end
							if not (l_return or l_break) then
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
						l_break := True
					end
				end
			end
			if not l_return then
				l_break := False
				if (l_p___0[0]).to_integer_32 /= 0 then
					Result := (0).to_boolean
					l_return := True
				end
			end
			if not l_return then
				Result := (1).to_boolean
			end
		end

	path_matches (a_full_path, a_prefix: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_full_path.is_void
			not a_prefix.is_void
		local
			l_len: INTEGER_32
			l_return: BOOLEAN
		do
			l_len := (strlen (a_prefix)).to_integer_32
			if 0 /= (strncmp (a_full_path, a_prefix, l_len.to_natural_32)) then
				Result := 0
				l_return := True
			end
			if not l_return then
				Result := (l_len + 1)
			end
		end

	equality_comparator (a_p1, a_p2: CE_POINTER [ANY]): INTEGER_32
		local
			l_wc1: CE_POINTER [PD_WEIGHED_COOKIE]
			l_wc2: CE_POINTER [PD_WEIGHED_COOKIE]
			l_namecmp: INTEGER_32
			l_valuecmp: INTEGER_32
			l_tmp___1: INTEGER_32
		do
			l_wc1 := create {CE_CLASS_POINTER [PD_WEIGHED_COOKIE]}.make_cast (a_p1)
			l_wc2 := create {CE_CLASS_POINTER [PD_WEIGHED_COOKIE]}.make_cast (a_p2)
			l_namecmp := (strcmp ((l_wc1.item.cookie).item.attr, (l_wc2.item.cookie).item.attr))
			l_valuecmp := (strcmp ((l_wc1.item.cookie).item.value, (l_wc2.item.cookie).item.value))
			if l_namecmp.to_boolean then
				l_tmp___1 := l_namecmp
			else
				l_tmp___1 := l_valuecmp
			end
			Result := l_tmp___1
		end

	goodness_comparator (a_p1, a_p2: CE_POINTER [ANY]): INTEGER_32
		local
			l_wc1: CE_POINTER [PD_WEIGHED_COOKIE]
			l_wc2: CE_POINTER [PD_WEIGHED_COOKIE]
			l_dgdiff: INTEGER_32
			l_pgdiff: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_wc1 := create {CE_CLASS_POINTER [PD_WEIGHED_COOKIE]}.make_cast (a_p1)
			l_wc2 := create {CE_CLASS_POINTER [PD_WEIGHED_COOKIE]}.make_cast (a_p2)
			l_dgdiff := l_wc2.item.domain_goodness - l_wc1.item.domain_goodness
			l_pgdiff := l_wc2.item.path_goodness - l_wc1.item.path_goodness
			if l_dgdiff.to_boolean then
				l_tmp := l_dgdiff
			else
				l_tmp := l_pgdiff
			end
			Result := l_tmp
		end

	domain_port (a_domain_b, a_domain_e: CE_POINTER [INTEGER_8]; a_domain_e_ptr: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_port: INTEGER_32
			l_p___0: CE_POINTER [INTEGER_8]
			l_colon: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			l_port := 0
			l_colon := create {CE_INTEGER_8_POINTER}.make_cast ((memchr (create {CE_VOID_POINTER}.make_cast (a_domain_b), (':').code, (a_domain_e.distance (a_domain_b)).to_natural_32)))
			if l_colon.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_p___0 := l_colon + 1
				from
				until
					(l_break)
				loop
					l_break := False
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_domain_e.c_pointer.to_integer_32).to_natural_32 then
						if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_p___0[0]).to_integer_32)) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_port := 10 * l_port + ((l_p___0[0]).to_integer_32 - 48)
						l_p___0 := l_p___0 + 1
					end
				end
				l_break := False
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_domain_e.c_pointer.to_integer_32).to_natural_32 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				a_domain_e_ptr.item := l_colon
				Result := l_port
			end
		end

	cookie_jar_load (a_jar: CE_POINTER [PD_COOKIE_JAR]; a_file: CE_POINTER [INTEGER_8])
		local
			l_line: CE_POINTER [INTEGER_8]
			l_fp: CE_POINTER [SD_IO_FILE]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_cookie: CE_POINTER [PD_COOKIE]
			l_p___0: CE_POINTER [INTEGER_8]
			l_expiry: CE_ARRAY [REAL_64]
			l_port: INTEGER_32
			l_domain_b: CE_POINTER [INTEGER_8]
			l_domain_e: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_domflag_b: CE_POINTER [INTEGER_8]
			l_domflag_e: CE_POINTER [INTEGER_8]
			l_path_b: CE_POINTER [INTEGER_8]
			l_path_e: CE_POINTER [INTEGER_8]
			l_secure_b: CE_POINTER [INTEGER_8]
			l_secure_e: CE_POINTER [INTEGER_8]
			l_expires_b: CE_POINTER [INTEGER_8]
			l_expires_e: CE_POINTER [INTEGER_8]
			l_name_b: CE_POINTER [INTEGER_8]
			l_name_e: CE_POINTER [INTEGER_8]
			l_value_b: CE_POINTER [INTEGER_8]
			l_value_e: CE_POINTER [INTEGER_8]
			l_tmp___7: INTEGER_32
			l_tmp___9: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_POINTER [PD_COOKIE]} l_cookie.make
			create {CE_INTEGER_8_POINTER} l_p___0.make
			create {CE_REAL_64_ARRAY} l_expiry.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_domain_e.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fp := (fopen (a_file, ce_string ("r")))
					if l_fp.is_void then
						l_tmp___1 := strerror ((errno_location).item)
						l_tmp___2 := (create {P_QUOTE_STATIC}).quote (a_file);
						(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Cannot open cookies file %%s: %%s%N"))), l_tmp___2, l_tmp___1])
						l_return := True
					end
					if l_return then
						l_pos := -1 + 36 -- skip if block
					end
				when 1 then -- if:
						cookies_now.item := time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
				when 2 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 35 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_continue := False
						l_line := (create {P_UTILS_STATIC}).read_whole_line (l_fp)
						if l_line.is_void then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_p___0 := l_line
							l_domain_b := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							l_domain_e.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							l_domflag_b := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							l_domflag_e := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							l_path_b := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							l_path_e := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							l_secure_b := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							l_secure_e := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							l_expires_b := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							l_expires_e := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							l_name_b := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							l_name_e := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							l_value_b := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							l_value_e := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_p___0[0]).to_boolean then
									if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_p___0[0]).to_integer_32)) then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_p___0 := l_p___0 + 1
								end
							end
							l_break := False
							if not (l_p___0[0]).to_boolean then
								l_continue := True
							elseif (l_p___0[0]).to_integer_32 = 35 then
								l_continue := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 32 -- skip if block
						end
				when 4 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 7 -- skip loop
						end
				when 5 then -- loop body:
						l_break := False
						l_domain_b := l_p___0
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p___0[0]).to_boolean then
								if (l_p___0[0]).to_integer_32 = 9 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
						l_domain_e.item := l_p___0
						if l_domain_b.is_equal (l_domain_e.item) then
							l_pos := -1 + 31 -- goto next
						elseif not (l_p___0[0]).to_boolean then
							l_pos := -1 + 31 -- goto next
						end
				when 6 then
						l_p___0 := l_p___0 + 1
						l_break := True
						l_pos := -1 + 4 -- back to loop condition
				when 7 then -- loop done
						l_break := False
				when 8 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 11 -- skip loop
						end
				when 9 then -- loop body:
						l_break := False
						l_domflag_b := l_p___0
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p___0[0]).to_boolean then
								if (l_p___0[0]).to_integer_32 = 9 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
						l_domflag_e := l_p___0
						if l_domflag_b.is_equal (l_domflag_e) then
							l_pos := -1 + 31 -- goto next
						elseif not (l_p___0[0]).to_boolean then
							l_pos := -1 + 31 -- goto next
						end
				when 10 then
						l_p___0 := l_p___0 + 1
						l_break := True
						l_pos := -1 + 8 -- back to loop condition
				when 11 then -- loop done
						l_break := False
				when 12 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 15 -- skip loop
						end
				when 13 then -- loop body:
						l_break := False
						l_path_b := l_p___0
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p___0[0]).to_boolean then
								if (l_p___0[0]).to_integer_32 = 9 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
						l_path_e := l_p___0
						if l_path_b.is_equal (l_path_e) then
							l_pos := -1 + 31 -- goto next
						elseif not (l_p___0[0]).to_boolean then
							l_pos := -1 + 31 -- goto next
						end
				when 14 then
						l_p___0 := l_p___0 + 1
						l_break := True
						l_pos := -1 + 12 -- back to loop condition
				when 15 then -- loop done
						l_break := False
				when 16 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 19 -- skip loop
						end
				when 17 then -- loop body:
						l_break := False
						l_secure_b := l_p___0
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p___0[0]).to_boolean then
								if (l_p___0[0]).to_integer_32 = 9 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
						l_secure_e := l_p___0
						if l_secure_b.is_equal (l_secure_e) then
							l_pos := -1 + 31 -- goto next
						elseif not (l_p___0[0]).to_boolean then
							l_pos := -1 + 31 -- goto next
						end
				when 18 then
						l_p___0 := l_p___0 + 1
						l_break := True
						l_pos := -1 + 16 -- back to loop condition
				when 19 then -- loop done
						l_break := False
				when 20 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 23 -- skip loop
						end
				when 21 then -- loop body:
						l_break := False
						l_expires_b := l_p___0
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p___0[0]).to_boolean then
								if (l_p___0[0]).to_integer_32 = 9 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
						l_expires_e := l_p___0
						if l_expires_b.is_equal (l_expires_e) then
							l_pos := -1 + 31 -- goto next
						elseif not (l_p___0[0]).to_boolean then
							l_pos := -1 + 31 -- goto next
						end
				when 22 then
						l_p___0 := l_p___0 + 1
						l_break := True
						l_pos := -1 + 20 -- back to loop condition
				when 23 then -- loop done
						l_break := False
				when 24 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 27 -- skip loop
						end
				when 25 then -- loop body:
						l_break := False
						l_name_b := l_p___0
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p___0[0]).to_boolean then
								if (l_p___0[0]).to_integer_32 = 9 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
						l_name_e := l_p___0
						if l_name_b.is_equal (l_name_e) then
							l_pos := -1 + 31 -- goto next
						elseif not (l_p___0[0]).to_boolean then
							l_pos := -1 + 31 -- goto next
						end
				when 26 then
						l_p___0 := l_p___0 + 1
						l_break := True
						l_pos := -1 + 24 -- back to loop condition
				when 27 then -- loop done
						l_break := False
						l_value_b := l_p___0
						l_value_e := l_p___0 + (strlen (l_p___0)).to_integer_32
						if (l_value_e.c_pointer.to_integer_32).to_natural_32 > (l_value_b.c_pointer.to_integer_32).to_natural_32 then
							if (l_value_e[-1]).to_integer_32 = 10 then
								l_value_e := l_value_e - 1
							end
						end
						if (l_value_e.c_pointer.to_integer_32).to_natural_32 > (l_value_b.c_pointer.to_integer_32).to_natural_32 then
							if (l_value_e[-1]).to_integer_32 = 13 then
								l_value_e := l_value_e - 1
							end
						end
						l_cookie := cookie_new
						l_cookie.item.attr := (create {P_UTILS_STATIC}).strdupdelim (l_name_b, l_name_e)
						l_cookie.item.value := (create {P_UTILS_STATIC}).strdupdelim (l_value_b, l_value_e)
						l_cookie.item.path := (create {P_UTILS_STATIC}).strdupdelim (l_path_b, l_path_e)
						if (l_secure_e.distance (l_secure_b)).to_natural_32 = (("TRUE").count + 1).to_natural_32 - {NATURAL_32} 1 then
							if (memcmp (create {CE_VOID_POINTER}.make_cast (l_secure_b), create {CE_VOID_POINTER}.make_cast (ce_string ("TRUE")), (("TRUE").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean then
								l_tmp___7 := 0
							else
								l_tmp___7 := 1
							end
						else
							l_tmp___7 := 0
						end
						l_cookie.item.secure := l_tmp___7.to_natural_32
						if (l_domflag_e.distance (l_domflag_b)).to_natural_32 = (("TRUE").count + 1).to_natural_32 - {NATURAL_32} 1 then
							if (memcmp (create {CE_VOID_POINTER}.make_cast (l_domflag_b), create {CE_VOID_POINTER}.make_cast (ce_string ("TRUE")), (("TRUE").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean then
								l_tmp___9 := 1
							else
								l_tmp___9 := 0
							end
						else
							l_tmp___9 := 1
						end
						l_cookie.item.domain_exact := l_tmp___9.to_natural_32
						l_port := domain_port (l_domain_b, l_domain_e.item, l_domain_e)
						if l_port.to_boolean then
							l_cookie.item.port := l_port
						end
						if (l_domain_b[0]).to_integer_32 = 46 then
							l_domain_b := l_domain_b + 1
						end
						l_cookie.item.domain := (create {P_UTILS_STATIC}).strdupdelim (l_domain_b, l_domain_e.item)
						l_expiry.item := cookies_now.item.to_double - (1).to_double
						l_expires_e[0] := (('%/0/').code).to_integer_8
						sscanf ([l_expires_b, ce_string ("%%lf"), l_expiry]).do_nothing
						if (l_expiry.item = (0).to_double) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						if l_expiry.item < cookies_now.item.to_double then
							l_pos := -1 + 33 -- goto abort_cookie
						end
				when 29 then
						l_cookie.item.expiry_time := (l_expiry.item).truncated_to_integer
						l_cookie.item.permanent := {NATURAL_32} 1
				when 30 then -- if done
						a_jar.item.store_cookie (l_cookie)
				when 31 then -- next:
						l_continue := True
				when 32 then -- if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 34 -- skip if block
						end
				when 33 then -- if: | abort_cookie:
						l_cookie.item.delete_cookie
				when 34 then -- if done
						if (not l_return and not l_break) then
							free (create {CE_VOID_POINTER}.make_cast (l_line))
						end
						l_pos := -1 + 2 -- back to loop condition
				when 35 then -- loop done
						l_break := False
						l_continue := False
						fclose (l_fp).do_nothing
				when 36 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cookie_jar_save (a_jar: CE_POINTER [PD_COOKIE_JAR]; a_file: CE_POINTER [INTEGER_8])
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_iter: CE_ARRAY [PD_HASH_TABLE_ITERATOR]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_domain: CE_POINTER [INTEGER_8]
			l_cookie: CE_POINTER [PD_COOKIE]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_tmp___17: CE_POINTER [INTEGER_8]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_HASH_TABLE_ITERATOR]} l_iter.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					from
					until
						(l_break)
					loop
						l_break := False
						if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
							(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Saving cookies to %%s.%N"), a_file])
						end
						l_break := True
					end
					l_break := False
					cookies_now.item := time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
					l_fp := fopen (a_file, ce_string ("w"))
					if l_fp.is_void then
						l_tmp___1 := strerror ((errno_location).item)
						l_tmp___2 := (create {P_QUOTE_STATIC}).quote (a_file);
						(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Cannot open cookies file %%s: %%s%N"))), l_tmp___2, l_tmp___1])
						l_return := True
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						fputs (ce_string ("# HTTP cookie file.%N"), l_fp).do_nothing
						fprintf ([l_fp, ce_string ("# Generated by Wget on %%s.%N"), ((create {P_UTILS_STATIC}).datetime_str (cookies_now.item))]).do_nothing
						fputs (ce_string ("# Edit at your own risk.%N%N"), l_fp).do_nothing;
						(a_jar.item.chains).item.hash_table_iterate (l_iter)
				when 2 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if not (l_iter.item.hash_table_iter_next).to_boolean then
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						l_domain := create {CE_INTEGER_8_POINTER}.make_cast (l_iter.item.key)
						l_cookie := create {CE_CLASS_POINTER [PD_COOKIE]}.make_cast (l_iter.item.value)
				when 5 then -- loop condition:
						if l_cookie.is_void then
							l_pos := -1 + 8 -- skip loop
						end
				when 6 then -- loop body:
						l_continue := False
						if not (l_cookie.item.permanent).to_boolean then
							if not (create {P_OPTIONS_STATIC}).opt.item.item.keep_session_cookies then
								l_continue := True
							end
						end
						if not (l_break or l_continue) then
							if (l_cookie.item.cookie_expired_p) then
								l_continue := True
							end
						end
						if not (l_break or l_continue) then
							if not (l_cookie.item.domain_exact).to_boolean then
								fputc (('.').code, l_fp).do_nothing
							end
							fputs (l_domain, l_fp).do_nothing
							if l_cookie.item.port /= -1 then
								fprintf ([l_fp, ce_string (":%%d"), l_cookie.item.port]).do_nothing
							end
							if (l_cookie.item.secure).to_boolean then
								l_tmp___6 := ce_string ("TRUE")
							else
								l_tmp___6 := ce_string ("FALSE")
							end
							if (l_cookie.item.domain_exact).to_boolean then
								l_tmp___7 := ce_string ("FALSE")
							else
								l_tmp___7 := ce_string ("TRUE")
							end
							fprintf ([l_fp, ce_string ("%T%%s%T%%s%T%%s%T%%.0f%T%%s%T%%s%N"), l_tmp___7, l_cookie.item.path, l_tmp___6, (l_cookie.item.expiry_time).to_double, l_cookie.item.attr, l_cookie.item.value]).do_nothing
							if (ferror (l_fp)).to_boolean then
								l_pos := -1 + 11 -- goto out
							end
						end
				when 7 then
						l_cookie := l_cookie.item.next
						l_pos := -1 + 5 -- back to loop condition
				when 8 then -- loop done
						l_continue := False
				when 9 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done
						l_break := False
				when 11 then -- out:
						if (ferror (l_fp)).to_boolean then
							l_tmp___11 := strerror ((errno_location).item)
							l_tmp___12 := (create {P_QUOTE_STATIC}).quote (a_file);
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Error writing to %%s: %%s%N"))), l_tmp___12, l_tmp___11])
						end
						if (fclose (l_fp)) < 0 then
							l_tmp___16 := strerror ((errno_location).item)
							l_tmp___17 := (create {P_QUOTE_STATIC}).quote (a_file);
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Error closing %%s: %%s%N"))), l_tmp___17, l_tmp___16])
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Done saving cookies.%N")])
							end
							l_break := True
						end
						l_break := False
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY} -- routine addresses

	equality_comparator_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent equality_comparator)
		end

	goodness_comparator_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent goodness_comparator)
		end

end
