class
	P_HTML_URL_STATIC

inherit
	CE_UTILITIES
	S_BITS_ERRNO_STATIC
	S_STRING_STATIC
	S_GCC_BUILTIN_STATIC
	S_STDLIB_STATIC
	S_LIBINTL_STATIC

feature {ANY} -- public attributes

	known_tags: CE_STATIC [CE_ARRAY [PD_KNOWN_TAG]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_KNOWN_TAG]}.make_initialized (<<
					create {PD_KNOWN_TAG}.make_initialized ([0, ce_string ("a"), (create {PD_TAGINFO_STATIC}).tag_find_urls_address]),
					create {PD_KNOWN_TAG}.make_initialized ([1, ce_string ("applet"), (create {PD_TAGINFO_STATIC}).tag_find_urls_address]),
					create {PD_KNOWN_TAG}.make_initialized ([2, ce_string ("area"), (create {PD_TAGINFO_STATIC}).tag_find_urls_address]),
					create {PD_KNOWN_TAG}.make_initialized ([3, ce_string ("base"), (create {PD_TAGINFO_STATIC}).tag_handle_base_address]),
					create {PD_KNOWN_TAG}.make_initialized ([4, ce_string ("bgsound"), (create {PD_TAGINFO_STATIC}).tag_find_urls_address]),
					create {PD_KNOWN_TAG}.make_initialized ([5, ce_string ("body"), (create {PD_TAGINFO_STATIC}).tag_find_urls_address]),
					create {PD_KNOWN_TAG}.make_initialized ([6, ce_string ("embed"), (create {PD_TAGINFO_STATIC}).tag_find_urls_address]),
					create {PD_KNOWN_TAG}.make_initialized ([7, ce_string ("fig"), (create {PD_TAGINFO_STATIC}).tag_find_urls_address]),
					create {PD_KNOWN_TAG}.make_initialized ([8, ce_string ("form"), (create {PD_TAGINFO_STATIC}).tag_handle_form_address]),
					create {PD_KNOWN_TAG}.make_initialized ([9, ce_string ("frame"), (create {PD_TAGINFO_STATIC}).tag_find_urls_address]),
					create {PD_KNOWN_TAG}.make_initialized ([10, ce_string ("iframe"), (create {PD_TAGINFO_STATIC}).tag_find_urls_address]),
					create {PD_KNOWN_TAG}.make_initialized ([11, ce_string ("img"), (create {PD_TAGINFO_STATIC}).tag_find_urls_address]),
					create {PD_KNOWN_TAG}.make_initialized ([12, ce_string ("input"), (create {PD_TAGINFO_STATIC}).tag_find_urls_address]),
					create {PD_KNOWN_TAG}.make_initialized ([13, ce_string ("layer"), (create {PD_TAGINFO_STATIC}).tag_find_urls_address]),
					create {PD_KNOWN_TAG}.make_initialized ([14, ce_string ("link"), (create {PD_TAGINFO_STATIC}).tag_handle_link_address]),
					create {PD_KNOWN_TAG}.make_initialized ([15, ce_string ("meta"), (create {PD_TAGINFO_STATIC}).tag_handle_meta_address]),
					create {PD_KNOWN_TAG}.make_initialized ([16, ce_string ("object"), (create {PD_TAGINFO_STATIC}).tag_find_urls_address]),
					create {PD_KNOWN_TAG}.make_initialized ([17, ce_string ("overlay"), (create {PD_TAGINFO_STATIC}).tag_find_urls_address]),
					create {PD_KNOWN_TAG}.make_initialized ([18, ce_string ("script"), (create {PD_TAGINFO_STATIC}).tag_find_urls_address]),
					create {PD_KNOWN_TAG}.make_initialized ([19, ce_string ("table"), (create {PD_TAGINFO_STATIC}).tag_find_urls_address]),
					create {PD_KNOWN_TAG}.make_initialized ([20, ce_string ("td"), (create {PD_TAGINFO_STATIC}).tag_find_urls_address]),
					create {PD_KNOWN_TAG}.make_initialized ([21, ce_string ("th"), (create {PD_TAGINFO_STATIC}).tag_find_urls_address])
				>>)
		end

	tag_url_attributes: CE_STATIC [CE_ARRAY [PD_TAG_URL_ATTRIBUTES]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_TAG_URL_ATTRIBUTES]}.make_initialized (<<
					create {PD_TAG_URL_ATTRIBUTES}.make_initialized ([0, ce_string ("href"), 2]),
					create {PD_TAG_URL_ATTRIBUTES}.make_initialized ([1, ce_string ("code"), 1]),
					create {PD_TAG_URL_ATTRIBUTES}.make_initialized ([2, ce_string ("href"), 2]),
					create {PD_TAG_URL_ATTRIBUTES}.make_initialized ([4, ce_string ("src"), 1]),
					create {PD_TAG_URL_ATTRIBUTES}.make_initialized ([5, ce_string ("background"), 1]),
					create {PD_TAG_URL_ATTRIBUTES}.make_initialized ([6, ce_string ("href"), 2]),
					create {PD_TAG_URL_ATTRIBUTES}.make_initialized ([6, ce_string ("src"), 3]),
					create {PD_TAG_URL_ATTRIBUTES}.make_initialized ([7, ce_string ("src"), 1]),
					create {PD_TAG_URL_ATTRIBUTES}.make_initialized ([9, ce_string ("src"), 3]),
					create {PD_TAG_URL_ATTRIBUTES}.make_initialized ([10, ce_string ("src"), 3]),
					create {PD_TAG_URL_ATTRIBUTES}.make_initialized ([11, ce_string ("href"), 1]),
					create {PD_TAG_URL_ATTRIBUTES}.make_initialized ([11, ce_string ("lowsrc"), 1]),
					create {PD_TAG_URL_ATTRIBUTES}.make_initialized ([11, ce_string ("src"), 1]),
					create {PD_TAG_URL_ATTRIBUTES}.make_initialized ([12, ce_string ("src"), 1]),
					create {PD_TAG_URL_ATTRIBUTES}.make_initialized ([13, ce_string ("src"), 3]),
					create {PD_TAG_URL_ATTRIBUTES}.make_initialized ([16, ce_string ("data"), 1]),
					create {PD_TAG_URL_ATTRIBUTES}.make_initialized ([17, ce_string ("src"), 3]),
					create {PD_TAG_URL_ATTRIBUTES}.make_initialized ([18, ce_string ("src"), 1]),
					create {PD_TAG_URL_ATTRIBUTES}.make_initialized ([19, ce_string ("background"), 1]),
					create {PD_TAG_URL_ATTRIBUTES}.make_initialized ([20, ce_string ("background"), 1]),
					create {PD_TAG_URL_ATTRIBUTES}.make_initialized ([21, ce_string ("background"), 1])
				>>)
		end

	additional_attributes: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("rel"),
					ce_string ("http-equiv"),
					ce_string ("name"),
					ce_string ("content"),
					ce_string ("action"),
					ce_string ("style")
				>>)
		end

	interesting_tags: CE_STATIC [CE_POINTER [PD_HASH_TABLE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_HASH_TABLE]}.make
		end

	interesting_attributes: CE_STATIC [CE_POINTER [PD_HASH_TABLE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_HASH_TABLE]}.make
		end

	meta_charset: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

feature {ANY} -- public routines

	init_interesting
		local
			l_i: NATURAL_32
			l_ignored: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_intersect: CE_POINTER [PD_HASH_TABLE]
			l_followed: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_t: CE_POINTER [PD_KNOWN_TAG]
			l_continue: BOOLEAN
		do
			interesting_tags.item := (create {P_HASH_STATIC}).make_nocase_string_hash_table ((((create {PD_KNOWN_TAG}.make).structure_size.to_natural_32 * (22).to_natural_32) // (create {PD_KNOWN_TAG}.make).structure_size.to_natural_32).to_integer_32)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < ((create {PD_KNOWN_TAG}.make).structure_size.to_natural_32 * (22).to_natural_32) // (create {PD_KNOWN_TAG}.make).structure_size.to_natural_32)
			loop
				interesting_tags.item.item.hash_table_put (create {CE_VOID_POINTER}.make_cast (known_tags.item[l_i.to_integer_32].name), create {CE_VOID_POINTER}.make_cast ((known_tags.item + l_i.to_integer_32)))
				l_i := l_i + 1
			end
			if (not ((create {P_OPTIONS_STATIC}).opt.item.item.ignore_tags).is_void) then
				l_ignored := (create {P_OPTIONS_STATIC}).opt.item.item.ignore_tags
				from
				until
					(l_ignored.item).is_void
				loop
					interesting_tags.item.item.hash_table_remove (create {CE_VOID_POINTER}.make_cast (l_ignored.item)).do_nothing
					l_ignored := l_ignored + 1
				end
			end
			if (not ((create {P_OPTIONS_STATIC}).opt.item.item.follow_tags).is_void) then
				l_intersect := ((create {P_HASH_STATIC}).make_nocase_string_hash_table (0))
				l_followed := (create {P_OPTIONS_STATIC}).opt.item.item.follow_tags
				from
				until
					(l_followed.item).is_void
				loop
					l_continue := False
					l_t := create {CE_CLASS_POINTER [PD_KNOWN_TAG]}.make_cast ((interesting_tags.item.item.hash_table_get (create {CE_VOID_POINTER}.make_cast (l_followed.item))))
					if l_t.is_void then
						l_continue := True
					end
					if not (l_continue) then
						l_intersect.item.hash_table_put (create {CE_VOID_POINTER}.make_cast (l_followed.item), create {CE_VOID_POINTER}.make_cast (l_t))
					end
					l_followed := l_followed + 1
				end
				l_continue := False
				interesting_tags.item.item.hash_table_destroy
				interesting_tags.item := l_intersect
			end
			interesting_attributes.item := (create {P_HASH_STATIC}).make_nocase_string_hash_table (10)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < ({PLATFORM}.Pointer_bytes.to_natural_32 * (6).to_natural_32) // {PLATFORM}.Pointer_bytes.to_natural_32)
			loop
				interesting_attributes.item.item.hash_table_put (create {CE_VOID_POINTER}.make_cast (additional_attributes.item[l_i.to_integer_32]), create {CE_VOID_POINTER}.make_cast (ce_string ("1")))
				l_i := l_i + 1
			end
			l_i := (0).to_natural_32
			from
			until
				not (l_i < ((create {PD_TAG_URL_ATTRIBUTES}.make).structure_size.to_natural_32 * (21).to_natural_32) // (create {PD_TAG_URL_ATTRIBUTES}.make).structure_size.to_natural_32)
			loop
				interesting_attributes.item.item.hash_table_put (create {CE_VOID_POINTER}.make_cast (tag_url_attributes.item[l_i.to_integer_32].attr_name), create {CE_VOID_POINTER}.make_cast (ce_string ("1")))
				l_i := l_i + 1
			end
		end

	get_urls_html (a_file, a_url: CE_POINTER [INTEGER_8]; a_meta_disallow_follow: CE_POINTER [BOOLEAN]; a_iri: CE_POINTER [PD_IRI]): CE_POINTER [PD_URLPOS]
		local
			l_fm: CE_POINTER [PD_FILE_MEMORY]
			l_ctx: CE_ARRAY [PD_MAP_CONTEXT]
			l_flags: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_MAP_CONTEXT]} l_ctx.make (<<1>>)

			l_fm := (create {P_UTILS_STATIC}).read_file (a_file)
			if l_fm.is_void then
				(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s%N"), a_file, (strerror ((errno_location).item))])
				Result := (create {CE_CLASS_POINTER [PD_URLPOS]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
						(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Loaded %%s (size %%s).%N"), a_file, ((create {P_UTILS_STATIC}).number_to_static_string ((l_fm.item.length).to_integer_64))])
					end
					l_break := True
				end
				l_break := False
				l_ctx.item.text := l_fm.item.content
				l_ctx.item.tail := create {CE_CLASS_POINTER [PD_URLPOS]}.make_shared (default_pointer)
				l_ctx.item.head := l_ctx.item.tail
				l_ctx.item.base := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				if (not a_url.is_void) then
					l_ctx.item.parent_base := a_url
				else
					l_ctx.item.parent_base := (create {P_OPTIONS_STATIC}).opt.item.item.base_href
				end
				l_ctx.item.document_file := a_file
				l_ctx.item.nofollow := (0).to_boolean
				if interesting_tags.item.is_void then
					init_interesting
				end
				l_flags := 2
				if (create {P_OPTIONS_STATIC}).opt.item.item.strict_comments then
					l_flags := (l_flags).bit_or ((1))
				end
				(create {P_HTML_PARSE_STATIC}).map_html_tags (l_fm.item.content, (l_fm.item.length).to_integer_32, (create {PD_TAGINFO_STATIC}).collect_tags_mapper_address, create {CE_VOID_POINTER}.make_cast (l_ctx), l_flags, create {CE_CLASS_POINTER [PD_HASH_TABLE]}.make_shared (default_pointer), interesting_attributes.item)
				if (not a_iri.is_void) then
					if (not meta_charset.item.is_void) then
						l_tmp___3 := 1
					else
						l_tmp___3 := 0
					end
				else
					l_tmp___3 := 0
				end
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
						(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("no-follow in %%s: %%d%N"), a_file, (l_ctx.item.nofollow).to_integer])
					end
					l_break := True
				end
				l_break := False
				if (not a_meta_disallow_follow.is_void) then
					a_meta_disallow_follow.item := l_ctx.item.nofollow
				end
				if (not (l_ctx.item.base).is_void) then
					free (create {CE_VOID_POINTER}.make_cast (l_ctx.item.base))
				end
				l_fm.item.read_file_free
				Result := (l_ctx.item.head)
			end
		end

	get_urls_file (a_file: CE_POINTER [INTEGER_8]): CE_POINTER [PD_URLPOS]
		local
			l_fm: CE_POINTER [PD_FILE_MEMORY]
			l_head: CE_POINTER [PD_URLPOS]
			l_tail: CE_POINTER [PD_URLPOS]
			l_text: CE_POINTER [INTEGER_8]
			l_text_end: CE_POINTER [INTEGER_8]
			l_up_error_code: CE_ARRAY [INTEGER_32]
			l_url_text: CE_POINTER [INTEGER_8]
			l_entry: CE_POINTER [PD_URLPOS]
			l_url: CE_POINTER [PD_URL]
			l_line_beg: CE_POINTER [INTEGER_8]
			l_line_end: CE_POINTER [INTEGER_8]
			l_merged: CE_POINTER [INTEGER_8]
			l_error___0: CE_POINTER [INTEGER_8]
			l_return, l_break, l_continue: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_up_error_code.make (<<1>>)
			create {CE_INTEGER_8_POINTER} l_url_text.make
			create {CE_CLASS_POINTER [PD_URL]} l_url.make

			l_fm := (create {P_UTILS_STATIC}).read_file (a_file)
			if l_fm.is_void then
				(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s%N"), a_file, (strerror ((errno_location).item))])
				Result := (create {CE_CLASS_POINTER [PD_URLPOS]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
						(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Loaded %%s (size %%s).%N"), a_file, ((create {P_UTILS_STATIC}).number_to_static_string ((l_fm.item.length).to_integer_64))])
					end
					l_break := True
				end
				l_break := False
				l_tail := create {CE_CLASS_POINTER [PD_URLPOS]}.make_shared (default_pointer)
				l_head := l_tail
				l_text := l_fm.item.content
				l_text_end := (l_fm.item.content + l_fm.item.length)
				from
				until
					not (not (l_return) and then ((l_text.c_pointer.to_integer_32).to_natural_32 < (l_text_end.c_pointer.to_integer_32).to_natural_32))
				loop
					l_continue := False
					l_line_beg := l_text
					l_line_end := create {CE_INTEGER_8_POINTER}.make_cast ((memchr (create {CE_VOID_POINTER}.make_cast (l_text), ('%N').code, (l_text_end.distance (l_text)).to_natural_32)))
					if l_line_end.is_void then
						l_line_end := l_text_end
					else
						l_line_end := l_line_end + 1
					end
					l_text := l_line_end
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_line_beg.c_pointer.to_integer_32).to_natural_32 < (l_line_end.c_pointer.to_integer_32).to_natural_32 then
							if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_line_beg[0]).to_integer_32)) then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_line_beg := l_line_beg + 1
						end
					end
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_line_end.c_pointer.to_integer_32).to_natural_32 > (l_line_beg.c_pointer.to_integer_32).to_natural_32 then
							if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_line_end[-1]).to_integer_32)) then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_line_end := l_line_end - 1
						end
					end
					l_break := False
					if l_line_beg.is_equal (l_line_end) then
						l_continue := True
					end
					if not (l_return or l_break or l_continue) then
						l_url_text := (create {P_UTILS_STATIC}).strdupdelim (l_line_beg, l_line_end)
						if (not ((create {P_OPTIONS_STATIC}).opt.item.item.base_href).is_void) then
							l_merged := ((create {P_URL_STATIC}).uri_merge ((create {P_OPTIONS_STATIC}).opt.item.item.base_href, l_url_text))
							free (create {CE_VOID_POINTER}.make_cast (l_url_text))
							l_url_text := l_merged
						end
						l_url := (create {P_URL_STATIC}).url_parse (l_url_text, l_up_error_code, create {CE_CLASS_POINTER [PD_IRI]}.make_shared (default_pointer), (0).to_boolean)
						if l_url.is_void then
							l_error___0 := ((create {P_URL_STATIC}).url_error (l_url_text, l_up_error_code.item));
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("%%s: Invalid URL %%s: %%s%N"))), a_file, l_url_text, l_error___0])
							free (create {CE_VOID_POINTER}.make_cast (l_url_text))
							free (create {CE_VOID_POINTER}.make_cast (l_error___0))
							l_continue := True
						end
					end
					if not (l_return or l_break or l_continue) then
						free (create {CE_VOID_POINTER}.make_cast (l_url_text))
						l_entry := create {CE_CLASS_POINTER [PD_URLPOS]}.make_cast (((create {P_XMALLOC_STATIC}).xcalloc ((1).to_natural_32, (create {PD_URLPOS}.make).structure_size.to_natural_32)))
						l_entry.item.url := l_url
						if l_head.is_void then
							l_head := l_entry
						else
							l_tail.item.next := l_entry
						end
						l_tail := l_entry
					end
				end
				l_continue := False
				l_fm.item.read_file_free
				Result := l_head
			end
		end

	cleanup_html_url
		do
			if (not interesting_tags.item.is_void) then
				interesting_tags.item.item.hash_table_destroy
			end
			if (not interesting_attributes.item.is_void) then
				interesting_attributes.item.item.hash_table_destroy
			end
		end

end
