class
	PD_ANONYMOUS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	c: INTEGER_8 assign set_c

	x: NATURAL_32 assign set_x

feature {ANY} -- field setters

	set_c (a_c: INTEGER_8)
		do
			c := a_c
			update_memory_field ("c")
		end

	set_x (a_x: NATURAL_32)
		do
			x := a_x
			update_memory_field ("x")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			c := a_other.c
			x := a_other.x
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				c = a_other.c and
				x = a_other.x
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("c"),
					create {CE_STRUCTURE_FIELD}.make ("x")
				>>)
			init_structure_info
		end

end
