class
	P_FTP_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	ftp_logged (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_rb: CE_POINTER [PD_READ_BUFFER]
			l_return: BOOLEAN
		do
			l_rb := (create {P_CONNECT_STATIC}).alloc_read_buffer (a_c)
			if l_rb.is_void then
				l_return := True
			end
			if not l_return and then (not ((create {P_DEFAULT_STATIC}).ftp_options.item.item.fast_ftp).to_boolean) then
				a_c.item.ftp_got_user_info (l_rb)
				l_return := True
			end
			if not l_return then
				a_c.item.read_from_socket (a_c.item.sock1, l_rb, (create {PD_CONNECTION_STATIC}).ftp_got_info_address)
			end
		end

	ftp_sent_passwd (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_rb: CE_POINTER [PD_READ_BUFFER]
			l_return: BOOLEAN
		do
			l_rb := (create {P_CONNECT_STATIC}).alloc_read_buffer (a_c)
			if l_rb.is_void then
				l_return := True
			end
			if not l_return then
				a_c.item.read_from_socket (a_c.item.sock1, l_rb, (create {PD_CONNECTION_STATIC}).ftp_pass_info_address)
			end
		end

	ftp_retr_1 (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_rb: CE_POINTER [PD_READ_BUFFER]
			l_return: BOOLEAN
		do
			l_rb := (create {P_CONNECT_STATIC}).alloc_read_buffer (a_c)
			if l_rb.is_void then
				l_return := True
			end
			if not l_return then
				a_c.item.read_from_socket (a_c.item.sock1, l_rb, (create {PD_CONNECTION_STATIC}).ftp_retr_file_address)
			end
		end

feature {ANY} -- routine addresses

	ftp_logged_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ftp_logged)
		end

	ftp_sent_passwd_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ftp_sent_passwd)
		end

	ftp_retr_1_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ftp_retr_1)
		end

end
