class
	P_HTML_R_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_STRING_STATIC

feature {ANY} -- public attributes

	nowrap: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	last_tag_to_move: CE_STATIC [CE_POINTER [PD_TAG]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_TAG]}.make
		end

	last_tag_for_newline: CE_STATIC [CE_POINTER [PD_TAG]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_TAG]}.make
		end

	last_link: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make
		end

	last_target: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make
		end

	last_image: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make
		end

	last_form: CE_STATIC [CE_POINTER [PD_FORM_CONTROL]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_FORM_CONTROL]}.make
		end

	nobreak: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	convert_table: CE_STATIC [CE_POINTER [PD_CONV_TABLE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_CONV_TABLE]}.make
		end

	buffer: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<256>>)
		end

	ta_cache: CE_STATIC [CE_ARRAY [PD_TEXT_ATTRIB_BEGINNING]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_TEXT_ATTRIB_BEGINNING]}.make_initialized (<<
					create {PD_TEXT_ATTRIB_BEGINNING}.make_initialized ([-1, create {PD_RGB}.make_initialized ([(0).to_natural_8, (0).to_natural_8, (0).to_natural_8, (0).to_natural_8]), create {PD_RGB}.make_initialized ([(0).to_natural_8, (0).to_natural_8, (0).to_natural_8, (0).to_natural_8])])
				>>)
		end

	bg_cache: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	fg_cache: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	g_ctrl_num: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	table_cache: CE_STATIC [CE_ARRAY [PD_LIST_HEAD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LIST_HEAD]}.make (<<1>>)
			Result.item[0] := create {PD_LIST_HEAD}.make_initialized ([create {CE_VOID_POINTER}.make_cast (table_cache.item), create {CE_VOID_POINTER}.make_cast (table_cache.item)])
		end

	table_cache_hash: CE_STATIC [CE_ARRAY [CE_POINTER [PD_TABLE_CACHE_ENTRY]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [PD_TABLE_CACHE_ENTRY]}.make (<<4_096>>)
		end

	format_cache: CE_STATIC [CE_ARRAY [PD_LIST_HEAD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LIST_HEAD]}.make (<<1>>)
			Result.item[0] := create {PD_LIST_HEAD}.make_initialized ([create {CE_VOID_POINTER}.make_cast (format_cache.item), create {CE_VOID_POINTER}.make_cast (format_cache.item)])
		end

	format_cache_entries: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	fg_color (a_fg, a_bg: INTEGER_32): INTEGER_32
		local
			l_l: INTEGER_32
			l_tmp: INTEGER_32
			l_h: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_bg < a_fg then
						l_tmp := a_bg
					else
						l_tmp := a_fg
					end
					l_l := l_tmp
					if a_bg < a_fg then
						l_tmp___0 := a_fg
					else
						l_tmp___0 := a_bg
					end
					l_h := l_tmp___0
					if l_l /= l_h then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 23 -- goto _L___2
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 3 then -- else:
						if l_l.to_boolean then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_h = 4 then
							l_pos := -1 + 23 -- goto _L___2
						elseif l_h = 8 then
							l_pos := -1 + 23 -- goto _L___2
						elseif l_h = 12 then
							l_pos := -1 + 23 -- goto _L___2
						else
							l_pos := -1 + 6 -- goto _L___7
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 6 then -- else: | _L___7:
						if l_l /= 1 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_h = 3 then
							l_pos := -1 + 23 -- goto _L___2
						elseif l_h = 5 then
							l_pos := -1 + 23 -- goto _L___2
						elseif l_h = 8 then
							l_pos := -1 + 23 -- goto _L___2
						elseif l_h = 12 then
							l_pos := -1 + 23 -- goto _L___2
						else
							l_pos := -1 + 9 -- goto _L___6
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 9 then -- else: | _L___6:
						if l_l /= 2 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if l_h = 6 then
							l_pos := -1 + 23 -- goto _L___2
						else
							l_pos := -1 + 12 -- goto _L___5
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 12 then -- else: | _L___5:
						if l_l /= 3 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if l_h = 5 then
							l_pos := -1 + 23 -- goto _L___2
						elseif l_h = 12 then
							l_pos := -1 + 23 -- goto _L___2
						else
							l_pos := -1 + 15 -- goto _L___4
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 15 then -- else: | _L___4:
						if l_l /= 4 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if l_h = 8 then
							l_pos := -1 + 23 -- goto _L___2
						elseif l_h = 12 then
							l_pos := -1 + 23 -- goto _L___2
						else
							l_pos := -1 + 18 -- goto _L___3
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 18 then -- else: | _L___3:
						if l_l /= 5 then
							l_pos := -1 + 31 -- skip if block
						end
				when 19 then -- if:
						if l_h /= 8 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 23 -- goto _L___2
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 22 then -- else:
						if l_h /= 12 then
							l_pos := -1 + 31 -- skip if block
						end
				when 23 then -- if: | _L___2:
						if a_fg /= 4 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_pos := -1 + 27 -- goto _L___0
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 26 then -- else:
						if a_fg /= 12 then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if: | _L___0:
						if a_bg = 0 then
							l_tmp___2 := 6
						elseif a_bg = 8 then
							l_tmp___2 := 6
						else
							l_pos := -1 + 29 -- goto _L
						end
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else: | _L:
						if a_bg = 2 then
							l_tmp___1 := 1
						elseif a_bg = 6 then
							l_tmp___1 := 1
						elseif a_bg = 7 then
							l_tmp___1 := 1
						else
							l_tmp___1 := 0
						end
						l_tmp___2 := 7 - 7 * l_tmp___1
				when 30 then -- if done
						Result := l_tmp___2
						l_return := True
				when 31 then -- if done | if done | if done | if done | if done | if done | if done | if done
					if not l_return then
						Result := a_fg
					end
				when 32 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	new_link (a_f: CE_POINTER [PD_F_DATA]): CE_POINTER [PD_LINK]
		local
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			if a_f.is_void then
				Result := (create {CE_CLASS_POINTER [PD_LINK]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				if not ((a_f.item.nlinks).bit_and (63)).to_boolean then
					if (a_f.item.nlinks).to_natural_32 > {NATURAL_32} 2_147_483_647 // (create {PD_LINK}.make).structure_size.to_natural_32 - {NATURAL_32} 64 then
						from
						until
							False
						loop
							(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_r.c"), 381]);
							(create {P_KBD_STATIC}).fatal_tty_exit
							exit (4)
						end
					end
					a_f.item.links := create {CE_CLASS_POINTER [PD_LINK]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 382, create {CE_VOID_POINTER}.make_cast (a_f.item.links), (a_f.item.nlinks + 64).to_natural_32 * (create {PD_LINK}.make).structure_size.to_natural_32)))
				end
				memset (create {CE_VOID_POINTER}.make_cast ((a_f.item.links + a_f.item.nlinks)), 0, (create {PD_LINK}.make).structure_size.to_natural_32).do_nothing
				l_tmp___0 := a_f.item.nlinks
				a_f.item.nlinks := (a_f.item.nlinks) + 1
				Result := (a_f.item.links + l_tmp___0)
			end
		end

	html_tag (a_f: CE_POINTER [PD_F_DATA]; a_t: CE_POINTER [NATURAL_8]; a_x, a_y: INTEGER_32)
		local
			l_tag: CE_POINTER [PD_TAG]
			l_tt: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_ll: CE_ARRAY [INTEGER_32]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_tt.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_ll.make (<<1>>)

			if a_f.is_void then
				l_return := True
			end
			if not l_return then
				l_tt.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 394)
				l_ll.item := 0;
				(create {P_URL_STATIC}).add_conv_str (l_tt, l_ll, a_t, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_t))).to_integer_32, -2)
				l_tag := create {CE_CLASS_POINTER [PD_TAG]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 397, ((create {PD_TAG}.make).structure_size.to_natural_32 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_tt.item)))) + {NATURAL_32} 1)))
				l_tag.item.x := a_x
				l_tag.item.y := a_y
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_tag.item.name)), create {CE_INTEGER_8_POINTER}.make_cast (l_tt.item)).do_nothing
				from
				until
					(l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_f.c_pointer + (create {PD_F_DATA}.make).offset_of ("tags")))))
					l_tag.item.next := (create {CE_CLASS_POINTER [PD_TAG]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_f.c_pointer + (create {PD_F_DATA}.make).offset_of ("tags"))))).item.next
					l_tag.item.prev := create {CE_CLASS_POINTER [PD_TAG]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_f.c_pointer + (create {PD_F_DATA}.make).offset_of ("tags"))));
					(create {CE_CLASS_POINTER [PD_TAG]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_f.c_pointer + (create {PD_F_DATA}.make).offset_of ("tags"))))).item.next := l_tag;
					(l_tag.item.next).item.prev := l_tag;
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_f.c_pointer + (create {PD_F_DATA}.make).offset_of ("tags")))))
					l_break := True
				end
				l_break := False
				if last_tag_for_newline.item.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_f.c_pointer + (create {PD_F_DATA}.make).offset_of ("tags"))) then
					last_tag_for_newline.item := l_tag
				end
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 403, create {CE_VOID_POINTER}.make_cast (l_tt.item))
			end
		end

	put_chars_conv (a_p: CE_POINTER [PD_PART]; a_c: CE_POINTER [NATURAL_8]; a_l: INTEGER_32): INTEGER_32
		local
			l_bp: INTEGER_32
			l_pp: INTEGER_32
			l_total: INTEGER_32
			l_e: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_t: CE_POINTER [PD_CONV_TABLE]
			l_i: INTEGER_32
			l_tmp___1: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_POINTER} l_e.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_bp := 0
					l_pp := 0
					l_total := 0
					if (((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.attr).bit_and (16)).to_boolean then
						put_chars (a_p, a_c, a_l)
						Result := a_l
						l_return := True
					end
					if l_return then
						l_pos := -1 + 32 -- skip if block
					end
				when 1 then -- if:
						if not a_l.to_boolean then
							put_chars (a_p, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0)
						end
				when 2 then -- loop condition:
						if not (not (l_return) and then (l_pp < a_l)) then
							l_pos := -1 + 31 -- skip loop
						end
				when 3 then -- loop body:
						l_continue := False
						if not ((a_c[l_pp]).to_integer_32 < 128) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (a_c[l_pp]).to_integer_32 = 38 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | putc:
						l_tmp := l_bp
						l_bp := l_bp + 1
						l_tmp___0 := l_pp
						l_pp := l_pp + 1
						buffer.item[l_tmp] := (a_c[l_tmp___0]).to_integer_8
						if l_bp < 256 then
							l_continue := True
						end
						if not (l_return or l_break or l_continue) then
							l_pos := -1 + 23 -- goto flush
						end
				when 6 then -- if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 21 -- skip if block
						end
				when 7 then -- if:
						if (a_c[l_pp]).to_integer_32 = 38 then
							l_pos := -1 + 17 -- skip if block
						end
				when 8 then -- if:
						if convert_table.item.is_void then
							l_pos := -1 + 5 -- goto putc
						end
				when 9 then
						l_t := convert_table.item
						l_i := l_pp
				when 10 then -- decode:
						if ((l_t + (a_c[l_i]).to_integer_32).item.t).to_boolean then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_e := (l_t + (a_c[l_i]).to_integer_32).item.u.str
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 13 then -- else:
						l_tmp___1 := l_i
						l_i := l_i + 1
						l_t := (l_t + (a_c[l_tmp___1]).to_integer_32).item.u.tbl
						if l_i >= a_l then
							l_pos := -1 + 5 -- goto putc
						end
				when 14 then
						l_pos := -1 + 10 -- goto decode
				when 15 then
						l_pp := l_i + 1
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 17 then -- else:
						l_i___0 := l_pp + 1
						if ((create {P_LINKS_STATIC}).d_opt.item.item.plain).to_boolean then
							l_pos := -1 + 5 -- goto putc
						end
				when 18 then
						from
						until
							(l_break)
						loop
							l_break := False
							if l_i___0 < a_l then
								if (a_c[l_i___0]).to_integer_32 /= 59 then
									if (a_c[l_i___0]).to_integer_32 /= 38 then
										if not ((a_c[l_i___0]).to_integer_32 > 32) then
											l_break := True
										end
									else
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
						l_e := (create {P_CHARSETS_STATIC}).get_entity_string (a_c + (l_pp + 1), (l_i___0 - l_pp) - 1, (create {P_LINKS_STATIC}).d_opt.item.item.cp)
						if l_e.is_void then
							l_pos := -1 + 5 -- goto putc
						end
				when 19 then
						if l_i___0 < a_l then
							if (a_c[l_i___0]).to_integer_32 = 59 then
								l_tmp___2 := 1
							else
								l_tmp___2 := 0
							end
						else
							l_tmp___2 := 0
						end
						l_pp := l_i___0 + l_tmp___2
				when 20 then -- if done
						if not (l_e[0]).to_boolean then
							l_continue := True
						end
				when 21 then -- if done
						if not (not (l_return or l_break or l_continue) and then (not (l_e[1]).to_boolean)) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_tmp___3 := l_bp
						l_bp := l_bp + 1
						buffer.item[l_tmp___3] := (l_e[0]).to_integer_8
						if l_bp < 256 then
							l_continue := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 24 -- skip if block
						end
				when 23 then -- if: | flush:
						l_e := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
						l_pos := -1 + 27 -- goto flush1
				when 24 then -- if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 30 -- skip if block
						end
				when 25 then -- if: | loop condition:
						if not ((l_e.item).to_boolean) then
							l_pos := -1 + 29 -- skip loop
						end
				when 26 then -- loop body:
						l_continue := False
						l_tmp___4 := l_bp
						l_bp := l_bp + 1
						l_tmp___5 := l_e
						l_e := l_e + 1
						buffer.item[l_tmp___4] := (l_tmp___5.item).to_integer_8
						if l_bp < 256 then
							l_continue := True
						end
						if (l_break or l_continue) then
							l_pos := -1 + 28 -- skip if block
						end
				when 27 then -- if: | flush1:
						put_chars (a_p, create {CE_NATURAL_8_POINTER}.make_cast (buffer.item), l_bp)
						l_total := l_total + l_bp
						l_bp := 0
				when 28 then -- if done
						l_pos := -1 + 25 -- back to loop condition
				when 29 then -- loop done
						l_continue := False
				when 30 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 31 then -- loop done
						l_continue := False
						if l_bp.to_boolean then
							put_chars (a_p, create {CE_NATURAL_8_POINTER}.make_cast (buffer.item), l_bp)
						end
						l_total := l_total + l_bp
						Result := l_total
				when 32 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	put_chars (a_p: CE_POINTER [PD_PART]; a_c: CE_POINTER [NATURAL_8]; a_l: INTEGER_32)
		local
			l_c: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_bg: INTEGER_32
			l_fg: INTEGER_32
			l_i: INTEGER_32
			l_link___0: CE_POINTER [PD_LINK]
			l_pt: CE_POINTER [PD_POINT]
			l_tmp___0: INTEGER_32
			l_x: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_s: CE_ARRAY [NATURAL_8]
			l_fl: CE_POINTER [NATURAL_8]
			l_ft: CE_POINTER [NATURAL_8]
			l_fi: CE_POINTER [NATURAL_8]
			l_ff___0: CE_POINTER [PD_FORM_CONTROL]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_s.make (<<64>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := a_c
					l_l := a_l
					if l_l < 0 then
						from
						until
							False
						loop
							(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_r.c"), 492]);
							(create {P_KBD_STATIC}).fatal_tty_exit
							exit (4)
						end
					end
					from
					until
						(l_break)
					loop
						l_break := False
						if (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.align /= 4 then
							if a_p.item.cx = -1 then
								if l_l.to_boolean then
									if (l_c.item).to_integer_32 /= 32 then
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_c := l_c + 1
							l_l := l_l - 1
						end
					end
					l_break := False
					if not l_l.to_boolean then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if (l_c[0]).to_integer_32 /= 32 then
							last_tag_for_newline.item := create {CE_CLASS_POINTER [PD_TAG]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared ((a_p.item.data).c_pointer + (create {PD_F_DATA}.make).offset_of ("tags"))))
						elseif (l_c[1]).to_boolean then
							if (l_c[1]).to_integer_32 /= 32 then
								last_tag_for_newline.item := create {CE_CLASS_POINTER [PD_TAG]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared ((a_p.item.data).c_pointer + (create {PD_F_DATA}.make).offset_of ("tags"))))
							end
						end
						if a_p.item.cx < (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin then
							a_p.item.cx := (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin
						end
						if (not last_link.item.is_void) then
							l_pos := -1 + 6 -- goto process_link
						elseif (not last_image.item.is_void) then
							l_pos := -1 + 6 -- goto process_link
						elseif (not last_form.item.is_void) then
							l_pos := -1 + 6 -- goto process_link
						elseif (not ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.link).is_void) then
							l_pos := -1 + 6 -- goto process_link
						elseif (not ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.image).is_void) then
							l_pos := -1 + 6 -- goto process_link
						elseif (not ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.form).is_void) then
							l_pos := -1 + 6 -- goto process_link
						end
				when 2 then -- no_l:
						if (memcmp (create {CE_VOID_POINTER}.make_cast (ta_cache.item), create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_TEXT_ATTRIB]}.make_shared ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).c_pointer + (create {PD_HTML_ELEMENT}.make).offset_of ("attr")))), (create {PD_TEXT_ATTRIB_BEGINNING}.make).structure_size.to_natural_32)).to_boolean then
							l_pos := -1 + 36 -- goto format_change
						end
				when 3 then
						l_bg := bg_cache.item
						l_fg := fg_cache.item
				when 4 then -- end_format_change:
						if a_p.item.cx = (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin then
							if (l_c.item).to_integer_32 = 32 then
								if (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.align /= 4 then
									l_c := l_c + 1
									l_l := l_l - 1
								end
							end
						end
						if a_p.item.y < a_p.item.cy + 1 then
							a_p.item.y := a_p.item.cy + 1
						end
						if nowrap.item.to_boolean then
							if (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.width - (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin > 0 then
								l_tmp___0 := (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.width - (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin
							else
								l_tmp___0 := 0
							end
							if a_p.item.cx + l_l > l_tmp___0 then
								l_return := True
							end
						end
				when 5 then -- if done
					if not l_return then
						a_p.item.set_hline (a_p.item.cx, a_p.item.cy, l_l, l_c, ((((((((((l_fg).bit_and (8))).bit_shift_left (3))).bit_or (((l_bg).bit_shift_left (3))))).bit_or (((l_fg).bit_and (7))))).bit_shift_left (8)).to_natural_32, 1)
						a_p.item.cx := a_p.item.cx + l_l
						nobreak.item := 0
						if (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.align /= 4 then
							from
							until
								(l_break)
							loop
								l_break := False
								if (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.width - (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin > 0 then
									l_tmp___1 := (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.width - (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin
								else
									l_tmp___1 := 0
								end
								if a_p.item.cx > l_tmp___1 then
									if not (a_p.item.cx > (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin) then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_x := a_p.item.split_line
									if not l_x.to_boolean then
										l_break := True
									end
								end
								if not (l_break) then
									a_p.item.align_line (a_p.item.cy - 1)
									nobreak.item := l_x - 1
								end
							end
							l_break := False
						end
						l_tmp___3 := a_p.item.xa + l_l
						a_p.item.xa := l_tmp___3
						if (l_c[(l_l - 1)]).to_integer_32 = 32 then
							if (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.align /= 4 then
								l_tmp___4 := 1
							else
								l_tmp___4 := 0
							end
						else
							l_tmp___4 := 0
						end
						if ((l_tmp___3 - l_tmp___4) + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin) + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin > a_p.item.xmax then
							if (l_c[(l_l - 1)]).to_integer_32 = 32 then
								if (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.align /= 4 then
									l_tmp___2 := 1
								else
									l_tmp___2 := 0
								end
							else
								l_tmp___2 := 0
							end
							a_p.item.xmax := ((a_p.item.xa - l_tmp___2) + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin) + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin
						end
						l_return := True
					end
					if l_return then
						l_pos := -1 + 37 -- skip if block
					end
				when 6 then -- if: | process_link:
						if last_link.item.is_void then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 13 -- goto _L___3
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 35
				when 9 then -- else:
						if last_image.item.is_void then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L___3
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 35
				when 12 then -- else:
						if last_form.item.is_void then
							l_pos := -1 + 30 -- skip if block
						end
				when 13 then -- if: | _L___3:
						if not (((create {P_LINKS_STATIC}).xstrcmp ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.link, last_link.item)).to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 30 -- goto _L___2
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 16 then -- else:
						if not (((create {P_LINKS_STATIC}).xstrcmp ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.target, last_target.item)).to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 30 -- goto _L___2
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 19 then -- else:
						if not (((create {P_LINKS_STATIC}).xstrcmp ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.image, last_image.item)).to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 30 -- goto _L___2
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 22 then -- else:
						if not (((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.form).is_equal (last_form.item)) then
							l_pos := -1 + 28 -- skip if block
						end
				when 23 then -- if:
						if (a_p.item.data).is_void then
							l_pos := -1 + 26 -- goto x
						end
				when 24 then
						l_link___0 := (a_p.item.data).item.links + ((a_p.item.data).item.nlinks - 1)
						if not ((a_p.item.data).item.nlinks).to_boolean then
							from
							until
								False
							loop
								(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c"));
								(create {P_LINKS_STATIC}).errline.item := 533;
								(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("no link"))])
							end
							l_pos := -1 + 2 -- goto no_l
						end
				when 25 then
						l_pos := -1 + 34 -- goto set_link
				when 26 then -- x:
						
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else:
						l_pos := -1 + 30 -- goto _L___2
				when 29 then -- if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 35
				when 30 then -- else: | _L___2:
						if (not last_link.item.is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 539, create {CE_VOID_POINTER}.make_cast (last_link.item))
						end
						if (not last_target.item.is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 540, create {CE_VOID_POINTER}.make_cast (last_target.item))
						end
						if (not last_image.item.is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 541, create {CE_VOID_POINTER}.make_cast (last_image.item))
						end
						last_image.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						last_target.item := last_image.item
						last_link.item := last_target.item
						last_form.item := create {CE_CLASS_POINTER [PD_FORM_CONTROL]}.make_shared (default_pointer)
						if ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.link).is_void then
							if ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.image).is_void then
								if ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.form).is_void then
									l_pos := -1 + 2 -- goto no_l
								end
							end
						end
				when 31 then
						if ((create {P_LINKS_STATIC}).d_opt.item.item.num_links).to_boolean then
							l_fl := (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.link
							l_ft := (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.target
							l_fi := (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.image
							l_ff___0 := (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.form
							l_tmp___6 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
							(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.image := l_tmp___6
							l_tmp___5 := l_tmp___6;
							(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.target := l_tmp___5;
							(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.link := l_tmp___5;
							(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.form := create {CE_CLASS_POINTER [PD_FORM_CONTROL]}.make_shared (default_pointer)
							l_s[0] := (('[').code).to_natural_8;
							(create {P_LINKS_STATIC}).snzprint (l_s + 1, 62, (a_p.item.link_num).to_integer_32).do_nothing
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_s), ce_string ("]")).do_nothing
							put_chars (a_p, l_s, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s))).to_integer_32)
							if (not l_ff___0.is_void) then
								if l_ff___0.item.type = 4 then
									a_p.item.line_break
								end
							end
							if a_p.item.cx = -1 then
								a_p.item.cx := (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin
							end
							(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.link := l_fl;
							(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.target := l_ft;
							(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.image := l_fi;
							(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.form := l_ff___0
						end
						a_p.item.link_num := (a_p.item.link_num) + 1
						last_link.item := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 561, (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.link)
						last_target.item := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 562, (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.target)
						last_image.item := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 563, (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.image)
						last_form.item := (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.form
						if (a_p.item.data).is_void then
							l_pos := -1 + 2 -- goto no_l
						end
				when 32 then
						l_link___0 := new_link (a_p.item.data)
						if l_link___0.is_void then
							l_pos := -1 + 2 -- goto no_l
						end
				when 33 then
						l_link___0.item.num := a_p.item.link_num - 1
						l_link___0.item.pos := create {CE_CLASS_POINTER [PD_POINT]}.make_shared (default_pointer + -1)
						if last_form.item.is_void then
							l_link___0.item.type := 0
							l_link___0.item.where := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 571, last_link.item)
							l_link___0.item.target := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 572, last_target.item)
						else
							if last_form.item.item.type = 1 then
								l_link___0.item.type := 4
							elseif last_form.item.item.type = 2 then
								l_link___0.item.type := 4
							elseif last_form.item.item.type = 3 then
								l_link___0.item.type := 4
							else
								if last_form.item.item.type = 4 then
									l_tmp___10 := 5
								else
									if last_form.item.item.type = 5 then
										l_tmp___9 := 2
									elseif last_form.item.item.type = 6 then
										l_tmp___9 := 2
									else
										if last_form.item.item.type = 7 then
											l_tmp___8 := 3
										else
											l_tmp___8 := 1
										end
										l_tmp___9 := l_tmp___8
									end
									l_tmp___10 := l_tmp___9
								end
								l_link___0.item.type := l_tmp___10
							end
							l_link___0.item.form := last_form.item
							l_link___0.item.target := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 576, last_form.item.item.target)
						end
						l_link___0.item.where_img := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 578, last_image.item)
						if l_link___0.item.type /= 4 then
							if l_link___0.item.type /= 5 then
								l_bg := (create {CE_CLASS_POINTER [PD_RGB]}.make_shared ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).c_pointer + (create {PD_HTML_ELEMENT}.make).offset_of ("attr") + (create {PD_TEXT_ATTRIB}.make).offset_of ("clink"))).item.find_nearest_color (8)
								l_fg := (create {CE_CLASS_POINTER [PD_RGB]}.make_shared ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).c_pointer + (create {PD_HTML_ELEMENT}.make).offset_of ("attr") + (create {PD_TEXT_ATTRIB}.make).offset_of ("bg"))).item.find_nearest_color (8)
								l_fg := fg_color (l_fg, l_bg)
							else
								l_fg := (create {CE_CLASS_POINTER [PD_RGB]}.make_shared ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).c_pointer + (create {PD_HTML_ELEMENT}.make).offset_of ("attr") + (create {PD_TEXT_ATTRIB}.make).offset_of ("fg"))).item.find_nearest_color (8)
								l_bg := (create {CE_CLASS_POINTER [PD_RGB]}.make_shared ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).c_pointer + (create {PD_HTML_ELEMENT}.make).offset_of ("attr") + (create {PD_TEXT_ATTRIB}.make).offset_of ("bg"))).item.find_nearest_color (8)
								l_fg := fg_color (l_fg, l_bg)
							end
						else
							l_fg := (create {CE_CLASS_POINTER [PD_RGB]}.make_shared ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).c_pointer + (create {PD_HTML_ELEMENT}.make).offset_of ("attr") + (create {PD_TEXT_ATTRIB}.make).offset_of ("fg"))).item.find_nearest_color (8)
							l_bg := (create {CE_CLASS_POINTER [PD_RGB]}.make_shared ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).c_pointer + (create {PD_HTML_ELEMENT}.make).offset_of ("attr") + (create {PD_TEXT_ATTRIB}.make).offset_of ("bg"))).item.find_nearest_color (8)
							l_fg := fg_color (l_fg, l_bg)
						end
						l_link___0.item.sel_color := ((((((((l_fg).bit_and (8))).bit_shift_left (3))).bit_or (((l_fg).bit_and (7))))).bit_or (((l_bg).bit_shift_left (3)))).to_natural_32
						l_link___0.item.n := 0
				when 34 then -- set_link:
						if (l_link___0.item.n).to_natural_32 + l_l.to_natural_32 > {NATURAL_32} 2_147_483_647 // (create {PD_POINT}.make).structure_size.to_natural_32 then
							from
							until
								False
							loop
								(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_r.c"), 591]);
								(create {P_KBD_STATIC}).fatal_tty_exit
								exit (4)
							end
						end
						l_pt := create {CE_CLASS_POINTER [PD_POINT]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 592, create {CE_VOID_POINTER}.make_cast (l_link___0.item.pos), (l_link___0.item.n + l_l).to_natural_32 * (create {PD_POINT}.make).structure_size.to_natural_32)))
						l_link___0.item.pos := l_pt
						l_i := 0
						from
						until
							not (l_i < l_l)
						loop
							(l_pt + (l_link___0.item.n + l_i)).item.x := (a_p.item.xp + a_p.item.cx) + l_i;
							(l_pt + (l_link___0.item.n + l_i)).item.y := a_p.item.yp + a_p.item.cy
							l_i := l_i + 1
						end
						l_link___0.item.n := l_link___0.item.n + l_l
				when 35 then -- if done | if done
						l_pos := -1 + 2 -- goto no_l
				when 36 then -- format_change:
						l_bg := (create {CE_CLASS_POINTER [PD_RGB]}.make_shared ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).c_pointer + (create {PD_HTML_ELEMENT}.make).offset_of ("attr") + (create {PD_TEXT_ATTRIB}.make).offset_of ("bg"))).item.find_nearest_color (8)
						l_fg := (create {CE_CLASS_POINTER [PD_RGB]}.make_shared ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).c_pointer + (create {PD_HTML_ELEMENT}.make).offset_of ("attr") + (create {PD_TEXT_ATTRIB}.make).offset_of ("fg"))).item.find_nearest_color (16)
						l_fg := fg_color (l_fg, l_bg)
						if (((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.attr).bit_and (2)).to_boolean then
							l_fg := (l_fg).bit_xor ((1))
						end
						if (((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.attr).bit_and (4)).to_boolean then
							l_fg := (((l_fg).bit_xor (4))).bit_or (8)
						end
						if (((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.attr).bit_and (1)).to_boolean then
							l_fg := (l_fg).bit_or ((8))
						end
						l_fg := fg_color (l_fg, l_bg)
						if (((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.attr).bit_and (16)).to_boolean then
							l_bg := (l_bg).bit_or ((16))
						end
						memcpy (create {CE_VOID_POINTER}.make_cast (ta_cache.item), create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_TEXT_ATTRIB]}.make_shared ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).c_pointer + (create {PD_HTML_ELEMENT}.make).offset_of ("attr")))), (create {PD_TEXT_ATTRIB_BEGINNING}.make).structure_size.to_natural_32).do_nothing
						fg_cache.item := l_fg
						bg_cache.item := l_bg
						l_pos := -1 + 4 -- goto end_format_change
				when 37 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	create_frameset (a_fda: CE_POINTER [PD_F_DATA]; a_fp: CE_POINTER [PD_FRAMESET_PARAM]): CE_POINTER [PD_FRAMESET_DESC]
		require
			not a_fp.is_void
		local
			l_i: INTEGER_32
			l_fd: CE_POINTER [PD_FRAMESET_DESC]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_fp.item.x).to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if (a_fp.item.y).to_boolean then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c"));
							(create {P_LINKS_STATIC}).errline.item := 689;
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("zero size of frameset"))])
						end
						Result := (create {CE_CLASS_POINTER [PD_FRAMESET_DESC]}.make_shared (default_pointer))
						l_return := True
				when 5 then -- if done
					if not l_return then
						if (a_fp.item.x).to_boolean then
							if ((a_fp.item.x).to_natural_32 * (a_fp.item.y).to_natural_32) // (a_fp.item.x).to_natural_32 /= (a_fp.item.y).to_natural_32 then
								from
								until
									False
								loop
									(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_r.c"), 692]);
									(create {P_KBD_STATIC}).fatal_tty_exit
									exit (4)
								end
							end
						end
						if (a_fp.item.x).to_natural_32 * (a_fp.item.y).to_natural_32 > ({NATURAL_32} 2_147_483_647 - (create {PD_FRAMESET_DESC}.make).structure_size.to_natural_32) // (create {PD_FRAME_DESC}.make).structure_size.to_natural_32 then
							from
							until
								False
							loop
								(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_r.c"), 693]);
								(create {P_KBD_STATIC}).fatal_tty_exit
								exit (4)
							end
						end
						l_fd := create {CE_CLASS_POINTER [PD_FRAMESET_DESC]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 694, (create {PD_FRAMESET_DESC}.make).structure_size.to_natural_32 + (a_fp.item.x * a_fp.item.y).to_natural_32 * (create {PD_FRAME_DESC}.make).structure_size.to_natural_32)))
						memset (create {CE_VOID_POINTER}.make_cast (l_fd), 0, (create {PD_FRAMESET_DESC}.make).structure_size.to_natural_32 + (a_fp.item.x * a_fp.item.y).to_natural_32 * (create {PD_FRAME_DESC}.make).structure_size.to_natural_32).do_nothing
						l_fd.item.n := a_fp.item.x * a_fp.item.y
						l_fd.item.x := a_fp.item.x
						l_fd.item.y := a_fp.item.y
						l_i := 0
						from
						until
							not (l_i < l_fd.item.n)
						loop
							l_fd.item.f[l_i].xw := a_fp.item.xw[l_i \\ a_fp.item.x]
							l_fd.item.f[l_i].yw := a_fp.item.yw[l_i // a_fp.item.x]
							l_i := l_i + 1
						end
						if (not (a_fp.item.parent).is_void) then
							(a_fp.item.parent).item.add_frameset_entry (l_fd, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						elseif (a_fda.item.frame_desc).is_void then
							a_fda.item.frame_desc := l_fd
						else
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 705, create {CE_VOID_POINTER}.make_cast (l_fd))
							l_fd := create {CE_CLASS_POINTER [PD_FRAMESET_DESC]}.make_shared (default_pointer)
						end
						Result := l_fd
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	html_special (a_args: TUPLE [a_p: CE_POINTER [PD_PART]; a_c: INTEGER_32]): CE_POINTER [ANY]
		local
			l_l: CE_VA_LIST
			l_t: CE_POINTER [NATURAL_8]
			l_fc: CE_POINTER [PD_FORM_CONTROL]
			l_fsp: CE_POINTER [PD_FRAMESET_PARAM]
			l_fp: CE_POINTER [PD_FRAME_PARAM]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create l_l.make_shared (default_pointer)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_l := create {CE_VA_LIST}.make (a_args, agent html_special)
					inspect a_args.a_c -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					when 3 then l_pos := -1 + 4
					when 4 then l_pos := -1 + 5
					when 5 then l_pos := -1 + 6
					when 6 then l_pos := -1 + 7
					else l_pos := -1 + 8
					end
				when 1 then -- switch 1, case 0
					l_t := (create {CE_NATURAL_8_POINTER}.make_cast (l_l.pointer_item))
					html_tag (a_args.a_p.item.data, l_t, a_args.a_p.item.xp + a_args.a_p.item.cx, a_args.a_p.item.yp + a_args.a_p.item.cy)
					l_pos := -1 + 9 -- switch 1; break
				when 2 then -- switch 1, case 1
					l_fc := (create {CE_CLASS_POINTER [PD_FORM_CONTROL]}.make_cast (l_l.pointer_item))
					a_args.a_p.item.html_form_control (l_fc)
					l_pos := -1 + 9 -- switch 1; break
				when 3 then -- switch 1, case 2
					Result := (create {CE_VOID_POINTER}.make_cast (convert_table.item))
					l_return := True
				when 4 then -- switch 1, case 3
					if not l_return then
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer + ((not (a_args.a_p.item.data).is_void)).to_integer))
						l_return := True
					end
				when 5 then -- switch 1, case 4
					if not l_return then
						l_fsp := (create {CE_CLASS_POINTER [PD_FRAMESET_PARAM]}.make_cast (l_l.pointer_item))
						Result := (create {CE_VOID_POINTER}.make_cast ((create_frameset (a_args.a_p.item.data, l_fsp))))
						l_return := True
					end
				when 6 then -- switch 1, case 5
					if not l_return then
						l_fp := (create {CE_CLASS_POINTER [PD_FRAME_PARAM]}.make_cast (l_l.pointer_item))
						l_fp.item.create_frame
					end
					l_pos := -1 + 9 -- switch 1; break
				when 7 then -- switch 1, case 6
					nowrap.item := l_l.integer_32_item
					l_pos := -1 + 9 -- switch 1; break
				when 8 then -- switch 1, default:
					from
					until
						False
					loop
						(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c"));
						(create {P_LINKS_STATIC}).errline.item := 753;
						(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_special: unknown code %%d")), a_args.a_c])
					end
				when 9 then -- switch 1, done:
					if not l_return then
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_format (a_start, a_end: CE_POINTER [INTEGER_8]; a_part: CE_POINTER [PD_PART]; a_head___0: CE_POINTER [NATURAL_8])
		do
			(create {P_HTML_STATIC}).parse_html (create {CE_NATURAL_8_POINTER}.make_cast (a_start), create {CE_NATURAL_8_POINTER}.make_cast (a_end), (put_chars_conv_address), ((create {PD_PART_STATIC}).line_break_address), (html_special_address), create {CE_VOID_POINTER}.make_cast (a_part), a_head___0)
		end

	free_table_cache
		local
			l_tce: CE_POINTER [PD_TABLE_CACHE_ENTRY]
			l_hash___0: INTEGER_32
			l_a__: CE_POINTER [PD_XLIST_HEAD]
		do
			l_tce := create {CE_CLASS_POINTER [PD_TABLE_CACHE_ENTRY]}.make_cast (table_cache.item.item.next)
			from
			until
				l_tce.is_equal (table_cache.item)
			loop
				l_hash___0 := (((((l_tce.item.start).c_pointer.to_integer_32).to_natural_32).to_integer_32 + l_tce.item.xs)).bit_and (4_095)
				table_cache_hash.item[l_hash___0] := create {CE_CLASS_POINTER [PD_TABLE_CACHE_ENTRY]}.make_shared (default_pointer)
				l_tce := l_tce.item.next
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (table_cache.item))
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (table_cache.item.item.next)
			from
			until
				l_a__.is_equal (table_cache.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				l_a__ := l_a__.item.next
			end
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (table_cache.item.item.prev)
			from
			until
				l_a__.is_equal (table_cache.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				l_a__ := l_a__.item.prev
			end
			from
			until
				(table_cache.item.item.next).is_equal (table_cache.item)
			loop
				l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (table_cache.item.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__));
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a__.item.prev);
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a__.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__));
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 794, create {CE_VOID_POINTER}.make_cast (l_a__))
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (table_cache.item))
		end

	format_html_part (a_start, a_end: CE_POINTER [NATURAL_8]; a_align, a_m, a_width: INTEGER_32; a_data: CE_POINTER [PD_F_DATA]; a_xs, a_ys: INTEGER_32; a_head___0: CE_POINTER [NATURAL_8]; a_link_num: INTEGER_32): CE_POINTER [PD_PART]
		local
			l_p: CE_POINTER [PD_PART]
			l_e: CE_POINTER [PD_HTML_ELEMENT]
			l_llm: INTEGER_32
			l_ltm: CE_POINTER [PD_TAG]
			l_lm: INTEGER_32
			l_ef: INTEGER_32
			l_fc: CE_POINTER [PD_FORM_CONTROL]
			l_tce: CE_POINTER [PD_TABLE_CACHE_ENTRY]
			l_n: CE_POINTER [PD_NODE]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_n___0: CE_POINTER [PD_NODE]
			l_a__: CE_POINTER [PD_XLIST_HEAD]
			l_hash___0: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_llm := (create {P_LINKS_STATIC}).last_link_to_move.item
					l_ltm := last_tag_to_move.item
					l_lm := (create {P_LINKS_STATIC}).margin.item
					l_ef := (create {P_LINKS_STATIC}).empty_format.item
					if a_data.is_void then
						l_tce := table_cache_hash.item[((((a_start.c_pointer.to_integer_32).to_natural_32).to_integer_32 + a_xs)).bit_and (4_095)]
						from
						until
							not (not (l_return) and then (not l_tce.is_void))
						loop
							if (l_tce.item.start).is_equal (a_start) then
								if (l_tce.item.end2).is_equal (a_end) then
									if l_tce.item.align = a_align then
										if l_tce.item.m = a_m then
											if l_tce.item.width = a_width then
												if l_tce.item.xs = a_xs then
													if l_tce.item.link_num = a_link_num then
														l_p := create {CE_CLASS_POINTER [PD_PART]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 812, (create {PD_PART}.make).structure_size.to_natural_32)))
														memcpy (create {CE_VOID_POINTER}.make_cast (l_p), create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_PART]}.make_shared (l_tce.c_pointer + (create {PD_TABLE_CACHE_ENTRY}.make).offset_of ("p")))), (create {PD_PART}.make).structure_size.to_natural_32).do_nothing
														Result := l_p
														l_return := True
													end
												end
											end
										end
									end
								end
							end
							if not l_return then
								l_tce := l_tce.item.hash_next
							end
						end
					end
					if not l_return and then (a_ys < 0) then
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c"));
							(create {P_LINKS_STATIC}).errline.item := 820;
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("format_html_part: ys == %%d")), a_ys])
						end
						Result := (create {CE_CLASS_POINTER [PD_PART]}.make_shared (default_pointer))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						if (not a_data.is_void) then
							l_n := create {CE_CLASS_POINTER [PD_NODE]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 825, (create {PD_NODE}.make).structure_size.to_natural_32)))
							l_n.item.x := a_xs
							l_n.item.y := a_ys
							if not ((create {P_LINKS_STATIC}).table_level.item).to_boolean then
								l_n.item.xw := 2_147_483_647
							else
								l_n.item.xw := a_width
							end
							from
							until
								(l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_data.c_pointer + (create {PD_F_DATA}.make).offset_of ("nodes")))))
								l_n.item.next := (create {CE_CLASS_POINTER [PD_NODE]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_data.c_pointer + (create {PD_F_DATA}.make).offset_of ("nodes"))))).item.next
								l_n.item.prev := create {CE_CLASS_POINTER [PD_NODE]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_data.c_pointer + (create {PD_F_DATA}.make).offset_of ("nodes"))));
								(create {CE_CLASS_POINTER [PD_NODE]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_data.c_pointer + (create {PD_F_DATA}.make).offset_of ("nodes"))))).item.next := l_n;
								(l_n.item.next).item.prev := l_n;
								(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_data.c_pointer + (create {PD_F_DATA}.make).offset_of ("nodes")))))
								l_break := True
							end
							l_break := False
						end
						if (not a_data.is_void) then
							(create {P_LINKS_STATIC}).last_link_to_move.item := a_data.item.nlinks
						else
							(create {P_LINKS_STATIC}).last_link_to_move.item := 0
						end
						if (not a_data.is_void) then
							last_tag_to_move.item := create {CE_CLASS_POINTER [PD_TAG]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_data.c_pointer + (create {PD_F_DATA}.make).offset_of ("tags"))))
						else
							last_tag_to_move.item := create {CE_CLASS_POINTER [PD_TAG]}.make_shared (default_pointer)
						end
						if (not a_data.is_void) then
							last_tag_for_newline.item := create {CE_CLASS_POINTER [PD_TAG]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_data.c_pointer + (create {PD_F_DATA}.make).offset_of ("tags"))))
						else
							last_tag_for_newline.item := create {CE_CLASS_POINTER [PD_TAG]}.make_shared (default_pointer)
						end
						(create {P_LINKS_STATIC}).margin.item := a_m;
						(create {P_LINKS_STATIC}).empty_format.item := (a_data.is_void).to_integer
						if (not last_link.item.is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 837, create {CE_VOID_POINTER}.make_cast (last_link.item))
						end
						if (not last_image.item.is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 838, create {CE_VOID_POINTER}.make_cast (last_image.item))
						end
						if (not last_target.item.is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 839, create {CE_VOID_POINTER}.make_cast (last_target.item))
						end
						last_target.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						last_image.item := last_target.item
						last_link.item := last_image.item
						last_form.item := create {CE_CLASS_POINTER [PD_FORM_CONTROL]}.make_shared (default_pointer)
						nobreak.item := 1
						l_p := create {CE_CLASS_POINTER [PD_PART]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 843, (create {PD_PART}.make).structure_size.to_natural_32)))
						l_tmp___2 := 0
						l_p.item.y := l_tmp___2
						l_p.item.x := l_tmp___2
						l_p.item.data := a_data
						l_p.item.xp := a_xs
						l_p.item.yp := a_ys
						l_tmp___3 := 0
						l_p.item.xa := l_tmp___3
						l_p.item.xmax := l_tmp___3
						l_p.item.bgcolor := (create {CE_CLASS_POINTER [PD_RGB]}.make_shared ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).c_pointer + (create {PD_HTML_ELEMENT}.make).offset_of ("parattr") + (create {PD_PAR_ATTRIB}.make).offset_of ("bgcolor"))).item.find_nearest_color (8)
						l_p.item.spaces := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer + -1)
						l_p.item.spl := 0
						l_p.item.link_num := a_link_num;
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_p.c_pointer + (create {PD_PART}.make).offset_of ("uf")))))
						l_p.item.uf.next := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_p.c_pointer + (create {PD_PART}.make).offset_of ("uf"))))
						l_p.item.uf.prev := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_p.c_pointer + (create {PD_PART}.make).offset_of ("uf"))));
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_p.c_pointer + (create {PD_PART}.make).offset_of ("uf")))));
						(create {P_HTML_STATIC}).html_stack_dup
						l_e := create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next);
						(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.dontkill := 2;
						(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.namelen := 0;
						(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.align := a_align;
						(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin := a_m;
						(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin := a_m;
						(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.width := a_width;
						(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.list_level := 0;
						(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.list_number := {NATURAL_32} 0;
						(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.dd_margin := 0
						l_p.item.cx := -1
						l_p.item.cy := 0
						do_format (create {CE_INTEGER_8_POINTER}.make_cast (a_start), create {CE_INTEGER_8_POINTER}.make_cast (a_end), l_p, a_head___0)
						if l_p.item.xmax < l_p.item.x then
							l_p.item.xmax := l_p.item.x
						end
						nobreak.item := 0;
						(create {P_LINKS_STATIC}).line_breax.item := 1
						if (not last_link.item.is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 870, create {CE_VOID_POINTER}.make_cast (last_link.item))
						end
						if (not last_image.item.is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 871, create {CE_VOID_POINTER}.make_cast (last_image.item))
						end
						if (not last_target.item.is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 872, create {CE_VOID_POINTER}.make_cast (last_target.item))
						end
				when 2 then -- loop condition:
						if not (not (l_return or l_break) and then (not ((create {P_HTML_STATIC}).html_stack.item.item.next).is_equal (l_e))) then
							l_pos := -1 + 9 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False;
						(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.kill_html_stack_item
						if (not (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).is_void) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if not (((create {P_HTML_STATIC}).html_stack.item.item.next).is_equal ((create {P_HTML_STATIC}).html_stack.item)) then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c"));
							(create {P_LINKS_STATIC}).errline.item := 876;
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html stack trashed"))])
						end
						l_break := True
				when 8 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 9 then -- loop done
						l_break := False;
						(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.dontkill := 0;
						(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.kill_html_stack_item;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 882, create {CE_VOID_POINTER}.make_cast (l_p.item.spaces))
						if (not a_data.is_void) then
							l_n___0 := create {CE_CLASS_POINTER [PD_NODE]}.make_cast (a_data.item.nodes.next)
							l_n___0.item.yw := (a_ys - l_n___0.item.y) + l_p.item.y
						end
						l_fc := create {CE_CLASS_POINTER [PD_FORM_CONTROL]}.make_cast (l_p.item.uf.next)
						from
						until
							l_fc.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_p.c_pointer + (create {PD_PART}.make).offset_of ("uf")))
						loop
							l_fc.item.destroy_fc
							l_fc := l_fc.item.next
						end
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_p.c_pointer + (create {PD_PART}.make).offset_of ("uf")))))
						l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (l_p.item.uf.next)
						from
						until
							l_a__.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_p.c_pointer + (create {PD_PART}.make).offset_of ("uf")))
						loop
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
							l_a__ := l_a__.item.next
						end
						l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (l_p.item.uf.prev)
						from
						until
							l_a__.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_p.c_pointer + (create {PD_PART}.make).offset_of ("uf")))
						loop
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
							l_a__ := l_a__.item.prev
						end
						from
						until
							(l_p.item.uf.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_p.c_pointer + (create {PD_PART}.make).offset_of ("uf")))
						loop
							l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (l_p.item.uf.next);
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__));
							(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a__.item.prev);
							(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a__.item.next);
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__));
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 888, create {CE_VOID_POINTER}.make_cast (l_a__))
						end
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_p.c_pointer + (create {PD_PART}.make).offset_of ("uf")))));
						(create {P_LINKS_STATIC}).last_link_to_move.item := l_llm
						last_tag_to_move.item := l_ltm;
						(create {P_LINKS_STATIC}).margin.item := l_lm;
						(create {P_LINKS_STATIC}).empty_format.item := l_ef
						last_target.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						last_image.item := last_target.item
						last_link.item := last_image.item
						last_form.item := create {CE_CLASS_POINTER [PD_FORM_CONTROL]}.make_shared (default_pointer)
						if (create {P_LINKS_STATIC}).table_level.item > 1 then
							if a_data.is_void then
								l_tce := create {CE_CLASS_POINTER [PD_TABLE_CACHE_ENTRY]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 898, (create {PD_TABLE_CACHE_ENTRY}.make).structure_size.to_natural_32)))
								l_tce.item.start := a_start
								l_tce.item.end2 := a_end
								l_tce.item.align := a_align
								l_tce.item.m := a_m
								l_tce.item.width := a_width
								l_tce.item.xs := a_xs
								l_tce.item.link_num := a_link_num
								memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_PART]}.make_shared (l_tce.c_pointer + (create {PD_TABLE_CACHE_ENTRY}.make).offset_of ("p")))), create {CE_VOID_POINTER}.make_cast (l_p), (create {PD_PART}.make).structure_size.to_natural_32).do_nothing
								from
								until
									(l_break)
								loop
									l_break := False;
									(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (table_cache.item))
									l_tce.item.next := (create {CE_CLASS_POINTER [PD_TABLE_CACHE_ENTRY]}.make_cast (table_cache.item)).item.next
									l_tce.item.prev := create {CE_CLASS_POINTER [PD_TABLE_CACHE_ENTRY]}.make_cast (table_cache.item);
									(create {CE_CLASS_POINTER [PD_TABLE_CACHE_ENTRY]}.make_cast (table_cache.item)).item.next := l_tce;
									(l_tce.item.next).item.prev := l_tce;
									(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (table_cache.item))
									l_break := True
								end
								l_break := False
								l_hash___0 := ((((a_start.c_pointer.to_integer_32).to_natural_32).to_integer_32 + a_xs)).bit_and (4_095)
								l_tce.item.hash_next := table_cache_hash.item[l_hash___0]
								table_cache_hash.item[l_hash___0] := l_tce
							end
						end
						Result := l_p
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_convert_table (a_head___0: CE_POINTER [NATURAL_8]; a_to, a_def: INTEGER_32; a_frm, a_aa: CE_POINTER [INTEGER_32]; a_hard: INTEGER_32): CE_POINTER [PD_CONV_TABLE]
		local
			l_from: INTEGER_32
			l_a: CE_POINTER [NATURAL_8]
			l_b: CE_POINTER [NATURAL_8]
			l_p: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p.make (<<1>>)

			l_from := -1
			l_p.item := a_head___0
			from
			until
				(l_break)
			loop
				l_break := False
				if l_from = -1 then
					if (not (l_p.item).is_void) then
						l_a := (create {P_HTTP_STATIC}).parse_http_header (l_p.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Content-Type")), l_p)
						if l_a.is_void then
							l_break := True
						end
					else
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_b := (create {P_HTTP_STATIC}).parse_header_param (l_a, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("charset")))
					if (not l_b.is_void) then
						l_from := (create {P_CHARSETS_STATIC}).get_cp_index (l_b);
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 957, create {CE_VOID_POINTER}.make_cast (l_b))
					end
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 959, create {CE_VOID_POINTER}.make_cast (l_a))
				end
			end
			l_break := False
			if l_from = -1 then
				if (not a_head___0.is_void) then
					l_a := (create {P_HTTP_STATIC}).parse_http_header (a_head___0, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Content-Charset")), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
					if (not l_a.is_void) then
						l_from := (create {P_CHARSETS_STATIC}).get_cp_index (l_a);
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 963, create {CE_VOID_POINTER}.make_cast (l_a))
					end
				end
			end
			if l_from = -1 then
				if (not a_head___0.is_void) then
					l_a := (create {P_HTTP_STATIC}).parse_http_header (a_head___0, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Charset")), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
					if (not l_a.is_void) then
						l_from := (create {P_CHARSETS_STATIC}).get_cp_index (l_a);
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 967, create {CE_VOID_POINTER}.make_cast (l_a))
					end
				end
			end
			if (not a_aa.is_void) then
				a_aa.item := (l_from = -1).to_integer
				if a_hard.to_boolean then
					if not (a_aa.item).to_boolean then
						a_aa.item := 2
					end
				end
			end
			if a_hard.to_boolean then
				l_from := a_def
			elseif l_from = -1 then
				l_from := a_def
			end
			if (not a_frm.is_void) then
				a_frm.item := l_from
			end
			Result := ((create {P_CHARSETS_STATIC}).get_translation_table (l_from, a_to))
		end

	shrink_format_cache (a_u: INTEGER_32)
		local
			l_ce: CE_POINTER [PD_F_DATA]
			l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					delete_unused_format_cache_entries
					if format_cache_entries.item < 0 then
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c"));
							(create {P_LINKS_STATIC}).errline.item := 1_083;
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("format_cache_entries underflow"))])
						end
						format_cache_entries.item := 0
					end
					l_ce := create {CE_CLASS_POINTER [PD_F_DATA]}.make_cast (format_cache.item.item.prev)
				when 1 then -- loop condition:
					if (l_break) then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_continue := False
						if not (a_u.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else:
						if not (format_cache_entries.item > (create {P_DEFAULT_STATIC}).max_format_cache_entries.item.item) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L:
						if l_ce.is_equal (format_cache.item) then
							l_break := True
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_break := True
				when 9 then -- if done
						if not (l_break or l_continue) and then ((l_ce.item.refcount).to_boolean) then
							l_ce := l_ce.item.prev
							l_continue := True
						end
						if not (l_break or l_continue) then
							l_ce := l_ce.item.prev;
							(l_ce.item.next).item.destroy_formatted
							format_cache_entries.item := format_cache_entries.item - 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					l_break := False
					l_continue := False
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	count_format_cache
		local
			l_ce: CE_POINTER [PD_F_DATA]
		do
			format_cache_entries.item := 0
			l_ce := create {CE_CLASS_POINTER [PD_F_DATA]}.make_cast (format_cache.item.item.next)
			from
			until
				l_ce.is_equal (format_cache.item)
			loop
				if not (l_ce.item.refcount).to_boolean then
					format_cache_entries.item := format_cache_entries.item + 1
				end
				l_ce := l_ce.item.next
			end
		end

	delete_unused_format_cache_entries
		local
			l_ce: CE_POINTER [PD_F_DATA]
			l_cee: CE_ARRAY [CE_POINTER [PD_CACHE_ENTRY]]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_CACHE_ENTRY]} l_cee.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ce := create {CE_CLASS_POINTER [PD_F_DATA]}.make_cast (format_cache.item.item.next)
				when 1 then -- loop condition:
					if not (not (l_return) and then (not l_ce.is_equal (format_cache.item))) then
						l_pos := -1 + 12 -- skip loop
					end
				when 2 then -- loop body:
						l_cee.item := create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_shared (default_pointer)
						if (l_ce.item.refcount).to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 3 then -- if:
						if not (((create {P_CACHE_STATIC}).find_in_cache (l_ce.item.url, l_cee)).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 6 then -- else:
						if (not (l_cee.item).is_void) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if l_cee.item.item.count = l_ce.item.use_tag then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						if (l_cee.item).is_void then
							from
							until
								False
							loop
								(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c"));
								(create {P_LINKS_STATIC}).errline.item := 1_111;
								(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file %%s disappeared from cache")), l_ce.item.url])
							end
						end
						l_ce := l_ce.item.prev;
						(l_ce.item.next).item.destroy_formatted
						format_cache_entries.item := format_cache_entries.item - 1
				when 11 then -- if done | if done | if done
						l_ce := l_ce.item.next
						l_pos := -1 + 1 -- back to loop condition
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cached_format_html (a_vs: CE_POINTER [PD_VIEW_STATE]; a_screen: CE_POINTER [PD_F_DATA_C]; a_opt: CE_POINTER [PD_DOCUMENT_OPTIONS])
		local
			l_n: CE_POINTER [NATURAL_8]
			l_ce: CE_POINTER [PD_F_DATA]
			l_cee: CE_ARRAY [CE_POINTER [PD_CACHE_ENTRY]]
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_CACHE_ENTRY]} l_cee.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_vs.is_void then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 20 -- skip if block
					end
				when 1 then -- if:
						l_n := a_screen.item.name
						a_screen.item.name := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						a_screen.item.detach_formatted
						a_screen.item.name := l_n
						a_screen.item.link_bg := create {CE_CLASS_POINTER [PD_LINK_BG]}.make_shared (default_pointer)
						a_screen.item.link_bg_n := 0
						a_screen.item.vs := a_vs
						l_tmp := -1
						a_screen.item.yl := l_tmp
						a_screen.item.xl := l_tmp
						a_screen.item.f_data := create {CE_CLASS_POINTER [PD_F_DATA]}.make_shared (default_pointer)
						l_ce := create {CE_CLASS_POINTER [PD_F_DATA]}.make_cast (format_cache.item.item.next)
				when 2 then -- loop condition:
						if not (not (l_return) and then (not l_ce.is_equal (format_cache.item))) then
							l_pos := -1 + 15 -- skip loop
						end
				when 3 then -- loop body:
						l_continue := False
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_ce.item.url), create {CE_INTEGER_8_POINTER}.make_cast ((a_vs.item.url)))).to_boolean then
							l_pos := -1 + 14 -- skip if block
						end
				when 4 then -- if:
						if ((create {CE_CLASS_POINTER [PD_DOCUMENT_OPTIONS]}.make_shared (l_ce.c_pointer + (create {PD_F_DATA}.make).offset_of ("opt"))).item.compare_opt (a_opt)).to_boolean then
							l_pos := -1 + 14 -- skip if block
						end
				when 5 then -- if:
						l_cee.item := create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_shared (default_pointer)
						if not (((create {P_CACHE_STATIC}).find_in_cache (a_vs.item.url, l_cee)).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 8 then -- else:
						if (not (l_cee.item).is_void) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if l_cee.item.item.count = l_ce.item.use_tag then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L:
						if (l_cee.item).is_void then
							from
							until
								False
							loop
								(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c"));
								(create {P_LINKS_STATIC}).errline.item := 1_142;
								(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file %%s disappeared from cache")), l_ce.item.url])
							end
						end
						if not (l_ce.item.refcount).to_boolean then
							l_ce := l_ce.item.prev;
							(l_ce.item.next).item.destroy_formatted
							format_cache_entries.item := format_cache_entries.item - 1
						end
						l_continue := True
				when 13 then -- if done | if done
						if not (l_return or l_continue) then
							l_ce.item.format_cache_reactivate
							l_tmp___1 := l_ce.item.refcount
							l_ce.item.refcount := (l_ce.item.refcount) + 1
							if not l_tmp___1.to_boolean then
								format_cache_entries.item := format_cache_entries.item - 1
							end
							a_screen.item.f_data := l_ce
							l_pos := -1 + 22 -- goto sx
						end
				when 14 then -- if done
						if (not l_return) then
							l_ce := l_ce.item.next
						end
						l_pos := -1 + 2 -- back to loop condition
				when 15 then -- loop done
						l_continue := False
						if not (((create {P_CACHE_STATIC}).find_in_cache (a_vs.item.url, l_cee)).to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 19 -- goto _L___0
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 18 then -- else:
						if (not (l_cee.item).is_void) then
							l_pos := -1 + 20 -- skip if block
						end
				when 19 then -- if: | _L___0:
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c"));
							(create {P_LINKS_STATIC}).errline.item := 1_156;
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("document to format not found"))])
						end
						l_return := True
				when 20 then -- if done | if done
					if l_return then
						l_pos := -1 + 23 -- skip if block
					end
				when 21 then -- if:
						l_cee.item.item.refcount := (l_cee.item.item.refcount) + 1;
						(create {P_MAIN_STATIC}).shrink_memory (0)
						l_ce := create {CE_CLASS_POINTER [PD_F_DATA]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 1_161, (create {PD_F_DATA}.make).structure_size.to_natural_32)))
						l_ce.item.init_formatted
						l_ce.item.refcount := 1
						l_ce.item.url := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 1_164, a_vs.item.url);
						(create {CE_CLASS_POINTER [PD_DOCUMENT_OPTIONS]}.make_shared (l_ce.c_pointer + (create {PD_F_DATA}.make).offset_of ("opt"))).item.copy_opt (a_opt)
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (format_cache.item))
							l_ce.item.next := (create {CE_CLASS_POINTER [PD_F_DATA]}.make_cast (format_cache.item)).item.next
							l_ce.item.prev := create {CE_CLASS_POINTER [PD_F_DATA]}.make_cast (format_cache.item);
							(create {CE_CLASS_POINTER [PD_F_DATA]}.make_cast (format_cache.item)).item.next := l_ce;
							(l_ce.item.next).item.prev := l_ce;
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (format_cache.item))
							l_break := True
						end
						l_break := False
						a_screen.item.f_data := l_ce
						l_ce.item.time_to_get := -((create {P_SELECT_STATIC}).get_time);
						(l_cee.item).item.format_html (l_ce)
						l_ce.item.time_to_get := l_ce.item.time_to_get + ((create {P_SELECT_STATIC}).get_time)
				when 22 then -- sx:
						a_screen.item.xw := l_ce.item.opt.xw
						a_screen.item.yw := l_ce.item.opt.yw
						a_screen.item.xp := l_ce.item.opt.xp
						a_screen.item.yp := l_ce.item.opt.yp
				when 23 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY} -- routine addresses

	put_chars_conv_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent put_chars_conv)
		end

	html_special_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent html_special)
		end

end
