class
	PD_CONNECTION_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- routine addresses

	dns_found_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION]; a_state: INTEGER_32)
				do
					a_c.item.dns_found (a_state)
				end)
		end

	connected_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION])
				do
					a_c.item.connected
				end)
		end

	write_select_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION])
				do
					a_c.item.write_select
				end)
		end

	read_select_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION])
				do
					a_c.item.read_select
				end)
		end

	finger_func_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION])
				do
					a_c.item.finger_func
				end)
		end

	finger_send_request_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION])
				do
					a_c.item.finger_send_request
				end)
		end

	finger_get_response_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION]; a_rb: CE_POINTER [PD_READ_BUFFER])
				do
					a_c.item.finger_get_response (a_rb)
				end)
		end

	ftp_login_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION])
				do
					a_c.item.ftp_login
				end)
		end

	ftp_retr_file_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION]; a_rb: CE_POINTER [PD_READ_BUFFER])
				do
					a_c.item.ftp_retr_file (a_rb)
				end)
		end

	ftp_got_final_response_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION]; a_rb: CE_POINTER [PD_READ_BUFFER])
				do
					a_c.item.ftp_got_final_response (a_rb)
				end)
		end

	got_something_from_data_connection_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION])
				do
					a_c.item.got_something_from_data_connection
				end)
		end

	http_send_header_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION])
				do
					a_c.item.http_send_header
				end)
		end

	read_http_data_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION]; a_rb: CE_POINTER [PD_READ_BUFFER])
				do
					a_c.item.read_http_data (a_rb)
				end)
		end

	http_got_header_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION]; a_rb: CE_POINTER [PD_READ_BUFFER])
				do
					a_c.item.http_got_header (a_rb)
				end)
		end

	stat_timer_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION])
				do
					a_c.item.stat_timer
				end)
		end

	connection_timeout_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION])
				do
					a_c.item.connection_timeout
				end)
		end

	connection_timeout_1_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION])
				do
					a_c.item.connection_timeout_1
				end)
		end

	smb_func_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION])
				do
					a_c.item.smb_func
				end)
		end

	smb_got_data_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION])
				do
					a_c.item.smb_got_data
				end)
		end

	smb_got_text_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION])
				do
					a_c.item.smb_got_text
				end)
		end

	exception_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION])
				do
					a_c.item.exception
				end)
		end

	file_func_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION])
				do
					a_c.item.file_func
				end)
		end

	finger_sent_request_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION])
				do
					a_c.item.finger_sent_request
				end)
		end

	ftp_func_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION])
				do
					a_c.item.ftp_func
				end)
		end

	ftp_get_banner_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION])
				do
					a_c.item.ftp_get_banner
				end)
		end

	ftp_got_banner_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION]; a_rb: CE_POINTER [PD_READ_BUFFER])
				do
					a_c.item.ftp_got_banner (a_rb)
				end)
		end

	ftp_got_info_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION]; a_rb: CE_POINTER [PD_READ_BUFFER])
				do
					a_c.item.ftp_got_info (a_rb)
				end)
		end

	ftp_got_user_info_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION]; a_rb: CE_POINTER [PD_READ_BUFFER])
				do
					a_c.item.ftp_got_user_info (a_rb)
				end)
		end

	ftp_dummy_info_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION]; a_rb: CE_POINTER [PD_READ_BUFFER])
				do
					a_c.item.ftp_dummy_info (a_rb)
				end)
		end

	ftp_pass_info_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION]; a_rb: CE_POINTER [PD_READ_BUFFER])
				do
					a_c.item.ftp_pass_info (a_rb)
				end)
		end

	http_func_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION])
				do
					a_c.item.http_func
				end)
		end

	proxy_func_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION])
				do
					a_c.item.proxy_func
				end)
		end

	http_get_header_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION])
				do
					a_c.item.http_get_header
				end)
		end

	https_func_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_c: CE_POINTER [PD_CONNECTION])
				do
					a_c.item.https_func
				end)
		end

end
