class
	PD_DIALOG_DATA_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- routine addresses

	cancel_dialog_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
				do
					Result := a_dlg.item.cancel_dialog (a_di)
				end)
		end

	ok_dialog_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
				do
					Result := a_dlg.item.ok_dialog (a_di)
				end)
		end

	checkbox_list_fn_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA])
				do
					a_dlg.item.checkbox_list_fn
				end)
		end

	group_fn_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA])
				do
					a_dlg.item.group_fn
				end)
		end

	msg_box_fn_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA])
				do
					a_dlg.item.msg_box_fn
				end)
		end

	msg_box_button_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
				do
					Result := a_dlg.item.msg_box_button (a_di)
				end)
		end

	input_field_cancel_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
				do
					Result := a_dlg.item.input_field_cancel (a_di)
				end)
		end

	input_field_ok_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
				do
					Result := a_dlg.item.input_field_ok (a_di)
				end)
		end

	input_field_fn_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA])
				do
					a_dlg.item.input_field_fn
				end)
		end

	bookmark_dialog_abort_handler_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA])
				do
					a_dlg.item.bookmark_dialog_abort_handler
				end)
		end

	layout_bookmark_manager_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA])
				do
					a_dlg.item.layout_bookmark_manager
				end)
		end

	push_add_button_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
				do
					Result := a_dlg.item.push_add_button (a_di)
				end)
		end

	push_goto_button_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_goto_btn: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
				do
					Result := a_dlg.item.push_goto_button (a_goto_btn)
				end)
		end

	push_edit_button_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_edit_btn: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
				do
					Result := a_dlg.item.push_edit_button (a_edit_btn)
				end)
		end

	push_delete_button_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_some_useless_delete_button: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
				do
					Result := a_dlg.item.push_delete_button (a_some_useless_delete_button)
				end)
		end

	layout_add_dialog_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA])
				do
					a_dlg.item.layout_add_dialog
				end)
		end

	refresh_abort_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA])
				do
					a_dlg.item.refresh_abort
				end)
		end

	dlg_http_options_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
				do
					Result := a_dlg.item.dlg_http_options (a_di)
				end)
		end

	ftpopt_fn_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA])
				do
					a_dlg.item.ftpopt_fn
				end)
		end

	dlg_ftp_options_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
				do
					Result := a_dlg.item.dlg_ftp_options (a_di)
				end)
		end

	netopt_fn_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA])
				do
					a_dlg.item.netopt_fn
				end)
		end

	netprog_fn_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA])
				do
					a_dlg.item.netprog_fn
				end)
		end

	dlg_assume_cp_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
				do
					Result := a_dlg.item.dlg_assume_cp (a_di)
				end)
		end

	dlg_abort_download_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
				do
					Result := a_dlg.item.dlg_abort_download (a_di)
				end)
		end

	dlg_undisplay_download_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
				do
					Result := a_dlg.item.dlg_undisplay_download (a_di)
				end)
		end

	download_abort_function_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA])
				do
					a_dlg.item.download_abort_function
				end)
		end

	download_window_function_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA])
				do
					a_dlg.item.download_window_function
				end)
		end

	add_ct_fn_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA])
				do
					a_dlg.item.add_ct_fn
				end)
		end

	add_ext_fn_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dlg: CE_POINTER [PD_DIALOG_DATA])
				do
					a_dlg.item.add_ext_fn
				end)
		end

	max_text_width_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (create {PD_DIALOG_DATA}.make).max_text_width)
		end

	min_text_width_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (create {PD_DIALOG_DATA}.make).min_text_width)
		end

	end_refresh_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (create {PD_DIALOG_DATA}.make).end_refresh)
		end

end
