class
	PD_F_DATA

inherit
	PD_F_DATA_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_F_DATA]} next.make
			create {CE_CLASS_POINTER [PD_F_DATA]} prev.make
			create {CE_NATURAL_8_POINTER} url.make
			create opt.make
			create {CE_NATURAL_8_POINTER} title.make
			create {CE_CLASS_POINTER [PD_FRAMESET_DESC]} frame_desc.make
			create {CE_CLASS_POINTER [PD_LINE]} data.make
			create {CE_CLASS_POINTER [PD_LINK]} links.make
			create {CE_POINTER_POINTER [PD_LINK]} lines1.make
			create {CE_POINTER_POINTER [PD_LINK]} lines2.make
			create forms.make
			create tags.make
			create nodes.make
			create {CE_CLASS_POINTER [PD_SEARCH]} search.make
			create {CE_POINTER_POINTER [PD_SEARCH]} slines1.make
			create {CE_POINTER_POINTER [PD_SEARCH]} slines2.make
			Precursor
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_F_DATA] assign set_next

	prev: CE_POINTER [PD_F_DATA] assign set_prev

	refcount: INTEGER_32 assign set_refcount

	url: CE_POINTER [NATURAL_8] assign set_url

	opt: PD_DOCUMENT_OPTIONS assign set_opt

	title: CE_POINTER [NATURAL_8] assign set_title

	cp: INTEGER_32 assign set_cp

	ass: INTEGER_32 assign set_ass

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	time_to_get: INTEGER_32 assign set_time_to_get

	use_tag: NATURAL_32 assign set_use_tag

	frame: INTEGER_32 assign set_frame

	frame_desc: CE_POINTER [PD_FRAMESET_DESC] assign set_frame_desc

	bg: INTEGER_32 assign set_bg

	data: CE_POINTER [PD_LINE] assign set_data

	links: CE_POINTER [PD_LINK] assign set_links

	nlinks: INTEGER_32 assign set_nlinks

	lines1: CE_POINTER [CE_POINTER [PD_LINK]] assign set_lines1

	lines2: CE_POINTER [CE_POINTER [PD_LINK]] assign set_lines2

	forms: PD_LIST_HEAD assign set_forms

	tags: PD_LIST_HEAD assign set_tags

	nodes: PD_LIST_HEAD assign set_nodes

	search: CE_POINTER [PD_SEARCH] assign set_search

	nsearch: INTEGER_32 assign set_nsearch

	slines1: CE_POINTER [CE_POINTER [PD_SEARCH]] assign set_slines1

	slines2: CE_POINTER [CE_POINTER [PD_SEARCH]] assign set_slines2

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_F_DATA])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_F_DATA])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_refcount (a_refcount: INTEGER_32)
		do
			refcount := a_refcount
			update_memory_field ("refcount")
		end

	set_url (a_url: CE_POINTER [NATURAL_8])
		do
			url := a_url
			update_memory_field ("url")
		end

	set_opt (a_opt: PD_DOCUMENT_OPTIONS)
		do
			opt := a_opt
			update_memory_field ("opt")
		end

	set_title (a_title: CE_POINTER [NATURAL_8])
		do
			title := a_title
			update_memory_field ("title")
		end

	set_cp (a_cp: INTEGER_32)
		do
			cp := a_cp
			update_memory_field ("cp")
		end

	set_ass (a_ass: INTEGER_32)
		do
			ass := a_ass
			update_memory_field ("ass")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_time_to_get (a_time_to_get: INTEGER_32)
		do
			time_to_get := a_time_to_get
			update_memory_field ("time_to_get")
		end

	set_use_tag (a_use_tag: NATURAL_32)
		do
			use_tag := a_use_tag
			update_memory_field ("use_tag")
		end

	set_frame (a_frame: INTEGER_32)
		do
			frame := a_frame
			update_memory_field ("frame")
		end

	set_frame_desc (a_frame_desc: CE_POINTER [PD_FRAMESET_DESC])
		do
			frame_desc := a_frame_desc
			update_memory_field ("frame_desc")
		end

	set_bg (a_bg: INTEGER_32)
		do
			bg := a_bg
			update_memory_field ("bg")
		end

	set_data (a_data: CE_POINTER [PD_LINE])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_links (a_links: CE_POINTER [PD_LINK])
		do
			links := a_links
			update_memory_field ("links")
		end

	set_nlinks (a_nlinks: INTEGER_32)
		do
			nlinks := a_nlinks
			update_memory_field ("nlinks")
		end

	set_lines1 (a_lines1: CE_POINTER [CE_POINTER [PD_LINK]])
		do
			lines1 := a_lines1
			update_memory_field ("lines1")
		end

	set_lines2 (a_lines2: CE_POINTER [CE_POINTER [PD_LINK]])
		do
			lines2 := a_lines2
			update_memory_field ("lines2")
		end

	set_forms (a_forms: PD_LIST_HEAD)
		do
			forms := a_forms
			update_memory_field ("forms")
		end

	set_tags (a_tags: PD_LIST_HEAD)
		do
			tags := a_tags
			update_memory_field ("tags")
		end

	set_nodes (a_nodes: PD_LIST_HEAD)
		do
			nodes := a_nodes
			update_memory_field ("nodes")
		end

	set_search (a_search: CE_POINTER [PD_SEARCH])
		do
			search := a_search
			update_memory_field ("search")
		end

	set_nsearch (a_nsearch: INTEGER_32)
		do
			nsearch := a_nsearch
			update_memory_field ("nsearch")
		end

	set_slines1 (a_slines1: CE_POINTER [CE_POINTER [PD_SEARCH]])
		do
			slines1 := a_slines1
			update_memory_field ("slines1")
		end

	set_slines2 (a_slines2: CE_POINTER [CE_POINTER [PD_SEARCH]])
		do
			slines2 := a_slines2
			update_memory_field ("slines2")
		end

feature {PD_F_DATA} -- private attributes

	head: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("%NLinks:%N%/0/")
		end

feature {ANY} -- public routines

	format_cache_reactivate
		local
			l_break: BOOLEAN
		do
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (next)).item.prev := create {CE_VOID_POINTER}.make_cast (prev)
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (prev)).item.next := create {CE_VOID_POINTER}.make_cast (next)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_HTML_R_STATIC}).format_cache.item)))
				update_class_fields -- Current might have been changed; synchronize
				Current.next := (create {CE_CLASS_POINTER [PD_F_DATA]}.make_cast (((create {P_HTML_R_STATIC}).format_cache.item))).item.next
				update_class_fields -- Current might have been changed; synchronize
				Current.prev := create {CE_CLASS_POINTER [PD_F_DATA]}.make_cast (((create {P_HTML_R_STATIC}).format_cache.item))
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_F_DATA]}.make_cast (((create {P_HTML_R_STATIC}).format_cache.item))).item.next := (create {CE_CLASS_POINTER [PD_F_DATA]}.make_shared (c_pointer))
				update_class_fields -- Current might have been changed; synchronize
				next.item.prev := (create {CE_CLASS_POINTER [PD_F_DATA]}.make_shared (c_pointer))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_HTML_R_STATIC}).format_cache.item)))
				update_class_fields -- Current might have been changed; synchronize
				l_break := True
			end
			l_break := False
		end

	add_srch_chr (a_c: NATURAL_8; a_x, a_y, a_nn: INTEGER_32)
		local
			l_n: INTEGER_32
			l_return: BOOLEAN
		do
			l_n := nsearch
			if a_c.to_integer_32 = 32 then
				if not l_n.to_boolean then
					l_return := True
				elseif ((search + (l_n - 1)).item.c).to_integer_32 = 32 then
					l_return := True
				end
			end
			if not l_return then
				(search + l_n).item.c := a_c
				update_class_fields; -- Current might have been changed; synchronize
				(search + l_n).item.x := a_x
				update_class_fields; -- Current might have been changed; synchronize
				(search + l_n).item.y := a_y
				update_class_fields; -- Current might have been changed; synchronize
				(search + l_n).item.n := a_nn
				update_class_fields -- Current might have been changed; synchronize
				Current.nsearch := nsearch + 1
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	sort_srch
		local
			l_i: INTEGER_32
			l_min: CE_POINTER [INTEGER_32]
			l_max: CE_POINTER [INTEGER_32]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [ANY]
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [ANY]
			l_s: CE_POINTER [PD_SEARCH]
		do
			if y.to_natural_32 > {NATURAL_32} 2_147_483_647 // {PLATFORM}.Pointer_bytes.to_natural_32 then
				from
				until
					False
				loop
					(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_r.c"), 1_369])
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_KBD_STATIC}).fatal_tty_exit
					update_class_fields -- Current might have been changed; synchronize
					exit (4)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if y.to_natural_32 > {NATURAL_32} 2_147_483_647 // {PLATFORM}.Integer_32_bytes.to_natural_32 then
				from
				until
					False
				loop
					(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_r.c"), 1_370])
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_KBD_STATIC}).fatal_tty_exit
					update_class_fields -- Current might have been changed; synchronize
					exit (4)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 1_371, y.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			Current.slines1 := create {CE_POINTER_POINTER [PD_SEARCH]}.make_cast (l_tmp)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 1_372, y.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			Current.slines2 := create {CE_POINTER_POINTER [PD_SEARCH]}.make_cast (l_tmp___0)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___1 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 1_373, y.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_min := create {CE_INTEGER_32_POINTER}.make_cast (l_tmp___1)
			l_tmp___2 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 1_374, y.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_max := create {CE_INTEGER_32_POINTER}.make_cast (l_tmp___2)
			memset (create {CE_VOID_POINTER}.make_cast (slines1), 0, y.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			memset (create {CE_VOID_POINTER}.make_cast (slines2), 0, y.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_i := 0
			from
			until
				not (l_i < y)
			loop
				l_min[l_i] := 2_147_483_647
				update_class_fields -- Current might have been changed; synchronize
				l_max[l_i] := 0
				update_class_fields -- Current might have been changed; synchronize
				l_i := l_i + 1
			end
			l_i := 0
			from
			until
				not (l_i < nsearch)
			loop
				l_s := search + l_i
				if l_s.item.x < l_min[l_s.item.y] then
					l_min[l_s.item.y] := l_s.item.x
					update_class_fields -- Current might have been changed; synchronize
					slines1[l_s.item.y] := l_s
					update_class_fields -- Current might have been changed; synchronize
				end
				if l_s.item.x + l_s.item.n > l_max[l_s.item.y] then
					l_max[l_s.item.y] := l_s.item.x + l_s.item.n
					update_class_fields -- Current might have been changed; synchronize
					slines2[l_s.item.y] := l_s
					update_class_fields -- Current might have been changed; synchronize
				end
				l_i := l_i + 1
			end
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 1_383, create {CE_VOID_POINTER}.make_cast (l_min))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 1_384, create {CE_VOID_POINTER}.make_cast (l_max))
			update_class_fields -- Current might have been changed; synchronize
		end

	get_srch: INTEGER_32
		local
			l_n: CE_POINTER [PD_NODE]
			l_cnt: INTEGER_32
			l_cc: INTEGER_32
			l_x: INTEGER_32
			l_y: INTEGER_32
			l_xm: INTEGER_32
			l_ym: INTEGER_32
			l_ns: INTEGER_32
			l_c: NATURAL_8
			l_tmp: INTEGER_32
			l_xx: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_cnt := 0
					l_cc := (search.is_void).to_integer
					l_n := create {CE_CLASS_POINTER [PD_NODE]}.make_cast (nodes.prev)
				when 1 then -- loop condition:
					if not (not (l_return) and then (not l_n.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_F_DATA}.make).offset_of ("nodes"))))) then
						l_pos := -1 + 23 -- skip loop
					end
				when 2 then -- loop body:
						l_xm := l_n.item.x + l_n.item.xw
						l_ym := l_n.item.y + l_n.item.yw
						l_y := l_n.item.y
				when 3 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 22 -- skip loop
						end
				when 4 then -- loop body:
						l_break := False
						if l_y < l_ym then
							if not (l_y < y) then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 21 -- skip if block
						end
				when 5 then -- if:
						l_ns := 1
						l_x := l_n.item.x
				when 6 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 20 -- skip loop
						end
				when 7 then -- loop body:
						l_break := False
						l_continue := False
						if l_x < l_xm then
							if not (l_x < (data + l_y).item.l) then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_c := ((data + l_y).item.d[l_x]).to_natural_8
							l_tmp := is_spc ((data + l_y).item.d[l_x])
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp.to_boolean then
								l_c := ((' ').code).to_natural_8
							end
							if l_c.to_integer_32 = 32 then
								if l_ns.to_boolean then
									l_continue := True
								end
							end
						end
						if not (l_return or l_break or l_continue) then
							l_c := (create {P_CHARSETS_STATIC}).charset_upcase (l_c, opt.cp)
							update_class_fields -- Current might have been changed; synchronize
							if l_ns.to_boolean then
								if not l_cc.to_boolean then
									((create {CE_CLASS_POINTER [PD_F_DATA]}.make_shared (c_pointer))).item.add_srch_chr (l_c, l_x, l_y, 1)
									update_class_fields -- Current might have been changed; synchronize
								else
									l_cnt := l_cnt + 1
								end
								l_ns := 0
								l_continue := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 19 -- skip if block
						end
				when 8 then -- if:
						if l_c.to_integer_32 = 32 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if not l_cc.to_boolean then
							((create {CE_CLASS_POINTER [PD_F_DATA]}.make_shared (c_pointer))).item.add_srch_chr (l_c, l_x, l_y, 1)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_cnt := l_cnt + 1
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 11 then -- else:
						l_xx := l_x + 1
				when 12 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 17 -- skip loop
						end
				when 13 then -- loop body:
						l_break := False
						if l_xx < l_xm then
							if not (l_xx < (data + l_y).item.l) then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_tmp___0 := is_spc ((data + l_y).item.d[l_xx])
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___0.to_boolean then
							l_pos := -1 + 18 -- goto ja_uz_z_toho_programovani_asi_zcvoknu
						end
				when 15 then
						l_xx := l_xx + 1
				when 16 then -- if done
						l_pos := -1 + 12 -- back to loop condition
				when 17 then -- loop done
						l_break := False
						l_xx := l_x
				when 18 then -- ja_uz_z_toho_programovani_asi_zcvoknu:
						if not l_cc.to_boolean then
							((create {CE_CLASS_POINTER [PD_F_DATA]}.make_shared (c_pointer))).item.add_srch_chr (((' ').code).to_natural_8, l_x, l_y, l_xx - l_x)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_cnt := l_cnt + 1
						end
						if l_xx = l_x then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_x := l_xx - 1
						end
				when 19 then -- if done | if done
						if (not l_return and not l_break) then
							l_x := l_x + 1
						end
						l_pos := -1 + 6 -- back to loop condition
				when 20 then -- loop done
						l_break := False
						l_continue := False
						if not l_cc.to_boolean then
							((create {CE_CLASS_POINTER [PD_F_DATA]}.make_shared (c_pointer))).item.add_srch_chr (((' ').code).to_natural_8, l_x, l_y, 0)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_cnt := l_cnt + 1
						end
						l_y := l_y + 1
				when 21 then -- if done
						l_pos := -1 + 3 -- back to loop condition
				when 22 then -- loop done
						l_break := False
						l_n := l_n.item.prev
						l_pos := -1 + 1 -- back to loop condition
				when 23 then -- loop done
					Result := l_cnt
				when 24 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_search_data
		local
			l_n: INTEGER_32
			l_tmp: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
		do
			if (not search.is_void) then
				l_return := True
			end
			if not l_return then
				l_n := ((create {CE_CLASS_POINTER [PD_F_DATA]}.make_shared (c_pointer))).item.get_srch
				update_class_fields -- Current might have been changed; synchronize
				Current.nsearch := 0
				update_class_fields -- Current might have been changed; synchronize
				if l_n.to_natural_32 > {NATURAL_32} 2_147_483_647 // (create {PD_SEARCH}.make).structure_size.to_natural_32 then
					from
					until
						False
					loop
						(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_r.c"), 1_443])
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_KBD_STATIC}).fatal_tty_exit
						update_class_fields -- Current might have been changed; synchronize
						exit (4)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 1_444, l_n.to_natural_32 * (create {PD_SEARCH}.make).structure_size.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				Current.search := create {CE_CLASS_POINTER [PD_SEARCH]}.make_cast (l_tmp)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_F_DATA]}.make_shared (c_pointer))).item.get_srch.do_nothing
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False
					if nsearch.to_boolean then
						if ((search + (nsearch - 1)).item.c).to_integer_32 /= 32 then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						Current.nsearch := nsearch - 1
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				l_break := False;
				((create {CE_CLASS_POINTER [PD_F_DATA]}.make_shared (c_pointer))).item.sort_srch
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	init_formatted
		do
			memset (create {CE_VOID_POINTER}.make_cast ((create {CE_POINTER_POINTER [PD_F_DATA]}.make_shared (c_pointer) + 2)), 0, (create {PD_F_DATA}.make).structure_size.to_natural_32 - {NATURAL_32} 2 * {PLATFORM}.Pointer_bytes.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			Current.data := create {CE_CLASS_POINTER [PD_LINE]}.make_shared (default_pointer + -1)
			update_class_fields -- Current might have been changed; synchronize
			Current.nlinks := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.links := create {CE_CLASS_POINTER [PD_LINK]}.make_shared (default_pointer + -1)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_F_DATA}.make).offset_of ("forms")))))
			update_class_fields -- Current might have been changed; synchronize
			forms.next := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_F_DATA}.make).offset_of ("forms"))))
			update_class_fields -- Current might have been changed; synchronize
			forms.prev := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_F_DATA}.make).offset_of ("forms"))))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_F_DATA}.make).offset_of ("forms")))))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_F_DATA}.make).offset_of ("tags")))))
			update_class_fields -- Current might have been changed; synchronize
			tags.next := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_F_DATA}.make).offset_of ("tags"))))
			update_class_fields -- Current might have been changed; synchronize
			tags.prev := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_F_DATA}.make).offset_of ("tags"))))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_F_DATA}.make).offset_of ("tags")))))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_F_DATA}.make).offset_of ("nodes")))))
			update_class_fields -- Current might have been changed; synchronize
			nodes.next := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_F_DATA}.make).offset_of ("nodes"))))
			update_class_fields -- Current might have been changed; synchronize
			nodes.prev := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_F_DATA}.make).offset_of ("nodes"))))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_F_DATA}.make).offset_of ("nodes")))))
			update_class_fields -- Current might have been changed; synchronize
		end

	destroy_formatted
		local
			l_return: BOOLEAN
		do
			if refcount.to_boolean then
				from
				until
					False
				loop
					(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_LINKS_STATIC}).errline.item := 104
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("trying to free locked formatted data"))])
					update_class_fields -- Current might have been changed; synchronize
				end
				l_return := True
			end
			if not l_return then
				clear_formatted ((create {CE_CLASS_POINTER [PD_F_DATA]}.make_shared (c_pointer)))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (next)).item.prev := create {CE_VOID_POINTER}.make_cast (prev)
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (prev)).item.next := create {CE_VOID_POINTER}.make_cast (next)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 109, create {CE_VOID_POINTER}.make_shared (c_pointer))
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	find_tag (a_name: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tag: CE_POINTER [PD_TAG]
			l_tt: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_ll: CE_ARRAY [INTEGER_32]
			l_tmp: NATURAL_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_tt.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_ll.make (<<1>>)

			l_tt.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 188)
			update_class_fields -- Current might have been changed; synchronize
			l_ll.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_name))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_URL_STATIC}).add_conv_str (l_tt, l_ll, a_name, l_tmp.to_integer_32, -2)
			update_class_fields -- Current might have been changed; synchronize
			l_tag := create {CE_CLASS_POINTER [PD_TAG]}.make_cast (tags.next)
			from
			until
				not (not (l_return) and then (not l_tag.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_F_DATA}.make).offset_of ("tags")))))
			loop
				l_tmp___0 := strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_tag.item.name)), create {CE_INTEGER_8_POINTER}.make_cast (l_tt.item))
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0.to_boolean then
					if (l_tag.item.name[0]).to_integer_32 = 35 then
						l_tmp___1 := strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_tag.item.name + 1)), create {CE_INTEGER_8_POINTER}.make_cast (l_tt.item))
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___1.to_boolean then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 192, create {CE_VOID_POINTER}.make_cast (l_tt.item))
							update_class_fields -- Current might have been changed; synchronize
							Result := (l_tag.item.y)
							l_return := True
						end
					end
				else
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 192, create {CE_VOID_POINTER}.make_cast (l_tt.item))
					update_class_fields -- Current might have been changed; synchronize
					Result := (l_tag.item.y)
					l_return := True
				end
				if not l_return then
					l_tag := l_tag.item.next
				end
			end
			if not l_return then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 195, create {CE_VOID_POINTER}.make_cast (l_tt.item))
				update_class_fields -- Current might have been changed; synchronize
				Result := (-1)
			end
		end

	dump_to_file (a_h: INTEGER_32): INTEGER_32
		local
			l_x: INTEGER_32
			l_y: INTEGER_32
			l_buf___0: CE_POINTER [NATURAL_8]
			l_bptr: INTEGER_32
			l_tmp: CE_POINTER [ANY]
			l_c: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_i: INTEGER_32
			l_tmp___3: NATURAL_32
			l_tmp___4: INTEGER_32
			l_tmp___5: NATURAL_32
			l_lnk: CE_POINTER [PD_LINK]
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_l: CE_ARRAY [INTEGER_32]
			l_fc: CE_POINTER [PD_FORM_CONTROL]
			l_fc___0: CE_POINTER [PD_FORM_CONTROL]
			l_tmp___7: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_s.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_l.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_bptr := 0
					l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 907, (65_536).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_buf___0 := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)
					l_y := 0
				when 1 then -- loop condition:
					if not (not (l_return) and then (l_y < y)) then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						l_x := 0
				when 3 then -- loop condition:
						if not (l_x <= (data + l_y).item.l) then
							l_pos := -1 + 8 -- skip loop
						end
				when 4 then -- loop body:
						if l_x = (data + l_y).item.l then
							l_c := ('%N').code
						else
							l_c := ((data + l_y).item.d[l_x]).to_integer_32
							if ((l_c).bit_and (255)) = 1 then
								l_c := l_c + (31)
							end
							if ((l_c).bit_shift_right (15)).to_boolean then
								if ((l_c).bit_and (255)) >= 176 then
									if ((l_c).bit_and (255)) < 224 then
										l_c := ((create {P_TERMINAL_STATIC}).frame_dumb.item[((l_c).bit_and (255)) - 176]).to_integer_32
									end
								end
							end
						end
						l_tmp___0 := l_bptr
						l_bptr := l_bptr + 1
						l_buf___0[l_tmp___0] := l_c.to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						if not (l_bptr >= 65_536) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_tmp___1 := (create {P_TERMINAL_STATIC}).hard_write (a_h, l_buf___0, l_bptr)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___1 /= l_bptr then
							l_pos := -1 + 10 -- goto fail
						end
				when 6 then
						l_bptr := 0
				when 7 then -- if done
						l_x := l_x + 1
						l_pos := -1 + 3 -- back to loop condition
				when 8 then -- loop done
						l_y := l_y + 1
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
					l_tmp___2 := (create {P_TERMINAL_STATIC}).hard_write (a_h, l_buf___0, l_bptr)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___2 = l_bptr then
						l_pos := -1 + 11 -- skip if block
					end
				when 10 then -- if: | fail:;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 923, create {CE_VOID_POINTER}.make_cast (l_buf___0))
						update_class_fields -- Current might have been changed; synchronize
						Result := (-1)
						l_return := True
				when 11 then -- if done
					if l_return then
						l_pos := -1 + 43 -- skip if block
					end
				when 12 then -- if:;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 926, create {CE_VOID_POINTER}.make_cast (l_buf___0))
						update_class_fields -- Current might have been changed; synchronize
						if not ((opt.num_links).to_boolean) then
							l_pos := -1 + 43 -- skip if block
						end
				when 13 then -- if:
						if not (nlinks.to_boolean) then
							l_pos := -1 + 43 -- skip if block
						end
				when 14 then -- if:
						l_tmp___3 := strlen (head.item)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___4 := (create {P_TERMINAL_STATIC}).hard_write (a_h, create {CE_NATURAL_8_POINTER}.make_cast (head.item), l_tmp___3.to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___5 := strlen (head.item)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___4 /= l_tmp___5.to_integer_32 then
							Result := (-1)
							l_return := True
						end
						if l_return then
							l_pos := -1 + 43 -- skip if block
						end
				when 15 then -- if:
						l_i := 0
				when 16 then -- loop condition:
						if not (not (l_return) and then (l_i < nlinks)) then
							l_pos := -1 + 43 -- skip loop
						end
				when 17 then -- loop body:
						l_lnk := links + l_i
						l_tmp___6 := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 933)
						update_class_fields -- Current might have been changed; synchronize
						l_s.item := l_tmp___6
						update_class_fields -- Current might have been changed; synchronize
						l_l.item := 0
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_num_to_str (l_s, l_l, (l_i + 1).to_integer_32)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (". ")))
						update_class_fields -- Current might have been changed; synchronize
						if (l_lnk.item.where).is_void then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:;
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, l_lnk.item.where)
						update_class_fields -- Current might have been changed; synchronize
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 20 then -- else:
						if (l_lnk.item.where_img).is_void then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:;
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Image: ")))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, l_lnk.item.where_img)
						update_class_fields -- Current might have been changed; synchronize
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 23 then -- else:
						if l_lnk.item.type /= 1 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_fc := l_lnk.item.form
						if l_fc.item.type = 10 then
							(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Reset form")))
							update_class_fields -- Current might have been changed; synchronize
						elseif (l_fc.item.action).is_void then
							(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Button")))
							update_class_fields -- Current might have been changed; synchronize
						else
							if (l_fc.item.method).to_boolean then
								(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Submit form: ")))
								update_class_fields -- Current might have been changed; synchronize
							else
								(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Post form: ")))
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, l_fc.item.action)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 26 then -- else:
						if l_lnk.item.type /= 2 then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						l_pos := -1 + 36 -- goto _L___0
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 29 then -- else:
						if l_lnk.item.type /= 3 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						l_pos := -1 + 36 -- goto _L___0
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 32 then -- else:
						if l_lnk.item.type /= 4 then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 36 -- goto _L___0
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 35 then -- else:
						if l_lnk.item.type /= 5 then
							l_pos := -1 + 42 -- skip if block
						end
				when 36 then -- if: | _L___0:
						l_fc___0 := l_lnk.item.form
						if l_fc___0.item.type = 6 then
							(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Radio button")))
							update_class_fields -- Current might have been changed; synchronize
						elseif l_fc___0.item.type = 5 then
							(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Checkbox")))
							update_class_fields -- Current might have been changed; synchronize
						elseif l_fc___0.item.type = 7 then
							(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Select field")))
							update_class_fields -- Current might have been changed; synchronize
						elseif l_fc___0.item.type = 1 then
							(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Text field")))
							update_class_fields -- Current might have been changed; synchronize
						elseif l_fc___0.item.type = 4 then
							(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Text area")))
							update_class_fields -- Current might have been changed; synchronize
						elseif l_fc___0.item.type = 3 then
							(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("File upload")))
							update_class_fields -- Current might have been changed; synchronize
						elseif l_fc___0.item.type = 2 then
							(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Password field")))
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 42 -- goto unknown
						end
				when 37 then
						if (not (l_fc___0.item.name).is_void) then
							if (l_fc___0.item.name[0]).to_boolean then
								(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (", Name ")))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, l_fc___0.item.name)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if l_fc___0.item.type /= 5 then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						l_pos := -1 + 41 -- goto _L
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 40 then -- else:
						if l_fc___0.item.type /= 6 then
							l_pos := -1 + 42 -- skip if block
						end
				when 41 then -- if: | _L:
						if (not (l_fc___0.item.default_value).is_void) then
							if (l_fc___0.item.default_value[0]).to_boolean then
								(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (", Value ")))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, l_fc___0.item.default_value)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 42 then -- if done | if done | if done | if done | if done | if done | if done | if done | unknown:;
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N")))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___7 := (create {P_TERMINAL_STATIC}).hard_write (a_h, l_s.item, l_l.item)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___7 /= l_l.item then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 967, create {CE_VOID_POINTER}.make_cast (l_s.item))
							update_class_fields -- Current might have been changed; synchronize
							Result := (-1)
							l_return := True
						end
						if not l_return then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 970, create {CE_VOID_POINTER}.make_cast (l_s.item))
							update_class_fields -- Current might have been changed; synchronize
							l_i := l_i + 1
						end
						l_pos := -1 + 16 -- back to loop condition
				when 43 then -- loop done | if done | if done | if done | if done
					if not l_return then
						Result := 0
					end
				when 44 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	decrement_fc_refcount
		do
			Current.refcount := refcount - 1
			update_class_fields -- Current might have been changed; synchronize
			if not refcount.to_boolean then
				(create {P_HTML_R_STATIC}).format_cache_entries.item := (create {P_HTML_R_STATIC}).format_cache_entries.item + 1
				update_class_fields -- Current might have been changed; synchronize
			end
		end

feature {PD_F_DATA} -- private routines

	is_spc (a_c: NATURAL_16): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if (a_c.to_natural_8).to_integer_32 <= 32 then
				l_tmp := 1
			elseif ((a_c.to_integer_32).bit_and (32_768)).to_boolean then
				l_tmp := 1
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	clear_formatted (a_scr: CE_POINTER [PD_F_DATA])
		local
			l_n: INTEGER_32
			l_y: INTEGER_32
			l_ce: CE_ARRAY [CE_POINTER [PD_CACHE_ENTRY]]
			l_fc: CE_POINTER [PD_FORM_CONTROL]
			l_l: CE_POINTER [PD_LINK]
			l_a__: CE_POINTER [PD_XLIST_HEAD]
			l_a_____0: CE_POINTER [PD_XLIST_HEAD]
			l_a_____1: CE_POINTER [PD_XLIST_HEAD]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_CACHE_ENTRY]} l_ce.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_scr.is_void then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if not (((create {P_CACHE_STATIC}).find_in_cache (a_scr.item.url, l_ce)).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if (not (l_ce.item).is_void) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c"));
							(create {P_LINKS_STATIC}).errline.item := 69;
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("no cache entry for document"))])
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_ce.item.item.refcount := (l_ce.item.item.refcount) - 1
				when 8 then -- if done
						if (not (a_scr.item.url).is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 71, create {CE_VOID_POINTER}.make_cast (a_scr.item.url))
						end
						if (not (a_scr.item.title).is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 72, create {CE_VOID_POINTER}.make_cast (a_scr.item.title))
						end
						if (not (a_scr.item.frame_desc).is_void) then
							free_frameset_desc (a_scr.item.frame_desc)
						end
						l_n := 0
						from
						until
							not (l_n < a_scr.item.nlinks)
						loop
							l_l := a_scr.item.links + l_n
							if (not (l_l.item.where).is_void) then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 78, create {CE_VOID_POINTER}.make_cast (l_l.item.where))
							end
							if (not (l_l.item.target).is_void) then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 79, create {CE_VOID_POINTER}.make_cast (l_l.item.target))
							end
							if (not (l_l.item.where_img).is_void) then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 80, create {CE_VOID_POINTER}.make_cast (l_l.item.where_img))
							end
							if (not (l_l.item.pos).is_void) then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 81, create {CE_VOID_POINTER}.make_cast (l_l.item.pos))
							end
							l_n := l_n + 1
						end
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 83, create {CE_VOID_POINTER}.make_cast (a_scr.item.links))
						l_y := 0
						from
						until
							not (l_y < a_scr.item.y)
						loop
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 84, create {CE_VOID_POINTER}.make_cast ((a_scr.item.data + l_y).item.d))
							l_y := l_y + 1
						end
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 85, create {CE_VOID_POINTER}.make_cast (a_scr.item.data))
						if (not (a_scr.item.lines1).is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 86, create {CE_VOID_POINTER}.make_cast (a_scr.item.lines1))
						end
						if (not (a_scr.item.lines2).is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 87, create {CE_VOID_POINTER}.make_cast (a_scr.item.lines2))
						end
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 88, create {CE_VOID_POINTER}.make_cast (a_scr.item.opt.framename))
						l_fc := create {CE_CLASS_POINTER [PD_FORM_CONTROL]}.make_cast (a_scr.item.forms.next)
						from
						until
							l_fc.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + (create {PD_F_DATA}.make).offset_of ("forms")))
						loop
							l_fc.item.destroy_fc
							l_fc := l_fc.item.next
						end
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + (create {PD_F_DATA}.make).offset_of ("forms")))))
						l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (a_scr.item.forms.next)
						from
						until
							l_a__.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + (create {PD_F_DATA}.make).offset_of ("forms")))
						loop
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
							l_a__ := l_a__.item.next
						end
						l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (a_scr.item.forms.prev)
						from
						until
							l_a__.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + (create {PD_F_DATA}.make).offset_of ("forms")))
						loop
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
							l_a__ := l_a__.item.prev
						end
						from
						until
							(a_scr.item.forms.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + (create {PD_F_DATA}.make).offset_of ("forms")))
						loop
							l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (a_scr.item.forms.next);
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__));
							(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a__.item.prev);
							(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a__.item.next);
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__));
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 92, create {CE_VOID_POINTER}.make_cast (l_a__))
						end
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + (create {PD_F_DATA}.make).offset_of ("forms")))));
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + (create {PD_F_DATA}.make).offset_of ("tags")))))
						l_a_____0 := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (a_scr.item.tags.next)
						from
						until
							l_a_____0.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + (create {PD_F_DATA}.make).offset_of ("tags")))
						loop
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____0))
							l_a_____0 := l_a_____0.item.next
						end
						l_a_____0 := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (a_scr.item.tags.prev)
						from
						until
							l_a_____0.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + (create {PD_F_DATA}.make).offset_of ("tags")))
						loop
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____0))
							l_a_____0 := l_a_____0.item.prev
						end
						from
						until
							(a_scr.item.tags.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + (create {PD_F_DATA}.make).offset_of ("tags")))
						loop
							l_a_____0 := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (a_scr.item.tags.next);
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____0));
							(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____0.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a_____0.item.prev);
							(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____0.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a_____0.item.next);
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____0));
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 93, create {CE_VOID_POINTER}.make_cast (l_a_____0))
						end
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + (create {PD_F_DATA}.make).offset_of ("tags")))));
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + (create {PD_F_DATA}.make).offset_of ("nodes")))))
						l_a_____1 := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (a_scr.item.nodes.next)
						from
						until
							l_a_____1.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + (create {PD_F_DATA}.make).offset_of ("nodes")))
						loop
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____1))
							l_a_____1 := l_a_____1.item.next
						end
						l_a_____1 := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (a_scr.item.nodes.prev)
						from
						until
							l_a_____1.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + (create {PD_F_DATA}.make).offset_of ("nodes")))
						loop
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____1))
							l_a_____1 := l_a_____1.item.prev
						end
						from
						until
							(a_scr.item.nodes.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + (create {PD_F_DATA}.make).offset_of ("nodes")))
						loop
							l_a_____1 := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (a_scr.item.nodes.next);
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____1));
							(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____1.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a_____1.item.prev);
							(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____1.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a_____1.item.next);
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____1));
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 94, create {CE_VOID_POINTER}.make_cast (l_a_____1))
						end
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + (create {PD_F_DATA}.make).offset_of ("nodes")))))
						if (not (a_scr.item.search).is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 95, create {CE_VOID_POINTER}.make_cast (a_scr.item.search))
						end
						if (not (a_scr.item.slines1).is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 96, create {CE_VOID_POINTER}.make_cast (a_scr.item.slines1))
						end
						if (not (a_scr.item.slines2).is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 97, create {CE_VOID_POINTER}.make_cast (a_scr.item.slines2))
						end
						a_scr.item.init_formatted
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	free_frameset_desc (a_fd: CE_POINTER [PD_FRAMESET_DESC])
		require
			not a_fd.is_void
		local
			l_i: INTEGER_32
		do
			l_i := 0
			from
			until
				not (l_i < a_fd.item.n)
			loop
				if (not (a_fd.item.f[l_i].subframe).is_void) then
					free_frameset_desc (a_fd.item.f[l_i].subframe)
				end
				if (not (a_fd.item.f[l_i].name).is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 56, create {CE_VOID_POINTER}.make_cast (a_fd.item.f[l_i].name))
				end
				if (not (a_fd.item.f[l_i].url).is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 57, create {CE_VOID_POINTER}.make_cast (a_fd.item.f[l_i].url))
				end
				l_i := l_i + 1
			end
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 59, create {CE_VOID_POINTER}.make_cast (a_fd))
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			refcount := a_other.refcount
			url := a_other.url
			opt := a_other.opt.twin
			title := a_other.title
			cp := a_other.cp
			ass := a_other.ass
			x := a_other.x
			y := a_other.y
			time_to_get := a_other.time_to_get
			use_tag := a_other.use_tag
			frame := a_other.frame
			frame_desc := a_other.frame_desc
			bg := a_other.bg
			data := a_other.data
			links := a_other.links
			nlinks := a_other.nlinks
			lines1 := a_other.lines1
			lines2 := a_other.lines2
			forms := a_other.forms.twin
			tags := a_other.tags.twin
			nodes := a_other.nodes.twin
			search := a_other.search
			nsearch := a_other.nsearch
			slines1 := a_other.slines1
			slines2 := a_other.slines2
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				refcount = a_other.refcount and
				url.is_equal (a_other.url) and
				opt.is_equal (a_other.opt) and
				title.is_equal (a_other.title) and
				cp = a_other.cp and
				ass = a_other.ass and
				x = a_other.x and
				y = a_other.y and
				time_to_get = a_other.time_to_get and
				use_tag = a_other.use_tag and
				frame = a_other.frame and
				frame_desc.is_equal (a_other.frame_desc) and
				bg = a_other.bg and
				data.is_equal (a_other.data) and
				links.is_equal (a_other.links) and
				nlinks = a_other.nlinks and
				lines1.is_equal (a_other.lines1) and
				lines2.is_equal (a_other.lines2) and
				forms.is_equal (a_other.forms) and
				tags.is_equal (a_other.tags) and
				nodes.is_equal (a_other.nodes) and
				search.is_equal (a_other.search) and
				nsearch = a_other.nsearch and
				slines1.is_equal (a_other.slines1) and
				slines2.is_equal (a_other.slines2)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("refcount"),
					create {CE_STRUCTURE_FIELD}.make ("url"),
					create {CE_STRUCTURE_FIELD}.make ("opt"),
					create {CE_STRUCTURE_FIELD}.make ("title"),
					create {CE_STRUCTURE_FIELD}.make ("cp"),
					create {CE_STRUCTURE_FIELD}.make ("ass"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("time_to_get"),
					create {CE_STRUCTURE_FIELD}.make ("use_tag"),
					create {CE_STRUCTURE_FIELD}.make ("frame"),
					create {CE_STRUCTURE_FIELD}.make ("frame_desc"),
					create {CE_STRUCTURE_FIELD}.make ("bg"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("links"),
					create {CE_STRUCTURE_FIELD}.make ("nlinks"),
					create {CE_STRUCTURE_FIELD}.make ("lines1"),
					create {CE_STRUCTURE_FIELD}.make ("lines2"),
					create {CE_STRUCTURE_FIELD}.make ("forms"),
					create {CE_STRUCTURE_FIELD}.make ("tags"),
					create {CE_STRUCTURE_FIELD}.make ("nodes"),
					create {CE_STRUCTURE_FIELD}.make ("search"),
					create {CE_STRUCTURE_FIELD}.make ("nsearch"),
					create {CE_STRUCTURE_FIELD}.make ("slines1"),
					create {CE_STRUCTURE_FIELD}.make ("slines2")
				>>)
			init_structure_info
		end

end
