class
	PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN

inherit
	PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create rd_cmd.make
			create rd_cfg.make
			create wr_cfg.make
			create {CE_VOID_POINTER} ptr.make
			create {CE_NATURAL_8_POINTER} cfg_name.make
			create {CE_NATURAL_8_POINTER} cmd_name.make
			Precursor
		end

feature {ANY} -- fields

	p: INTEGER_32 assign set_p

	rd_cmd: CE_ROUTINE assign set_rd_cmd

	rd_cfg: CE_ROUTINE assign set_rd_cfg

	wr_cfg: CE_ROUTINE assign set_wr_cfg

	min: INTEGER_32 assign set_min

	max: INTEGER_32 assign set_max

	ptr: CE_POINTER [ANY] assign set_ptr

	cfg_name: CE_POINTER [NATURAL_8] assign set_cfg_name

	cmd_name: CE_POINTER [NATURAL_8] assign set_cmd_name

feature {ANY} -- field setters

	set_p (a_p: INTEGER_32)
		do
			p := a_p
			update_memory_field ("p")
		end

	set_rd_cmd (a_rd_cmd: CE_ROUTINE)
		do
			rd_cmd := a_rd_cmd
			update_memory_field ("rd_cmd")
		end

	set_rd_cfg (a_rd_cfg: CE_ROUTINE)
		do
			rd_cfg := a_rd_cfg
			update_memory_field ("rd_cfg")
		end

	set_wr_cfg (a_wr_cfg: CE_ROUTINE)
		do
			wr_cfg := a_wr_cfg
			update_memory_field ("wr_cfg")
		end

	set_min (a_min: INTEGER_32)
		do
			min := a_min
			update_memory_field ("min")
		end

	set_max (a_max: INTEGER_32)
		do
			max := a_max
			update_memory_field ("max")
		end

	set_ptr (a_ptr: CE_POINTER [ANY])
		do
			ptr := a_ptr
			update_memory_field ("ptr")
		end

	set_cfg_name (a_cfg_name: CE_POINTER [NATURAL_8])
		do
			cfg_name := a_cfg_name
			update_memory_field ("cfg_name")
		end

	set_cmd_name (a_cmd_name: CE_POINTER [NATURAL_8])
		do
			cmd_name := a_cmd_name
			update_memory_field ("cmd_name")
		end

feature {ANY} -- public routines

	add_nm (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32])
		require
			not a_s.is_void
			not a_l.is_void
		do
			if (a_l.item).to_boolean then
				(create {P_LINKS_STATIC}).add_to_str (a_s, a_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N")))
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_LINKS_STATIC}).add_to_str (a_s, a_l, cfg_name)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (a_s, a_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
			update_class_fields -- Current might have been changed; synchronize
		end

	num_wr (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32])
		require
			not a_s.is_void
			not a_l.is_void
		do
			((create {CE_CLASS_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]}.make_shared (c_pointer))).item.add_nm (a_s, a_l)
			update_class_fields -- Current might have been changed; synchronize
			add_knum_to_str (a_s, a_l, (create {CE_INTEGER_32_POINTER}.make_cast (ptr)).item)
			update_class_fields -- Current might have been changed; synchronize
		end

	str_wr (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32])
		require
			not a_s.is_void
			not a_l.is_void
		local
			l_s1: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp: CE_POINTER [NATURAL_8]
			l_l1: CE_ARRAY [INTEGER_32]
			l_tmp___0: NATURAL_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_s1.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_l1.make (<<1>>);

			((create {CE_CLASS_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]}.make_shared (c_pointer))).item.add_nm (a_s, a_l)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (ptr))
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___0 + {NATURAL_32} 1 > max.to_natural_32 then
				l_tmp := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("default.c")), 461)
				update_class_fields -- Current might have been changed; synchronize
				l_s1.item := l_tmp
				update_class_fields -- Current might have been changed; synchronize
				l_l1.item := 0
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_LINKS_STATIC}).add_bytes_to_str (l_s1, l_l1, create {CE_NATURAL_8_POINTER}.make_cast (ptr), max - 1)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_DEFAULT_STATIC}).add_quoted_to_str (a_s, a_l, l_s1.item)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("default.c")), 465, create {CE_VOID_POINTER}.make_cast (l_s1.item))
				update_class_fields -- Current might have been changed; synchronize
			else
				(create {P_DEFAULT_STATIC}).add_quoted_to_str (a_s, a_l, create {CE_NATURAL_8_POINTER}.make_cast (ptr))
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	cp_wr (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32])
		require
			not a_s.is_void
			not a_l.is_void
		local
			l_n: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
		do
			l_tmp := (create {P_CHARSETS_STATIC}).get_cp_mime_name ((create {CE_INTEGER_32_POINTER}.make_cast (ptr)).item)
			update_class_fields -- Current might have been changed; synchronize
			l_n := l_tmp;
			((create {CE_CLASS_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]}.make_shared (c_pointer))).item.add_nm (a_s, a_l)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (a_s, a_l, l_n)
			update_class_fields -- Current might have been changed; synchronize
		end

	lang_wr (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32])
		require
			not a_s.is_void
			not a_l.is_void
		local
			l_tmp: CE_POINTER [NATURAL_8]
		do
			((create {CE_CLASS_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]}.make_shared (c_pointer))).item.add_nm (a_s, a_l)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := (create {P_LANGUAGE_STATIC}).language_name ((create {P_LINKS_STATIC}).current_language.item.item)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_DEFAULT_STATIC}).add_quoted_to_str (a_s, a_l, l_tmp)
			update_class_fields -- Current might have been changed; synchronize
		end

	prog_wr (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32])
		local
			l_a: CE_POINTER [PD_PROTOCOL_PROGRAM]
			l_continue: BOOLEAN
		do
			l_a := create {CE_CLASS_POINTER [PD_PROTOCOL_PROGRAM]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (ptr)).item.prev)
			from
			until
				l_a.is_equal (ptr)
			loop
				l_continue := False
				if not ((l_a.item.prog).item).to_boolean then
					l_continue := True
				end
				if not (l_continue) then
					((create {CE_CLASS_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]}.make_shared (c_pointer))).item.add_nm (a_s, a_l)
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_DEFAULT_STATIC}).add_quoted_to_str (a_s, a_l, l_a.item.prog)
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_LINKS_STATIC}).add_to_str (a_s, a_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_LINKS_STATIC}).add_num_to_str (a_s, a_l, (l_a.item.system).to_integer_32)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_a := l_a.item.prev
			end
			l_continue := False
		end

	gen_cmd (a_argv: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_argc: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		require
			not a_argc.is_void
		local
			l_e: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_l: CE_ARRAY [INTEGER_32]
			l_r: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_e.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_l.make (<<1>>)

			if not (a_argc.item).to_boolean then
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Parameter expected")))
				l_return := True
			end
			if not l_return then
				l_e.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("default.c")), 726)
				update_class_fields -- Current might have been changed; synchronize
				l_l.item := 0
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_DEFAULT_STATIC}).add_quoted_to_str (l_e, l_l, (a_argv.item).item)
				update_class_fields -- Current might have been changed; synchronize
				l_r := create {CE_NATURAL_8_POINTER}.make_cast (rd_cfg.pointer_item ([(create {CE_CLASS_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]}.make_shared (c_pointer)), l_e.item]))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("default.c")), 730, create {CE_VOID_POINTER}.make_cast (l_e.item))
				update_class_fields -- Current might have been changed; synchronize
				if (not l_r.is_void) then
					Result := l_r
					l_return := True
				end
			end
			if not l_return then
				a_argv.item := (a_argv.item) + 1
				update_class_fields -- Current might have been changed; synchronize
				a_argc.item := (a_argc.item) - 1
				update_class_fields -- Current might have been changed; synchronize
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
			end
		end

	dump_cmd (a_argv: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_argc: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		local
			l_return: BOOLEAN
		do
			if (create {P_DEFAULT_STATIC}).dmp.item /= min then
				if ((create {P_DEFAULT_STATIC}).dmp.item).to_boolean then
					Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Can%'t use both -dump and -source")))
					l_return := True
				end
			end
			if not l_return then
				(create {P_DEFAULT_STATIC}).dmp.item := min
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_DEFAULT_STATIC}).no_connect.item := 1
				update_class_fields -- Current might have been changed; synchronize
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
			end
		end

feature {PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN} -- private routines

	add_knum_to_str (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_n: INTEGER_32)
		require
			not a_s.is_void
			not a_l.is_void
		local
			l_a: CE_ARRAY [NATURAL_8]
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_a.make (<<13>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_n.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (a_n // 1_048_576) * 1_048_576 = a_n then
							(create {P_LINKS_STATIC}).snzprint (l_a, 12, (a_n // 1_048_576).to_integer_32).do_nothing
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_a), ce_string ("M")).do_nothing
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if a_n.to_boolean then
							if (a_n // 1_024) * 1_024 = a_n then
								(create {P_LINKS_STATIC}).snzprint (l_a, 12, (a_n // 1_024).to_integer_32).do_nothing
								strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_a), ce_string ("k")).do_nothing
							else
								(create {P_LINKS_STATIC}).snzprint (l_a, 13, a_n.to_integer_32).do_nothing
							end
						else
							(create {P_LINKS_STATIC}).snzprint (l_a, 13, a_n.to_integer_32).do_nothing
						end
				when 4 then;
					(create {P_LINKS_STATIC}).add_to_str (a_s, a_l, l_a)
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			p := a_other.p
			rd_cmd := a_other.rd_cmd
			rd_cfg := a_other.rd_cfg
			wr_cfg := a_other.wr_cfg
			min := a_other.min
			max := a_other.max
			ptr := a_other.ptr
			cfg_name := a_other.cfg_name
			cmd_name := a_other.cmd_name
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				p = a_other.p and
				rd_cmd.is_equal (a_other.rd_cmd) and
				rd_cfg.is_equal (a_other.rd_cfg) and
				wr_cfg.is_equal (a_other.wr_cfg) and
				min = a_other.min and
				max = a_other.max and
				ptr.is_equal (a_other.ptr) and
				cfg_name.is_equal (a_other.cfg_name) and
				cmd_name.is_equal (a_other.cmd_name)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("p"),
					create {CE_STRUCTURE_FIELD}.make ("rd_cmd"),
					create {CE_STRUCTURE_FIELD}.make ("rd_cfg"),
					create {CE_STRUCTURE_FIELD}.make ("wr_cfg"),
					create {CE_STRUCTURE_FIELD}.make ("min"),
					create {CE_STRUCTURE_FIELD}.make ("max"),
					create {CE_STRUCTURE_FIELD}.make ("ptr"),
					create {CE_STRUCTURE_FIELD}.make ("cfg_name"),
					create {CE_STRUCTURE_FIELD}.make ("cmd_name")
				>>)
			init_structure_info
		end

end
