class
	PD_SESSION_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- routine addresses

	mms_func_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_ses: CE_POINTER [PD_SESSION]; a_url: CE_POINTER [NATURAL_8])
				do
					a_ses.item.mms_func (a_url)
				end)
		end

	really_exit_prog_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_ses: CE_POINTER [PD_SESSION])
				do
					a_ses.item.really_exit_prog
				end)
		end

	dont_exit_prog_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_ses: CE_POINTER [PD_SESSION])
				do
					a_ses.item.dont_exit_prog
				end)
		end

	html_refresh_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_ses: CE_POINTER [PD_SESSION])
				do
					a_ses.item.html_refresh
				end)
		end

	search_back_dlg_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
				do
					a_ses.item.search_back_dlg (a_f, a_a)
				end)
		end

	search_dlg_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
				do
					a_ses.item.search_dlg (a_f, a_a)
				end)
		end

	start_download_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_ses: CE_POINTER [PD_SESSION]; a_file: CE_POINTER [NATURAL_8])
				do
					a_ses.item.start_download (a_file)
				end)
		end

	continue_download_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_ses: CE_POINTER [PD_SESSION]; a_file: CE_POINTER [NATURAL_8])
				do
					a_ses.item.continue_download (a_file)
				end)
		end

	tp_cancel_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_ses: CE_POINTER [PD_SESSION])
				do
					a_ses.item.tp_cancel
				end)
		end

	tp_save_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_ses: CE_POINTER [PD_SESSION])
				do
					a_ses.item.tp_save
				end)
		end

	tp_open_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_ses: CE_POINTER [PD_SESSION])
				do
					a_ses.item.tp_open
				end)
		end

	tp_display_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_ses: CE_POINTER [PD_SESSION])
				do
					a_ses.item.tp_display
				end)
		end

	display_timer2_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_ses: CE_POINTER [PD_SESSION])
				do
					a_ses.item.display_timer2
				end)
		end

	set_frame_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
				do
					a_ses.item.set_frame (a_f, a_a)
				end)
		end

	find_next_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
				do
					a_ses.item.find_next (a_f, a_a)
				end)
		end

	find_next_back_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
				do
					a_ses.item.find_next_back (a_f, a_a)
				end)
		end

	save_url_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_ses: CE_POINTER [PD_SESSION]; a_url: CE_POINTER [NATURAL_8])
				do
					a_ses.item.save_url (a_url)
				end)
		end

	save_formatted_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_ses: CE_POINTER [PD_SESSION]; a_file: CE_POINTER [NATURAL_8])
				do
					a_ses.item.save_formatted (a_file)
				end)
		end

	search_for_back_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_ses: CE_POINTER [PD_SESSION]; a_str: CE_POINTER [NATURAL_8])
				do
					a_ses.item.search_for_back (a_str)
				end)
		end

	search_for_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_ses: CE_POINTER [PD_SESSION]; a_str: CE_POINTER [NATURAL_8])
				do
					a_ses.item.search_for (a_str)
				end)
		end

	goto_link_number_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_ses: CE_POINTER [PD_SESSION]; a_num: CE_POINTER [NATURAL_8])
				do
					a_ses.item.goto_link_number (a_num)
				end)
		end

	display_download_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (create {PD_SESSION}.make).display_download)
		end

	undisplay_download_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (create {PD_SESSION}.make).undisplay_download)
		end

	down_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (create {PD_SESSION}.make).down)
		end

	page_down_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (create {PD_SESSION}.make).page_down)
		end

	send_image_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (create {PD_SESSION}.make).send_image)
		end

	link_menu_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (create {PD_SESSION}.make).link_menu)
		end

end
