class
	S_SYS_STAT_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	stat (a___file: CE_POINTER [INTEGER_8]; a___buf: CE_POINTER [SD_STAT]): INTEGER_32
		require
			not a___file.is_void
			not a___buf.is_void
		do
			Result := c_stat (a___file.c_pointer, a___buf.c_pointer)
		end

	c_stat (a___file: POINTER; a___buf: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return stat($a___file, $a___buf);"
		end

	chmod (a___file: CE_POINTER [INTEGER_8]; a___mode: NATURAL_32): INTEGER_32
		require
			not a___file.is_void
		do
			Result := c_chmod (a___file.c_pointer, a___mode)
		end

	c_chmod (a___file: POINTER; a___mode: NATURAL_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return chmod($a___file, $a___mode);"
		end

	mkdir (a___path: CE_POINTER [INTEGER_8]; a___mode: NATURAL_32): INTEGER_32
		require
			not a___path.is_void
		do
			Result := c_mkdir (a___path.c_pointer, a___mode)
		end

	c_mkdir (a___path: POINTER; a___mode: NATURAL_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return mkdir($a___path, $a___mode);"
		end

	lstat (a___file: CE_POINTER [INTEGER_8]; a___buf: CE_POINTER [SD_STAT]): INTEGER_32
		require
			not a___file.is_void
			not a___buf.is_void
		do
			Result := c_lstat (a___file.c_pointer, a___buf.c_pointer)
		end

	c_lstat (a___file: POINTER; a___buf: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return lstat($a___file, $a___buf);"
		end

end
