class
	P_GUI_GTK_STATIC

inherit
	CE_UTILITIES
	S_GDK_PIXBUF_GDK_PIXBUF_STATIC
	S_GTK_GTK_STATIC
	S_GLIB_OBJECT_STATIC
	S_GDK_GDK_STATIC
	S_GLIB_STATIC
	S_STRING_STATIC
	S_LIBINTL_STATIC

feature {ANY} -- public attributes

	popup_mouse_pos: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	find_widgets: CE_STATIC [CE_ARRAY [PD_SHAREDFINDREPLACE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_SHAREDFINDREPLACE]}.make_initialized (<<
					create {PD_SHAREDFINDREPLACE}.make_initialized ([create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer)])
				>>)
		end

	repl_widgets: CE_STATIC [CE_ARRAY [PD_SHAREDFINDREPLACE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_SHAREDFINDREPLACE]}.make_initialized (<<
					create {PD_SHAREDFINDREPLACE}.make_initialized ([create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer)])
				>>)
		end

feature {ANY} -- public routines

	add_stock_icon (a_factory: CE_POINTER [SD_GTKICONFACTORY]; a_stock_id: CE_POINTER [INTEGER_8]; a_inline_data: CE_POINTER [NATURAL_8]; a_data_length: INTEGER_32)
		local
			l_pixbuf: CE_POINTER [ANY]
			l_icon_set: CE_POINTER [ANY]
		do
			l_pixbuf := gdk_pixbuf_new_from_inline (a_data_length, a_inline_data, 0, create {CE_POINTER_POINTER [SD_GERROR]}.make_shared (default_pointer))
			l_icon_set := gtk_icon_set_new_from_pixbuf (l_pixbuf)
			gtk_icon_factory_add (a_factory, a_stock_id, l_icon_set)
			gtk_icon_set_unref (l_icon_set)
			g_object_unref (l_pixbuf)
		end

	toolbar_button_focus_in_event (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTFOCUS]; a_data: CE_POINTER [ANY]): INTEGER_32
		do
			if (create {P_GLOBALS_STATIC}).gtk_socket_id.item /= {NATURAL_32} 0 then
				gtk_widget_grab_focus ((create {P_GUI_STATIC}).gui.item.item.drawarea)
			end
			Result := 1
		end

	gui_gtk_register_stock_icons
		local
			l_factory: CE_POINTER [SD_GTKICONFACTORY]
		do
			l_factory := gtk_icon_factory_new
			add_stock_icon (l_factory, ce_string ("vim-build-tags"), (create {P_PIXMAPS_STOCK_ICONS_STATIC}).stock_vim_build_tags.item, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_329).to_natural_32).to_integer_32)
			add_stock_icon (l_factory, ce_string ("vim-find-help"), (create {P_PIXMAPS_STOCK_ICONS_STATIC}).stock_vim_find_help.item, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_329).to_natural_32).to_integer_32)
			add_stock_icon (l_factory, ce_string ("vim-save-all"), (create {P_PIXMAPS_STOCK_ICONS_STATIC}).stock_vim_save_all.item, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_329).to_natural_32).to_integer_32)
			add_stock_icon (l_factory, ce_string ("vim-session-load"), (create {P_PIXMAPS_STOCK_ICONS_STATIC}).stock_vim_session_load.item, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_329).to_natural_32).to_integer_32)
			add_stock_icon (l_factory, ce_string ("vim-session-new"), (create {P_PIXMAPS_STOCK_ICONS_STATIC}).stock_vim_session_new.item, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_329).to_natural_32).to_integer_32)
			add_stock_icon (l_factory, ce_string ("vim-session-save"), (create {P_PIXMAPS_STOCK_ICONS_STATIC}).stock_vim_session_save.item, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_329).to_natural_32).to_integer_32)
			add_stock_icon (l_factory, ce_string ("vim-shell"), (create {P_PIXMAPS_STOCK_ICONS_STATIC}).stock_vim_shell.item, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (9_241).to_natural_32).to_integer_32)
			add_stock_icon (l_factory, ce_string ("vim-window-maximize"), (create {P_PIXMAPS_STOCK_ICONS_STATIC}).stock_vim_window_maximize.item, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_329).to_natural_32).to_integer_32)
			add_stock_icon (l_factory, ce_string ("vim-window-maximize-width"), (create {P_PIXMAPS_STOCK_ICONS_STATIC}).stock_vim_window_maximize_width.item, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_329).to_natural_32).to_integer_32)
			add_stock_icon (l_factory, ce_string ("vim-window-minimize"), (create {P_PIXMAPS_STOCK_ICONS_STATIC}).stock_vim_window_minimize.item, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_329).to_natural_32).to_integer_32)
			add_stock_icon (l_factory, ce_string ("vim-window-minimize-width"), (create {P_PIXMAPS_STOCK_ICONS_STATIC}).stock_vim_window_minimize_width.item, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_329).to_natural_32).to_integer_32)
			add_stock_icon (l_factory, ce_string ("vim-window-split"), (create {P_PIXMAPS_STOCK_ICONS_STATIC}).stock_vim_window_split.item, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_329).to_natural_32).to_integer_32)
			add_stock_icon (l_factory, ce_string ("vim-window-split-vertical"), (create {P_PIXMAPS_STOCK_ICONS_STATIC}).stock_vim_window_split_vertical.item, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_329).to_natural_32).to_integer_32)
			gtk_icon_factory_add_default (l_factory)
			g_object_unref (create {CE_VOID_POINTER}.make_cast (l_factory))
		end

	translate_mnemonic_tag (a_name___1: CE_POINTER [NATURAL_8]; a_use_mnemonic: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_name___1: CE_POINTER [NATURAL_8]
			l_buf___6: CE_POINTER [NATURAL_8]
			l_psrc: CE_POINTER [NATURAL_8]
			l_pdest: CE_POINTER [NATURAL_8]
			l_n_underscores: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			l_name___1 := a_name___1
			l_n_underscores := 0
			if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
				l_name___1 := l_name___1
			elseif l_name___1.is_void then
				l_name___1 := l_name___1
			else
				l_name___1 := ((create {P_MBYTE_STATIC}).string_convert ((create {P_GLOBALS_STATIC}).output_conv.item, l_name___1, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)))
			end
			if l_name___1.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_psrc := l_name___1
				from
				until
					(l_break)
				loop
					l_break := False
					if (l_psrc.item).to_integer_32 /= 0 then
						if (l_psrc.item).to_integer_32 = 9 then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						if (l_psrc.item).to_integer_32 = 95 then
							l_n_underscores := l_n_underscores + 1
						end
						l_psrc := l_psrc + 1
					end
				end
				l_break := False
				l_buf___6 := (create {P_MISC2_STATIC}).alloc ((((l_psrc.distance (l_name___1)) + l_n_underscores) + 1).to_natural_32)
				if not l_buf___6.is_void then
					l_pdest := l_buf___6
					l_psrc := l_name___1
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_psrc.item).to_integer_32 /= 0 then
							if (l_psrc.item).to_integer_32 = 9 then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							if (l_psrc.item).to_integer_32 = 95 then
								l_tmp___0 := l_pdest
								l_pdest := l_pdest + 1
								l_tmp___0.item := (('_').code).to_natural_8
								l_tmp___1 := l_pdest
								l_pdest := l_pdest + 1
								l_tmp___1.item := (('_').code).to_natural_8
							elseif (l_psrc.item).to_integer_32 /= 38 then
								l_tmp___2 := l_pdest
								l_pdest := l_pdest + 1
								l_tmp___2.item := l_psrc.item
							elseif (l_psrc[1]).to_integer_32 = 38 then
								l_tmp___3 := l_pdest
								l_pdest := l_pdest + 1
								l_tmp___4 := l_psrc
								l_psrc := l_psrc + 1
								l_tmp___3.item := l_tmp___4.item
							elseif a_use_mnemonic.to_boolean then
								l_tmp___5 := l_pdest
								l_pdest := l_pdest + 1
								l_tmp___5.item := (('_').code).to_natural_8
							end
							l_psrc := l_psrc + 1
						end
					end
					l_break := False
					l_pdest.item := (('%/0/').code).to_natural_8
				end
				if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
					l_name___1 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				else
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_name___1))
					l_name___1 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				end
				Result := l_buf___6
			end
		end

	menu_item_activate (a_widget: CE_POINTER [SD_GTKWIDGET]; a_data: CE_POINTER [ANY])
		do
			(create {P_GUI_STATIC}).gui_menu_cb (create {CE_CLASS_POINTER [PD_VIMMENU]}.make_cast (a_data))
		end

	gui_mch_set_text_area_pos (a_x___0, a_y, a_w, a_h: INTEGER_32)
		do
			(create {P_GUI_GTK_F_STATIC}).gtk_form_move_resize (create {CE_CLASS_POINTER [PD_GTKFORM]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast ((create {P_GUI_STATIC}).gui.item.item.formwin), ((create {P_GUI_GTK_F_STATIC}).gtk_form_get_type)))), (create {P_GUI_STATIC}).gui.item.item.drawarea, a_x___0, a_y, a_w, a_h)
		end

	gui_gtk_set_mnemonics (a_enable: INTEGER_32)
		local
			l_menu___1: CE_POINTER [PD_VIMMENU]
			l_name___1: CE_POINTER [NATURAL_8]
			l_continue: BOOLEAN
		do
			l_menu___1 := (create {P_GLOBALS_STATIC}).root_menu.item.item
			from
			until
				l_menu___1.is_void
			loop
				l_continue := False
				if (l_menu___1.item.id).is_void then
					l_continue := True
				end
				if not (l_continue) then
					l_name___1 := translate_mnemonic_tag (l_menu___1.item.name, a_enable)
					gtk_label_set_text_with_mnemonic (create {CE_CLASS_POINTER [SD_GTKLABEL]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_menu___1.item.label), (gtk_label_get_type)))), create {CE_INTEGER_8_POINTER}.make_cast (l_name___1));
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_name___1))
				end
				l_menu___1 := l_menu___1.item.next
			end
			l_continue := False
		end

	recurse_tearoffs (a_menu___1: CE_POINTER [PD_VIMMENU]; a_val___0: INTEGER_32)
		local
			l_menu___1: CE_POINTER [PD_VIMMENU]
		do
			l_menu___1 := a_menu___1
			from
			until
				l_menu___1.is_void
			loop
				if not (l_menu___1.item.submenu_id).is_void then
					if not (l_menu___1.item.tearoff_handle).is_void then
						if (l_menu___1.item.name[0]).to_integer_32 /= 93 then
							if not ((create {P_MENU_STATIC}).menu_is_popup (l_menu___1.item.name)).to_boolean then
								if a_val___0.to_boolean then
									gtk_widget_show (l_menu___1.item.tearoff_handle)
								else
									gtk_widget_hide (l_menu___1.item.tearoff_handle)
								end
							end
						end
					end
				end
				recurse_tearoffs (l_menu___1.item.children, a_val___0)
				l_menu___1 := l_menu___1.item.next
			end
		end

	gui_mch_toggle_tearoffs (a_enable: INTEGER_32)
		do
			recurse_tearoffs ((create {P_GLOBALS_STATIC}).root_menu.item.item, a_enable)
		end

	adjustment_value_changed (a_adjustment: CE_POINTER [SD_GTKADJUSTMENT]; a_data: CE_POINTER [ANY])
		require
			not a_adjustment.is_void
		local
			l_sb: CE_POINTER [PD_GUISCROLLBAR]
			l_value: INTEGER_32
			l_dragging: INTEGER_32
			l_x___0: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
			l_state: CE_ARRAY [NATURAL_32]
			l_width: CE_ARRAY [INTEGER_32]
			l_height: CE_ARRAY [INTEGER_32]
		do
			create {CE_INTEGER_32_ARRAY} l_x___0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_y.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_state.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_width.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_height.make (<<1>>)

			l_dragging := 0
			if ((create {P_MBYTE_STATIC}).im_is_preediting).to_boolean then
				(create {P_MBYTE_STATIC}).xim_reset
			end
			l_sb := (create {P_GUI_STATIC}).gui_find_scrollbar ((a_data.c_pointer.to_integer_32).to_integer_32)
			l_value := (a_adjustment.item.value).truncated_to_integer
			if not l_sb.is_void then
				l_dragging := 1
				if not (l_sb.item.wp).is_void then
					gdk_window_get_pointer ((l_sb.item.id).item.window, l_x___0, l_y, l_state).do_nothing
					gdk_drawable_get_size ((l_sb.item.id).item.window, l_width, l_height)
					if l_x___0.item >= 0 then
						if l_x___0.item < l_width.item then
							if l_y.item >= 0 then
								if l_y.item < l_height.item then
									if l_y.item < l_width.item then
										l_dragging := 0
										l_value := (l_sb.item.wp).item.w_topline - 2
									elseif l_y.item > l_height.item - l_width.item then
										l_dragging := 0
										l_value := (l_sb.item.wp).item.w_topline
									end
								end
							end
						end
					end
				end
			end
			(create {P_GUI_STATIC}).gui_drag_scrollbar (l_sb, l_value, l_dragging)
		end

	gui_mch_browse (a_saving: INTEGER_32; a_title, a_dflt, a_ext, a_initdir, a_filter: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_title: CE_POINTER [NATURAL_8]
			l_fc: CE_POINTER [SD_GTKWIDGET]
			l_dirbuf: CE_ARRAY [NATURAL_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: INTEGER_32
			l_filename: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_dirbuf.make (<<4_096>>)

			l_title := a_title
			if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
				l_title := l_title
			elseif l_title.is_void then
				l_title := l_title
			else
				l_title := ((create {P_MBYTE_STATIC}).string_convert ((create {P_GLOBALS_STATIC}).output_conv.item, l_title, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)))
			end
			if a_initdir.is_void then
				(create {P_OS_UNIX_STATIC}).mch_dirname (l_dirbuf, 4_096).do_nothing
			elseif (a_initdir.item).to_integer_32 = 0 then
				(create {P_OS_UNIX_STATIC}).mch_dirname (l_dirbuf, 4_096).do_nothing
			elseif ((create {P_WINDOW_STATIC}).vim_FullName (a_initdir, l_dirbuf, 4_094, 0)) = 0 then
				l_dirbuf[0] := (('%/0/').code).to_natural_8
			end
			(create {P_MISC1_STATIC}).add_pathsep (l_dirbuf);
			(create {P_GUI_GTK_X11_STATIC}).gui_mch_mousehide (0)
			if a_saving.to_boolean then
				l_tmp___1 := ce_string ("gtk-save")
			else
				l_tmp___1 := ce_string ("gtk-open")
			end
			if a_saving.to_boolean then
				l_tmp___2 := 1
			else
				l_tmp___2 := 0
			end
			l_fc := gtk_file_chooser_dialog_new ([create {CE_INTEGER_8_POINTER}.make_cast (l_title), create {CE_CLASS_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast ((create {P_GUI_STATIC}).gui.item.item.mainwin), (gtk_window_get_type)))), l_tmp___2.to_natural_32, ce_string ("gtk-cancel"), -6, l_tmp___1, -3, create {CE_VOID_POINTER}.make_shared (default_pointer)])
			gtk_file_chooser_set_current_folder (create {CE_VOID_POINTER}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_fc), (gtk_file_chooser_get_type)))), create {CE_INTEGER_8_POINTER}.make_cast (l_dirbuf)).do_nothing
			if a_saving.to_boolean then
				if not a_dflt.is_void then
					if (a_dflt.item).to_integer_32 /= 0 then
						gtk_file_chooser_set_current_name (create {CE_VOID_POINTER}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_fc), (gtk_file_chooser_get_type)))), create {CE_INTEGER_8_POINTER}.make_cast (a_dflt))
					end
				end
			end
			(create {P_GUI_STATIC}).gui.item.item.browse_fname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			if (gtk_dialog_run (create {CE_CLASS_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_fc), (gtk_dialog_get_type)))))) = -3 then
				l_filename := gtk_file_chooser_get_filename (create {CE_VOID_POINTER}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_fc), (gtk_file_chooser_get_type)))));
				(create {P_GUI_STATIC}).gui.item.item.browse_fname := create {CE_NATURAL_8_POINTER}.make_cast ((g_strdup (l_filename)))
				g_free (create {CE_VOID_POINTER}.make_cast (l_filename))
			end
			gtk_widget_destroy (create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_fc), (gtk_widget_get_type)))))
			if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
				l_title := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			else
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_title))
				l_title := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			end
			if ((create {P_GUI_STATIC}).gui.item.item.browse_fname).is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := ((create {P_MISC2_STATIC}).vim_strsave (((create {P_FILEIO_STATIC}).shorten_fname1 ((create {P_GUI_STATIC}).gui.item.item.browse_fname))))
			end
		end

	gui_mch_browsedir (a_title, a_initdir: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_title: CE_POINTER [NATURAL_8]
			l_dirbuf: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_dirdlg: CE_POINTER [SD_GTKWIDGET]
			l_dirname: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_dirbuf.make (<<4_096>>)

			l_title := a_title
			l_dirname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
				l_title := l_title
			elseif l_title.is_void then
				l_title := l_title
			else
				l_title := ((create {P_MBYTE_STATIC}).string_convert ((create {P_GLOBALS_STATIC}).output_conv.item, l_title, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)))
			end
			l_dirdlg := gtk_file_chooser_dialog_new ([create {CE_INTEGER_8_POINTER}.make_cast (l_title), create {CE_CLASS_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast ((create {P_GUI_STATIC}).gui.item.item.mainwin), (gtk_window_get_type)))), {SC_GTKFILECHOOSERACTION}.GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER, ce_string ("gtk-cancel"), -6, ce_string ("gtk-ok"), -3, create {CE_VOID_POINTER}.make_shared (default_pointer)])
			if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
				l_title := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			else
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_title))
				l_title := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			end
			(create {P_GUI_GTK_X11_STATIC}).gui_mch_mousehide (0)
			if a_initdir.is_void then
				(create {P_OS_UNIX_STATIC}).mch_dirname (l_dirbuf, 4_086).do_nothing
			elseif (a_initdir.item).to_integer_32 = 0 then
				(create {P_OS_UNIX_STATIC}).mch_dirname (l_dirbuf, 4_086).do_nothing
			elseif ((create {P_WINDOW_STATIC}).vim_FullName (a_initdir, l_dirbuf, 4_086, 0)) = 0 then
				(create {P_OS_UNIX_STATIC}).mch_dirname (l_dirbuf, 4_086).do_nothing
			end
			(create {P_MISC1_STATIC}).add_pathsep (l_dirbuf)
			strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_dirbuf), ce_string ("@zd(*&1|")).do_nothing
			gtk_file_chooser_set_filename (create {CE_VOID_POINTER}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dirdlg), (gtk_file_chooser_get_type)))), create {CE_INTEGER_8_POINTER}.make_cast (l_dirbuf)).do_nothing
			if (gtk_dialog_run (create {CE_CLASS_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dirdlg), (gtk_dialog_get_type)))))) = -3 then
				l_dirname := create {CE_NATURAL_8_POINTER}.make_cast ((gtk_file_chooser_get_filename (create {CE_VOID_POINTER}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dirdlg), (gtk_file_chooser_get_type)))))))
			end
			gtk_widget_destroy (l_dirdlg)
			if l_dirname.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_p___0 := (create {P_MISC2_STATIC}).vim_strsave (((create {P_FILEIO_STATIC}).shorten_fname1 (l_dirname)))
				g_free (create {CE_VOID_POINTER}.make_cast (l_dirname))
				Result := l_p___0
			end
		end

	create_message_dialog (a_type: INTEGER_32; a_title, a_message: CE_POINTER [NATURAL_8]): CE_POINTER [SD_GTKWIDGET]
		local
			l_title: CE_POINTER [NATURAL_8]
			l_message: CE_POINTER [NATURAL_8]
			l_dialog: CE_POINTER [SD_GTKWIDGET]
			l_message_type: NATURAL_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_title := a_title
					l_message := a_message
					inspect a_type -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 4 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 1
					l_message_type := {SC_GTKMESSAGETYPE}.GTK_MESSAGE_ERROR
					l_pos := -1 + 5 -- switch 1; break
				when 2 then -- switch 1, case 2
					l_message_type := {SC_GTKMESSAGETYPE}.GTK_MESSAGE_WARNING
					l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case 4
					l_message_type := {SC_GTKMESSAGETYPE}.GTK_MESSAGE_QUESTION
					l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, default:
					l_message_type := {SC_GTKMESSAGETYPE}.GTK_MESSAGE_INFO
					l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done:
					if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
						l_message := l_message
					elseif l_message.is_void then
						l_message := l_message
					else
						l_message := ((create {P_MBYTE_STATIC}).string_convert ((create {P_GLOBALS_STATIC}).output_conv.item, l_message, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)))
					end
					l_dialog := gtk_message_dialog_new ([create {CE_CLASS_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast ((create {P_GUI_STATIC}).gui.item.item.mainwin), (gtk_window_get_type)))), {SC_GTKDIALOGFLAGS}.GTK_DIALOG_DESTROY_WITH_PARENT, l_message_type, {SC_GTKBUTTONSTYPE}.GTK_BUTTONS_NONE, ce_string ("%%s"), create {CE_INTEGER_8_POINTER}.make_cast (l_message)])
					if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
						l_message := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					else
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_message))
						l_message := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					end
					if not l_title.is_void then
						if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
							l_title := l_title
						elseif l_title.is_void then
							l_title := l_title
						else
							l_title := ((create {P_MBYTE_STATIC}).string_convert ((create {P_GLOBALS_STATIC}).output_conv.item, l_title, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)))
						end
						gtk_window_set_title (create {CE_CLASS_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dialog), (gtk_window_get_type)))), create {CE_INTEGER_8_POINTER}.make_cast (l_title))
						if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
							l_title := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						else
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_title))
							l_title := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						end
					elseif a_type = 0 then
						gtk_window_set_title (create {CE_CLASS_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dialog), (gtk_window_get_type)))), ce_string ("VIM"))
					end
					Result := l_dialog
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	split_button_string (a_button_string: CE_POINTER [NATURAL_8]; a_n_buttons: CE_POINTER [INTEGER_32]): CE_POINTER [CE_POINTER [INTEGER_8]]
		require
			not a_button_string.is_void
			not a_n_buttons.is_void
		local
			l_array: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_p___0: CE_POINTER [NATURAL_8]
			l_count___2: NATURAL_32
			l_tmp___0: NATURAL_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: NATURAL_32
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___5: INTEGER_32
		do
			l_count___2 := {NATURAL_32} 1
			l_p___0 := a_button_string
			from
			until
				(l_p___0.item).to_integer_32 = 0
			loop
				if (l_p___0.item).to_integer_32 = 10 then
					l_count___2 := l_count___2 + 1
				end
				l_p___0 := l_p___0 + 1
			end
			l_array := create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (((create {P_MISC2_STATIC}).alloc ((l_count___2 + {NATURAL_32} 1) * {PLATFORM}.Pointer_bytes.to_natural_32)))
			l_count___2 := {NATURAL_32} 0
			if not l_array.is_void then
				l_tmp___0 := l_count___2
				l_count___2 := l_count___2 + 1
				l_array[l_tmp___0.to_integer_32] := create {CE_INTEGER_8_POINTER}.make_cast (a_button_string)
				l_p___0 := a_button_string
				from
				until
					(l_p___0.item).to_integer_32 = 0
				loop
					if (l_p___0.item).to_integer_32 = 10 then
						l_tmp___1 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___1.item := (('%/0/').code).to_natural_8
						l_tmp___2 := l_count___2
						l_count___2 := l_count___2 + 1
						l_array[l_tmp___2.to_integer_32] := create {CE_INTEGER_8_POINTER}.make_cast (l_p___0)
					elseif (l_p___0.item).to_integer_32 = 38 then
						l_tmp___3 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___3.item := (('_').code).to_natural_8
					else
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___5 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0]))
						else
							l_tmp___5 := 1
						end
						l_p___0 := l_p___0 + l_tmp___5
					end
				end
				l_array[l_count___2.to_integer_32] := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			end
			a_n_buttons.item := l_count___2.to_integer_32
			Result := l_array
		end

	split_button_translation (a_message: CE_POINTER [INTEGER_8]): CE_POINTER [CE_POINTER [INTEGER_8]]
		local
			l_buttons: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_str___1: CE_POINTER [NATURAL_8]
			l_n_buttons: CE_ARRAY [INTEGER_32]
			l_n_expected: INTEGER_32
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_n_buttons.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buttons := create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_n_buttons.item := 0
					l_n_expected := 1
					l_str___1 := create {CE_NATURAL_8_POINTER}.make_cast (a_message)
					from
					until
						(l_str___1.item).to_integer_32 = 0
					loop
						if (l_str___1.item).to_integer_32 = 10 then
							l_n_expected := l_n_expected + 1
						end
						l_str___1 := l_str___1 + 1
					end
					l_str___1 := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (a_message)))
					if not l_str___1.is_void then
						if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type /= 0 then
							l_str___1 := (create {P_MBYTE_STATIC}).string_convert ((create {P_GLOBALS_STATIC}).output_conv.item, l_str___1, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						else
							l_str___1 := (create {P_MISC2_STATIC}).vim_strsave (l_str___1)
						end
						if not l_str___1.is_void then
							l_buttons := split_button_string (l_str___1, l_n_buttons)
						end
					end
					if not (l_buttons.is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_n_buttons.item = l_n_expected then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buttons));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_str___1))
						l_buttons := create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer)
						l_str___1 := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (a_message))
						if not l_str___1.is_void then
							l_buttons := split_button_string (l_str___1, l_n_buttons)
						end
						if l_buttons.is_void then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_str___1))
						end
				when 5 then -- if done
					Result := l_buttons
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	button_equal (a_a, a_b: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_a.is_void
		local
			l_a: CE_POINTER [INTEGER_8]
			l_b: CE_POINTER [INTEGER_8]
			l_tmp___0: NATURAL_32
			l_tmp___3: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_a := a_a
			l_b := a_b
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				if (l_a[0]).to_integer_32 /= 0 then
					if (l_b[0]).to_integer_32 = 0 then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_return or l_break) and then ((l_a[0]).to_integer_32 = 95) then
					l_a := l_a + 1
					if (l_a[0]).to_integer_32 = 0 then
						l_break := True
					end
				end
				if not (l_return or l_break) and then ((l_b[0]).to_integer_32 = 95) then
					l_b := l_b + 1
					if (l_b[0]).to_integer_32 = 0 then
						l_break := True
					end
				end
				if not (l_return or l_break) then
					l_tmp___0 := g_unichar_tolower ((g_utf8_get_char (l_a)))
					if l_tmp___0 /= (g_unichar_tolower ((g_utf8_get_char (l_b)))) then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_a := (l_a + (g_utf8_skip[((create {CE_NATURAL_8_POINTER}.make_cast (l_a)).item).to_integer_32]).to_integer_32)
						l_b := (l_b + (g_utf8_skip[((create {CE_NATURAL_8_POINTER}.make_cast (l_b)).item).to_integer_32]).to_integer_32)
					end
				end
			end
			if not l_return then
				l_break := False
				if (l_a[0]).to_integer_32 = 0 then
					if (l_b[0]).to_integer_32 = 0 then
						l_tmp___3 := 1
					else
						l_tmp___3 := 0
					end
				else
					l_tmp___3 := 0
				end
				Result := l_tmp___3
			end
		end

	dialog_add_buttons (a_dialog: CE_POINTER [SD_GTKDIALOG]; a_button_string: CE_POINTER [NATURAL_8])
		local
			l_button_string: CE_POINTER [NATURAL_8]
			l_ok: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_ync: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_buttons: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_n_buttons: CE_ARRAY [INTEGER_32]
			l_idx: INTEGER_32
			l_vbutton_box: CE_POINTER [SD_GTKWIDGET]
			l_tmp: NATURAL_32
			l_label: CE_POINTER [INTEGER_8]
			l_label8: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_n_buttons.make (<<1>>)

			l_button_string := a_button_string
			l_n_buttons.item := 0
			l_button_string := (create {P_MISC2_STATIC}).vim_strsave (l_button_string)
			if l_button_string.is_void then
				l_return := True
			end
			if not l_return then
				if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_go.item.item, ('v').code)).is_void then
					l_vbutton_box := gtk_vbutton_box_new
					gtk_widget_show (l_vbutton_box)
					l_tmp := gtk_box_get_type
					gtk_box_pack_end (create {CE_CLASS_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast ((create {CE_CLASS_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_dialog), (gtk_dialog_get_type))))).item.vbox), l_tmp))), l_vbutton_box, 1, 0, (0).to_natural_32);
					(create {CE_CLASS_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_dialog), (gtk_dialog_get_type))))).item.action_area := l_vbutton_box
				end
				l_ok := split_button_translation (ce_string ("&Ok"))
				l_ync := split_button_translation (ce_string ("&Yes%N&No%N&Cancel"))
				l_buttons := split_button_string (l_button_string, l_n_buttons)
				l_idx := 1
				from
				until
					not (l_idx <= l_n_buttons.item)
				loop
					l_label := l_buttons[(l_idx - 1)]
					if not l_ok.is_void then
						if not l_ync.is_void then
							if (button_equal (l_label, l_ok[0])).to_boolean then
								l_label := ce_string ("gtk-ok")
							elseif (button_equal (l_label, l_ync[0])).to_boolean then
								l_label := ce_string ("gtk-yes")
							elseif (button_equal (l_label, l_ync[1])).to_boolean then
								l_label := ce_string ("gtk-no")
							elseif (button_equal (l_label, l_ync[2])).to_boolean then
								l_label := ce_string ("gtk-cancel")
							elseif (button_equal (l_label, ce_string ("Ok"))).to_boolean then
								l_label := ce_string ("gtk-ok")
							elseif (button_equal (l_label, ce_string ("Yes"))).to_boolean then
								l_label := ce_string ("gtk-yes")
							elseif (button_equal (l_label, ce_string ("No"))).to_boolean then
								l_label := ce_string ("gtk-no")
							elseif (button_equal (l_label, ce_string ("Cancel"))).to_boolean then
								l_label := ce_string ("gtk-cancel")
							end
						end
					end
					if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
						l_label8 := create {CE_NATURAL_8_POINTER}.make_cast (l_label)
					elseif l_label.is_void then
						l_label8 := create {CE_NATURAL_8_POINTER}.make_cast (l_label)
					else
						l_label8 := ((create {P_MBYTE_STATIC}).string_convert ((create {P_GLOBALS_STATIC}).output_conv.item, create {CE_NATURAL_8_POINTER}.make_cast (l_label), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)))
					end
					gtk_dialog_add_button (a_dialog, create {CE_INTEGER_8_POINTER}.make_cast (l_label8), l_idx).do_nothing
					if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
						l_label8 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					else
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_label8))
						l_label8 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					end
					l_idx := l_idx + 1
				end
				if not l_ok.is_void then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ok.item))
				end
				if not l_ync.is_void then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ync.item))
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ok));
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ync));
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buttons));
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_button_string))
			end
		end

	dialog_key_press_event_cb (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTKEY]; a_data: CE_POINTER [ANY]): INTEGER_32
		require
			not a_event.is_void
		local
			l_di: CE_POINTER [PD_DIALOGINFO]
			l_tmp___1: NATURAL_32
			l_return: BOOLEAN
		do
			l_di := create {CE_CLASS_POINTER [PD_DIALOGINFO]}.make_cast (a_data)
			if (l_di.item.ignore_enter).to_boolean then
				if a_event.item.keyval = {NATURAL_32} 65_293 then
					Result := 1
					l_return := True
				elseif a_event.item.keyval = {NATURAL_32} 32 then
					Result := 1
					l_return := True
				else
					l_di.item.ignore_enter := 0
				end
			else
				l_di.item.ignore_enter := 0
			end
			if not l_return and then (a_event.item.keyval = {NATURAL_32} 65_307) then
				gtk_dialog_response (l_di.item.dialog, -2)
				Result := 1
				l_return := True
			end
			if not l_return and then ((l_di.item.noalt).to_boolean) then
				if ((a_event.item.state).bit_and ((gtk_accelerator_get_default_mod_mask))) = {NATURAL_32} 0 then
					l_tmp___1 := gtk_window_get_mnemonic_modifier (create {CE_CLASS_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget), (gtk_window_get_type)))))
					Result := (gtk_window_mnemonic_activate (create {CE_CLASS_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget), (gtk_window_get_type)))), a_event.item.keyval, l_tmp___1))
					l_return := True
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gui_mch_dialog (a_type: INTEGER_32; a_title, a_message, a_buttons: CE_POINTER [NATURAL_8]; a_def_but: INTEGER_32; a_textfield: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_dialog: CE_POINTER [SD_GTKWIDGET]
			l_entry: CE_POINTER [SD_GTKWIDGET]
			l_text: CE_POINTER [NATURAL_8]
			l_response: INTEGER_32
			l_dialoginfo: CE_ARRAY [PD_DIALOGINFO]
			l_alignment: CE_POINTER [SD_GTKWIDGET]
			l_tmp___10: NATURAL_32
			l_tmp___23: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_DIALOGINFO]} l_dialoginfo.make (<<1>>)

			l_entry := create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer)
			l_dialog := create_message_dialog (a_type, a_title, a_message)
			l_dialoginfo.item.dialog := create {CE_CLASS_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dialog), (gtk_dialog_get_type))))
			dialog_add_buttons (create {CE_CLASS_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dialog), (gtk_dialog_get_type)))), a_buttons)
			if not a_textfield.is_void then
				l_entry := gtk_entry_new
				gtk_widget_show (l_entry)
				if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
					l_text := a_textfield
				elseif a_textfield.is_void then
					l_text := a_textfield
				else
					l_text := ((create {P_MBYTE_STATIC}).string_convert ((create {P_GLOBALS_STATIC}).output_conv.item, a_textfield, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)))
				end
				gtk_entry_set_text (create {CE_CLASS_POINTER [SD_GTKENTRY]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_entry), (gtk_entry_get_type)))), create {CE_INTEGER_8_POINTER}.make_cast (l_text))
				if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
					l_text := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				else
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_text))
					l_text := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				end
				l_alignment := gtk_alignment_new ((0.5).truncated_to_real, (0.5).truncated_to_real, (1.0).truncated_to_real, (1.0).truncated_to_real)
				gtk_container_add (create {CE_CLASS_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_alignment), (gtk_container_get_type)))), l_entry)
				gtk_container_set_border_width (create {CE_CLASS_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_alignment), (gtk_container_get_type)))), (5).to_natural_32)
				gtk_widget_show (l_alignment)
				l_tmp___10 := gtk_box_get_type
				gtk_box_pack_start (create {CE_CLASS_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast ((create {CE_CLASS_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dialog), (gtk_dialog_get_type))))).item.vbox), l_tmp___10))), l_alignment, 1, 0, (0).to_natural_32)
				l_dialoginfo.item.noalt := 0
			else
				l_dialoginfo.item.noalt := 1
			end
			g_signal_connect_data (create {CE_VOID_POINTER}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dialog), ((20).bit_shift_left (2)).to_natural_32))), ce_string ("key_press_event"), (dialog_key_press_event_cb_address), create {CE_VOID_POINTER}.make_cast (l_dialoginfo), create {CE_ROUTINE}.make_shared (default_pointer), (0).to_natural_32).do_nothing
			if a_def_but > 0 then
				gtk_dialog_set_default_response (create {CE_CLASS_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dialog), (gtk_dialog_get_type)))), a_def_but)
				l_dialoginfo.item.ignore_enter := 0
			else
				l_dialoginfo.item.ignore_enter := 1
			end
			(create {P_GUI_GTK_X11_STATIC}).gui_mch_mousehide (0)
			l_response := gtk_dialog_run (create {CE_CLASS_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dialog), (gtk_dialog_get_type)))))
			if l_response /= -1 then
				if l_response = -3 then
					l_response := a_def_but
				end
				if not a_textfield.is_void then
					l_text := create {CE_NATURAL_8_POINTER}.make_cast ((gtk_entry_get_text (create {CE_CLASS_POINTER [SD_GTKENTRY]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_entry), (gtk_entry_get_type)))))))
					if (create {P_GLOBALS_STATIC}).input_conv.item.item.vc_type = 0 then
						l_text := l_text
					elseif l_text.is_void then
						l_text := l_text
					else
						l_text := ((create {P_MBYTE_STATIC}).string_convert ((create {P_GLOBALS_STATIC}).input_conv.item, l_text, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)))
					end
					(create {P_MISC2_STATIC}).vim_strncpy (a_textfield, l_text, (1_024).to_natural_32)
					if (create {P_GLOBALS_STATIC}).input_conv.item.item.vc_type = 0 then
						l_text := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					else
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_text))
						l_text := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					end
				end
				gtk_widget_destroy (l_dialog)
			end
			if l_response > 0 then
				l_tmp___23 := l_response
			else
				l_tmp___23 := 0
			end
			Result := l_tmp___23
		end

	popup_menu_position_func (a_menu___1: CE_POINTER [SD_GTKMENU]; a_x___0, a_y, a_push_in: CE_POINTER [INTEGER_32]; a_user_data: CE_POINTER [ANY])
		local
			l_mx: CE_ARRAY [INTEGER_32]
			l_my: CE_ARRAY [INTEGER_32]
		do
			create {CE_INTEGER_32_ARRAY} l_mx.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_my.make (<<1>>)

			gdk_window_get_origin (((create {P_GUI_STATIC}).gui.item.item.drawarea).item.window, a_x___0, a_y).do_nothing
			if popup_mouse_pos.item.to_boolean then
				(create {P_GUI_GTK_X11_STATIC}).gui_mch_getmouse (l_mx, l_my)
				a_x___0.item := a_x___0.item + (l_mx.item)
				a_y.item := a_y.item + (l_my.item)
			elseif not ((create {P_GLOBALS_STATIC}).curwin.item).is_void then
				if not ((create {P_GUI_STATIC}).gui.item.item.drawarea).is_void then
					if not (((create {P_GUI_STATIC}).gui.item.item.drawarea).item.window).is_void then
						a_x___0.item := a_x___0.item + (((((create {P_GLOBALS_STATIC}).curwin.item.item.w_wincol + (create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol) + 1) * (create {P_GUI_STATIC}).gui.item.item.char_width + (create {P_GUI_STATIC}).gui.item.item.border_offset) + 1)
						a_y.item := a_y.item + (((((create {P_GLOBALS_STATIC}).curwin.item.item.w_winrow + (create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow) + 1) * (create {P_GUI_STATIC}).gui.item.item.char_height + (create {P_GUI_STATIC}).gui.item.item.border_offset) + 1)
					end
				end
			end
		end

	find_key_press_event (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTKEY]; a_frdp: CE_POINTER [PD_SHAREDFINDREPLACE]): INTEGER_32
		require
			not a_event.is_void
		local
			l_return: BOOLEAN
		do
			if ((a_event.item.state).bit_and ({NATURAL_32} 5)).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return and then (a_event.item.keyval = {NATURAL_32} 65_307) then
				gtk_widget_hide (a_frdp.item.dialog)
				Result := 1
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	create_image_button (a_stock_id, a_label: CE_POINTER [INTEGER_8]): CE_POINTER [SD_GTKWIDGET]
		local
			l_text: CE_POINTER [NATURAL_8]
			l_box: CE_POINTER [SD_GTKWIDGET]
			l_alignment: CE_POINTER [SD_GTKWIDGET]
			l_button: CE_POINTER [SD_GTKWIDGET]
			l_tmp___0: CE_POINTER [SD_GTKWIDGET]
			l_tmp___3: CE_POINTER [SD_GTKWIDGET]
		do
			if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
				l_text := create {CE_NATURAL_8_POINTER}.make_cast (a_label)
			elseif a_label.is_void then
				l_text := create {CE_NATURAL_8_POINTER}.make_cast (a_label)
			else
				l_text := ((create {P_MBYTE_STATIC}).string_convert ((create {P_GLOBALS_STATIC}).output_conv.item, create {CE_NATURAL_8_POINTER}.make_cast (a_label), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)))
			end
			l_box := gtk_hbox_new (0, 3)
			l_tmp___0 := gtk_image_new_from_stock (a_stock_id, {SC_GTKICONSIZE}.GTK_ICON_SIZE_BUTTON)
			gtk_box_pack_start (create {CE_CLASS_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_box), (gtk_box_get_type)))), l_tmp___0, 0, 0, (0).to_natural_32)
			l_tmp___3 := gtk_label_new (create {CE_INTEGER_8_POINTER}.make_cast (l_text))
			gtk_box_pack_start (create {CE_CLASS_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_box), (gtk_box_get_type)))), l_tmp___3, 0, 0, (0).to_natural_32)
			if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
				l_text := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			else
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_text))
				l_text := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			end
			l_alignment := gtk_alignment_new ((0.5).truncated_to_real, (0.5).truncated_to_real, (0.0).truncated_to_real, (0.0).truncated_to_real)
			gtk_container_add (create {CE_CLASS_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_alignment), (gtk_container_get_type)))), l_box)
			gtk_widget_show_all (l_alignment)
			l_button := gtk_button_new
			gtk_container_add (create {CE_CLASS_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_button), (gtk_container_get_type)))), l_alignment)
			Result := l_button
		end

	convert_localized_message (a_buffer: CE_POINTER [CE_POINTER [NATURAL_8]]; a_message: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_return: BOOLEAN
		do
			if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
				Result := a_message
				l_return := True
			end
			if not l_return then
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_buffer.item))
				a_buffer.item := (create {P_MBYTE_STATIC}).string_convert ((create {P_GLOBALS_STATIC}).output_conv.item, create {CE_NATURAL_8_POINTER}.make_cast (a_message), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
				Result := (create {CE_INTEGER_8_POINTER}.make_cast (a_buffer.item))
			end
		end

	find_replace_dialog_create (a_arg: CE_POINTER [NATURAL_8]; a_do_replace: INTEGER_32)
		require
			not a_arg.is_void
		local
			l_hbox: CE_POINTER [SD_GTKWIDGET]
			l_actionarea: CE_POINTER [SD_GTKWIDGET]
			l_table: CE_POINTER [SD_GTKWIDGET]
			l_tmp: CE_POINTER [SD_GTKWIDGET]
			l_vbox: CE_POINTER [SD_GTKWIDGET]
			l_sensitive: INTEGER_32
			l_frdp: CE_POINTER [PD_SHAREDFINDREPLACE]
			l_entry_text: CE_POINTER [NATURAL_8]
			l_wword: CE_ARRAY [INTEGER_32]
			l_mcase: CE_ARRAY [INTEGER_32]
			l_conv_buffer: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_old_text: CE_POINTER [NATURAL_8]
			l_tmp___11: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___17: CE_POINTER [INTEGER_8]
			l_tmp___21: CE_POINTER [INTEGER_8]
			l_tmp___26: NATURAL_32
			l_tmp___40: INTEGER_32
			l_tmp___96: CE_POINTER [INTEGER_8]
			l_tmp___111: CE_POINTER [ANY]
			l_tmp___115: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___120: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___127: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___133: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___137: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___141: CE_POINTER [SD_GTYPEINSTANCE]
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_wword.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_mcase.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_conv_buffer.make (<<1>>)

			l_wword.item := 0
			l_mcase.item := (not ((create {P_OPTION_STATIC}).p_ic.item.item).to_boolean).to_integer
			l_conv_buffer.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			if a_do_replace.to_boolean then
				l_frdp := repl_widgets.item
			else
				l_frdp := find_widgets.item
			end
			l_entry_text := (create {P_GUI_STATIC}).get_find_dialog_text (a_arg, l_wword, l_mcase)
			if not l_entry_text.is_void then
				if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type /= 0 then
					l_old_text := l_entry_text
					l_entry_text := (create {P_MBYTE_STATIC}).string_convert ((create {P_GLOBALS_STATIC}).output_conv.item, l_entry_text, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer));
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_old_text))
				end
			end
			if (not (l_frdp.item.dialog).is_void) then
				if not l_entry_text.is_void then
					gtk_entry_set_text (create {CE_CLASS_POINTER [SD_GTKENTRY]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.what), (gtk_entry_get_type)))), create {CE_INTEGER_8_POINTER}.make_cast (l_entry_text))
					gtk_toggle_button_set_active (create {CE_CLASS_POINTER [SD_GTKTOGGLEBUTTON]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.wword), (gtk_toggle_button_get_type)))), l_wword.item)
					gtk_toggle_button_set_active (create {CE_CLASS_POINTER [SD_GTKTOGGLEBUTTON]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.mcase), (gtk_toggle_button_get_type)))), l_mcase.item)
				end
				gtk_window_present (create {CE_CLASS_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.dialog), (gtk_window_get_type)))));
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_entry_text))
				l_return := True
			end
			if not l_return then
				l_frdp.item.dialog := gtk_dialog_new
				gtk_dialog_set_has_separator (create {CE_CLASS_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.dialog), (gtk_dialog_get_type)))), 0)
				l_tmp___11 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast ((create {P_GUI_STATIC}).gui.item.item.mainwin), (gtk_window_get_type))
				gtk_window_set_transient_for (create {CE_CLASS_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.dialog), (gtk_window_get_type)))), create {CE_CLASS_POINTER [SD_GTKWINDOW]}.make_cast (l_tmp___11))
				gtk_window_set_destroy_with_parent (create {CE_CLASS_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.dialog), (gtk_window_get_type)))), 1)
				if a_do_replace.to_boolean then
					l_tmp___17 := convert_localized_message (l_conv_buffer, (gettext (ce_string ("VIM - Search and Replace..."))))
					gtk_window_set_title (create {CE_CLASS_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.dialog), (gtk_window_get_type)))), l_tmp___17)
				else
					l_tmp___21 := convert_localized_message (l_conv_buffer, (gettext (ce_string ("VIM - Search..."))))
					gtk_window_set_title (create {CE_CLASS_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.dialog), (gtk_window_get_type)))), l_tmp___21)
				end
				l_hbox := gtk_hbox_new (0, 0)
				gtk_container_set_border_width (create {CE_CLASS_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_hbox), (gtk_container_get_type)))), (10).to_natural_32)
				l_tmp___26 := gtk_container_get_type
				gtk_container_add (create {CE_CLASS_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast ((create {CE_CLASS_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.dialog), (gtk_dialog_get_type))))).item.vbox), l_tmp___26))), l_hbox)
				if a_do_replace.to_boolean then
					l_table := gtk_table_new ((1_024).to_natural_32, (4).to_natural_32, 0)
				else
					l_table := gtk_table_new ((1_024).to_natural_32, (3).to_natural_32, 0)
				end
				gtk_box_pack_start (create {CE_CLASS_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_hbox), (gtk_box_get_type)))), l_table, 1, 1, (0).to_natural_32)
				gtk_container_set_border_width (create {CE_CLASS_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_table), (gtk_container_get_type)))), (4).to_natural_32)
				l_tmp := gtk_label_new ((convert_localized_message (l_conv_buffer, (gettext (ce_string ("Find what:"))))))
				gtk_misc_set_alignment (create {CE_CLASS_POINTER [SD_GTKMISC]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_tmp), (gtk_misc_get_type)))), (0.0).truncated_to_real, (0.5).truncated_to_real)
				gtk_table_attach (create {CE_CLASS_POINTER [SD_GTKTABLE]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_table), (gtk_table_get_type)))), l_tmp, (0).to_natural_32, (1).to_natural_32, (0).to_natural_32, (1).to_natural_32, {SC_GTKATTACHOPTIONS}.GTK_FILL, {SC_GTKATTACHOPTIONS}.GTK_EXPAND, (2).to_natural_32, (2).to_natural_32)
				l_frdp.item.what := gtk_entry_new
				if not l_entry_text.is_void then
					if (l_entry_text[0]).to_integer_32 /= 0 then
						l_tmp___40 := 1
					else
						l_tmp___40 := 0
					end
				else
					l_tmp___40 := 0
				end
				l_sensitive := l_tmp___40
				if not l_entry_text.is_void then
					gtk_entry_set_text (create {CE_CLASS_POINTER [SD_GTKENTRY]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.what), (gtk_entry_get_type)))), create {CE_INTEGER_8_POINTER}.make_cast (l_entry_text))
				end
				gtk_signal_connect_full (create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.what), (gtk_object_get_type)))), ce_string ("changed"), (entry_changed_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_cast (l_frdp.item.dialog), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
				gtk_signal_connect_full (create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.what), (gtk_object_get_type)))), ce_string ("key_press_event"), (find_key_press_event_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_cast (l_frdp), create {CE_ROUTINE}.make_shared (default_pointer), 0, 1).do_nothing
				gtk_table_attach (create {CE_CLASS_POINTER [SD_GTKTABLE]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_table), (gtk_table_get_type)))), l_frdp.item.what, (1).to_natural_32, (1_024).to_natural_32, (0).to_natural_32, (1).to_natural_32, (5).to_natural_32, {SC_GTKATTACHOPTIONS}.GTK_EXPAND, (2).to_natural_32, (2).to_natural_32)
				if a_do_replace.to_boolean then
					l_tmp := gtk_label_new ((convert_localized_message (l_conv_buffer, (gettext (ce_string ("Replace with:"))))))
					gtk_misc_set_alignment (create {CE_CLASS_POINTER [SD_GTKMISC]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_tmp), (gtk_misc_get_type)))), (0.0).truncated_to_real, (0.5).truncated_to_real)
					gtk_table_attach (create {CE_CLASS_POINTER [SD_GTKTABLE]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_table), (gtk_table_get_type)))), l_tmp, (0).to_natural_32, (1).to_natural_32, (1).to_natural_32, (2).to_natural_32, {SC_GTKATTACHOPTIONS}.GTK_FILL, {SC_GTKATTACHOPTIONS}.GTK_EXPAND, (2).to_natural_32, (2).to_natural_32)
					l_frdp.item.with := gtk_entry_new
					gtk_signal_connect_full (create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.with), (gtk_object_get_type)))), ce_string ("activate"), (find_replace_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer + 2), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
					gtk_signal_connect_full (create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.with), (gtk_object_get_type)))), ce_string ("key_press_event"), (find_key_press_event_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_cast (l_frdp), create {CE_ROUTINE}.make_shared (default_pointer), 0, 1).do_nothing
					gtk_table_attach (create {CE_CLASS_POINTER [SD_GTKTABLE]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_table), (gtk_table_get_type)))), l_frdp.item.with, (1).to_natural_32, (1_024).to_natural_32, (1).to_natural_32, (2).to_natural_32, (5).to_natural_32, {SC_GTKATTACHOPTIONS}.GTK_EXPAND, (2).to_natural_32, (2).to_natural_32)
					gtk_signal_connect_full (create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.what), (gtk_object_get_type)))), ce_string ("activate"), (entry_activate_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_cast (l_frdp.item.with), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
				else
					gtk_signal_connect_full (create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.what), (gtk_object_get_type)))), ce_string ("activate"), (find_replace_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer + 1), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
				end
				l_frdp.item.wword := gtk_check_button_new_with_label ((convert_localized_message (l_conv_buffer, (gettext (ce_string ("Match whole word only"))))))
				gtk_toggle_button_set_active (create {CE_CLASS_POINTER [SD_GTKTOGGLEBUTTON]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.wword), (gtk_toggle_button_get_type)))), l_wword.item)
				if a_do_replace.to_boolean then
					gtk_table_attach (create {CE_CLASS_POINTER [SD_GTKTABLE]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_table), (gtk_table_get_type)))), l_frdp.item.wword, (0).to_natural_32, (1_023).to_natural_32, (2).to_natural_32, (3).to_natural_32, {SC_GTKATTACHOPTIONS}.GTK_FILL, {SC_GTKATTACHOPTIONS}.GTK_EXPAND, (2).to_natural_32, (2).to_natural_32)
				else
					gtk_table_attach (create {CE_CLASS_POINTER [SD_GTKTABLE]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_table), (gtk_table_get_type)))), l_frdp.item.wword, (0).to_natural_32, (1_023).to_natural_32, (1).to_natural_32, (2).to_natural_32, {SC_GTKATTACHOPTIONS}.GTK_FILL, {SC_GTKATTACHOPTIONS}.GTK_EXPAND, (2).to_natural_32, (2).to_natural_32)
				end
				l_frdp.item.mcase := gtk_check_button_new_with_label ((convert_localized_message (l_conv_buffer, (gettext (ce_string ("Match case"))))))
				gtk_toggle_button_set_active (create {CE_CLASS_POINTER [SD_GTKTOGGLEBUTTON]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.mcase), (gtk_toggle_button_get_type)))), l_mcase.item)
				if a_do_replace.to_boolean then
					gtk_table_attach (create {CE_CLASS_POINTER [SD_GTKTABLE]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_table), (gtk_table_get_type)))), l_frdp.item.mcase, (0).to_natural_32, (1_023).to_natural_32, (3).to_natural_32, (4).to_natural_32, {SC_GTKATTACHOPTIONS}.GTK_FILL, {SC_GTKATTACHOPTIONS}.GTK_EXPAND, (2).to_natural_32, (2).to_natural_32)
				else
					gtk_table_attach (create {CE_CLASS_POINTER [SD_GTKTABLE]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_table), (gtk_table_get_type)))), l_frdp.item.mcase, (0).to_natural_32, (1_023).to_natural_32, (2).to_natural_32, (3).to_natural_32, {SC_GTKATTACHOPTIONS}.GTK_FILL, {SC_GTKATTACHOPTIONS}.GTK_EXPAND, (2).to_natural_32, (2).to_natural_32)
				end
				l_tmp := gtk_frame_new ((convert_localized_message (l_conv_buffer, (gettext (ce_string ("Direction"))))))
				if a_do_replace.to_boolean then
					gtk_table_attach (create {CE_CLASS_POINTER [SD_GTKTABLE]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_table), (gtk_table_get_type)))), l_tmp, (1_023).to_natural_32, (1_024).to_natural_32, (2).to_natural_32, (4).to_natural_32, {SC_GTKATTACHOPTIONS}.GTK_FILL, {SC_GTKATTACHOPTIONS}.GTK_FILL, (2).to_natural_32, (2).to_natural_32)
				else
					gtk_table_attach (create {CE_CLASS_POINTER [SD_GTKTABLE]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_table), (gtk_table_get_type)))), l_tmp, (1_023).to_natural_32, (1_024).to_natural_32, (1).to_natural_32, (3).to_natural_32, {SC_GTKATTACHOPTIONS}.GTK_FILL, {SC_GTKATTACHOPTIONS}.GTK_FILL, (2).to_natural_32, (2).to_natural_32)
				end
				l_vbox := gtk_vbox_new (0, 0)
				gtk_container_set_border_width (create {CE_CLASS_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_vbox), (gtk_container_get_type)))), (0).to_natural_32)
				gtk_container_add (create {CE_CLASS_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_tmp), (gtk_container_get_type)))), l_vbox)
				l_frdp.item.up := gtk_radio_button_new_with_label (create {CE_CLASS_POINTER [SD_GSLIST]}.make_shared (default_pointer), (convert_localized_message (l_conv_buffer, (gettext (ce_string ("Up"))))))
				gtk_box_pack_start (create {CE_CLASS_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_vbox), (gtk_box_get_type)))), l_frdp.item.up, 1, 1, (0).to_natural_32)
				l_tmp___96 := convert_localized_message (l_conv_buffer, (gettext (ce_string ("Down"))))
				l_frdp.item.down := gtk_radio_button_new_with_label ((gtk_radio_button_get_group (create {CE_CLASS_POINTER [SD_GTKRADIOBUTTON]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.up), (gtk_radio_button_get_type)))))), l_tmp___96)
				gtk_toggle_button_set_active (create {CE_CLASS_POINTER [SD_GTKTOGGLEBUTTON]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.down), (gtk_toggle_button_get_type)))), 1)
				gtk_container_set_border_width (create {CE_CLASS_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_vbox), (gtk_container_get_type)))), (2).to_natural_32)
				gtk_box_pack_start (create {CE_CLASS_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_vbox), (gtk_box_get_type)))), l_frdp.item.down, 1, 1, (0).to_natural_32)
				l_actionarea := gtk_vbutton_box_new
				gtk_container_set_border_width (create {CE_CLASS_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_actionarea), (gtk_container_get_type)))), (2).to_natural_32)
				gtk_box_pack_end (create {CE_CLASS_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_hbox), (gtk_box_get_type)))), l_actionarea, 0, 0, (0).to_natural_32)
				l_frdp.item.find := create_image_button (ce_string ("gtk-find"), (gettext (ce_string ("Find Next"))))
				gtk_widget_set_sensitive (l_frdp.item.find, l_sensitive)
				if a_do_replace.to_boolean then
					l_tmp___111 := create {CE_VOID_POINTER}.make_shared (default_pointer + 2)
				else
					l_tmp___111 := create {CE_VOID_POINTER}.make_shared (default_pointer + 1)
				end
				gtk_signal_connect_full (create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.find), (gtk_object_get_type)))), ce_string ("clicked"), (find_replace_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), l_tmp___111, create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___115 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.find), (gtk_object_get_type));
					(create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___115)).item.flags := ((create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___115)).item.flags).bit_or (({NATURAL_32} 8_192))
					l_break := True
				end
				l_break := False
				gtk_box_pack_start (create {CE_CLASS_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_actionarea), (gtk_box_get_type)))), l_frdp.item.find, 0, 0, (0).to_natural_32)
				gtk_widget_grab_default (l_frdp.item.find)
				if a_do_replace.to_boolean then
					l_frdp.item.replace := create_image_button (ce_string ("gtk-convert"), (gettext (ce_string ("Replace"))))
					gtk_widget_set_sensitive (l_frdp.item.replace, l_sensitive)
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp___120 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.replace), (gtk_object_get_type));
						(create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___120)).item.flags := ((create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___120)).item.flags).bit_or (({NATURAL_32} 8_192))
						l_break := True
					end
					l_break := False
					gtk_box_pack_start (create {CE_CLASS_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_actionarea), (gtk_box_get_type)))), l_frdp.item.replace, 0, 0, (0).to_natural_32)
					gtk_signal_connect_full (create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.replace), (gtk_object_get_type)))), ce_string ("clicked"), (find_replace_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer + 3), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
					l_frdp.item.all2 := create_image_button (ce_string ("gtk-convert"), (gettext (ce_string ("Replace All"))))
					gtk_widget_set_sensitive (l_frdp.item.all2, l_sensitive)
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp___127 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.all2), (gtk_object_get_type));
						(create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___127)).item.flags := ((create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___127)).item.flags).bit_or (({NATURAL_32} 8_192))
						l_break := True
					end
					l_break := False
					gtk_box_pack_start (create {CE_CLASS_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_actionarea), (gtk_box_get_type)))), l_frdp.item.all2, 0, 0, (0).to_natural_32)
					gtk_signal_connect_full (create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.all2), (gtk_object_get_type)))), ce_string ("clicked"), (find_replace_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer + 4), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
				end
				l_tmp := gtk_button_new_from_stock (ce_string ("gtk-close"))
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___133 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_tmp), (gtk_object_get_type));
					(create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___133)).item.flags := ((create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___133)).item.flags).bit_or (({NATURAL_32} 8_192))
					l_break := True
				end
				l_break := False
				gtk_box_pack_end (create {CE_CLASS_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_actionarea), (gtk_box_get_type)))), l_tmp, 0, 0, (0).to_natural_32)
				l_tmp___137 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.dialog), (gtk_object_get_type))
				gtk_signal_connect_full (create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_tmp), (gtk_object_get_type)))), ce_string ("clicked"), (gtk_widget_hide_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_cast (l_tmp___137), create {CE_ROUTINE}.make_shared (default_pointer), 1, 0).do_nothing
				l_tmp___141 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.dialog), (gtk_object_get_type))
				gtk_signal_connect_full (create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.dialog), (gtk_object_get_type)))), ce_string ("delete_event"), (gtk_widget_hide_on_delete_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_cast (l_tmp___141), create {CE_ROUTINE}.make_shared (default_pointer), 1, 0).do_nothing
				l_tmp := gtk_vseparator_new
				gtk_box_pack_end (create {CE_CLASS_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_hbox), (gtk_box_get_type)))), l_tmp, 0, 0, (10).to_natural_32)
				gtk_widget_hide ((create {CE_CLASS_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.dialog), (gtk_dialog_get_type))))).item.action_area)
				gtk_widget_show_all (l_hbox)
				gtk_widget_show (l_frdp.item.dialog);
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_entry_text));
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_conv_buffer.item))
			end
		end

	gui_mch_find_dialog (a_eap: CE_POINTER [PD_EXARG])
		do
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				find_replace_dialog_create (a_eap.item.arg, 0)
			end
		end

	gui_mch_replace_dialog (a_eap: CE_POINTER [PD_EXARG])
		do
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				find_replace_dialog_create (a_eap.item.arg, 1)
			end
		end

	find_replace_cb (a_widget: CE_POINTER [SD_GTKWIDGET]; a_data: CE_POINTER [ANY])
		local
			l_flags___0: INTEGER_32
			l_find_text: CE_POINTER [NATURAL_8]
			l_repl_text: CE_POINTER [NATURAL_8]
			l_direction_down: INTEGER_32
			l_sfr: CE_POINTER [PD_SHAREDFINDREPLACE]
			l_rc: INTEGER_32
		do
			l_flags___0 := ((a_data.c_pointer.to_integer_32).to_integer_32).to_integer_32
			if l_flags___0 = 1 then
				l_repl_text := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				l_sfr := find_widgets.item
			else
				l_repl_text := create {CE_NATURAL_8_POINTER}.make_cast ((gtk_entry_get_text (create {CE_CLASS_POINTER [SD_GTKENTRY]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (repl_widgets.item.item.with), (gtk_entry_get_type)))))))
				l_sfr := repl_widgets.item
			end
			l_find_text := create {CE_NATURAL_8_POINTER}.make_cast ((gtk_entry_get_text (create {CE_CLASS_POINTER [SD_GTKENTRY]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_sfr.item.what), (gtk_entry_get_type)))))))
			l_direction_down := ((create {CE_CLASS_POINTER [SD_GTKTOGGLEBUTTON]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_sfr.item.down), (gtk_toggle_button_get_type))))).item.active).to_integer_32
			if ((create {CE_CLASS_POINTER [SD_GTKTOGGLEBUTTON]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_sfr.item.wword), (gtk_toggle_button_get_type))))).item.active).to_boolean then
				l_flags___0 := (l_flags___0).bit_or ((8))
			end
			if ((create {CE_CLASS_POINTER [SD_GTKTOGGLEBUTTON]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_sfr.item.mcase), (gtk_toggle_button_get_type))))).item.active).to_boolean then
				l_flags___0 := (l_flags___0).bit_or ((16))
			end
			if (create {P_GLOBALS_STATIC}).input_conv.item.item.vc_type = 0 then
				l_repl_text := l_repl_text
			elseif l_repl_text.is_void then
				l_repl_text := l_repl_text
			else
				l_repl_text := ((create {P_MBYTE_STATIC}).string_convert ((create {P_GLOBALS_STATIC}).input_conv.item, l_repl_text, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)))
			end
			if (create {P_GLOBALS_STATIC}).input_conv.item.item.vc_type = 0 then
				l_find_text := l_find_text
			elseif l_find_text.is_void then
				l_find_text := l_find_text
			else
				l_find_text := ((create {P_MBYTE_STATIC}).string_convert ((create {P_GLOBALS_STATIC}).input_conv.item, l_find_text, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)))
			end
			l_rc := (create {P_GUI_STATIC}).gui_do_findrepl (l_flags___0, l_find_text, l_repl_text, l_direction_down)
			if (create {P_GLOBALS_STATIC}).input_conv.item.item.vc_type = 0 then
				l_repl_text := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			else
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_repl_text))
				l_repl_text := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			end
			if (create {P_GLOBALS_STATIC}).input_conv.item.item.vc_type = 0 then
				l_find_text := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			else
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_find_text))
				l_find_text := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			end
		end

	entry_activate_cb (a_widget: CE_POINTER [SD_GTKWIDGET]; a_data: CE_POINTER [ANY])
		do
			gtk_widget_grab_focus (create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_data), (gtk_widget_get_type)))))
		end

	entry_changed_cb (a_entry, a_dialog: CE_POINTER [SD_GTKWIDGET])
		local
			l_entry_text: CE_POINTER [INTEGER_8]
			l_nonempty: INTEGER_32
			l_return: BOOLEAN
		do
			l_entry_text := gtk_entry_get_text (create {CE_CLASS_POINTER [SD_GTKENTRY]}.make_cast ((g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_entry), (gtk_entry_get_type)))))
			if l_entry_text.is_void then
				l_return := True
			end
			if not l_return then
				l_nonempty := ((l_entry_text[0]).to_integer_32 /= 0).to_integer
				if a_dialog.is_equal (find_widgets.item.item.dialog) then
					gtk_widget_set_sensitive (find_widgets.item.item.find, l_nonempty)
				end
				if a_dialog.is_equal (repl_widgets.item.item.dialog) then
					gtk_widget_set_sensitive (repl_widgets.item.item.find, l_nonempty)
					gtk_widget_set_sensitive (repl_widgets.item.item.replace, l_nonempty)
					gtk_widget_set_sensitive (repl_widgets.item.item.all2, l_nonempty)
				end
			end
		end

	ex_helpfind (a_eap: CE_POINTER [PD_EXARG])
		do
			(create {P_EX_DOCMD_STATIC}).do_cmdline_cmd (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("emenu ToolBar.FindHelp"))).do_nothing
		end

feature {ANY} -- routine addresses

	toolbar_button_focus_in_event_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent toolbar_button_focus_in_event)
		end

	menu_item_activate_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent menu_item_activate)
		end

	adjustment_value_changed_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent adjustment_value_changed)
		end

	dialog_key_press_event_cb_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent dialog_key_press_event_cb)
		end

	popup_menu_position_func_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent popup_menu_position_func)
		end

	find_key_press_event_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent find_key_press_event)
		end

	gui_mch_find_dialog_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent gui_mch_find_dialog)
		end

	gui_mch_replace_dialog_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent gui_mch_replace_dialog)
		end

	find_replace_cb_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent find_replace_cb)
		end

	entry_activate_cb_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent entry_activate_cb)
		end

	entry_changed_cb_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent entry_changed_cb)
		end

	ex_helpfind_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_helpfind)
		end

end
