class
	P_MARK_STATIC

inherit
	CE_UTILITIES
	S_CTYPE_STATIC
	S_LIBINTL_STATIC
	S_STDIO_STATIC
	S_STRING_STATIC

feature {ANY} -- public attributes

	namedfm: CE_STATIC [CE_ARRAY [PD_XFILEMARK]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_XFILEMARK]}.make (<<36>>)
		end

	pos_copy: CE_STATIC [CE_ARRAY [PD_POS_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_POS_T]}.make (<<1>>)
		end

feature {ANY} -- public routines

	setmark (a_c: INTEGER_32): INTEGER_32
		do
			Result := (setmark_pos (a_c, create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum))
		end

	setmark_pos (a_c: INTEGER_32; a_pos___3: CE_POINTER [PD_POS_T]; a_fnum___0: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_c < 0 then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if a_c /= 39 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if a_c /= 96 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if a_pos___3.is_equal (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))) then
							setpcmark;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_prev_pcmark := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_pcmark).twin
						else
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_pcmark := (a_pos___3.item).twin
						end
						Result := 1
						l_return := True
				when 6 then -- if done | if done
					if not l_return and then (a_c = 34) then
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_last_cursor := (a_pos___3.item).twin
						Result := 1
						l_return := True
					end
					if not l_return and then (a_c = 91) then
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start := (a_pos___3.item).twin
						Result := 1
						l_return := True
					end
					if not l_return and then (a_c = 93) then
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end := (a_pos___3.item).twin
						Result := 1
						l_return := True
					end
					if not l_return and then (a_c > 122) then
						Result := 0
						l_return := True
					end
					if not l_return then
						if ((((ctype_b_loc).item[a_c]).to_integer_32).bit_and (512)).to_boolean then
							l_i___0 := a_c - 97;
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_namedm[l_i___0] := (a_pos___3.item).twin
							Result := 1
							l_return := True
						end
					end
					if not l_return then
						if ((((ctype_b_loc).item[a_c]).to_integer_32).bit_and (256)).to_boolean then
							l_i___0 := a_c - 65
							namedfm.item[l_i___0].fmark.mark := (a_pos___3.item).twin
							namedfm.item[l_i___0].fmark.fnum := a_fnum___0;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (namedfm.item[l_i___0].fname))
							namedfm.item[l_i___0].fname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							Result := 1
							l_return := True
						end
					end
					if not l_return then
						Result := 0
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	setpcmark
		local
			l_i___0: INTEGER_32
			l_fm: CE_POINTER [PD_XFILEMARK]
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).global_busy.item).to_boolean then
				l_return := True
			elseif ((create {P_GLOBALS_STATIC}).listcmd_busy.item).to_boolean then
				l_return := True
			elseif ((create {P_GLOBALS_STATIC}).cmdmod.item.item.keepjumps).to_boolean then
				l_return := True
			end
			if not l_return then
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_prev_pcmark := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_pcmark).twin;
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_pcmark := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin;
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistlen := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistlen) + 1
				if (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistlen > 100 then
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistlen := 100;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplist[0].fname))
					l_i___0 := 1
					from
					until
						not (l_i___0 < 100)
					loop
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplist[l_i___0 - 1] := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplist[l_i___0]).twin
						l_i___0 := l_i___0 + 1
					end
				end
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistidx := (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistlen
				l_fm := create {CE_CLASS_POINTER [PD_XFILEMARK]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_jumplist") + (create {PD_XFILEMARK}.make).structure_size * ((create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistlen - 1))
				l_fm.item.fmark.mark := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_pcmark).twin
				l_fm.item.fmark.fnum := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum
				l_fm.item.fname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			end
		end

	checkpcmark
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_prev_pcmark.lnum = 0 then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_pcmark.lnum /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_pcmark.col = (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_pcmark.coladd = (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_pcmark := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_prev_pcmark).twin;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_prev_pcmark.lnum := (0).to_integer_32
							else
								l_pos := -1 + 4 -- goto _L___0
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L___0:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_pcmark.lnum = 0 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_pcmark := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_prev_pcmark).twin;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_prev_pcmark.lnum := (0).to_integer_32
						end
				when 5 then -- if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	getmark (a_c, a_changefile: INTEGER_32): CE_POINTER [PD_POS_T]
		do
			Result := (getmark_fnum (a_c, a_changefile, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)))
		end

	getmark_fnum (a_c, a_changefile: INTEGER_32; a_fnum___0: CE_POINTER [INTEGER_32]): CE_POINTER [PD_POS_T]
		local
			l_c: INTEGER_32
			l_posp: CE_POINTER [PD_POS_T]
			l_startp: CE_POINTER [PD_POS_T]
			l_endp: CE_POINTER [PD_POS_T]
			l_pos___3: PD_POS_T
			l_oa: CE_ARRAY [PD_OPARG_S]
			l_slcb: INTEGER_32
			l_tmp: INTEGER_32
			l_pos___4: PD_POS_T
			l_slcb___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_OPARG_S]} l_oa.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := a_c
					l_posp := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer)
					if l_c < 0 then
						Result := l_posp
						l_return := True
					end
					if not (not l_return and then (not (l_c > 126))) then
						l_pos := -1 + 49 -- skip if block
					end
				when 1 then -- if:
						if l_c /= 39 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						pos_copy.item.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_pcmark).twin
						l_posp := pos_copy.item
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 4 then -- else:
						if l_c /= 96 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						pos_copy.item.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_pcmark).twin
						l_posp := pos_copy.item
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 7 then -- else:
						if l_c /= 34 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_posp := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_last_cursor"))
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 10 then -- else:
						if l_c /= 94 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_posp := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_last_insert"))
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 13 then -- else:
						if l_c /= 46 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_posp := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_last_change"))
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 16 then -- else:
						if l_c /= 91 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_posp := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_op_start"))
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 19 then -- else:
						if l_c /= 93 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_posp := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_op_end"))
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 22 then -- else:
						if l_c /= 123 then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 26 -- goto _L___4
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 25 then -- else:
						if l_c /= 125 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if: | _L___4:
						l_slcb := (create {P_GLOBALS_STATIC}).listcmd_busy.item
						l_pos___3 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin;
						(create {P_GLOBALS_STATIC}).listcmd_busy.item := 1
						if l_c = 125 then
							l_tmp := 1
						else
							l_tmp := -1
						end
						if ((create {P_SEARCH_STATIC}).findpar (create {CE_INTEGER_32_POINTER}.make_shared (l_oa.item.c_pointer + (create {PD_OPARG_S}.make).offset_of ("inclusive")), l_tmp, 1, ('%/0/').code, 0)).to_boolean then
							pos_copy.item.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
							l_posp := pos_copy.item
						end
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_pos___3.twin;
						(create {P_GLOBALS_STATIC}).listcmd_busy.item := l_slcb
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 28 then -- else:
						if l_c /= 40 then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						l_pos := -1 + 32 -- goto _L___3
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 31 then -- else:
						if l_c /= 41 then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if: | _L___3:
						l_slcb___0 := (create {P_GLOBALS_STATIC}).listcmd_busy.item
						l_pos___4 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin;
						(create {P_GLOBALS_STATIC}).listcmd_busy.item := 1
						if l_c = 41 then
							l_tmp___1 := 1
						else
							l_tmp___1 := -1
						end
						if ((create {P_SEARCH_STATIC}).findsent (l_tmp___1, 1)).to_boolean then
							pos_copy.item.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
							l_posp := pos_copy.item
						end
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_pos___4.twin;
						(create {P_GLOBALS_STATIC}).listcmd_busy.item := l_slcb___0
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 34 then -- else:
						if l_c /= 60 then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						l_pos := -1 + 38 -- goto _L___2
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 37 then -- else:
						if l_c /= 62 then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if: | _L___2:
						l_startp := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_visual") + (create {PD_VISUALINFO_T}.make).offset_of ("vi_start"))
						l_endp := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_visual") + (create {PD_VISUALINFO_T}.make).offset_of ("vi_end"))
						if l_startp.item.lnum /= l_endp.item.lnum then
							l_tmp___4 := (l_startp.item.lnum < l_endp.item.lnum).to_integer
						else
							if l_startp.item.col /= l_endp.item.col then
								l_tmp___3 := (l_startp.item.col < l_endp.item.col).to_integer
							else
								l_tmp___3 := (l_startp.item.coladd < l_endp.item.coladd).to_integer
							end
							l_tmp___4 := l_tmp___3
						end
						if (l_c = 60) = l_tmp___4.to_boolean then
							l_posp := l_startp
						else
							l_posp := l_endp
						end
						if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual.vi_mode = 86 then
							pos_copy.item.item := (l_posp.item).twin
							l_posp := pos_copy.item
							if l_c = 60 then
								pos_copy.item.item.col := 0
							else
								pos_copy.item.item.col := (2_147_483_647).to_integer_32
							end
							pos_copy.item.item.coladd := 0
						end
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 40 then -- else:
						if not (l_c < 127) then
							l_pos := -1 + 43 -- skip if block
						end
				when 41 then -- if:
						if ((((ctype_b_loc).item[l_c]).to_integer_32).bit_and (512)).to_boolean then
							l_posp := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_namedm") + (create {PD_POS_T}.make).structure_size * (l_c - 97))
						else
							l_pos := -1 + 43 -- goto _L___1
						end
				when 42 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 43 then -- else: | _L___1:
						if not (l_c < 127) then
							l_pos := -1 + 46 -- skip if block
						end
				when 44 then -- if:
						if ((((ctype_b_loc).item[l_c]).to_integer_32).bit_and (256)).to_boolean then
							l_pos := -1 + 48 -- goto _L
						else
							l_pos := -1 + 46 -- goto _L___0
						end
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 46 then -- else: | _L___0:
						if not (l_c >= 48) then
							l_pos := -1 + 49 -- skip if block
						end
				when 47 then -- if:
						if not (l_c <= 57) then
							l_pos := -1 + 49 -- skip if block
						end
				when 48 then -- if: | _L:
						if l_c >= 48 then
							if l_c <= 57 then
								l_c := (l_c - 48) + 26
							else
								l_c := l_c - (65)
							end
						else
							l_c := l_c - (65)
						end
						l_posp := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (namedfm.item.c_pointer + (create {PD_XFILEMARK}.make).structure_size * (l_c) + (create {PD_XFILEMARK}.make).offset_of ("fmark") + (create {PD_FILEMARK}.make).offset_of ("mark"))
						if namedfm.item[l_c].fmark.fnum = 0 then
							(namedfm.item + l_c).item.fname2fnum
						end
						if not a_fnum___0.is_void then
							a_fnum___0.item := namedfm.item[l_c].fmark.fnum
						elseif namedfm.item[l_c].fmark.fnum /= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum then
							l_posp := pos_copy.item
							if namedfm.item[l_c].fmark.mark.lnum /= 0 then
								if a_changefile.to_boolean then
									if (namedfm.item[l_c].fmark.fnum).to_boolean then
										if ((create {P_BUFFER_STATIC}).buflist_getfile (namedfm.item[l_c].fmark.fnum, (1).to_integer_32, 1, 0)) = 1 then
											(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := (namedfm.item[l_c].fmark.mark).twin
											Result := (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer + -1))
											l_return := True
										end
										if not l_return then
											pos_copy.item.item.lnum := (-1).to_integer_32
										end
									else
										pos_copy.item.item.lnum := (0).to_integer_32
									end
								else
									pos_copy.item.item.lnum := (0).to_integer_32
								end
							else
								pos_copy.item.item.lnum := (0).to_integer_32
							end
						end
				when 49 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
					if not l_return then
						Result := l_posp
					end
				when 50 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_mark (a_pos___3: CE_POINTER [PD_POS_T]): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if a_pos___3.is_void then
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_umark.item)))))).do_nothing
				Result := 0
				l_return := True
			end
			if not l_return and then (a_pos___3.item.lnum <= 0) then
				if a_pos___3.item.lnum = 0 then
					(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_marknotset.item)))))).do_nothing
				end
				Result := 0
				l_return := True
			end
			if not l_return and then (a_pos___3.item.lnum > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count) then
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_markinval.item)))))).do_nothing
				Result := 0
				l_return := True
			end
			if not l_return then
				Result := 1
			end
		end

	ex_jumps (a_eap: CE_POINTER [PD_EXARG])
		local
			l_i___0: INTEGER_32
			l_name___1: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_break, l_continue: BOOLEAN
		do
			cleanup_jumplist;
			(create {P_MESSAGE_STATIC}).msg_puts_title (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%N jump line  col file/text")))))
			l_i___0 := 0
			from
			until
				(l_break)
			loop
				l_break := False
				l_continue := False
				if l_i___0 < (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistlen then
					if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break or l_continue) and then ((create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplist[l_i___0].fmark.mark.lnum /= 0) then
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplist[l_i___0].fmark.fnum = 0 then
						(create {CE_CLASS_POINTER [PD_XFILEMARK]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_jumplist") + (create {PD_XFILEMARK}.make).structure_size * (l_i___0))).item.fname2fnum
					end
					l_name___1 := (create {CE_CLASS_POINTER [PD_FILEMARK]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_jumplist") + (create {PD_XFILEMARK}.make).structure_size * (l_i___0) + (create {PD_XFILEMARK}.make).offset_of ("fmark"))).item.fm_getname (16)
					if l_name___1.is_void then
						l_continue := True
					end
					if not (l_break or l_continue) then
						(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_name___1))
							l_break := True
						end
					end
					if not (l_break or l_continue) then
						if l_i___0 > (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistidx then
							l_tmp___0 := l_i___0 - (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistidx
						else
							l_tmp___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistidx - l_i___0
						end
						if l_i___0 = (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistidx then
							l_tmp___1 := ('>').code
						else
							l_tmp___1 := (' ').code
						end
						sprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), ce_string ("%%c %%2d %%5ld %%4d "), l_tmp___1, l_tmp___0, (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplist[l_i___0].fmark.mark.lnum, (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplist[l_i___0].fmark.mark.col]).do_nothing;
						(create {P_MESSAGE_STATIC}).msg_outtrans ((create {P_GLOBALS_STATIC}).IObuff.item).do_nothing
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplist[l_i___0].fmark.fnum = (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum then
							l_tmp___2 := (create {P_GLOBALS_STATIC}).highlight_attr.item[2]
						else
							l_tmp___2 := 0
						end
						(create {P_MESSAGE_STATIC}).msg_outtrans_attr (l_name___1, l_tmp___2).do_nothing;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_name___1));
						(create {P_UI_STATIC}).ui_breakcheck
					end
				end
				if not (l_break or l_continue) then
					(create {P_TERM_STATIC}).out_flush
				end
				if (not l_break) then
					l_i___0 := l_i___0 + 1
				end
			end
			l_break := False
			l_continue := False
			if (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistidx = (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistlen then
				(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N>")))
			end
		end

	ex_changes (a_eap: CE_POINTER [PD_EXARG])
		local
			l_i___0: INTEGER_32
			l_name___1: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_break: BOOLEAN
		do
			create {CE_NATURAL_8_POINTER} l_name___1.make;

			(create {P_MESSAGE_STATIC}).msg_puts_title (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%Nchange line  col text")))))
			l_i___0 := 0
			from
			until
				(l_break)
			loop
				l_break := False
				if l_i___0 < (create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelistlen then
					if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) and then ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelist[l_i___0].lnum /= 0) then
					(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
					if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
						l_break := True
					end
					if not (l_break) then
						if l_i___0 > (create {P_GLOBALS_STATIC}).curwin.item.item.w_changelistidx then
							l_tmp___0 := l_i___0 - (create {P_GLOBALS_STATIC}).curwin.item.item.w_changelistidx
						else
							l_tmp___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_changelistidx - l_i___0
						end
						if l_i___0 = (create {P_GLOBALS_STATIC}).curwin.item.item.w_changelistidx then
							l_tmp___1 := ('>').code
						else
							l_tmp___1 := (' ').code
						end
						sprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), ce_string ("%%c %%3d %%5ld %%4d "), l_tmp___1, l_tmp___0, (create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelist[l_i___0].lnum, (create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelist[l_i___0].col]).do_nothing;
						(create {P_MESSAGE_STATIC}).msg_outtrans ((create {P_GLOBALS_STATIC}).IObuff.item).do_nothing
						l_name___1 := (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_changelist") + (create {PD_POS_T}.make).structure_size * (l_i___0))).item.mark_line (17)
						if l_name___1.is_void then
							l_break := True
						end
					end
					if not (l_break) then
						(create {P_MESSAGE_STATIC}).msg_outtrans_attr (l_name___1, (create {P_GLOBALS_STATIC}).highlight_attr.item[2]).do_nothing;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_name___1));
						(create {P_UI_STATIC}).ui_breakcheck
					end
				end
				if not (l_break) then
					(create {P_TERM_STATIC}).out_flush
					l_i___0 := l_i___0 + 1
				end
			end
			l_break := False
			if (create {P_GLOBALS_STATIC}).curwin.item.item.w_changelistidx = (create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelistlen then
				(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N>")))
			end
		end

	mark_adjust (a_line1, a_line2, a_amount, a_amount_after: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_fnum___0: INTEGER_32
			l_lp: CE_POINTER [INTEGER_32]
			l_win: CE_POINTER [PD_WINDOW_S]
			l_tab___0: CE_POINTER [PD_TABPAGE_S]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fnum___0 := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum
					if a_line2 < a_line1 then
						if a_amount_after = 0 then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 104 -- skip if block
					end
				when 1 then -- if:
						if ((create {P_GLOBALS_STATIC}).cmdmod.item.item.lockmarks).to_boolean then
							l_pos := -1 + 46 -- skip if block
						end
				when 2 then -- if:
						l_i___0 := 0
				when 3 then -- loop condition:
						if not (l_i___0 < 26) then
							l_pos := -1 + 14 -- skip loop
						end
				when 4 then -- loop body:
						l_lp := create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_namedm") + (create {PD_POS_T}.make).structure_size * (l_i___0) + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := (0).to_integer_32
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 8 then
						if namedfm.item[l_i___0].fmark.fnum /= l_fnum___0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 9 then -- if:
						l_lp := create {CE_INTEGER_32_POINTER}.make_shared (namedfm.item.c_pointer + (create {PD_XFILEMARK}.make).structure_size * (l_i___0) + (create {PD_XFILEMARK}.make).offset_of ("fmark") + (create {PD_FILEMARK}.make).offset_of ("mark") + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := a_line1
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 12 -- goto _L___0
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___0:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 13 then -- if done
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 3 -- back to loop condition
				when 14 then -- loop done
						l_i___0 := 26
				when 15 then -- loop condition:
						if not (l_i___0 < 36) then
							l_pos := -1 + 22 -- skip loop
						end
				when 16 then -- loop body:
						if namedfm.item[l_i___0].fmark.fnum /= l_fnum___0 then
							l_pos := -1 + 21 -- skip if block
						end
				when 17 then -- if:
						l_lp := create {CE_INTEGER_32_POINTER}.make_shared (namedfm.item.c_pointer + (create {PD_XFILEMARK}.make).structure_size * (l_i___0) + (create {PD_XFILEMARK}.make).offset_of ("fmark") + (create {PD_FILEMARK}.make).offset_of ("mark") + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := a_line1
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 20 -- goto _L___1
						end
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else: | _L___1:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 21 then -- if done
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 15 -- back to loop condition
				when 22 then -- loop done
						l_lp := create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_last_insert") + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := (0).to_integer_32
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 25 -- goto _L___2
						end
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else: | _L___2:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 26 then
						l_lp := create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_last_change") + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := (0).to_integer_32
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 29 -- goto _L___3
						end
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else: | _L___3:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 30 then
						l_i___0 := 0
				when 31 then -- loop condition:
						if not (l_i___0 < (create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelistlen) then
							l_pos := -1 + 37 -- skip loop
						end
				when 32 then -- loop body:
						l_lp := create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_changelist") + (create {PD_POS_T}.make).structure_size * (l_i___0) + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := a_line1
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 35 -- goto _L___4
						end
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 35 then -- else: | _L___4:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 36 then
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 31 -- back to loop condition
				when 37 then -- loop done
						l_lp := create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_visual") + (create {PD_VISUALINFO_T}.make).offset_of ("vi_start") + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := a_line1
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 40 -- goto _L___5
						end
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 40 then -- else: | _L___5:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 41 then
						l_lp := create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_visual") + (create {PD_VISUALINFO_T}.make).offset_of ("vi_end") + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 44 -- skip if block
						end
				when 42 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := a_line1
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 44 -- goto _L___6
						end
				when 43 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 44 then -- else: | _L___6:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 45 then;
						(create {P_QUICKFIX_STATIC}).qf_mark_adjust (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer), a_line1, a_line2, a_amount, a_amount_after)
						l_tab___0 := (create {P_GLOBALS_STATIC}).first_tabpage.item
						from
						until
							not (not (l_return) and then (not l_tab___0.is_void))
						loop
							if l_tab___0.is_equal ((create {P_GLOBALS_STATIC}).curtab.item) then
								l_win := (create {P_GLOBALS_STATIC}).firstwin.item
							else
								l_win := l_tab___0.item.tp_firstwin
							end
							from
							until
								l_win.is_void
							loop
								(create {P_QUICKFIX_STATIC}).qf_mark_adjust (l_win, a_line1, a_line2, a_amount, a_amount_after)
								l_win := l_win.item.w_next
							end
							l_tab___0 := l_tab___0.item.tp_next
						end
						(create {P_BUFFER_STATIC}).sign_mark_adjust (a_line1, a_line2, a_amount, a_amount_after)
				when 46 then -- if done
						l_lp := create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_pcmark") + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 49 -- skip if block
						end
				when 47 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := (0).to_integer_32
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 49 -- goto _L___7
						end
				when 48 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 49 then -- else: | _L___7:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 50 then
						l_lp := create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_prev_pcmark") + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 53 -- skip if block
						end
				when 51 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := (0).to_integer_32
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 53 -- goto _L___8
						end
				when 52 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 53 then -- else: | _L___8:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 54 then
						if (create {P_GLOBALS_STATIC}).saved_cursor.item.item.lnum = 0 then
							l_pos := -1 + 59 -- skip if block
						end
				when 55 then -- if:
						l_lp := create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).saved_cursor.item.item.c_pointer + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 58 -- skip if block
						end
				when 56 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := a_line1
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 58 -- goto _L___9
						end
				when 57 then -- if block done, skip else block:
						l_pos := -1 + 59
				when 58 then -- else: | _L___9:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 59 then -- if done
						l_tab___0 := (create {P_GLOBALS_STATIC}).first_tabpage.item
				when 60 then -- loop condition:
						if not (not (l_return) and then (not l_tab___0.is_void)) then
							l_pos := -1 + 103 -- skip loop
						end
				when 61 then -- loop body:
						if l_tab___0.is_equal ((create {P_GLOBALS_STATIC}).curtab.item) then
							l_win := (create {P_GLOBALS_STATIC}).firstwin.item
						else
							l_win := l_tab___0.item.tp_firstwin
						end
				when 62 then -- loop condition:
						if not (not (l_return) and then (not l_win.is_void)) then
							l_pos := -1 + 102 -- skip loop
						end
				when 63 then -- loop body:
						if ((create {P_GLOBALS_STATIC}).cmdmod.item.item.lockmarks).to_boolean then
							l_pos := -1 + 72 -- skip if block
						end
				when 64 then -- if:
						l_i___0 := 0
				when 65 then -- loop condition:
						if not (l_i___0 < l_win.item.w_jumplistlen) then
							l_pos := -1 + 72 -- skip loop
						end
				when 66 then -- loop body:
						if l_win.item.w_jumplist[l_i___0].fmark.fnum /= l_fnum___0 then
							l_pos := -1 + 71 -- skip if block
						end
				when 67 then -- if:
						l_lp := create {CE_INTEGER_32_POINTER}.make_shared (l_win.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_jumplist") + (create {PD_XFILEMARK}.make).structure_size * (l_i___0) + (create {PD_XFILEMARK}.make).offset_of ("fmark") + (create {PD_FILEMARK}.make).offset_of ("mark") + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 70 -- skip if block
						end
				when 68 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := a_line1
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 70 -- goto _L___10
						end
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 71
				when 70 then -- else: | _L___10:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 71 then -- if done
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 65 -- back to loop condition
				when 72 then -- loop done | if done
						if not ((l_win.item.w_buffer).is_equal ((create {P_GLOBALS_STATIC}).curbuf.item)) then
							l_pos := -1 + 101 -- skip if block
						end
				when 73 then -- if:
						if ((create {P_GLOBALS_STATIC}).cmdmod.item.item.lockmarks).to_boolean then
							l_pos := -1 + 82 -- skip if block
						end
				when 74 then -- if:
						l_i___0 := 0
				when 75 then -- loop condition:
						if not (l_i___0 < l_win.item.w_tagstacklen) then
							l_pos := -1 + 82 -- skip loop
						end
				when 76 then -- loop body:
						if l_win.item.w_tagstack[l_i___0].fmark.fnum /= l_fnum___0 then
							l_pos := -1 + 81 -- skip if block
						end
				when 77 then -- if:
						l_lp := create {CE_INTEGER_32_POINTER}.make_shared (l_win.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_tagstack") + (create {PD_TAGGY}.make).structure_size * (l_i___0) + (create {PD_TAGGY}.make).offset_of ("fmark") + (create {PD_FILEMARK}.make).offset_of ("mark") + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 80 -- skip if block
						end
				when 78 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := a_line1
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 80 -- goto _L___11
						end
				when 79 then -- if block done, skip else block:
						l_pos := -1 + 81
				when 80 then -- else: | _L___11:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 81 then -- if done
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 75 -- back to loop condition
				when 82 then -- loop done | if done
						if l_win.item.w_old_cursor_lnum = 0 then
							l_pos := -1 + 91 -- skip if block
						end
				when 83 then -- if:
						l_lp := create {CE_INTEGER_32_POINTER}.make_shared (l_win.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_old_cursor_lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 86 -- skip if block
						end
				when 84 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := a_line1
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 86 -- goto _L___12
						end
				when 85 then -- if block done, skip else block:
						l_pos := -1 + 87
				when 86 then -- else: | _L___12:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 87 then
						l_lp := create {CE_INTEGER_32_POINTER}.make_shared (l_win.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_old_visual_lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 90 -- skip if block
						end
				when 88 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := a_line1
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 90 -- goto _L___13
						end
				when 89 then -- if block done, skip else block:
						l_pos := -1 + 91
				when 90 then -- else: | _L___13:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 91 then -- if done
						if l_win.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
							l_pos := -1 + 100 -- skip if block
						end
				when 92 then -- if:
						if not (l_win.item.w_topline >= a_line1) then
							l_pos := -1 + 95 -- skip if block
						end
				when 93 then -- if:
						if l_win.item.w_topline <= a_line2 then
							if a_amount = 2_147_483_647 then
								if a_line1 <= 1 then
									l_win.item.w_topline := (1).to_integer_32
								else
									l_win.item.w_topline := a_line1 - 1
								end
							else
								l_win.item.w_topline := l_win.item.w_topline + a_amount
							end
							l_win.item.w_topfill := 0
						else
							l_pos := -1 + 95 -- goto _L___14
						end
				when 94 then -- if block done, skip else block:
						l_pos := -1 + 96
				when 95 then -- else: | _L___14:
						if a_amount_after.to_boolean then
							if l_win.item.w_topline > a_line2 then
								l_win.item.w_topline := l_win.item.w_topline + a_amount_after
								l_win.item.w_topfill := 0
							end
						end
				when 96 then
						if not (l_win.item.w_cursor.lnum >= a_line1) then
							l_pos := -1 + 99 -- skip if block
						end
				when 97 then -- if:
						if l_win.item.w_cursor.lnum <= a_line2 then
							if a_amount = 2_147_483_647 then
								if a_line1 <= 1 then
									l_win.item.w_cursor.lnum := (1).to_integer_32
								else
									l_win.item.w_cursor.lnum := a_line1 - 1
								end
								l_win.item.w_cursor.col := 0
							else
								l_win.item.w_cursor.lnum := l_win.item.w_cursor.lnum + a_amount
							end
						else
							l_pos := -1 + 99 -- goto _L___15
						end
				when 98 then -- if block done, skip else block:
						l_pos := -1 + 100
				when 99 then -- else: | _L___15:
						if a_amount_after.to_boolean then
							if l_win.item.w_cursor.lnum > a_line2 then
								l_win.item.w_cursor.lnum := l_win.item.w_cursor.lnum + a_amount_after
							end
						end
				when 100 then -- if done;
						(create {P_FOLD_STATIC}).foldMarkAdjust (l_win, a_line1, a_line2, a_amount, a_amount_after)
				when 101 then -- if done
						l_win := l_win.item.w_next
						l_pos := -1 + 62 -- back to loop condition
				when 102 then -- loop done
						l_tab___0 := l_tab___0.item.tp_next
						l_pos := -1 + 60 -- back to loop condition
				when 103 then -- loop done;
						(create {P_DIFF_STATIC}).diff_mark_adjust (a_line1, a_line2, a_amount, a_amount_after)
				when 104 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mark_col_adjust (a_lnum: INTEGER_32; a_mincol: INTEGER_32; a_lnum_amount, a_col_amount: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_fnum___0: INTEGER_32
			l_win: CE_POINTER [PD_WINDOW_S]
			l_posp: CE_POINTER [PD_POS_T]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fnum___0 := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum
					if a_col_amount /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_lnum_amount = 0 then
							l_return := True
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if ((create {P_GLOBALS_STATIC}).cmdmod.item.item.lockmarks).to_boolean then
							l_return := True
						end
				when 4 then
					if not l_return then
						l_i___0 := 0
						from
						until
							not (l_i___0 < 26)
						loop
							l_posp := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_namedm") + (create {PD_POS_T}.make).structure_size * (l_i___0))
							if l_posp.item.lnum = a_lnum then
								if l_posp.item.col >= a_mincol then
									l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
									if a_col_amount < 0 then
										if l_posp.item.col <= (-a_col_amount).to_integer_32 then
											l_posp.item.col := 0
										else
											l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
										end
									else
										l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
									end
								end
							end
							if namedfm.item[l_i___0].fmark.fnum = l_fnum___0 then
								l_posp := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (namedfm.item.c_pointer + (create {PD_XFILEMARK}.make).structure_size * (l_i___0) + (create {PD_XFILEMARK}.make).offset_of ("fmark") + (create {PD_FILEMARK}.make).offset_of ("mark"))
								if l_posp.item.lnum = a_lnum then
									if l_posp.item.col >= a_mincol then
										l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
										if a_col_amount < 0 then
											if l_posp.item.col <= (-a_col_amount).to_integer_32 then
												l_posp.item.col := 0
											else
												l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
											end
										else
											l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
										end
									end
								end
							end
							l_i___0 := l_i___0 + 1
						end
						l_i___0 := 26
						from
						until
							not (l_i___0 < 36)
						loop
							if namedfm.item[l_i___0].fmark.fnum = l_fnum___0 then
								l_posp := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (namedfm.item.c_pointer + (create {PD_XFILEMARK}.make).structure_size * (l_i___0) + (create {PD_XFILEMARK}.make).offset_of ("fmark") + (create {PD_FILEMARK}.make).offset_of ("mark"))
								if l_posp.item.lnum = a_lnum then
									if l_posp.item.col >= a_mincol then
										l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
										if a_col_amount < 0 then
											if l_posp.item.col <= (-a_col_amount).to_integer_32 then
												l_posp.item.col := 0
											else
												l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
											end
										else
											l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
										end
									end
								end
							end
							l_i___0 := l_i___0 + 1
						end
						l_posp := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_last_insert"))
						if l_posp.item.lnum = a_lnum then
							if l_posp.item.col >= a_mincol then
								l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
								if a_col_amount < 0 then
									if l_posp.item.col <= (-a_col_amount).to_integer_32 then
										l_posp.item.col := 0
									else
										l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
									end
								else
									l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
								end
							end
						end
						l_posp := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_last_change"))
						if l_posp.item.lnum = a_lnum then
							if l_posp.item.col >= a_mincol then
								l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
								if a_col_amount < 0 then
									if l_posp.item.col <= (-a_col_amount).to_integer_32 then
										l_posp.item.col := 0
									else
										l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
									end
								else
									l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
								end
							end
						end
						l_i___0 := 0
						from
						until
							not (l_i___0 < (create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelistlen)
						loop
							l_posp := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_changelist") + (create {PD_POS_T}.make).structure_size * (l_i___0))
							if l_posp.item.lnum = a_lnum then
								if l_posp.item.col >= a_mincol then
									l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
									if a_col_amount < 0 then
										if l_posp.item.col <= (-a_col_amount).to_integer_32 then
											l_posp.item.col := 0
										else
											l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
										end
									else
										l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
									end
								end
							end
							l_i___0 := l_i___0 + 1
						end
						l_posp := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_visual") + (create {PD_VISUALINFO_T}.make).offset_of ("vi_start"))
						if l_posp.item.lnum = a_lnum then
							if l_posp.item.col >= a_mincol then
								l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
								if a_col_amount < 0 then
									if l_posp.item.col <= (-a_col_amount).to_integer_32 then
										l_posp.item.col := 0
									else
										l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
									end
								else
									l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
								end
							end
						end
						l_posp := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_visual") + (create {PD_VISUALINFO_T}.make).offset_of ("vi_end"))
						if l_posp.item.lnum = a_lnum then
							if l_posp.item.col >= a_mincol then
								l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
								if a_col_amount < 0 then
									if l_posp.item.col <= (-a_col_amount).to_integer_32 then
										l_posp.item.col := 0
									else
										l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
									end
								else
									l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
								end
							end
						end
						l_posp := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_pcmark"))
						if l_posp.item.lnum = a_lnum then
							if l_posp.item.col >= a_mincol then
								l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
								if a_col_amount < 0 then
									if l_posp.item.col <= (-a_col_amount).to_integer_32 then
										l_posp.item.col := 0
									else
										l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
									end
								else
									l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
								end
							end
						end
						l_posp := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_prev_pcmark"))
						if l_posp.item.lnum = a_lnum then
							if l_posp.item.col >= a_mincol then
								l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
								if a_col_amount < 0 then
									if l_posp.item.col <= (-a_col_amount).to_integer_32 then
										l_posp.item.col := 0
									else
										l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
									end
								else
									l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
								end
							end
						end
						l_posp := (create {P_GLOBALS_STATIC}).saved_cursor.item
						if l_posp.item.lnum = a_lnum then
							if l_posp.item.col >= a_mincol then
								l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
								if a_col_amount < 0 then
									if l_posp.item.col <= (-a_col_amount).to_integer_32 then
										l_posp.item.col := 0
									else
										l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
									end
								else
									l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
								end
							end
						end
						l_win := (create {P_GLOBALS_STATIC}).firstwin.item
						from
						until
							not (not (l_return) and then (not l_win.is_void))
						loop
							l_i___0 := 0
							from
							until
								not (l_i___0 < l_win.item.w_jumplistlen)
							loop
								if l_win.item.w_jumplist[l_i___0].fmark.fnum = l_fnum___0 then
									l_posp := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (l_win.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_jumplist") + (create {PD_XFILEMARK}.make).structure_size * (l_i___0) + (create {PD_XFILEMARK}.make).offset_of ("fmark") + (create {PD_FILEMARK}.make).offset_of ("mark"))
									if l_posp.item.lnum = a_lnum then
										if l_posp.item.col >= a_mincol then
											l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
											if a_col_amount < 0 then
												if l_posp.item.col <= (-a_col_amount).to_integer_32 then
													l_posp.item.col := 0
												else
													l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
												end
											else
												l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
											end
										end
									end
								end
								l_i___0 := l_i___0 + 1
							end
							if (l_win.item.w_buffer).is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
								l_i___0 := 0
								from
								until
									not (l_i___0 < l_win.item.w_tagstacklen)
								loop
									if l_win.item.w_tagstack[l_i___0].fmark.fnum = l_fnum___0 then
										l_posp := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (l_win.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_tagstack") + (create {PD_TAGGY}.make).structure_size * (l_i___0) + (create {PD_TAGGY}.make).offset_of ("fmark") + (create {PD_FILEMARK}.make).offset_of ("mark"))
										if l_posp.item.lnum = a_lnum then
											if l_posp.item.col >= a_mincol then
												l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
												if a_col_amount < 0 then
													if l_posp.item.col <= (-a_col_amount).to_integer_32 then
														l_posp.item.col := 0
													else
														l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
													end
												else
													l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
												end
											end
										end
									end
									l_i___0 := l_i___0 + 1
								end
								if not l_win.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
									l_posp := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (l_win.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
									if l_posp.item.lnum = a_lnum then
										if l_posp.item.col >= a_mincol then
											l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
											if a_col_amount < 0 then
												if l_posp.item.col <= (-a_col_amount).to_integer_32 then
													l_posp.item.col := 0
												else
													l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
												end
											else
												l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
											end
										end
									end
								end
							end
							l_win := l_win.item.w_next
						end
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cleanup_jumplist
		local
			l_i___0: INTEGER_32
			l_from: INTEGER_32
			l_to: INTEGER_32
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_to := 0
			l_from := 0
			from
			until
				not (not (l_return) and then (l_from < (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistlen))
			loop
				if (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistidx = l_from then
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistidx := l_to
				end
				l_i___0 := l_from + 1
				from
				until
					not (not (l_break) and then (l_i___0 < (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistlen))
				loop
					l_break := False
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplist[l_i___0].fmark.fnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplist[l_from].fmark.fnum then
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplist[l_from].fmark.fnum /= 0 then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplist[l_i___0].fmark.mark.lnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplist[l_from].fmark.mark.lnum then
								l_break := True
							end
						end
					end
					if not (l_break) then
						l_i___0 := l_i___0 + 1
					end
				end
				l_break := False
				if l_i___0 >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistlen then
					l_tmp := l_to
					l_to := l_to + 1;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplist[l_tmp] := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplist[l_from]).twin
				else
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplist[l_from].fname))
				end
				l_from := l_from + 1
			end
			if (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistidx = (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistlen then
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistidx := l_to
			end
			(create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistlen := l_to
		end

	write_viminfo_filemarks (a_fp: CE_POINTER [SD_IO_FILE])
		local
			l_i___0: INTEGER_32
			l_name___1: CE_POINTER [NATURAL_8]
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_fm: CE_POINTER [PD_XFILEMARK]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___5: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if ((create {P_OPTION_STATIC}).get_viminfo_parameter (('f').code)) = 0 then
				l_return := True
			end
			if not l_return then
				fputs ((gettext (ce_string ("%N# File marks:%N"))), a_fp).do_nothing
				if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname).is_void then
					if not (removable ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname)).to_boolean then
						l_name___1 := (create {P_BUFFER_STATIC}).buflist_nr2name ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum, 1, 0)
						l_i___0 := 26
						from
						until
							not (not (l_break) and then (l_i___0 < 35))
						loop
							l_break := False
							if namedfm.item[l_i___0].fmark.mark.lnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
								if (namedfm.item[l_i___0].fname).is_void then
									l_tmp___3 := (namedfm.item[l_i___0].fmark.fnum = (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum).to_integer
								else
									if not l_name___1.is_void then
										if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_name___1), create {CE_INTEGER_8_POINTER}.make_cast (namedfm.item[l_i___0].fname))) = 0 then
											l_tmp___2 := 1
										else
											l_tmp___2 := 0
										end
									else
										l_tmp___2 := 0
									end
									l_tmp___3 := l_tmp___2
								end
								if l_tmp___3.to_boolean then
									l_break := True
								end
							end
							if not (l_break) then
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_name___1));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (namedfm.item[l_i___0].fname))
						from
						until
							not (l_i___0 > 26)
						loop
							namedfm.item[l_i___0] := (namedfm.item[l_i___0 - 1]).twin
							l_i___0 := l_i___0 - 1
						end
						namedfm.item[26].fmark.mark := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
						namedfm.item[26].fmark.fnum := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum
						namedfm.item[26].fname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					end
				end
				l_i___0 := 0
				from
				until
					not (l_i___0 < 36)
				loop
					if l_i___0 < 26 then
						l_tmp___5 := l_i___0 + 65
					else
						l_tmp___5 := (l_i___0 - 26) + 48
					end
					(namedfm.item + l_i___0).item.write_one_filemark (a_fp, ('%'').code, l_tmp___5)
					l_i___0 := l_i___0 + 1
				end
				fputs ((gettext (ce_string ("%N# Jumplist (newest first):%N"))), a_fp).do_nothing
				setpcmark
				cleanup_jumplist
				l_fm := create {CE_CLASS_POINTER [PD_XFILEMARK]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_jumplist") + (create {PD_XFILEMARK}.make).structure_size * ((create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistlen - 1))
				from
				until
					not ((l_fm.c_pointer.to_integer_32).to_natural_32 >= ((create {CE_CLASS_POINTER [PD_XFILEMARK]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_jumplist") + (create {PD_XFILEMARK}.make).structure_size * (0))).c_pointer.to_integer_32).to_natural_32)
				loop
					if l_fm.item.fmark.fnum = 0 then
						l_fm.item.write_one_filemark (a_fp, ('-').code, ('%'').code)
					else
						l_buf___6 := (create {P_BUFFER_STATIC}).buflist_findnr (l_fm.item.fmark.fnum)
						if not l_buf___6.is_void then
							if not (removable (l_buf___6.item.b_ffname)).to_boolean then
								l_fm.item.write_one_filemark (a_fp, ('-').code, ('%'').code)
							end
						end
					end
					l_fm := l_fm - 1
				end
			end
		end

	removable (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_name___1: CE_POINTER [NATURAL_8]
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_part: CE_ARRAY [NATURAL_8]
			l_retval: INTEGER_32
			l_n: NATURAL_32
			l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_part.make (<<51>>)

			l_name___1 := a_name___1
			l_retval := 0
			l_name___1 := (create {P_MISC1_STATIC}).home_replace_save (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), l_name___1)
			if not l_name___1.is_void then
				l_p___0.item := (create {P_OPTION_STATIC}).p_viminfo.item.item
				from
				until
					not (not (l_break) and then ((l_p___0.item.item).to_boolean))
				loop
					l_break := False;
					(create {P_MISC2_STATIC}).copy_option_part (l_p___0, l_part, 51, ce_string (", ")).do_nothing
					if (l_part[0]).to_integer_32 = 114 then
						l_n := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_part + 1)))
						if ((create {P_MBYTE_STATIC}).mb_strnicmp (l_part + 1, l_name___1, (l_n.to_integer_32).to_natural_32)) = 0 then
							l_retval := 1
							l_break := True
						end
					end
				end
				l_break := False;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_name___1))
			end
			Result := l_retval
		end

	write_viminfo_marks (a_fp_out: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_count___2: INTEGER_32
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_is_mark_set: INTEGER_32
			l_i___0: INTEGER_32
			l_win: CE_POINTER [PD_WINDOW_S]
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_return, l_break: BOOLEAN
		do
			l_tp := (create {P_GLOBALS_STATIC}).first_tabpage.item
			from
			until
				not (not (l_return) and then (not l_tp.is_void))
			loop
				if l_tp.is_equal ((create {P_GLOBALS_STATIC}).curtab.item) then
					l_win := (create {P_GLOBALS_STATIC}).firstwin.item
				else
					l_win := l_tp.item.tp_firstwin
				end
				from
				until
					l_win.is_void
				loop
					l_win.item.set_last_cursor
					l_win := l_win.item.w_next
				end
				l_tp := l_tp.item.tp_next
			end
			fputs ((gettext (ce_string ("%N# History of marks within files (newest to oldest):%N"))), a_fp_out).do_nothing
			l_count___2 := 0
			l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
			from
			until
				not (not (l_return) and then (not l_buf___6.is_void))
			loop
				if (l_buf___6.item.b_marks_read).to_boolean then
					if l_buf___6.item.b_last_cursor.lnum /= 0 then
						l_is_mark_set := 1
					else
						l_is_mark_set := 0
						l_i___0 := 0
						from
						until
							not (not (l_break) and then (l_i___0 < 26))
						loop
							l_break := False
							if l_buf___6.item.b_namedm[l_i___0].lnum /= 0 then
								l_is_mark_set := 1
								l_break := True
							end
							if not (l_return or l_break) then
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
					end
					if l_is_mark_set.to_boolean then
						if not (l_buf___6.item.b_ffname).is_void then
							if (l_buf___6.item.b_ffname[0]).to_integer_32 /= 0 then
								if not (removable (l_buf___6.item.b_ffname)).to_boolean then
									(create {P_MISC1_STATIC}).home_replace (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), l_buf___6.item.b_ffname, (create {P_GLOBALS_STATIC}).IObuff.item, 1_025, 1)
									fprintf ([a_fp_out, ce_string ("%N> ")]).do_nothing;
									(create {P_EX_CMDS_STATIC}).viminfo_writestring (a_fp_out, (create {P_GLOBALS_STATIC}).IObuff.item);
									(create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (l_buf___6.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_last_cursor"))).item.write_one_mark (a_fp_out, ('%"').code);
									(create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (l_buf___6.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_last_insert"))).item.write_one_mark (a_fp_out, ('^').code);
									(create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (l_buf___6.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_last_change"))).item.write_one_mark (a_fp_out, ('.').code)
									l_i___0 := 0
									from
									until
										not (l_i___0 < l_buf___6.item.b_changelistlen)
									loop
										(create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (l_buf___6.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_changelist") + (create {PD_POS_T}.make).structure_size * (l_i___0))).item.write_one_mark (a_fp_out, ('+').code)
										l_i___0 := l_i___0 + 1
									end
									l_i___0 := 0
									from
									until
										not (l_i___0 < 26)
									loop
										(create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (l_buf___6.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_namedm") + (create {PD_POS_T}.make).structure_size * (l_i___0))).item.write_one_mark (a_fp_out, 97 + l_i___0)
										l_i___0 := l_i___0 + 1
									end
									l_count___2 := l_count___2 + 1
								end
							end
						end
					end
				end
				l_buf___6 := l_buf___6.item.b_next
			end
			Result := l_count___2
		end

feature {ANY} -- routine addresses

	ex_jumps_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_jumps)
		end

	ex_changes_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_changes)
		end

end
