class
	P_MOVE_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	update_topline_redraw
		do
			update_topline
			if ((create {P_GLOBALS_STATIC}).must_redraw.item).to_boolean then
				(create {P_SCREEN_STATIC}).update_screen (0)
			end
		end

	update_topline
		local
			l_line_count: INTEGER_32
			l_halfheight: INTEGER_32
			l_n: INTEGER_32
			l_old_topline___0: INTEGER_32
			l_old_topfill___0: INTEGER_32
			l_lnum: CE_ARRAY [INTEGER_32]
			l_check_topline: INTEGER_32
			l_check_botline: INTEGER_32
			l_save_so: INTEGER_32
			l_loff: CE_ARRAY [PD_LINEOFF_T]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_lnum.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_LINEOFF_T]} l_loff.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_check_topline := 0
					l_check_botline := 0
					l_save_so := ((create {P_OPTION_STATIC}).p_so.item.item).to_integer_32
					if not ((create {P_SCREEN_STATIC}).screen_valid (1)).to_boolean then
						l_return := True
					end
					if not l_return then
						((create {P_GLOBALS_STATIC}).curwin.item).item.check_cursor_moved
						if (((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and (128)).to_boolean then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 22 -- skip if block
					end
				when 1 then -- if:
						if (create {P_GLOBALS_STATIC}).mouse_dragging.item > 0 then
							(create {P_OPTION_STATIC}).p_so.item.item := ((create {P_GLOBALS_STATIC}).mouse_dragging.item - 1).to_integer_32
						end
						l_old_topline___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline
						l_old_topfill___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill
						if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count /= 1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (((create {P_MEMLINE_STATIC}).ml_get ((1).to_integer_32)).item).to_integer_32 = 0 then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline /= 1 then
								(create {P_SCREEN_STATIC}).redraw_later (40)
							end
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := (1).to_integer_32;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_botline := (2).to_integer_32;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_or ((96));
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_scbind_pos := 1
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline > 1 then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline then
								l_check_topline := 1
							elseif (check_top_offset).to_boolean then
								l_check_topline := 1
							end
						end
						if not l_check_topline.to_boolean then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill > ((create {P_DIFF_STATIC}).diff_check_fill ((create {P_GLOBALS_STATIC}).curwin.item, (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline)) then
								l_check_topline := 1
							end
						end
						if l_check_topline.to_boolean then
							l_halfheight := (create {P_GLOBALS_STATIC}).curwin.item.item.w_height // 2 - 1
							if l_halfheight < 2 then
								l_halfheight := 2
							end
							if (((create {P_GLOBALS_STATIC}).curwin.item).item.hasAnyFolding).to_boolean then
								l_n := 0
								l_lnum.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
								from
								until
									not (not (l_break) and then (l_lnum.item < (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline + (create {P_OPTION_STATIC}).p_so.item.item))
								loop
									l_break := False
									l_n := l_n + 1
									if l_lnum.item >= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
										l_break := True
									elseif l_n >= l_halfheight then
										l_break := True
									end
									if not (l_break) then
										(create {P_FOLD_STATIC}).hasFolding (l_lnum.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_lnum).do_nothing
										l_lnum.item := l_lnum.item + 1
									end
								end
								l_break := False
							else
								l_n := (((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline + (create {P_OPTION_STATIC}).p_so.item.item) - (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum).to_integer_32
							end
							if l_n >= l_halfheight then
								scroll_cursor_halfway (0)
							else
								scroll_cursor_top ((scrolljump_value), 0)
								l_check_botline := 1
							end
						else
							(create {P_FOLD_STATIC}).hasFolding ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline, create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_topline")), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)).do_nothing
							l_check_botline := 1
						end
				when 5 then
						if not (l_check_botline.to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 6 then -- if:
						if not (((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and (64)).to_boolean then
							validate_botline
						end
						if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_botline <= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count) then
							l_pos := -1 + 16 -- skip if block
						end
				when 7 then -- if:
						if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline) then
							l_pos := -1 + 15 -- skip if block
						end
				when 8 then -- if:
						if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline - (create {P_OPTION_STATIC}).p_so.item.item) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L___0
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 11 then -- else:
						if not ((((create {P_GLOBALS_STATIC}).curwin.item).item.hasAnyFolding).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if: | _L___0:
						l_n := (create {P_GLOBALS_STATIC}).curwin.item.item.w_empty_rows
						l_loff.item.lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum;
						(create {P_FOLD_STATIC}).hasFolding (l_loff.item.lnum, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (l_loff.item.c_pointer + (create {PD_LINEOFF_T}.make).offset_of ("lnum"))).do_nothing
						l_loff.item.fill := 0
						l_n := l_n + ((create {P_GLOBALS_STATIC}).curwin.item.item.w_filler_rows)
						l_loff.item.height := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if l_loff.item.lnum < (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline then
								if not (l_loff.item.lnum + 1 < (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline) then
									if l_loff.item.fill /= 0 then
										l_break := True
									end
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_n := l_n + (l_loff.item.height)
								if l_n.to_integer_32 >= (create {P_OPTION_STATIC}).p_so.item.item then
									l_break := True
								end
							end
							if not (l_break) then
								l_loff.item.botline_forw
							end
						end
						l_break := False
						if l_n.to_integer_32 >= (create {P_OPTION_STATIC}).p_so.item.item then
							l_check_botline := 0
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						l_check_botline := 0
				when 15 then -- if done | if done
						if l_check_botline.to_boolean then
							if (((create {P_GLOBALS_STATIC}).curwin.item).item.hasAnyFolding).to_boolean then
								l_line_count := 0
								l_lnum.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
								from
								until
									not (not (l_break) and then (l_lnum.item >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline - (create {P_OPTION_STATIC}).p_so.item.item))
								loop
									l_break := False
									l_line_count := l_line_count + 1
									if l_lnum.item <= 0 then
										l_break := True
									elseif l_line_count > ((create {P_GLOBALS_STATIC}).curwin.item.item.w_height + 1).to_integer_32 then
										l_break := True
									end
									if not (l_break) then
										(create {P_FOLD_STATIC}).hasFolding (l_lnum.item, l_lnum, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)).do_nothing
										l_lnum.item := l_lnum.item - 1
									end
								end
								l_break := False
							else
								l_line_count := (((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum - (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline) + 1) + (create {P_OPTION_STATIC}).p_so.item.item
							end
							if l_line_count <= ((create {P_GLOBALS_STATIC}).curwin.item.item.w_height + 1).to_integer_32 then
								scroll_cursor_bot ((scrolljump_value), 0)
							else
								scroll_cursor_halfway (0)
							end
						end
				when 16 then -- if done | if done;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_or ((128))
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline = l_old_topline___0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 20 -- goto _L___1
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 19 then -- else:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill = l_old_topfill___0 then
							l_pos := -1 + 21 -- skip if block
						end
				when 20 then -- if: | _L___1:;
						(create {P_GLOBALS_STATIC}).dollar_vcol.item := 0
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_skipcol /= 0 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_skipcol := 0;
							(create {P_SCREEN_STATIC}).redraw_later (40)
						else
							(create {P_SCREEN_STATIC}).redraw_later (10)
						end
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline then
							validate_cursor
						end
				when 21 then -- if done;
						(create {P_OPTION_STATIC}).p_so.item.item := l_save_so.to_integer_32
				when 22 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	scrolljump_value: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if (create {P_OPTION_STATIC}).p_sj.item.item >= 0 then
				Result := ((create {P_OPTION_STATIC}).p_sj.item.item).to_integer_32
				l_return := True
			end
			if not l_return then
				Result := ((((create {P_GLOBALS_STATIC}).curwin.item.item.w_height).to_integer_32 * -(create {P_OPTION_STATIC}).p_sj.item.item) // 100).to_integer_32
			end
		end

	check_top_offset: INTEGER_32
		local
			l_loff: CE_ARRAY [PD_LINEOFF_T]
			l_n: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_LINEOFF_T]} l_loff.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline + (create {P_OPTION_STATIC}).p_so.item.item) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((((create {P_GLOBALS_STATIC}).curwin.item).item.hasAnyFolding).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						l_loff.item.lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
						l_loff.item.fill := 0
						l_n := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill
						from
						until
							not (not (l_break) and then (l_n.to_integer_32 < (create {P_OPTION_STATIC}).p_so.item.item))
						loop
							l_break := False
							l_loff.item.topline_back
							if l_loff.item.lnum < (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline then
								l_break := True
							elseif l_loff.item.lnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline then
								if l_loff.item.fill > 0 then
									l_break := True
								end
							end
							if not (l_break) then
								l_n := l_n + (l_loff.item.height)
							end
						end
						l_break := False
						if l_n.to_integer_32 < (create {P_OPTION_STATIC}).p_so.item.item then
							Result := 1
							l_return := True
						end
				when 5 then -- if done
					if not l_return then
						Result := 0
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	update_curswant
		do
			if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant).to_boolean then
				validate_virtcol;
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant := (create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol;
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 0
			end
		end

	changed_window_setting
		do
			((create {P_GLOBALS_STATIC}).curwin.item).item.changed_window_setting_win
		end

	changed_cline_bef_curs
		do
			(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-144))
		end

	changed_line_abv_curs
		do
			(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-160))
		end

	validate_botline
		do
			if not (((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and (32)).to_boolean then
				((create {P_GLOBALS_STATIC}).curwin.item).item.comp_botline
			end
		end

	invalidate_botline
		do
			(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-97))
		end

	validate_cursor
		do
			((create {P_GLOBALS_STATIC}).curwin.item).item.check_cursor_moved
			if (((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and (3)) /= 3 then
				curs_columns (1)
			end
		end

	validate_cline_row
		do
			update_topline;
			((create {P_GLOBALS_STATIC}).curwin.item).item.check_cursor_moved
			if not (((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and (16)).to_boolean then
				((create {P_GLOBALS_STATIC}).curwin.item).item.curs_rows (0)
			end
		end

	validate_virtcol
		do
			((create {P_GLOBALS_STATIC}).curwin.item).item.validate_virtcol_win
		end

	validate_cheight
		do
			((create {P_GLOBALS_STATIC}).curwin.item).item.check_cursor_moved
			if not (((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and (8)).to_boolean then
				if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline then
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_height := ((create {P_MISC1_STATIC}).plines_nofill ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)) + (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill
				else
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_height := (create {P_MISC1_STATIC}).plines ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)
				end
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_folded := (create {P_FOLD_STATIC}).hasFolding ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer));
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_or ((8))
			end
		end

	validate_cursor_col
		local
			l_off___0: INTEGER_32
			l_col: INTEGER_32
			l_width: INTEGER_32
		do
			validate_virtcol
			if not (((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and (2)).to_boolean then
				l_col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol
				l_off___0 := curwin_col_off
				l_col := l_col + l_off___0
				l_width := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_width - l_off___0) + (curwin_col_off2)
				if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_wrap).to_boolean then
					if l_col >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_width then
						if l_width > 0 then
							l_col := l_col - (((l_col - (create {P_GLOBALS_STATIC}).curwin.item.item.w_width) // l_width + 1) * l_width)
						end
					end
				end
				if l_col > (create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol then
					l_col := l_col - ((create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol)
				else
					l_col := 0
				end
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol := l_col;
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_or ((2))
			end
		end

	curwin_col_off: INTEGER_32
		do
			Result := (((create {P_GLOBALS_STATIC}).curwin.item).item.win_col_off)
		end

	curwin_col_off2: INTEGER_32
		do
			Result := (((create {P_GLOBALS_STATIC}).curwin.item).item.win_col_off2)
		end

	curs_columns (a_scroll: INTEGER_32)
		local
			l_diff: INTEGER_32
			l_extra: INTEGER_32
			l_off_left: INTEGER_32
			l_off_right: INTEGER_32
			l_n: INTEGER_32
			l_p_lines: INTEGER_32
			l_width: INTEGER_32
			l_textwidth: INTEGER_32
			l_new_leftcol: INTEGER_32
			l_startcol: CE_ARRAY [INTEGER_32]
			l_endcol: CE_ARRAY [INTEGER_32]
			l_prev_skipcol: INTEGER_32
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_startcol.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_endcol.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_width := 0
					update_topline
					if not (((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and (16)).to_boolean then
						((create {P_GLOBALS_STATIC}).curwin.item).item.curs_rows (0)
					end
					if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_folded).to_boolean then
						l_endcol.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol
						l_tmp := l_endcol.item;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol := l_tmp
						l_startcol.item := l_tmp
					else
						((create {P_GLOBALS_STATIC}).curwin.item).item.getvvcol (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), l_startcol, create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_virtcol")), l_endcol)
					end
					if l_startcol.item > (create {P_GLOBALS_STATIC}).dollar_vcol.item then
						(create {P_GLOBALS_STATIC}).dollar_vcol.item := 0
					end
					l_extra := curwin_col_off;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol + l_extra
					l_endcol.item := l_endcol.item + l_extra;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_row
					l_textwidth := (create {P_GLOBALS_STATIC}).curwin.item.item.w_width - l_extra
					if not (l_textwidth <= 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_width - 1;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow := (create {P_GLOBALS_STATIC}).curwin.item.item.w_height - 1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 3 then -- else:
						if not (((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_wrap).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_width /= 0 then
							l_width := l_textwidth + (curwin_col_off2)
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_width then
								l_n := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol - (create {P_GLOBALS_STATIC}).curwin.item.item.w_width) // l_width + 1;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol - (l_n * l_width);
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow := (create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow + l_n
								if ((create {P_OPTION_STATIC}).p_sbr.item.item.item).to_boolean then
									if (((create {P_MEMLINE_STATIC}).ml_get_cursor).item).to_integer_32 = 0 then
										if (create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol = ((create {P_CHARSET_STATIC}).vim_strsize ((create {P_OPTION_STATIC}).p_sbr.item.item)) then
											(create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol := 0
										end
									end
								end
							end
						else
							l_pos := -1 + 6 -- goto _L___1
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 6 then -- else: | _L___1:
						if not (a_scroll.to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 7 then -- if:
						if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_folded).to_boolean then
							l_pos := -1 + 15 -- skip if block
						end
				when 8 then -- if:
						l_off_left := ((l_startcol.item - (create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol).to_integer_32 - (create {P_OPTION_STATIC}).p_siso.item.item).to_integer_32
						l_off_right := (l_endcol.item - (((create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol + (create {P_GLOBALS_STATIC}).curwin.item.item.w_width).to_integer_32 - (create {P_OPTION_STATIC}).p_siso.item.item).to_integer_32) + 1
						if not (l_off_left < 0) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if not (l_off_right > 0) then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L:
						if l_off_left < 0 then
							l_diff := -l_off_left
						else
							l_diff := l_off_right
						end
						if (create {P_OPTION_STATIC}).p_ss.item.item = 0 then
							l_new_leftcol := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol - l_extra) - l_textwidth // 2
						elseif l_diff >= l_textwidth // 2 then
							l_new_leftcol := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol - l_extra) - l_textwidth // 2
						elseif l_off_right >= l_off_left then
							l_new_leftcol := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol - l_extra) - l_textwidth // 2
						else
							if l_diff.to_integer_32 < (create {P_OPTION_STATIC}).p_ss.item.item then
								l_diff := ((create {P_OPTION_STATIC}).p_ss.item.item).to_integer_32
							end
							if l_off_left < 0 then
								l_new_leftcol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol - l_diff
							else
								l_new_leftcol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol + l_diff
							end
						end
						if l_new_leftcol < 0 then
							l_new_leftcol := 0
						end
						if l_new_leftcol /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol := l_new_leftcol;
							(create {P_SCREEN_STATIC}).redraw_later (40)
						end
				when 13 then -- if done;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol - ((create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol)
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						l_pos := -1 + 17 -- goto _L___0
				when 16 then -- if done | if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else: | _L___0:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol > (create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol - ((create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol)
						else
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol := 0
						end
				when 18 then -- if done | if done
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline then
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow := (create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow + ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill)
					else
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow := (create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow + ((create {P_DIFF_STATIC}).diff_check_fill ((create {P_GLOBALS_STATIC}).curwin.item, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum))
					end
					l_prev_skipcol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_skipcol
					l_p_lines := 0
					if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_height) then
						l_pos := -1 + 21 -- skip if block
					end
				when 19 then -- if:
						l_pos := -1 + 26 -- goto _L___3
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 21 then -- else:
						if not (l_prev_skipcol > 0) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_pos := -1 + 25 -- goto _L___4
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 24 then -- else:
						if not (((create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow).to_integer_32 + (create {P_OPTION_STATIC}).p_so.item.item >= ((create {P_GLOBALS_STATIC}).curwin.item.item.w_height).to_integer_32) then
							l_pos := -1 + 49 -- skip if block
						end
				when 25 then -- if: | _L___4:
						l_p_lines := ((create {P_GLOBALS_STATIC}).curwin.item).item.plines_win_nofill ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, 0)
						if not (l_p_lines - 1 >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_height) then
							l_pos := -1 + 47 -- skip if block
						end
				when 26 then -- if: | _L___3:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_height = 0 then
							l_pos := -1 + 45 -- skip if block
						end
				when 27 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline then
							l_pos := -1 + 43 -- skip if block
						end
				when 28 then -- if:
						if not (l_width > 0) then
							l_pos := -1 + 41 -- skip if block
						end
				when 29 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_width = 0 then
							l_pos := -1 + 39 -- skip if block
						end
				when 30 then -- if:
						l_extra := 0
						if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_skipcol).to_integer_32 + (create {P_OPTION_STATIC}).p_so.item.item * l_width.to_integer_32 > ((create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol).to_integer_32 then
							l_extra := 1
						end
						if l_p_lines = 0 then
							l_p_lines := ((create {P_GLOBALS_STATIC}).curwin.item).item.plines_win ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, 0)
						end
						l_p_lines := l_p_lines - 1
						if l_p_lines.to_integer_32 > ((create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow).to_integer_32 + (create {P_OPTION_STATIC}).p_so.item.item then
							l_n := (((create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow).to_integer_32 + (create {P_OPTION_STATIC}).p_so.item.item).to_integer_32
						else
							l_n := l_p_lines
						end
						if l_n >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_height + (create {P_GLOBALS_STATIC}).curwin.item.item.w_skipcol // l_width then
							l_extra := l_extra + (2)
						end
						if l_extra /= 3 then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						l_pos := -1 + 34 -- goto _L___2
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 33 then -- else:
						if not (l_p_lines.to_integer_32 < (create {P_OPTION_STATIC}).p_so.item.item * 2) then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if: | _L___2:
						l_n := (create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol // l_width
						if l_n > (create {P_GLOBALS_STATIC}).curwin.item.item.w_height // 2 then
							l_n := l_n - ((create {P_GLOBALS_STATIC}).curwin.item.item.w_height // 2)
						else
							l_n := 0
						end
						if l_n > (l_p_lines - (create {P_GLOBALS_STATIC}).curwin.item.item.w_height) + 1 then
							l_n := (l_p_lines - (create {P_GLOBALS_STATIC}).curwin.item.item.w_height) + 1
						end
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_skipcol := l_n * l_width
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 36 then -- else:
						if l_extra = 1 then
							l_extra := (((((((create {P_GLOBALS_STATIC}).curwin.item.item.w_skipcol).to_integer_32 + (create {P_OPTION_STATIC}).p_so.item.item * l_width.to_integer_32) - ((create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol).to_integer_32) + l_width.to_integer_32) - 1) // l_width.to_integer_32).to_integer_32
							if l_extra > 0 then
								if l_extra * l_width > (create {P_GLOBALS_STATIC}).curwin.item.item.w_skipcol then
									l_extra := (create {P_GLOBALS_STATIC}).curwin.item.item.w_skipcol // l_width
								end
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_skipcol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_skipcol - (l_extra * l_width)
							end
						elseif l_extra = 2 then
							l_endcol.item := ((l_n - (create {P_GLOBALS_STATIC}).curwin.item.item.w_height) + 1) * l_width
							from
							until
								not (l_endcol.item > (create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol)
							loop
								l_endcol.item := l_endcol.item - l_width
							end
							if l_endcol.item > (create {P_GLOBALS_STATIC}).curwin.item.item.w_skipcol then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_skipcol := l_endcol.item
							end
						end
				when 37 then -- if done;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow := (create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow - ((create {P_GLOBALS_STATIC}).curwin.item.item.w_skipcol // l_width)
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_height then
							l_extra := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow - (create {P_GLOBALS_STATIC}).curwin.item.item.w_height) + 1;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_skipcol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_skipcol + (l_extra * l_width);
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow := (create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow - l_extra
						end
						l_extra := (l_prev_skipcol - (create {P_GLOBALS_STATIC}).curwin.item.item.w_skipcol) // l_width
						if l_extra > 0 then
							((create {P_GLOBALS_STATIC}).curwin.item).item.win_ins_lines (0, l_extra, 0, 0).do_nothing
						elseif l_extra < 0 then
							((create {P_GLOBALS_STATIC}).curwin.item).item.win_del_lines (0, -l_extra, 0, 0).do_nothing
						end
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 39 then -- else:;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_skipcol := 0
				when 40 then -- if done | if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else:;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_skipcol := 0
				when 42 then -- if done | if block done, skip else block:
						l_pos := -1 + 44
				when 43 then -- else:;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_skipcol := 0
				when 44 then -- if done | if block done, skip else block:
						l_pos := -1 + 46
				when 45 then -- else:;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_skipcol := 0
				when 46 then -- if done | if block done, skip else block:
						l_pos := -1 + 48
				when 47 then -- else:;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_skipcol := 0
				when 48 then -- if done | if block done, skip else block:
						l_pos := -1 + 50
				when 49 then -- else:;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_skipcol := 0
				when 50 then -- if done | if done
					if l_prev_skipcol /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_skipcol then
						(create {P_SCREEN_STATIC}).redraw_later (40)
					end
					if (((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and (1)) /= 0 then
						l_pos := -1 + 53 -- skip if block
					end
				when 51 then -- if:
						if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_rnu).to_boolean then
							l_pos := -1 + 55 -- goto _L___5
						elseif ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_cul).to_boolean then
							l_pos := -1 + 55 -- goto _L___5
						else
							l_pos := -1 + 53 -- goto _L___6
						end
				when 52 then -- if block done, skip else block:
						l_pos := -1 + 56
				when 53 then -- else: | _L___6:
						if not (((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_cuc).to_boolean) then
							l_pos := -1 + 56 -- skip if block
						end
				when 54 then -- if:
						if (((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and (4)) /= 0 then
							l_pos := -1 + 56 -- skip if block
						end
				when 55 then -- if: | _L___5:
						if not ((create {P_POPUPMNU_STATIC}).pum_visible).to_boolean then
							(create {P_SCREEN_STATIC}).redraw_later (35)
						end
				when 56 then -- if done | if done;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_or ((7))
				when 57 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	scrolldown (a_line_count: INTEGER_32; a_byfold: INTEGER_32)
		local
			l_line_count: INTEGER_32
			l_done___2: INTEGER_32
			l_wrow: INTEGER_32
			l_moved: INTEGER_32
			l_first___0: CE_ARRAY [INTEGER_32]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_first___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_line_count := a_line_count
					l_done___2 := 0
					l_moved := 0;
					(create {P_FOLD_STATIC}).hasFolding ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline, create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_topline")), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)).do_nothing
					validate_cursor
				when 1 then -- loop condition:
					if (l_break) then
						l_pos := -1 + 8 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_tmp___2 := l_line_count
						l_line_count := l_line_count - 1
						if not (l_tmp___2 > 0) then
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if:
						if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill < (((create {P_GLOBALS_STATIC}).curwin.item).item.diff_check ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline))) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill < (create {P_GLOBALS_STATIC}).curwin.item.item.w_height - 1 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill) + 1
							l_done___2 := l_done___2 + 1
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline = 1 then
							l_break := True
						end
						if not (l_break) then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline) - 1;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := 0
							if ((create {P_FOLD_STATIC}).hasFolding ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline, l_first___0, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))).to_boolean then
								l_done___2 := l_done___2 + 1
								if not a_byfold.to_boolean then
									l_line_count := l_line_count - (((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline - l_first___0.item) - 1)
								end
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_botline := (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline - ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline - l_first___0.item);
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := l_first___0.item
							else
								l_done___2 := l_done___2 + ((create {P_MISC1_STATIC}).plines_nofill ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline)).to_integer_32
							end
						end
				when 7 then -- if done
						if not (l_break) then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_botline := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_botline) - 1
							invalidate_botline
						end
						l_pos := -1 + 1 -- back to loop condition
				when 8 then -- loop done
					l_break := False;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow := (((create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow).to_integer_32 + l_done___2).to_integer_32;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_row := (((create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_row).to_integer_32 + l_done___2).to_integer_32
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline then
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_row := 0
					end
					((create {P_GLOBALS_STATIC}).curwin.item).item.check_topfill (1)
					l_wrow := (create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow
					if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_wrap).to_boolean then
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_width /= 0 then
							validate_virtcol
							validate_cheight
							l_wrow := l_wrow + (((create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_height - 1) - (create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol // (create {P_GLOBALS_STATIC}).curwin.item.item.w_width)
						end
					end
					from
					until
						(l_break)
					loop
						l_break := False
						if l_wrow >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_height then
							if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum > 1) then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							if ((create {P_FOLD_STATIC}).hasFolding ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_first___0, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))).to_boolean then
								l_wrow := l_wrow - 1
								if l_first___0.item = 1 then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (1).to_integer_32
								else
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_first___0.item - 1
								end
							else
								l_tmp___3 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) - 1
								l_wrow := l_wrow - ((create {P_MISC1_STATIC}).plines (l_tmp___3))
							end
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-32))
							l_moved := 1
						end
					end
					l_break := False
					if l_moved.to_boolean then
						(create {P_FOLD_STATIC}).foldAdjustCursor;
						(create {P_MISC2_STATIC}).coladvance ((create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant).do_nothing
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	scrollup (a_line_count: INTEGER_32; a_byfold: INTEGER_32)
		local
			l_line_count: INTEGER_32
			l_lnum: CE_ARRAY [INTEGER_32]
			l_tmp: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_lnum.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_line_count := a_line_count
					if not (a_byfold.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (((create {P_GLOBALS_STATIC}).curwin.item).item.hasAnyFolding).to_boolean then
							l_pos := -1 + 4 -- goto _L
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else: | _L___0:
						if not (((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_diff).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_lnum.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp := l_line_count
							l_line_count := l_line_count - 1
							if not l_tmp.to_boolean then
								l_break := True
							end
							if not (l_break) then
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill > 0 then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill) - 1
								else
									if a_byfold.to_boolean then
										(create {P_FOLD_STATIC}).hasFolding (l_lnum.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_lnum).do_nothing
									end
									if l_lnum.item >= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
										l_break := True
									end
									if not (l_break) then
										l_lnum.item := l_lnum.item + 1;
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := (create {P_DIFF_STATIC}).diff_check_fill ((create {P_GLOBALS_STATIC}).curwin.item, l_lnum.item)
									end
								end
							end
						end
						l_break := False;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_botline := (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline + (l_lnum.item - (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline);
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := l_lnum.item
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline + l_line_count;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_botline := (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline + l_line_count
				when 7 then -- if done
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count
					end
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count + 1 then
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_botline := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count + 1
					end
					((create {P_GLOBALS_STATIC}).curwin.item).item.check_topfill (0)
					if (((create {P_GLOBALS_STATIC}).curwin.item).item.hasAnyFolding).to_boolean then
						(create {P_FOLD_STATIC}).hasFolding ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline, create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_topline")), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)).do_nothing
					end
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-50))
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline then
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-32));
						(create {P_MISC2_STATIC}).coladvance ((create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant).do_nothing
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	max_topfill
		local
			l_n: INTEGER_32
		do
			l_n := (create {P_MISC1_STATIC}).plines_nofill ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline)
			if l_n >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_height then
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := 0
			else
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := (create {P_DIFF_STATIC}).diff_check_fill ((create {P_GLOBALS_STATIC}).curwin.item, (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline)
				if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill + l_n > (create {P_GLOBALS_STATIC}).curwin.item.item.w_height then
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := (create {P_GLOBALS_STATIC}).curwin.item.item.w_height - l_n
				end
			end
		end

	scrolldown_clamp
		local
			l_end_row: INTEGER_32
			l_can_fill: INTEGER_32
			l_return: BOOLEAN
		do
			l_can_fill := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill < ((create {P_DIFF_STATIC}).diff_check_fill ((create {P_GLOBALS_STATIC}).curwin.item, (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline))).to_integer
			if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline <= 1 then
				if not l_can_fill.to_boolean then
					l_return := True
				end
			end
			if not l_return then
				validate_cursor
				l_end_row := (create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow
				if l_can_fill.to_boolean then
					l_end_row := l_end_row + 1
				else
					l_end_row := l_end_row + ((create {P_MISC1_STATIC}).plines_nofill ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline - 1))
				end
				if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_wrap).to_boolean then
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_width /= 0 then
						validate_cheight
						validate_virtcol
						l_end_row := l_end_row + (((create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_height - 1) - (create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol // (create {P_GLOBALS_STATIC}).curwin.item.item.w_width)
					end
				end
				if l_end_row.to_integer_32 < ((create {P_GLOBALS_STATIC}).curwin.item.item.w_height).to_integer_32 - (create {P_OPTION_STATIC}).p_so.item.item then
					if l_can_fill.to_boolean then
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill) + 1;
						((create {P_GLOBALS_STATIC}).curwin.item).item.check_topfill (1)
					else
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline) - 1;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := 0
					end
					(create {P_FOLD_STATIC}).hasFolding ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline, create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_topline")), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)).do_nothing;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_botline := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_botline) - 1;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-50))
				end
			end
		end

	scrollup_clamp
		local
			l_start_row: INTEGER_32
			l_return: BOOLEAN
		do
			if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline = (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
				if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill = 0 then
					l_return := True
				end
			end
			if not l_return then
				validate_cursor
				l_start_row := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow - ((create {P_MISC1_STATIC}).plines_nofill ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline))) - (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill
				if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_wrap).to_boolean then
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_width /= 0 then
						validate_virtcol
						l_start_row := l_start_row - ((create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol // (create {P_GLOBALS_STATIC}).curwin.item.item.w_width)
					end
				end
				if l_start_row.to_integer_32 >= (create {P_OPTION_STATIC}).p_so.item.item then
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill > 0 then
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill) - 1
					else
						(create {P_FOLD_STATIC}).hasFolding ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_topline"))).do_nothing;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline) + 1
					end
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_botline := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_botline) + 1;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-50))
				end
			end
		end

	scroll_cursor_top (a_min_scroll, a_always: INTEGER_32)
		local
			l_scrolled: INTEGER_32
			l_extra: INTEGER_32
			l_used: INTEGER_32
			l_i___0: INTEGER_32
			l_top: CE_ARRAY [INTEGER_32]
			l_bot: CE_ARRAY [INTEGER_32]
			l_old_topline___0: INTEGER_32
			l_old_topfill___0: INTEGER_32
			l_new_topline: INTEGER_32
			l_off___0: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_top.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_bot.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_scrolled := 0
					l_extra := 0
					l_old_topline___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline
					l_old_topfill___0 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill).to_integer_32
					l_off___0 := ((create {P_OPTION_STATIC}).p_so.item.item).to_integer_32
					if (create {P_GLOBALS_STATIC}).mouse_dragging.item > 0 then
						l_off___0 := (create {P_GLOBALS_STATIC}).mouse_dragging.item - 1
					end
					validate_cheight
					l_used := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_height
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline then
						l_scrolled := l_used
					end
					if ((create {P_FOLD_STATIC}).hasFolding ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_top, l_bot)).to_boolean then
						l_top.item := l_top.item - 1
						l_bot.item := l_bot.item + 1
					else
						l_top.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum - 1
						l_bot.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum + 1
					end
					l_new_topline := l_top.item + 1
					l_i___0 := (create {P_DIFF_STATIC}).diff_check_fill ((create {P_GLOBALS_STATIC}).curwin.item, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)
					l_used := l_used + l_i___0
					l_extra := l_extra + l_i___0
				when 1 then -- loop condition:
					if not (not (l_break) and then (l_top.item > 0)) then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if ((create {P_FOLD_STATIC}).hasFolding (l_top.item, l_top, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))).to_boolean then
							l_i___0 := 1
						else
							l_i___0 := (create {P_MISC1_STATIC}).plines (l_top.item)
						end
						l_used := l_used + l_i___0
						if l_extra + l_i___0 <= l_off___0 then
							if l_bot.item < (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
								if ((create {P_FOLD_STATIC}).hasFolding (l_bot.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_bot)).to_boolean then
									l_used := l_used + 1
								else
									l_used := l_used + ((create {P_MISC1_STATIC}).plines (l_bot.item))
								end
							end
						end
						if l_used > (create {P_GLOBALS_STATIC}).curwin.item.item.w_height then
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						if l_top.item < (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline then
							l_scrolled := l_scrolled + l_i___0
						end
						if not (l_new_topline >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if not (l_scrolled > a_min_scroll) then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						if l_extra >= l_off___0 then
							l_break := True
						end
				when 8 then -- if done | if done
						if not (l_break) then
							l_extra := l_extra + l_i___0
							l_new_topline := l_top.item
							l_top.item := l_top.item - 1
							l_bot.item := l_bot.item + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
					l_break := False
					if l_used > (create {P_GLOBALS_STATIC}).curwin.item.item.w_height then
						scroll_cursor_halfway (0)
					else
						if l_new_topline < (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := l_new_topline
						elseif a_always.to_boolean then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := l_new_topline
						end
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline > (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
						end
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := (create {P_DIFF_STATIC}).diff_check_fill ((create {P_GLOBALS_STATIC}).curwin.item, (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline)
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill > 0 then
							if l_extra > l_off___0 then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill - (l_extra - l_off___0)
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill < 0 then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := 0
								end
							end
						end
						((create {P_GLOBALS_STATIC}).curwin.item).item.check_topfill (0)
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline /= l_old_topline___0 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-114))
						elseif ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill).to_integer_32 /= l_old_topfill___0 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-114))
						end
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_or ((128))
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	scroll_cursor_bot (a_min_scroll, a_set_topbot: INTEGER_32)
		local
			l_used: INTEGER_32
			l_scrolled: INTEGER_32
			l_extra: INTEGER_32
			l_i___0: INTEGER_32
			l_line_count: INTEGER_32
			l_old_topline___0: INTEGER_32
			l_loff: CE_ARRAY [PD_LINEOFF_T]
			l_boff: CE_ARRAY [PD_LINEOFF_T]
			l_old_topfill___0: INTEGER_32
			l_fill_below_window: INTEGER_32
			l_old_botline: INTEGER_32
			l_old_valid: INTEGER_32
			l_old_empty_rows: INTEGER_32
			l_cln: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_LINEOFF_T]} l_loff.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_LINEOFF_T]} l_boff.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_scrolled := 0
					l_extra := 0
					l_old_topline___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline
					l_old_topfill___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill
					l_old_botline := (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline
					l_old_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).to_integer_32
					l_old_empty_rows := (create {P_GLOBALS_STATIC}).curwin.item.item.w_empty_rows
					l_cln := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
					if a_set_topbot.to_boolean then
						l_used := 0;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_botline := l_cln + 1
						l_loff.item.fill := 0;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline
						from
						until
							not (not (l_break) and then ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline > 1))
						loop
							l_break := False
							l_loff.item.lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline
							l_loff.item.topline_back
							if (l_loff.item.height).to_integer_32 = 2_147_483_647 then
								l_break := True
							elseif l_used + l_loff.item.height > (create {P_GLOBALS_STATIC}).curwin.item.item.w_height then
								l_break := True
							end
							if not (l_break) then
								l_used := l_used + (l_loff.item.height);
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := l_loff.item.fill;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := l_loff.item.lnum
							end
						end
						l_break := False;
						((create {P_GLOBALS_STATIC}).curwin.item).item.set_empty_rows (l_used);
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_or ((96))
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline /= l_old_topline___0 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-18))
						elseif (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill /= l_old_topfill___0 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-18))
						end
					else
						validate_botline
					end
					l_used := (create {P_MISC1_STATIC}).plines_nofill (l_cln)
					if l_cln >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline then
						l_scrolled := l_used
						if l_cln = (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline then
							l_scrolled := l_scrolled - ((create {P_GLOBALS_STATIC}).curwin.item.item.w_empty_rows)
						end
					end
					if not ((create {P_FOLD_STATIC}).hasFolding ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, create {CE_INTEGER_32_POINTER}.make_shared (l_loff.item.c_pointer + (create {PD_LINEOFF_T}.make).offset_of ("lnum")), create {CE_INTEGER_32_POINTER}.make_shared (l_boff.item.c_pointer + (create {PD_LINEOFF_T}.make).offset_of ("lnum")))).to_boolean then
						l_loff.item.lnum := l_cln
						l_boff.item.lnum := l_cln
					end
					l_loff.item.fill := 0
					l_boff.item.fill := 0
					l_fill_below_window := ((create {P_DIFF_STATIC}).diff_check_fill ((create {P_GLOBALS_STATIC}).curwin.item, (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline)) - (create {P_GLOBALS_STATIC}).curwin.item.item.w_filler_rows
				when 1 then -- loop condition:
					if not (not (l_break) and then (l_loff.item.lnum > 1)) then
						l_pos := -1 + 30 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if not (l_scrolled <= 0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L___1
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 5 then -- else:
						if not (l_scrolled >= a_min_scroll) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L___1:
						if (create {P_GLOBALS_STATIC}).mouse_dragging.item > 0 then
							l_tmp___1 := ((create {P_GLOBALS_STATIC}).mouse_dragging.item - 1).to_integer_32
						else
							l_tmp___1 := (create {P_OPTION_STATIC}).p_so.item.item
						end
						if l_extra.to_integer_32 >= l_tmp___1 then
							l_pos := -1 + 9 -- goto _L
						else
							l_pos := -1 + 8 -- goto _L___0
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else: | _L___0:
						if not (l_boff.item.lnum + 1 > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count) then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if l_loff.item.lnum <= (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline then
							if l_loff.item.lnum < (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline then
								l_break := True
							elseif l_loff.item.fill >= l_fill_below_window then
								l_break := True
							end
						end
				when 10 then -- if done | if done
						if not (l_break) then
							l_loff.item.topline_back
							if (l_loff.item.height).to_integer_32 = 2_147_483_647 then
								l_used := 2_147_483_647
							else
								l_used := l_used + (l_loff.item.height)
							end
							if l_used > (create {P_GLOBALS_STATIC}).curwin.item.item.w_height then
								l_break := True
							end
						end
						if (l_break) then
							l_pos := -1 + 29 -- skip if block
						end
				when 11 then -- if:
						if not (l_loff.item.lnum >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline) then
							l_pos := -1 + 17 -- skip if block
						end
				when 12 then -- if:
						if not (l_loff.item.lnum > (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L___2
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 15 then -- else:
						if not (l_loff.item.fill <= l_fill_below_window) then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | _L___2:
						l_scrolled := l_scrolled + (l_loff.item.height)
						if l_loff.item.lnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline then
							if l_boff.item.fill = 0 then
								l_scrolled := l_scrolled - ((create {P_GLOBALS_STATIC}).curwin.item.item.w_empty_rows)
							end
						end
				when 17 then -- if done | if done
						if not (l_boff.item.lnum < (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count) then
							l_pos := -1 + 29 -- skip if block
						end
				when 18 then -- if:
						l_boff.item.botline_forw
						l_used := l_used + (l_boff.item.height)
						if l_used > (create {P_GLOBALS_STATIC}).curwin.item.item.w_height then
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 29 -- skip if block
						end
				when 19 then -- if:
						if (create {P_GLOBALS_STATIC}).mouse_dragging.item > 0 then
							l_tmp___2 := ((create {P_GLOBALS_STATIC}).mouse_dragging.item - 1).to_integer_32
						else
							l_tmp___2 := (create {P_OPTION_STATIC}).p_so.item.item
						end
						if not (l_extra.to_integer_32 < l_tmp___2) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 23 -- goto _L___4
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 22 then -- else:
						if not (l_scrolled < a_min_scroll) then
							l_pos := -1 + 29 -- skip if block
						end
				when 23 then -- if: | _L___4:
						l_extra := l_extra + (l_boff.item.height)
						if not (l_boff.item.lnum >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline) then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_pos := -1 + 28 -- goto _L___3
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 26 then -- else:
						if l_boff.item.lnum + 1 /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						if not (l_boff.item.fill > (create {P_GLOBALS_STATIC}).curwin.item.item.w_filler_rows) then
							l_pos := -1 + 29 -- skip if block
						end
				when 28 then -- if: | _L___3:
						l_scrolled := l_scrolled + (l_boff.item.height)
						if l_boff.item.lnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline then
							if l_boff.item.fill = 0 then
								l_scrolled := l_scrolled - ((create {P_GLOBALS_STATIC}).curwin.item.item.w_empty_rows)
							end
						end
				when 29 then -- if done | if done | if done | if done | if done | if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 30 then -- loop done
					l_break := False
					if l_scrolled <= 0 then
						l_line_count := (0).to_integer_32
					elseif l_used > (create {P_GLOBALS_STATIC}).curwin.item.item.w_height then
						l_line_count := l_used.to_integer_32
					else
						l_line_count := (0).to_integer_32
						l_boff.item.fill := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill
						l_boff.item.lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline - 1
						l_i___0 := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if l_i___0 < l_scrolled then
								if not (l_boff.item.lnum < (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_boff.item.botline_forw
								l_i___0 := l_i___0 + (l_boff.item.height)
								l_line_count := l_line_count + 1
							end
						end
						l_break := False
						if l_i___0 < l_scrolled then
							l_line_count := (9_999).to_integer_32
						end
					end
					if l_line_count >= ((create {P_GLOBALS_STATIC}).curwin.item.item.w_height).to_integer_32 then
						if l_line_count > a_min_scroll.to_integer_32 then
							scroll_cursor_halfway (0)
						else
							scrollup (l_line_count, 1)
						end
					else
						scrollup (l_line_count, 1)
					end
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline = l_old_topline___0 then
						if a_set_topbot.to_boolean then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_botline := l_old_botline;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_empty_rows := l_old_empty_rows;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := l_old_valid.to_integer_32
						end
					end
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_or ((128))
				when 31 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	scroll_cursor_halfway (a_atend: INTEGER_32)
		local
			l_above: INTEGER_32
			l_topline: INTEGER_32
			l_topfill: INTEGER_32
			l_below: INTEGER_32
			l_used: INTEGER_32
			l_loff: CE_ARRAY [PD_LINEOFF_T]
			l_boff: CE_ARRAY [PD_LINEOFF_T]
			l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_LINEOFF_T]} l_loff.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_LINEOFF_T]} l_boff.make (<<1>>)

			l_above := 0
			l_topfill := 0
			l_below := 0
			l_boff.item.lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
			l_loff.item.lnum := l_boff.item.lnum;
			(create {P_FOLD_STATIC}).hasFolding (l_loff.item.lnum, create {CE_INTEGER_32_POINTER}.make_shared (l_loff.item.c_pointer + (create {PD_LINEOFF_T}.make).offset_of ("lnum")), create {CE_INTEGER_32_POINTER}.make_shared (l_boff.item.c_pointer + (create {PD_LINEOFF_T}.make).offset_of ("lnum"))).do_nothing
			l_used := (create {P_MISC1_STATIC}).plines_nofill (l_loff.item.lnum)
			l_loff.item.fill := 0
			l_boff.item.fill := 0
			l_topline := l_loff.item.lnum
			from
			until
				not (not (l_break) and then (l_topline > 1))
			loop
				l_break := False
				if l_below <= l_above then
					if l_boff.item.lnum < (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
						l_boff.item.botline_forw
						l_used := l_used + (l_boff.item.height)
						if l_used > (create {P_GLOBALS_STATIC}).curwin.item.item.w_height then
							l_break := True
						end
						if not (l_break) then
							l_below := l_below + (l_boff.item.height)
						end
					else
						l_below := l_below + 1
						if a_atend.to_boolean then
							l_used := l_used + 1
						end
					end
				end
				if not (l_break) and then (l_below > l_above) then
					l_loff.item.topline_back
					if (l_loff.item.height).to_integer_32 = 2_147_483_647 then
						l_used := 2_147_483_647
					else
						l_used := l_used + (l_loff.item.height)
					end
					if l_used > (create {P_GLOBALS_STATIC}).curwin.item.item.w_height then
						l_break := True
					end
					if not (l_break) then
						l_above := l_above + (l_loff.item.height)
						l_topline := l_loff.item.lnum
						l_topfill := l_loff.item.fill
					end
				end
			end
			l_break := False
			if not ((create {P_FOLD_STATIC}).hasFolding (l_topline, create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_topline")), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))).to_boolean then
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := l_topline
			end
			(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := l_topfill;
			((create {P_GLOBALS_STATIC}).curwin.item).item.check_topfill (0);
			(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-114));
			(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_or ((128))
		end

	cursor_correct
		local
			l_above: INTEGER_32
			l_topline: CE_ARRAY [INTEGER_32]
			l_below: INTEGER_32
			l_botline: CE_ARRAY [INTEGER_32]
			l_above_wanted: INTEGER_32
			l_below_wanted: INTEGER_32
			l_cln: INTEGER_32
			l_max_off: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_topline.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_botline.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_above := 0
					l_below := 0
					l_above_wanted := ((create {P_OPTION_STATIC}).p_so.item.item).to_integer_32
					l_below_wanted := ((create {P_OPTION_STATIC}).p_so.item.item).to_integer_32
					if (create {P_GLOBALS_STATIC}).mouse_dragging.item > 0 then
						l_above_wanted := (create {P_GLOBALS_STATIC}).mouse_dragging.item - 1
						l_below_wanted := (create {P_GLOBALS_STATIC}).mouse_dragging.item - 1
					end
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline = 1 then
						l_above_wanted := 0
						l_max_off := (create {P_GLOBALS_STATIC}).curwin.item.item.w_height // 2
						if l_below_wanted > l_max_off then
							l_below_wanted := l_max_off
						end
					end
					validate_botline
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline = (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count + 1 then
						if (create {P_GLOBALS_STATIC}).mouse_dragging.item = 0 then
							l_below_wanted := 0
							l_max_off := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_height - 1) // 2
							if l_above_wanted > l_max_off then
								l_above_wanted := l_max_off
							end
						end
					end
					l_cln := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
					if l_cln >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline + l_above_wanted.to_integer_32 then
						if l_cln < (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline - l_below_wanted.to_integer_32 then
							if not (((create {P_GLOBALS_STATIC}).curwin.item).item.hasAnyFolding).to_boolean then
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 25 -- skip if block
					end
				when 1 then -- if:
						l_topline.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline
						l_botline.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline - 1
						l_above := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill
						l_below := (create {P_GLOBALS_STATIC}).curwin.item.item.w_filler_rows
				when 2 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 24 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if not (l_above < l_above_wanted) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___1
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not (l_below < l_below_wanted) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___1:
						if not (l_topline.item < l_botline.item) then
							l_break := True
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_break := True
				when 10 then -- if done
						if (l_break) then
							l_pos := -1 + 23 -- skip if block
						end
				when 11 then -- if:
						if not (l_below < l_below_wanted) then
							l_pos := -1 + 17 -- skip if block
						end
				when 12 then -- if:
						if not (l_below <= l_above) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 15 then -- else:
						if not (l_above >= l_above_wanted) then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | _L:
						if ((create {P_FOLD_STATIC}).hasFolding (l_botline.item, l_botline, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))).to_boolean then
							l_below := l_below + 1
						else
							l_below := l_below + ((create {P_MISC1_STATIC}).plines (l_botline.item))
						end
						l_botline.item := l_botline.item - 1
				when 17 then -- if done | if done
						if not (l_above < l_above_wanted) then
							l_pos := -1 + 23 -- skip if block
						end
				when 18 then -- if:
						if not (l_above < l_below) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 22 -- goto _L___0
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 21 then -- else:
						if not (l_below >= l_below_wanted) then
							l_pos := -1 + 23 -- skip if block
						end
				when 22 then -- if: | _L___0:
						if ((create {P_FOLD_STATIC}).hasFolding (l_topline.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_topline)).to_boolean then
							l_above := l_above + 1
						else
							l_above := l_above + ((create {P_MISC1_STATIC}).plines_nofill (l_topline.item))
						end
						if l_topline.item < l_botline.item then
							l_above := l_above + ((create {P_DIFF_STATIC}).diff_check_fill ((create {P_GLOBALS_STATIC}).curwin.item, l_topline.item + 1))
						end
						l_topline.item := l_topline.item + 1
				when 23 then -- if done | if done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 24 then -- loop done
						l_break := False
						if l_topline.item = l_botline.item then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_topline.item
						elseif l_botline.item = 0 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_topline.item
						elseif l_topline.item > l_botline.item then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_botline.item
						else
							if l_cln < l_topline.item then
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline > 1 then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_topline.item;
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-28))
								end
							end
							if l_cln > l_botline.item then
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline <= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_botline.item;
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-28))
								end
							end
						end
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_or ((128))
				when 25 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	onepage (a_dir___0: INTEGER_32; a_count___2: INTEGER_32): INTEGER_32
		local
			l_count___2: INTEGER_32
			l_n: INTEGER_32
			l_retval: INTEGER_32
			l_loff: CE_ARRAY [PD_LINEOFF_T]
			l_old_topline___0: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_LINEOFF_T]} l_loff.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count___2 := a_count___2
					l_retval := 1
					l_old_topline___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline
					if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count = 1 then
						(create {P_MISC1_STATIC}).beep_flush
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 25 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if not (not (l_return or l_break) and then (l_count___2 > 0)) then
							l_pos := -1 + 24 -- skip loop
						end
				when 2 then -- loop body:
						l_break := False
						l_continue := False
						validate_botline
						if a_dir___0 = 1 then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline >= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count - (create {P_OPTION_STATIC}).p_so.item.item then
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
									l_tmp := 1
								else
									l_tmp := 0
								end
							else
								l_tmp := 0
							end
							l_tmp___2 := l_tmp
						else
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline = 1 then
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill = ((create {P_DIFF_STATIC}).diff_check_fill ((create {P_GLOBALS_STATIC}).curwin.item, (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline)) then
									l_tmp___1 := 1
								else
									l_tmp___1 := 0
								end
							else
								l_tmp___1 := 0
							end
							l_tmp___2 := l_tmp___1
						end
						if l_tmp___2.to_boolean then
							(create {P_MISC1_STATIC}).beep_flush
							l_retval := 0
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 23 -- skip if block
						end
				when 3 then -- if:
						l_loff.item.fill := 0
						if a_dir___0 /= 1 then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if not (((create {P_GLOBALS_STATIC}).firstwin.item).is_equal ((create {P_GLOBALS_STATIC}).lastwin.item)) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (create {P_OPTION_STATIC}).p_window.item.item > 0 then
							if (create {P_OPTION_STATIC}).p_window.item.item < (create {P_GLOBALS_STATIC}).Rows.item.item - 1 then
								if (create {P_OPTION_STATIC}).p_window.item.item <= 2 then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline) + 1
								else
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline + ((create {P_OPTION_STATIC}).p_window.item.item - 2)
								end
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count
								end
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline
							else
								l_pos := -1 + 7 -- goto _L___0
							end
						else
							l_pos := -1 + 7 -- goto _L___0
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L___0:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := 0;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-18))
						else
							l_loff.item.lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline
							l_loff.item.fill := ((create {P_DIFF_STATIC}).diff_check_fill ((create {P_GLOBALS_STATIC}).curwin.item, l_loff.item.lnum)) - (create {P_GLOBALS_STATIC}).curwin.item.item.w_filler_rows
							get_scroll_overlap (l_loff, -1);
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := l_loff.item.lnum;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := l_loff.item.fill;
							((create {P_GLOBALS_STATIC}).curwin.item).item.check_topfill (0);
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-124))
						end
				when 8 then -- if done | if block done, skip else block:
						l_pos := -1 + 23
				when 9 then -- else:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline = 1 then
							max_topfill
							l_continue := True
						end
						if not (l_return or l_break or l_continue) and then (((create {P_GLOBALS_STATIC}).firstwin.item).is_equal ((create {P_GLOBALS_STATIC}).lastwin.item)) then
							if (create {P_OPTION_STATIC}).p_window.item.item > 0 then
								if (create {P_OPTION_STATIC}).p_window.item.item < (create {P_GLOBALS_STATIC}).Rows.item.item - 1 then
									if (create {P_OPTION_STATIC}).p_window.item.item <= 2 then
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline) - 1
									else
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline - ((create {P_OPTION_STATIC}).p_window.item.item - 2)
									end
									if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline < 1 then
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := (1).to_integer_32
									end
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline + (create {P_OPTION_STATIC}).p_window.item.item) - 1
									if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count
									end
									l_continue := True
								end
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 23 -- skip if block
						end
				when 10 then -- if:
						l_loff.item.lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline - 1
						l_loff.item.fill := ((create {P_DIFF_STATIC}).diff_check_fill ((create {P_GLOBALS_STATIC}).curwin.item, l_loff.item.lnum + 1)) - (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill
						get_scroll_overlap (l_loff, 1)
						if l_loff.item.lnum >= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
							l_loff.item.lnum := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count
							l_loff.item.fill := 0
						else
							l_loff.item.botline_topline
						end
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_loff.item.lnum
						l_n := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if l_n <= ((create {P_GLOBALS_STATIC}).curwin.item.item.w_height).to_integer_32 then
								if not (l_loff.item.lnum >= 1) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_loff.item.topline_back
								if (l_loff.item.height).to_integer_32 = 2_147_483_647 then
									l_n := 2_147_483_647
								else
									l_n := l_n + (l_loff.item.height).to_integer_32
								end
							end
						end
						l_break := False
						if not (l_loff.item.lnum < 1) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := (1).to_integer_32
						max_topfill;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-50))
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 13 then -- else:
						l_loff.item.topline_botline
						l_loff.item.botline_forw
						l_loff.item.botline_forw
						l_loff.item.botline_topline;
						(create {P_FOLD_STATIC}).hasFolding (l_loff.item.lnum, create {CE_INTEGER_32_POINTER}.make_shared (l_loff.item.c_pointer + (create {PD_LINEOFF_T}.make).offset_of ("lnum")), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)).do_nothing
						if not (l_loff.item.lnum >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline) then
							l_pos := -1 + 22 -- skip if block
						end
				when 14 then -- if:
						if not (l_loff.item.lnum > (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 18 -- goto _L___1
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 17 then -- else:
						if not (l_loff.item.fill >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if: | _L___1:
						l_loff.item.fill := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill < ((create {P_DIFF_STATIC}).diff_check_fill ((create {P_GLOBALS_STATIC}).curwin.item, (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline)) then
							max_topfill
						end
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill = l_loff.item.fill then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline) - 1;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := 0
						end
						((create {P_GLOBALS_STATIC}).curwin.item).item.comp_botline;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline - 1;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-28))
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := l_loff.item.lnum;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := l_loff.item.fill;
						((create {P_GLOBALS_STATIC}).curwin.item).item.check_topfill (0);
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-50))
				when 21 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := l_loff.item.lnum;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := l_loff.item.fill;
						((create {P_GLOBALS_STATIC}).curwin.item).item.check_topfill (0);
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-50))
				when 23 then -- if done | if done | if done | if done
						if (not l_return and not l_break) then
							l_count___2 := l_count___2 - 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 24 then -- loop done
						l_break := False
						l_continue := False;
						(create {P_FOLD_STATIC}).foldAdjustCursor
						cursor_correct
						if l_retval = 1 then
							(create {P_EDIT_STATIC}).beginline (6)
						end
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-8))
						if l_retval = 1 then
							if a_dir___0 = 1 then
								if (check_top_offset).to_boolean then
									scroll_cursor_top (1, 0)
									if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline <= l_old_topline___0 then
										if l_old_topline___0 < (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
											(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := l_old_topline___0 + 1;
											(create {P_FOLD_STATIC}).hasFolding ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline, create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_topline")), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)).do_nothing
										end
									end
								end
							end
						end
						(create {P_SCREEN_STATIC}).redraw_later (10)
						Result := l_retval
				when 25 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_scroll_overlap (a_lp: CE_POINTER [PD_LINEOFF_T]; a_dir___0: INTEGER_32)
		require
			not a_lp.is_void
		local
			l_h1: INTEGER_32
			l_h2: INTEGER_32
			l_h3: INTEGER_32
			l_h4: INTEGER_32
			l_min_height: INTEGER_32
			l_loff0: PD_LINEOFF_T
			l_loff1: PD_LINEOFF_T
			l_loff2: PD_LINEOFF_T
			l_return: BOOLEAN
		do
			l_min_height := (create {P_GLOBALS_STATIC}).curwin.item.item.w_height - 2
			if a_lp.item.fill > 0 then
				a_lp.item.height := 1
			else
				a_lp.item.height := (create {P_MISC1_STATIC}).plines_nofill (a_lp.item.lnum)
			end
			l_h1 := a_lp.item.height
			if l_h1 > l_min_height then
				l_return := True
			end
			if not l_return then
				l_loff0 := (a_lp.item).twin
				if a_dir___0 > 0 then
					a_lp.item.botline_forw
				else
					a_lp.item.topline_back
				end
				l_h2 := a_lp.item.height
				if l_h2 + l_h1 > l_min_height then
					a_lp.item := l_loff0.twin
					l_return := True
				end
			end
			if not l_return then
				l_loff1 := (a_lp.item).twin
				if a_dir___0 > 0 then
					a_lp.item.botline_forw
				else
					a_lp.item.topline_back
				end
				l_h3 := a_lp.item.height
				if l_h3 + l_h2 > l_min_height then
					a_lp.item := l_loff0.twin
					l_return := True
				end
			end
			if not l_return then
				l_loff2 := (a_lp.item).twin
				if a_dir___0 > 0 then
					a_lp.item.botline_forw
				else
					a_lp.item.topline_back
				end
				l_h4 := a_lp.item.height
				if (l_h4 + l_h3) + l_h2 > l_min_height then
					a_lp.item := l_loff1.twin
				elseif (l_h3 + l_h2) + l_h1 > l_min_height then
					a_lp.item := l_loff1.twin
				else
					a_lp.item := l_loff2.twin
				end
			end
		end

	do_check_cursorbind
		local
			l_line: INTEGER_32
			l_col: INTEGER_32
			l_old_curwin___1: CE_POINTER [PD_WINDOW_S]
			l_old_curbuf: CE_POINTER [PD_FILE_BUFFER]
			l_old_VIsual_select: INTEGER_32
			l_old_VIsual_active: INTEGER_32
		do
			l_line := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
			l_col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
			l_old_curwin___1 := (create {P_GLOBALS_STATIC}).curwin.item
			l_old_curbuf := (create {P_GLOBALS_STATIC}).curbuf.item
			l_old_VIsual_select := (create {P_GLOBALS_STATIC}).VIsual_select.item
			l_old_VIsual_active := (create {P_GLOBALS_STATIC}).VIsual_active.item;
			(create {P_GLOBALS_STATIC}).VIsual_active.item := 0;
			(create {P_GLOBALS_STATIC}).VIsual_select.item := (create {P_GLOBALS_STATIC}).VIsual_active.item;
			(create {P_GLOBALS_STATIC}).curwin.item := (create {P_GLOBALS_STATIC}).firstwin.item
			from
			until
				((create {P_GLOBALS_STATIC}).curwin.item).is_void
			loop
				(create {P_GLOBALS_STATIC}).curbuf.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer
				if not ((create {P_GLOBALS_STATIC}).curwin.item).is_equal (l_old_curwin___1) then
					if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_crb).to_boolean then
						if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_diff).to_boolean then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (create {P_DIFF_STATIC}).diff_get_corresponding_line (l_old_curbuf, l_line, (create {P_GLOBALS_STATIC}).curbuf.item, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)
						else
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_line
						end
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_col;
						(create {P_MISC2_STATIC}).check_cursor
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							(create {P_MBYTE_STATIC}).mb_adjust_cursor
						end
						(create {P_SCREEN_STATIC}).redraw_later (10)
						update_topline;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_redr_status := 1
					end
				end
				(create {P_GLOBALS_STATIC}).curwin.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_next
			end
			(create {P_GLOBALS_STATIC}).VIsual_select.item := l_old_VIsual_select;
			(create {P_GLOBALS_STATIC}).VIsual_active.item := l_old_VIsual_active;
			(create {P_GLOBALS_STATIC}).curwin.item := l_old_curwin___1;
			(create {P_GLOBALS_STATIC}).curbuf.item := l_old_curbuf
		end

end
