class
	P_NETBEANS_STATIC

inherit
	CE_UTILITIES
	S_GDK_GDK_STATIC
	S_UNISTD_STATIC
	S_STDLIB_STATIC
	S_STRING_STATIC
	S_SYS_SOCKET_STATIC
	S_BITS_ERRNO_STATIC
	S_NETINET_IN_STATIC
	S_NETDB_STATIC
	S_FCNTL_STATIC
	S_LIBINTL_STATIC
	S_STDIO_STATIC
	S_SYS_STAT_STATIC
	S_SYS_SELECT_STATIC
	S_GTK_GTK_STATIC
	VIM_ASSEMBLER

feature {ANY} -- public attributes

	ExtEdProtocolVersion: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("2.5")
		end

	nbsock: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					-1
				>>)
		end

	inputHandler: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	r_cmdno: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	dosetvisible: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	needupdate: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	inAtomic: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	keyHead: CE_STATIC [CE_ARRAY [PD_KEYQUEUE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_KEYQUEUE]}.make (<<1>>)
		end

	head: CE_STATIC [CE_ARRAY [PD_CMDQUEUE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CMDQUEUE]}.make (<<1>>)
		end

	buf___4: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	buf_list: CE_STATIC [CE_POINTER [PD_NBBUF_STRUCT]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_NBBUF_STRUCT]}.make_shared (default_pointer)
		end

	buf_list_size: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	buf_list_used: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	curPCtype: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	buf___5: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<128>>)
		end

	did_error: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	skip: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	text___1: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
		end

	guardId: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 1_000_000
		end

	did_init: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	netbeans_close
		local
			l_return: BOOLEAN
		do
			if nbsock.item.item = -1 then
				l_return := True
			end
			if not l_return then
				netbeans_send_disconnect
				if inputHandler.item /= 0 then
					gdk_input_remove (inputHandler.item)
					inputHandler.item := 0
				end
				(create {P_GLOBALS_STATIC}).bevalServers.item := ((create {P_GLOBALS_STATIC}).bevalServers.item).bit_and ((-2))
				close (nbsock.item.item).do_nothing
				nbsock.item.item := -1
				needupdate.item := 0
				inAtomic.item := 0
				nb_free
				coloncmd ([ce_string (":sign unplace *")]);
				(create {P_MOVE_STATIC}).changed_window_setting;
				(create {P_SCREEN_STATIC}).update_screen (50);
				(create {P_SCREEN_STATIC}).setcursor;
				(create {P_TERM_STATIC}).out_flush
				if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
					(create {P_GUI_STATIC}).gui_update_cursor (1, 0);
					(create {P_GUI_GTK_X11_STATIC}).gui_mch_flush
				end
			end
		end

	netbeans_connect (a_params: CE_POINTER [INTEGER_8]; a_doabort: INTEGER_32): INTEGER_32
		require
			not a_params.is_void
		local
			l_server: CE_ARRAY [SD_SOCKADDR_IN]
			l_host: CE_POINTER [SD_HOSTENT]
			l_port: INTEGER_32
			l_sd: INTEGER_32
			l_buf___6: CE_ARRAY [INTEGER_8]
			l_hostname: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_address: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_password: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_fname: CE_POINTER [INTEGER_8]
			l_arg: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_retries: INTEGER_32
			l_success___0: INTEGER_32
			l_tmp___20: INTEGER_32
			l_tmp___24: CE_POINTER [INTEGER_8]
			l_tmp___28: CE_POINTER [INTEGER_8]
			l_tmp___32: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_SOCKADDR_IN]} l_server.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_buf___6.make (<<32>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_hostname.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_address.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_password.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_hostname.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_address.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_password.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_arg := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					if (a_params[0]).to_integer_32 /= 61 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (getConnInfo (a_params + 1, l_hostname, l_address, l_password)) = 0 then
							Result := 0
							l_return := True
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if (a_params[0]).to_integer_32 = 58 then
							l_arg := a_params + 1
						end
						if not (l_arg.is_void) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_fname := getenv (ce_string ("__NETBEANS_CONINFO"))
						if not l_fname.is_void then
							if (getConnInfo (l_fname, l_hostname, l_address, l_password)) = 0 then
								Result := 0
								l_return := True
							end
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if not l_arg.is_void then
							l_hostname.item := l_arg
							l_address.item := strchr (l_hostname.item, (':').code)
							if not (l_address.item).is_void then
								l_tmp___1 := l_address.item
								l_address.item := l_address.item + 1
								l_tmp___1[0] := (('%/0/').code).to_integer_8
								l_password.item := strchr (l_address.item, (':').code)
								if not (l_password.item).is_void then
									l_tmp___2 := l_password.item
									l_password.item := l_password.item + 1
									l_tmp___2[0] := (('%/0/').code).to_integer_8
								end
							end
						end
						if (l_hostname.item).is_void then
							l_hostname.item := getenv (ce_string ("__NETBEANS_HOST"))
						elseif (l_hostname.item[0]).to_integer_32 = 0 then
							l_hostname.item := getenv (ce_string ("__NETBEANS_HOST"))
						end
						if (l_address.item).is_void then
							l_address.item := getenv (ce_string ("__NETBEANS_SOCKET"))
						end
						if (l_password.item).is_void then
							l_password.item := getenv (ce_string ("__NETBEANS_VIM_PASSWORD"))
						end
						if not (l_hostname.item).is_void then
							l_hostname.item := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (l_hostname.item))))
						end
						if not (l_address.item).is_void then
							l_address.item := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (l_address.item))))
						end
						if not (l_password.item).is_void then
							l_password.item := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (l_password.item))))
						end
				when 7 then -- if done
					if l_return then
						l_pos := -1 + 21 -- skip if block
					end
				when 8 then -- if:
						if (l_hostname.item).is_void then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_hostname.item))
							l_tmp___6 := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("localhost")))
							l_hostname.item := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___6)
						elseif (l_hostname.item[0]).to_integer_32 = 0 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_hostname.item))
							l_tmp___6 := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("localhost")))
							l_hostname.item := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___6)
						end
						if (l_address.item).is_void then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_address.item))
							l_tmp___7 := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("3219")))
							l_address.item := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___7)
						elseif (l_address.item[0]).to_integer_32 = 0 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_address.item))
							l_tmp___7 := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("3219")))
							l_address.item := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___7)
						end
						if (l_password.item).is_void then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_password.item))
							l_tmp___8 := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("changeme")))
							l_password.item := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___8)
						elseif (l_password.item[0]).to_integer_32 = 0 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_password.item))
							l_tmp___8 := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("changeme")))
							l_password.item := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___8)
						end
						if (l_hostname.item).is_void then
							l_pos := -1 + 20 -- goto theend
						elseif (l_address.item).is_void then
							l_pos := -1 + 20 -- goto theend
						elseif (l_password.item).is_void then
							l_pos := -1 + 20 -- goto theend
						end
				when 9 then
						l_port := atoi (l_address.item)
						l_sd := (socket (2, 1, 0))
						if l_sd = -1 then
							(create {P_MISC2_STATIC}).emsg3 (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%%s: %%s")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("socket() in netbeans_connect()")), create {CE_NATURAL_8_POINTER}.make_cast ((strerror ((errno_location).item)))).do_nothing
							l_pos := -1 + 20 -- goto theend
						end
				when 10 then
						memset (create {CE_VOID_POINTER}.make_cast (l_server), ('%/0/').code, (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32).do_nothing
						l_server.item.sin_family := (2).to_natural_16
						l_server.item.sin_port := htons (l_port.to_natural_16)
						l_host := gethostbyname (l_hostname.item)
						if not (l_host.is_void) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if (access (l_hostname.item, 4)) >= 0 then
							l_sd := open ([l_hostname.item, 0, 0])
							l_pos := -1 + 20 -- goto theend
						end
				when 12 then;
						(create {P_MISC2_STATIC}).emsg3 (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%%s: %%s")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("gethostbyname() in netbeans_connect()")), create {CE_NATURAL_8_POINTER}.make_cast ((strerror ((errno_location).item)))).do_nothing
						l_pos := -1 + 20 -- goto theend
				when 13 then
						memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_IN_ADDR]}.make_shared (l_server.item.c_pointer + (create {SD_SOCKADDR_IN}.make).offset_of ("sin_addr")))), create {CE_VOID_POINTER}.make_cast (l_host.item.h_addr_list[0]), (l_host.item.h_length).to_natural_32).do_nothing
						if not ((connect (l_sd, create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (l_server), (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32)).to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if:
						if (errno_location).item /= 111 then
							l_pos := -1 + 18 -- skip if block
						end
				when 15 then -- if:
						close (l_sd).do_nothing
						l_sd := (socket (2, 1, 0))
						if l_sd = -1 then
							(create {P_MISC2_STATIC}).emsg3 (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%%s: %%s")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("socket()#2 in netbeans_connect()")), create {CE_NATURAL_8_POINTER}.make_cast ((strerror ((errno_location).item)))).do_nothing
							l_pos := -1 + 20 -- goto theend
						end
				when 16 then
						if (connect (l_sd, create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (l_server), (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32)).to_boolean then
							l_retries := 36
							l_success___0 := 0
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___20 := l_retries
								l_retries := l_retries - 1
								if l_tmp___20.to_boolean then
									if (errno_location).item /= 111 then
										if (errno_location).item /= 4 then
											l_break := True
										end
									end
								else
									l_break := True
								end
								if not (l_break) then
									sleep ({NATURAL_32} 5).do_nothing
									if not a_doabort.to_boolean then
										(create {P_UI_STATIC}).ui_breakcheck
										if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
											(errno_location).item := 4
											l_break := True
										end
									end
								end
								if not (l_break) then
									if (connect (l_sd, create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (l_server), (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32)) = 0 then
										l_success___0 := 1
										l_break := True
									end
								end
							end
							l_break := False
							if not l_success___0.to_boolean then
								l_tmp___24 := strerror ((errno_location).item);
								(create {P_MISC2_STATIC}).emsg3 (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%%s: %%s")), create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Cannot connect to Netbeans #2")))), create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___24)).do_nothing
								if a_doabort.to_boolean then
									(create {P_MAIN_STATIC}).getout (1)
								end
								l_pos := -1 + 20 -- goto theend
							end
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						l_tmp___28 := strerror ((errno_location).item);
						(create {P_MISC2_STATIC}).emsg3 (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%%s: %%s")), create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Cannot connect to Netbeans")))), create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___28)).do_nothing
						if a_doabort.to_boolean then
							(create {P_MAIN_STATIC}).getout (1)
						end
						l_pos := -1 + 20 -- goto theend
				when 19 then -- if done
						nbsock.item.item := l_sd;
						(create {P_MESSAGE_STATIC}).vim_snprintf ([l_buf___6, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (32).to_natural_32), ce_string ("AUTH %%s%N"), l_password.item]).do_nothing
						nb_send (l_buf___6, ce_string ("netbeans_connect"))
						sprintf ([l_buf___6, ce_string ("0:version=0 %"%%s%"%N"), ExtEdProtocolVersion.item]).do_nothing
						nb_send (l_buf___6, ce_string ("externaleditor_version"))
				when 20 then -- theend:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_hostname.item));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_address.item));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_password.item))
						if nbsock.item.item /= -1 then
							l_tmp___32 := 1
						else
							l_tmp___32 := 0
						end
						Result := l_tmp___32
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	getConnInfo (a_file: CE_POINTER [INTEGER_8]; a_host, a_port, a_auth: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		require
			not a_file.is_void
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_lp: CE_POINTER [NATURAL_8]
			l_nl: CE_POINTER [NATURAL_8]
			l_st: CE_ARRAY [SD_STAT]
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<8_192>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)

			if (stat (a_file, l_st)) = 0 then
				if ((l_st.item.st_mode).bit_and ({NATURAL_32} 63)) /= {NATURAL_32} 0 then
					(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E668: Wrong access mode for NetBeans connection info file: %"%%s%"")))), create {CE_NATURAL_8_POINTER}.make_cast (a_file)).do_nothing
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_fp := fopen (a_file, ce_string ("r"))
				if l_fp.is_void then
					(create {P_MISC2_STATIC}).emsg3 (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%%s: %%s")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E660: Cannot open NetBeans connection info file")), create {CE_NATURAL_8_POINTER}.make_cast ((strerror ((errno_location).item)))).do_nothing
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					l_lp := create {CE_NATURAL_8_POINTER}.make_cast ((fgets (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), 8_192, l_fp)))
					if l_lp.is_void then
						l_break := True
					end
					if not (l_break) then
						l_nl := (create {P_MISC2_STATIC}).vim_strchr (l_lp, ('%N').code)
						if not l_nl.is_void then
							l_nl.item := (0).to_natural_8
						end
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_lp), ce_string ("host="), (5).to_natural_32)) = 0 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_host.item))
							a_host.item := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MISC2_STATIC}).vim_strsave (l_buf___6 + 5)))
						elseif (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_lp), ce_string ("port="), (5).to_natural_32)) = 0 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_port.item))
							a_port.item := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MISC2_STATIC}).vim_strsave (l_buf___6 + 5)))
						elseif (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_lp), ce_string ("auth="), (5).to_natural_32)) = 0 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_auth.item))
							a_auth.item := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MISC2_STATIC}).vim_strsave (l_buf___6 + 5)))
						end
					end
				end
				l_break := False
				fclose (l_fp).do_nothing
				Result := 1
			end
		end

	postpone_keycommand (a_keystr: CE_POINTER [NATURAL_8])
		local
			l_node: CE_POINTER [PD_KEYQUEUE]
			l_return: BOOLEAN
		do
			l_node := create {CE_CLASS_POINTER [PD_KEYQUEUE]}.make_cast (((create {P_MISC2_STATIC}).alloc ((create {PD_KEYQUEUE}.make).structure_size.to_natural_32)))
			if l_node.is_void then
				l_return := True
			end
			if not l_return then
				if (keyHead.item.item.next).is_void then
					keyHead.item.item.next := keyHead.item
					keyHead.item.item.prev := keyHead.item
				end
				l_node.item.next := keyHead.item
				l_node.item.prev := keyHead.item.item.prev;
				(keyHead.item.item.prev).item.next := l_node
				keyHead.item.item.prev := l_node
				l_node.item.keystr := (create {P_MISC2_STATIC}).vim_strsave (a_keystr)
			end
		end

	handle_key_queue
		local
			l_postponed: INTEGER_32
			l_node: CE_POINTER [PD_KEYQUEUE]
			l_tmp___0: INTEGER_32
			l_break: BOOLEAN
		do
			l_postponed := 0
			from
			until
				(l_break)
			loop
				l_break := False
				if not l_postponed.to_boolean then
					if (not (keyHead.item.item.next).is_void) then
						if (keyHead.item.item.next).is_equal (keyHead.item) then
							l_break := True
						end
					else
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_node := keyHead.item.item.next
					keyHead.item.item.next := l_node.item.next;
					(l_node.item.next).item.prev := l_node.item.prev
					if not (l_node.item.keystr).is_void then
						if (netbeans_keystring (l_node.item.keystr)).to_boolean then
							l_tmp___0 := 0
						else
							l_tmp___0 := 1
						end
						l_postponed := l_tmp___0
					end
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_node.item.keystr));
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_node))
				end
			end
			l_break := False
		end

	save (a_buf___6: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_node: CE_POINTER [PD_CMDQUEUE]
			l_return: BOOLEAN
		do
			l_node := create {CE_CLASS_POINTER [PD_CMDQUEUE]}.make_cast (((create {P_MISC2_STATIC}).alloc ((create {PD_CMDQUEUE}.make).structure_size.to_natural_32)))
			if l_node.is_void then
				l_return := True
			end
			if not l_return then
				l_node.item.buffer := (create {P_MISC2_STATIC}).alloc ((a_len + 1).to_natural_32)
				if (l_node.item.buffer).is_void then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_node))
					l_return := True
				end
			end
			if not l_return then
				memmove (create {CE_VOID_POINTER}.make_cast (l_node.item.buffer), create {CE_VOID_POINTER}.make_cast (a_buf___6), a_len.to_natural_32).do_nothing
				l_node.item.buffer[a_len] := (('%/0/').code).to_natural_8
				if (head.item.item.next).is_void then
					head.item.item.next := head.item
					head.item.item.prev := head.item
				end
				l_node.item.next := head.item
				l_node.item.prev := head.item.item.prev;
				(head.item.item.prev).item.next := l_node
				head.item.item.prev := l_node
			end
		end

	netbeans_parse_messages
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_node: CE_POINTER [PD_CMDQUEUE]
			l_tmp: NATURAL_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			if nbsock.item.item = -1 then
				l_return := True
			end
			if not l_return then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if not (head.item.item.next).is_void then
						if (head.item.item.next).is_equal (head.item) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_return or l_break) then
						l_node := head.item.item.next
						l_p___0 := (create {P_MISC2_STATIC}).vim_strchr (l_node.item.buffer, ('%N').code)
						if l_p___0.is_void then
							if (l_node.item.next).is_equal (head.item) then
								l_return := True
							end
							if not l_return then
								l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_node.item.buffer))
								l_p___0 := (create {P_MISC2_STATIC}).alloc ((l_tmp + (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_node.item.next).item.buffer)))) + {NATURAL_32} 1)
								if l_p___0.is_void then
									l_return := True
								end
							end
							if not l_return then
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), create {CE_INTEGER_8_POINTER}.make_cast (l_node.item.buffer)).do_nothing
								strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), create {CE_INTEGER_8_POINTER}.make_cast ((l_node.item.next).item.buffer)).do_nothing;
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((l_node.item.next).item.buffer));
								(l_node.item.next).item.buffer := l_p___0
								head.item.item.next := l_node.item.next;
								(l_node.item.next).item.prev := l_node.item.prev;
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_node.item.buffer));
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_node))
							end
						else
							l_tmp___1 := l_p___0
							l_p___0 := l_p___0 + 1
							l_tmp___1.item := (('%/0/').code).to_natural_8
							if (l_p___0.item).to_integer_32 = 0 then
								head.item.item.next := l_node.item.next;
								(l_node.item.next).item.prev := l_node.item.prev
							end
							nb_parse_cmd (l_node.item.buffer)
							if (l_p___0.item).to_integer_32 = 0 then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_node.item.buffer));
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_node))
							else
								memmove (create {CE_VOID_POINTER}.make_cast (l_node.item.buffer), create {CE_VOID_POINTER}.make_cast (l_p___0), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))) + {NATURAL_32} 1).do_nothing
							end
						end
					end
				end
			end
			if not l_return then
				l_break := False
			end
		end

	messageFromNetbeans (a_clientData: CE_POINTER [ANY]; a_unused1: INTEGER_32; a_unused2: NATURAL_32)
		do
			netbeans_read
		end

	netbeans_read
		local
			l_len: INTEGER_32
			l_readlen: INTEGER_32
			l_tval: CE_ARRAY [SD_TIMEVAL]
			l_rfds: CE_ARRAY [SD_FD_SET]
			l___d0: CE_ARRAY [INTEGER_32]
			l___d1: CE_ARRAY [INTEGER_32]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_tval.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_FD_SET]} l_rfds.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l___d0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l___d1.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := 0
					l_readlen := 0
					if nbsock.item.item = -1 then
						l_return := True
					end
					if not l_return and then (buf___4.item.is_void) then
						buf___4.item := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 4_096)
						if buf___4.item.is_void then
							l_return := True
						end
					end
					if not l_return then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								asm15 (l___d0, l___d1, l_rfds)
								l_break := True
							end
							l_break := False
							asm16 (l_rfds, nbsock.item)
							l_tval.item.tv_sec := (0).to_integer_32
							l_tval.item.tv_usec := (0).to_integer_32
							if (select2 (nbsock.item.item + 1, l_rfds, create {CE_CLASS_POINTER [SD_FD_SET]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_FD_SET]}.make_shared (default_pointer), l_tval)) <= 0 then
								l_break := True
							end
							if not (l_return or l_break) then
								l_len := read (nbsock.item.item, create {CE_VOID_POINTER}.make_cast (buf___4.item), (4_096).to_natural_32)
								if l_len <= 0 then
									l_break := True
								end
							end
							if not (l_return or l_break) then
								save (buf___4.item, l_len)
								l_readlen := l_readlen + l_len
								if l_len < 4_096 then
									l_break := True
								end
							end
						end
						l_break := False
						if l_readlen <= 0 then
							netbeans_close
							if l_len < 0 then
								l_tmp___1 := strerror ((errno_location).item);
								(create {P_MISC2_STATIC}).emsg3 (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%%s: %%s")), create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("read from Netbeans socket")))), create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)).do_nothing
							end
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (((create {P_GUI_STATIC}).gui.item.item.starting).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if (gtk_main_level) > {NATURAL_32} 0 then
							gtk_main_quit
						end
				when 6 then -- if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	nb_parse_cmd (a_cmd: CE_POINTER [NATURAL_8])
		local
			l_verb: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_q: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_bufno: INTEGER_32
			l_isfunc: INTEGER_32
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___6: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_verb.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_q.make (<<1>>)

			l_isfunc := -1
			if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("DISCONNECT"))) = 0 then
				netbeans_close;
				(create {P_MAIN_STATIC}).getout (0)
			end
			if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("DETACH"))) = 0 then
				netbeans_close
				l_return := True
			end
			if not l_return then
				l_bufno := (strtol (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), l_verb, 10)).to_integer_32
				if (l_verb.item[0]).to_integer_32 /= 58 then
					(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E627: missing colon: %%s")), a_cmd).do_nothing
					l_return := True
				end
			end
			if not l_return then
				l_verb.item := l_verb.item + 1
				l_q.item := l_verb.item
				from
				until
					not (not (l_break) and then ((l_q.item[0]).to_boolean))
				loop
					l_break := False
					if (l_q.item[0]).to_integer_32 = 33 then
						l_tmp___2 := l_q.item
						l_q.item := l_q.item + 1
						l_tmp___2[0] := (('%/0/').code).to_integer_8
						l_isfunc := 0
						l_break := True
					elseif (l_q.item[0]).to_integer_32 = 47 then
						l_tmp___3 := l_q.item
						l_q.item := l_q.item + 1
						l_tmp___3[0] := (('%/0/').code).to_integer_8
						l_isfunc := 1
						l_break := True
					end
					if not (l_break) then
						l_q.item := l_q.item + 1
					end
				end
				l_break := False
				if l_isfunc < 0 then
					(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E628: missing ! or / in: %%s")), a_cmd).do_nothing
					l_return := True
				end
			end
			if not l_return then
				r_cmdno.item := (strtol (l_q.item, l_q, 10)).to_integer_32
				l_q.item := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_CHARSET_STATIC}).skipwhite (create {CE_NATURAL_8_POINTER}.make_cast (l_q.item))))
				l_tmp___6 := nb_do_cmd (l_bufno, create {CE_NATURAL_8_POINTER}.make_cast (l_verb.item), l_isfunc, r_cmdno.item, create {CE_NATURAL_8_POINTER}.make_cast (l_q.item))
			end
		end

	nb_free
		local
			l_key_node: CE_POINTER [PD_KEYQUEUE]
			l_cmd_node: CE_POINTER [PD_CMDQUEUE]
			l_buf___6: PD_NBBUF_STRUCT
			l_bufp: CE_POINTER [PD_FILE_BUFFER]
			l_i___0: INTEGER_32
			l_next: CE_POINTER [PD_KEYQUEUE]
			l_next___0: CE_POINTER [PD_CMDQUEUE]
			l_break: BOOLEAN
		do
			create {CE_CLASS_POINTER [PD_KEYQUEUE]} l_next.make
			create {CE_CLASS_POINTER [PD_CMDQUEUE]} l_next___0.make

			l_key_node := keyHead.item.item.next
			l_cmd_node := head.item.item.next
			l_i___0 := 0
			from
			until
				not (l_i___0 < buf_list_used.item)
			loop
				l_buf___6 := (buf_list.item[l_i___0]).twin;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6.displayname));
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6.signmap))
				l_bufp := l_buf___6.bufp
				if not l_bufp.is_void then
					(l_buf___6.bufp).item.b_netbeans_file := 0;
					(l_buf___6.bufp).item.b_was_netbeans_file := 0
				end
				l_i___0 := l_i___0 + 1
			end
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (buf_list.item))
			buf_list.item := create {CE_CLASS_POINTER [PD_NBBUF_STRUCT]}.make_shared (default_pointer)
			buf_list_size.item := 0
			buf_list_used.item := 0
			from
			until
				(l_break)
			loop
				l_break := False
				if not l_key_node.is_void then
					if l_key_node.is_equal (keyHead.item) then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_next := l_key_node.item.next;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_key_node.item.keystr));
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_key_node))
					if l_next.is_equal (keyHead.item) then
						keyHead.item.item.next := keyHead.item
						keyHead.item.item.prev := keyHead.item
						l_break := True
					end
				end
				if not (l_break) then
					l_key_node := l_next
				end
			end
			l_break := False
			from
			until
				(l_break)
			loop
				l_break := False
				if not l_cmd_node.is_void then
					if l_cmd_node.is_equal (head.item) then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_next___0 := l_cmd_node.item.next;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_cmd_node.item.buffer));
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_cmd_node))
					if l_next___0.is_equal (head.item) then
						head.item.item.next := head.item
						head.item.item.prev := head.item
						l_break := True
					end
				end
				if not (l_break) then
					l_cmd_node := l_next___0
				end
			end
			l_break := False
		end

	nb_getbufno (a_bufp: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_return: BOOLEAN
		do
			l_i___0 := 0
			from
			until
				not (not (l_return) and then (l_i___0 < buf_list_used.item))
			loop
				if ((buf_list.item + l_i___0).item.bufp).is_equal (a_bufp) then
					Result := l_i___0
					l_return := True
				end
				if not l_return then
					l_i___0 := l_i___0 + 1
				end
			end
			if not l_return then
				Result := (-1)
			end
		end

	isNetbeansBuffer (a_bufp: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if nbsock.item.item /= -1 then
				if (a_bufp.item.b_netbeans_file).to_boolean then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	isNetbeansModified (a_bufp: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			l_bufno: INTEGER_32
		do
			if (isNetbeansBuffer (a_bufp)).to_boolean then
				l_bufno := (nb_getbufno (a_bufp))
				if l_bufno > 0 then
					Result := ((buf_list.item + l_bufno).item.modified).to_integer_32
				else
					Result := 0
				end
			else
				Result := 0
			end
		end

	nb_get_buf (a_bufno: INTEGER_32): CE_POINTER [PD_NBBUF_STRUCT]
		local
			l_incr: INTEGER_32
			l_return: BOOLEAN
		do
			if a_bufno <= 0 then
				Result := (create {CE_CLASS_POINTER [PD_NBBUF_STRUCT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				if buf_list.item.is_void then
					buf_list.item := create {CE_CLASS_POINTER [PD_NBBUF_STRUCT]}.make_cast (((create {P_MISC2_STATIC}).alloc_clear ({NATURAL_32} 100 * (create {PD_NBBUF_STRUCT}.make).structure_size.to_natural_32)))
					buf_list_size.item := 100
				end
				if a_bufno >= buf_list_used.item then
					if a_bufno >= buf_list_size.item then
						l_incr := (a_bufno - buf_list_size.item) + 90
						buf_list_size.item := buf_list_size.item + l_incr
						buf_list.item := create {CE_CLASS_POINTER [PD_NBBUF_STRUCT]}.make_cast ((realloc (create {CE_VOID_POINTER}.make_cast (buf_list.item), buf_list_size.item.to_natural_32 * (create {PD_NBBUF_STRUCT}.make).structure_size.to_natural_32)))
						memset (create {CE_VOID_POINTER}.make_cast (((buf_list.item + buf_list_size.item) - l_incr)), 0, l_incr.to_natural_32 * (create {PD_NBBUF_STRUCT}.make).structure_size.to_natural_32).do_nothing
					end
					from
					until
						not (buf_list_used.item <= a_bufno)
					loop
						(buf_list.item + buf_list_used.item).item.fireChanges := {NATURAL_32} 1
						buf_list_used.item := buf_list_used.item + 1
					end
				end
				Result := (buf_list.item + a_bufno)
			end
		end

	count_changed_buffers: INTEGER_32
		local
			l_bufp: CE_POINTER [PD_FILE_BUFFER]
			l_n: INTEGER_32
		do
			l_n := 0
			l_bufp := (create {P_GLOBALS_STATIC}).firstbuf.item
			from
			until
				l_bufp.is_void
			loop
				if (l_bufp.item.b_changed).to_boolean then
					l_n := l_n + 1
				end
				l_bufp := l_bufp.item.b_next
			end
			Result := l_n
		end

	netbeans_end
		local
			l_i___0: INTEGER_32
			l_return, l_continue: BOOLEAN
		do
			if nbsock.item.item = -1 then
				l_return := True
			end
			if not l_return then
				l_i___0 := 0
				from
				until
					not (l_i___0 < buf_list_used.item)
				loop
					l_continue := False
					if ((buf_list.item + l_i___0).item.bufp).is_void then
						l_continue := True
					end
					if not (l_continue) then
						if ((create {P_GLOBALS_STATIC}).netbeansForcedQuit.item).to_boolean then
							sprintf ([buf___5.item, ce_string ("%%d:unmodified=%%d%N"), l_i___0, r_cmdno.item]).do_nothing
							nb_send (buf___5.item, ce_string ("netbeans_end"))
						end
						sprintf ([buf___5.item, ce_string ("%%d:killed=%%d%N"), l_i___0, r_cmdno.item]).do_nothing;
						(create {P_GLOBALS_STATIC}).ignored.item := write (nbsock.item.item, create {CE_VOID_POINTER}.make_cast (buf___5.item), ((strlen (buf___5.item)).to_integer_32).to_natural_32)
					end
					l_i___0 := l_i___0 + 1
				end
				l_continue := False
			end
		end

	nb_send (a_buf___6, a_fun: CE_POINTER [INTEGER_8])
		local
			l_tmp___0: INTEGER_32
		do
			if nbsock.item.item = -1 then
				if not did_error.item.to_boolean then
					(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E630: %%s(): write while not connected")), create {CE_NATURAL_8_POINTER}.make_cast (a_fun)).do_nothing
				end
				did_error.item := 1
			else
				l_tmp___0 := write (nbsock.item.item, create {CE_VOID_POINTER}.make_cast (a_buf___6), ((strlen (a_buf___6)).to_integer_32).to_natural_32)
				if l_tmp___0 /= (strlen (a_buf___6)).to_integer_32 then
					if not did_error.item.to_boolean then
						(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E631: %%s(): write failed")), create {CE_NATURAL_8_POINTER}.make_cast (a_fun)).do_nothing
					end
					did_error.item := 1
				else
					did_error.item := 0
				end
			end
		end

	nb_reply_nil (a_cmdno: INTEGER_32)
		local
			l_reply: CE_ARRAY [INTEGER_8]
		do
			create {CE_INTEGER_8_ARRAY} l_reply.make (<<32>>)

			sprintf ([l_reply, ce_string ("%%d%N"), a_cmdno]).do_nothing
			nb_send (l_reply, ce_string ("nb_reply_nil"))
		end

	nb_reply_text (a_cmdno: INTEGER_32; a_result___2: CE_POINTER [NATURAL_8])
		local
			l_reply: CE_POINTER [NATURAL_8]
		do
			l_reply := (create {P_MISC2_STATIC}).alloc ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_result___2))) + {NATURAL_32} 32)
			sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_reply), ce_string ("%%d %%s%N"), a_cmdno, create {CE_INTEGER_8_POINTER}.make_cast (a_result___2)]).do_nothing
			nb_send (create {CE_INTEGER_8_POINTER}.make_cast (l_reply), ce_string ("nb_reply_text"));
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_reply))
		end

	nb_reply_nr (a_cmdno: INTEGER_32; a_result___2: INTEGER_32)
		local
			l_reply: CE_ARRAY [INTEGER_8]
		do
			create {CE_INTEGER_8_ARRAY} l_reply.make (<<32>>)

			sprintf ([l_reply, ce_string ("%%d %%ld%N"), a_cmdno, a_result___2]).do_nothing
			nb_send (l_reply, ce_string ("nb_reply_nr"))
		end

	nb_quote (a_txt: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_buf___6: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_q: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buf___6 := ((create {P_MISC2_STATIC}).alloc ({NATURAL_32} 2 * (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_txt))) + {NATURAL_32} 1))
					l_p___0 := a_txt
					l_q := l_buf___6
					if l_buf___6.is_void then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if not ((l_p___0.item).to_boolean) then
							l_pos := -1 + 8 -- skip loop
						end
				when 2 then -- loop body:
						inspect (l_p___0.item).to_integer_32 -- switch 1 head
						when 34 then l_pos := -1 + 3
						when 92 then l_pos := -1 + 3
						when 10 then l_pos := -1 + 4
						when 13 then l_pos := -1 + 5
						else l_pos := -1 + 6
						end
				when 3 then -- switch 1, case 34 | switch 1, case 92
						l_tmp___1 := l_q
						l_q := l_q + 1
						l_tmp___1.item := (('\').code).to_natural_8
						l_tmp___2 := l_q
						l_q := l_q + 1
						l_tmp___2.item := l_p___0.item
						l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 10
						l_tmp___3 := l_q
						l_q := l_q + 1
						l_tmp___3.item := (('\').code).to_natural_8
						l_tmp___4 := l_q
						l_q := l_q + 1
						l_tmp___4.item := (('n').code).to_natural_8
						l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 13
						l_tmp___5 := l_q
						l_q := l_q + 1
						l_tmp___5.item := (('\').code).to_natural_8
						l_tmp___6 := l_q
						l_q := l_q + 1
						l_tmp___6.item := (('r').code).to_natural_8
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, default:
						l_tmp___7 := l_q
						l_q := l_q + 1
						l_tmp___7.item := l_p___0.item
						l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
						l_p___0 := l_p___0 + 1
						l_pos := -1 + 1 -- back to loop condition
				when 8 then -- loop done
						l_q.item := (('%/0/').code).to_natural_8
						Result := l_buf___6
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	nb_unquote (a_p___0: CE_POINTER [NATURAL_8]; a_endp: CE_POINTER [CE_POINTER [NATURAL_8]]): CE_POINTER [INTEGER_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_result___2: CE_POINTER [INTEGER_8]
			l_q: CE_POINTER [INTEGER_8]
			l_done___2: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := a_p___0
					l_result___2 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_done___2 := 0
					l_result___2 := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MISC2_STATIC}).alloc_clear ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))) + {NATURAL_32} 1)))
					if l_result___2.is_void then
						Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						l_tmp___1 := l_p___0
						l_p___0 := l_p___0 + 1
						if (l_tmp___1.item).to_integer_32 /= 34 then
							l_result___2[0] := (('%/0/').code).to_integer_8
							Result := l_result___2
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 17 -- skip if block
					end
				when 1 then -- if:
						l_q := l_result___2
				when 2 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 16 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if not l_done___2.to_boolean then
							if (l_p___0.item).to_integer_32 = 0 then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 15 -- skip if block
						end
				when 4 then -- if:
						inspect (l_p___0.item).to_integer_32 -- switch 1 head
						when 34 then l_pos := -1 + 5
						when 92 then l_pos := -1 + 6
						else l_pos := -1 + 14
						end
				when 5 then -- switch 1, case 34
						l_done___2 := 1
						l_pos := -1 + 15 -- switch 1; break
				when 6 then -- switch 1, case 92
						l_p___0 := l_p___0 + 1
						inspect (l_p___0.item).to_integer_32 -- switch 2 head
						when 92 then l_pos := -1 + 7
						when 110 then l_pos := -1 + 8
						when 116 then l_pos := -1 + 9
						when 114 then l_pos := -1 + 10
						when 34 then l_pos := -1 + 11
						when 0 then l_pos := -1 + 12
						else l_pos := -1 + 13
						end
				when 7 then -- switch 2, case 92
						l_tmp___2 := l_q
						l_q := l_q + 1
						l_tmp___2[0] := (('\').code).to_integer_8
						l_pos := -1 + 13 -- switch 2; break
				when 8 then -- switch 2, case 110
						l_tmp___3 := l_q
						l_q := l_q + 1
						l_tmp___3[0] := (('%N').code).to_integer_8
						l_pos := -1 + 13 -- switch 2; break
				when 9 then -- switch 2, case 116
						l_tmp___4 := l_q
						l_q := l_q + 1
						l_tmp___4[0] := (('%T').code).to_integer_8
						l_pos := -1 + 13 -- switch 2; break
				when 10 then -- switch 2, case 114
						l_tmp___5 := l_q
						l_q := l_q + 1
						l_tmp___5[0] := (('%R').code).to_integer_8
						l_pos := -1 + 13 -- switch 2; break
				when 11 then -- switch 2, case 34
						l_tmp___6 := l_q
						l_q := l_q + 1
						l_tmp___6[0] := (('%"').code).to_integer_8
						l_pos := -1 + 13 -- switch 2; break
				when 12 then -- switch 2, case 0
						l_p___0 := l_p___0 - 1
						l_pos := -1 + 13 -- switch 2; break
				when 13 then -- switch 2, done:
						l_p___0 := l_p___0 + 1
						l_pos := -1 + 15 -- switch 1; break
				when 14 then -- switch 1, default:
						l_tmp___7 := l_q
						l_q := l_q + 1
						l_tmp___8 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___7[0] := (l_tmp___8.item).to_integer_8
				when 15 then -- switch 1, done: | if done
						l_pos := -1 + 2 -- back to loop condition
				when 16 then -- loop done
						l_break := False
						if not a_endp.is_void then
							a_endp.item := l_p___0
						end
						Result := l_result___2
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	nb_partialremove (a_lnum: INTEGER_32; a_first___0, a_last: INTEGER_32)
		local
			l_oldtext: CE_POINTER [NATURAL_8]
			l_newtext: CE_POINTER [NATURAL_8]
			l_oldlen: INTEGER_32
			l_lastbyte: INTEGER_32
			l_return: BOOLEAN
		do
			l_lastbyte := a_last
			l_oldtext := (create {P_MEMLINE_STATIC}).ml_get (a_lnum)
			l_oldlen := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_oldtext))).to_integer_32
			if a_first___0 >= l_oldlen then
				l_return := True
			elseif l_oldlen = 0 then
				l_return := True
			end
			if not l_return then
				if l_lastbyte >= l_oldlen then
					l_lastbyte := l_oldlen - 1
				end
				l_newtext := (create {P_MISC2_STATIC}).alloc ((l_oldlen - (l_lastbyte - a_first___0)).to_natural_32)
				if not l_newtext.is_void then
					memmove (create {CE_VOID_POINTER}.make_cast (l_newtext), create {CE_VOID_POINTER}.make_cast (l_oldtext), a_first___0.to_natural_32).do_nothing
					memmove (create {CE_VOID_POINTER}.make_cast ((l_newtext + a_first___0)), create {CE_VOID_POINTER}.make_cast (((l_oldtext + l_lastbyte) + 1)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((l_oldtext + l_lastbyte) + 1)))) + {NATURAL_32} 1).do_nothing;
					(create {P_MEMLINE_STATIC}).ml_replace (a_lnum, l_newtext, 0).do_nothing
				end
			end
		end

	nb_joinlines (a_first___0, a_other: INTEGER_32)
		local
			l_len_first: INTEGER_32
			l_len_other: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
		do
			l_len_first := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MEMLINE_STATIC}).ml_get (a_first___0))))).to_integer_32
			l_len_other := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MEMLINE_STATIC}).ml_get (a_other))))).to_integer_32
			l_p___0 := (create {P_MISC2_STATIC}).alloc (((l_len_first + l_len_other) + 1).to_natural_32)
			if not l_p___0.is_void then
				memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (((create {P_MEMLINE_STATIC}).ml_get (a_first___0))), l_len_first.to_natural_32).do_nothing
				memmove (create {CE_VOID_POINTER}.make_cast ((l_p___0 + l_len_first)), create {CE_VOID_POINTER}.make_cast (((create {P_MEMLINE_STATIC}).ml_get (a_other))), (l_len_other + 1).to_natural_32).do_nothing;
				(create {P_MEMLINE_STATIC}).ml_replace (a_first___0, l_p___0, 0).do_nothing
			end
		end

	nb_do_cmd (a_bufno: INTEGER_32; a_cmd: CE_POINTER [NATURAL_8]; a_func, a_cmdno: INTEGER_32; a_args: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_args: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_doupdate: INTEGER_32
			l_off___0: INTEGER_32
			l_buf___6: CE_POINTER [PD_NBBUF_STRUCT]
			l_retval: INTEGER_32
			l_cp: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_tmp___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_text: CE_ARRAY [NATURAL_8]
			l_tmp___4: INTEGER_32
			l_linenum: INTEGER_32
			l_serNum: INTEGER_32
			l_len: INTEGER_32
			l_len___0: INTEGER_32
			l_nlines: INTEGER_32
			l_text___0: CE_POINTER [NATURAL_8]
			l_lno: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_line: CE_POINTER [NATURAL_8]
			l_tmp___8: INTEGER_32
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___12: CE_POINTER [NATURAL_8]
			l_tmp___13: CE_POINTER [NATURAL_8]
			l_tmp___14: CE_POINTER [NATURAL_8]
			l_count___2: INTEGER_32
			l_first___0: PD_POS_T
			l_last: PD_POS_T
			l_pos___3: CE_POINTER [PD_POS_T]
			l_next: CE_POINTER [PD_POS_T]
			l_del_from_lnum: INTEGER_32
			l_del_to_lnum: INTEGER_32
			l_oldFire: INTEGER_32
			l_oldSuppress: INTEGER_32
			l_wasChanged: INTEGER_32
			l_i___0: INTEGER_32
			l_id: INTEGER_32
			l_to_free: CE_POINTER [NATURAL_8]
			l_ff_detected: INTEGER_32
			l_buf_was_empty: INTEGER_32
			l_len___1: NATURAL_32
			l_added: INTEGER_32
			l_oldFire___0: INTEGER_32
			l_old_b_changed: INTEGER_32
			l_nl: CE_POINTER [NATURAL_8]
			l_lnum: INTEGER_32
			l_lnum_start: INTEGER_32
			l_pos___4: CE_POINTER [PD_POS_T]
			l_oldline: CE_POINTER [NATURAL_8]
			l_newline: CE_POINTER [NATURAL_8]
			l_savedChars: INTEGER_32
			l_path: CE_POINTER [NATURAL_8]
			l_bufp: CE_POINTER [PD_FILE_BUFFER]
			l_exarg: CE_ARRAY [PD_EXARG]
			l_prev_b_changed: INTEGER_32
			l_st: CE_ARRAY [SD_STAT]
			l_pos___5: CE_POINTER [PD_POS_T]
			l_typeNum: INTEGER_32
			l_typeName: CE_POINTER [NATURAL_8]
			l_tooltip: CE_POINTER [NATURAL_8]
			l_p___1: CE_POINTER [NATURAL_8]
			l_glyphFile: CE_POINTER [NATURAL_8]
			l_parse_error: INTEGER_32
			l_fg: CE_POINTER [NATURAL_8]
			l_bg: CE_POINTER [NATURAL_8]
			l_serNum___0: INTEGER_32
			l_localTypeNum: INTEGER_32
			l_typeNum___0: INTEGER_32
			l_pos___6: CE_POINTER [PD_POS_T]
			l_serNum___1: INTEGER_32
			l_len___2: INTEGER_32
			l_first___1: PD_POS_T
			l_last___0: PD_POS_T
			l_pos___7: CE_POINTER [PD_POS_T]
			l_un: INTEGER_32
			l_lnum___0: INTEGER_32
			l_tmp___47: INTEGER_32
			l_tmp___52: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_args.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_cp.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_text.make (<<200>>)
			create {CE_CLASS_ARRAY [PD_EXARG]} l_exarg.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_args.item := a_args
					l_doupdate := 0
					l_off___0 := 0
					l_buf___6 := (nb_get_buf (a_bufno))
					l_retval := 1
					if not (a_func.to_boolean) then
						l_pos := -1 + 77 -- skip if block
					end
				when 1 then -- if:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("getModified"))) /= 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_buf___6.is_void then
							l_tmp___0 := count_changed_buffers
							nb_reply_nr (a_cmdno, l_tmp___0.to_integer_32)
						elseif (l_buf___6.item.bufp).is_void then
							l_tmp___0 := count_changed_buffers
							nb_reply_nr (a_cmdno, l_tmp___0.to_integer_32)
						else
							if ((l_buf___6.item.bufp).item.b_changed).to_boolean then
								l_tmp___2 := 1
							elseif (isNetbeansModified (l_buf___6.item.bufp)).to_boolean then
								l_tmp___2 := 1
							else
								l_tmp___2 := 0
							end
							nb_reply_nr (a_cmdno, l_tmp___2.to_integer_32)
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 76
				when 4 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("saveAndExit"))) /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						coloncmd ([ce_string (":confirm qall")])
						nb_reply_nr (a_cmdno, (count_changed_buffers).to_integer_32)
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 76
				when 7 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("getCursor"))) /= 0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_tmp___4 := ((create {P_GLOBALS_STATIC}).curbuf.item).item.pos2off (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")))
						sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_text), ce_string ("%%d %%ld %%d %%ld"), (nb_getbufno ((create {P_GLOBALS_STATIC}).curbuf.item)), (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col, l_tmp___4]).do_nothing
						nb_reply_text (a_cmdno, l_text)
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 76
				when 10 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("getAnno"))) /= 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_linenum := 0
						if l_buf___6.is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E652: Invalid buffer identifier in getAnno"))).do_nothing
							l_retval := 0
						elseif (l_buf___6.item.bufp).is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E652: Invalid buffer identifier in getAnno"))).do_nothing
							l_retval := 0
						else
							l_cp.item := create {CE_INTEGER_8_POINTER}.make_cast (l_args.item)
							l_serNum := (strtol (l_cp.item, l_cp, 10)).to_integer_32
							l_linenum := ((l_buf___6.item.bufp).item.buf_findsign (l_serNum)).to_integer_32
						end
						nb_reply_nr (a_cmdno, l_linenum)
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 76
				when 13 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("getLength"))) /= 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_len := 0
						if l_buf___6.is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E632: invalid buffer identifier in getLength"))).do_nothing
							l_retval := 0
						elseif (l_buf___6.item.bufp).is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E632: invalid buffer identifier in getLength"))).do_nothing
							l_retval := 0
						else
							l_len := (l_buf___6.item.bufp).item.get_buf_size
						end
						nb_reply_nr (a_cmdno, l_len)
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 76
				when 16 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("getText"))) /= 0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_text___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_lno := (1).to_integer_32
						if l_buf___6.is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E633: invalid buffer identifier in getText"))).do_nothing
							l_retval := 0
						elseif (l_buf___6.item.bufp).is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E633: invalid buffer identifier in getText"))).do_nothing
							l_retval := 0
						else
							l_len___0 := (l_buf___6.item.bufp).item.get_buf_size
							l_nlines := (l_buf___6.item.bufp).item.b_ml.ml_line_count
							if l_len___0 > 0 then
								l_tmp___8 := (l_len___0 + l_nlines) * 2
							else
								l_tmp___8 := 4
							end
							l_text___0 := (create {P_MISC2_STATIC}).alloc (l_tmp___8.to_natural_32)
							if l_text___0.is_void then
								l_retval := 0
							else
								l_p___0 := l_text___0
								l_tmp___9 := l_p___0
								l_p___0 := l_p___0 + 1
								l_tmp___9.item := (('%"').code).to_natural_8
								from
								until
									not (l_lno <= l_nlines)
								loop
									l_line := nb_quote (((l_buf___6.item.bufp).item.ml_get_buf (l_lno, 0)))
									if not l_line.is_void then
										strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), create {CE_INTEGER_8_POINTER}.make_cast (l_line)).do_nothing
										l_p___0 := l_p___0 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_line))).to_integer_32
										l_tmp___12 := l_p___0
										l_p___0 := l_p___0 + 1
										l_tmp___12.item := (('\').code).to_natural_8
										l_tmp___13 := l_p___0
										l_p___0 := l_p___0 + 1
										l_tmp___13.item := (('n').code).to_natural_8;
										(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_line))
									end
									l_lno := l_lno + 1
								end
								l_tmp___14 := l_p___0
								l_p___0 := l_p___0 + 1
								l_tmp___14.item := (('%"').code).to_natural_8
								l_p___0.item := (('%/0/').code).to_natural_8
							end
						end
						if l_text___0.is_void then
							nb_reply_text (a_cmdno, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
						else
							nb_reply_text (a_cmdno, l_text___0);
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_text___0))
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 76
				when 19 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("remove"))) /= 0 then
							l_pos := -1 + 47 -- skip if block
						end
				when 20 then -- if:
						l_oldFire := (create {P_GLOBALS_STATIC}).netbeansFireChanges.item
						l_oldSuppress := (create {P_GLOBALS_STATIC}).netbeansSuppressNoLines.item
						if skip.item >= 2 then
							nb_reply_nil (a_cmdno)
							Result := 1
							l_return := True
						end
						if l_return then
							l_pos := -1 + 45 -- skip if block
						end
				when 21 then -- if:
						if not (l_buf___6.is_void) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:;
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E634: invalid buffer identifier in remove"))).do_nothing
						l_retval := 0
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 24 then -- else:
						if not ((l_buf___6.item.bufp).is_void) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:;
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E634: invalid buffer identifier in remove"))).do_nothing
						l_retval := 0
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 27 then -- else:;
						(create {P_GLOBALS_STATIC}).netbeansFireChanges.item := 0;
						(create {P_GLOBALS_STATIC}).netbeansSuppressNoLines.item := 1
						nb_set_curbuf (l_buf___6.item.bufp)
						l_wasChanged := (l_buf___6.item.bufp).item.b_changed
						l_cp.item := create {CE_INTEGER_8_POINTER}.make_cast (l_args.item)
						l_off___0 := strtol (l_cp.item, l_cp, 10)
						l_count___2 := strtol (l_cp.item, l_cp, 10)
						l_args.item := create {CE_NATURAL_8_POINTER}.make_cast (l_cp.item)
						l_pos___3 := (l_buf___6.item.bufp).item.off2pos (l_off___0)
						if l_pos___3.is_void then
							nb_reply_text (a_cmdno, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("!bad position")));
							(create {P_GLOBALS_STATIC}).netbeansFireChanges.item := l_oldFire;
							(create {P_GLOBALS_STATIC}).netbeansSuppressNoLines.item := l_oldSuppress
							Result := 0
							l_return := True
						end
						if not l_return then
							l_first___0 := (l_pos___3.item).twin
							l_pos___3 := (l_buf___6.item.bufp).item.off2pos ((l_off___0 + l_count___2) - 1)
							if l_pos___3.is_void then
								nb_reply_text (a_cmdno, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("!bad count")));
								(create {P_GLOBALS_STATIC}).netbeansFireChanges.item := l_oldFire;
								(create {P_GLOBALS_STATIC}).netbeansSuppressNoLines.item := l_oldSuppress
								Result := 0
								l_return := True
							end
						end
						if l_return then
							l_pos := -1 + 45 -- skip if block
						end
				when 28 then -- if:
						l_last := (l_pos___3.item).twin
						l_del_from_lnum := l_first___0.lnum
						l_del_to_lnum := l_last.lnum
						l_doupdate := 1
						l_next := (l_buf___6.item.bufp).item.off2pos (l_off___0 + l_count___2)
						if l_first___0.col = 0 then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						l_pos := -1 + 33 -- goto _L___0
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 31 then -- else:
						if l_next.is_void then
							l_pos := -1 + 44 -- skip if block
						end
				when 32 then -- if:
						if l_first___0.lnum /= l_next.item.lnum then
							l_pos := -1 + 44 -- skip if block
						end
				when 33 then -- if: | _L___0:
						if l_first___0.lnum = l_last.lnum then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if:
						l_pos := -1 + 38 -- goto _L
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 36 then -- else:
						if l_next.is_void then
							l_pos := -1 + 42 -- skip if block
						end
				when 37 then -- if:
						if l_first___0.lnum = l_next.item.lnum then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if: | _L:
						nb_partialremove (l_first___0.lnum, l_first___0.col, (2_147_483_647).to_integer_32)
						if l_first___0.lnum = l_last.lnum then
							nb_joinlines (l_first___0.lnum, l_next.item.lnum)
							l_del_to_lnum := l_next.item.lnum
						end
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 40 then -- else:
						nb_partialremove (l_first___0.lnum, l_first___0.col, l_last.col)
				when 41 then -- if done | if block done, skip else block:
						l_pos := -1 + 43
				when 42 then -- else:
						nb_partialremove (l_first___0.lnum, l_first___0.col, l_last.col)
				when 43 then -- if done
						l_del_from_lnum := l_del_from_lnum + 1
				when 44 then -- if done | if done
						if l_first___0.lnum /= l_last.lnum then
							if not l_next.is_void then
								if l_next.item.col /= 0 then
									if l_last.lnum = l_next.item.lnum then
										nb_partialremove (l_last.lnum, 0, l_last.col)
										if l_del_from_lnum > l_first___0.lnum then
											nb_joinlines (l_first___0.lnum, l_last.lnum)
										else
											l_del_to_lnum := l_del_to_lnum - 1
										end
									end
								end
							end
						end
						if l_first___0.lnum /= l_last.lnum then
							if l_del_from_lnum > l_first___0.lnum then
								if not l_next.is_void then
									if l_last.lnum /= l_next.item.lnum then
										nb_joinlines (l_first___0.lnum, l_next.item.lnum)
										l_del_to_lnum := l_next.item.lnum
									end
								end
							end
						end
						if l_del_to_lnum >= l_del_from_lnum then
							l_i___0 := l_del_from_lnum.to_integer_32
							from
							until
								not (l_i___0.to_integer_32 <= l_del_to_lnum)
							loop
								l_id := ((l_buf___6.item.bufp).item.buf_findsign_id (l_i___0.to_integer_32))
								if l_id > 0 then
									(l_buf___6.item.bufp).item.buf_delsign (l_id).do_nothing
								end
								l_i___0 := l_i___0 + 1
							end
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_del_from_lnum;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0;
							(create {P_MISC1_STATIC}).del_lines ((l_del_to_lnum - l_del_from_lnum) + 1, 0)
						end
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_first___0.twin;
						(create {P_MISC2_STATIC}).check_cursor_lnum;
						(l_buf___6.item.bufp).item.b_changed := l_wasChanged;
						(create {P_GLOBALS_STATIC}).netbeansFireChanges.item := l_oldFire;
						(create {P_GLOBALS_STATIC}).netbeansSuppressNoLines.item := l_oldSuppress;
						(l_buf___6.item.bufp).item.u_blockfree;
						(l_buf___6.item.bufp).item.u_clearall
				when 45 then -- if done | if done | if done | if done
						if not l_return then
							nb_reply_nil (a_cmdno)
						end
				when 46 then -- if block done, skip else block:
						l_pos := -1 + 76
				when 47 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("insert"))) /= 0 then
							l_pos := -1 + 75 -- skip if block
						end
				when 48 then -- if:
						if skip.item >= 2 then
							nb_reply_nil (a_cmdno)
							Result := 1
							l_return := True
						end
						if l_return then
							l_pos := -1 + 74 -- skip if block
						end
				when 49 then -- if:
						l_cp.item := create {CE_INTEGER_8_POINTER}.make_cast (l_args.item)
						l_off___0 := strtol (l_cp.item, l_cp, 10)
						l_args.item := create {CE_NATURAL_8_POINTER}.make_cast (l_cp.item)
						l_args.item := (create {P_CHARSET_STATIC}).skipwhite (l_args.item)
						l_to_free := create {CE_NATURAL_8_POINTER}.make_cast ((nb_unquote (l_args.item, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))))
						l_args.item := l_to_free
						if not (l_buf___6.is_void) then
							l_pos := -1 + 52 -- skip if block
						end
				when 50 then -- if:;
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E635: invalid buffer identifier in insert"))).do_nothing
						l_retval := 0
				when 51 then -- if block done, skip else block:
						l_pos := -1 + 73
				when 52 then -- else:
						if not ((l_buf___6.item.bufp).is_void) then
							l_pos := -1 + 55 -- skip if block
						end
				when 53 then -- if:;
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E635: invalid buffer identifier in insert"))).do_nothing
						l_retval := 0
				when 54 then -- if block done, skip else block:
						l_pos := -1 + 73
				when 55 then -- else:
						if (l_args.item).is_void then
							l_pos := -1 + 73 -- skip if block
						end
				when 56 then -- if:
						l_ff_detected := -1
						l_buf_was_empty := ((l_buf___6.item.bufp).item.b_ml.ml_flags).bit_and (1)
						l_len___1 := (0).to_natural_32
						l_added := 0
						l_oldFire___0 := (create {P_GLOBALS_STATIC}).netbeansFireChanges.item;
						(create {P_GLOBALS_STATIC}).netbeansFireChanges.item := 0
						nb_set_curbuf (l_buf___6.item.bufp)
						l_old_b_changed := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_changed
						l_pos___4 := ((create {P_GLOBALS_STATIC}).curbuf.item).item.off2pos (l_off___0)
						if not l_pos___4.is_void then
							if l_pos___4.item.lnum <= 0 then
								l_lnum_start := (1).to_integer_32
							else
								l_lnum_start := l_pos___4.item.lnum
							end
						elseif l_buf_was_empty.to_boolean then
							l_lnum_start := (1).to_integer_32
						else
							l_lnum_start := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count + 1
						end
						l_lnum := l_lnum_start
						l_doupdate := 1
				when 57 then -- loop condition:
						if not (not (l_break) and then ((l_args.item.item).to_integer_32 /= 0)) then
							l_pos := -1 + 72 -- skip loop
						end
				when 58 then -- loop body:
						l_break := False
						l_nl := (create {P_MISC2_STATIC}).vim_strchr (l_args.item, ('%N').code)
						if l_nl.is_void then
							l_len___1 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_args.item))
						else
							l_len___1 := (l_nl.distance ((l_args.item))).to_natural_32
							if (l_nl.c_pointer.to_integer_32).to_natural_32 > ((l_args.item).c_pointer.to_integer_32).to_natural_32 then
								if (l_nl[-1]).to_integer_32 = 13 then
									l_ff_detected := 1
									l_len___1 := l_len___1 - 1
								else
									l_ff_detected := 0
								end
							else
								l_ff_detected := 0
							end
						end
						l_args.item[l_len___1.to_integer_32] := (('%/0/').code).to_natural_8
						if l_lnum /= l_lnum_start then
							l_pos := -1 + 70 -- skip if block
						end
				when 59 then -- if:
						if l_pos___4.is_void then
							l_pos := -1 + 62 -- skip if block
						end
				when 60 then -- if:
						if l_pos___4.item.col > 0 then
							l_pos := -1 + 64 -- goto _L___1
						else
							l_pos := -1 + 62 -- goto _L___2
						end
				when 61 then -- if block done, skip else block:
						l_pos := -1 + 69
				when 62 then -- else: | _L___2:
						if l_lnum /= 1 then
							l_pos := -1 + 68 -- skip if block
						end
				when 63 then -- if:
						if not (l_buf_was_empty.to_boolean) then
							l_pos := -1 + 66 -- skip if block
						end
				when 64 then -- if: | _L___1:
						l_oldline := ((create {P_MEMLINE_STATIC}).ml_get (l_lnum))
						l_newline := (create {P_MISC2_STATIC}).alloc_check (((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_oldline))) + l_len___1) + {NATURAL_32} 1)
						if not l_newline.is_void then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_newline), create {CE_INTEGER_8_POINTER}.make_cast (l_oldline)).do_nothing
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_newline), create {CE_INTEGER_8_POINTER}.make_cast (l_args.item)).do_nothing;
							(create {P_MEMLINE_STATIC}).ml_replace (l_lnum, l_newline, 0).do_nothing
						end
				when 65 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 66 then -- else:;
						(create {P_MEMLINE_STATIC}).ml_append (l_lnum - 1, l_args.item, (l_len___1 + {NATURAL_32} 1).to_integer_32, 0).do_nothing
						l_added := l_added + 1
				when 67 then -- if done | if block done, skip else block:
						l_pos := -1 + 69
				when 68 then -- else:;
						(create {P_MEMLINE_STATIC}).ml_append (l_lnum - 1, l_args.item, (l_len___1 + {NATURAL_32} 1).to_integer_32, 0).do_nothing
						l_added := l_added + 1
				when 69 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 71
				when 70 then -- else:;
						(create {P_MEMLINE_STATIC}).ml_append (l_lnum - 1, l_args.item, (l_len___1 + {NATURAL_32} 1).to_integer_32, 0).do_nothing
						l_added := l_added + 1
				when 71 then
						if l_nl.is_void then
							l_break := True
						end
						if not (l_break) then
							l_lnum := l_lnum + 1
							l_args.item := l_nl + 1
						end
						l_pos := -1 + 57 -- back to loop condition
				when 72 then -- loop done
						l_break := False;
						(create {P_MISC1_STATIC}).appended_lines_mark (l_lnum_start - 1, l_added.to_integer_32)
						if l_buf_was_empty.to_boolean then
							if l_ff_detected = -1 then
								l_ff_detected := 0
							end
							(create {P_MISC2_STATIC}).set_fileformat (l_ff_detected, 4);
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_start_ffc := (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ff).item).to_integer_32
						end
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_changed := l_old_b_changed;
						(create {P_GLOBALS_STATIC}).netbeansFireChanges.item := l_oldFire___0;
						((create {P_GLOBALS_STATIC}).curbuf.item).item.u_blockfree;
						((create {P_GLOBALS_STATIC}).curbuf.item).item.u_clearall
				when 73 then -- if done | if done | if done;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_to_free))
						nb_reply_nil (a_cmdno)
				when 74 then -- if done | if block done, skip else block:
						l_pos := -1 + 76
				when 75 then -- else:
						nb_reply_nil (a_cmdno)
						l_retval := 0
				when 76 then -- if done | if done | if done | if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 169
				when 77 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("create"))) /= 0 then
							l_pos := -1 + 80 -- skip if block
						end
				when 78 then -- if:
						if l_buf___6.is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E636: invalid buffer identifier in create"))).do_nothing
							Result := 0
							l_return := True
						end
						if not l_return then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6.item.displayname))
							l_buf___6.item.displayname := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer);
							(create {P_GLOBALS_STATIC}).netbeansReadFile.item := 0;
							(create {P_EX_CMDS_STATIC}).do_ecmd (0, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer), (1).to_integer_32, 5, (create {P_GLOBALS_STATIC}).curwin.item).do_nothing;
							(create {P_GLOBALS_STATIC}).netbeansReadFile.item := 1
							l_buf___6.item.bufp := (create {P_GLOBALS_STATIC}).curbuf.item;
							(create {P_BUFFER_STATIC}).maketitle
							l_buf___6.item.insertDone := {NATURAL_32} 0
							if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
								(create {P_MENU_STATIC}).gui_update_menus (0)
							end
						end
				when 79 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 80 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("insertDone"))) /= 0 then
							l_pos := -1 + 83 -- skip if block
						end
				when 81 then -- if:
						if not (l_buf___6.is_void) then
							if not ((l_buf___6.item.bufp).is_void) then
								(l_buf___6.item.bufp).item.b_start_eol := ((l_args.item.item).to_integer_32 = 84).to_integer
								l_buf___6.item.insertDone := {NATURAL_32} 1
								l_args.item := l_args.item + (2);
								(l_buf___6.item.bufp).item.b_p_ro := ((l_args.item.item).to_integer_32 = 84).to_integer
								l_buf___6.item.print_read_msg
							end
						end
				when 82 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 83 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("saveDone"))) /= 0 then
							l_pos := -1 + 86 -- skip if block
						end
				when 84 then -- if:
						l_savedChars := (atol (create {CE_INTEGER_8_POINTER}.make_cast (l_args.item)))
						if not (l_buf___6.is_void) then
							if not ((l_buf___6.item.bufp).is_void) then
								print_save_msg (l_buf___6, l_savedChars)
							end
						end
				when 85 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 86 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("startDocumentListen"))) /= 0 then
							l_pos := -1 + 89 -- skip if block
						end
				when 87 then -- if:
						if l_buf___6.is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E637: invalid buffer identifier in startDocumentListen"))).do_nothing
							Result := 0
							l_return := True
						end
						if not l_return then
							l_buf___6.item.fireChanges := {NATURAL_32} 1
						end
				when 88 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 89 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("stopDocumentListen"))) /= 0 then
							l_pos := -1 + 92 -- skip if block
						end
				when 90 then -- if:
						if l_buf___6.is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E638: invalid buffer identifier in stopDocumentListen"))).do_nothing
							Result := 0
							l_return := True
						end
						if not l_return then
							l_buf___6.item.fireChanges := {NATURAL_32} 0
							if not (l_buf___6.item.bufp).is_void then
								if ((l_buf___6.item.bufp).item.b_was_netbeans_file).to_boolean then
									if not ((l_buf___6.item.bufp).item.b_netbeans_file).to_boolean then
										(create {P_MISC2_STATIC}).emsgn (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E658: NetBeans connection lost for buffer %%ld")))), ((l_buf___6.item.bufp).item.b_fnum).to_integer_32).do_nothing
									else
										(create {P_BUFFER_STATIC}).do_bufdel (3, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), 1, (l_buf___6.item.bufp).item.b_fnum, (l_buf___6.item.bufp).item.b_fnum, 1).do_nothing
										memset (create {CE_VOID_POINTER}.make_cast (l_buf___6), 0, (create {PD_NBBUF_STRUCT}.make).structure_size.to_natural_32).do_nothing
									end
								end
							end
						end
				when 91 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 92 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("setTitle"))) /= 0 then
							l_pos := -1 + 95 -- skip if block
						end
				when 93 then -- if:
						if l_buf___6.is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E639: invalid buffer identifier in setTitle"))).do_nothing
							Result := 0
							l_return := True
						end
						if not l_return then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6.item.displayname))
							l_buf___6.item.displayname := nb_unquote (l_args.item, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
						end
				when 94 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 95 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("initDone"))) /= 0 then
							l_pos := -1 + 98 -- skip if block
						end
				when 96 then -- if:
						if l_buf___6.is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E640: invalid buffer identifier in initDone"))).do_nothing
							Result := 0
							l_return := True
						elseif (l_buf___6.item.bufp).is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E640: invalid buffer identifier in initDone"))).do_nothing
							Result := 0
							l_return := True
						end
						if not l_return then
							l_doupdate := 1
							l_buf___6.item.initDone := {NATURAL_32} 1
							nb_set_curbuf (l_buf___6.item.bufp);
							(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFREADPOST, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, l_buf___6.item.bufp).do_nothing
							handle_key_queue
						end
				when 97 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 98 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("setBufferNumber"))) /= 0 then
							l_pos := -1 + 101 -- skip if block
						end
				when 99 then -- if:
						l_pos := -1 + 102 -- goto _L___7
				when 100 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 101 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("putBufferNumber"))) /= 0 then
							l_pos := -1 + 104 -- skip if block
						end
				when 102 then -- if: | _L___7:
						if l_buf___6.is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E641: invalid buffer identifier in setBufferNumber"))).do_nothing
							Result := 0
							l_return := True
						end
						if not l_return then
							l_path := create {CE_NATURAL_8_POINTER}.make_cast ((nb_unquote (l_args.item, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))))
							if l_path.is_void then
								Result := 0
								l_return := True
							end
						end
						if not l_return then
							l_bufp := (create {P_BUFFER_STATIC}).buflist_findname (l_path);
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_path))
							if l_bufp.is_void then
								(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E642: File %%s not found in setBufferNumber")), l_args.item).do_nothing
								Result := 0
								l_return := True
							end
						end
						if not l_return then
							l_buf___6.item.bufp := l_bufp
							l_buf___6.item.nbbuf_number := l_bufp.item.b_fnum
							if (a_cmd.item).to_integer_32 /= 112 then
								coloncmd ([ce_string (":buffer %%d"), l_bufp.item.b_fnum])
							else
								l_buf___6.item.initDone := {NATURAL_32} 1
								handle_key_queue
							end
						end
				when 103 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 104 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("setFullName"))) /= 0 then
							l_pos := -1 + 107 -- skip if block
						end
				when 105 then -- if:
						if l_buf___6.is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E643: invalid buffer identifier in setFullName"))).do_nothing
							Result := 0
							l_return := True
						end
						if not l_return then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6.item.displayname))
							l_buf___6.item.displayname := nb_unquote (l_args.item, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer));
							(create {P_GLOBALS_STATIC}).netbeansReadFile.item := 0;
							(create {P_EX_CMDS_STATIC}).do_ecmd (0, create {CE_NATURAL_8_POINTER}.make_cast (l_buf___6.item.displayname), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer), (1).to_integer_32, 5, (create {P_GLOBALS_STATIC}).curwin.item).do_nothing;
							(create {P_GLOBALS_STATIC}).netbeansReadFile.item := 1
							l_buf___6.item.bufp := (create {P_GLOBALS_STATIC}).curbuf.item;
							(create {P_BUFFER_STATIC}).maketitle
							if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
								(create {P_MENU_STATIC}).gui_update_menus (0)
							end
						end
				when 106 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 107 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("editFile"))) /= 0 then
							l_pos := -1 + 110 -- skip if block
						end
				when 108 then -- if:
						if l_buf___6.is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E644: invalid buffer identifier in editFile"))).do_nothing
							Result := 0
							l_return := True
						end
						if not l_return then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6.item.displayname))
							l_buf___6.item.displayname := nb_unquote (l_args.item, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer));
							(create {P_EX_CMDS_STATIC}).do_ecmd (0, create {CE_NATURAL_8_POINTER}.make_cast (l_buf___6.item.displayname), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer), (1).to_integer_32, 5, (create {P_GLOBALS_STATIC}).curwin.item).do_nothing
							l_buf___6.item.bufp := (create {P_GLOBALS_STATIC}).curbuf.item
							l_buf___6.item.initDone := {NATURAL_32} 1
							l_doupdate := 1;
							(create {P_BUFFER_STATIC}).maketitle
							if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
								(create {P_MENU_STATIC}).gui_update_menus (0)
							end
						end
				when 109 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 110 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("setVisible"))) /= 0 then
							l_pos := -1 + 118 -- skip if block
						end
				when 111 then -- if:
						if not (l_buf___6.is_void) then
							l_pos := -1 + 114 -- skip if block
						end
				when 112 then -- if:
						l_pos := -1 + 115 -- goto _L___3
				when 113 then -- if block done, skip else block:
						l_pos := -1 + 116
				when 114 then -- else:
						if not ((l_buf___6.item.bufp).is_void) then
							l_pos := -1 + 116 -- skip if block
						end
				when 115 then -- if: | _L___3:
						if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E645: invalid buffer identifier in setVisible"))).do_nothing
						end
						Result := 0
						l_return := True
				when 116 then -- if done
						if not l_return then
							if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_args.item), ce_string ("T"))) = 0 then
								if not (l_buf___6.item.bufp).is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
									l_exarg.item.cmd := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("goto"))
									l_exarg.item.forceit := 0
									dosetvisible.item := 1
									l_exarg.item.goto_buffer (1, 1, (l_buf___6.item.bufp).item.b_fnum)
									l_doupdate := 1
									dosetvisible.item := 0
									if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
										(create {P_GUI_GTK_X11_STATIC}).gui_mch_set_foreground
									end
								end
							end
						end
				when 117 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 118 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("raise"))) /= 0 then
							l_pos := -1 + 121 -- skip if block
						end
				when 119 then -- if:
						if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							(create {P_GUI_GTK_X11_STATIC}).gui_mch_set_foreground
						end
				when 120 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 121 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("setModified"))) /= 0 then
							l_pos := -1 + 129 -- skip if block
						end
				when 122 then -- if:
						if not (l_buf___6.is_void) then
							l_pos := -1 + 125 -- skip if block
						end
				when 123 then -- if:
						l_pos := -1 + 126 -- goto _L___4
				when 124 then -- if block done, skip else block:
						l_pos := -1 + 127
				when 125 then -- else:
						if not ((l_buf___6.item.bufp).is_void) then
							l_pos := -1 + 127 -- skip if block
						end
				when 126 then -- if: | _L___4:
						if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E646: invalid buffer identifier in setModified"))).do_nothing
						end
						Result := 0
						l_return := True
				when 127 then -- if done
						if not l_return then
							l_prev_b_changed := (l_buf___6.item.bufp).item.b_changed
							if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_args.item), ce_string ("T"))) = 0 then
								(l_buf___6.item.bufp).item.b_changed := 1
							else
								if not ((l_buf___6.item.bufp).item.b_ffname).is_void then
									if (stat (create {CE_INTEGER_8_POINTER}.make_cast ((l_buf___6.item.bufp).item.b_ffname), l_st)) >= 0 then
										(l_buf___6.item.bufp).item.buf_store_time (l_st, (l_buf___6.item.bufp).item.b_ffname)
									end
								end
								(l_buf___6.item.bufp).item.b_changed := 0
							end
							l_buf___6.item.modified := ((l_buf___6.item.bufp).item.b_changed).to_natural_32
							if l_prev_b_changed /= (l_buf___6.item.bufp).item.b_changed then
								(create {P_MISC1_STATIC}).check_status (l_buf___6.item.bufp);
								(create {P_GLOBALS_STATIC}).redraw_tabline.item := 1;
								(create {P_BUFFER_STATIC}).maketitle;
								(create {P_SCREEN_STATIC}).update_screen (0)
							end
						end
				when 128 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 129 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("setModtime"))) /= 0 then
							l_pos := -1 + 132 -- skip if block
						end
				when 130 then -- if:
						if not (l_buf___6.is_void) then
							if not ((l_buf___6.item.bufp).is_void) then
								(l_buf___6.item.bufp).item.b_mtime := (atoi (create {CE_INTEGER_8_POINTER}.make_cast (l_args.item))).to_integer_32
							end
						end
				when 131 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 132 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("setReadOnly"))) /= 0 then
							l_pos := -1 + 135 -- skip if block
						end
				when 133 then -- if:
						if not (l_buf___6.is_void) then
							if not ((l_buf___6.item.bufp).is_void) then
								if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_args.item), ce_string ("T"))) = 0 then
									(l_buf___6.item.bufp).item.b_p_ro := 1
								else
									(l_buf___6.item.bufp).item.b_p_ro := 0
								end
							end
						end
				when 134 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 135 then -- else:
						if ((strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("setMark"))) = 0) then
							l_pos := -1 + 169 -- skip if block
						end
				when 136 then -- if:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("showBalloon"))) /= 0 then
							l_pos := -1 + 139 -- skip if block
						end
				when 137 then -- if:
						if not ((create {P_GLOBALS_STATIC}).balloonEval.item).is_void then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (text___1.item))
							text___1.item := nb_unquote (l_args.item, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
							if not text___1.item.is_void then
								((create {P_GLOBALS_STATIC}).balloonEval.item).item.gui_mch_post_balloon (create {CE_NATURAL_8_POINTER}.make_cast (text___1.item))
							end
						end
				when 138 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 139 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("setDot"))) /= 0 then
							l_pos := -1 + 147 -- skip if block
						end
				when 140 then -- if:
						if l_buf___6.is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E647: invalid buffer identifier in setDot"))).do_nothing
							Result := 0
							l_return := True
						elseif (l_buf___6.item.bufp).is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E647: invalid buffer identifier in setDot"))).do_nothing
							Result := 0
							l_return := True
						end
						if l_return then
							l_pos := -1 + 146 -- skip if block
						end
				when 141 then -- if:
						nb_set_curbuf (l_buf___6.item.bufp)
						if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
							(create {P_NORMAL_STATIC}).end_visual_mode
						end
						l_pos___5 := (l_buf___6.item.bufp).item.get_off_or_lnum (l_args)
						if (not l_pos___5.is_void) then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := (l_pos___5.item).twin;
							(create {P_MISC2_STATIC}).check_cursor;
							(create {P_FOLD_STATIC}).foldOpenCursor
						end
						(create {P_MOVE_STATIC}).update_topline;
						(create {P_SCREEN_STATIC}).update_screen (10);
						(create {P_SCREEN_STATIC}).setcursor;
						(create {P_TERM_STATIC}).out_flush
						if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							(create {P_GUI_STATIC}).gui_update_cursor (1, 0);
							(create {P_GUI_GTK_X11_STATIC}).gui_mch_flush
						end
						if (create {P_GLOBALS_STATIC}).State.item /= 513 then
							l_pos := -1 + 144 -- skip if block
						end
				when 142 then -- if:
						l_pos := -1 + 145 -- goto _L___5
				when 143 then -- if block done, skip else block:
						l_pos := -1 + 146
				when 144 then -- else:
						if (create {P_GLOBALS_STATIC}).State.item /= 768 then
							l_pos := -1 + 146 -- skip if block
						end
				when 145 then -- if: | _L___5:
						if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							if (gtk_main_level) > {NATURAL_32} 0 then
								gtk_main_quit
							end
						end
				when 146 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 169
				when 147 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("close"))) /= 0 then
							l_pos := -1 + 150 -- skip if block
						end
				when 148 then -- if:
						if l_buf___6.is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E648: invalid buffer identifier in close"))).do_nothing
							Result := 0
							l_return := True
						end
						if not l_return then
							if (l_buf___6.item.bufp).is_void then
								if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
									(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E649: invalid buffer identifier in close"))).do_nothing
								end
							end
							(create {P_GLOBALS_STATIC}).need_mouse_correct.item := 1
							if not (l_buf___6.item.bufp).is_void then
								(create {P_BUFFER_STATIC}).do_buffer (4, 1, 1, (l_buf___6.item.bufp).item.b_fnum, 1).do_nothing
							end
							l_buf___6.item.bufp := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
							l_buf___6.item.initDone := {NATURAL_32} 0
							l_doupdate := 1
						end
				when 149 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 150 then -- else:
						if ((strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("setStyle"))) = 0) then
							l_pos := -1 + 169 -- skip if block
						end
				when 151 then -- if:
						if ((strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("setExitDelay"))) = 0) then
							l_pos := -1 + 169 -- skip if block
						end
				when 152 then -- if:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("defineAnnoType"))) /= 0 then
							l_pos := -1 + 155 -- skip if block
						end
				when 153 then -- if:
						l_parse_error := 0
						if l_buf___6.is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E650: invalid buffer identifier in defineAnnoType"))).do_nothing
							Result := 0
							l_return := True
						end
						if not l_return then
							l_cp.item := create {CE_INTEGER_8_POINTER}.make_cast (l_args.item)
							l_typeNum := (strtol (l_cp.item, l_cp, 10)).to_integer_32
							l_args.item := create {CE_NATURAL_8_POINTER}.make_cast (l_cp.item)
							l_args.item := (create {P_CHARSET_STATIC}).skipwhite (l_args.item)
							l_typeName := create {CE_NATURAL_8_POINTER}.make_cast ((nb_unquote (l_args.item, l_args)))
							l_args.item := (create {P_CHARSET_STATIC}).skipwhite (l_args.item + 1)
							l_tooltip := create {CE_NATURAL_8_POINTER}.make_cast ((nb_unquote (l_args.item, l_args)))
							l_args.item := (create {P_CHARSET_STATIC}).skipwhite (l_args.item + 1)
							l_p___1 := create {CE_NATURAL_8_POINTER}.make_cast ((nb_unquote (l_args.item, l_args)))
							l_glyphFile := (create {P_MISC2_STATIC}).vim_strsave_escaped (l_p___1, (create {P_GLOBALS_STATIC}).escape_chars.item);
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___1))
							l_args.item := (create {P_CHARSET_STATIC}).skipwhite (l_args.item + 1)
							l_p___1 := (create {P_CHARSET_STATIC}).skiptowhite (l_args.item)
							if (l_p___1.item).to_integer_32 /= 0 then
								l_p___1.item := (('%/0/').code).to_natural_8
								l_p___1 := (create {P_CHARSET_STATIC}).skipwhite (l_p___1 + 1)
							end
							l_fg := (create {P_MISC2_STATIC}).vim_strsave (l_args.item)
							l_bg := (create {P_MISC2_STATIC}).vim_strsave (l_p___1)
							if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_fg))) > {NATURAL_32} 32 then
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E532: highlighting color name too long in defineAnnoType"))).do_nothing;
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_typeName))
								l_parse_error := 1
							elseif (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_bg))) > {NATURAL_32} 32 then
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E532: highlighting color name too long in defineAnnoType"))).do_nothing;
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_typeName))
								l_parse_error := 1
							elseif not l_typeName.is_void then
								if not l_tooltip.is_void then
									if not l_glyphFile.is_void then
										l_buf___6.item.addsigntype (l_typeNum, l_typeName, l_tooltip, l_glyphFile, l_fg, l_bg)
									else
										(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_typeName))
									end
								else
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_typeName))
								end
							else
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_typeName))
							end
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fg));
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_bg));
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tooltip));
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_glyphFile))
							if l_parse_error.to_boolean then
								Result := 0
								l_return := True
							end
						end
				when 154 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 155 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("addAnno"))) /= 0 then
							l_pos := -1 + 158 -- skip if block
						end
				when 156 then -- if:
						if l_buf___6.is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E651: invalid buffer identifier in addAnno"))).do_nothing
							Result := 0
							l_return := True
						elseif (l_buf___6.item.bufp).is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E651: invalid buffer identifier in addAnno"))).do_nothing
							Result := 0
							l_return := True
						end
						if not l_return then
							l_doupdate := 1
							l_cp.item := create {CE_INTEGER_8_POINTER}.make_cast (l_args.item)
							l_serNum___0 := (strtol (l_cp.item, l_cp, 10)).to_integer_32
							l_localTypeNum := (strtol (l_cp.item, l_cp, 10)).to_integer_32
							l_args.item := create {CE_NATURAL_8_POINTER}.make_cast (l_cp.item)
							l_typeNum___0 := mapsigntype (l_buf___6, l_localTypeNum)
							l_pos___6 := (l_buf___6.item.bufp).item.get_off_or_lnum (l_args)
							l_cp.item := create {CE_INTEGER_8_POINTER}.make_cast (l_args.item);
							(create {P_GLOBALS_STATIC}).ignored.item := (strtol (l_cp.item, l_cp, 10)).to_integer_32
							l_args.item := create {CE_NATURAL_8_POINTER}.make_cast (l_cp.item)
							if l_serNum___0 >= 1_000_000 then
								Result := 0
								l_return := True
							end
						end
						if not l_return and then (not l_pos___6.is_void) then
							coloncmd ([ce_string (":sign place %%d line=%%ld name=%%d buffer=%%d"), l_serNum___0, l_pos___6.item.lnum, l_typeNum___0, (l_buf___6.item.bufp).item.b_fnum])
							if l_typeNum___0 = curPCtype.item then
								coloncmd ([ce_string (":sign jump %%d buffer=%%d"), l_serNum___0, (l_buf___6.item.bufp).item.b_fnum])
							end
						end
				when 157 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 158 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("removeAnno"))) /= 0 then
							l_pos := -1 + 161 -- skip if block
						end
				when 159 then -- if:
						if l_buf___6.is_void then
							Result := 0
							l_return := True
						elseif (l_buf___6.item.bufp).is_void then
							Result := 0
							l_return := True
						end
						if not l_return then
							l_doupdate := 1
							l_cp.item := create {CE_INTEGER_8_POINTER}.make_cast (l_args.item)
							l_serNum___1 := (strtol (l_cp.item, l_cp, 10)).to_integer_32
							l_args.item := create {CE_NATURAL_8_POINTER}.make_cast (l_cp.item)
							coloncmd ([ce_string (":sign unplace %%d buffer=%%d"), l_serNum___1, (l_buf___6.item.bufp).item.b_fnum]);
							(create {P_SCREEN_STATIC}).redraw_buf_later (l_buf___6.item.bufp, 40)
						end
				when 160 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 161 then -- else:
						if ((strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("moveAnnoToFront"))) = 0) then
							l_pos := -1 + 169 -- skip if block
						end
				when 162 then -- if:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("guard"))) /= 0 then
							l_pos := -1 + 165 -- skip if block
						end
				when 163 then -- if:
						l_pos := -1 + 166 -- goto _L___6
				when 164 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 165 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("unguard"))) /= 0 then
							l_pos := -1 + 168 -- skip if block
						end
				when 166 then -- if: | _L___6:
						l_un := ((a_cmd[0]).to_integer_32 = 117).to_integer
						if skip.item >= 2 then
							Result := 1
							l_return := True
						end
						if not l_return then
							nb_init_graphics
							if l_buf___6.is_void then
								Result := 0
								l_return := True
							elseif (l_buf___6.item.bufp).is_void then
								Result := 0
								l_return := True
							end
						end
						if not l_return then
							nb_set_curbuf (l_buf___6.item.bufp)
							l_cp.item := create {CE_INTEGER_8_POINTER}.make_cast (l_args.item)
							l_off___0 := strtol (l_cp.item, l_cp, 10)
							l_len___2 := (strtol (l_cp.item, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 10)).to_integer_32
							l_args.item := create {CE_NATURAL_8_POINTER}.make_cast (l_cp.item)
							l_pos___7 := (l_buf___6.item.bufp).item.off2pos (l_off___0)
							l_doupdate := 1
							if (not l_pos___7.is_void) then
								l_first___1 := (l_pos___7.item).twin
								l_pos___7 := (l_buf___6.item.bufp).item.off2pos ((l_off___0 + l_len___2.to_integer_32) - 1)
								if not l_pos___7.is_void then
									if l_pos___7.item.col = 0 then
										l_pos___7 := (l_buf___6.item.bufp).item.off2pos ((l_off___0 + l_len___2.to_integer_32) - 2)
									end
								end
								if (not l_pos___7.is_void) then
									l_last___0 := (l_pos___7.item).twin
									l_lnum___0 := l_first___1.lnum
									from
									until
										not (l_lnum___0 <= l_last___0.lnum)
									loop
										if not l_un.to_boolean then
											if ((l_buf___6.item.bufp).item.buf_findsigntype_id (l_lnum___0, 10_000)) = 0 then
												l_tmp___47 := guardId.item
												guardId.item := guardId.item + 1
												coloncmd ([ce_string (":sign place %%d line=%%ld name=%%d buffer=%%d"), l_tmp___47, l_lnum___0, 10_000, (l_buf___6.item.bufp).item.b_fnum])
											end
										end
										l_lnum___0 := l_lnum___0 + 1
									end
									(create {P_SCREEN_STATIC}).redraw_buf_later (l_buf___6.item.bufp, 40)
								end
							end
						end
				when 167 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 168 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("startAtomic"))) = 0 then
							inAtomic.item := 1
						elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("endAtomic"))) = 0 then
							inAtomic.item := 0
							if needupdate.item.to_boolean then
								l_doupdate := 1
								needupdate.item := 0
							end
						elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("save"))) = 0 then
							if l_buf___6.is_void then
								Result := 0
								l_return := True
							elseif (l_buf___6.item.bufp).is_void then
								Result := 0
								l_return := True
							end
							if not l_return then
								if ((l_buf___6.item.bufp).item.bufIsChanged).to_boolean then
									if ((create {P_OPTION_STATIC}).p_write.item.item).to_boolean then
										if not ((l_buf___6.item.bufp).item.b_p_ro).to_boolean then
											if not ((l_buf___6.item.bufp).item.b_ffname).is_void then
												if not ((l_buf___6.item.bufp).item.bt_dontwrite).to_boolean then
													(l_buf___6.item.bufp).item.buf_write_all (0).do_nothing
													if not ((create {P_BUFFER_STATIC}).buf_valid (l_buf___6.item.bufp)).to_boolean then
														l_buf___6.item.bufp := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
													end
												end
											end
										end
									end
								end
							end
						elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("netbeansBuffer"))) = 0 then
							if l_buf___6.is_void then
								Result := 0
								l_return := True
							elseif (l_buf___6.item.bufp).is_void then
								Result := 0
								l_return := True
							end
							if not l_return then
								if (l_args.item.item).to_integer_32 = 84 then
									(l_buf___6.item.bufp).item.b_netbeans_file := 1;
									(l_buf___6.item.bufp).item.b_was_netbeans_file := 1
								else
									(l_buf___6.item.bufp).item.b_netbeans_file := 0
								end
							end
						elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("specialKeys"))) = 0 then
							special_keys___0 (l_args.item)
						elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("actionMenuItem"))) /= 0 then
							l_tmp___52 := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd), ce_string ("version"))
						end
				when 169 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
					if l_return then
						l_pos := -1 + 179 -- skip if block
					end
				when 170 then -- if:
						if inAtomic.item.to_boolean then
							if l_doupdate.to_boolean then
								needupdate.item := 1
								l_doupdate := 0
							end
						end
						if l_buf___6.is_void then
							l_pos := -1 + 178 -- skip if block
						end
				when 171 then -- if:
						if not ((l_buf___6.item.initDone).to_boolean) then
							l_pos := -1 + 178 -- skip if block
						end
				when 172 then -- if:
						if not (l_doupdate.to_boolean) then
							l_pos := -1 + 178 -- skip if block
						end
				when 173 then -- if:;
						(create {P_SCREEN_STATIC}).update_screen (40);
						(create {P_SCREEN_STATIC}).setcursor;
						(create {P_TERM_STATIC}).out_flush
						if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							(create {P_GUI_STATIC}).gui_update_cursor (1, 0);
							(create {P_GUI_GTK_X11_STATIC}).gui_mch_flush
						end
						if (create {P_GLOBALS_STATIC}).State.item /= 513 then
							l_pos := -1 + 176 -- skip if block
						end
				when 174 then -- if:
						l_pos := -1 + 177 -- goto _L___8
				when 175 then -- if block done, skip else block:
						l_pos := -1 + 178
				when 176 then -- else:
						if (create {P_GLOBALS_STATIC}).State.item /= 768 then
							l_pos := -1 + 178 -- skip if block
						end
				when 177 then -- if: | _L___8:
						if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							if (gtk_main_level) > {NATURAL_32} 0 then
								gtk_main_quit
							end
						end
				when 178 then -- if done | if done | if done | if done
						Result := l_retval
				when 179 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	nb_set_curbuf (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		do
			if not ((create {P_GLOBALS_STATIC}).curbuf.item).is_equal (a_buf___6) then
				if ((create {P_WINDOW_STATIC}).buf_jump_open_win (a_buf___6)).is_void then
					(create {P_BUFFER_STATIC}).set_curbuf (a_buf___6, 0)
				end
			end
		end

	coloncmd (a_args: TUPLE [a_cmd: CE_POINTER [INTEGER_8]])
		local
			l_buf___6: CE_ARRAY [INTEGER_8]
			l_ap___0: CE_VA_LIST
		do
			create {CE_INTEGER_8_ARRAY} l_buf___6.make (<<1_024>>)
			create l_ap___0.make_shared (default_pointer)

			l_ap___0 := create {CE_VA_LIST}.make (a_args, agent coloncmd);
			(create {P_MESSAGE_STATIC}).vim_vsnprintf (l_buf___6, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (1_024).to_natural_32), a_args.a_cmd, l_ap___0.twin, create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (default_pointer)).do_nothing;
			(create {P_EX_DOCMD_STATIC}).do_cmdline (create {CE_NATURAL_8_POINTER}.make_cast (l_buf___6), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 10).do_nothing;
			(create {P_SCREEN_STATIC}).setcursor;
			(create {P_TERM_STATIC}).out_flush
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				(create {P_GUI_STATIC}).gui_update_cursor (1, 0);
				(create {P_GUI_GTK_X11_STATIC}).gui_mch_flush
			end
		end

	special_keys___0 (a_args: CE_POINTER [NATURAL_8])
		local
			l_save_str: CE_POINTER [INTEGER_8]
			l_tok: CE_POINTER [INTEGER_8]
			l_sep: CE_POINTER [INTEGER_8]
			l_keybuf: CE_ARRAY [INTEGER_8]
			l_cmdbuf: CE_ARRAY [INTEGER_8]
			l_i___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_8_ARRAY} l_keybuf.make (<<64>>)
			create {CE_INTEGER_8_ARRAY} l_cmdbuf.make (<<256>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_save_str := (nb_unquote (a_args, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)))
					l_tok := (strtok (l_save_str, ce_string (" ")))
				when 1 then -- loop condition:
					if not (not (l_return) and then (not l_tok.is_void)) then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						l_i___0 := 0
						l_sep := strchr (l_tok, ('-').code)
						if l_sep.is_void then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						l_sep[0] := (('%/0/').code).to_integer_8
				when 4 then -- loop condition:
						if not ((l_tok[0]).to_boolean) then
							l_pos := -1 + 8 -- skip loop
						end
				when 5 then -- loop body:
						inspect (l_tok[0]).to_integer_32 -- switch 1 head
						when 65 then l_pos := -1 + 6
						when 77 then l_pos := -1 + 6
						when 67 then l_pos := -1 + 6
						when 83 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 6 then -- switch 1, case 65 | switch 1, case 77 | switch 1, case 67 | switch 1, case 83
						l_tmp___1 := l_i___0
						l_i___0 := l_i___0 + 1
						l_keybuf[l_tmp___1] := l_tok[0]
						l_tmp___2 := l_i___0
						l_i___0 := l_i___0 + 1
						l_keybuf[l_tmp___2] := (('-').code).to_integer_8
						l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
						l_tok := l_tok + 1
						l_pos := -1 + 4 -- back to loop condition
				when 8 then -- loop done
						l_tok := l_tok + 1
				when 9 then -- if done
						strcpy ((l_keybuf + l_i___0), l_tok).do_nothing;
						(create {P_MESSAGE_STATIC}).vim_snprintf ([l_cmdbuf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32), ce_string ("<silent><%%s> :nbkey %%s<CR>"), l_keybuf, l_keybuf]).do_nothing;
						(create {P_GETCHAR_STATIC}).do_map (0, create {CE_NATURAL_8_POINTER}.make_cast (l_cmdbuf), 1, 0).do_nothing
						l_tok := strtok (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), ce_string (" "))
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_save_str))
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_nbclose (a_eap: CE_POINTER [PD_EXARG])
		do
			netbeans_close
		end

	nb_init_graphics
		do
			if not did_init.item.to_boolean then
				coloncmd ([ce_string (":highlight NBGuarded guibg=Cyan guifg=Black ctermbg=LightCyan ctermfg=Black")])
				coloncmd ([ce_string (":sign define %%d linehl=NBGuarded"), 10_000])
				did_init.item := 1
			end
		end

	netbeans_keyname (a_key: INTEGER_32; a_buf___6: CE_POINTER [INTEGER_8])
		require
			not a_buf___6.is_void
		local
			l_name___1: CE_POINTER [INTEGER_8]
			l_namebuf: CE_ARRAY [INTEGER_8]
			l_ctrl: INTEGER_32
			l_shift: INTEGER_32
			l_alt: INTEGER_32
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_8_ARRAY} l_namebuf.make (<<2>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_name___1 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_ctrl := 0
					l_shift := 0
					l_alt := 0
					if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (4)).to_boolean then
						l_ctrl := 1
					end
					if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (2)).to_boolean then
						l_shift := 1
					end
					if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (8)).to_boolean then
						l_alt := 1
					end
					inspect a_key -- switch 1 head
					when -12651 then l_pos := -1 + 1 -- -(107 + ((49).bit_shift_left (8)))
					when -1789 then l_pos := -1 + 2 -- -(253 + ((6).bit_shift_left (8)))
					when -12907 then l_pos := -1 + 3 -- -(107 + ((50).bit_shift_left (8)))
					when -2045 then l_pos := -1 + 4 -- -(253 + ((7).bit_shift_left (8)))
					when -13163 then l_pos := -1 + 5 -- -(107 + ((51).bit_shift_left (8)))
					when -2301 then l_pos := -1 + 6 -- -(253 + ((8).bit_shift_left (8)))
					when -13419 then l_pos := -1 + 7 -- -(107 + ((52).bit_shift_left (8)))
					when -2557 then l_pos := -1 + 8 -- -(253 + ((9).bit_shift_left (8)))
					when -13675 then l_pos := -1 + 9 -- -(107 + ((53).bit_shift_left (8)))
					when -2813 then l_pos := -1 + 10 -- -(253 + ((10).bit_shift_left (8)))
					when -13931 then l_pos := -1 + 11 -- -(107 + ((54).bit_shift_left (8)))
					when -3069 then l_pos := -1 + 12 -- -(253 + ((11).bit_shift_left (8)))
					when -14187 then l_pos := -1 + 13 -- -(107 + ((55).bit_shift_left (8)))
					when -3325 then l_pos := -1 + 14 -- -(253 + ((12).bit_shift_left (8)))
					when -14443 then l_pos := -1 + 15 -- -(107 + ((56).bit_shift_left (8)))
					when -3581 then l_pos := -1 + 16 -- -(253 + ((13).bit_shift_left (8)))
					when -14699 then l_pos := -1 + 17 -- -(107 + ((57).bit_shift_left (8)))
					when -3837 then l_pos := -1 + 18 -- -(253 + ((14).bit_shift_left (8)))
					when -15211 then l_pos := -1 + 19 -- -(107 + ((59).bit_shift_left (8)))
					when -4093 then l_pos := -1 + 20 -- -(253 + ((15).bit_shift_left (8)))
					when -12614 then l_pos := -1 + 21 -- -(70 + ((49).bit_shift_left (8)))
					when -4349 then l_pos := -1 + 22 -- -(253 + ((16).bit_shift_left (8)))
					when -12870 then l_pos := -1 + 23 -- -(70 + ((50).bit_shift_left (8)))
					when -4605 then l_pos := -1 + 24 -- -(253 + ((17).bit_shift_left (8)))
					else l_pos := -1 + 25
					end
				when 1 then -- switch 1, case -(107 + (49 << 8))
					l_name___1 := ce_string ("F1")
					l_pos := -1 + 26 -- switch 1; break
				when 2 then -- switch 1, case -(253 + (6 << 8))
					l_name___1 := ce_string ("F1")
					l_shift := 1
					l_pos := -1 + 26 -- switch 1; break
				when 3 then -- switch 1, case -(107 + (50 << 8))
					l_name___1 := ce_string ("F2")
					l_pos := -1 + 26 -- switch 1; break
				when 4 then -- switch 1, case -(253 + (7 << 8))
					l_name___1 := ce_string ("F2")
					l_shift := 1
					l_pos := -1 + 26 -- switch 1; break
				when 5 then -- switch 1, case -(107 + (51 << 8))
					l_name___1 := ce_string ("F3")
					l_pos := -1 + 26 -- switch 1; break
				when 6 then -- switch 1, case -(253 + (8 << 8))
					l_name___1 := ce_string ("F3")
					l_shift := 1
					l_pos := -1 + 26 -- switch 1; break
				when 7 then -- switch 1, case -(107 + (52 << 8))
					l_name___1 := ce_string ("F4")
					l_pos := -1 + 26 -- switch 1; break
				when 8 then -- switch 1, case -(253 + (9 << 8))
					l_name___1 := ce_string ("F4")
					l_shift := 1
					l_pos := -1 + 26 -- switch 1; break
				when 9 then -- switch 1, case -(107 + (53 << 8))
					l_name___1 := ce_string ("F5")
					l_pos := -1 + 26 -- switch 1; break
				when 10 then -- switch 1, case -(253 + (10 << 8))
					l_name___1 := ce_string ("F5")
					l_shift := 1
					l_pos := -1 + 26 -- switch 1; break
				when 11 then -- switch 1, case -(107 + (54 << 8))
					l_name___1 := ce_string ("F6")
					l_pos := -1 + 26 -- switch 1; break
				when 12 then -- switch 1, case -(253 + (11 << 8))
					l_name___1 := ce_string ("F6")
					l_shift := 1
					l_pos := -1 + 26 -- switch 1; break
				when 13 then -- switch 1, case -(107 + (55 << 8))
					l_name___1 := ce_string ("F7")
					l_pos := -1 + 26 -- switch 1; break
				when 14 then -- switch 1, case -(253 + (12 << 8))
					l_name___1 := ce_string ("F7")
					l_shift := 1
					l_pos := -1 + 26 -- switch 1; break
				when 15 then -- switch 1, case -(107 + (56 << 8))
					l_name___1 := ce_string ("F8")
					l_pos := -1 + 26 -- switch 1; break
				when 16 then -- switch 1, case -(253 + (13 << 8))
					l_name___1 := ce_string ("F8")
					l_shift := 1
					l_pos := -1 + 26 -- switch 1; break
				when 17 then -- switch 1, case -(107 + (57 << 8))
					l_name___1 := ce_string ("F9")
					l_pos := -1 + 26 -- switch 1; break
				when 18 then -- switch 1, case -(253 + (14 << 8))
					l_name___1 := ce_string ("F9")
					l_shift := 1
					l_pos := -1 + 26 -- switch 1; break
				when 19 then -- switch 1, case -(107 + (59 << 8))
					l_name___1 := ce_string ("F10")
					l_pos := -1 + 26 -- switch 1; break
				when 20 then -- switch 1, case -(253 + (15 << 8))
					l_name___1 := ce_string ("F10")
					l_shift := 1
					l_pos := -1 + 26 -- switch 1; break
				when 21 then -- switch 1, case -(70 + (49 << 8))
					l_name___1 := ce_string ("F11")
					l_pos := -1 + 26 -- switch 1; break
				when 22 then -- switch 1, case -(253 + (16 << 8))
					l_name___1 := ce_string ("F11")
					l_shift := 1
					l_pos := -1 + 26 -- switch 1; break
				when 23 then -- switch 1, case -(70 + (50 << 8))
					l_name___1 := ce_string ("F12")
					l_pos := -1 + 26 -- switch 1; break
				when 24 then -- switch 1, case -(253 + (17 << 8))
					l_name___1 := ce_string ("F12")
					l_shift := 1
					l_pos := -1 + 26 -- switch 1; break
				when 25 then -- switch 1, default:
					if a_key >= 32 then
						if a_key <= 126 then
							l_name___1 := l_namebuf
							l_namebuf[0] := a_key.to_integer_8
							l_namebuf[1] := (('%/0/').code).to_integer_8
						else
							l_name___1 := ce_string ("X")
						end
					else
						l_name___1 := ce_string ("X")
					end
					l_pos := -1 + 26 -- switch 1; break
				when 26 then -- switch 1, done:
					a_buf___6[0] := (('%/0/').code).to_integer_8
					if l_ctrl.to_boolean then
						strcat (a_buf___6, ce_string ("C")).do_nothing
					end
					if l_shift.to_boolean then
						strcat (a_buf___6, ce_string ("S")).do_nothing
					end
					if l_alt.to_boolean then
						strcat (a_buf___6, ce_string ("M")).do_nothing
					end
					if l_ctrl.to_boolean then
						strcat (a_buf___6, ce_string ("-")).do_nothing
					elseif l_shift.to_boolean then
						strcat (a_buf___6, ce_string ("-")).do_nothing
					elseif l_alt.to_boolean then
						strcat (a_buf___6, ce_string ("-")).do_nothing
					end
					strcat (a_buf___6, l_name___1).do_nothing
				when 27 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	netbeans_beval_cb (a_beval: CE_POINTER [PD_BALLOONEVALSTRUCT]; a_state: INTEGER_32)
		local
			l_wp___0: CE_ARRAY [CE_POINTER [PD_WINDOW_S]]
			l_text: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_lnum: CE_ARRAY [INTEGER_32]
			l_col: CE_ARRAY [INTEGER_32]
			l_buf___6: CE_ARRAY [INTEGER_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_WINDOW_S]} l_wp___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_text.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_lnum.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_col.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_buf___6.make (<<8_217>>)

			if not ((create {P_OPTION_STATIC}).p_beval.item.item).to_boolean then
				l_return := True
			elseif (create {P_GLOBALS_STATIC}).msg_scrolled.item > 0 then
				l_return := True
			elseif nbsock.item.item = -1 then
				l_return := True
			end
			if not l_return then
				if (a_beval.item.get_beval_info (1, l_wp___0, l_lnum, l_text, l_col)) = 1 then
					if not (l_text.item).is_void then
						if (l_text.item[0]).to_integer_32 /= 0 then
							if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_text.item))) < {NATURAL_32} 4_096 then
								l_p___0 := nb_quote (l_text.item)
								if not l_p___0.is_void then
									(create {P_MESSAGE_STATIC}).vim_snprintf ([l_buf___6, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (8_217).to_natural_32), ce_string ("0:balloonText=%%d %"%%s%"%N"), r_cmdno.item, l_p___0]).do_nothing;
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
								end
								nb_send (l_buf___6, ce_string ("netbeans_beval_cb"))
							end
						end
					end
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_text.item))
				end
			end
		end

	netbeans_active: INTEGER_32
		do
			Result := (nbsock.item.item /= -1).to_integer
		end

	netbeans_filedesc: INTEGER_32
		do
			Result := (nbsock.item.item)
		end

	netbeans_gui_register
		local
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (((create {P_GUI_STATIC}).gui.item.item.starting).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						if nbsock.item.item = -1 then
							l_return := True
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_return := True
				when 7 then -- if done
					if not l_return then
						if inputHandler.item = 0 then
							inputHandler.item := gdk_input_add (nbsock.item.item, (5).to_natural_32, messageFromNetbeans_address, create {CE_VOID_POINTER}.make_shared (default_pointer))
						end
						(create {P_GLOBALS_STATIC}).bevalServers.item := ((create {P_GLOBALS_STATIC}).bevalServers.item).bit_or ((1))
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	netbeans_open (a_params: CE_POINTER [INTEGER_8]; a_doabort: INTEGER_32)
		local
			l_cmd: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_cmd := ce_string ("0:startupDone=0%N")
			if nbsock.item.item /= -1 then
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E511: netbeans already connected"))))).do_nothing
				l_return := True
			end
			if not l_return then
				if (netbeans_connect (a_params, a_doabort)) /= 1 then
					l_return := True
				end
			end
			if not l_return then
				netbeans_gui_register
				nb_send (l_cmd, ce_string ("netbeans_startup_done"));
				(create {P_MOVE_STATIC}).changed_window_setting;
				(create {P_SCREEN_STATIC}).update_screen (50);
				(create {P_SCREEN_STATIC}).setcursor;
				(create {P_TERM_STATIC}).out_flush
				if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
					(create {P_GUI_STATIC}).gui_update_cursor (1, 0);
					(create {P_GUI_GTK_X11_STATIC}).gui_mch_flush
				end
			end
		end

	netbeans_send_disconnect
		local
			l_buf___6: CE_ARRAY [INTEGER_8]
		do
			create {CE_INTEGER_8_ARRAY} l_buf___6.make (<<128>>)

			if nbsock.item.item /= -1 then
				sprintf ([l_buf___6, ce_string ("0:disconnect=%%d%N"), r_cmdno.item]).do_nothing
				nb_send (l_buf___6, ce_string ("netbeans_disconnect"))
			end
		end

	netbeans_file_opened (a_bufp: CE_POINTER [PD_FILE_BUFFER])
		local
			l_bufno: INTEGER_32
			l_buffer: CE_ARRAY [INTEGER_8]
			l_q: CE_POINTER [NATURAL_8]
			l_bp___0: CE_POINTER [PD_NBBUF_STRUCT]
			l_bnum: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_8_ARRAY} l_buffer.make (<<8_192>>)

			l_bufno := (nb_getbufno (a_bufp))
			l_bp___0 := (nb_get_buf ((nb_getbufno (a_bufp))))
			if nbsock.item.item = -1 then
				l_return := True
			end
			if not l_return then
				l_q := nb_quote (a_bufp.item.b_ffname)
				if l_q.is_void then
					l_return := True
				end
			end
			if not l_return then
				if not l_bp___0.is_void then
					l_bnum := l_bufno
				else
					l_bnum := 0
				end
				(create {P_MESSAGE_STATIC}).vim_snprintf ([l_buffer, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (8_192).to_natural_32), ce_string ("%%d:fileOpened=%%d %"%%s%" %%s %%s%N"), l_bnum, 0, create {CE_INTEGER_8_POINTER}.make_cast (l_q), ce_string ("T"), ce_string ("F")]).do_nothing;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_q))
				nb_send (l_buffer, ce_string ("netbeans_file_opened"))
				if ((create {P_OPTION_STATIC}).p_acd.item.item).to_boolean then
					if ((create {P_MISC2_STATIC}).vim_chdirfile (a_bufp.item.b_ffname)) = 1 then
						(create {P_FILEIO_STATIC}).shorten_fnames (1)
					end
				end
			end
		end

	nb_bufp2nbbuf_fire (a_bufp: CE_POINTER [PD_FILE_BUFFER]; a_bufnop: CE_POINTER [INTEGER_32]): CE_POINTER [PD_NBBUF_STRUCT]
		local
			l_bufno: INTEGER_32
			l_nbbuf: CE_POINTER [PD_NBBUF_STRUCT]
			l_return: BOOLEAN
		do
			if nbsock.item.item = -1 then
				Result := (create {CE_CLASS_POINTER [PD_NBBUF_STRUCT]}.make_shared (default_pointer))
				l_return := True
			elseif not ((create {P_GLOBALS_STATIC}).netbeansFireChanges.item).to_boolean then
				Result := (create {CE_CLASS_POINTER [PD_NBBUF_STRUCT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_bufno := nb_getbufno (a_bufp)
				if l_bufno <= 0 then
					Result := (create {CE_CLASS_POINTER [PD_NBBUF_STRUCT]}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				l_nbbuf := nb_get_buf (l_bufno)
				if not l_nbbuf.is_void then
					if not (l_nbbuf.item.fireChanges).to_boolean then
						Result := (create {CE_CLASS_POINTER [PD_NBBUF_STRUCT]}.make_shared (default_pointer))
						l_return := True
					end
				end
			end
			if not l_return then
				a_bufnop.item := l_bufno
				Result := l_nbbuf
			end
		end

	netbeans_inserted (a_bufp: CE_POINTER [PD_FILE_BUFFER]; a_linenr: INTEGER_32; a_col: INTEGER_32; a_txt: CE_POINTER [NATURAL_8]; a_newlen: INTEGER_32)
		local
			l_buf___6: CE_POINTER [NATURAL_8]
			l_bufno: CE_ARRAY [INTEGER_32]
			l_nbbuf: CE_POINTER [PD_NBBUF_STRUCT]
			l_pos___3: CE_ARRAY [PD_POS_T]
			l_off___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_newtxt: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_bufno.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_POS_T]} l_pos___3.make (<<1>>)

			if nbsock.item.item = -1 then
				l_return := True
			end
			if not l_return then
				l_nbbuf := nb_bufp2nbbuf_fire (a_bufp, l_bufno)
				if l_nbbuf.is_void then
					l_return := True
				end
			end
			if not l_return then
				if (l_nbbuf.item.insertDone).to_boolean then
					l_nbbuf.item.modified := {NATURAL_32} 1
				end
				l_pos___3.item.lnum := a_linenr
				l_pos___3.item.col := a_col
				l_off___0 := a_bufp.item.pos2off (l_pos___3)
				l_newtxt := (create {P_MISC2_STATIC}).alloc ((a_newlen + 1).to_natural_32);
				(create {P_MISC2_STATIC}).vim_strncpy (l_newtxt, a_txt, a_newlen.to_natural_32)
				l_p___0 := nb_quote (l_newtxt)
				if not l_p___0.is_void then
					l_buf___6 := (create {P_MISC2_STATIC}).alloc ((128 + 2 * a_newlen).to_natural_32)
					sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("%%d:insert=%%d %%ld %"%%s%"%N"), l_bufno.item, r_cmdno.item, l_off___0, l_p___0]).do_nothing
					nb_send (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("netbeans_inserted"));
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0));
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6))
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_newtxt))
			end
		end

	netbeans_removed (a_bufp: CE_POINTER [PD_FILE_BUFFER]; a_linenr: INTEGER_32; a_col: INTEGER_32; a_len: INTEGER_32)
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_bufno: CE_ARRAY [INTEGER_32]
			l_nbbuf: CE_POINTER [PD_NBBUF_STRUCT]
			l_pos___3: CE_ARRAY [PD_POS_T]
			l_off___0: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<128>>)
			create {CE_INTEGER_32_ARRAY} l_bufno.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_POS_T]} l_pos___3.make (<<1>>)

			if nbsock.item.item = -1 then
				l_return := True
			end
			if not l_return then
				l_nbbuf := nb_bufp2nbbuf_fire (a_bufp, l_bufno)
				if l_nbbuf.is_void then
					l_return := True
				end
			end
			if not l_return and then (a_len < 0) then
				l_return := True
			end
			if not l_return then
				l_nbbuf.item.modified := {NATURAL_32} 1
				l_pos___3.item.lnum := a_linenr
				l_pos___3.item.col := a_col
				l_off___0 := a_bufp.item.pos2off (l_pos___3)
				sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("%%d:remove=%%d %%ld %%ld%N"), l_bufno.item, r_cmdno.item, l_off___0, a_len]).do_nothing
				nb_send (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("netbeans_removed"))
			end
		end

	netbeans_button_release (a_button: INTEGER_32)
		local
			l_buf___6: CE_ARRAY [INTEGER_8]
			l_bufno: INTEGER_32
			l_col: INTEGER_32
			l_tmp: INTEGER_32
			l_off___0: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_8_ARRAY} l_buf___6.make (<<128>>)

			if nbsock.item.item = -1 then
				l_return := True
			end
			if not l_return then
				l_bufno := nb_getbufno ((create {P_GLOBALS_STATIC}).curbuf.item)
				if l_bufno >= 0 then
					if not ((create {P_GLOBALS_STATIC}).curwin.item).is_void then
						if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer).is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
							if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_nu).to_boolean then
								l_tmp := 9
							elseif ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_rnu).to_boolean then
								l_tmp := 9
							else
								l_tmp := 1
							end
							l_col := ((create {P_GLOBALS_STATIC}).mouse_col.item - (create {P_GLOBALS_STATIC}).curwin.item.item.w_wincol) - l_tmp
							l_off___0 := (((create {P_GLOBALS_STATIC}).curbuf.item).item.pos2off (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))))
							sprintf ([l_buf___6, ce_string ("%%d:newDotAndMark=%%d %%ld %%ld%N"), l_bufno, r_cmdno.item, l_off___0, l_off___0]).do_nothing
							nb_send (l_buf___6, ce_string ("netbeans_button_release[newDotAndMark]"))
							sprintf ([l_buf___6, ce_string ("%%d:buttonRelease=%%d %%d %%ld %%d%N"), l_bufno, r_cmdno.item, a_button, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_col]).do_nothing
							nb_send (l_buf___6, ce_string ("netbeans_button_release"))
						end
					end
				end
			end
		end

	netbeans_keycommand (a_key: INTEGER_32): INTEGER_32
		local
			l_keyName: CE_ARRAY [INTEGER_8]
		do
			create {CE_INTEGER_8_ARRAY} l_keyName.make (<<60>>)

			netbeans_keyname (a_key, l_keyName)
			Result := (netbeans_keystring (create {CE_NATURAL_8_POINTER}.make_cast (l_keyName)))
		end

	netbeans_keystring (a_keyName: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_buf___6: CE_ARRAY [INTEGER_8]
			l_bufno: INTEGER_32
			l_off___0: INTEGER_32
			l_q: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			create {CE_INTEGER_8_ARRAY} l_buf___6.make (<<8_192>>)

			l_bufno := (nb_getbufno ((create {P_GLOBALS_STATIC}).curbuf.item))
			if nbsock.item.item = -1 then
				Result := 1
				l_return := True
			end
			if not l_return and then (l_bufno = -1) then
				if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname).is_void then
					l_q := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
				else
					l_q := (nb_quote ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname))
				end
				if l_q.is_void then
					Result := 1
					l_return := True
				end
				if not l_return then
					(create {P_MESSAGE_STATIC}).vim_snprintf ([l_buf___6, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (8_192).to_natural_32), ce_string ("0:fileOpened=%%d %"%%s%" %%s %%s%N"), 0, l_q, ce_string ("T"), ce_string ("F")]).do_nothing
					if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname).is_void then
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_q))
					end
					nb_send (l_buf___6, ce_string ("netbeans_keycommand"))
					postpone_keycommand (a_keyName)
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_off___0 := ((create {P_GLOBALS_STATIC}).curbuf.item).item.pos2off (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")))
				sprintf ([l_buf___6, ce_string ("%%d:newDotAndMark=%%d %%ld %%ld%N"), l_bufno, r_cmdno.item, l_off___0, l_off___0]).do_nothing
				nb_send (l_buf___6, ce_string ("netbeans_keycommand"));
				(create {P_MESSAGE_STATIC}).vim_snprintf ([l_buf___6, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (8_192).to_natural_32), ce_string ("%%d:keyCommand=%%d %"%%s%"%N"), l_bufno, r_cmdno.item, a_keyName]).do_nothing
				nb_send (l_buf___6, ce_string ("netbeans_keycommand"));
				(create {P_MESSAGE_STATIC}).vim_snprintf ([l_buf___6, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (8_192).to_natural_32), ce_string ("%%d:keyAtPos=%%d %"%%s%" %%ld %%ld/%%ld%N"), l_bufno, r_cmdno.item, a_keyName, l_off___0, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col).to_integer_32]).do_nothing
				nb_send (l_buf___6, ce_string ("netbeans_keycommand"))
				Result := 1
			end
		end

	netbeans_save_buffer (a_bufp: CE_POINTER [PD_FILE_BUFFER])
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_bufno: CE_ARRAY [INTEGER_32]
			l_nbbuf: CE_POINTER [PD_NBBUF_STRUCT]
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<64>>)
			create {CE_INTEGER_32_ARRAY} l_bufno.make (<<1>>)

			if nbsock.item.item = -1 then
				l_return := True
			end
			if not l_return then
				l_nbbuf := nb_bufp2nbbuf_fire (a_bufp, l_bufno)
				if l_nbbuf.is_void then
					l_return := True
				end
			end
			if not l_return then
				l_nbbuf.item.modified := {NATURAL_32} 0
				sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("%%d:save=%%d%N"), l_bufno.item, r_cmdno.item]).do_nothing
				nb_send (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("netbeans_save_buffer"))
			end
		end

	netbeans_is_guarded (a_top, a_bot: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [PD_SIGNLIST]
			l_lnum: INTEGER_32
			l_return: BOOLEAN
		do
			if nbsock.item.item = -1 then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_p___0 := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_signlist
				from
				until
					not (not (l_return) and then (not l_p___0.is_void))
				loop
					if l_p___0.item.id >= 1_000_000 then
						l_lnum := (a_top + 1).to_integer_32
						from
						until
							not (not (l_return) and then (l_lnum.to_integer_32 < a_bot))
						loop
							if l_lnum.to_integer_32 = l_p___0.item.lnum then
								Result := 1
								l_return := True
							end
							if not l_return then
								l_lnum := l_lnum + 1
							end
						end
					end
					if not l_return then
						l_p___0 := l_p___0.item.next
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	netbeans_draw_multisign_indicator (a_row: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_y: INTEGER_32
			l_x___0: INTEGER_32
			l_drawable: CE_POINTER [SD_GDKDRAWABLE]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			l_drawable := ((create {P_GUI_STATIC}).gui.item.item.drawarea).item.window
			if nbsock.item.item = -1 then
				l_return := True
			end
			if not l_return then
				l_x___0 := 0
				l_y := a_row * (create {P_GUI_STATIC}).gui.item.item.char_height + 2
				l_i___0 := 0
				from
				until
					not (l_i___0 < (create {P_GUI_STATIC}).gui.item.item.char_height - 3)
				loop
					l_tmp := l_y
					l_y := l_y + 1
					gdk_draw_point (l_drawable, (create {P_GUI_STATIC}).gui.item.item.text_gc, l_x___0 + 2, l_tmp)
					l_i___0 := l_i___0 + 1
				end
				gdk_draw_point (l_drawable, (create {P_GUI_STATIC}).gui.item.item.text_gc, l_x___0, l_y)
				gdk_draw_point (l_drawable, (create {P_GUI_STATIC}).gui.item.item.text_gc, l_x___0 + 2, l_y)
				l_tmp___0 := l_y
				l_y := l_y + 1
				gdk_draw_point (l_drawable, (create {P_GUI_STATIC}).gui.item.item.text_gc, l_x___0 + 4, l_tmp___0)
				gdk_draw_point (l_drawable, (create {P_GUI_STATIC}).gui.item.item.text_gc, l_x___0 + 1, l_y)
				gdk_draw_point (l_drawable, (create {P_GUI_STATIC}).gui.item.item.text_gc, l_x___0 + 2, l_y)
				l_tmp___1 := l_y
				l_y := l_y + 1
				gdk_draw_point (l_drawable, (create {P_GUI_STATIC}).gui.item.item.text_gc, l_x___0 + 3, l_tmp___1)
				gdk_draw_point (l_drawable, (create {P_GUI_STATIC}).gui.item.item.text_gc, l_x___0 + 2, l_y)
			end
		end

	mapsigntype (a_buf___6: CE_POINTER [PD_NBBUF_STRUCT]; a_localsigntype: INTEGER_32): INTEGER_32
		local
			l_localsigntype: INTEGER_32
			l_return: BOOLEAN
		do
			l_localsigntype := a_localsigntype
			l_localsigntype := l_localsigntype - 1
			if l_localsigntype >= 0 then
				if l_localsigntype < (a_buf___6.item.signmapused).to_integer_32 then
					Result := (a_buf___6.item.signmap[l_localsigntype])
					l_return := True
				end
			end
			if not l_return then
				Result := 0
			end
		end

	print_save_msg (a_buf___6: CE_POINTER [PD_NBBUF_STRUCT]; a_nchars: INTEGER_32)
		local
			l_c: NATURAL_8
			l_p___0: CE_POINTER [NATURAL_8]
			l_ebuf: CE_ARRAY [NATURAL_8]
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_ebuf.make (<<8_192>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_nchars >= 0) then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:;
						(create {P_FILEIO_STATIC}).msg_add_fname (a_buf___6.item.bufp, (a_buf___6.item.bufp).item.b_ffname)
						l_c := (0).to_natural_8;
						(create {P_FILEIO_STATIC}).msg_add_lines (l_c.to_integer_32, (a_buf___6.item.bufp).item.b_ml.ml_line_count, (a_buf___6.item.bufp).item.b_orig_size);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).keep_msg.item));
						(create {P_GLOBALS_STATIC}).keep_msg.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
						(create {P_GLOBALS_STATIC}).msg_scrolled_ign.item := 1
						l_p___0 := (create {P_MESSAGE_STATIC}).msg_trunc_attr ((create {P_GLOBALS_STATIC}).IObuff.item, 0, 0)
						if not (((create {P_GLOBALS_STATIC}).msg_scrolled.item).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if not ((create {P_GLOBALS_STATIC}).need_wait_return.item).to_boolean then
							(create {P_MESSAGE_STATIC}).set_keep_msg (l_p___0, 0)
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if not (a_buf___6.item.initDone).to_boolean then
							(create {P_MESSAGE_STATIC}).set_keep_msg (l_p___0, 0)
						end
				when 5 then;
						(create {P_GLOBALS_STATIC}).msg_scrolled_ign.item := 0
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_ebuf), (gettext (ce_string ("E505: ")))).do_nothing
						strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_ebuf), create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item)).do_nothing
						strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_ebuf), (gettext (ce_string ("is read-only (add ! to override)")))).do_nothing
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), create {CE_INTEGER_8_POINTER}.make_cast (l_ebuf)).do_nothing;
						(create {P_MESSAGE_STATIC}).emsg ((create {P_GLOBALS_STATIC}).IObuff.item).do_nothing
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY} -- routine addresses

	messageFromNetbeans_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent messageFromNetbeans)
		end

	ex_nbclose_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_nbclose)
		end

end
