class
	P_POPUPMNU_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC

feature {ANY} -- public attributes

	pum_array: CE_STATIC [CE_POINTER [PD_PUMITEM_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_PUMITEM_T]}.make_shared (default_pointer)
		end

	pum_size: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	pum_selected: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	pum_first: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	pum_height: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	pum_width: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	pum_base_width: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	pum_kind_width: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	pum_scrollbar: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	pum_row: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	pum_col: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	pum_do_redraw: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	pum_display (a_array: CE_POINTER [PD_PUMITEM_T]; a_size, a_selected: INTEGER_32)
		local
			l_w: INTEGER_32
			l_def_width: INTEGER_32
			l_max_width: INTEGER_32
			l_kind_width: INTEGER_32
			l_extra_width: INTEGER_32
			l_i___0: INTEGER_32
			l_top_clear: INTEGER_32
			l_row: INTEGER_32
			l_context_lines: INTEGER_32
			l_col: INTEGER_32
			l_above_row: INTEGER_32
			l_redo_count: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_above_row := (create {P_GLOBALS_STATIC}).cmdline_row.item
					l_redo_count := 0
				when 1 then -- redo:
					l_def_width := 15
					l_max_width := 0
					l_kind_width := 0
					l_extra_width := 0
					pum_array.item := create {CE_CLASS_POINTER [PD_PUMITEM_T]}.make_shared (default_pointer + 1);
					(create {P_MOVE_STATIC}).validate_cursor_col
					pum_array.item := create {CE_CLASS_POINTER [PD_PUMITEM_T]}.make_shared (default_pointer)
					l_row := (create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow + (create {P_GLOBALS_STATIC}).curwin.item.item.w_winrow
					if ((create {P_GLOBALS_STATIC}).firstwin.item.item.w_onebuf_opt.wo_pvw).to_boolean then
						l_top_clear := (create {P_GLOBALS_STATIC}).firstwin.item.item.w_height
					else
						l_top_clear := 0
					end
					if ((create {P_GLOBALS_STATIC}).lastwin.item.item.w_onebuf_opt.wo_pvw).to_boolean then
						l_above_row := l_above_row - (((create {P_GLOBALS_STATIC}).lastwin.item.item.w_height + (create {P_GLOBALS_STATIC}).lastwin.item.item.w_status_height) + 1)
					end
					if a_size < 10 then
						pum_height.item := a_size
					else
						pum_height.item := 10
					end
					if (create {P_OPTION_STATIC}).p_ph.item.item > 0 then
						if pum_height.item.to_integer_32 > (create {P_OPTION_STATIC}).p_ph.item.item then
							pum_height.item := ((create {P_OPTION_STATIC}).p_ph.item.item).to_integer_32
						end
					end
					if not (l_row + 2 >= l_above_row - pum_height.item) then
						l_pos := -1 + 4 -- skip if block
					end
				when 2 then -- if:
						if l_row > (l_above_row - l_top_clear) // 2 then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow - (create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_row >= 2 then
								l_context_lines := 2
							else
								l_context_lines := (create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow - (create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_row
							end
							if l_row >= a_size + l_context_lines then
								pum_row.item := (l_row - a_size) - l_context_lines
								pum_height.item := a_size
							else
								pum_row.item := 0
								pum_height.item := l_row - l_context_lines
							end
							if (create {P_OPTION_STATIC}).p_ph.item.item > 0 then
								if pum_height.item.to_integer_32 > (create {P_OPTION_STATIC}).p_ph.item.item then
									pum_row.item := (pum_row.item.to_integer_32 + (pum_height.item.to_integer_32 - (create {P_OPTION_STATIC}).p_ph.item.item)).to_integer_32
									pum_height.item := ((create {P_OPTION_STATIC}).p_ph.item.item).to_integer_32
								end
							end
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_row + (create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_height) - (create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow >= 3 then
							l_context_lines := 3
						else
							l_context_lines := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_row + (create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_height) - (create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow
						end
						pum_row.item := l_row + l_context_lines
						if a_size > l_above_row - pum_row.item then
							pum_height.item := l_above_row - pum_row.item
						else
							pum_height.item := a_size
						end
						if (create {P_OPTION_STATIC}).p_ph.item.item > 0 then
							if pum_height.item.to_integer_32 > (create {P_OPTION_STATIC}).p_ph.item.item then
								pum_height.item := ((create {P_OPTION_STATIC}).p_ph.item.item).to_integer_32
							end
						end
				when 5 then
					if pum_height.item < 1 then
						l_return := True
					elseif pum_height.item = 1 then
						if a_size > 1 then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 14 -- skip if block
					end
				when 6 then -- if:
						if ((create {P_GLOBALS_STATIC}).firstwin.item.item.w_onebuf_opt.wo_pvw).to_boolean then
							if pum_row.item < (create {P_GLOBALS_STATIC}).firstwin.item.item.w_height then
								if pum_height.item > (create {P_GLOBALS_STATIC}).firstwin.item.item.w_height + 4 then
									pum_row.item := pum_row.item + ((create {P_GLOBALS_STATIC}).firstwin.item.item.w_height)
									pum_height.item := pum_height.item - ((create {P_GLOBALS_STATIC}).firstwin.item.item.w_height)
								end
							end
						end
						l_i___0 := 0
						from
						until
							not (l_i___0 < a_size)
						loop
							l_w := (create {P_CHARSET_STATIC}).vim_strsize ((a_array + l_i___0).item.pum_text)
							if l_max_width < l_w then
								l_max_width := l_w
							end
							if not ((a_array + l_i___0).item.pum_kind).is_void then
								l_w := ((create {P_CHARSET_STATIC}).vim_strsize ((a_array + l_i___0).item.pum_kind)) + 1
								if l_kind_width < l_w then
									l_kind_width := l_w
								end
							end
							if not ((a_array + l_i___0).item.pum_extra).is_void then
								l_w := ((create {P_CHARSET_STATIC}).vim_strsize ((a_array + l_i___0).item.pum_extra)) + 1
								if l_extra_width < l_w then
									l_extra_width := l_w
								end
							end
							l_i___0 := l_i___0 + 1
						end
						pum_base_width.item := l_max_width
						pum_kind_width.item := l_kind_width
						l_col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_wincol + (create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol
						if pum_height.item < a_size then
							pum_scrollbar.item := 1
							l_max_width := l_max_width + 1
						else
							pum_scrollbar.item := 0
						end
						if l_def_width < l_max_width then
							l_def_width := l_max_width
						end
						if not (l_col.to_integer_32 < (create {P_GLOBALS_STATIC}).Columns.item.item - 15) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if not (l_col.to_integer_32 < (create {P_GLOBALS_STATIC}).Columns.item.item - l_max_width.to_integer_32) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L___0:
						pum_col.item := l_col
						pum_width.item := (((create {P_GLOBALS_STATIC}).Columns.item.item - pum_col.item.to_integer_32) - pum_scrollbar.item.to_integer_32).to_integer_32
						if pum_width.item > ((l_max_width + l_kind_width) + l_extra_width) + 1 then
							if pum_width.item > 15 then
								pum_width.item := ((l_max_width + l_kind_width) + l_extra_width) + 1
								if pum_width.item < 15 then
									pum_width.item := 15
								end
							end
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						if (create {P_GLOBALS_STATIC}).Columns.item.item < l_def_width.to_integer_32 then
							pum_col.item := 0
							pum_width.item := ((create {P_GLOBALS_STATIC}).Columns.item.item - 1).to_integer_32
						else
							if l_max_width > 15 then
								l_max_width := 15
							end
							pum_col.item := ((create {P_GLOBALS_STATIC}).Columns.item.item - l_max_width.to_integer_32).to_integer_32
							pum_width.item := l_max_width - pum_scrollbar.item
						end
				when 13 then -- if done
						pum_array.item := a_array
						pum_size.item := a_size
						if (pum_set_selected (a_selected, l_redo_count)).to_boolean then
							l_redo_count := l_redo_count + 1
							if l_redo_count <= 2 then
								l_pos := -1 + 1 -- goto redo
							end
						end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	pum_redraw
		local
			l_row: INTEGER_32
			l_col: INTEGER_32
			l_attr_norm: INTEGER_32
			l_attr_select: INTEGER_32
			l_attr_scroll: INTEGER_32
			l_attr_thumb: INTEGER_32
			l_attr: INTEGER_32
			l_i___0: INTEGER_32
			l_idx: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_totwidth: INTEGER_32
			l_width: INTEGER_32
			l_w: INTEGER_32
			l_thumb_pos: INTEGER_32
			l_thumb_heigth: INTEGER_32
			l_round: INTEGER_32
			l_n: INTEGER_32
			l_tmp___0: INTEGER_32
			l_st: CE_POINTER [NATURAL_8]
			l_saved: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_row := pum_row.item
					l_attr_norm := (create {P_GLOBALS_STATIC}).highlight_attr.item[31]
					l_attr_select := (create {P_GLOBALS_STATIC}).highlight_attr.item[32]
					l_attr_scroll := (create {P_GLOBALS_STATIC}).highlight_attr.item[33]
					l_attr_thumb := (create {P_GLOBALS_STATIC}).highlight_attr.item[34]
					l_p___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_thumb_pos := 0
					l_thumb_heigth := 1
					if pum_scrollbar.item.to_boolean then
						l_thumb_heigth := (pum_height.item * pum_height.item) // pum_size.item
						if l_thumb_heigth = 0 then
							l_thumb_heigth := 1
						end
						l_thumb_pos := (pum_first.item * (pum_height.item - l_thumb_heigth) + (pum_size.item - pum_height.item) // 2) // (pum_size.item - pum_height.item)
					end
					l_i___0 := 0
				when 1 then -- loop condition:
					if not (not (l_return) and then (l_i___0 < pum_height.item)) then
						l_pos := -1 + 34 -- skip loop
					end
				when 2 then -- loop body:
						l_idx := l_i___0 + pum_first.item
						if l_idx = pum_selected.item then
							l_attr := l_attr_select
						else
							l_attr := l_attr_norm
						end
						if pum_col.item > 0 then
							(create {P_SCREEN_STATIC}).screen_putchar ((' ').code, l_row, pum_col.item - 1, l_attr)
						end
						l_col := pum_col.item
						l_totwidth := 0
						l_round := 1
				when 3 then -- loop condition:
						if not (not (l_return or l_break) and then (l_round <= 3)) then
							l_pos := -1 + 33 -- skip loop
						end
				when 4 then -- loop body:
						l_break := False
						l_width := 0
						l_s := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						inspect l_round -- switch 1 head
						when 1 then l_pos := -1 + 5
						when 2 then l_pos := -1 + 6
						when 3 then l_pos := -1 + 7
						else l_pos := -1 + 8
						end
				when 5 then -- switch 1, case 1
						l_p___0 := (pum_array.item + l_idx).item.pum_text
						l_pos := -1 + 8 -- switch 1; break
				when 6 then -- switch 1, case 2
						l_p___0 := (pum_array.item + l_idx).item.pum_kind
						l_pos := -1 + 8 -- switch 1; break
				when 7 then -- switch 1, case 3
						l_p___0 := (pum_array.item + l_idx).item.pum_extra
						l_pos := -1 + 8 -- switch 1; break
				when 8 then -- switch 1, done:
						if l_p___0.is_void then
							l_pos := -1 + 22 -- skip if block
						end
				when 9 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 21 -- skip loop
						end
				when 10 then -- loop body:
						l_break := False
						if l_s.is_void then
							l_s := l_p___0
						end
						l_w := (create {P_CHARSET_STATIC}).ptr2cells (l_p___0)
						if (l_p___0.item).to_integer_32 /= 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else:
						if (l_p___0.item).to_integer_32 /= 9 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 16 then -- else:
						if not (l_totwidth + l_w > pum_width.item) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if: | _L:
						l_saved := (l_p___0.item).to_integer_32
						l_p___0.item := (('%/0/').code).to_natural_8
						l_st := (create {P_CHARSET_STATIC}).transstr (l_s)
						l_p___0.item := l_saved.to_natural_8
						if not l_st.is_void then
							(create {P_SCREEN_STATIC}).screen_puts_len (l_st, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_st))).to_integer_32, l_row, l_col, l_attr);
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_st))
						end
						l_col := l_col + l_width
						if (l_p___0.item).to_integer_32 /= 9 then
							l_break := True
						end
						if not (l_break) then
							(create {P_SCREEN_STATIC}).screen_puts_len (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("  ")), 2, l_row, l_col, l_attr)
							l_col := l_col + (2)
							l_totwidth := l_totwidth + (2)
							l_s := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							l_width := 0
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:
						l_width := l_width + l_w
				when 20 then -- if done | if done
						if not (l_break) then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___0 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0]))
							else
								l_tmp___0 := 1
							end
							l_p___0 := l_p___0 + l_tmp___0
						end
						l_pos := -1 + 9 -- back to loop condition
				when 21 then -- loop done
						l_break := False
				when 22 then -- if done
						if l_round > 1 then
							l_n := pum_kind_width.item + 1
						else
							l_n := 1
						end
						if l_round /= 3 then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_break := True
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 25 then -- else:
						if l_round /= 2 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						if ((pum_array.item + l_idx).item.pum_extra).is_void then
							l_break := True
						else
							l_pos := -1 + 28 -- goto _L___2
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 28 then -- else: | _L___2:
						if l_round /= 1 then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						if ((pum_array.item + l_idx).item.pum_kind).is_void then
							if ((pum_array.item + l_idx).item.pum_extra).is_void then
								l_break := True
							else
								l_pos := -1 + 31 -- goto _L___1
							end
						else
							l_pos := -1 + 31 -- goto _L___1
						end
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 31 then -- else: | _L___1:
						if pum_base_width.item + l_n >= pum_width.item then
							l_break := True
						end
				when 32 then -- if done | if done
						if not (l_return or l_break) then
							(create {P_SCREEN_STATIC}).screen_fill (l_row, l_row + 1, l_col, (pum_col.item + pum_base_width.item) + l_n, (' ').code, (' ').code, l_attr)
							l_col := (pum_col.item + pum_base_width.item) + l_n
							l_totwidth := pum_base_width.item + l_n
							l_round := l_round + 1
						end
						l_pos := -1 + 3 -- back to loop condition
				when 33 then -- loop done
						l_break := False;
						(create {P_SCREEN_STATIC}).screen_fill (l_row, l_row + 1, l_col, pum_col.item + pum_width.item, (' ').code, (' ').code, l_attr)
						if pum_scrollbar.item > 0 then
							if l_i___0 >= l_thumb_pos then
								if l_i___0 < l_thumb_pos + l_thumb_heigth then
									l_tmp___2 := l_attr_thumb
								else
									l_tmp___2 := l_attr_scroll
								end
							else
								l_tmp___2 := l_attr_scroll
							end
							(create {P_SCREEN_STATIC}).screen_putchar ((' ').code, l_row, pum_col.item + pum_width.item, l_tmp___2)
						end
						l_row := l_row + 1
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 1 -- back to loop condition
				when 34 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	pum_set_selected (a_n, a_repeat: INTEGER_32): INTEGER_32
		local
			l_resized: INTEGER_32
			l_context: INTEGER_32
			l_curwin_save: CE_POINTER [PD_WINDOW_S]
			l_res: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [NATURAL_8]
			l_lnum: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_resized := 0
					l_context := pum_height.item // 2
					pum_selected.item := a_n
					if not (pum_selected.item >= 0) then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if not (pum_selected.item < pum_size.item) then
							l_pos := -1 + 12 -- skip if block
						end
				when 2 then -- if:
						if pum_first.item > pum_selected.item - 4 then
							if pum_first.item > pum_selected.item - 2 then
								pum_first.item := pum_first.item - (pum_height.item - 2)
								if pum_first.item < 0 then
									pum_first.item := 0
								elseif pum_first.item > pum_selected.item then
									pum_first.item := pum_selected.item
								end
							else
								pum_first.item := pum_selected.item
							end
						elseif pum_first.item < (pum_selected.item - pum_height.item) + 5 then
							if pum_first.item < ((pum_selected.item - pum_height.item) + 1) + 2 then
								pum_first.item := pum_first.item + (pum_height.item - 2)
								if pum_first.item < (pum_selected.item - pum_height.item) + 1 then
									pum_first.item := (pum_selected.item - pum_height.item) + 1
								end
							else
								pum_first.item := (pum_selected.item - pum_height.item) + 1
							end
						end
						if l_context > 3 then
							l_context := 3
						end
						if pum_height.item > 2 then
							if pum_first.item > pum_selected.item - l_context then
								pum_first.item := pum_selected.item - l_context
								if pum_first.item < 0 then
									pum_first.item := 0
								end
							elseif pum_first.item < ((pum_selected.item + l_context) - pum_height.item) + 1 then
								pum_first.item := ((pum_selected.item + l_context) - pum_height.item) + 1
							end
						end
						if ((pum_array.item + pum_selected.item).item.pum_info).is_void then
							l_pos := -1 + 12 -- skip if block
						end
				when 3 then -- if:
						if not ((create {P_GLOBALS_STATIC}).Rows.item.item > 10) then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if not (a_repeat <= 1) then
							l_pos := -1 + 12 -- skip if block
						end
				when 5 then -- if:
						if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cot.item.item, ('p').code)).is_void then
							l_pos := -1 + 12 -- skip if block
						end
				when 6 then -- if:
						l_curwin_save := (create {P_GLOBALS_STATIC}).curwin.item
						l_res := 1;
						(create {P_GLOBALS_STATIC}).g_do_tagpreview.item := 3
						l_resized := (create {P_EX_CMDS_STATIC}).prepare_tagpreview (0);
						(create {P_GLOBALS_STATIC}).g_do_tagpreview.item := 0
						if not (((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_pvw).to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname).is_void) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bt[0]).to_integer_32 = 110 then
							if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bt[2]).to_integer_32 = 102 then
								if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bh[0]).to_integer_32 = 119 then
									from
									until
										(l_break)
									loop
										l_break := False
										if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count = 1 then
											if (((create {P_MEMLINE_STATIC}).ml_get ((1).to_integer_32)).item).to_integer_32 = 0 then
												l_break := True
											end
										end
										if not (l_break) then
											(create {P_MEMLINE_STATIC}).ml_delete ((1).to_integer_32, 0).do_nothing
										end
									end
									l_break := False
								else
									l_pos := -1 + 10 -- goto _L___1
								end
							else
								l_pos := -1 + 10 -- goto _L___1
							end
						else
							l_pos := -1 + 10 -- goto _L___1
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L___1:;
						(create {P_GLOBALS_STATIC}).no_u_sync.item := (create {P_GLOBALS_STATIC}).no_u_sync.item + 1
						l_res := (create {P_EX_CMDS_STATIC}).do_ecmd (0, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer), (1).to_integer_32, 0, create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer));
						(create {P_GLOBALS_STATIC}).no_u_sync.item := (create {P_GLOBALS_STATIC}).no_u_sync.item - 1
						if l_res = 1 then
							(create {P_OPTION_STATIC}).set_option_value (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("swf")), 0, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 4);
							(create {P_OPTION_STATIC}).set_option_value (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bt")), 0, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("nofile")), 4);
							(create {P_OPTION_STATIC}).set_option_value (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bh")), 0, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("wipe")), 4);
							(create {P_OPTION_STATIC}).set_option_value (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("diff")), 0, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 4)
						end
				when 11 then
						if l_res = 1 then
							l_lnum := (0).to_integer_32
							l_p___0 := (pum_array.item + pum_selected.item).item.pum_info
							from
							until
								not (not (l_break) and then ((l_p___0.item).to_integer_32 /= 0))
							loop
								l_break := False
								l_e := (create {P_MISC2_STATIC}).vim_strchr (l_p___0, ('%N').code)
								if l_e.is_void then
									l_tmp___0 := l_lnum
									l_lnum := l_lnum + 1;
									(create {P_MEMLINE_STATIC}).ml_append (l_tmp___0, l_p___0, 0, 0).do_nothing
									l_break := True
								else
									l_e.item := (('%/0/').code).to_natural_8
									l_tmp___1 := l_lnum
									l_lnum := l_lnum + 1;
									(create {P_MEMLINE_STATIC}).ml_append (l_tmp___1, l_p___0, (l_e.distance (l_p___0)) + 1, 0).do_nothing
									l_e.item := (('%N').code).to_natural_8
									l_p___0 := l_e + 1
								end
							end
							l_break := False
							if a_repeat = 0 then
								if l_lnum > (create {P_OPTION_STATIC}).p_pvh.item.item then
									l_lnum := (create {P_OPTION_STATIC}).p_pvh.item.item
								end
								if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_height).to_integer_32 < l_lnum then
									(create {P_WINDOW_STATIC}).win_setheight (l_lnum.to_integer_32)
									l_resized := 1
								end
							end
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_changed := 0;
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ma := 0;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (1).to_integer_32;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
							if not ((create {P_GLOBALS_STATIC}).curwin.item).is_equal (l_curwin_save) then
								if ((create {P_WINDOW_STATIC}).win_valid (l_curwin_save)).to_boolean then
									(create {P_MOVE_STATIC}).validate_cursor;
									(create {P_SCREEN_STATIC}).redraw_later (35)
									if l_resized.to_boolean then
										(create {P_WINDOW_STATIC}).win_enter (l_curwin_save, 1);
										(create {P_MOVE_STATIC}).update_topline
									end
									pum_do_redraw.item := 1;
									(create {P_SCREEN_STATIC}).update_screen (0)
									pum_do_redraw.item := 0
									if not l_resized.to_boolean then
										if ((create {P_WINDOW_STATIC}).win_valid (l_curwin_save)).to_boolean then
											(create {P_WINDOW_STATIC}).win_enter (l_curwin_save, 1)
										end
									end
									pum_do_redraw.item := 1;
									(create {P_SCREEN_STATIC}).update_screen (0)
									pum_do_redraw.item := 0
								end
							end
						end
				when 12 then -- if done | if done | if done | if done | if done | if done | if done
					if pum_first.item > pum_size.item - pum_height.item then
						pum_first.item := pum_size.item - pum_height.item
					end
					if not l_resized.to_boolean then
						pum_redraw
					end
					Result := l_resized
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	pum_undisplay
		do
			pum_array.item := create {CE_CLASS_POINTER [PD_PUMITEM_T]}.make_shared (default_pointer);
			(create {P_SCREEN_STATIC}).redraw_all_later (35);
			(create {P_GLOBALS_STATIC}).redraw_tabline.item := 1;
			(create {P_SCREEN_STATIC}).status_redraw_all
		end

	pum_clear
		do
			pum_first.item := 0
		end

	pum_visible: INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if not pum_do_redraw.item.to_boolean then
				if not pum_array.item.is_void then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	pum_get_height: INTEGER_32
		do
			Result := pum_height.item
		end

end
