class
	PD_CLINTERVAL

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	first: NATURAL_16 assign set_first

	last: NATURAL_16 assign set_last

	class2: NATURAL_16 assign set_class2

feature {ANY} -- field setters

	set_first (a_first: NATURAL_16)
		do
			first := a_first
			update_memory_field ("first")
		end

	set_last (a_last: NATURAL_16)
		do
			last := a_last
			update_memory_field ("last")
		end

	set_class2 (a_class2: NATURAL_16)
		do
			class2 := a_class2
			update_memory_field ("class2")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			first := a_other.first
			last := a_other.last
			class2 := a_other.class2
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				first = a_other.first and
				last = a_other.last and
				class2 = a_other.class2
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("first"),
					create {CE_STRUCTURE_FIELD}.make ("last"),
					create {CE_STRUCTURE_FIELD}.make ("class2")
				>>)
			init_structure_info
		end

end
