class
	PD_CS_PEND

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	csp_rv: CE_ARRAY [CE_POINTER [ANY]]

	csp_ex: CE_ARRAY [CE_POINTER [ANY]]

feature {ANY}

	copy (a_other: like Current)
		do
			csp_rv := a_other.csp_rv.twin
			csp_ex := a_other.csp_ex.twin
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				csp_rv.is_equal (a_other.csp_rv) and
				csp_ex.is_equal (a_other.csp_ex)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("csp_rv", <<50>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("csp_ex", <<50>>)
				>>)
			init_structure_info
		end

end
