class
	PD_OPARG_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create start.make
			create end2.make
			create cursor_start.make
			Precursor
		end

feature {ANY} -- fields

	op_type: INTEGER_32 assign set_op_type

	regname: INTEGER_32 assign set_regname

	motion_type: INTEGER_32 assign set_motion_type

	motion_force: INTEGER_32 assign set_motion_force

	use_reg_one: INTEGER_32 assign set_use_reg_one

	inclusive: INTEGER_32 assign set_inclusive

	end_adjusted: INTEGER_32 assign set_end_adjusted

	start: PD_POS_T assign set_start

	end2: PD_POS_T assign set_end2

	cursor_start: PD_POS_T assign set_cursor_start

	line_count: INTEGER_32 assign set_line_count

	empty: INTEGER_32 assign set_empty

	is_VIsual: INTEGER_32 assign set_is_VIsual

	block_mode: INTEGER_32 assign set_block_mode

	start_vcol: INTEGER_32 assign set_start_vcol

	end_vcol: INTEGER_32 assign set_end_vcol

	prev_opcount: INTEGER_32 assign set_prev_opcount

	prev_count0: INTEGER_32 assign set_prev_count0

feature {ANY} -- field setters

	set_op_type (a_op_type: INTEGER_32)
		do
			op_type := a_op_type
			update_memory_field ("op_type")
		end

	set_regname (a_regname: INTEGER_32)
		do
			regname := a_regname
			update_memory_field ("regname")
		end

	set_motion_type (a_motion_type: INTEGER_32)
		do
			motion_type := a_motion_type
			update_memory_field ("motion_type")
		end

	set_motion_force (a_motion_force: INTEGER_32)
		do
			motion_force := a_motion_force
			update_memory_field ("motion_force")
		end

	set_use_reg_one (a_use_reg_one: INTEGER_32)
		do
			use_reg_one := a_use_reg_one
			update_memory_field ("use_reg_one")
		end

	set_inclusive (a_inclusive: INTEGER_32)
		do
			inclusive := a_inclusive
			update_memory_field ("inclusive")
		end

	set_end_adjusted (a_end_adjusted: INTEGER_32)
		do
			end_adjusted := a_end_adjusted
			update_memory_field ("end_adjusted")
		end

	set_start (a_start: PD_POS_T)
		do
			start := a_start
			update_memory_field ("start")
		end

	set_end2 (a_end2: PD_POS_T)
		do
			end2 := a_end2
			update_memory_field ("end2")
		end

	set_cursor_start (a_cursor_start: PD_POS_T)
		do
			cursor_start := a_cursor_start
			update_memory_field ("cursor_start")
		end

	set_line_count (a_line_count: INTEGER_32)
		do
			line_count := a_line_count
			update_memory_field ("line_count")
		end

	set_empty (a_empty: INTEGER_32)
		do
			empty := a_empty
			update_memory_field ("empty")
		end

	set_is_VIsual (a_is_VIsual: INTEGER_32)
		do
			is_VIsual := a_is_VIsual
			update_memory_field ("is_VIsual")
		end

	set_block_mode (a_block_mode: INTEGER_32)
		do
			block_mode := a_block_mode
			update_memory_field ("block_mode")
		end

	set_start_vcol (a_start_vcol: INTEGER_32)
		do
			start_vcol := a_start_vcol
			update_memory_field ("start_vcol")
		end

	set_end_vcol (a_end_vcol: INTEGER_32)
		do
			end_vcol := a_end_vcol
			update_memory_field ("end_vcol")
		end

	set_prev_opcount (a_prev_opcount: INTEGER_32)
		do
			prev_opcount := a_prev_opcount
			update_memory_field ("prev_opcount")
		end

	set_prev_count0 (a_prev_count0: INTEGER_32)
		do
			prev_count0 := a_prev_count0
			update_memory_field ("prev_count0")
		end

feature {PD_OPARG_S} -- private attributes

	old_mapped_len: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	normal_cmd (a_toplevel: INTEGER_32)
		local
			l_ca: CE_ARRAY [PD_CMDARG_S]
			l_c: INTEGER_32
			l_ctrl_w: INTEGER_32
			l_old_col: INTEGER_32
			l_need_flushbuf: INTEGER_32
			l_old_pos: PD_POS_T
			l_mapped_len: INTEGER_32
			l_idx: INTEGER_32
			l_set_prevcount: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_count___2: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_cp: CE_POINTER [INTEGER_32]
			l_repl: INTEGER_32
			l_lit: INTEGER_32
			l_langmap_active: INTEGER_32
			l_lang: INTEGER_32
			l_save_smd: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: CE_POINTER [NATURAL_8]
			l_towait: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_save_State: INTEGER_32
			l_kmsg: CE_POINTER [NATURAL_8]
			l_tmp___19: INTEGER_32
			l_tmp___20: INTEGER_32
			l_tmp___21: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_CMDARG_S]} l_ca.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ctrl_w := 0
					l_old_col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant
					l_set_prevcount := 0
					memset (create {CE_VOID_POINTER}.make_cast (l_ca), 0, (create {PD_CMDARG_S}.make).structure_size.to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_ca.item.oap := (create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (c_pointer))
					update_class_fields -- Current might have been changed; synchronize
					l_ca.item.opcount := ((create {P_GLOBALS_STATIC}).opcount.item).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
					l_c := (create {P_GLOBALS_STATIC}).finish_op.item;
					(create {P_GLOBALS_STATIC}).finish_op.item := (op_type /= 0).to_integer
					update_class_fields -- Current might have been changed; synchronize
					if (create {P_GLOBALS_STATIC}).finish_op.item /= l_c then
						(create {P_UI_STATIC}).ui_cursor_shape
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).update_mouseshape (-1)
						update_class_fields -- Current might have been changed; synchronize
					end
					if not ((create {P_GLOBALS_STATIC}).finish_op.item).to_boolean then
						if not regname.to_boolean then
							l_ca.item.opcount := 0
							update_class_fields -- Current might have been changed; synchronize
							l_set_prevcount := 1
						end
					end
					if prev_opcount > 0 then
						l_ca.item.opcount := prev_opcount
						update_class_fields -- Current might have been changed; synchronize
						l_ca.item.count0 := prev_count0
						update_class_fields -- Current might have been changed; synchronize
						Current.prev_opcount := 0
						update_class_fields -- Current might have been changed; synchronize
						Current.prev_count0 := 0
						update_class_fields -- Current might have been changed; synchronize
					elseif prev_count0 > 0 then
						l_ca.item.opcount := prev_opcount
						update_class_fields -- Current might have been changed; synchronize
						l_ca.item.count0 := prev_count0
						update_class_fields -- Current might have been changed; synchronize
						Current.prev_opcount := 0
						update_class_fields -- Current might have been changed; synchronize
						Current.prev_count0 := 0
						update_class_fields -- Current might have been changed; synchronize
					end
					l_mapped_len := typebuf_maplen
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_GLOBALS_STATIC}).State.item := 257
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_GLOBALS_STATIC}).dont_scroll.item := 0
					update_class_fields -- Current might have been changed; synchronize
					l_c := (create {P_GETCHAR_STATIC}).safe_vgetc
					update_class_fields -- Current might have been changed; synchronize
					if (create {P_GLOBALS_STATIC}).restart_edit.item = 0 then
						old_mapped_len.item := 0
					elseif old_mapped_len.item.to_boolean then
						old_mapped_len.item := typebuf_maplen
						update_class_fields -- Current might have been changed; synchronize
					elseif ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
						if l_mapped_len = 0 then
							l_tmp := typebuf_maplen
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp > 0 then
								old_mapped_len.item := typebuf_maplen
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
					if l_c = 0 then
						l_c := -(255 + ((88).bit_shift_left (8)))
					end
					if not (((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean) then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						if not (((create {P_GLOBALS_STATIC}).VIsual_select.item).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 2 then -- if:
						l_tmp___0 := (create {P_CHARSET_STATIC}).vim_isprintc (l_c)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___0.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 5 then -- else:
						if l_c /= 10 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 8 then -- else:
						if l_c /= 13 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if l_c /= -(75 + ((65).bit_shift_left (8))) then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L:;
						(create {P_GETCHAR_STATIC}).ins_char_typebuf (l_c)
						update_class_fields -- Current might have been changed; synchronize
						if (create {P_GLOBALS_STATIC}).restart_edit.item /= 0 then
							l_c := ('d').code
						else
							l_c := ('c').code
						end
						(create {P_GLOBALS_STATIC}).msg_nowait.item := 1
						update_class_fields -- Current might have been changed; synchronize
				when 13 then -- if done | if done | if done | if done | if done
					l_need_flushbuf := (create {P_NORMAL_STATIC}).add_to_showcmd (l_c)
					update_class_fields -- Current might have been changed; synchronize
				when 14 then -- getcount:
					if not (((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean) then
						l_pos := -1 + 17 -- skip if block
					end
				when 15 then -- if:
						if not ((create {P_GLOBALS_STATIC}).VIsual_select.item).to_boolean then
							l_pos := -1 + 17 -- goto _L___1
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 17 then -- else: | _L___1:
						if (l_break) then
							l_pos := -1 + 23 -- skip loop
						end
				when 18 then -- loop body:
						l_break := False
						if not (l_c >= 49) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if not (l_c <= 57) then
							l_pos := -1 + 21 -- goto _L___0
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else: | _L___0:
						if l_ca.item.count0 /= 0 then
							if l_c /= -(107 + ((68).bit_shift_left (8))) then
								if l_c /= -(253 + ((80).bit_shift_left (8))) then
									if l_c /= 48 then
										l_break := True
									end
								end
							end
						else
							l_break := True
						end
				when 22 then
						if not (l_break) then
							if l_c = -(107 + ((68).bit_shift_left (8))) then
								l_ca.item.count0 := l_ca.item.count0 // (10)
								update_class_fields -- Current might have been changed; synchronize
								del_from_showcmd (4)
								update_class_fields -- Current might have been changed; synchronize
							elseif l_c = -(253 + ((80).bit_shift_left (8))) then
								l_ca.item.count0 := l_ca.item.count0 // (10)
								update_class_fields -- Current might have been changed; synchronize
								del_from_showcmd (4)
								update_class_fields -- Current might have been changed; synchronize
							else
								l_ca.item.count0 := l_ca.item.count0 * 10 + (l_c - 48).to_integer_32
								update_class_fields -- Current might have been changed; synchronize
							end
							if l_ca.item.count0 < 0 then
								l_ca.item.count0 := 999_999_999
								update_class_fields -- Current might have been changed; synchronize
							end
							if a_toplevel.to_boolean then
								l_tmp___3 := (create {P_GETCHAR_STATIC}).stuff_empty
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___3.to_boolean then
									l_count___2 := l_ca.item.count0
									if l_ca.item.opcount /= 0 then
										if l_count___2 = 0 then
											l_tmp___1 := 1
										else
											l_tmp___1 := l_count___2
										end
										l_count___2 := l_ca.item.opcount * l_tmp___1
									end
									if l_count___2 = 0 then
										l_tmp___2 := 1
									else
										l_tmp___2 := l_count___2
									end
									set_vcount (l_count___2, l_tmp___2, l_set_prevcount)
									update_class_fields -- Current might have been changed; synchronize
									l_set_prevcount := 0
								end
							end
							if l_ctrl_w.to_boolean then
								(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item + 1
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_GLOBALS_STATIC}).allow_keys.item := (create {P_GLOBALS_STATIC}).allow_keys.item + 1
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_GLOBALS_STATIC}).no_zero_mapping.item := (create {P_GLOBALS_STATIC}).no_zero_mapping.item + 1
							update_class_fields -- Current might have been changed; synchronize
							l_c := (create {P_GETCHAR_STATIC}).plain_vgetc
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_GLOBALS_STATIC}).no_zero_mapping.item := (create {P_GLOBALS_STATIC}).no_zero_mapping.item - 1
							update_class_fields -- Current might have been changed; synchronize
							if l_ctrl_w.to_boolean then
								(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item - 1
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_GLOBALS_STATIC}).allow_keys.item := (create {P_GLOBALS_STATIC}).allow_keys.item - 1
								update_class_fields -- Current might have been changed; synchronize
							end
							l_tmp___4 := (create {P_NORMAL_STATIC}).add_to_showcmd (l_c)
							update_class_fields -- Current might have been changed; synchronize
							l_need_flushbuf := (l_need_flushbuf).bit_or (l_tmp___4)
						end
						l_pos := -1 + 17 -- back to loop condition
				when 23 then -- loop done
						l_break := False
						if l_c = 23 then
							if not l_ctrl_w.to_boolean then
								if op_type = 0 then
									l_ctrl_w := 1
									l_ca.item.opcount := l_ca.item.count0
									update_class_fields -- Current might have been changed; synchronize
									l_ca.item.count0 := 0
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item + 1
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_GLOBALS_STATIC}).allow_keys.item := (create {P_GLOBALS_STATIC}).allow_keys.item + 1
									update_class_fields -- Current might have been changed; synchronize
									l_c := (create {P_GETCHAR_STATIC}).plain_vgetc
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item - 1
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_GLOBALS_STATIC}).allow_keys.item := (create {P_GLOBALS_STATIC}).allow_keys.item - 1
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___5 := (create {P_NORMAL_STATIC}).add_to_showcmd (l_c)
									update_class_fields -- Current might have been changed; synchronize
									l_need_flushbuf := (l_need_flushbuf).bit_or (l_tmp___5)
									l_pos := -1 + 14 -- goto getcount
								end
							end
						end
				when 24 then
					if l_c = -(253 + ((96).bit_shift_left (8))) then
						Current.prev_opcount := l_ca.item.opcount
						update_class_fields -- Current might have been changed; synchronize
						Current.prev_count0 := l_ca.item.count0
						update_class_fields -- Current might have been changed; synchronize
					elseif l_ca.item.opcount /= 0 then
						if (l_ca.item.count0).to_boolean then
							l_ca.item.count0 := l_ca.item.count0 * (l_ca.item.opcount)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_ca.item.count0 := l_ca.item.opcount
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					l_ca.item.opcount := l_ca.item.count0
					update_class_fields -- Current might have been changed; synchronize
					if l_ca.item.count0 = 0 then
						l_ca.item.count1 := 1
						update_class_fields -- Current might have been changed; synchronize
					else
						l_ca.item.count1 := l_ca.item.count0
						update_class_fields -- Current might have been changed; synchronize
					end
					if a_toplevel.to_boolean then
						l_tmp___6 := (create {P_GETCHAR_STATIC}).stuff_empty
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___6.to_boolean then
							set_vcount (l_ca.item.count0, l_ca.item.count1, l_set_prevcount)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if l_ctrl_w.to_boolean then
						l_ca.item.nchar := l_c
						update_class_fields -- Current might have been changed; synchronize
						l_ca.item.cmdchar := 23
						update_class_fields -- Current might have been changed; synchronize
					else
						l_ca.item.cmdchar := l_c
						update_class_fields -- Current might have been changed; synchronize
					end
					l_idx := find_command___0 (l_ca.item.cmdchar)
					update_class_fields -- Current might have been changed; synchronize
					if l_idx < 0 then
						((create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (c_pointer))).item.clearopbeep
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 117 -- goto normal_end
					end
				when 25 then
					l_tmp___7 := (create {P_EX_GETLN_STATIC}).text_locked
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___7.to_boolean then
						if ((((create {P_NORMAL_STATIC}).nv_cmds.item[l_idx].cmd_flags).to_integer_32).bit_and (512)).to_boolean then
							((create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (c_pointer))).item.clearopbeep
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_EX_GETLN_STATIC}).text_locked_msg
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 117 -- goto normal_end
						end
					end
				when 26 then
					if ((((create {P_NORMAL_STATIC}).nv_cmds.item[l_idx].cmd_flags).to_integer_32).bit_and (512)).to_boolean then
						l_tmp___8 := (create {P_EX_GETLN_STATIC}).curbuf_locked
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___8.to_boolean then
							l_pos := -1 + 117 -- goto normal_end
						end
					end
				when 27 then
					if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
						if ((create {P_GLOBALS_STATIC}).km_stopsel.item).to_boolean then
							if ((((create {P_NORMAL_STATIC}).nv_cmds.item[l_idx].cmd_flags).to_integer_32).bit_and (64)).to_boolean then
								if not (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (2)).to_boolean then
									(create {P_NORMAL_STATIC}).end_visual_mode
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_SCREEN_STATIC}).redraw_curbuf_later (20)
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						if ((create {P_GLOBALS_STATIC}).km_startsel.item).to_boolean then
							if ((((create {P_NORMAL_STATIC}).nv_cmds.item[l_idx].cmd_flags).to_integer_32).bit_and (16)).to_boolean then
								unshift_special (l_ca)
								update_class_fields -- Current might have been changed; synchronize
								l_idx := find_command___0 (l_ca.item.cmdchar)
								update_class_fields -- Current might have been changed; synchronize
								if l_idx < 0 then
									((create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (c_pointer))).item.clearopbeep
									update_class_fields -- Current might have been changed; synchronize
									l_pos := -1 + 117 -- goto normal_end
								end
							elseif ((((create {P_NORMAL_STATIC}).nv_cmds.item[l_idx].cmd_flags).to_integer_32).bit_and (32)).to_boolean then
								if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (2)).to_boolean then
									(create {P_GLOBALS_STATIC}).mod_mask.item.item := ((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and ((-3))
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
					end
				when 28 then
					if not (((((create {P_NORMAL_STATIC}).nv_cmds.item[l_idx].cmd_flags).to_integer_32).bit_and (1)).to_boolean) then
						l_pos := -1 + 76 -- skip if block
					end
				when 29 then -- if:
						if ((((create {P_NORMAL_STATIC}).nv_cmds.item[l_idx].cmd_flags).to_integer_32).bit_and (3)) /= 3 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						if op_type = 0 then
							l_pos := -1 + 46 -- goto _L___7
						else
							l_pos := -1 + 32 -- goto _L___12
						end
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 76
				when 32 then -- else: | _L___12:
						if ((((create {P_NORMAL_STATIC}).nv_cmds.item[l_idx].cmd_flags).to_integer_32).bit_and (5)) /= 5 then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 46 -- goto _L___7
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 76
				when 35 then -- else:
						if l_ca.item.cmdchar /= 113 then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if:
						if op_type = 0 then
							if not ((create {P_GLOBALS_STATIC}).Recording.item).to_boolean then
								if not ((create {P_GLOBALS_STATIC}).Exec_reg.item).to_boolean then
									l_pos := -1 + 46 -- goto _L___7
								else
									l_pos := -1 + 38 -- goto _L___11
								end
							else
								l_pos := -1 + 38 -- goto _L___11
							end
						else
							l_pos := -1 + 38 -- goto _L___11
						end
				when 37 then -- if block done, skip else block:
						l_pos := -1 + 76
				when 38 then -- else: | _L___11:
						if l_ca.item.cmdchar /= 97 then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						l_pos := -1 + 42 -- goto _L___8
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 76
				when 41 then -- else:
						if l_ca.item.cmdchar /= 105 then
							l_pos := -1 + 76 -- skip if block
						end
				when 42 then -- if: | _L___8:
						if op_type = 0 then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if:
						l_pos := -1 + 46 -- goto _L___7
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 76
				when 45 then -- else:
						if not (((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean) then
							l_pos := -1 + 76 -- skip if block
						end
				when 46 then -- if: | _L___7:
						l_repl := 0
						l_lit := 0
						l_langmap_active := 0;
						(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item + 1
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).allow_keys.item := (create {P_GLOBALS_STATIC}).allow_keys.item + 1
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).did_cursorhold.item := 1
						update_class_fields -- Current might have been changed; synchronize
						if l_ca.item.cmdchar /= 103 then
							l_pos := -1 + 61 -- skip if block
						end
				when 47 then -- if:
						l_ca.item.nchar := (create {P_GETCHAR_STATIC}).plain_vgetc
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___9 := (create {P_NORMAL_STATIC}).add_to_showcmd (l_ca.item.nchar)
						update_class_fields -- Current might have been changed; synchronize
						l_need_flushbuf := (l_need_flushbuf).bit_or (l_tmp___9)
						if l_ca.item.nchar /= 114 then
							l_pos := -1 + 50 -- skip if block
						end
				when 48 then -- if:
						l_pos := -1 + 57 -- goto _L___2
				when 49 then -- if block done, skip else block:
						l_pos := -1 + 60
				when 50 then -- else:
						if l_ca.item.nchar /= 39 then
							l_pos := -1 + 53 -- skip if block
						end
				when 51 then -- if:
						l_pos := -1 + 57 -- goto _L___2
				when 52 then -- if block done, skip else block:
						l_pos := -1 + 60
				when 53 then -- else:
						if l_ca.item.nchar /= 96 then
							l_pos := -1 + 56 -- skip if block
						end
				when 54 then -- if:
						l_pos := -1 + 57 -- goto _L___2
				when 55 then -- if block done, skip else block:
						l_pos := -1 + 60
				when 56 then -- else:
						if l_ca.item.nchar /= 28 then
							l_pos := -1 + 59 -- skip if block
						end
				when 57 then -- if: | _L___2:
						l_cp := create {CE_INTEGER_32_POINTER}.make_shared (l_ca.item.c_pointer + (create {PD_CMDARG_S}.make).offset_of ("extra_char"))
						if l_ca.item.nchar /= 114 then
							l_lit := 1
						else
							l_repl := 1
						end
				when 58 then -- if block done, skip else block:
						l_pos := -1 + 60
				when 59 then -- else:
						l_cp := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
				when 60 then -- if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 62
				when 61 then -- else:
						if l_ca.item.cmdchar = 114 then
							l_repl := 1
						end
						l_cp := create {CE_INTEGER_32_POINTER}.make_shared (l_ca.item.c_pointer + (create {PD_CMDARG_S}.make).offset_of ("nchar"))
				when 62 then
						if l_repl.to_boolean then
							l_tmp___10 := 1
						elseif ((((create {P_NORMAL_STATIC}).nv_cmds.item[l_idx].cmd_flags).to_integer_32).bit_and (8)).to_boolean then
							l_tmp___10 := 1
						else
							l_tmp___10 := 0
						end
						l_lang := l_tmp___10
						if l_cp.is_void then
							l_pos := -1 + 75 -- skip if block
						end
				when 63 then -- if:
						if l_repl.to_boolean then
							(create {P_GLOBALS_STATIC}).State.item := 80
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_UI_STATIC}).ui_cursor_shape
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_lang.to_boolean then
							if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_iminsert = 1 then
								(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item - 1
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_GLOBALS_STATIC}).allow_keys.item := (create {P_GLOBALS_STATIC}).allow_keys.item - 1
								update_class_fields -- Current might have been changed; synchronize
								if l_repl.to_boolean then
									(create {P_GLOBALS_STATIC}).State.item := 96
									update_class_fields -- Current might have been changed; synchronize
								else
									(create {P_GLOBALS_STATIC}).State.item := 32
									update_class_fields -- Current might have been changed; synchronize
								end
								l_langmap_active := 1
							end
						end
						l_save_smd := (create {P_OPTION_STATIC}).p_smd.item.item;
						(create {P_OPTION_STATIC}).p_smd.item.item := 0
						update_class_fields -- Current might have been changed; synchronize
						if l_lang.to_boolean then
							if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_iminsert = 2 then
								(create {P_MBYTE_STATIC}).im_set_active (1)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_cp.item := (create {P_GETCHAR_STATIC}).plain_vgetc
						update_class_fields -- Current might have been changed; synchronize
						if l_langmap_active.to_boolean then
							(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item + 1
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_GLOBALS_STATIC}).allow_keys.item := (create {P_GLOBALS_STATIC}).allow_keys.item + 1
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_GLOBALS_STATIC}).State.item := 257
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_lang.to_boolean then
							if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_iminsert /= 1 then
								(create {P_UI_STATIC}).im_save_status (create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_iminsert")))
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_MBYTE_STATIC}).im_set_active (0)
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_OPTION_STATIC}).p_smd.item.item := l_save_smd
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).State.item := 257
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___11 := (create {P_NORMAL_STATIC}).add_to_showcmd (l_cp.item)
						update_class_fields -- Current might have been changed; synchronize
						l_need_flushbuf := (l_need_flushbuf).bit_or (l_tmp___11)
						if l_lit.to_boolean then
							l_pos := -1 + 70 -- skip if block
						end
				when 64 then -- if:
						if l_cp.item /= 11 then
							l_pos := -1 + 70 -- skip if block
						end
				when 65 then -- if:
						if not (((((create {P_NORMAL_STATIC}).nv_cmds.item[l_idx].cmd_flags).to_integer_32).bit_and (8)).to_boolean) then
							l_pos := -1 + 68 -- skip if block
						end
				when 66 then -- if:
						l_pos := -1 + 69 -- goto _L___3
				when 67 then -- if block done, skip else block:
						l_pos := -1 + 70
				when 68 then -- else:
						if not (l_cp.is_equal (create {CE_INTEGER_32_POINTER}.make_shared (l_ca.item.c_pointer + (create {PD_CMDARG_S}.make).offset_of ("extra_char")))) then
							l_pos := -1 + 70 -- skip if block
						end
				when 69 then -- if: | _L___3:
						l_tmp___13 := (create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('D').code)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___13.is_void then
							l_c := (create {P_DIGRAPH_STATIC}).get_digraph (0)
							update_class_fields -- Current might have been changed; synchronize
							if l_c > 0 then
								l_cp.item := l_c
								update_class_fields -- Current might have been changed; synchronize
								del_from_showcmd (3)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___12 := (create {P_NORMAL_STATIC}).add_to_showcmd (l_cp.item)
								update_class_fields -- Current might have been changed; synchronize
								l_need_flushbuf := (l_need_flushbuf).bit_or (l_tmp___12)
							end
						end
				when 70 then -- if done | if done | if done
						if not (l_cp.is_equal (create {CE_INTEGER_32_POINTER}.make_shared (l_ca.item.c_pointer + (create {PD_CMDARG_S}.make).offset_of ("extra_char")))) then
							l_pos := -1 + 73 -- skip if block
						end
				when 71 then -- if:
						if l_ca.item.nchar = 28 then
							if l_ca.item.extra_char = 14 then
								l_ca.item.cmdchar := 28
								update_class_fields -- Current might have been changed; synchronize
								l_ca.item.nchar := l_ca.item.extra_char
								update_class_fields -- Current might have been changed; synchronize
								l_idx := find_command___0 (l_ca.item.cmdchar)
								update_class_fields -- Current might have been changed; synchronize
							elseif l_ca.item.extra_char = 7 then
								l_ca.item.cmdchar := 28
								update_class_fields -- Current might have been changed; synchronize
								l_ca.item.nchar := l_ca.item.extra_char
								update_class_fields -- Current might have been changed; synchronize
								l_idx := find_command___0 (l_ca.item.cmdchar)
								update_class_fields -- Current might have been changed; synchronize
							else
								l_pos := -1 + 73 -- goto _L___5
							end
						else
							l_pos := -1 + 73 -- goto _L___5
						end
				when 72 then -- if block done, skip else block:
						l_pos := -1 + 74
				when 73 then -- else: | _L___5:
						if l_cp.item = 28 then
							if (create {P_OPTION_STATIC}).p_ttm.item.item >= 0 then
								l_tmp___14 := (create {P_OPTION_STATIC}).p_ttm.item.item
							else
								l_tmp___14 := (create {P_OPTION_STATIC}).p_tm.item.item
							end
							l_towait := l_tmp___14
							from
							until
								(l_break)
							loop
								l_break := False
								l_c := (create {P_GETCHAR_STATIC}).vpeekc
								update_class_fields -- Current might have been changed; synchronize
								if l_c <= 0 then
									if not (l_towait > 0) then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									if l_towait > 50 then
										l_tmp___15 := 50
									else
										l_tmp___15 := l_towait
									end
									(create {P_EX_DOCMD_STATIC}).do_sleep (l_tmp___15)
									update_class_fields -- Current might have been changed; synchronize
									l_towait := l_towait - (50)
								end
							end
							l_break := False
							if l_c > 0 then
								l_c := (create {P_GETCHAR_STATIC}).plain_vgetc
								update_class_fields -- Current might have been changed; synchronize
								if l_c /= 14 then
									if l_c /= 7 then
										(create {P_GETCHAR_STATIC}).vungetc (l_c)
										update_class_fields -- Current might have been changed; synchronize
									else
										l_ca.item.cmdchar := 28
										update_class_fields -- Current might have been changed; synchronize
										l_ca.item.nchar := l_c
										update_class_fields -- Current might have been changed; synchronize
										l_idx := find_command___0 (l_ca.item.cmdchar)
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									l_ca.item.cmdchar := 28
									update_class_fields -- Current might have been changed; synchronize
									l_ca.item.nchar := l_c
									update_class_fields -- Current might have been changed; synchronize
									l_idx := find_command___0 (l_ca.item.cmdchar)
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
				when 74 then
						from
						until
							(l_break)
						loop
							l_break := False
							if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
								if l_lang.to_boolean then
									l_c := (create {P_GETCHAR_STATIC}).vpeekc
									update_class_fields -- Current might have been changed; synchronize
									if l_c > 0 then
										if not (l_c >= 256) then
											l_tmp___17 := (create {P_GETCHAR_STATIC}).vpeekc
											update_class_fields -- Current might have been changed; synchronize
											if not (((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[l_tmp___17]).to_integer_32 > 1) then
												l_break := True
											end
										end
									else
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_c := (create {P_GETCHAR_STATIC}).plain_vgetc
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___16 := (create {P_MBYTE_STATIC}).utf_iscomposing (l_c)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___16.to_boolean then
									if l_ca.item.ncharC1 = 0 then
										l_ca.item.ncharC1 := l_c
										update_class_fields -- Current might have been changed; synchronize
									else
										l_ca.item.ncharC2 := l_c
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									(create {P_GETCHAR_STATIC}).vungetc (l_c)
									update_class_fields -- Current might have been changed; synchronize
									l_break := True
								end
							end
						end
						l_break := False
				when 75 then -- if done;
						(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item - 1
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).allow_keys.item := (create {P_GLOBALS_STATIC}).allow_keys.item - 1
						update_class_fields -- Current might have been changed; synchronize
				when 76 then -- if done | if done | if done | if done | if done | if done | if done
					if l_need_flushbuf.to_boolean then
						(create {P_TERM_STATIC}).out_flush
						update_class_fields -- Current might have been changed; synchronize
					end
					if l_ca.item.cmdchar /= -(253 + ((53).bit_shift_left (8))) then
						(create {P_GLOBALS_STATIC}).did_cursorhold.item := 0
						update_class_fields -- Current might have been changed; synchronize
					end
					(create {P_GLOBALS_STATIC}).State.item := 1
					update_class_fields -- Current might have been changed; synchronize
					if l_ca.item.nchar = 27 then
						((create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (c_pointer))).item.clearop
						update_class_fields -- Current might have been changed; synchronize
						if (create {P_GLOBALS_STATIC}).restart_edit.item = 0 then
							l_tmp___18 := (create {P_MISC1_STATIC}).goto_im
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___18.to_boolean then
								(create {P_GLOBALS_STATIC}).restart_edit.item := ('a').code
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_pos := -1 + 117 -- goto normal_end
					end
				when 77 then
					if l_ca.item.cmdchar /= -(253 + ((53).bit_shift_left (8))) then
						(create {P_GLOBALS_STATIC}).msg_didout.item := 0
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).msg_col.item := 0
						update_class_fields -- Current might have been changed; synchronize
					end
					l_old_pos := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
					if not ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
						if ((create {P_GLOBALS_STATIC}).km_startsel.item).to_boolean then
							if ((((create {P_NORMAL_STATIC}).nv_cmds.item[l_idx].cmd_flags).to_integer_32).bit_and (16)).to_boolean then
								(create {P_NORMAL_STATIC}).start_selection
								update_class_fields -- Current might have been changed; synchronize
								unshift_special (l_ca)
								update_class_fields -- Current might have been changed; synchronize
								l_idx := find_command___0 (l_ca.item.cmdchar)
								update_class_fields -- Current might have been changed; synchronize
							elseif ((((create {P_NORMAL_STATIC}).nv_cmds.item[l_idx].cmd_flags).to_integer_32).bit_and (32)).to_boolean then
								if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (2)).to_boolean then
									(create {P_NORMAL_STATIC}).start_selection
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_GLOBALS_STATIC}).mod_mask.item.item := ((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and ((-3))
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
					end
					l_ca.item.arg := ((create {P_NORMAL_STATIC}).nv_cmds.item[l_idx].cmd_arg).to_integer_32
					update_class_fields; -- Current might have been changed; synchronize
					((create {P_NORMAL_STATIC}).nv_cmds.item[l_idx].cmd_func).call ([l_ca])
					update_class_fields -- Current might have been changed; synchronize
					if not ((create {P_GLOBALS_STATIC}).finish_op.item).to_boolean then
						if not op_type.to_boolean then
							if l_idx < 0 then
								((create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (c_pointer))).item.clearop
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_EVAL_STATIC}).set_reg_var (('%"').code)
								update_class_fields -- Current might have been changed; synchronize
							elseif not ((((create {P_NORMAL_STATIC}).nv_cmds.item[l_idx].cmd_flags).to_integer_32).bit_and (256)).to_boolean then
								((create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (c_pointer))).item.clearop
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_EVAL_STATIC}).set_reg_var (('%"').code)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
					if old_mapped_len.item > 0 then
						old_mapped_len.item := typebuf_maplen
						update_class_fields -- Current might have been changed; synchronize
					end
					l_ca.item.do_pending_operator (l_old_col, 0)
					update_class_fields -- Current might have been changed; synchronize
					if not (((create {P_OPTION_STATIC}).p_smd.item.item).to_boolean) then
						l_pos := -1 + 110 -- skip if block
					end
				when 78 then -- if:
						if (create {P_GLOBALS_STATIC}).msg_silent.item /= 0 then
							l_pos := -1 + 108 -- skip if block
						end
				when 79 then -- if:
						if (create {P_GLOBALS_STATIC}).restart_edit.item = 0 then
							l_pos := -1 + 82 -- skip if block
						end
				when 80 then -- if:
						l_pos := -1 + 85 -- goto _L___22
				when 81 then -- if block done, skip else block:
						l_pos := -1 + 107
				when 82 then -- else:
						if not (((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean) then
							l_pos := -1 + 106 -- skip if block
						end
				when 83 then -- if:
						if l_old_pos.lnum /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
							l_pos := -1 + 104 -- skip if block
						end
				when 84 then -- if:
						if l_old_pos.col /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col then
							l_pos := -1 + 102 -- skip if block
						end
				when 85 then -- if: | _L___22:
						if not (((create {P_GLOBALS_STATIC}).clear_cmdline.item).to_boolean) then
							l_pos := -1 + 88 -- skip if block
						end
				when 86 then -- if:
						l_pos := -1 + 89 -- goto _L___20
				when 87 then -- if block done, skip else block:
						l_pos := -1 + 101
				when 88 then -- else:
						if not (((create {P_GLOBALS_STATIC}).redraw_cmdline.item).to_boolean) then
							l_pos := -1 + 100 -- skip if block
						end
				when 89 then -- if: | _L___20:
						if not (((create {P_GLOBALS_STATIC}).msg_didout.item).to_boolean) then
							l_pos := -1 + 92 -- skip if block
						end
				when 90 then -- if:
						l_pos := -1 + 94 -- goto _L___18
				when 91 then -- if block done, skip else block:
						l_pos := -1 + 99
				when 92 then -- else:
						if not (((create {P_GLOBALS_STATIC}).msg_didany.item).to_boolean) then
							l_pos := -1 + 98 -- skip if block
						end
				when 93 then -- if:
						if not (((create {P_GLOBALS_STATIC}).msg_scroll.item).to_boolean) then
							l_pos := -1 + 96 -- skip if block
						end
				when 94 then -- if: | _L___18:
						if not ((create {P_GLOBALS_STATIC}).msg_nowait.item).to_boolean then
							if ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
								l_pos := -1 + 116 -- goto _L___14
							else
								l_pos := -1 + 110 -- goto _L___23
							end
						else
							l_pos := -1 + 110 -- goto _L___23
						end
				when 95 then -- if block done, skip else block:
						l_pos := -1 + 97
				when 96 then -- else:
						l_pos := -1 + 110 -- goto _L___23
				when 97 then -- if done | if block done, skip else block:
						l_pos := -1 + 99
				when 98 then -- else:
						l_pos := -1 + 110 -- goto _L___23
				when 99 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 101
				when 100 then -- else:
						l_pos := -1 + 110 -- goto _L___23
				when 101 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 103
				when 102 then -- else:
						l_pos := -1 + 110 -- goto _L___23
				when 103 then -- if done | if block done, skip else block:
						l_pos := -1 + 105
				when 104 then -- else:
						l_pos := -1 + 110 -- goto _L___23
				when 105 then -- if done | if block done, skip else block:
						l_pos := -1 + 107
				when 106 then -- else:
						l_pos := -1 + 110 -- goto _L___23
				when 107 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 109
				when 108 then -- else:
						l_pos := -1 + 110 -- goto _L___23
				when 109 then -- if done | if block done, skip else block:
						l_pos := -1 + 117
				when 110 then -- else: | _L___23:
						if (create {P_GLOBALS_STATIC}).restart_edit.item = 0 then
							l_pos := -1 + 117 -- skip if block
						end
				when 111 then -- if:
						if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
							l_pos := -1 + 117 -- skip if block
						end
				when 112 then -- if:
						if not (((create {P_GLOBALS_STATIC}).msg_scroll.item).to_boolean) then
							l_pos := -1 + 115 -- skip if block
						end
				when 113 then -- if:
						l_pos := -1 + 116 -- goto _L___14
				when 114 then -- if block done, skip else block:
						l_pos := -1 + 117
				when 115 then -- else:
						if not (((create {P_GLOBALS_STATIC}).emsg_on_display.item).to_boolean) then
							l_pos := -1 + 117 -- skip if block
						end
				when 116 then -- if: | _L___14:
						if regname = 0 then
							if not ((l_ca.item.retval).bit_and (1)).to_boolean then
								l_tmp___19 := (create {P_GETCHAR_STATIC}).stuff_empty
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___19.to_boolean then
									l_tmp___20 := (create {P_GETCHAR_STATIC}).typebuf_typed
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___20.to_boolean then
										if (create {P_GLOBALS_STATIC}).emsg_silent.item = 0 then
											if not ((create {P_GLOBALS_STATIC}).did_wait_return.item).to_boolean then
												if op_type = 0 then
													l_save_State := (create {P_GLOBALS_STATIC}).State.item
													if (create {P_GLOBALS_STATIC}).restart_edit.item /= 0 then
														(create {P_GLOBALS_STATIC}).State.item := 16
														update_class_fields -- Current might have been changed; synchronize
													end
													if ((create {P_GLOBALS_STATIC}).must_redraw.item).to_boolean then
														if not ((create {P_GLOBALS_STATIC}).keep_msg.item).is_void then
															if not ((create {P_GLOBALS_STATIC}).emsg_on_display.item).to_boolean then
																l_kmsg := (create {P_GLOBALS_STATIC}).keep_msg.item;
																(create {P_GLOBALS_STATIC}).keep_msg.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
																update_class_fields; -- Current might have been changed; synchronize
																(create {P_SCREEN_STATIC}).update_screen (0)
																update_class_fields; -- Current might have been changed; synchronize
																(create {P_GLOBALS_STATIC}).keep_msg.item := l_kmsg
																update_class_fields; -- Current might have been changed; synchronize
																(create {P_MESSAGE_STATIC}).msg_attr (l_kmsg, (create {P_GLOBALS_STATIC}).keep_msg_attr.item).do_nothing
																update_class_fields; -- Current might have been changed; synchronize
																(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_kmsg))
																update_class_fields -- Current might have been changed; synchronize
															end
														end
													end
													(create {P_SCREEN_STATIC}).setcursor
													update_class_fields; -- Current might have been changed; synchronize
													(create {P_TERM_STATIC}).cursor_on
													update_class_fields; -- Current might have been changed; synchronize
													(create {P_TERM_STATIC}).out_flush
													update_class_fields -- Current might have been changed; synchronize
													if ((create {P_GLOBALS_STATIC}).msg_scroll.item).to_boolean then
														(create {P_UI_STATIC}).ui_delay (1_000, 1)
														update_class_fields -- Current might have been changed; synchronize
													elseif ((create {P_GLOBALS_STATIC}).emsg_on_display.item).to_boolean then
														(create {P_UI_STATIC}).ui_delay (1_000, 1)
														update_class_fields -- Current might have been changed; synchronize
													end
													(create {P_UI_STATIC}).ui_delay (3_000, 0)
													update_class_fields; -- Current might have been changed; synchronize
													(create {P_GLOBALS_STATIC}).State.item := l_save_State
													update_class_fields; -- Current might have been changed; synchronize
													(create {P_GLOBALS_STATIC}).msg_scroll.item := 0
													update_class_fields; -- Current might have been changed; synchronize
													(create {P_GLOBALS_STATIC}).emsg_on_display.item := 0
													update_class_fields -- Current might have been changed; synchronize
												end
											end
										end
									end
								end
							end
						end
				when 117 then -- if done | if done | if done | if done | normal_end:;
					(create {P_GLOBALS_STATIC}).msg_nowait.item := 0
					update_class_fields -- Current might have been changed; synchronize
					l_c := (create {P_GLOBALS_STATIC}).finish_op.item;
					(create {P_GLOBALS_STATIC}).finish_op.item := 0
					update_class_fields -- Current might have been changed; synchronize
					if l_c.to_boolean then
						(create {P_UI_STATIC}).ui_cursor_shape
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).update_mouseshape (-1)
						update_class_fields -- Current might have been changed; synchronize
					elseif l_ca.item.cmdchar = 114 then
						(create {P_UI_STATIC}).ui_cursor_shape
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).update_mouseshape (-1)
						update_class_fields -- Current might have been changed; synchronize
					end
					if op_type = 0 then
						if regname = 0 then
							if l_ca.item.cmdchar /= -(253 + ((96).bit_shift_left (8))) then
								(create {P_NORMAL_STATIC}).clear_showcmd
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
					(create {P_MARK_STATIC}).checkpcmark
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ca.item.searchbuf))
					update_class_fields -- Current might have been changed; synchronize
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						(create {P_MBYTE_STATIC}).mb_adjust_cursor
						update_class_fields -- Current might have been changed; synchronize
					end
					if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_scb).to_boolean then
						if a_toplevel.to_boolean then
							(create {P_MOVE_STATIC}).validate_cursor
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_NORMAL_STATIC}).do_check_scrollbind (1)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_crb).to_boolean then
						if a_toplevel.to_boolean then
							(create {P_MOVE_STATIC}).validate_cursor
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MOVE_STATIC}).do_check_cursorbind
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if op_type /= 0 then
						l_pos := -1 + 123 -- skip if block
					end
				when 118 then -- if:
						if (create {P_GLOBALS_STATIC}).restart_edit.item = 0 then
							l_pos := -1 + 121 -- skip if block
						end
				when 119 then -- if:
						if not ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
							if old_mapped_len.item = 0 then
								l_pos := -1 + 122 -- goto _L___24
							else
								l_pos := -1 + 121 -- goto _L___26
							end
						else
							l_pos := -1 + 121 -- goto _L___26
						end
				when 120 then -- if block done, skip else block:
						l_pos := -1 + 123
				when 121 then -- else: | _L___26:
						if (create {P_NORMAL_STATIC}).restart_VIsual_select.item /= 1 then
							l_pos := -1 + 123 -- skip if block
						end
				when 122 then -- if: | _L___24:
						if not ((l_ca.item.retval).bit_and (1)).to_boolean then
							l_tmp___21 := (create {P_GETCHAR_STATIC}).stuff_empty
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___21.to_boolean then
								if regname = 0 then
									if (create {P_NORMAL_STATIC}).restart_VIsual_select.item = 1 then
										(create {P_GLOBALS_STATIC}).VIsual_select.item := 1
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_SCREEN_STATIC}).showmode.do_nothing
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_NORMAL_STATIC}).restart_VIsual_select.item := 0
										update_class_fields -- Current might have been changed; synchronize
									end
									if (create {P_GLOBALS_STATIC}).restart_edit.item /= 0 then
										if not ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
											if old_mapped_len.item = 0 then
												(create {P_EDIT_STATIC}).edit ((create {P_GLOBALS_STATIC}).restart_edit.item, 0, 1).do_nothing
												update_class_fields -- Current might have been changed; synchronize
											end
										end
									end
								end
							end
						end
				when 123 then -- if done | if done
					if (create {P_NORMAL_STATIC}).restart_VIsual_select.item = 2 then
						(create {P_NORMAL_STATIC}).restart_VIsual_select.item := 1
						update_class_fields -- Current might have been changed; synchronize
					end
					(create {P_GLOBALS_STATIC}).opcount.item := (l_ca.item.opcount).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				when 124 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	checkclearop: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if op_type = 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				((create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (c_pointer))).item.clearopbeep
				update_class_fields -- Current might have been changed; synchronize
				Result := 1
			end
		end

	clearop
		do
			Current.op_type := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.regname := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.motion_force := ('%/0/').code
			update_class_fields -- Current might have been changed; synchronize
			Current.use_reg_one := 0
			update_class_fields -- Current might have been changed; synchronize
		end

	clearopbeep
		do
			((create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (c_pointer))).item.clearop
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC1_STATIC}).beep_flush
			update_class_fields -- Current might have been changed; synchronize
		end

	op_shift (a_curs_top, a_amount: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_first_char: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_block_col: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_block_col := 0
			l_tmp := (create {P_UNDO_STATIC}).u_save (start.lnum - 1, end2.lnum + 1)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp = 0 then
				l_return := True
			end
			if not l_return then
				if block_mode.to_boolean then
					l_block_col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
				end
				l_i___0 := line_count
				from
				until
					(l_break)
				loop
					l_break := False
					l_i___0 := l_i___0 - 1
					if not (l_i___0 >= 0) then
						l_break := True
					end
					if not (l_break) then
						l_tmp___0 := (create {P_MEMLINE_STATIC}).ml_get_curline
						update_class_fields -- Current might have been changed; synchronize
						l_first_char := (l_tmp___0.item).to_integer_32
						if l_first_char = 0 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
							update_class_fields -- Current might have been changed; synchronize
						elseif block_mode.to_boolean then
							((create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (c_pointer))).item.shift_block (a_amount)
							update_class_fields -- Current might have been changed; synchronize
						elseif l_first_char /= 35 then
							(create {P_OPS_STATIC}).shift_line ((op_type = 4).to_integer, (create {P_OPTION_STATIC}).p_sr.item.item, a_amount, 0)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___1 := (create {P_OPS_STATIC}).preprocs_left
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___1.to_boolean then
								(create {P_OPS_STATIC}).shift_line ((op_type = 4).to_integer, (create {P_OPTION_STATIC}).p_sr.item.item, a_amount, 0)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) + 1
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				l_break := False;
				(create {P_MISC1_STATIC}).changed_lines (start.lnum, 0, end2.lnum + 1, 0)
				update_class_fields -- Current might have been changed; synchronize
				if block_mode.to_boolean then
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := start.lnum
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_block_col
					update_class_fields -- Current might have been changed; synchronize
				elseif a_curs_top.to_boolean then
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := start.lnum
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_EDIT_STATIC}).beginline (6)
					update_class_fields -- Current might have been changed; synchronize
				else
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) - 1
					update_class_fields -- Current might have been changed; synchronize
				end
				if line_count > (create {P_OPTION_STATIC}).p_report.item.item then
					if op_type = 5 then
						l_s := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (">"))
					else
						l_s := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<"))
					end
					if line_count = 1 then
						if a_amount = 1 then
							l_tmp___2 := gettext (ce_string ("1 line %%sed 1 time"))
							update_class_fields -- Current might have been changed; synchronize
							sprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), l_tmp___2, l_s]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___3 := gettext (ce_string ("1 line %%sed %%d times"))
							update_class_fields -- Current might have been changed; synchronize
							sprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), l_tmp___3, l_s, a_amount]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
					elseif a_amount = 1 then
						l_tmp___4 := gettext (ce_string ("%%ld lines %%sed 1 time"))
						update_class_fields -- Current might have been changed; synchronize
						sprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), l_tmp___4, line_count, l_s]).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					else
						l_tmp___5 := gettext (ce_string ("%%ld lines %%sed %%d times"))
						update_class_fields -- Current might have been changed; synchronize
						sprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), l_tmp___5, line_count, l_s, a_amount]).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					(create {P_MESSAGE_STATIC}).msg ((create {P_GLOBALS_STATIC}).IObuff.item).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start := start.twin
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.lnum := end2.lnum
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___6 := (create {P_MEMLINE_STATIC}).ml_get (end2.lnum)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___7 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___6))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.col := l_tmp___7.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.col > 0 then
					(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.col := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.col) - 1
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	shift_block (a_amount: INTEGER_32)
		local
			l_left: INTEGER_32
			l_oldstate: INTEGER_32
			l_total: INTEGER_32
			l_newp: CE_POINTER [NATURAL_8]
			l_oldp: CE_POINTER [NATURAL_8]
			l_oldcol: INTEGER_32
			l_p_sw___0: INTEGER_32
			l_p_ts___0: INTEGER_32
			l_bd: CE_ARRAY [PD_BLOCK_DEF]
			l_incr: INTEGER_32
			l_ws_vcol: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_len: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: NATURAL_32
			l_destination_col: INTEGER_32
			l_verbatim_copy_end: CE_POINTER [NATURAL_8]
			l_verbatim_copy_width: INTEGER_32
			l_fill: NATURAL_32
			l_new_line_len: NATURAL_32
			l_block_space_width: NATURAL_32
			l_shift_amount: NATURAL_32
			l_non_white: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_non_white_col: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: NATURAL_32
			l_tmp___6: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_BLOCK_DEF]} l_bd.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_non_white.make (<<1>>)

			l_left := (op_type = 4).to_integer
			l_oldstate := (create {P_GLOBALS_STATIC}).State.item
			l_oldcol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
			l_p_sw___0 := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sw).to_integer_32
			l_p_ts___0 := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32
			l_i___0 := 0
			l_j := 0;
			(create {P_GLOBALS_STATIC}).State.item := 16
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (c_pointer))).item.block_prep (l_bd, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, 1)
			update_class_fields -- Current might have been changed; synchronize
			if (l_bd.item.is_short).to_boolean then
				l_return := True
			end
			if not l_return then
				l_total := a_amount * l_p_sw___0
				l_oldp := (create {P_MEMLINE_STATIC}).ml_get_curline
				update_class_fields -- Current might have been changed; synchronize
				if not l_left.to_boolean then
					l_total := l_total + (l_bd.item.pre_whitesp)
					l_ws_vcol := l_bd.item.start_vcol - l_bd.item.pre_whitesp
					if (l_bd.item.startspaces).to_boolean then
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_bd.item.textstart])
							update_class_fields -- Current might have been changed; synchronize
							l_bd.item.textstart := l_bd.item.textstart + l_tmp
							update_class_fields -- Current might have been changed; synchronize
						else
							l_bd.item.textstart := (l_bd.item.textstart) + 1
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					from
					until
						(l_break)
					loop
						l_break := False
						if ((l_bd.item.textstart).item).to_integer_32 /= 32 then
							if ((l_bd.item.textstart).item).to_integer_32 /= 9 then
								l_break := True
							end
						end
						if not (l_break) then
							l_incr := (create {P_CHARSET_STATIC}).lbr_chartabsize_adv (create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (l_bd.item.c_pointer + (create {PD_BLOCK_DEF}.make).offset_of ("textstart")), l_bd.item.start_vcol)
							update_class_fields -- Current might have been changed; synchronize
							l_total := l_total + l_incr
							l_bd.item.start_vcol := l_bd.item.start_vcol + l_incr
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					l_break := False
					if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_et).to_boolean then
						l_i___0 := (l_ws_vcol \\ l_p_ts___0 + l_total) // l_p_ts___0
					end
					if l_i___0.to_boolean then
						l_j := (l_ws_vcol \\ l_p_ts___0 + l_total) \\ l_p_ts___0
					else
						l_j := l_total
					end
					l_bd.item.textcol := l_bd.item.textcol - (l_bd.item.pre_whitesp_c - (l_bd.item.startspaces /= 0).to_integer)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_bd.item.textstart))
					update_class_fields -- Current might have been changed; synchronize
					l_len := l_tmp___0.to_integer_32 + 1
					l_newp := (create {P_MISC2_STATIC}).alloc_check ((((l_bd.item.textcol + l_i___0) + l_j) + l_len).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					if l_newp.is_void then
						l_return := True
					end
					if not l_return then
						memset (create {CE_VOID_POINTER}.make_cast (l_newp), ('%/0/').code, (((l_bd.item.textcol + l_i___0) + l_j) + l_len).to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						memmove (create {CE_VOID_POINTER}.make_cast (l_newp), create {CE_VOID_POINTER}.make_cast (l_oldp), (l_bd.item.textcol).to_natural_32).do_nothing
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).copy_chars (l_newp + l_bd.item.textcol, l_i___0.to_natural_32, ('%T').code)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).copy_spaces ((l_newp + l_bd.item.textcol) + l_i___0, l_j.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						memmove (create {CE_VOID_POINTER}.make_cast ((((l_newp + l_bd.item.textcol) + l_i___0) + l_j)), create {CE_VOID_POINTER}.make_cast (l_bd.item.textstart), l_len.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					l_non_white.item := l_bd.item.textstart
					update_class_fields -- Current might have been changed; synchronize
					if (l_bd.item.startspaces).to_boolean then
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___1 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_non_white.item])
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___2 := l_tmp___1
						else
							l_tmp___2 := 1
						end
						l_non_white.item := l_non_white.item + l_tmp___2
						update_class_fields -- Current might have been changed; synchronize
					end
					l_non_white_col := l_bd.item.start_vcol
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_non_white.item.item).to_integer_32 /= 32 then
							if (l_non_white.item.item).to_integer_32 /= 9 then
								l_break := True
							end
						end
						if not (l_break) then
							l_incr := (create {P_CHARSET_STATIC}).lbr_chartabsize_adv (l_non_white, l_non_white_col)
							update_class_fields -- Current might have been changed; synchronize
							l_non_white_col := l_non_white_col + l_incr
						end
					end
					l_break := False
					l_block_space_width := (l_non_white_col - start_vcol).to_natural_32
					if l_block_space_width < l_total.to_natural_32 then
						l_shift_amount := l_block_space_width
					else
						l_shift_amount := l_total.to_natural_32
					end
					l_destination_col := (l_non_white_col.to_natural_32 - l_shift_amount).to_integer_32
					l_verbatim_copy_end := l_bd.item.textstart
					l_verbatim_copy_width := l_bd.item.start_vcol
					if (l_bd.item.startspaces).to_boolean then
						l_verbatim_copy_width := l_verbatim_copy_width - (l_bd.item.start_char_vcols)
					end
					from
					until
						not (not (l_break) and then (l_verbatim_copy_width < l_destination_col))
					loop
						l_break := False
						l_incr := (create {P_CHARSET_STATIC}).lbr_chartabsize (l_verbatim_copy_end, l_verbatim_copy_width)
						update_class_fields -- Current might have been changed; synchronize
						if l_verbatim_copy_width + l_incr > l_destination_col then
							l_break := True
						end
						if not (l_break) then
							l_verbatim_copy_width := l_verbatim_copy_width + l_incr
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___3 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_verbatim_copy_end])
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___4 := l_tmp___3
							else
								l_tmp___4 := 1
							end
							l_verbatim_copy_end := l_verbatim_copy_end + l_tmp___4
						end
					end
					l_break := False
					l_fill := (l_destination_col - l_verbatim_copy_width).to_natural_32
					l_tmp___5 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_non_white.item))
					update_class_fields -- Current might have been changed; synchronize
					l_new_line_len := (((l_verbatim_copy_end.distance (l_oldp)).to_natural_32 + l_fill) + l_tmp___5) + {NATURAL_32} 1
					l_newp := (create {P_MISC2_STATIC}).alloc_check (l_new_line_len)
					update_class_fields -- Current might have been changed; synchronize
					if l_newp.is_void then
						l_return := True
					end
					if not l_return then
						memmove (create {CE_VOID_POINTER}.make_cast (l_newp), create {CE_VOID_POINTER}.make_cast (l_oldp), (l_verbatim_copy_end.distance (l_oldp)).to_natural_32).do_nothing
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).copy_spaces (l_newp + (l_verbatim_copy_end.distance (l_oldp)), l_fill)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___6 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_non_white.item))
						update_class_fields -- Current might have been changed; synchronize
						memmove (create {CE_VOID_POINTER}.make_cast (((l_newp + (l_verbatim_copy_end.distance (l_oldp))) + l_fill.to_integer_32)), create {CE_VOID_POINTER}.make_cast (l_non_white.item), l_tmp___6 + {NATURAL_32} 1).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			if not l_return then
				(create {P_MEMLINE_STATIC}).ml_replace ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_newp, 0).do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MISC1_STATIC}).changed_bytes ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_bd.item.textcol)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).State.item := l_oldstate
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_oldcol
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	mb_adjust_opend
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
		do
			if inclusive.to_boolean then
				l_p___0 := (create {P_MEMLINE_STATIC}).ml_get (end2.lnum)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := (create {P_MBYTE_STATIC}).mb_tail_off (l_p___0, l_p___0 + end2.col)
				update_class_fields -- Current might have been changed; synchronize
				end2.col := end2.col + l_tmp
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	op_change: INTEGER_32
		local
			l_l: INTEGER_32
			l_retval: INTEGER_32
			l_offset: INTEGER_32
			l_linenr: INTEGER_32
			l_ins_len: INTEGER_32
			l_pre_textlen: INTEGER_32
			l_pre_indent: INTEGER_32
			l_firstline: CE_POINTER [NATURAL_8]
			l_ins_text: CE_POINTER [NATURAL_8]
			l_newp: CE_POINTER [NATURAL_8]
			l_oldp: CE_POINTER [NATURAL_8]
			l_bd: CE_ARRAY [PD_BLOCK_DEF]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: NATURAL_32
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_new_indent: INTEGER_32
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: NATURAL_32
			l_vpos: CE_ARRAY [PD_POS_T]
			l_tmp___8: NATURAL_32
			l_tmp___9: NATURAL_32
			l_return, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_BLOCK_DEF]} l_bd.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_POS_T]} l_vpos.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pre_textlen := 0
					l_pre_indent := 0
					l_l := start.col
					if motion_type = 1 then
						l_l := 0
						if not ((create {P_OPTION_STATIC}).p_paste.item.item).to_boolean then
							if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_si).to_boolean then
								if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_cin).to_boolean then
									(create {P_GLOBALS_STATIC}).can_si.item := 1
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
					end
					if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags).bit_and (1)).to_boolean then
						l_tmp := (create {P_UNDO_STATIC}).u_save_cursor
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp = 0 then
							Result := 0
							l_return := True
						end
					else
						l_tmp___0 := (create {P_OPS_STATIC}).op_delete ((create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (c_pointer)))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0 = 0 then
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 17 -- skip if block
					end
				when 1 then -- if:
						if l_l > (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col then
							l_tmp___1 := (create {P_MEMLINE_STATIC}).ml_get ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)
							update_class_fields -- Current might have been changed; synchronize
							if (l_tmp___1.item).to_integer_32 /= 0 then
								if not ((create {P_GLOBALS_STATIC}).virtual_op.item).to_boolean then
									(create {P_MISC2_STATIC}).inc_cursor.do_nothing
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						if block_mode.to_boolean then
							if ((create {P_GLOBALS_STATIC}).virtual_op.item).to_boolean then
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd > 0 then
									l_tmp___2 := (create {P_MISC2_STATIC}).getviscol
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_MISC2_STATIC}).coladvance_force (l_tmp___2).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								else
									l_tmp___3 := (create {P_MISC1_STATIC}).gchar_cursor
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___3 = 0 then
										l_tmp___2 := (create {P_MISC2_STATIC}).getviscol
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_MISC2_STATIC}).coladvance_force (l_tmp___2).do_nothing
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							end
							l_firstline := (create {P_MEMLINE_STATIC}).ml_get (start.lnum)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___4 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_firstline))
							update_class_fields -- Current might have been changed; synchronize
							l_pre_textlen := l_tmp___4.to_integer_32
							l_tmp___5 := (create {P_CHARSET_STATIC}).skipwhite (l_firstline)
							update_class_fields -- Current might have been changed; synchronize
							l_pre_indent := (l_tmp___5.distance (l_firstline)).to_integer_32
							l_bd.item.textcol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
							update_class_fields -- Current might have been changed; synchronize
						end
						if motion_type = 1 then
							fix_indent
							update_class_fields -- Current might have been changed; synchronize
						end
						l_retval := (create {P_EDIT_STATIC}).edit (('%/0/').code, 0, (1).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if not (block_mode.to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 2 then -- if:
						if start.lnum = end2.lnum then
							l_pos := -1 + 16 -- skip if block
						end
				when 3 then -- if:
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							l_pos := -1 + 16 -- skip if block
						end
				when 4 then -- if:
						l_firstline := (create {P_MEMLINE_STATIC}).ml_get (start.lnum)
						update_class_fields -- Current might have been changed; synchronize
						if l_bd.item.textcol > l_pre_indent.to_integer_32 then
							l_tmp___6 := (create {P_CHARSET_STATIC}).skipwhite (l_firstline)
							update_class_fields -- Current might have been changed; synchronize
							l_new_indent := (l_tmp___6.distance (l_firstline)).to_integer_32
							l_pre_textlen := l_pre_textlen + (l_new_indent - l_pre_indent)
							l_bd.item.textcol := ((l_bd.item.textcol).to_integer_32 + (l_new_indent - l_pre_indent)).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
						l_tmp___7 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_firstline))
						update_class_fields -- Current might have been changed; synchronize
						l_ins_len := l_tmp___7.to_integer_32 - l_pre_textlen
						if not (l_ins_len > 0) then
							l_pos := -1 + 16 -- skip if block
						end
				when 5 then -- if:
						l_ins_text := (create {P_MISC2_STATIC}).alloc_check ((l_ins_len + 1).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_ins_text.is_void then
							l_pos := -1 + 15 -- skip if block
						end
				when 6 then -- if:;
						(create {P_MISC2_STATIC}).vim_strncpy (l_ins_text, l_firstline + l_bd.item.textcol, l_ins_len.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_linenr := start.lnum + 1
				when 7 then -- loop condition:
						if not (l_linenr <= end2.lnum) then
							l_pos := -1 + 14 -- skip loop
						end
				when 8 then -- loop body:
						l_continue := False;
						((create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (c_pointer))).item.block_prep (l_bd, l_linenr, 1)
						update_class_fields -- Current might have been changed; synchronize
						if (l_bd.item.is_short).to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if not (((create {P_GLOBALS_STATIC}).virtual_op.item).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L:
						if (l_bd.item.is_short).to_boolean then
							l_vpos.item.lnum := l_linenr
							update_class_fields -- Current might have been changed; synchronize
							l_vpos.item.getvpos (start_vcol).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						else
							l_vpos.item.coladd := 0
							update_class_fields -- Current might have been changed; synchronize
						end
						l_oldp := (create {P_MEMLINE_STATIC}).ml_get (l_linenr)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___8 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_oldp))
						update_class_fields -- Current might have been changed; synchronize
						l_newp := (create {P_MISC2_STATIC}).alloc_check ((((l_tmp___8 + (l_vpos.item.coladd).to_natural_32).to_natural_32 + l_ins_len.to_natural_32) + {NATURAL_32} 1).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_newp.is_void then
							l_continue := True
						end
						if not (l_continue) then
							memmove (create {CE_VOID_POINTER}.make_cast (l_newp), create {CE_VOID_POINTER}.make_cast (l_oldp), (l_bd.item.textcol).to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_offset := (l_bd.item.textcol).to_integer_32;
							(create {P_MISC2_STATIC}).copy_spaces (l_newp + l_offset, (l_vpos.item.coladd).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							l_offset := l_offset + (l_vpos.item.coladd).to_integer_32
							memmove (create {CE_VOID_POINTER}.make_cast ((l_newp + l_offset)), create {CE_VOID_POINTER}.make_cast (l_ins_text), l_ins_len.to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_offset := l_offset + l_ins_len
							l_oldp := l_oldp + (l_bd.item.textcol)
							l_tmp___9 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_oldp))
							update_class_fields -- Current might have been changed; synchronize
							memmove (create {CE_VOID_POINTER}.make_cast ((l_newp + l_offset)), create {CE_VOID_POINTER}.make_cast (l_oldp), l_tmp___9 + {NATURAL_32} 1).do_nothing
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MEMLINE_STATIC}).ml_replace (l_linenr, l_newp, 0).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
				when 13 then -- if done
						l_linenr := l_linenr + 1
						l_pos := -1 + 7 -- back to loop condition
				when 14 then -- loop done
						l_continue := False;
						(create {P_MISC2_STATIC}).check_cursor
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC1_STATIC}).changed_lines (start.lnum + 1, 0, end2.lnum + 1, 0)
						update_class_fields -- Current might have been changed; synchronize
				when 15 then -- if done;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ins_text))
						update_class_fields -- Current might have been changed; synchronize
				when 16 then -- if done | if done | if done | if done
						Result := l_retval
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	op_yank (a_deleting, a_mess: INTEGER_32): INTEGER_32
		local
			l_y_idx: INTEGER_32
			l_curr: CE_POINTER [PD_YANKREG]
			l_newreg: CE_ARRAY [PD_YANKREG]
			l_new_ptr: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_lnum: INTEGER_32
			l_j: INTEGER_32
			l_yanktype: INTEGER_32
			l_yanklines: INTEGER_32
			l_yankendlnum: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_pnew: CE_POINTER [NATURAL_8]
			l_bd: CE_ARRAY [PD_BLOCK_DEF]
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_startcol: INTEGER_32
			l_endcol: INTEGER_32
			l_is_oneChar: INTEGER_32
			l_cs: CE_ARRAY [INTEGER_32]
			l_ce: CE_ARRAY [INTEGER_32]
			l_tmp___4: INTEGER_32
			l_tmp___5: NATURAL_32
			l_tmp___6: INTEGER_32
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___8: NATURAL_32
			l_tmp___9: NATURAL_32
			l_tmp___10: INTEGER_32
			l_tmp___11: CE_POINTER [NATURAL_8]
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_tmp___17: CE_POINTER [INTEGER_8]
			l_tmp___18: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_POINTER [PD_YANKREG]} l_curr.make
			create {CE_CLASS_ARRAY [PD_YANKREG]} l_newreg.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_BLOCK_DEF]} l_bd.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_cs.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_ce.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_yanktype := motion_type
					l_yanklines := line_count
					l_yankendlnum := end2.lnum
					if regname /= 0 then
						l_tmp := (create {P_OPS_STATIC}).valid_yank_reg (regname, 1)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp.to_boolean then
							(create {P_MISC1_STATIC}).beep_flush
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						end
					end
					if not l_return and then (regname = 95) then
						Result := 1
						l_return := True
					end
					if l_return then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						if ((create {P_GLOBALS_STATIC}).clip_star.item.item.available).to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if regname = 42 then
							Current.regname := 0
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if not ((create {P_GLOBALS_STATIC}).clip_plus.item.item.available).to_boolean then
							if regname = 43 then
								Current.regname := 0
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 5 then
						if not a_deleting.to_boolean then
							(create {P_OPS_STATIC}).get_yank_register (regname, 1)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_curr := (create {P_OPS_STATIC}).y_current.item
						if ((create {P_OPS_STATIC}).y_append.item).to_boolean then
							if not ((create {P_OPS_STATIC}).y_current.item.item.y_array).is_void then
								(create {P_OPS_STATIC}).y_current.item := l_newreg
								update_class_fields -- Current might have been changed; synchronize
							else
								(create {P_OPS_STATIC}).free_yank_all
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							(create {P_OPS_STATIC}).free_yank_all
							update_class_fields -- Current might have been changed; synchronize
						end
						if motion_type /= 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 6 then -- if:
						if start.col /= 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 7 then -- if:
						if inclusive.to_boolean then
							l_pos := -1 + 13 -- skip if block
						end
				when 8 then -- if:
						if is_VIsual.to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L___0
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if ((create {P_OPTION_STATIC}).p_sel.item.item.item).to_integer_32 /= 111 then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L___0:
						if not block_mode.to_boolean then
							if end2.col = 0 then
								if l_yanklines > 1 then
									l_yanktype := 1
									l_yankendlnum := l_yankendlnum - 1
									l_yanklines := l_yanklines - 1
								end
							end
						end
				when 13 then -- if done | if done | if done | if done;
						(create {P_OPS_STATIC}).y_current.item.item.y_size := l_yanklines
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_OPS_STATIC}).y_current.item.item.y_type := l_yanktype.to_natural_8
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_OPS_STATIC}).y_current.item.item.y_width := 0
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___0 := (create {P_MISC2_STATIC}).lalloc_clear (({PLATFORM}.Pointer_bytes.to_natural_32).to_natural_32 * l_yanklines.to_natural_32, 1)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_OPS_STATIC}).y_current.item.item.y_array := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_tmp___0)
						update_class_fields -- Current might have been changed; synchronize
						if ((create {P_OPS_STATIC}).y_current.item.item.y_array).is_void then
							(create {P_OPS_STATIC}).y_current.item := l_curr
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						end
				when 14 then -- if done
					if l_return then
						l_pos := -1 + 61 -- skip if block
					end
				when 15 then -- if:
						l_y_idx := 0
						l_lnum := start.lnum
						if block_mode.to_boolean then
							(create {P_OPS_STATIC}).y_current.item.item.y_type := (2).to_natural_8
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_OPS_STATIC}).y_current.item.item.y_width := end_vcol - start_vcol
							update_class_fields -- Current might have been changed; synchronize
							if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant).to_integer_32 = 2_147_483_647 then
								if (create {P_OPS_STATIC}).y_current.item.item.y_width > 0 then
									(create {P_OPS_STATIC}).y_current.item.item.y_width := ((create {P_OPS_STATIC}).y_current.item.item.y_width) - 1
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
				when 16 then -- loop condition:
						if not (l_lnum <= l_yankendlnum) then
							l_pos := -1 + 33 -- skip loop
						end
				when 17 then -- loop body:
						inspect ((create {P_OPS_STATIC}).y_current.item.item.y_type).to_integer_32 -- switch 1 head
						when 2 then l_pos := -1 + 18
						when 1 then l_pos := -1 + 20
						when 0 then l_pos := -1 + 22
						else l_pos := -1 + 32
						end
				when 18 then -- switch 1, case 2;
						((create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (c_pointer))).item.block_prep (l_bd, l_lnum, 0)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___1 := yank_copy_line (l_bd, l_y_idx)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___1 = 0 then
							l_pos := -1 + 62 -- goto fail
						end
				when 19 then
						l_pos := -1 + 32 -- switch 1; break
				when 20 then -- switch 1, case 1
						l_tmp___3 := (create {P_MEMLINE_STATIC}).ml_get (l_lnum)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___2 := (create {P_MISC2_STATIC}).vim_strsave (l_tmp___3)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_OPS_STATIC}).y_current.item.item.y_array[l_y_idx] := l_tmp___2
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___2.is_void then
							l_pos := -1 + 62 -- goto fail
						end
				when 21 then
						l_pos := -1 + 32 -- switch 1; break
				when 22 then -- switch 1, case 0
						l_startcol := 0
						l_endcol := (2_147_483_647).to_integer_32
						l_is_oneChar := 0
						l_p___0 := (create {P_MEMLINE_STATIC}).ml_get (l_lnum)
						update_class_fields -- Current might have been changed; synchronize
						l_bd.item.startspaces := 0
						update_class_fields -- Current might have been changed; synchronize
						l_bd.item.endspaces := 0
						update_class_fields -- Current might have been changed; synchronize
						if l_lnum = start.lnum then
							l_startcol := start.col
							if ((create {P_GLOBALS_STATIC}).virtual_op.item).to_boolean then
								((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (c_pointer + (create {PD_OPARG_S}.make).offset_of ("start")), l_cs, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_ce)
								update_class_fields -- Current might have been changed; synchronize
								if l_ce.item /= l_cs.item then
									if start.coladd > 0 then
										l_bd.item.startspaces := ((l_ce.item - l_cs.item) + 1) - start.coladd
										update_class_fields -- Current might have been changed; synchronize
										l_startcol := l_startcol + 1
									end
								end
							end
						end
						if l_lnum /= end2.lnum then
							l_pos := -1 + 30 -- skip if block
						end
				when 23 then -- if:
						l_endcol := end2.col
						if not (((create {P_GLOBALS_STATIC}).virtual_op.item).to_boolean) then
							l_pos := -1 + 30 -- skip if block
						end
				when 24 then -- if:;
						((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (c_pointer + (create {PD_OPARG_S}.make).offset_of ("end2")), l_cs, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_ce)
						update_class_fields -- Current might have been changed; synchronize
						if (l_p___0[l_endcol]).to_integer_32 /= 0 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 29 -- goto _L___1
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 27 then -- else:
						if not (l_cs.item + end2.coladd < l_ce.item) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						l_tmp___4 := (create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_p___0, l_p___0 + l_endcol])
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___4 /= 0 then
							l_pos := -1 + 30 -- skip if block
						end
				when 29 then -- if: | _L___1:
						if start.lnum = end2.lnum then
							if start.col = end2.col then
								l_is_oneChar := 1
								l_bd.item.startspaces := (end2.coladd - start.coladd) + inclusive
								update_class_fields -- Current might have been changed; synchronize
								l_endcol := l_startcol
							else
								l_bd.item.endspaces := end2.coladd + inclusive
								update_class_fields -- Current might have been changed; synchronize
								l_endcol := l_endcol - inclusive
							end
						else
							l_bd.item.endspaces := end2.coladd + inclusive
							update_class_fields -- Current might have been changed; synchronize
							l_endcol := l_endcol - inclusive
						end
				when 30 then -- if done | if done | if done | if done
						if l_startcol > l_endcol then
							l_bd.item.textlen := 0
							update_class_fields -- Current might have been changed; synchronize
						elseif l_is_oneChar.to_boolean then
							l_bd.item.textlen := 0
							update_class_fields -- Current might have been changed; synchronize
						else
							if l_endcol.to_integer_32 = 2_147_483_647 then
								l_tmp___5 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))
								update_class_fields -- Current might have been changed; synchronize
								l_endcol := l_tmp___5.to_integer_32
							end
							l_bd.item.textlen := (l_endcol - l_startcol) + inclusive
							update_class_fields -- Current might have been changed; synchronize
						end
						l_bd.item.textstart := l_p___0 + l_startcol
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___6 := yank_copy_line (l_bd, l_y_idx)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___6 = 0 then
							l_pos := -1 + 62 -- goto fail
						end
				when 31 then
						l_pos := -1 + 32 -- switch 1; break
				when 32 then -- switch 1, done:
						l_lnum := l_lnum + 1
						l_y_idx := l_y_idx + 1
						l_pos := -1 + 16 -- back to loop condition
				when 33 then -- loop done
						if l_curr.is_equal ((create {P_OPS_STATIC}).y_current.item) then
							l_pos := -1 + 44 -- skip if block
						end
				when 34 then -- if:
						l_tmp___7 := (create {P_MISC2_STATIC}).lalloc (({PLATFORM}.Pointer_bytes.to_natural_32).to_natural_32 * (l_curr.item.y_size + (create {P_OPS_STATIC}).y_current.item.item.y_size).to_natural_32, 1)
						update_class_fields -- Current might have been changed; synchronize
						l_new_ptr := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_tmp___7)
						if l_new_ptr.is_void then
							l_pos := -1 + 62 -- goto fail
						end
				when 35 then
						l_j := 0
						from
						until
							not (l_j < l_curr.item.y_size)
						loop
							l_new_ptr[l_j] := l_curr.item.y_array[l_j]
							update_class_fields -- Current might have been changed; synchronize
							l_j := l_j + 1
						end
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_curr.item.y_array))
						update_class_fields -- Current might have been changed; synchronize
						l_curr.item.y_array := l_new_ptr
						update_class_fields -- Current might have been changed; synchronize
						if l_yanktype = 1 then
							l_curr.item.y_type := (1).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
						end
						if (l_curr.item.y_type).to_integer_32 /= 0 then
							l_pos := -1 + 42 -- skip if block
						end
				when 36 then -- if:
						l_tmp___11 := (create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('>').code)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___11.is_void) then
							l_pos := -1 + 40 -- skip if block
						end
				when 37 then -- if:
						l_tmp___8 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_curr.item.y_array[(l_curr.item.y_size - 1)]))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___9 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPS_STATIC}).y_current.item.item.y_array[0]))
						update_class_fields -- Current might have been changed; synchronize
						l_pnew := (create {P_MISC2_STATIC}).lalloc (((l_tmp___8 + l_tmp___9) + {NATURAL_32} 1).to_natural_32, 1)
						update_class_fields -- Current might have been changed; synchronize
						if l_pnew.is_void then
							l_y_idx := (create {P_OPS_STATIC}).y_current.item.item.y_size - 1
							l_pos := -1 + 62 -- goto fail
						end
				when 38 then
						l_j := l_j - 1
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_pnew), create {CE_INTEGER_8_POINTER}.make_cast (l_curr.item.y_array[l_j])).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_pnew), create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPS_STATIC}).y_current.item.item.y_array[0])).do_nothing
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_curr.item.y_array[l_j]))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_OPS_STATIC}).y_current.item.item.y_array[0]))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___10 := l_j
						l_j := l_j + 1
						l_curr.item.y_array[l_tmp___10] := l_pnew
						update_class_fields -- Current might have been changed; synchronize
						l_y_idx := 1
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 40 then -- else:
						l_y_idx := 0
				when 41 then -- if done | if block done, skip else block:
						l_pos := -1 + 43
				when 42 then -- else:
						l_y_idx := 0
				when 43 then -- if done
						from
						until
							not (l_y_idx < (create {P_OPS_STATIC}).y_current.item.item.y_size)
						loop
							l_tmp___12 := l_j
							l_j := l_j + 1
							l_tmp___13 := l_y_idx
							l_y_idx := l_y_idx + 1
							l_curr.item.y_array[l_tmp___12] := (create {P_OPS_STATIC}).y_current.item.item.y_array[l_tmp___13]
							update_class_fields -- Current might have been changed; synchronize
						end
						l_curr.item.y_size := l_j
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_OPS_STATIC}).y_current.item.item.y_array))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_OPS_STATIC}).y_current.item := l_curr
						update_class_fields -- Current might have been changed; synchronize
				when 44 then -- if done
						if a_mess.to_boolean then
							if l_yanktype = 0 then
								if not block_mode.to_boolean then
									if l_yanklines = 1 then
										l_yanklines := 0
									end
								end
							end
							if l_yanklines > (create {P_OPTION_STATIC}).p_report.item.item then
								(create {P_MOVE_STATIC}).update_topline_redraw
								update_class_fields -- Current might have been changed; synchronize
								if l_yanklines = 1 then
									if block_mode.to_boolean then
										l_tmp___14 := gettext (ce_string ("block of 1 line yanked"))
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___14)).do_nothing
										update_class_fields -- Current might have been changed; synchronize
									else
										l_tmp___15 := gettext (ce_string ("1 line yanked"))
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___15)).do_nothing
										update_class_fields -- Current might have been changed; synchronize
									end
								elseif block_mode.to_boolean then
									l_tmp___16 := gettext (ce_string ("block of %%ld lines yanked"))
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___16), l_yanklines]).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								else
									l_tmp___17 := gettext (ce_string ("%%ld lines yanked"))
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___17), l_yanklines]).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start := start.twin
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end := end2.twin
						update_class_fields -- Current might have been changed; synchronize
						if l_yanktype = 1 then
							if not block_mode.to_boolean then
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.col := 0
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.col := (2_147_483_647).to_integer_32
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if not (((create {P_GLOBALS_STATIC}).clip_star.item.item.available).to_boolean) then
							l_pos := -1 + 59 -- skip if block
						end
				when 45 then -- if:
						if not (l_curr.is_equal ((create {P_OPS_STATIC}).y_regs.item + 37)) then
							l_pos := -1 + 48 -- skip if block
						end
				when 46 then -- if:
						l_pos := -1 + 51 -- goto _L___3
				when 47 then -- if block done, skip else block:
						l_pos := -1 + 58
				when 48 then -- else:
						if a_deleting.to_boolean then
							l_pos := -1 + 57 -- skip if block
						end
				when 49 then -- if:
						if regname /= 0 then
							l_pos := -1 + 55 -- skip if block
						end
				when 50 then -- if:
						if not (((create {P_GLOBALS_STATIC}).clip_unnamed.item).to_boolean) then
							l_pos := -1 + 53 -- skip if block
						end
				when 51 then -- if: | _L___3:
						if not l_curr.is_equal ((create {P_OPS_STATIC}).y_regs.item + 37) then
							copy_yank_reg ((create {P_OPS_STATIC}).y_regs.item + 37)
							update_class_fields -- Current might have been changed; synchronize
						end
						((create {P_GLOBALS_STATIC}).clip_star.item).item.clip_own_selection
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_UI_STATIC}).clip_gen_set_selection ((create {P_GLOBALS_STATIC}).clip_star.item)
						update_class_fields -- Current might have been changed; synchronize
				when 52 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 53 then -- else:
						l_pos := -1 + 59 -- goto _L___2
				when 54 then -- if done | if block done, skip else block:
						l_pos := -1 + 56
				when 55 then -- else:
						l_pos := -1 + 59 -- goto _L___2
				when 56 then -- if done | if block done, skip else block:
						l_pos := -1 + 58
				when 57 then -- else:
						l_pos := -1 + 59 -- goto _L___2
				when 58 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 60
				when 59 then -- else: | _L___2:
						if ((create {P_GLOBALS_STATIC}).clip_plus.item.item.available).to_boolean then
							if l_curr.is_equal ((create {P_OPS_STATIC}).y_regs.item + 38) then
								((create {P_GLOBALS_STATIC}).clip_plus.item).item.clip_own_selection
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_UI_STATIC}).clip_gen_set_selection ((create {P_GLOBALS_STATIC}).clip_plus.item)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___18 := (create {P_UI_STATIC}).clip_isautosel
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp___18.to_boolean then
									copy_yank_reg ((create {P_OPS_STATIC}).y_regs.item + 37)
									update_class_fields; -- Current might have been changed; synchronize
									((create {P_GLOBALS_STATIC}).clip_star.item).item.clip_own_selection
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_UI_STATIC}).clip_gen_set_selection ((create {P_GLOBALS_STATIC}).clip_star.item)
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
				when 60 then
						Result := 1
						l_return := True
				when 61 then -- if done
					if l_return then
						l_pos := -1 + 63 -- skip if block
					end
				when 62 then -- if: | fail:;
						(create {P_OPS_STATIC}).free_yank (l_y_idx + 1)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_OPS_STATIC}).y_current.item := l_curr
						update_class_fields -- Current might have been changed; synchronize
						Result := 0
				when 63 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	block_prep (a_bdp: CE_POINTER [PD_BLOCK_DEF]; a_lnum: INTEGER_32; a_is_del: INTEGER_32)
		require
			not a_bdp.is_void
		local
			l_incr: INTEGER_32
			l_pend: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_pstart: CE_POINTER [NATURAL_8]
			l_line: CE_POINTER [NATURAL_8]
			l_prev_pstart: CE_POINTER [NATURAL_8]
			l_prev_pend: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_pend.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_incr := 0
					a_bdp.item.startspaces := 0
					update_class_fields -- Current might have been changed; synchronize
					a_bdp.item.endspaces := 0
					update_class_fields -- Current might have been changed; synchronize
					a_bdp.item.textlen := 0
					update_class_fields -- Current might have been changed; synchronize
					a_bdp.item.start_vcol := 0
					update_class_fields -- Current might have been changed; synchronize
					a_bdp.item.end_vcol := 0
					update_class_fields -- Current might have been changed; synchronize
					a_bdp.item.is_short := 0
					update_class_fields -- Current might have been changed; synchronize
					a_bdp.item.is_oneChar := 0
					update_class_fields -- Current might have been changed; synchronize
					a_bdp.item.pre_whitesp := 0
					update_class_fields -- Current might have been changed; synchronize
					a_bdp.item.pre_whitesp_c := 0
					update_class_fields -- Current might have been changed; synchronize
					a_bdp.item.end_char_vcols := 0
					update_class_fields -- Current might have been changed; synchronize
					a_bdp.item.start_char_vcols := 0
					update_class_fields -- Current might have been changed; synchronize
					l_line := (create {P_MEMLINE_STATIC}).ml_get (a_lnum)
					update_class_fields -- Current might have been changed; synchronize
					l_pstart := l_line
					l_prev_pstart := l_line
					from
					until
						(l_break)
					loop
						l_break := False
						if a_bdp.item.start_vcol < start_vcol then
							if not (l_pstart.item).to_boolean then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_incr := (create {P_CHARSET_STATIC}).lbr_chartabsize (l_pstart, a_bdp.item.start_vcol)
							update_class_fields -- Current might have been changed; synchronize
							a_bdp.item.start_vcol := a_bdp.item.start_vcol + l_incr
							update_class_fields -- Current might have been changed; synchronize
							if (l_pstart.item).to_integer_32 = 32 then
								a_bdp.item.pre_whitesp := a_bdp.item.pre_whitesp + l_incr
								update_class_fields -- Current might have been changed; synchronize
								a_bdp.item.pre_whitesp_c := (a_bdp.item.pre_whitesp_c) + 1
								update_class_fields -- Current might have been changed; synchronize
							elseif (l_pstart.item).to_integer_32 = 9 then
								a_bdp.item.pre_whitesp := a_bdp.item.pre_whitesp + l_incr
								update_class_fields -- Current might have been changed; synchronize
								a_bdp.item.pre_whitesp_c := (a_bdp.item.pre_whitesp_c) + 1
								update_class_fields -- Current might have been changed; synchronize
							else
								a_bdp.item.pre_whitesp := 0
								update_class_fields -- Current might have been changed; synchronize
								a_bdp.item.pre_whitesp_c := 0
								update_class_fields -- Current might have been changed; synchronize
							end
							l_prev_pstart := l_pstart
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_pstart])
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___0 := l_tmp
							else
								l_tmp___0 := 1
							end
							l_pstart := l_pstart + l_tmp___0
						end
					end
					l_break := False
					a_bdp.item.start_char_vcols := l_incr
					update_class_fields -- Current might have been changed; synchronize
					if not (a_bdp.item.start_vcol < start_vcol) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_bdp.item.end_vcol := a_bdp.item.start_vcol
						update_class_fields -- Current might have been changed; synchronize
						a_bdp.item.is_short := 1
						update_class_fields -- Current might have been changed; synchronize
						if not a_is_del.to_boolean then
							a_bdp.item.endspaces := (end_vcol - start_vcol) + 1
							update_class_fields -- Current might have been changed; synchronize
						elseif op_type = 18 then
							a_bdp.item.endspaces := (end_vcol - start_vcol) + 1
							update_class_fields -- Current might have been changed; synchronize
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 3 then -- else:
						a_bdp.item.startspaces := a_bdp.item.start_vcol - start_vcol
						update_class_fields -- Current might have been changed; synchronize
						if a_is_del.to_boolean then
							if (a_bdp.item.startspaces).to_boolean then
								a_bdp.item.startspaces := a_bdp.item.start_char_vcols - a_bdp.item.startspaces
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_pend.item := l_pstart
						update_class_fields -- Current might have been changed; synchronize
						a_bdp.item.end_vcol := a_bdp.item.start_vcol
						update_class_fields -- Current might have been changed; synchronize
						if not (a_bdp.item.end_vcol > end_vcol) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						a_bdp.item.is_oneChar := 1
						update_class_fields -- Current might have been changed; synchronize
						if op_type = 17 then
							a_bdp.item.endspaces := a_bdp.item.start_char_vcols - a_bdp.item.startspaces
							update_class_fields -- Current might have been changed; synchronize
						elseif op_type = 18 then
							a_bdp.item.startspaces := a_bdp.item.startspaces + ((end_vcol - start_vcol) + 1)
							update_class_fields -- Current might have been changed; synchronize
							a_bdp.item.endspaces := a_bdp.item.start_char_vcols - a_bdp.item.startspaces
							update_class_fields -- Current might have been changed; synchronize
						else
							a_bdp.item.startspaces := (end_vcol - start_vcol) + 1
							update_class_fields -- Current might have been changed; synchronize
							if a_is_del.to_boolean then
								if op_type /= 4 then
									a_bdp.item.startspaces := a_bdp.item.start_char_vcols - (a_bdp.item.start_vcol - start_vcol)
									update_class_fields -- Current might have been changed; synchronize
									a_bdp.item.endspaces := (a_bdp.item.end_vcol - end_vcol) - 1
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 6 then -- else:
						l_prev_pend := l_pend.item
						from
						until
							(l_break)
						loop
							l_break := False
							if a_bdp.item.end_vcol <= end_vcol then
								if (l_pend.item.item).to_integer_32 = 0 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_prev_pend := l_pend.item
								l_incr := (create {P_CHARSET_STATIC}).lbr_chartabsize_adv (l_pend, a_bdp.item.end_vcol)
								update_class_fields -- Current might have been changed; synchronize
								a_bdp.item.end_vcol := a_bdp.item.end_vcol + l_incr
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_break := False
						if not (a_bdp.item.end_vcol <= end_vcol) then
							l_pos := -1 + 18 -- skip if block
						end
				when 7 then -- if:
						if a_is_del.to_boolean then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 14 -- goto _L___0
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 10 then -- else:
						if op_type /= 18 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L___0
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 13 then -- else:
						if op_type /= 16 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if: | _L___0:
						a_bdp.item.is_short := 1
						update_class_fields -- Current might have been changed; synchronize
						if op_type = 18 then
							a_bdp.item.endspaces := (end_vcol - a_bdp.item.end_vcol) + inclusive
							update_class_fields -- Current might have been changed; synchronize
						elseif ((create {P_GLOBALS_STATIC}).virtual_op.item).to_boolean then
							a_bdp.item.endspaces := (end_vcol - a_bdp.item.end_vcol) + inclusive
							update_class_fields -- Current might have been changed; synchronize
						else
							a_bdp.item.endspaces := 0
							update_class_fields -- Current might have been changed; synchronize
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						l_pos := -1 + 18 -- goto _L
				when 17 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L:
						if a_bdp.item.end_vcol > end_vcol then
							a_bdp.item.endspaces := (a_bdp.item.end_vcol - end_vcol) - 1
							update_class_fields -- Current might have been changed; synchronize
							if not a_is_del.to_boolean then
								if (a_bdp.item.endspaces).to_boolean then
									a_bdp.item.endspaces := l_incr - a_bdp.item.endspaces
									update_class_fields -- Current might have been changed; synchronize
									if not (l_pend.item).is_equal (l_pstart) then
										l_pend.item := l_prev_pend
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							end
						end
				when 19 then -- if done
						a_bdp.item.end_char_vcols := l_incr
						update_class_fields -- Current might have been changed; synchronize
						if a_is_del.to_boolean then
							if (a_bdp.item.startspaces).to_boolean then
								l_pstart := l_prev_pstart
							end
						end
						a_bdp.item.textlen := (l_pend.item).distance (l_pstart)
						update_class_fields -- Current might have been changed; synchronize
				when 20 then -- if done
					a_bdp.item.textcol := l_pstart.distance (l_line)
					update_class_fields -- Current might have been changed; synchronize
					a_bdp.item.textstart := l_pstart
					update_class_fields -- Current might have been changed; synchronize
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {PD_OPARG_S} -- private routines

	fix_indent
		local
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((create {P_OPTION_STATIC}).p_paste.item.item).to_boolean then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_lisp).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ai).to_boolean then
							(create {P_EDIT_STATIC}).fixthisline ((create {P_MISC1_STATIC}).get_lisp_indent_address)
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if ((create {P_EDIT_STATIC}).cindent_on).to_boolean then
							(create {P_MISC1_STATIC}).do_c_expr_indent
						end
				when 5 then -- if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_vcount (a_count___2, a_count1: INTEGER_32; a_set_prevcount: INTEGER_32)
		do
			if a_set_prevcount.to_boolean then
				(create {P_EVAL_STATIC}).vimvars.item[2].vv_di.di_tv.vval.v_number := (create {P_EVAL_STATIC}).vimvars.item[0].vv_di.di_tv.vval.v_number
			end
			(create {P_EVAL_STATIC}).vimvars.item[0].vv_di.di_tv.vval.v_number := a_count___2.to_integer_32;
			(create {P_EVAL_STATIC}).vimvars.item[1].vv_di.di_tv.vval.v_number := a_count1.to_integer_32
		end

	typebuf_maplen: INTEGER_32
		do
			Result := ((create {P_GLOBALS_STATIC}).typebuf.item.tb_maplen)
		end

	find_command___0 (a_cmdchar: INTEGER_32): INTEGER_32
		local
			l_cmdchar: INTEGER_32
			l_i___0: INTEGER_32
			l_idx: INTEGER_32
			l_top: INTEGER_32
			l_bot: INTEGER_32
			l_c: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_cmdchar := a_cmdchar
			if l_cmdchar >= 256 then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				if l_cmdchar < 0 then
					l_cmdchar := -l_cmdchar
				end
				if l_cmdchar <= (create {P_NORMAL_STATIC}).nv_max_linear.item then
					Result := ((create {P_NORMAL_STATIC}).nv_cmd_idx.item.item[l_cmdchar]).to_integer_32
					l_return := True
				end
			end
			if not l_return then
				l_bot := (create {P_NORMAL_STATIC}).nv_max_linear.item + 1
				l_top := (((create {PD_NV_CMD}.make).structure_size.to_natural_32 * (190).to_natural_32) // (create {PD_NV_CMD}.make).structure_size.to_natural_32 - {NATURAL_32} 1).to_integer_32
				l_idx := -1
				from
				until
					not (not (l_break) and then (l_bot <= l_top))
				loop
					l_break := False
					l_i___0 := (l_top + l_bot) // 2
					l_c := (create {P_NORMAL_STATIC}).nv_cmds.item[((create {P_NORMAL_STATIC}).nv_cmd_idx.item.item[l_i___0]).to_integer_32].cmd_char
					if l_c < 0 then
						l_c := -l_c
					end
					if l_cmdchar = l_c then
						l_idx := ((create {P_NORMAL_STATIC}).nv_cmd_idx.item.item[l_i___0]).to_integer_32
						l_break := True
					end
					if not (l_break) then
						if l_cmdchar > l_c then
							l_bot := l_i___0 + 1
						else
							l_top := l_i___0 - 1
						end
					end
				end
				l_break := False
				Result := l_idx
			end
		end

	unshift_special (a_cap: CE_POINTER [PD_CMDARG_S])
		require
			not a_cap.is_void
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_cap.item.cmdchar -- switch 1 head
					when -26917 then l_pos := -1 + 1 -- -(37 + ((105).bit_shift_left (8)))
					when -13347 then l_pos := -1 + 2 -- -(35 + ((52).bit_shift_left (8)))
					when -1277 then l_pos := -1 + 3 -- -(253 + ((4).bit_shift_left (8)))
					when -1533 then l_pos := -1 + 4 -- -(253 + ((5).bit_shift_left (8)))
					when -12835 then l_pos := -1 + 5 -- -(35 + ((50).bit_shift_left (8)))
					when -14122 then l_pos := -1 + 6 -- -(42 + ((55).bit_shift_left (8)))
					else l_pos := -1 + 7
					end
				when 1 then -- switch 1, case -(37 + (105 << 8))
					a_cap.item.cmdchar := -(107 + ((114).bit_shift_left (8)))
					l_pos := -1 + 7 -- switch 1; break
				when 2 then -- switch 1, case -(35 + (52 << 8))
					a_cap.item.cmdchar := -(107 + ((108).bit_shift_left (8)))
					l_pos := -1 + 7 -- switch 1; break
				when 3 then -- switch 1, case -(253 + (4 << 8))
					a_cap.item.cmdchar := -(107 + ((117).bit_shift_left (8)))
					l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case -(253 + (5 << 8))
					a_cap.item.cmdchar := -(107 + ((100).bit_shift_left (8)))
					l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case -(35 + (50 << 8))
					a_cap.item.cmdchar := -(107 + ((104).bit_shift_left (8)))
					l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, case -(42 + (55 << 8))
					a_cap.item.cmdchar := -(64 + ((55).bit_shift_left (8)))
					l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
					a_cap.item.cmdchar := (create {P_MISC2_STATIC}).simplify_key (a_cap.item.cmdchar, (create {P_GLOBALS_STATIC}).mod_mask.item)
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	del_from_showcmd (a_len: INTEGER_32)
		local
			l_len: INTEGER_32
			l_old_len: INTEGER_32
			l_return: BOOLEAN
		do
			l_len := a_len
			if not ((create {P_OPTION_STATIC}).p_sc.item.item).to_boolean then
				l_return := True
			end
			if not l_return then
				l_old_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_NORMAL_STATIC}).showcmd_buf.item)))).to_integer_32
				if l_len > l_old_len then
					l_len := l_old_len
				end
				(create {P_NORMAL_STATIC}).showcmd_buf.item[l_old_len - l_len] := (('%/0/').code).to_natural_8
				if not ((create {P_GETCHAR_STATIC}).char_avail).to_boolean then
					(create {P_NORMAL_STATIC}).display_showcmd
				end
			end
		end

	yank_copy_line (a_bd: CE_POINTER [PD_BLOCK_DEF]; a_y_idx: INTEGER_32): INTEGER_32
		require
			not a_bd.is_void
		local
			l_pnew: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_pnew := (create {P_MISC2_STATIC}).alloc ((((a_bd.item.startspaces + a_bd.item.endspaces) + a_bd.item.textlen) + 1).to_natural_32)
			if l_pnew.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				(create {P_OPS_STATIC}).y_current.item.item.y_array[a_y_idx] := l_pnew;
				(create {P_MISC2_STATIC}).copy_spaces (l_pnew, (a_bd.item.startspaces).to_natural_32)
				l_pnew := l_pnew + (a_bd.item.startspaces)
				memmove (create {CE_VOID_POINTER}.make_cast (l_pnew), create {CE_VOID_POINTER}.make_cast (a_bd.item.textstart), (a_bd.item.textlen).to_natural_32).do_nothing
				l_pnew := l_pnew + (a_bd.item.textlen);
				(create {P_MISC2_STATIC}).copy_spaces (l_pnew, (a_bd.item.endspaces).to_natural_32)
				l_pnew := l_pnew + (a_bd.item.endspaces)
				l_pnew.item := (('%/0/').code).to_natural_8
				Result := 1
			end
		end

	copy_yank_reg (a_reg___0: CE_POINTER [PD_YANKREG])
		local
			l_curr: CE_POINTER [PD_YANKREG]
			l_j: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_break: BOOLEAN
		do
			l_curr := (create {P_OPS_STATIC}).y_current.item;
			(create {P_OPS_STATIC}).y_current.item := a_reg___0;
			(create {P_OPS_STATIC}).free_yank_all;
			(create {P_OPS_STATIC}).y_current.item.item := (l_curr.item).twin;
			(create {P_OPS_STATIC}).y_current.item.item.y_array := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (((create {P_MISC2_STATIC}).lalloc_clear (({PLATFORM}.Pointer_bytes.to_natural_32).to_natural_32 * ((create {P_OPS_STATIC}).y_current.item.item.y_size).to_natural_32, 1)))
			if ((create {P_OPS_STATIC}).y_current.item.item.y_array).is_void then
				(create {P_OPS_STATIC}).y_current.item.item.y_size := (0).to_integer_32
			else
				l_j := 0
				from
				until
					not (not (l_break) and then (l_j < (create {P_OPS_STATIC}).y_current.item.item.y_size))
				loop
					l_break := False
					l_tmp___0 := (create {P_MISC2_STATIC}).vim_strsave (l_curr.item.y_array[l_j]);
					(create {P_OPS_STATIC}).y_current.item.item.y_array[l_j] := l_tmp___0
					if l_tmp___0.is_void then
						(create {P_OPS_STATIC}).free_yank (l_j);
						(create {P_OPS_STATIC}).y_current.item.item.y_size := (0).to_integer_32
						l_break := True
					end
					if not (l_break) then
						l_j := l_j + 1
					end
				end
				l_break := False
			end
			(create {P_OPS_STATIC}).y_current.item := l_curr
		end

feature {ANY}

	copy (a_other: like Current)
		do
			op_type := a_other.op_type
			regname := a_other.regname
			motion_type := a_other.motion_type
			motion_force := a_other.motion_force
			use_reg_one := a_other.use_reg_one
			inclusive := a_other.inclusive
			end_adjusted := a_other.end_adjusted
			start := a_other.start.twin
			end2 := a_other.end2.twin
			cursor_start := a_other.cursor_start.twin
			line_count := a_other.line_count
			empty := a_other.empty
			is_VIsual := a_other.is_VIsual
			block_mode := a_other.block_mode
			start_vcol := a_other.start_vcol
			end_vcol := a_other.end_vcol
			prev_opcount := a_other.prev_opcount
			prev_count0 := a_other.prev_count0
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				op_type = a_other.op_type and
				regname = a_other.regname and
				motion_type = a_other.motion_type and
				motion_force = a_other.motion_force and
				use_reg_one = a_other.use_reg_one and
				inclusive = a_other.inclusive and
				end_adjusted = a_other.end_adjusted and
				start.is_equal (a_other.start) and
				end2.is_equal (a_other.end2) and
				cursor_start.is_equal (a_other.cursor_start) and
				line_count = a_other.line_count and
				empty = a_other.empty and
				is_VIsual = a_other.is_VIsual and
				block_mode = a_other.block_mode and
				start_vcol = a_other.start_vcol and
				end_vcol = a_other.end_vcol and
				prev_opcount = a_other.prev_opcount and
				prev_count0 = a_other.prev_count0
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("op_type"),
					create {CE_STRUCTURE_FIELD}.make ("regname"),
					create {CE_STRUCTURE_FIELD}.make ("motion_type"),
					create {CE_STRUCTURE_FIELD}.make ("motion_force"),
					create {CE_STRUCTURE_FIELD}.make ("use_reg_one"),
					create {CE_STRUCTURE_FIELD}.make ("inclusive"),
					create {CE_STRUCTURE_FIELD}.make ("end_adjusted"),
					create {CE_STRUCTURE_FIELD}.make ("start"),
					create {CE_STRUCTURE_FIELD}.make ("end2"),
					create {CE_STRUCTURE_FIELD}.make ("cursor_start"),
					create {CE_STRUCTURE_FIELD}.make ("line_count"),
					create {CE_STRUCTURE_FIELD}.make ("empty"),
					create {CE_STRUCTURE_FIELD}.make ("is_VIsual"),
					create {CE_STRUCTURE_FIELD}.make ("block_mode"),
					create {CE_STRUCTURE_FIELD}.make ("start_vcol"),
					create {CE_STRUCTURE_FIELD}.make ("end_vcol"),
					create {CE_STRUCTURE_FIELD}.make ("prev_opcount"),
					create {CE_STRUCTURE_FIELD}.make ("prev_count0")
				>>)
			init_structure_info
		end

end
