class
	PD_REG_EXTMATCH_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} matches.make (<<10>>)
		end

feature {ANY} -- fields

	refcnt: INTEGER_16 assign set_refcnt

	matches: CE_ARRAY [CE_POINTER [NATURAL_8]]

feature {ANY} -- field setters

	set_refcnt (a_refcnt: INTEGER_16)
		do
			refcnt := a_refcnt
			update_memory_field ("refcnt")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			refcnt := a_other.refcnt
			matches := a_other.matches.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				refcnt = a_other.refcnt and
				matches.is_equal (a_other.matches)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("refcnt"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("matches", <<10>>)
				>>)
			init_structure_info
		end

end
