class
	S_FCNTL_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	open (a_args: TUPLE [a___file: CE_POINTER [INTEGER_8]; a___oflag: INTEGER_32]): INTEGER_32
		require
			not a_args.a___file.is_void
		do
			Result := (create {CE_ROUTINE}.make_shared (c_open)).integer_32_item (a_args)
		end

	c_open: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)&open;"
		end

	fcntl (a_args: TUPLE [a___fd, a___cmd: INTEGER_32]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_fcntl)).integer_32_item (a_args)
		end

	c_fcntl: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)&fcntl;"
		end

end
