class
	S_MATH_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	acos (a___x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return acos($a___x);"
		end

	asin (a___x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return asin($a___x);"
		end

	atan (a___x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return atan($a___x);"
		end

	atan2 (a___y: REAL_64; a___x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return atan2($a___y, $a___x);"
		end

	cos (a___x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return cos($a___x);"
		end

	sin (a___x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return sin($a___x);"
		end

	tan (a___x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return tan($a___x);"
		end

	cosh (a___x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return cosh($a___x);"
		end

	sinh (a___x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return sinh($a___x);"
		end

	tanh (a___x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return tanh($a___x);"
		end

	exp (a___x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return exp($a___x);"
		end

	log (a___x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return log($a___x);"
		end

	log10 (a___x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return log10($a___x);"
		end

	pow (a___x: REAL_64; a___y: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return pow($a___x, $a___y);"
		end

	sqrt (a___x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return sqrt($a___x);"
		end

	ceil (a___x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return ceil($a___x);"
		end

	fabs (a___x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return fabs($a___x);"
		end

	floor (a___x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return floor($a___x);"
		end

	fmod (a___x: REAL_64; a___y: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return fmod($a___x, $a___y);"
		end

end
