class
	S_X11_XLIB_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	XInternAtom (a_arg1: CE_POINTER [ANY]; a_arg2: CE_POINTER [INTEGER_8]; a_arg3: INTEGER_32): NATURAL_32
		do
			Result := c_XInternAtom (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3)
		end

	c_XInternAtom (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return XInternAtom($a_arg1, $a_arg2, $a_arg3);"
		end

	XCreateSimpleWindow (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32; a_arg3, a_arg4: INTEGER_32; a_arg5, a_arg6, a_arg7: NATURAL_32; a_arg8, a_arg9: NATURAL_32): NATURAL_32
		do
			Result := c_XCreateSimpleWindow (a_arg1.c_pointer, a_arg2, a_arg3, a_arg4, a_arg5, a_arg6, a_arg7, a_arg8, a_arg9)
		end

	c_XCreateSimpleWindow (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: INTEGER_32; a_arg4: INTEGER_32; a_arg5: NATURAL_32; a_arg6: NATURAL_32; a_arg7: NATURAL_32; a_arg8: NATURAL_32; a_arg9: NATURAL_32): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return XCreateSimpleWindow($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5, $a_arg6, $a_arg7, $a_arg8, $a_arg9);"
		end

	XListProperties (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32; a_arg3: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_32]
		do
			create {CE_NATURAL_32_POINTER} Result.make_shared (c_XListProperties (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer))
		end

	c_XListProperties (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)XListProperties($a_arg1, $a_arg2, $a_arg3);"
		end

	XDefaultRootWindow (a_arg1: CE_POINTER [ANY]): NATURAL_32
		do
			Result := c_XDefaultRootWindow (a_arg1.c_pointer)
		end

	c_XDefaultRootWindow (a_arg1: POINTER): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return XDefaultRootWindow($a_arg1);"
		end

	XSetErrorHandler (a_arg1: CE_ROUTINE): CE_ROUTINE
		do
			create Result.make_shared (c_XSetErrorHandler (a_arg1.c_pointer))
		end

	c_XSetErrorHandler (a_arg1: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)XSetErrorHandler($a_arg1);"
		end

	XChangeProperty (a_arg1: CE_POINTER [ANY]; a_arg2, a_arg3, a_arg4: NATURAL_32; a_arg5, a_arg6: INTEGER_32; a_arg7: CE_POINTER [NATURAL_8]; a_arg8: INTEGER_32): INTEGER_32
		do
			Result := c_XChangeProperty (a_arg1.c_pointer, a_arg2, a_arg3, a_arg4, a_arg5, a_arg6, a_arg7.c_pointer, a_arg8)
		end

	c_XChangeProperty (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: NATURAL_32; a_arg4: NATURAL_32; a_arg5: INTEGER_32; a_arg6: INTEGER_32; a_arg7: POINTER; a_arg8: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XChangeProperty($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5, $a_arg6, $a_arg7, $a_arg8);"
		end

	XDeleteProperty (a_arg1: CE_POINTER [ANY]; a_arg2, a_arg3: NATURAL_32): INTEGER_32
		do
			Result := c_XDeleteProperty (a_arg1.c_pointer, a_arg2, a_arg3)
		end

	c_XDeleteProperty (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: NATURAL_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XDeleteProperty($a_arg1, $a_arg2, $a_arg3);"
		end

	XEventsQueued (a_arg1: CE_POINTER [ANY]; a_arg2: INTEGER_32): INTEGER_32
		do
			Result := c_XEventsQueued (a_arg1.c_pointer, a_arg2)
		end

	c_XEventsQueued (a_arg1: POINTER; a_arg2: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XEventsQueued($a_arg1, $a_arg2);"
		end

	XFlush (a_arg1: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_XFlush (a_arg1.c_pointer)
		end

	c_XFlush (a_arg1: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XFlush($a_arg1);"
		end

	XFree (a_arg1: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_XFree (a_arg1.c_pointer)
		end

	c_XFree (a_arg1: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XFree($a_arg1);"
		end

	XGetGeometry (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32; a_arg3: CE_POINTER [NATURAL_32]; a_arg4, a_arg5: CE_POINTER [INTEGER_32]; a_arg6, a_arg7, a_arg8, a_arg9: CE_POINTER [NATURAL_32]): INTEGER_32
		do
			Result := c_XGetGeometry (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4.c_pointer, a_arg5.c_pointer, a_arg6.c_pointer, a_arg7.c_pointer, a_arg8.c_pointer, a_arg9.c_pointer)
		end

	c_XGetGeometry (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: POINTER; a_arg4: POINTER; a_arg5: POINTER; a_arg6: POINTER; a_arg7: POINTER; a_arg8: POINTER; a_arg9: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XGetGeometry($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5, $a_arg6, $a_arg7, $a_arg8, $a_arg9);"
		end

	XGetWindowProperty (a_arg1: CE_POINTER [ANY]; a_arg2, a_arg3: NATURAL_32; a_arg4, a_arg5: INTEGER_32; a_arg6: INTEGER_32; a_arg7: NATURAL_32; a_arg8: CE_POINTER [NATURAL_32]; a_arg9: CE_POINTER [INTEGER_32]; a_arg10, a_arg11: CE_POINTER [NATURAL_32]; a_arg12: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		do
			Result := c_XGetWindowProperty (a_arg1.c_pointer, a_arg2, a_arg3, a_arg4, a_arg5, a_arg6, a_arg7, a_arg8.c_pointer, a_arg9.c_pointer, a_arg10.c_pointer, a_arg11.c_pointer, a_arg12.c_pointer)
		end

	c_XGetWindowProperty (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: NATURAL_32; a_arg4: INTEGER_32; a_arg5: INTEGER_32; a_arg6: INTEGER_32; a_arg7: NATURAL_32; a_arg8: POINTER; a_arg9: POINTER; a_arg10: POINTER; a_arg11: POINTER; a_arg12: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XGetWindowProperty($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5, $a_arg6, $a_arg7, $a_arg8, $a_arg9, $a_arg10, $a_arg11, $a_arg12);"
		end

	XGrabServer (a_arg1: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_XGrabServer (a_arg1.c_pointer)
		end

	c_XGrabServer (a_arg1: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XGrabServer($a_arg1);"
		end

	XNextEvent (a_arg1: CE_POINTER [ANY]; a_arg2: CE_POINTER [SD_XEVENT]): INTEGER_32
		do
			Result := c_XNextEvent (a_arg1.c_pointer, a_arg2.c_pointer)
		end

	c_XNextEvent (a_arg1: POINTER; a_arg2: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XNextEvent($a_arg1, $a_arg2);"
		end

	XSelectInput (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32; a_arg3: INTEGER_32): INTEGER_32
		do
			Result := c_XSelectInput (a_arg1.c_pointer, a_arg2, a_arg3)
		end

	c_XSelectInput (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XSelectInput($a_arg1, $a_arg2, $a_arg3);"
		end

	XSync (a_arg1: CE_POINTER [ANY]; a_arg2: INTEGER_32): INTEGER_32
		do
			Result := c_XSync (a_arg1.c_pointer, a_arg2)
		end

	c_XSync (a_arg1: POINTER; a_arg2: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XSync($a_arg1, $a_arg2);"
		end

	XUngrabServer (a_arg1: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_XUngrabServer (a_arg1.c_pointer)
		end

	c_XUngrabServer (a_arg1: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XUngrabServer($a_arg1);"
		end

	XKeysymToKeycode (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32): NATURAL_8
		do
			Result := c_XKeysymToKeycode (a_arg1.c_pointer, a_arg2)
		end

	c_XKeysymToKeycode (a_arg1: POINTER; a_arg2: NATURAL_32): NATURAL_8
		external
			"C inline use <vim.h>"
		alias
			"return XKeysymToKeycode($a_arg1, $a_arg2);"
		end

	XStoreBuffer (a_arg1: CE_POINTER [ANY]; a_arg2: CE_POINTER [INTEGER_8]; a_arg3, a_arg4: INTEGER_32): INTEGER_32
		do
			Result := c_XStoreBuffer (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4)
		end

	c_XStoreBuffer (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XStoreBuffer($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	XOpenDisplay (a_arg1: CE_POINTER [INTEGER_8]): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_XOpenDisplay (a_arg1.c_pointer))
		end

	c_XOpenDisplay (a_arg1: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)XOpenDisplay($a_arg1);"
		end

	XSetIOErrorHandler (a_arg1: CE_ROUTINE): CE_ROUTINE
		do
			create Result.make_shared (c_XSetIOErrorHandler (a_arg1.c_pointer))
		end

	c_XSetIOErrorHandler (a_arg1: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)XSetIOErrorHandler($a_arg1);"
		end

	XFreeStringList (a_arg1: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			c_XFreeStringList (a_arg1.c_pointer)
		end

	c_XFreeStringList (a_arg1: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"XFreeStringList($a_arg1);"
		end

	XCloseDisplay (a_arg1: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_XCloseDisplay (a_arg1.c_pointer)
		end

	c_XCloseDisplay (a_arg1: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XCloseDisplay($a_arg1);"
		end

	XGetErrorText (a_arg1: CE_POINTER [ANY]; a_arg2: INTEGER_32; a_arg3: CE_POINTER [INTEGER_8]; a_arg4: INTEGER_32): INTEGER_32
		do
			Result := c_XGetErrorText (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4)
		end

	c_XGetErrorText (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: POINTER; a_arg4: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XGetErrorText($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	XQueryPointer (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32; a_arg3, a_arg4: CE_POINTER [NATURAL_32]; a_arg5, a_arg6, a_arg7, a_arg8: CE_POINTER [INTEGER_32]; a_arg9: CE_POINTER [NATURAL_32]): INTEGER_32
		do
			Result := c_XQueryPointer (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4.c_pointer, a_arg5.c_pointer, a_arg6.c_pointer, a_arg7.c_pointer, a_arg8.c_pointer, a_arg9.c_pointer)
		end

	c_XQueryPointer (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: POINTER; a_arg4: POINTER; a_arg5: POINTER; a_arg6: POINTER; a_arg7: POINTER; a_arg8: POINTER; a_arg9: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XQueryPointer($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5, $a_arg6, $a_arg7, $a_arg8, $a_arg9);"
		end

	XQueryTree (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32; a_arg3, a_arg4: CE_POINTER [NATURAL_32]; a_arg5: CE_POINTER [CE_POINTER [NATURAL_32]]; a_arg6: CE_POINTER [NATURAL_32]): INTEGER_32
		do
			Result := c_XQueryTree (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4.c_pointer, a_arg5.c_pointer, a_arg6.c_pointer)
		end

	c_XQueryTree (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: POINTER; a_arg4: POINTER; a_arg5: POINTER; a_arg6: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XQueryTree($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5, $a_arg6);"
		end

	XFetchBuffer (a_arg1: CE_POINTER [ANY]; a_arg2: CE_POINTER [INTEGER_32]; a_arg3: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_XFetchBuffer (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3))
		end

	c_XFetchBuffer (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)XFetchBuffer($a_arg1, $a_arg2, $a_arg3);"
		end

	XCheckTypedEvent (a_arg1: CE_POINTER [ANY]; a_arg2: INTEGER_32; a_arg3: CE_POINTER [SD_XEVENT]): INTEGER_32
		do
			Result := c_XCheckTypedEvent (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer)
		end

	c_XCheckTypedEvent (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XCheckTypedEvent($a_arg1, $a_arg2, $a_arg3);"
		end

	XGetWMProtocols (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32; a_arg3: CE_POINTER [CE_POINTER [NATURAL_32]]; a_arg4: CE_POINTER [INTEGER_32]): INTEGER_32
		do
			Result := c_XGetWMProtocols (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4.c_pointer)
		end

	c_XGetWMProtocols (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: POINTER; a_arg4: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XGetWMProtocols($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	XSetWMProtocols (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32; a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32): INTEGER_32
		do
			Result := c_XSetWMProtocols (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4)
		end

	c_XSetWMProtocols (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: POINTER; a_arg4: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XSetWMProtocols($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	XParseGeometry (a_arg1: CE_POINTER [INTEGER_8]; a_arg2, a_arg3: CE_POINTER [INTEGER_32]; a_arg4, a_arg5: CE_POINTER [NATURAL_32]): INTEGER_32
		do
			Result := c_XParseGeometry (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3.c_pointer, a_arg4.c_pointer, a_arg5.c_pointer)
		end

	c_XParseGeometry (a_arg1: POINTER; a_arg2: POINTER; a_arg3: POINTER; a_arg4: POINTER; a_arg5: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XParseGeometry($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5);"
		end

	XSetCommand (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32; a_arg3: CE_POINTER [CE_POINTER [INTEGER_8]]; a_arg4: INTEGER_32): INTEGER_32
		do
			Result := c_XSetCommand (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4)
		end

	c_XSetCommand (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: POINTER; a_arg4: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XSetCommand($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	XWarpPointer (a_arg1: CE_POINTER [ANY]; a_arg2, a_arg3: NATURAL_32; a_arg4, a_arg5: INTEGER_32; a_arg6, a_arg7: NATURAL_32; a_arg8, a_arg9: INTEGER_32): INTEGER_32
		do
			Result := c_XWarpPointer (a_arg1.c_pointer, a_arg2, a_arg3, a_arg4, a_arg5, a_arg6, a_arg7, a_arg8, a_arg9)
		end

	c_XWarpPointer (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: NATURAL_32; a_arg4: INTEGER_32; a_arg5: INTEGER_32; a_arg6: NATURAL_32; a_arg7: NATURAL_32; a_arg8: INTEGER_32; a_arg9: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XWarpPointer($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5, $a_arg6, $a_arg7, $a_arg8, $a_arg9);"
		end

end
