class
	SD_GTKIMAGEIMAGEDATA

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [SD_GDKIMAGE]} image.make
		end

feature {ANY} -- fields

	image: CE_POINTER [SD_GDKIMAGE] assign set_image

feature {ANY} -- field setters

	set_image (a_image: CE_POINTER [SD_GDKIMAGE])
		do
			image := a_image
			update_memory_field ("image")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			image := a_other.image
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				image.is_equal (a_other.image)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("image")
				>>)
			init_structure_info
		end

end
