class
	SD_GTKSTYLE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create parent_instance.make
			create {CE_CLASS_ARRAY [SD_GDKCOLOR]} fg.make (<<5>>)
			create {CE_CLASS_ARRAY [SD_GDKCOLOR]} bg.make (<<5>>)
			create {CE_CLASS_ARRAY [SD_GDKCOLOR]} light.make (<<5>>)
			create {CE_CLASS_ARRAY [SD_GDKCOLOR]} dark.make (<<5>>)
			create {CE_CLASS_ARRAY [SD_GDKCOLOR]} mid.make (<<5>>)
			create {CE_CLASS_ARRAY [SD_GDKCOLOR]} text.make (<<5>>)
			create {CE_CLASS_ARRAY [SD_GDKCOLOR]} base.make (<<5>>)
			create {CE_CLASS_ARRAY [SD_GDKCOLOR]} text_aa.make (<<5>>)
			create black.make
			create white.make
			create {CE_VOID_POINTER} font_desc.make
			create {CE_POINTER_ARRAY [SD_GDKGC]} fg_gc.make (<<5>>)
			create {CE_POINTER_ARRAY [SD_GDKGC]} bg_gc.make (<<5>>)
			create {CE_POINTER_ARRAY [SD_GDKGC]} light_gc.make (<<5>>)
			create {CE_POINTER_ARRAY [SD_GDKGC]} dark_gc.make (<<5>>)
			create {CE_POINTER_ARRAY [SD_GDKGC]} mid_gc.make (<<5>>)
			create {CE_POINTER_ARRAY [SD_GDKGC]} text_gc.make (<<5>>)
			create {CE_POINTER_ARRAY [SD_GDKGC]} base_gc.make (<<5>>)
			create {CE_POINTER_ARRAY [SD_GDKGC]} text_aa_gc.make (<<5>>)
			create {CE_CLASS_POINTER [SD_GDKGC]} black_gc.make
			create {CE_CLASS_POINTER [SD_GDKGC]} white_gc.make
			create {CE_POINTER_ARRAY [SD_GDKDRAWABLE]} bg_pixmap.make (<<5>>)
			create {CE_CLASS_POINTER [SD_GDKCOLORMAP]} colormap.make
			create {CE_CLASS_POINTER [SD_GDKFONT]} private_font.make
			create {CE_VOID_POINTER} private_font_desc.make
			create {CE_CLASS_POINTER [SD_GTKRCSTYLE]} rc_style.make
			create {CE_CLASS_POINTER [SD_GSLIST]} styles.make
			create {CE_CLASS_POINTER [SD_GARRAY]} property_cache.make
			create {CE_CLASS_POINTER [SD_GSLIST]} icon_factories.make
		end

feature {ANY} -- fields

	parent_instance: SD_GOBJECT assign set_parent_instance

	fg: CE_ARRAY [SD_GDKCOLOR]

	bg: CE_ARRAY [SD_GDKCOLOR]

	light: CE_ARRAY [SD_GDKCOLOR]

	dark: CE_ARRAY [SD_GDKCOLOR]

	mid: CE_ARRAY [SD_GDKCOLOR]

	text: CE_ARRAY [SD_GDKCOLOR]

	base: CE_ARRAY [SD_GDKCOLOR]

	text_aa: CE_ARRAY [SD_GDKCOLOR]

	black: SD_GDKCOLOR assign set_black

	white: SD_GDKCOLOR assign set_white

	font_desc: CE_POINTER [ANY] assign set_font_desc

	xthickness: INTEGER_32 assign set_xthickness

	ythickness: INTEGER_32 assign set_ythickness

	fg_gc: CE_ARRAY [CE_POINTER [SD_GDKGC]]

	bg_gc: CE_ARRAY [CE_POINTER [SD_GDKGC]]

	light_gc: CE_ARRAY [CE_POINTER [SD_GDKGC]]

	dark_gc: CE_ARRAY [CE_POINTER [SD_GDKGC]]

	mid_gc: CE_ARRAY [CE_POINTER [SD_GDKGC]]

	text_gc: CE_ARRAY [CE_POINTER [SD_GDKGC]]

	base_gc: CE_ARRAY [CE_POINTER [SD_GDKGC]]

	text_aa_gc: CE_ARRAY [CE_POINTER [SD_GDKGC]]

	black_gc: CE_POINTER [SD_GDKGC] assign set_black_gc

	white_gc: CE_POINTER [SD_GDKGC] assign set_white_gc

	bg_pixmap: CE_ARRAY [CE_POINTER [SD_GDKDRAWABLE]]

	attach_count: INTEGER_32 assign set_attach_count

	depth: INTEGER_32 assign set_depth

	colormap: CE_POINTER [SD_GDKCOLORMAP] assign set_colormap

	private_font: CE_POINTER [SD_GDKFONT] assign set_private_font

	private_font_desc: CE_POINTER [ANY] assign set_private_font_desc

	rc_style: CE_POINTER [SD_GTKRCSTYLE] assign set_rc_style

	styles: CE_POINTER [SD_GSLIST] assign set_styles

	property_cache: CE_POINTER [SD_GARRAY] assign set_property_cache

	icon_factories: CE_POINTER [SD_GSLIST] assign set_icon_factories

feature {ANY} -- field setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance := a_parent_instance
			update_memory_field ("parent_instance")
		end

	set_black (a_black: SD_GDKCOLOR)
		do
			black := a_black
			update_memory_field ("black")
		end

	set_white (a_white: SD_GDKCOLOR)
		do
			white := a_white
			update_memory_field ("white")
		end

	set_font_desc (a_font_desc: CE_POINTER [ANY])
		do
			font_desc := a_font_desc
			update_memory_field ("font_desc")
		end

	set_xthickness (a_xthickness: INTEGER_32)
		do
			xthickness := a_xthickness
			update_memory_field ("xthickness")
		end

	set_ythickness (a_ythickness: INTEGER_32)
		do
			ythickness := a_ythickness
			update_memory_field ("ythickness")
		end

	set_black_gc (a_black_gc: CE_POINTER [SD_GDKGC])
		do
			black_gc := a_black_gc
			update_memory_field ("black_gc")
		end

	set_white_gc (a_white_gc: CE_POINTER [SD_GDKGC])
		do
			white_gc := a_white_gc
			update_memory_field ("white_gc")
		end

	set_attach_count (a_attach_count: INTEGER_32)
		do
			attach_count := a_attach_count
			update_memory_field ("attach_count")
		end

	set_depth (a_depth: INTEGER_32)
		do
			depth := a_depth
			update_memory_field ("depth")
		end

	set_colormap (a_colormap: CE_POINTER [SD_GDKCOLORMAP])
		do
			colormap := a_colormap
			update_memory_field ("colormap")
		end

	set_private_font (a_private_font: CE_POINTER [SD_GDKFONT])
		do
			private_font := a_private_font
			update_memory_field ("private_font")
		end

	set_private_font_desc (a_private_font_desc: CE_POINTER [ANY])
		do
			private_font_desc := a_private_font_desc
			update_memory_field ("private_font_desc")
		end

	set_rc_style (a_rc_style: CE_POINTER [SD_GTKRCSTYLE])
		do
			rc_style := a_rc_style
			update_memory_field ("rc_style")
		end

	set_styles (a_styles: CE_POINTER [SD_GSLIST])
		do
			styles := a_styles
			update_memory_field ("styles")
		end

	set_property_cache (a_property_cache: CE_POINTER [SD_GARRAY])
		do
			property_cache := a_property_cache
			update_memory_field ("property_cache")
		end

	set_icon_factories (a_icon_factories: CE_POINTER [SD_GSLIST])
		do
			icon_factories := a_icon_factories
			update_memory_field ("icon_factories")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent_instance := a_other.parent_instance.twin
			fg := a_other.fg.twin
			bg := a_other.bg.twin
			light := a_other.light.twin
			dark := a_other.dark.twin
			mid := a_other.mid.twin
			text := a_other.text.twin
			base := a_other.base.twin
			text_aa := a_other.text_aa.twin
			black := a_other.black.twin
			white := a_other.white.twin
			font_desc := a_other.font_desc
			xthickness := a_other.xthickness
			ythickness := a_other.ythickness
			fg_gc := a_other.fg_gc.twin
			bg_gc := a_other.bg_gc.twin
			light_gc := a_other.light_gc.twin
			dark_gc := a_other.dark_gc.twin
			mid_gc := a_other.mid_gc.twin
			text_gc := a_other.text_gc.twin
			base_gc := a_other.base_gc.twin
			text_aa_gc := a_other.text_aa_gc.twin
			black_gc := a_other.black_gc
			white_gc := a_other.white_gc
			bg_pixmap := a_other.bg_pixmap.twin
			attach_count := a_other.attach_count
			depth := a_other.depth
			colormap := a_other.colormap
			private_font := a_other.private_font
			private_font_desc := a_other.private_font_desc
			rc_style := a_other.rc_style
			styles := a_other.styles
			property_cache := a_other.property_cache
			icon_factories := a_other.icon_factories
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent_instance.is_equal (a_other.parent_instance) and
				fg.is_equal (a_other.fg) and
				bg.is_equal (a_other.bg) and
				light.is_equal (a_other.light) and
				dark.is_equal (a_other.dark) and
				mid.is_equal (a_other.mid) and
				text.is_equal (a_other.text) and
				base.is_equal (a_other.base) and
				text_aa.is_equal (a_other.text_aa) and
				black.is_equal (a_other.black) and
				white.is_equal (a_other.white) and
				font_desc.is_equal (a_other.font_desc) and
				xthickness = a_other.xthickness and
				ythickness = a_other.ythickness and
				fg_gc.is_equal (a_other.fg_gc) and
				bg_gc.is_equal (a_other.bg_gc) and
				light_gc.is_equal (a_other.light_gc) and
				dark_gc.is_equal (a_other.dark_gc) and
				mid_gc.is_equal (a_other.mid_gc) and
				text_gc.is_equal (a_other.text_gc) and
				base_gc.is_equal (a_other.base_gc) and
				text_aa_gc.is_equal (a_other.text_aa_gc) and
				black_gc.is_equal (a_other.black_gc) and
				white_gc.is_equal (a_other.white_gc) and
				bg_pixmap.is_equal (a_other.bg_pixmap) and
				attach_count = a_other.attach_count and
				depth = a_other.depth and
				colormap.is_equal (a_other.colormap) and
				private_font.is_equal (a_other.private_font) and
				private_font_desc.is_equal (a_other.private_font_desc) and
				rc_style.is_equal (a_other.rc_style) and
				styles.is_equal (a_other.styles) and
				property_cache.is_equal (a_other.property_cache) and
				icon_factories.is_equal (a_other.icon_factories)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent_instance"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("fg", <<5>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("bg", <<5>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("light", <<5>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("dark", <<5>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("mid", <<5>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("text", <<5>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("base", <<5>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("text_aa", <<5>>),
					create {CE_STRUCTURE_FIELD}.make ("black"),
					create {CE_STRUCTURE_FIELD}.make ("white"),
					create {CE_STRUCTURE_FIELD}.make ("font_desc"),
					create {CE_STRUCTURE_FIELD}.make ("xthickness"),
					create {CE_STRUCTURE_FIELD}.make ("ythickness"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("fg_gc", <<5>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("bg_gc", <<5>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("light_gc", <<5>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("dark_gc", <<5>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("mid_gc", <<5>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("text_gc", <<5>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("base_gc", <<5>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("text_aa_gc", <<5>>),
					create {CE_STRUCTURE_FIELD}.make ("black_gc"),
					create {CE_STRUCTURE_FIELD}.make ("white_gc"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("bg_pixmap", <<5>>),
					create {CE_STRUCTURE_FIELD}.make ("attach_count"),
					create {CE_STRUCTURE_FIELD}.make ("depth"),
					create {CE_STRUCTURE_FIELD}.make ("colormap"),
					create {CE_STRUCTURE_FIELD}.make ("private_font"),
					create {CE_STRUCTURE_FIELD}.make ("private_font_desc"),
					create {CE_STRUCTURE_FIELD}.make ("rc_style"),
					create {CE_STRUCTURE_FIELD}.make ("styles"),
					create {CE_STRUCTURE_FIELD}.make ("property_cache"),
					create {CE_STRUCTURE_FIELD}.make ("icon_factories")
				>>)
			init_structure_info
		end

end
