class
	SD_GTKWIDGETCLASS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create parent_class.make
			create dispatch_child_properties_changed.make
			create show.make
			create show_all.make
			create hide.make
			create hide_all.make
			create map.make
			create unmap.make
			create realize.make
			create unrealize.make
			create size_request.make
			create size_allocate.make
			create state_changed.make
			create parent_set.make
			create hierarchy_changed.make
			create style_set.make
			create direction_changed.make
			create grab_notify.make
			create child_notify.make
			create mnemonic_activate.make
			create grab_focus.make
			create focus.make
			create event.make
			create button_press_event.make
			create button_release_event.make
			create scroll_event.make
			create motion_notify_event.make
			create delete_event.make
			create destroy_event.make
			create expose_event.make
			create key_press_event.make
			create key_release_event.make
			create enter_notify_event.make
			create leave_notify_event.make
			create configure_event.make
			create focus_in_event.make
			create focus_out_event.make
			create map_event.make
			create unmap_event.make
			create property_notify_event.make
			create selection_clear_event.make
			create selection_request_event.make
			create selection_notify_event.make
			create proximity_in_event.make
			create proximity_out_event.make
			create visibility_notify_event.make
			create client_event.make
			create no_expose_event.make
			create window_state_event.make
			create selection_get.make
			create selection_received.make
			create drag_begin.make
			create drag_end.make
			create drag_data_get.make
			create drag_data_delete.make
			create drag_leave.make
			create drag_motion.make
			create drag_drop.make
			create drag_data_received.make
			create popup_menu.make
			create show_help.make
			create get_accessible.make
			create screen_changed.make
			create can_activate_accel.make
			create grab_broken_event.make
			create composited_changed.make
			create query_tooltip.make
			create gtk_reserved5.make
			create gtk_reserved6.make
			create gtk_reserved7.make
		end

feature {ANY} -- fields

	parent_class: SD_GTKOBJECTCLASS assign set_parent_class

	activate_signal: NATURAL_32 assign set_activate_signal

	set_scroll_adjustments_signal: NATURAL_32 assign set_set_scroll_adjustments_signal

	dispatch_child_properties_changed: CE_ROUTINE assign set_dispatch_child_properties_changed

	show: CE_ROUTINE assign set_show

	show_all: CE_ROUTINE assign set_show_all

	hide: CE_ROUTINE assign set_hide

	hide_all: CE_ROUTINE assign set_hide_all

	map: CE_ROUTINE assign set_map

	unmap: CE_ROUTINE assign set_unmap

	realize: CE_ROUTINE assign set_realize

	unrealize: CE_ROUTINE assign set_unrealize

	size_request: CE_ROUTINE assign set_size_request

	size_allocate: CE_ROUTINE assign set_size_allocate

	state_changed: CE_ROUTINE assign set_state_changed

	parent_set: CE_ROUTINE assign set_parent_set

	hierarchy_changed: CE_ROUTINE assign set_hierarchy_changed

	style_set: CE_ROUTINE assign set_style_set

	direction_changed: CE_ROUTINE assign set_direction_changed

	grab_notify: CE_ROUTINE assign set_grab_notify

	child_notify: CE_ROUTINE assign set_child_notify

	mnemonic_activate: CE_ROUTINE assign set_mnemonic_activate

	grab_focus: CE_ROUTINE assign set_grab_focus

	focus: CE_ROUTINE assign set_focus

	event: CE_ROUTINE assign set_event

	button_press_event: CE_ROUTINE assign set_button_press_event

	button_release_event: CE_ROUTINE assign set_button_release_event

	scroll_event: CE_ROUTINE assign set_scroll_event

	motion_notify_event: CE_ROUTINE assign set_motion_notify_event

	delete_event: CE_ROUTINE assign set_delete_event

	destroy_event: CE_ROUTINE assign set_destroy_event

	expose_event: CE_ROUTINE assign set_expose_event

	key_press_event: CE_ROUTINE assign set_key_press_event

	key_release_event: CE_ROUTINE assign set_key_release_event

	enter_notify_event: CE_ROUTINE assign set_enter_notify_event

	leave_notify_event: CE_ROUTINE assign set_leave_notify_event

	configure_event: CE_ROUTINE assign set_configure_event

	focus_in_event: CE_ROUTINE assign set_focus_in_event

	focus_out_event: CE_ROUTINE assign set_focus_out_event

	map_event: CE_ROUTINE assign set_map_event

	unmap_event: CE_ROUTINE assign set_unmap_event

	property_notify_event: CE_ROUTINE assign set_property_notify_event

	selection_clear_event: CE_ROUTINE assign set_selection_clear_event

	selection_request_event: CE_ROUTINE assign set_selection_request_event

	selection_notify_event: CE_ROUTINE assign set_selection_notify_event

	proximity_in_event: CE_ROUTINE assign set_proximity_in_event

	proximity_out_event: CE_ROUTINE assign set_proximity_out_event

	visibility_notify_event: CE_ROUTINE assign set_visibility_notify_event

	client_event: CE_ROUTINE assign set_client_event

	no_expose_event: CE_ROUTINE assign set_no_expose_event

	window_state_event: CE_ROUTINE assign set_window_state_event

	selection_get: CE_ROUTINE assign set_selection_get

	selection_received: CE_ROUTINE assign set_selection_received

	drag_begin: CE_ROUTINE assign set_drag_begin

	drag_end: CE_ROUTINE assign set_drag_end

	drag_data_get: CE_ROUTINE assign set_drag_data_get

	drag_data_delete: CE_ROUTINE assign set_drag_data_delete

	drag_leave: CE_ROUTINE assign set_drag_leave

	drag_motion: CE_ROUTINE assign set_drag_motion

	drag_drop: CE_ROUTINE assign set_drag_drop

	drag_data_received: CE_ROUTINE assign set_drag_data_received

	popup_menu: CE_ROUTINE assign set_popup_menu

	show_help: CE_ROUTINE assign set_show_help

	get_accessible: CE_ROUTINE assign set_get_accessible

	screen_changed: CE_ROUTINE assign set_screen_changed

	can_activate_accel: CE_ROUTINE assign set_can_activate_accel

	grab_broken_event: CE_ROUTINE assign set_grab_broken_event

	composited_changed: CE_ROUTINE assign set_composited_changed

	query_tooltip: CE_ROUTINE assign set_query_tooltip

	gtk_reserved5: CE_ROUTINE assign set_gtk_reserved5

	gtk_reserved6: CE_ROUTINE assign set_gtk_reserved6

	gtk_reserved7: CE_ROUTINE assign set_gtk_reserved7

feature {ANY} -- field setters

	set_parent_class (a_parent_class: SD_GTKOBJECTCLASS)
		do
			parent_class := a_parent_class
			update_memory_field ("parent_class")
		end

	set_activate_signal (a_activate_signal: NATURAL_32)
		do
			activate_signal := a_activate_signal
			update_memory_field ("activate_signal")
		end

	set_set_scroll_adjustments_signal (a_set_scroll_adjustments_signal: NATURAL_32)
		do
			set_scroll_adjustments_signal := a_set_scroll_adjustments_signal
			update_memory_field ("set_scroll_adjustments_signal")
		end

	set_dispatch_child_properties_changed (a_dispatch_child_properties_changed: CE_ROUTINE)
		do
			dispatch_child_properties_changed := a_dispatch_child_properties_changed
			update_memory_field ("dispatch_child_properties_changed")
		end

	set_show (a_show: CE_ROUTINE)
		do
			show := a_show
			update_memory_field ("show")
		end

	set_show_all (a_show_all: CE_ROUTINE)
		do
			show_all := a_show_all
			update_memory_field ("show_all")
		end

	set_hide (a_hide: CE_ROUTINE)
		do
			hide := a_hide
			update_memory_field ("hide")
		end

	set_hide_all (a_hide_all: CE_ROUTINE)
		do
			hide_all := a_hide_all
			update_memory_field ("hide_all")
		end

	set_map (a_map: CE_ROUTINE)
		do
			map := a_map
			update_memory_field ("map")
		end

	set_unmap (a_unmap: CE_ROUTINE)
		do
			unmap := a_unmap
			update_memory_field ("unmap")
		end

	set_realize (a_realize: CE_ROUTINE)
		do
			realize := a_realize
			update_memory_field ("realize")
		end

	set_unrealize (a_unrealize: CE_ROUTINE)
		do
			unrealize := a_unrealize
			update_memory_field ("unrealize")
		end

	set_size_request (a_size_request: CE_ROUTINE)
		do
			size_request := a_size_request
			update_memory_field ("size_request")
		end

	set_size_allocate (a_size_allocate: CE_ROUTINE)
		do
			size_allocate := a_size_allocate
			update_memory_field ("size_allocate")
		end

	set_state_changed (a_state_changed: CE_ROUTINE)
		do
			state_changed := a_state_changed
			update_memory_field ("state_changed")
		end

	set_parent_set (a_parent_set: CE_ROUTINE)
		do
			parent_set := a_parent_set
			update_memory_field ("parent_set")
		end

	set_hierarchy_changed (a_hierarchy_changed: CE_ROUTINE)
		do
			hierarchy_changed := a_hierarchy_changed
			update_memory_field ("hierarchy_changed")
		end

	set_style_set (a_style_set: CE_ROUTINE)
		do
			style_set := a_style_set
			update_memory_field ("style_set")
		end

	set_direction_changed (a_direction_changed: CE_ROUTINE)
		do
			direction_changed := a_direction_changed
			update_memory_field ("direction_changed")
		end

	set_grab_notify (a_grab_notify: CE_ROUTINE)
		do
			grab_notify := a_grab_notify
			update_memory_field ("grab_notify")
		end

	set_child_notify (a_child_notify: CE_ROUTINE)
		do
			child_notify := a_child_notify
			update_memory_field ("child_notify")
		end

	set_mnemonic_activate (a_mnemonic_activate: CE_ROUTINE)
		do
			mnemonic_activate := a_mnemonic_activate
			update_memory_field ("mnemonic_activate")
		end

	set_grab_focus (a_grab_focus: CE_ROUTINE)
		do
			grab_focus := a_grab_focus
			update_memory_field ("grab_focus")
		end

	set_focus (a_focus: CE_ROUTINE)
		do
			focus := a_focus
			update_memory_field ("focus")
		end

	set_event (a_event: CE_ROUTINE)
		do
			event := a_event
			update_memory_field ("event")
		end

	set_button_press_event (a_button_press_event: CE_ROUTINE)
		do
			button_press_event := a_button_press_event
			update_memory_field ("button_press_event")
		end

	set_button_release_event (a_button_release_event: CE_ROUTINE)
		do
			button_release_event := a_button_release_event
			update_memory_field ("button_release_event")
		end

	set_scroll_event (a_scroll_event: CE_ROUTINE)
		do
			scroll_event := a_scroll_event
			update_memory_field ("scroll_event")
		end

	set_motion_notify_event (a_motion_notify_event: CE_ROUTINE)
		do
			motion_notify_event := a_motion_notify_event
			update_memory_field ("motion_notify_event")
		end

	set_delete_event (a_delete_event: CE_ROUTINE)
		do
			delete_event := a_delete_event
			update_memory_field ("delete_event")
		end

	set_destroy_event (a_destroy_event: CE_ROUTINE)
		do
			destroy_event := a_destroy_event
			update_memory_field ("destroy_event")
		end

	set_expose_event (a_expose_event: CE_ROUTINE)
		do
			expose_event := a_expose_event
			update_memory_field ("expose_event")
		end

	set_key_press_event (a_key_press_event: CE_ROUTINE)
		do
			key_press_event := a_key_press_event
			update_memory_field ("key_press_event")
		end

	set_key_release_event (a_key_release_event: CE_ROUTINE)
		do
			key_release_event := a_key_release_event
			update_memory_field ("key_release_event")
		end

	set_enter_notify_event (a_enter_notify_event: CE_ROUTINE)
		do
			enter_notify_event := a_enter_notify_event
			update_memory_field ("enter_notify_event")
		end

	set_leave_notify_event (a_leave_notify_event: CE_ROUTINE)
		do
			leave_notify_event := a_leave_notify_event
			update_memory_field ("leave_notify_event")
		end

	set_configure_event (a_configure_event: CE_ROUTINE)
		do
			configure_event := a_configure_event
			update_memory_field ("configure_event")
		end

	set_focus_in_event (a_focus_in_event: CE_ROUTINE)
		do
			focus_in_event := a_focus_in_event
			update_memory_field ("focus_in_event")
		end

	set_focus_out_event (a_focus_out_event: CE_ROUTINE)
		do
			focus_out_event := a_focus_out_event
			update_memory_field ("focus_out_event")
		end

	set_map_event (a_map_event: CE_ROUTINE)
		do
			map_event := a_map_event
			update_memory_field ("map_event")
		end

	set_unmap_event (a_unmap_event: CE_ROUTINE)
		do
			unmap_event := a_unmap_event
			update_memory_field ("unmap_event")
		end

	set_property_notify_event (a_property_notify_event: CE_ROUTINE)
		do
			property_notify_event := a_property_notify_event
			update_memory_field ("property_notify_event")
		end

	set_selection_clear_event (a_selection_clear_event: CE_ROUTINE)
		do
			selection_clear_event := a_selection_clear_event
			update_memory_field ("selection_clear_event")
		end

	set_selection_request_event (a_selection_request_event: CE_ROUTINE)
		do
			selection_request_event := a_selection_request_event
			update_memory_field ("selection_request_event")
		end

	set_selection_notify_event (a_selection_notify_event: CE_ROUTINE)
		do
			selection_notify_event := a_selection_notify_event
			update_memory_field ("selection_notify_event")
		end

	set_proximity_in_event (a_proximity_in_event: CE_ROUTINE)
		do
			proximity_in_event := a_proximity_in_event
			update_memory_field ("proximity_in_event")
		end

	set_proximity_out_event (a_proximity_out_event: CE_ROUTINE)
		do
			proximity_out_event := a_proximity_out_event
			update_memory_field ("proximity_out_event")
		end

	set_visibility_notify_event (a_visibility_notify_event: CE_ROUTINE)
		do
			visibility_notify_event := a_visibility_notify_event
			update_memory_field ("visibility_notify_event")
		end

	set_client_event (a_client_event: CE_ROUTINE)
		do
			client_event := a_client_event
			update_memory_field ("client_event")
		end

	set_no_expose_event (a_no_expose_event: CE_ROUTINE)
		do
			no_expose_event := a_no_expose_event
			update_memory_field ("no_expose_event")
		end

	set_window_state_event (a_window_state_event: CE_ROUTINE)
		do
			window_state_event := a_window_state_event
			update_memory_field ("window_state_event")
		end

	set_selection_get (a_selection_get: CE_ROUTINE)
		do
			selection_get := a_selection_get
			update_memory_field ("selection_get")
		end

	set_selection_received (a_selection_received: CE_ROUTINE)
		do
			selection_received := a_selection_received
			update_memory_field ("selection_received")
		end

	set_drag_begin (a_drag_begin: CE_ROUTINE)
		do
			drag_begin := a_drag_begin
			update_memory_field ("drag_begin")
		end

	set_drag_end (a_drag_end: CE_ROUTINE)
		do
			drag_end := a_drag_end
			update_memory_field ("drag_end")
		end

	set_drag_data_get (a_drag_data_get: CE_ROUTINE)
		do
			drag_data_get := a_drag_data_get
			update_memory_field ("drag_data_get")
		end

	set_drag_data_delete (a_drag_data_delete: CE_ROUTINE)
		do
			drag_data_delete := a_drag_data_delete
			update_memory_field ("drag_data_delete")
		end

	set_drag_leave (a_drag_leave: CE_ROUTINE)
		do
			drag_leave := a_drag_leave
			update_memory_field ("drag_leave")
		end

	set_drag_motion (a_drag_motion: CE_ROUTINE)
		do
			drag_motion := a_drag_motion
			update_memory_field ("drag_motion")
		end

	set_drag_drop (a_drag_drop: CE_ROUTINE)
		do
			drag_drop := a_drag_drop
			update_memory_field ("drag_drop")
		end

	set_drag_data_received (a_drag_data_received: CE_ROUTINE)
		do
			drag_data_received := a_drag_data_received
			update_memory_field ("drag_data_received")
		end

	set_popup_menu (a_popup_menu: CE_ROUTINE)
		do
			popup_menu := a_popup_menu
			update_memory_field ("popup_menu")
		end

	set_show_help (a_show_help: CE_ROUTINE)
		do
			show_help := a_show_help
			update_memory_field ("show_help")
		end

	set_get_accessible (a_get_accessible: CE_ROUTINE)
		do
			get_accessible := a_get_accessible
			update_memory_field ("get_accessible")
		end

	set_screen_changed (a_screen_changed: CE_ROUTINE)
		do
			screen_changed := a_screen_changed
			update_memory_field ("screen_changed")
		end

	set_can_activate_accel (a_can_activate_accel: CE_ROUTINE)
		do
			can_activate_accel := a_can_activate_accel
			update_memory_field ("can_activate_accel")
		end

	set_grab_broken_event (a_grab_broken_event: CE_ROUTINE)
		do
			grab_broken_event := a_grab_broken_event
			update_memory_field ("grab_broken_event")
		end

	set_composited_changed (a_composited_changed: CE_ROUTINE)
		do
			composited_changed := a_composited_changed
			update_memory_field ("composited_changed")
		end

	set_query_tooltip (a_query_tooltip: CE_ROUTINE)
		do
			query_tooltip := a_query_tooltip
			update_memory_field ("query_tooltip")
		end

	set_gtk_reserved5 (a_gtk_reserved5: CE_ROUTINE)
		do
			gtk_reserved5 := a_gtk_reserved5
			update_memory_field ("gtk_reserved5")
		end

	set_gtk_reserved6 (a_gtk_reserved6: CE_ROUTINE)
		do
			gtk_reserved6 := a_gtk_reserved6
			update_memory_field ("gtk_reserved6")
		end

	set_gtk_reserved7 (a_gtk_reserved7: CE_ROUTINE)
		do
			gtk_reserved7 := a_gtk_reserved7
			update_memory_field ("gtk_reserved7")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent_class := a_other.parent_class.twin
			activate_signal := a_other.activate_signal
			set_scroll_adjustments_signal := a_other.set_scroll_adjustments_signal
			dispatch_child_properties_changed := a_other.dispatch_child_properties_changed
			show := a_other.show
			show_all := a_other.show_all
			hide := a_other.hide
			hide_all := a_other.hide_all
			map := a_other.map
			unmap := a_other.unmap
			realize := a_other.realize
			unrealize := a_other.unrealize
			size_request := a_other.size_request
			size_allocate := a_other.size_allocate
			state_changed := a_other.state_changed
			parent_set := a_other.parent_set
			hierarchy_changed := a_other.hierarchy_changed
			style_set := a_other.style_set
			direction_changed := a_other.direction_changed
			grab_notify := a_other.grab_notify
			child_notify := a_other.child_notify
			mnemonic_activate := a_other.mnemonic_activate
			grab_focus := a_other.grab_focus
			focus := a_other.focus
			event := a_other.event
			button_press_event := a_other.button_press_event
			button_release_event := a_other.button_release_event
			scroll_event := a_other.scroll_event
			motion_notify_event := a_other.motion_notify_event
			delete_event := a_other.delete_event
			destroy_event := a_other.destroy_event
			expose_event := a_other.expose_event
			key_press_event := a_other.key_press_event
			key_release_event := a_other.key_release_event
			enter_notify_event := a_other.enter_notify_event
			leave_notify_event := a_other.leave_notify_event
			configure_event := a_other.configure_event
			focus_in_event := a_other.focus_in_event
			focus_out_event := a_other.focus_out_event
			map_event := a_other.map_event
			unmap_event := a_other.unmap_event
			property_notify_event := a_other.property_notify_event
			selection_clear_event := a_other.selection_clear_event
			selection_request_event := a_other.selection_request_event
			selection_notify_event := a_other.selection_notify_event
			proximity_in_event := a_other.proximity_in_event
			proximity_out_event := a_other.proximity_out_event
			visibility_notify_event := a_other.visibility_notify_event
			client_event := a_other.client_event
			no_expose_event := a_other.no_expose_event
			window_state_event := a_other.window_state_event
			selection_get := a_other.selection_get
			selection_received := a_other.selection_received
			drag_begin := a_other.drag_begin
			drag_end := a_other.drag_end
			drag_data_get := a_other.drag_data_get
			drag_data_delete := a_other.drag_data_delete
			drag_leave := a_other.drag_leave
			drag_motion := a_other.drag_motion
			drag_drop := a_other.drag_drop
			drag_data_received := a_other.drag_data_received
			popup_menu := a_other.popup_menu
			show_help := a_other.show_help
			get_accessible := a_other.get_accessible
			screen_changed := a_other.screen_changed
			can_activate_accel := a_other.can_activate_accel
			grab_broken_event := a_other.grab_broken_event
			composited_changed := a_other.composited_changed
			query_tooltip := a_other.query_tooltip
			gtk_reserved5 := a_other.gtk_reserved5
			gtk_reserved6 := a_other.gtk_reserved6
			gtk_reserved7 := a_other.gtk_reserved7
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent_class.is_equal (a_other.parent_class) and
				activate_signal = a_other.activate_signal and
				set_scroll_adjustments_signal = a_other.set_scroll_adjustments_signal and
				dispatch_child_properties_changed.is_equal (a_other.dispatch_child_properties_changed) and
				show.is_equal (a_other.show) and
				show_all.is_equal (a_other.show_all) and
				hide.is_equal (a_other.hide) and
				hide_all.is_equal (a_other.hide_all) and
				map.is_equal (a_other.map) and
				unmap.is_equal (a_other.unmap) and
				realize.is_equal (a_other.realize) and
				unrealize.is_equal (a_other.unrealize) and
				size_request.is_equal (a_other.size_request) and
				size_allocate.is_equal (a_other.size_allocate) and
				state_changed.is_equal (a_other.state_changed) and
				parent_set.is_equal (a_other.parent_set) and
				hierarchy_changed.is_equal (a_other.hierarchy_changed) and
				style_set.is_equal (a_other.style_set) and
				direction_changed.is_equal (a_other.direction_changed) and
				grab_notify.is_equal (a_other.grab_notify) and
				child_notify.is_equal (a_other.child_notify) and
				mnemonic_activate.is_equal (a_other.mnemonic_activate) and
				grab_focus.is_equal (a_other.grab_focus) and
				focus.is_equal (a_other.focus) and
				event.is_equal (a_other.event) and
				button_press_event.is_equal (a_other.button_press_event) and
				button_release_event.is_equal (a_other.button_release_event) and
				scroll_event.is_equal (a_other.scroll_event) and
				motion_notify_event.is_equal (a_other.motion_notify_event) and
				delete_event.is_equal (a_other.delete_event) and
				destroy_event.is_equal (a_other.destroy_event) and
				expose_event.is_equal (a_other.expose_event) and
				key_press_event.is_equal (a_other.key_press_event) and
				key_release_event.is_equal (a_other.key_release_event) and
				enter_notify_event.is_equal (a_other.enter_notify_event) and
				leave_notify_event.is_equal (a_other.leave_notify_event) and
				configure_event.is_equal (a_other.configure_event) and
				focus_in_event.is_equal (a_other.focus_in_event) and
				focus_out_event.is_equal (a_other.focus_out_event) and
				map_event.is_equal (a_other.map_event) and
				unmap_event.is_equal (a_other.unmap_event) and
				property_notify_event.is_equal (a_other.property_notify_event) and
				selection_clear_event.is_equal (a_other.selection_clear_event) and
				selection_request_event.is_equal (a_other.selection_request_event) and
				selection_notify_event.is_equal (a_other.selection_notify_event) and
				proximity_in_event.is_equal (a_other.proximity_in_event) and
				proximity_out_event.is_equal (a_other.proximity_out_event) and
				visibility_notify_event.is_equal (a_other.visibility_notify_event) and
				client_event.is_equal (a_other.client_event) and
				no_expose_event.is_equal (a_other.no_expose_event) and
				window_state_event.is_equal (a_other.window_state_event) and
				selection_get.is_equal (a_other.selection_get) and
				selection_received.is_equal (a_other.selection_received) and
				drag_begin.is_equal (a_other.drag_begin) and
				drag_end.is_equal (a_other.drag_end) and
				drag_data_get.is_equal (a_other.drag_data_get) and
				drag_data_delete.is_equal (a_other.drag_data_delete) and
				drag_leave.is_equal (a_other.drag_leave) and
				drag_motion.is_equal (a_other.drag_motion) and
				drag_drop.is_equal (a_other.drag_drop) and
				drag_data_received.is_equal (a_other.drag_data_received) and
				popup_menu.is_equal (a_other.popup_menu) and
				show_help.is_equal (a_other.show_help) and
				get_accessible.is_equal (a_other.get_accessible) and
				screen_changed.is_equal (a_other.screen_changed) and
				can_activate_accel.is_equal (a_other.can_activate_accel) and
				grab_broken_event.is_equal (a_other.grab_broken_event) and
				composited_changed.is_equal (a_other.composited_changed) and
				query_tooltip.is_equal (a_other.query_tooltip) and
				gtk_reserved5.is_equal (a_other.gtk_reserved5) and
				gtk_reserved6.is_equal (a_other.gtk_reserved6) and
				gtk_reserved7.is_equal (a_other.gtk_reserved7)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent_class"),
					create {CE_STRUCTURE_FIELD}.make ("activate_signal"),
					create {CE_STRUCTURE_FIELD}.make ("set_scroll_adjustments_signal"),
					create {CE_STRUCTURE_FIELD}.make ("dispatch_child_properties_changed"),
					create {CE_STRUCTURE_FIELD}.make ("show"),
					create {CE_STRUCTURE_FIELD}.make ("show_all"),
					create {CE_STRUCTURE_FIELD}.make ("hide"),
					create {CE_STRUCTURE_FIELD}.make ("hide_all"),
					create {CE_STRUCTURE_FIELD}.make ("map"),
					create {CE_STRUCTURE_FIELD}.make ("unmap"),
					create {CE_STRUCTURE_FIELD}.make ("realize"),
					create {CE_STRUCTURE_FIELD}.make ("unrealize"),
					create {CE_STRUCTURE_FIELD}.make ("size_request"),
					create {CE_STRUCTURE_FIELD}.make ("size_allocate"),
					create {CE_STRUCTURE_FIELD}.make ("state_changed"),
					create {CE_STRUCTURE_FIELD}.make ("parent_set"),
					create {CE_STRUCTURE_FIELD}.make ("hierarchy_changed"),
					create {CE_STRUCTURE_FIELD}.make ("style_set"),
					create {CE_STRUCTURE_FIELD}.make ("direction_changed"),
					create {CE_STRUCTURE_FIELD}.make ("grab_notify"),
					create {CE_STRUCTURE_FIELD}.make ("child_notify"),
					create {CE_STRUCTURE_FIELD}.make ("mnemonic_activate"),
					create {CE_STRUCTURE_FIELD}.make ("grab_focus"),
					create {CE_STRUCTURE_FIELD}.make ("focus"),
					create {CE_STRUCTURE_FIELD}.make ("event"),
					create {CE_STRUCTURE_FIELD}.make ("button_press_event"),
					create {CE_STRUCTURE_FIELD}.make ("button_release_event"),
					create {CE_STRUCTURE_FIELD}.make ("scroll_event"),
					create {CE_STRUCTURE_FIELD}.make ("motion_notify_event"),
					create {CE_STRUCTURE_FIELD}.make ("delete_event"),
					create {CE_STRUCTURE_FIELD}.make ("destroy_event"),
					create {CE_STRUCTURE_FIELD}.make ("expose_event"),
					create {CE_STRUCTURE_FIELD}.make ("key_press_event"),
					create {CE_STRUCTURE_FIELD}.make ("key_release_event"),
					create {CE_STRUCTURE_FIELD}.make ("enter_notify_event"),
					create {CE_STRUCTURE_FIELD}.make ("leave_notify_event"),
					create {CE_STRUCTURE_FIELD}.make ("configure_event"),
					create {CE_STRUCTURE_FIELD}.make ("focus_in_event"),
					create {CE_STRUCTURE_FIELD}.make ("focus_out_event"),
					create {CE_STRUCTURE_FIELD}.make ("map_event"),
					create {CE_STRUCTURE_FIELD}.make ("unmap_event"),
					create {CE_STRUCTURE_FIELD}.make ("property_notify_event"),
					create {CE_STRUCTURE_FIELD}.make ("selection_clear_event"),
					create {CE_STRUCTURE_FIELD}.make ("selection_request_event"),
					create {CE_STRUCTURE_FIELD}.make ("selection_notify_event"),
					create {CE_STRUCTURE_FIELD}.make ("proximity_in_event"),
					create {CE_STRUCTURE_FIELD}.make ("proximity_out_event"),
					create {CE_STRUCTURE_FIELD}.make ("visibility_notify_event"),
					create {CE_STRUCTURE_FIELD}.make ("client_event"),
					create {CE_STRUCTURE_FIELD}.make ("no_expose_event"),
					create {CE_STRUCTURE_FIELD}.make ("window_state_event"),
					create {CE_STRUCTURE_FIELD}.make ("selection_get"),
					create {CE_STRUCTURE_FIELD}.make ("selection_received"),
					create {CE_STRUCTURE_FIELD}.make ("drag_begin"),
					create {CE_STRUCTURE_FIELD}.make ("drag_end"),
					create {CE_STRUCTURE_FIELD}.make ("drag_data_get"),
					create {CE_STRUCTURE_FIELD}.make ("drag_data_delete"),
					create {CE_STRUCTURE_FIELD}.make ("drag_leave"),
					create {CE_STRUCTURE_FIELD}.make ("drag_motion"),
					create {CE_STRUCTURE_FIELD}.make ("drag_drop"),
					create {CE_STRUCTURE_FIELD}.make ("drag_data_received"),
					create {CE_STRUCTURE_FIELD}.make ("popup_menu"),
					create {CE_STRUCTURE_FIELD}.make ("show_help"),
					create {CE_STRUCTURE_FIELD}.make ("get_accessible"),
					create {CE_STRUCTURE_FIELD}.make ("screen_changed"),
					create {CE_STRUCTURE_FIELD}.make ("can_activate_accel"),
					create {CE_STRUCTURE_FIELD}.make ("grab_broken_event"),
					create {CE_STRUCTURE_FIELD}.make ("composited_changed"),
					create {CE_STRUCTURE_FIELD}.make ("query_tooltip"),
					create {CE_STRUCTURE_FIELD}.make ("gtk_reserved5"),
					create {CE_STRUCTURE_FIELD}.make ("gtk_reserved6"),
					create {CE_STRUCTURE_FIELD}.make ("gtk_reserved7")
				>>)
			init_structure_info
		end

end
