class
	SD_IN_ADDR

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	s_addr: NATURAL_32 assign set_s_addr

feature {ANY} -- field setters

	set_s_addr (a_s_addr: NATURAL_32)
		do
			s_addr := a_s_addr
			update_memory_field ("s_addr")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			s_addr := a_other.s_addr
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				s_addr = a_other.s_addr
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("s_addr")
				>>)
			init_structure_info
		end

end
