class
	SD_XPRIVDISPLAY

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [SD_XEXTDATA]} ext_data.make
			create {CE_VOID_POINTER} private1.make
			create {CE_INTEGER_8_POINTER} vendor.make
			create resource_alloc.make
			create {CE_CLASS_POINTER [SD_SCREENFORMAT]} pixmap_format.make
			create {CE_VOID_POINTER} private9.make
			create {CE_VOID_POINTER} private10.make
			create {CE_INTEGER_8_POINTER} private11.make
			create {CE_INTEGER_8_POINTER} private12.make
			create {CE_INTEGER_8_POINTER} private13.make
			create {CE_INTEGER_8_POINTER} private14.make
			create {CE_VOID_POINTER} db.make
			create private15.make
			create {CE_INTEGER_8_POINTER} display_name.make
			create {CE_CLASS_POINTER [SD_SCREEN]} screens.make
			create {CE_INTEGER_8_POINTER} private17.make
			create {CE_INTEGER_8_POINTER} private18.make
			create {CE_INTEGER_8_POINTER} xdefaults.make
		end

feature {ANY} -- fields

	ext_data: CE_POINTER [SD_XEXTDATA] assign set_ext_data

	private1: CE_POINTER [ANY] assign set_private1

	fd: INTEGER_32 assign set_fd

	private2: INTEGER_32 assign set_private2

	proto_major_version: INTEGER_32 assign set_proto_major_version

	proto_minor_version: INTEGER_32 assign set_proto_minor_version

	vendor: CE_POINTER [INTEGER_8] assign set_vendor

	private3: NATURAL_32 assign set_private3

	private4: NATURAL_32 assign set_private4

	private5: NATURAL_32 assign set_private5

	private6: INTEGER_32 assign set_private6

	resource_alloc: CE_ROUTINE assign set_resource_alloc

	byte_order: INTEGER_32 assign set_byte_order

	bitmap_unit: INTEGER_32 assign set_bitmap_unit

	bitmap_pad: INTEGER_32 assign set_bitmap_pad

	bitmap_bit_order: INTEGER_32 assign set_bitmap_bit_order

	nformats: INTEGER_32 assign set_nformats

	pixmap_format: CE_POINTER [SD_SCREENFORMAT] assign set_pixmap_format

	private8: INTEGER_32 assign set_private8

	release: INTEGER_32 assign set_release

	private9: CE_POINTER [ANY] assign set_private9

	private10: CE_POINTER [ANY] assign set_private10

	qlen: INTEGER_32 assign set_qlen

	last_request_read: NATURAL_32 assign set_last_request_read

	request: NATURAL_32 assign set_request

	private11: CE_POINTER [INTEGER_8] assign set_private11

	private12: CE_POINTER [INTEGER_8] assign set_private12

	private13: CE_POINTER [INTEGER_8] assign set_private13

	private14: CE_POINTER [INTEGER_8] assign set_private14

	max_request_size: NATURAL_32 assign set_max_request_size

	db: CE_POINTER [ANY] assign set_db

	private15: CE_ROUTINE assign set_private15

	display_name: CE_POINTER [INTEGER_8] assign set_display_name

	default_screen: INTEGER_32 assign set_default_screen

	nscreens: INTEGER_32 assign set_nscreens

	screens: CE_POINTER [SD_SCREEN] assign set_screens

	motion_buffer: NATURAL_32 assign set_motion_buffer

	private16: NATURAL_32 assign set_private16

	min_keycode: INTEGER_32 assign set_min_keycode

	max_keycode: INTEGER_32 assign set_max_keycode

	private17: CE_POINTER [INTEGER_8] assign set_private17

	private18: CE_POINTER [INTEGER_8] assign set_private18

	private19: INTEGER_32 assign set_private19

	xdefaults: CE_POINTER [INTEGER_8] assign set_xdefaults

feature {ANY} -- field setters

	set_ext_data (a_ext_data: CE_POINTER [SD_XEXTDATA])
		do
			ext_data := a_ext_data
			update_memory_field ("ext_data")
		end

	set_private1 (a_private1: CE_POINTER [ANY])
		do
			private1 := a_private1
			update_memory_field ("private1")
		end

	set_fd (a_fd: INTEGER_32)
		do
			fd := a_fd
			update_memory_field ("fd")
		end

	set_private2 (a_private2: INTEGER_32)
		do
			private2 := a_private2
			update_memory_field ("private2")
		end

	set_proto_major_version (a_proto_major_version: INTEGER_32)
		do
			proto_major_version := a_proto_major_version
			update_memory_field ("proto_major_version")
		end

	set_proto_minor_version (a_proto_minor_version: INTEGER_32)
		do
			proto_minor_version := a_proto_minor_version
			update_memory_field ("proto_minor_version")
		end

	set_vendor (a_vendor: CE_POINTER [INTEGER_8])
		do
			vendor := a_vendor
			update_memory_field ("vendor")
		end

	set_private3 (a_private3: NATURAL_32)
		do
			private3 := a_private3
			update_memory_field ("private3")
		end

	set_private4 (a_private4: NATURAL_32)
		do
			private4 := a_private4
			update_memory_field ("private4")
		end

	set_private5 (a_private5: NATURAL_32)
		do
			private5 := a_private5
			update_memory_field ("private5")
		end

	set_private6 (a_private6: INTEGER_32)
		do
			private6 := a_private6
			update_memory_field ("private6")
		end

	set_resource_alloc (a_resource_alloc: CE_ROUTINE)
		do
			resource_alloc := a_resource_alloc
			update_memory_field ("resource_alloc")
		end

	set_byte_order (a_byte_order: INTEGER_32)
		do
			byte_order := a_byte_order
			update_memory_field ("byte_order")
		end

	set_bitmap_unit (a_bitmap_unit: INTEGER_32)
		do
			bitmap_unit := a_bitmap_unit
			update_memory_field ("bitmap_unit")
		end

	set_bitmap_pad (a_bitmap_pad: INTEGER_32)
		do
			bitmap_pad := a_bitmap_pad
			update_memory_field ("bitmap_pad")
		end

	set_bitmap_bit_order (a_bitmap_bit_order: INTEGER_32)
		do
			bitmap_bit_order := a_bitmap_bit_order
			update_memory_field ("bitmap_bit_order")
		end

	set_nformats (a_nformats: INTEGER_32)
		do
			nformats := a_nformats
			update_memory_field ("nformats")
		end

	set_pixmap_format (a_pixmap_format: CE_POINTER [SD_SCREENFORMAT])
		do
			pixmap_format := a_pixmap_format
			update_memory_field ("pixmap_format")
		end

	set_private8 (a_private8: INTEGER_32)
		do
			private8 := a_private8
			update_memory_field ("private8")
		end

	set_release (a_release: INTEGER_32)
		do
			release := a_release
			update_memory_field ("release")
		end

	set_private9 (a_private9: CE_POINTER [ANY])
		do
			private9 := a_private9
			update_memory_field ("private9")
		end

	set_private10 (a_private10: CE_POINTER [ANY])
		do
			private10 := a_private10
			update_memory_field ("private10")
		end

	set_qlen (a_qlen: INTEGER_32)
		do
			qlen := a_qlen
			update_memory_field ("qlen")
		end

	set_last_request_read (a_last_request_read: NATURAL_32)
		do
			last_request_read := a_last_request_read
			update_memory_field ("last_request_read")
		end

	set_request (a_request: NATURAL_32)
		do
			request := a_request
			update_memory_field ("request")
		end

	set_private11 (a_private11: CE_POINTER [INTEGER_8])
		do
			private11 := a_private11
			update_memory_field ("private11")
		end

	set_private12 (a_private12: CE_POINTER [INTEGER_8])
		do
			private12 := a_private12
			update_memory_field ("private12")
		end

	set_private13 (a_private13: CE_POINTER [INTEGER_8])
		do
			private13 := a_private13
			update_memory_field ("private13")
		end

	set_private14 (a_private14: CE_POINTER [INTEGER_8])
		do
			private14 := a_private14
			update_memory_field ("private14")
		end

	set_max_request_size (a_max_request_size: NATURAL_32)
		do
			max_request_size := a_max_request_size
			update_memory_field ("max_request_size")
		end

	set_db (a_db: CE_POINTER [ANY])
		do
			db := a_db
			update_memory_field ("db")
		end

	set_private15 (a_private15: CE_ROUTINE)
		do
			private15 := a_private15
			update_memory_field ("private15")
		end

	set_display_name (a_display_name: CE_POINTER [INTEGER_8])
		do
			display_name := a_display_name
			update_memory_field ("display_name")
		end

	set_default_screen (a_default_screen: INTEGER_32)
		do
			default_screen := a_default_screen
			update_memory_field ("default_screen")
		end

	set_nscreens (a_nscreens: INTEGER_32)
		do
			nscreens := a_nscreens
			update_memory_field ("nscreens")
		end

	set_screens (a_screens: CE_POINTER [SD_SCREEN])
		do
			screens := a_screens
			update_memory_field ("screens")
		end

	set_motion_buffer (a_motion_buffer: NATURAL_32)
		do
			motion_buffer := a_motion_buffer
			update_memory_field ("motion_buffer")
		end

	set_private16 (a_private16: NATURAL_32)
		do
			private16 := a_private16
			update_memory_field ("private16")
		end

	set_min_keycode (a_min_keycode: INTEGER_32)
		do
			min_keycode := a_min_keycode
			update_memory_field ("min_keycode")
		end

	set_max_keycode (a_max_keycode: INTEGER_32)
		do
			max_keycode := a_max_keycode
			update_memory_field ("max_keycode")
		end

	set_private17 (a_private17: CE_POINTER [INTEGER_8])
		do
			private17 := a_private17
			update_memory_field ("private17")
		end

	set_private18 (a_private18: CE_POINTER [INTEGER_8])
		do
			private18 := a_private18
			update_memory_field ("private18")
		end

	set_private19 (a_private19: INTEGER_32)
		do
			private19 := a_private19
			update_memory_field ("private19")
		end

	set_xdefaults (a_xdefaults: CE_POINTER [INTEGER_8])
		do
			xdefaults := a_xdefaults
			update_memory_field ("xdefaults")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ext_data := a_other.ext_data
			private1 := a_other.private1
			fd := a_other.fd
			private2 := a_other.private2
			proto_major_version := a_other.proto_major_version
			proto_minor_version := a_other.proto_minor_version
			vendor := a_other.vendor
			private3 := a_other.private3
			private4 := a_other.private4
			private5 := a_other.private5
			private6 := a_other.private6
			resource_alloc := a_other.resource_alloc
			byte_order := a_other.byte_order
			bitmap_unit := a_other.bitmap_unit
			bitmap_pad := a_other.bitmap_pad
			bitmap_bit_order := a_other.bitmap_bit_order
			nformats := a_other.nformats
			pixmap_format := a_other.pixmap_format
			private8 := a_other.private8
			release := a_other.release
			private9 := a_other.private9
			private10 := a_other.private10
			qlen := a_other.qlen
			last_request_read := a_other.last_request_read
			request := a_other.request
			private11 := a_other.private11
			private12 := a_other.private12
			private13 := a_other.private13
			private14 := a_other.private14
			max_request_size := a_other.max_request_size
			db := a_other.db
			private15 := a_other.private15
			display_name := a_other.display_name
			default_screen := a_other.default_screen
			nscreens := a_other.nscreens
			screens := a_other.screens
			motion_buffer := a_other.motion_buffer
			private16 := a_other.private16
			min_keycode := a_other.min_keycode
			max_keycode := a_other.max_keycode
			private17 := a_other.private17
			private18 := a_other.private18
			private19 := a_other.private19
			xdefaults := a_other.xdefaults
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ext_data.is_equal (a_other.ext_data) and
				private1.is_equal (a_other.private1) and
				fd = a_other.fd and
				private2 = a_other.private2 and
				proto_major_version = a_other.proto_major_version and
				proto_minor_version = a_other.proto_minor_version and
				vendor.is_equal (a_other.vendor) and
				private3 = a_other.private3 and
				private4 = a_other.private4 and
				private5 = a_other.private5 and
				private6 = a_other.private6 and
				resource_alloc.is_equal (a_other.resource_alloc) and
				byte_order = a_other.byte_order and
				bitmap_unit = a_other.bitmap_unit and
				bitmap_pad = a_other.bitmap_pad and
				bitmap_bit_order = a_other.bitmap_bit_order and
				nformats = a_other.nformats and
				pixmap_format.is_equal (a_other.pixmap_format) and
				private8 = a_other.private8 and
				release = a_other.release and
				private9.is_equal (a_other.private9) and
				private10.is_equal (a_other.private10) and
				qlen = a_other.qlen and
				last_request_read = a_other.last_request_read and
				request = a_other.request and
				private11.is_equal (a_other.private11) and
				private12.is_equal (a_other.private12) and
				private13.is_equal (a_other.private13) and
				private14.is_equal (a_other.private14) and
				max_request_size = a_other.max_request_size and
				db.is_equal (a_other.db) and
				private15.is_equal (a_other.private15) and
				display_name.is_equal (a_other.display_name) and
				default_screen = a_other.default_screen and
				nscreens = a_other.nscreens and
				screens.is_equal (a_other.screens) and
				motion_buffer = a_other.motion_buffer and
				private16 = a_other.private16 and
				min_keycode = a_other.min_keycode and
				max_keycode = a_other.max_keycode and
				private17.is_equal (a_other.private17) and
				private18.is_equal (a_other.private18) and
				private19 = a_other.private19 and
				xdefaults.is_equal (a_other.xdefaults)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ext_data"),
					create {CE_STRUCTURE_FIELD}.make ("private1"),
					create {CE_STRUCTURE_FIELD}.make ("fd"),
					create {CE_STRUCTURE_FIELD}.make ("private2"),
					create {CE_STRUCTURE_FIELD}.make ("proto_major_version"),
					create {CE_STRUCTURE_FIELD}.make ("proto_minor_version"),
					create {CE_STRUCTURE_FIELD}.make ("vendor"),
					create {CE_STRUCTURE_FIELD}.make ("private3"),
					create {CE_STRUCTURE_FIELD}.make ("private4"),
					create {CE_STRUCTURE_FIELD}.make ("private5"),
					create {CE_STRUCTURE_FIELD}.make ("private6"),
					create {CE_STRUCTURE_FIELD}.make ("resource_alloc"),
					create {CE_STRUCTURE_FIELD}.make ("byte_order"),
					create {CE_STRUCTURE_FIELD}.make ("bitmap_unit"),
					create {CE_STRUCTURE_FIELD}.make ("bitmap_pad"),
					create {CE_STRUCTURE_FIELD}.make ("bitmap_bit_order"),
					create {CE_STRUCTURE_FIELD}.make ("nformats"),
					create {CE_STRUCTURE_FIELD}.make ("pixmap_format"),
					create {CE_STRUCTURE_FIELD}.make ("private8"),
					create {CE_STRUCTURE_FIELD}.make ("release"),
					create {CE_STRUCTURE_FIELD}.make ("private9"),
					create {CE_STRUCTURE_FIELD}.make ("private10"),
					create {CE_STRUCTURE_FIELD}.make ("qlen"),
					create {CE_STRUCTURE_FIELD}.make ("last_request_read"),
					create {CE_STRUCTURE_FIELD}.make ("request"),
					create {CE_STRUCTURE_FIELD}.make ("private11"),
					create {CE_STRUCTURE_FIELD}.make ("private12"),
					create {CE_STRUCTURE_FIELD}.make ("private13"),
					create {CE_STRUCTURE_FIELD}.make ("private14"),
					create {CE_STRUCTURE_FIELD}.make ("max_request_size"),
					create {CE_STRUCTURE_FIELD}.make ("db"),
					create {CE_STRUCTURE_FIELD}.make ("private15"),
					create {CE_STRUCTURE_FIELD}.make ("display_name"),
					create {CE_STRUCTURE_FIELD}.make ("default_screen"),
					create {CE_STRUCTURE_FIELD}.make ("nscreens"),
					create {CE_STRUCTURE_FIELD}.make ("screens"),
					create {CE_STRUCTURE_FIELD}.make ("motion_buffer"),
					create {CE_STRUCTURE_FIELD}.make ("private16"),
					create {CE_STRUCTURE_FIELD}.make ("min_keycode"),
					create {CE_STRUCTURE_FIELD}.make ("max_keycode"),
					create {CE_STRUCTURE_FIELD}.make ("private17"),
					create {CE_STRUCTURE_FIELD}.make ("private18"),
					create {CE_STRUCTURE_FIELD}.make ("private19"),
					create {CE_STRUCTURE_FIELD}.make ("xdefaults")
				>>)
			init_structure_info
		end

end
