class
	P_HOSTSYN_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	Curl_wait_for_resolv (a_conn: CE_POINTER [PD_CONNECTDATA]; a_entry: CE_POINTER [CE_POINTER [PD_CURL_DNS_ENTRY]]): NATURAL_32
		require
			not a_entry.is_void
		do
			a_entry.item := create {CE_CLASS_POINTER [PD_CURL_DNS_ENTRY]}.make_shared (default_pointer)
			Result := ({PC_CURLCODE}.CURLE_COULDNT_RESOLVE_HOST)
		end

	Curl_is_resolved (a_conn: CE_POINTER [PD_CONNECTDATA]; a_dns: CE_POINTER [CE_POINTER [PD_CURL_DNS_ENTRY]]): NATURAL_32
		require
			not a_dns.is_void
		do
			a_dns.item := create {CE_CLASS_POINTER [PD_CURL_DNS_ENTRY]}.make_shared (default_pointer)
			Result := ({PC_CURLCODE}.CURLE_COULDNT_RESOLVE_HOST)
		end

end
