class
	P_SENDF_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC

feature {ANY} -- public routines

	Curl_infof (a_args: TUPLE [a_data: CE_POINTER [PD_SESSIONHANDLE]; a_fmt: CE_POINTER [INTEGER_8]])
		local
			l_ap: CE_VA_LIST
			l_len: NATURAL_32
			l_print_buffer: CE_ARRAY [INTEGER_8]
		do
			create l_ap.make_shared (default_pointer)
			create {CE_INTEGER_8_ARRAY} l_print_buffer.make (<<2_049>>)

			if (not a_args.a_data.is_void) then
				if a_args.a_data.item.set.verbose then
					l_ap := create {CE_VA_LIST}.make (a_args, agent Curl_infof);
					(create {P_MPRINTF_STATIC}).curl_mvsnprintf (l_print_buffer, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (2_049).to_natural_32), a_args.a_fmt, l_ap.twin).do_nothing
					l_len := strlen (l_print_buffer)
					a_args.a_data.item.Curl_debug ({PC_CURL_INFOTYPE}.CURLINFO_TEXT, l_print_buffer, l_len, create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)).do_nothing
				end
			end
		end

end
