class
	P_SPLAY_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	KEY_NOTUSED: CE_STATIC [SD_TIMEVAL]
		once ("PROCESS")
			Result.item := create {SD_TIMEVAL}.make_initialized ([(-1).to_integer_32, (-1).to_integer_32])
		end

feature {ANY} -- public routines

	Curl_splay (a_i: SD_TIMEVAL; a_t: CE_POINTER [PD_CURL_TREE]): CE_POINTER [PD_CURL_TREE]
		local
			l_t: CE_POINTER [PD_CURL_TREE]
			l_N: CE_ARRAY [PD_CURL_TREE]
			l_l: CE_POINTER [PD_CURL_TREE]
			l_r: CE_POINTER [PD_CURL_TREE]
			l_y: CE_POINTER [PD_CURL_TREE]
			l_comp: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_CURL_TREE]} l_N.make (<<1>>)

			l_t := a_t
			if l_t.is_void then
				Result := l_t
				l_return := True
			end
			if not l_return then
				l_N.item.larger := create {CE_CLASS_POINTER [PD_CURL_TREE]}.make_shared (default_pointer)
				l_N.item.smaller := l_N.item.larger
				l_r := l_N
				l_l := l_r
				from
				until
					(l_break)
				loop
					l_break := False
					if a_i.tv_sec < l_t.item.key.tv_sec then
						l_comp := -1
					else
						if a_i.tv_sec > l_t.item.key.tv_sec then
							l_tmp___1 := 1
						else
							if a_i.tv_usec < l_t.item.key.tv_usec then
								l_tmp___0 := -1
							else
								if a_i.tv_usec > l_t.item.key.tv_usec then
									l_tmp := 1
								else
									l_tmp := 0
								end
								l_tmp___0 := l_tmp
							end
							l_tmp___1 := l_tmp___0
						end
						l_comp := l_tmp___1.to_integer_32
					end
					if l_comp < 0 then
						if (l_t.item.smaller).is_void then
							l_break := True
						end
						if not (l_break) then
							if a_i.tv_sec < (l_t.item.smaller).item.key.tv_sec then
								l_tmp___5 := -1
							else
								if a_i.tv_sec > (l_t.item.smaller).item.key.tv_sec then
									l_tmp___4 := 1
								else
									if a_i.tv_usec < (l_t.item.smaller).item.key.tv_usec then
										l_tmp___3 := -1
									else
										if a_i.tv_usec > (l_t.item.smaller).item.key.tv_usec then
											l_tmp___2 := 1
										else
											l_tmp___2 := 0
										end
										l_tmp___3 := l_tmp___2
									end
									l_tmp___4 := l_tmp___3
								end
								l_tmp___5 := l_tmp___4
							end
							if l_tmp___5 < 0 then
								l_y := l_t.item.smaller
								l_t.item.smaller := l_y.item.larger
								l_y.item.larger := l_t
								l_t := l_y
								if (l_t.item.smaller).is_void then
									l_break := True
								end
							end
						end
						if not (l_break) then
							l_r.item.smaller := l_t
							l_r := l_t
							l_t := l_t.item.smaller
						end
					elseif l_comp > 0 then
						if (l_t.item.larger).is_void then
							l_break := True
						end
						if not (l_break) then
							if a_i.tv_sec < (l_t.item.larger).item.key.tv_sec then
								l_tmp___9 := -1
							else
								if a_i.tv_sec > (l_t.item.larger).item.key.tv_sec then
									l_tmp___8 := 1
								else
									if a_i.tv_usec < (l_t.item.larger).item.key.tv_usec then
										l_tmp___7 := -1
									else
										if a_i.tv_usec > (l_t.item.larger).item.key.tv_usec then
											l_tmp___6 := 1
										else
											l_tmp___6 := 0
										end
										l_tmp___7 := l_tmp___6
									end
									l_tmp___8 := l_tmp___7
								end
								l_tmp___9 := l_tmp___8
							end
							if l_tmp___9 > 0 then
								l_y := l_t.item.larger
								l_t.item.larger := l_y.item.smaller
								l_y.item.smaller := l_t
								l_t := l_y
								if (l_t.item.larger).is_void then
									l_break := True
								end
							end
						end
						if not (l_break) then
							l_l.item.larger := l_t
							l_l := l_t
							l_t := l_t.item.larger
						end
					else
						l_break := True
					end
				end
				l_break := False
				l_l.item.larger := l_t.item.smaller
				l_r.item.smaller := l_t.item.larger
				l_t.item.smaller := l_N.item.larger
				l_t.item.larger := l_N.item.smaller
				Result := l_t
			end
		end

	Curl_splayinsert (a_i: SD_TIMEVAL; a_t, a_node: CE_POINTER [PD_CURL_TREE]): CE_POINTER [PD_CURL_TREE]
		local
			l_t: CE_POINTER [PD_CURL_TREE]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: CE_POINTER [PD_CURL_TREE]
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_return: BOOLEAN
		do
			l_t := a_t
			if a_node.is_void then
				Result := l_t
				l_return := True
			end
			if not l_return and then (not l_t.is_void) then
				l_t := Curl_splay (a_i.twin, l_t)
				if a_i.tv_sec < l_t.item.key.tv_sec then
					l_tmp___2 := -1
				else
					if a_i.tv_sec > l_t.item.key.tv_sec then
						l_tmp___1 := 1
					else
						if a_i.tv_usec < l_t.item.key.tv_usec then
							l_tmp___0 := -1
						else
							if a_i.tv_usec > l_t.item.key.tv_usec then
								l_tmp := 1
							else
								l_tmp := 0
							end
							l_tmp___0 := l_tmp
						end
						l_tmp___1 := l_tmp___0
					end
					l_tmp___2 := l_tmp___1
				end
				if l_tmp___2 = 0 then
					a_node.item.same := l_t
					a_node.item.key := a_i.twin
					a_node.item.smaller := l_t.item.smaller
					a_node.item.larger := l_t.item.larger
					l_t.item.smaller := a_node
					l_t.item.key := KEY_NOTUSED.item.twin
					Result := a_node
					l_return := True
				end
			end
			if not l_return then
				if l_t.is_void then
					l_tmp___3 := create {CE_CLASS_POINTER [PD_CURL_TREE]}.make_shared (default_pointer)
					a_node.item.larger := l_tmp___3
					a_node.item.smaller := l_tmp___3
				else
					if a_i.tv_sec < l_t.item.key.tv_sec then
						l_tmp___7 := -1
					else
						if a_i.tv_sec > l_t.item.key.tv_sec then
							l_tmp___6 := 1
						else
							if a_i.tv_usec < l_t.item.key.tv_usec then
								l_tmp___5 := -1
							else
								if a_i.tv_usec > l_t.item.key.tv_usec then
									l_tmp___4 := 1
								else
									l_tmp___4 := 0
								end
								l_tmp___5 := l_tmp___4
							end
							l_tmp___6 := l_tmp___5
						end
						l_tmp___7 := l_tmp___6
					end
					if l_tmp___7 < 0 then
						a_node.item.smaller := l_t.item.smaller
						a_node.item.larger := l_t
						l_t.item.smaller := create {CE_CLASS_POINTER [PD_CURL_TREE]}.make_shared (default_pointer)
					else
						a_node.item.larger := l_t.item.larger
						a_node.item.smaller := l_t
						l_t.item.larger := create {CE_CLASS_POINTER [PD_CURL_TREE]}.make_shared (default_pointer)
					end
				end
				a_node.item.key := a_i.twin
				a_node.item.same := create {CE_CLASS_POINTER [PD_CURL_TREE]}.make_shared (default_pointer)
				Result := a_node
			end
		end

end
