class
	P_STRERROR_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	curl_multi_strerror (a_error: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_error -- switch 1 head
					when -1 then l_pos := -1 + 1 -- -1
					when 0 then l_pos := -1 + 2
					when 1 then l_pos := -1 + 3
					when 2 then l_pos := -1 + 4
					when 3 then l_pos := -1 + 5
					when 4 then l_pos := -1 + 6
					when 5 then l_pos := -1 + 7
					when 6 then l_pos := -1 + 8
					when 7 then l_pos := -1 + 9
					else l_pos := -1 + 10
					end
				when 1 then -- switch 1, case -1
					Result := (ce_string ("Please call curl_multi_perform() soon"))
					l_return := True
				when 2 then -- switch 1, case 0
					if not l_return then
						Result := (ce_string ("No error"))
						l_return := True
					end
				when 3 then -- switch 1, case 1
					if not l_return then
						Result := (ce_string ("Invalid multi handle"))
						l_return := True
					end
				when 4 then -- switch 1, case 2
					if not l_return then
						Result := (ce_string ("Invalid easy handle"))
						l_return := True
					end
				when 5 then -- switch 1, case 3
					if not l_return then
						Result := (ce_string ("Out of memory"))
						l_return := True
					end
				when 6 then -- switch 1, case 4
					if not l_return then
						Result := (ce_string ("Internal error"))
						l_return := True
					end
				when 7 then -- switch 1, case 5
					if not l_return then
						Result := (ce_string ("Invalid socket argument"))
						l_return := True
					end
				when 8 then -- switch 1, case 6
					if not l_return then
						Result := (ce_string ("Unknown option"))
						l_return := True
					end
				when 9 then -- switch 1, case 7
					l_pos := -1 + 10 -- switch 1; break
				when 10 then -- switch 1, done:
					if not l_return then
						Result := (ce_string ("Unknown error"))
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	curl_share_strerror (a_error: NATURAL_32): CE_POINTER [INTEGER_8]
		local
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_error.to_integer_32 -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					when 3 then l_pos := -1 + 4
					when 4 then l_pos := -1 + 5
					when 5 then l_pos := -1 + 6
					else l_pos := -1 + 7
					end
				when 1 then -- switch 1, case 0
					Result := (ce_string ("No error"))
					l_return := True
				when 2 then -- switch 1, case 1
					if not l_return then
						Result := (ce_string ("Unknown share option"))
						l_return := True
					end
				when 3 then -- switch 1, case 2
					if not l_return then
						Result := (ce_string ("Share currently in use"))
						l_return := True
					end
				when 4 then -- switch 1, case 3
					if not l_return then
						Result := (ce_string ("Invalid share handle"))
						l_return := True
					end
				when 5 then -- switch 1, case 4
					if not l_return then
						Result := (ce_string ("Out of memory"))
						l_return := True
					end
				when 6 then -- switch 1, case 5
					l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
					if not l_return then
						Result := (ce_string ("CURLSHcode unknown"))
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
