class
	PD_CONNECTDATA_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- routine addresses

	file_connect_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
				do
					Result := a_conn.item.file_connect (a_done)
				end)
		end

	file_done_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_status: NATURAL_32; a_premature: BOOLEAN): NATURAL_32
				do
					Result := a_conn.item.file_done (a_status, a_premature)
				end)
		end

	file_do_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
				do
					Result := a_conn.item.file_do (a_done)
				end)
		end

	Curl_http_connect_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
				do
					Result := a_conn.item.Curl_http_connect (a_done)
				end)
		end

	http_getsock_do_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_socks: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
				do
					Result := a_conn.item.http_getsock_do (a_socks, a_numsocks)
				end)
		end

	Curl_http_done_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_status: NATURAL_32; a_premature: BOOLEAN): NATURAL_32
				do
					Result := a_conn.item.Curl_http_done (a_status, a_premature)
				end)
		end

	Curl_http_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
				do
					Result := a_conn.item.Curl_http (a_done)
				end)
		end

	Curl_send_plain_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_num: INTEGER_32; a_mem: CE_POINTER [ANY]; a_len: NATURAL_32; a_code: CE_POINTER [NATURAL_32]): INTEGER_32
				do
					Result := a_conn.item.Curl_send_plain (a_num, a_mem, a_len, a_code)
				end)
		end

	Curl_recv_plain_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_num: INTEGER_32; a_buf: CE_POINTER [INTEGER_8]; a_len: NATURAL_32; a_code: CE_POINTER [NATURAL_32]): INTEGER_32
				do
					Result := a_conn.item.Curl_recv_plain (a_num, a_buf, a_len, a_code)
				end)
		end

	ftp_statemach_act_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
				do
					Result := a_conn.item.ftp_statemach_act
				end)
		end

	ftp_connect_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
				do
					Result := a_conn.item.ftp_connect (a_done)
				end)
		end

	ftp_done_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_status: NATURAL_32; a_premature: BOOLEAN): NATURAL_32
				do
					Result := a_conn.item.ftp_done (a_status, a_premature)
				end)
		end

	ftp_nextconnect_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
				do
					Result := a_conn.item.ftp_nextconnect
				end)
		end

	ftp_do_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
				do
					Result := a_conn.item.ftp_do (a_done)
				end)
		end

	ftp_disconnect_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
				do
					Result := a_conn.item.ftp_disconnect
				end)
		end

	ftp_setup_connection_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
				do
					Result := a_conn.item.ftp_setup_connection
				end)
		end

	dict_do_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
				do
					Result := a_conn.item.dict_do (a_done)
				end)
		end

	telnet_done_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_status: NATURAL_32; a_premature: BOOLEAN): NATURAL_32
				do
					Result := a_conn.item.telnet_done (a_status, a_premature)
				end)
		end

	telnet_do_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
				do
					Result := a_conn.item.telnet_do (a_done)
				end)
		end

	tftp_disconnect_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
				do
					Result := a_conn.item.tftp_disconnect
				end)
		end

	tftp_connect_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
				do
					Result := a_conn.item.tftp_connect (a_done)
				end)
		end

	tftp_done_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_status: NATURAL_32; a_premature: BOOLEAN): NATURAL_32
				do
					Result := a_conn.item.tftp_done (a_status, a_premature)
				end)
		end

	tftp_getsock_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_socks: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
				do
					Result := a_conn.item.tftp_getsock (a_socks, a_numsocks)
				end)
		end

	tftp_multi_statemach_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
				do
					Result := a_conn.item.tftp_multi_statemach (a_done)
				end)
		end

	tftp_doing_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_dophase_done: CE_POINTER [BOOLEAN]): NATURAL_32
				do
					Result := a_conn.item.tftp_doing (a_dophase_done)
				end)
		end

	tftp_do_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
				do
					Result := a_conn.item.tftp_do (a_done)
				end)
		end

	tftp_setup_connection_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
				do
					Result := a_conn.item.tftp_setup_connection
				end)
		end

	imap_statemach_act_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
				do
					Result := a_conn.item.imap_statemach_act
				end)
		end

	imap_connect_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
				do
					Result := a_conn.item.imap_connect (a_done)
				end)
		end

	imap_done_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_status: NATURAL_32; a_premature: BOOLEAN): NATURAL_32
				do
					Result := a_conn.item.imap_done (a_status, a_premature)
				end)
		end

	imap_do_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
				do
					Result := a_conn.item.imap_do (a_done)
				end)
		end

	imap_setup_connection_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
				do
					Result := a_conn.item.imap_setup_connection
				end)
		end

	pop3_statemach_act_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
				do
					Result := a_conn.item.pop3_statemach_act
				end)
		end

	pop3_connect_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
				do
					Result := a_conn.item.pop3_connect (a_done)
				end)
		end

	pop3_done_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_status: NATURAL_32; a_premature: BOOLEAN): NATURAL_32
				do
					Result := a_conn.item.pop3_done (a_status, a_premature)
				end)
		end

	pop3_do_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
				do
					Result := a_conn.item.pop3_do (a_done)
				end)
		end

	pop3_setup_connection_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
				do
					Result := a_conn.item.pop3_setup_connection
				end)
		end

	smtp_statemach_act_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
				do
					Result := a_conn.item.smtp_statemach_act
				end)
		end

	smtp_connect_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
				do
					Result := a_conn.item.smtp_connect (a_done)
				end)
		end

	smtp_done_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_status: NATURAL_32; a_premature: BOOLEAN): NATURAL_32
				do
					Result := a_conn.item.smtp_done (a_status, a_premature)
				end)
		end

	smtp_do_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
				do
					Result := a_conn.item.smtp_do (a_done)
				end)
		end

	smtp_setup_connection_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
				do
					Result := a_conn.item.smtp_setup_connection
				end)
		end

	rtsp_getsock_do_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_socks: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
				do
					Result := a_conn.item.rtsp_getsock_do (a_socks, a_numsocks)
				end)
		end

	Curl_rtsp_connect_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
				do
					Result := a_conn.item.Curl_rtsp_connect (a_done)
				end)
		end

	Curl_rtsp_disconnect_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
				do
					Result := a_conn.item.Curl_rtsp_disconnect
				end)
		end

	Curl_rtsp_done_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_status: NATURAL_32; a_premature: BOOLEAN): NATURAL_32
				do
					Result := a_conn.item.Curl_rtsp_done (a_status, a_premature)
				end)
		end

	Curl_rtsp_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
				do
					Result := a_conn.item.Curl_rtsp (a_done)
				end)
		end

	gopher_do_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
				do
					Result := a_conn.item.gopher_do (a_done)
				end)
		end

	MD5_Init_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (create {PD_CONNECTDATA}.make).MD5_Init)
		end

end
