class
	P_BDIV_Q_1_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	gmpn_pi1_bdiv_q_1 (a_rp, a_up: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_d, a_di: NATURAL_32; a_shift: INTEGER_32): NATURAL_32
		require
			not a_rp.is_void
			not a_up.is_void
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_d: CE_ARRAY [NATURAL_32]
			l_i: INTEGER_32
			l_c: NATURAL_32
			l_h: CE_ARRAY [NATURAL_32]
			l_l: CE_ARRAY [NATURAL_32]
			l_u: NATURAL_32
			l_u_next: NATURAL_32
			l_dummy: CE_ARRAY [NATURAL_32]
			l___x: NATURAL_32
			l___y: NATURAL_32
			l___w: NATURAL_32
			l___x___0: NATURAL_32
			l___y___0: NATURAL_32
			l___w___0: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_d.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_h.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_l.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_dummy.make (<<1>>)

			l_rp := a_rp
			l_d.item := a_d
			l_d.item := l_d.item
			if a_shift /= 0 then
				l_c := (0).to_natural_32
				l_u := a_up[0]
				l_rp := l_rp - 1
				l_i := (1).to_integer_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_u_next := a_up[l_i]
					l_u := (((((l_u).bit_shift_right (a_shift))).bit_or (((l_u_next).bit_shift_left ((32 - a_shift)))))).bit_and ({NATURAL_32} 4_294_967_295)
					from
					until
						(l_break)
					loop
						l_break := False
						l___x := l_u
						l___y := l_c
						l___w := l___x - l___y
						l_l.item := l___w
						l_c := (l___w > l___x).to_integer.to_natural_32
						l_break := True
					end
					l_break := False
					l_l.item := (l_l.item * a_di).bit_and ({NATURAL_32} 4_294_967_295)
					l_rp[l_i] := l_l.item
					asm320 (l_dummy, l_h, l_l, l_d)
					l_c := l_c + (l_h.item)
					l_u := l_u_next
					l_i := l_i + 1
				end
				l_u := (l_u).bit_shift_right (a_shift)
				l_l.item := l_u - l_c
				l_l.item := (l_l.item * a_di).bit_and ({NATURAL_32} 4_294_967_295)
				l_rp[l_i] := l_l.item
			else
				l_u := a_up[0]
				l_l.item := (l_u * a_di).bit_and ({NATURAL_32} 4_294_967_295)
				l_rp[0] := l_l.item
				l_c := (0).to_natural_32
				l_i := (1).to_integer_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					asm321 (l_dummy, l_h, l_l, l_d)
					l_c := l_c + (l_h.item)
					l_u := a_up[l_i]
					from
					until
						(l_break)
					loop
						l_break := False
						l___x___0 := l_u
						l___y___0 := l_c
						l___w___0 := l___x___0 - l___y___0
						l_l.item := l___w___0
						l_c := (l___w___0 > l___x___0).to_integer.to_natural_32
						l_break := True
					end
					l_break := False
					l_l.item := (l_l.item * a_di).bit_and ({NATURAL_32} 4_294_967_295)
					l_rp[l_i] := l_l.item
					l_i := l_i + 1
				end
			end
			Result := l_c
		end

	gmpn_bdiv_q_1 (a_rp, a_up: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_d: NATURAL_32): NATURAL_32
		require
			not a_rp.is_void
			not a_up.is_void
		local
			l_d: NATURAL_32
			l_di: NATURAL_32
			l_shift: INTEGER_32
			l___n: NATURAL_32
			l___inv: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_d := a_d
			if ((l_d).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_shift := builtin_ctzl (l_d)
					l_break := True
				end
				l_break := False
				l_d := (l_d).bit_shift_right (l_shift)
			else
				l_shift := 0
			end
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l___n := l_d
				l___inv := ((create {P_GMP_IMPL_STATIC}).gmp_binvert_limb_table[((l___n // {NATURAL_32} 2).bit_and ({NATURAL_32} 127)).to_integer_32]).to_natural_32
				l___inv := {NATURAL_32} 2 * l___inv - (l___inv * l___inv) * l___n
				l___inv := {NATURAL_32} 2 * l___inv - (l___inv * l___inv) * l___n
				l_di := (l___inv).bit_and ({NATURAL_32} 4_294_967_295)
				l_break := True
			end
			l_break := False
			Result := (gmpn_pi1_bdiv_q_1 (a_rp, a_up, a_n, l_d, l_di, l_shift))
		end

end
