class
	P_INVERT_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	gmpn_invert (a_ip, a_dp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		local
			l_n: CE_ARRAY [INTEGER_32]
			l_dp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_ip: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_scratch: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___2: CE_POINTER [ANY]
			l_i: INTEGER_32
			l_xp: CE_POINTER [NATURAL_32]
			l___d: CE_POINTER [NATURAL_32]
			l___s: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_32]
			l_tmp___5: CE_POINTER [NATURAL_32]
			l_inv: PD_GMP_PI1_T
			l_v: CE_ARRAY [NATURAL_32]
			l_p: NATURAL_32
			l_t1: CE_ARRAY [NATURAL_32]
			l_t0: CE_ARRAY [NATURAL_32]
			l_mask: NATURAL_32
			l_e: NATURAL_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_INTEGER_32_ARRAY} l_n.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_dp.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_ip.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)
			create l_inv.make
			create {CE_NATURAL_32_ARRAY} l_v.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_t1.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_t0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_n.item := a_n
					l_dp.item := a_dp
					l_ip.item := a_ip
					l_scratch := a_scratch
					if l_n.item /= 1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							(l_break)
						loop
							l_break := False
							l_ip.item.item := (create {P_GMP_IMPL_STATIC}).gmpn_invert_limb (l_dp.item.item)
							l_break := True
						end
						l_break := False
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						if l_scratch.is_void then
							if (builtin_expect (((3 * l_n.item + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___2 := (l_aaf.new (((3 * l_n.item + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___2 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((3 * l_n.item + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_scratch := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2)
						end
						if 61 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_n.item >= 61 then
							l_e := (create {P_INVERTAPPR_STATIC}).gmpn_ni_invertappr (l_ip.item, l_dp.item, l_n.item, l_scratch)
							if l_e.to_boolean then
								(create {P_MUL_N_STATIC}).gmpn_mul_n (l_scratch, l_ip.item, l_dp.item, l_n.item);
								(create {P_GMP_STATIC}).gmpn_add_n (l_scratch + l_n.item, (l_scratch + l_n.item), l_dp.item, l_n.item).do_nothing
								if not ((create {P_GMP_STATIC}).gmpn_add (l_scratch, l_scratch, 2 * l_n.item, l_dp.item, l_n.item)).to_boolean then
									from
									until
										(l_break)
									loop
										l_break := False
										asm220 (l___ptr_dummy, l_ip)
										l_break := True
									end
									l_break := False
								end
							end
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						l_xp := l_scratch
						l_i := l_n.item - 1
						from
						until
							not (l_i >= 0)
						loop
							l_xp[l_i] := {NATURAL_32} 4_294_967_295
							l_i := l_i - 1
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l___d := l_xp + l_n.item
							l___s := l_dp.item
							l___n := l_n.item
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___4 := l___d
								l___d := l___d + 1
								l_tmp___5 := l___s
								l___s := l___s + 1
								l_tmp___4.item := (((l_tmp___5.item).bit_not).bit_and ({NATURAL_32} 4_294_967_295))
								l___n := l___n - 1
								if not l___n.to_boolean then
									l_break := True
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if l_n.item = 2 then
							(create {P_GMP_STATIC}).gmpn_divrem_2 (l_ip.item, (0).to_integer_32, l_xp, (4).to_integer_32, l_dp.item).do_nothing
						else
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									l_v.item := (create {P_GMP_IMPL_STATIC}).gmpn_invert_limb (l_dp.item[(l_n.item - 1)])
									l_break := True
								end
								l_break := False
								l_p := (l_dp.item[(l_n.item - 1)] * l_v.item)
								l_p := l_p + (l_dp.item[(l_n.item - 2)])
								if l_p < l_dp.item[(l_n.item - 2)] then
									l_v.item := l_v.item - 1
									l_mask := (-(l_p >= l_dp.item[(l_n.item - 1)]).to_integer).to_integer.to_natural_32
									l_p := l_p - (l_dp.item[(l_n.item - 1)])
									l_v.item := l_v.item + l_mask
									l_p := l_p - ((l_mask).bit_and (l_dp.item[(l_n.item - 1)]))
								end
								asm221 (l_t0, l_t1, l_dp, l_n, l_v)
								l_p := l_p + (l_t1.item)
								if l_p < l_t1.item then
									l_v.item := l_v.item - 1
									if (builtin_expect ((l_p >= l_dp.item[(l_n.item - 1)]).to_integer, 0)).to_boolean then
										if l_p > l_dp.item[(l_n.item - 1)] then
											l_v.item := l_v.item - 1
										elseif l_t0.item >= l_dp.item[(l_n.item - 2)] then
											l_v.item := l_v.item - 1
										end
									end
								end
								l_inv.inv32 := l_v.item
								l_break := True
							end
							l_break := False;
							(create {P_SBPI1_DIV_Q_STATIC}).gmpn_sbpi1_div_q (l_ip.item, l_xp, 2 * l_n.item, l_dp.item, l_n.item, l_inv.inv32).do_nothing
						end
				when 7 then
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
