class
	P_MOD_1_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	mpn_mod_1_unnorm (a_up: CE_POINTER [NATURAL_32]; a_un: INTEGER_32; a_d: NATURAL_32): NATURAL_32
		require
			not a_up.is_void
		local
			l_un: INTEGER_32
			l_d: CE_ARRAY [NATURAL_32]
			l_i: INTEGER_32
			l_n1: CE_ARRAY [NATURAL_32]
			l_n0: CE_ARRAY [NATURAL_32]
			l_r: CE_ARRAY [NATURAL_32]
			l_dummy: CE_ARRAY [NATURAL_32]
			l_cnt: CE_ARRAY [INTEGER_32]
			l_inv: CE_ARRAY [NATURAL_32]
			l__qh: CE_ARRAY [NATURAL_32]
			l__ql: CE_ARRAY [NATURAL_32]
			l__r: NATURAL_32
			l__qh___0: CE_ARRAY [NATURAL_32]
			l__ql___0: CE_ARRAY [NATURAL_32]
			l__r___0: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_32_ARRAY} l_d.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_n1.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_n0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_r.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_dummy.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_cnt.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_inv.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__qh.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__ql.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__qh___0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__ql___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_un := a_un
					l_d.item := a_d
					l_d.item := l_d.item
					l_r.item := a_up[(l_un - 1)]
					if l_r.item < l_d.item then
						l_r.item := l_r.item
						l_un := l_un - 1
						if l_un = 0 then
							Result := (l_r.item)
							l_return := True
						end
					else
						l_r.item := (0).to_natural_32
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if 5 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if not (l_un >= 5) then
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						l_i := l_un - 1
						from
						until
							not (l_i >= 0)
						loop
							l_n0.item := a_up[l_i]
							asm27 (l_dummy, l_r, l_n0, l_d)
							l_r.item := l_r.item
							l_i := l_i - 1
						end
						Result := (l_r.item)
						l_return := True
				when 5 then -- if done
					if not l_return then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_cnt.item := builtin_clzl (l_d.item)
							l_break := True
						end
						l_break := False
						l_d.item := (l_d.item).bit_shift_left ((l_cnt.item))
						l_n1.item := a_up[(l_un - 1)]
						l_r.item := (((l_r.item).bit_shift_left (l_cnt.item))).bit_or (((l_n1.item).bit_shift_right ((32 - l_cnt.item))))
						from
						until
							(l_break)
						loop
							l_break := False
							l_inv.item := (create {P_GMP_IMPL_STATIC}).gmpn_invert_limb (l_d.item)
							l_break := True
						end
						l_break := False
						l_i := l_un - 2
						from
						until
							not (not (l_return) and then (l_i >= 0))
						loop
							l_n0.item := a_up[l_i]
							from
							until
								(l_break)
							loop
								l_break := False
								asm28 (l__ql, l__qh, l_r, l_inv)
								asm29 (l__qh, l__ql, l_r, l_n1, l_cnt, l_n0)
								l__r := ((((l_n1.item).bit_shift_left (l_cnt.item))).bit_or (((l_n0.item).bit_shift_right ((32 - l_cnt.item))))) - l__qh.item * l_d.item
								if l__r > l__ql.item then
									l__r := l__r + (l_d.item)
									l__qh.item := l__qh.item - 1
								end
								if (builtin_expect ((l__r >= l_d.item).to_integer, 0)).to_boolean then
									l__r := l__r - (l_d.item)
									l__qh.item := l__qh.item + 1
								end
								l_r.item := l__r
								l_dummy.item := l__qh.item
								l_break := True
							end
							l_break := False
							l_r.item := l_r.item
							l_n1.item := l_n0.item
							l_i := l_i - 1
						end
						from
						until
							(l_break)
						loop
							l_break := False
							asm30 (l__ql___0, l__qh___0, l_r, l_inv)
							asm31 (l__qh___0, l__ql___0, l_r, l_n1, l_cnt)
							l__r___0 := ((l_n1.item).bit_shift_left (l_cnt.item)) - l__qh___0.item * l_d.item
							if l__r___0 > l__ql___0.item then
								l__r___0 := l__r___0 + (l_d.item)
								l__qh___0.item := l__qh___0.item - 1
							end
							if (builtin_expect ((l__r___0 >= l_d.item).to_integer, 0)).to_boolean then
								l__r___0 := l__r___0 - (l_d.item)
								l__qh___0.item := l__qh___0.item + 1
							end
							l_r.item := l__r___0
							l_dummy.item := l__qh___0.item
							l_break := True
						end
						l_break := False
						l_r.item := l_r.item
						Result := ((l_r.item).bit_shift_right (l_cnt.item))
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mpn_mod_1_norm (a_up: CE_POINTER [NATURAL_32]; a_un: INTEGER_32; a_d: NATURAL_32): NATURAL_32
		require
			not a_up.is_void
		local
			l_un: INTEGER_32
			l_d: CE_ARRAY [NATURAL_32]
			l_i: INTEGER_32
			l_n0: CE_ARRAY [NATURAL_32]
			l_r: CE_ARRAY [NATURAL_32]
			l_dummy: CE_ARRAY [NATURAL_32]
			l_inv: CE_ARRAY [NATURAL_32]
			l__qh: CE_ARRAY [NATURAL_32]
			l__ql: CE_ARRAY [NATURAL_32]
			l__r: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_32_ARRAY} l_d.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_n0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_r.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_dummy.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_inv.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__qh.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__ql.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_un := a_un
					l_d.item := a_d
					l_d.item := l_d.item
					l_r.item := a_up[(l_un - 1)]
					if l_r.item >= l_d.item then
						l_r.item := l_r.item - (l_d.item)
					end
					l_r.item := l_r.item
					l_un := l_un - 1
					if l_un = 0 then
						Result := (l_r.item)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if 3 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_un >= 3 then
							from
							until
								(l_break)
							loop
								l_break := False
								l_inv.item := (create {P_GMP_IMPL_STATIC}).gmpn_invert_limb (l_d.item)
								l_break := True
							end
							l_break := False
							l_i := l_un - 1
							from
							until
								not (not (l_return) and then (l_i >= 0))
							loop
								l_n0.item := a_up[l_i]
								from
								until
									(l_break)
								loop
									l_break := False
									asm32 (l__ql, l__qh, l_r, l_inv)
									asm33 (l__qh, l__ql, l_r, l_n0)
									l__r := l_n0.item - l__qh.item * l_d.item
									if l__r > l__ql.item then
										l__r := l__r + (l_d.item)
										l__qh.item := l__qh.item - 1
									end
									if (builtin_expect ((l__r >= l_d.item).to_integer, 0)).to_boolean then
										l__r := l__r - (l_d.item)
										l__qh.item := l__qh.item + 1
									end
									l_r.item := l__r
									l_dummy.item := l__qh.item
									l_break := True
								end
								l_break := False
								l_r.item := l_r.item
								l_i := l_i - 1
							end
							Result := (l_r.item)
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						l_i := l_un - 1
						from
						until
							not (l_i >= 0)
						loop
							l_n0.item := a_up[l_i]
							asm34 (l_dummy, l_r, l_n0, l_d)
							l_r.item := l_r.item
							l_i := l_i - 1
						end
						Result := (l_r.item)
				when 5 then -- if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_mod_1 (a_ap: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_b: NATURAL_32): NATURAL_32
		local
			l_tmp: NATURAL_32
			l_pre: CE_ARRAY [NATURAL_32]
			l_tmp___1: NATURAL_32
			l_pre___0: CE_ARRAY [NATURAL_32]
			l_tmp___2: NATURAL_32
			l_pre___1: CE_ARRAY [NATURAL_32]
			l_pre___2: CE_ARRAY [NATURAL_32]
			l_return: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_pre.make (<<4>>)
			create {CE_NATURAL_32_ARRAY} l_pre___0.make (<<4>>)
			create {CE_NATURAL_32_ARRAY} l_pre___1.make (<<5>>)
			create {CE_NATURAL_32_ARRAY} l_pre___2.make (<<7>>)

			if a_n = 0 then
				Result := (0).to_natural_32
				l_return := True
			end
			if not l_return then
				if (builtin_expect ((((a_b).bit_and ((({NATURAL_32} 1).bit_shift_left (31)))) /= {NATURAL_32} 0).to_integer, 0)).to_boolean then
					if 10 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						if a_n >= 10 then
							(create {P_MOD_1_1_STATIC}).gmpn_mod_1_1p_cps (create {CE_NATURAL_32_POINTER}.make_cast (l_pre), a_b)
							Result := ((create {P_MOD_1_1_STATIC}).gmpn_mod_1_1p (a_ap, a_n, a_b, create {CE_NATURAL_32_POINTER}.make_cast (l_pre)))
						else
							l_tmp := mpn_mod_1_norm (a_ap, a_n, a_b)
							Result := l_tmp
						end
					else
						l_tmp := mpn_mod_1_norm (a_ap, a_n, a_b)
						Result := l_tmp
					end
				elseif 5 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if a_n >= 5 then
						if 6 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if a_n >= 6 then
								if (builtin_expect ((a_b > {NATURAL_32} 1_073_741_823).to_integer, 0)).to_boolean then
									(create {P_MOD_1_2_STATIC}).gmpn_mod_1s_2p_cps (create {CE_NATURAL_32_POINTER}.make_cast (l_pre___1), a_b)
									Result := ((create {P_MOD_1_2_STATIC}).gmpn_mod_1s_2p (a_ap, a_n, (a_b).bit_shift_left ((l_pre___1[1]).to_integer_32), create {CE_NATURAL_32_POINTER}.make_cast (l_pre___1)))
								else
									(create {P_GMP_IMPL_STATIC}).gmpn_mod_1s_4p_cps (create {CE_NATURAL_32_POINTER}.make_cast (l_pre___2), a_b)
									Result := ((create {P_GMP_IMPL_STATIC}).gmpn_mod_1s_4p (a_ap, a_n, (a_b).bit_shift_left ((l_pre___2[1]).to_integer_32), create {CE_NATURAL_32_POINTER}.make_cast (l_pre___2)))
								end
							else
								(create {P_MOD_1_1_STATIC}).gmpn_mod_1_1p_cps (create {CE_NATURAL_32_POINTER}.make_cast (l_pre___0), a_b)
								l_tmp___2 := (create {P_MOD_1_1_STATIC}).gmpn_mod_1_1p (a_ap, a_n, (a_b).bit_shift_left ((l_pre___0[1]).to_integer_32), create {CE_NATURAL_32_POINTER}.make_cast (l_pre___0))
								Result := l_tmp___2
							end
						else
							(create {P_MOD_1_1_STATIC}).gmpn_mod_1_1p_cps (create {CE_NATURAL_32_POINTER}.make_cast (l_pre___0), a_b)
							l_tmp___2 := (create {P_MOD_1_1_STATIC}).gmpn_mod_1_1p (a_ap, a_n, (a_b).bit_shift_left ((l_pre___0[1]).to_integer_32), create {CE_NATURAL_32_POINTER}.make_cast (l_pre___0))
							Result := l_tmp___2
						end
					else
						l_tmp___1 := mpn_mod_1_unnorm (a_ap, a_n, a_b)
						Result := l_tmp___1
					end
				else
					l_tmp___1 := mpn_mod_1_unnorm (a_ap, a_n, a_b)
					Result := l_tmp___1
				end
			end
		end

end
