class
	P_MU_DIV_Q_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpn_mu_div_q (a_qp, a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_tp: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_ip: CE_POINTER [NATURAL_32]
			l_this_ip: CE_POINTER [NATURAL_32]
			l_qn: INTEGER_32
			l_in: INTEGER_32
			l_this_in: INTEGER_32
			l_cy: NATURAL_32
			l_qh: NATURAL_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_in1: INTEGER_32
			l_in2: INTEGER_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
			l_cy___0: NATURAL_32
			l_pp: CE_POINTER [NATURAL_32]
			l_tmp___7: NATURAL_32
			l_cy___1: NATURAL_32
			l_tmp___11: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			l_qn := a_nn - a_dn
			l_tp := create {CE_NATURAL_32_POINTER}.make_cast (((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_qn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			if l_qn >= a_dn then
				if a_dn /= l_qn then
					l_in1 := (create {P_MU_DIV_QR_STATIC}).gmpn_mu_div_qr_choose_in (l_qn - a_dn, a_dn, 0)
					l_in2 := (create {P_MU_DIVAPPR_Q_STATIC}).gmpn_mu_divappr_q_choose_in (a_dn + 1, a_dn, 0)
					if l_in1 > l_in2 then
						l_in := l_in1
					else
						l_in := l_in2
					end
				else
					l_in := (create {P_MU_DIVAPPR_Q_STATIC}).gmpn_mu_divappr_q_choose_in (a_dn + 1, a_dn, 0)
				end
				l_ip := create {CE_NATURAL_32_POINTER}.make_cast (((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_in + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				if a_dn = l_in then
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (a_scratch + 1, a_dp, l_in)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					a_scratch[0] := (1).to_natural_32;
					(create {P_INVERTAPPR_STATIC}).gmpn_invertappr (l_ip, a_scratch, l_in + 1, create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)).do_nothing
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (l_ip, (l_ip + 1), l_in)
						l_break := True
					end
					l_break := False
				else
					l_cy := (create {P_GMP_STATIC}).gmpn_add_1 (a_scratch, (a_dp + a_dn) - (l_in + 1), l_in + 1, (1).to_natural_32)
					if (builtin_expect ((l_cy /= {NATURAL_32} 0).to_integer, 0)).to_boolean then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_in /= 0 then
								l___dst := l_ip
								l___n := l_in
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___1 := l___dst
									l___dst := l___dst + 1
									l_tmp___1.item := (0).to_natural_32
									l___n := l___n - 1
									if not l___n.to_boolean then
										l_break := True
									end
								end
								l_break := False
							end
							l_break := True
						end
						l_break := False
					else
						(create {P_INVERTAPPR_STATIC}).gmpn_invertappr (l_ip, a_scratch, l_in + 1, create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)).do_nothing
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_ip, (l_ip + 1), l_in)
							l_break := True
						end
						l_break := False
					end
				end
				l_rp := create {CE_NATURAL_32_POINTER}.make_cast (((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((2 * a_dn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				l_this_in := (create {P_MU_DIV_QR_STATIC}).gmpn_mu_div_qr_choose_in (l_qn - a_dn, a_dn, 0)
				l_this_ip := (l_ip + l_in) - l_this_in
				l_qh := (create {P_MU_DIV_QR_STATIC}).gmpn_preinv_mu_div_qr ((l_tp + a_dn) + 1, (l_rp + a_dn) + 1, a_np + a_dn, l_qn, a_dp, a_dn, l_this_ip, l_this_in, a_scratch)
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (l_rp + 1, a_np, a_dn)
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
				l_rp[0] := (0).to_natural_32
				l_this_in := (create {P_MU_DIVAPPR_Q_STATIC}).gmpn_mu_divappr_q_choose_in (a_dn + 1, a_dn, 0)
				l_this_ip := (l_ip + l_in) - l_this_in
				l_cy := (create {P_MU_DIVAPPR_Q_STATIC}).gmpn_preinv_mu_divappr_q (l_tp, l_rp, 2 * a_dn + 1, a_dp, a_dn, l_this_ip, l_this_in, a_scratch)
				if (builtin_expect ((l_cy /= {NATURAL_32} 0).to_integer, 0)).to_boolean then
					l_i := (0).to_integer_32
					from
					until
						not (l_i < a_dn + 1)
					loop
						l_tp[l_i] := {NATURAL_32} 4_294_967_295
						l_i := l_i + 1
					end
				end
				if l_tp[0] > {NATURAL_32} 4 then
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (a_qp, (l_tp + 1), l_qn)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
				else
					l_pp := create {CE_NATURAL_32_POINTER}.make_cast (((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (a_nn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)));
					(create {P_MUL_STATIC}).gmpn_mul (l_pp, (l_tp + 1), l_qn, a_dp, a_dn).do_nothing
					if l_qh /= {NATURAL_32} 0 then
						l_cy___0 := ((create {P_GMP_STATIC}).gmpn_add_n (l_pp + l_qn, (l_pp + l_qn), a_dp, a_dn))
					else
						l_cy___0 := (0).to_natural_32
					end
					if l_cy___0.to_boolean then
						l_tmp___7 := (create {P_GMP_STATIC}).gmpn_sub_1 (a_qp, (l_tp + 1), l_qn, (1).to_natural_32)
						l_qh := l_qh - l_tmp___7
					elseif ((create {P_GMP_STATIC}).gmpn_cmp (l_pp, a_np, a_nn)) > 0 then
						l_tmp___7 := (create {P_GMP_STATIC}).gmpn_sub_1 (a_qp, (l_tp + 1), l_qn, (1).to_natural_32)
						l_qh := l_qh - l_tmp___7
					else
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (a_qp, (l_tp + 1), l_qn)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
					end
				end
			else
				l_qh := (create {P_MU_DIVAPPR_Q_STATIC}).gmpn_mu_divappr_q (l_tp, (a_np + a_nn) - (2 * l_qn + 2), 2 * l_qn + 2, (a_dp + a_dn) - (l_qn + 1), l_qn + 1, a_scratch)
				if l_tp[0] > {NATURAL_32} 6 then
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (a_qp, (l_tp + 1), l_qn)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
				else
					l_rp := create {CE_NATURAL_32_POINTER}.make_cast (((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (a_nn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)));
					(create {P_MUL_STATIC}).gmpn_mul (l_rp, a_dp, a_dn, (l_tp + 1), l_qn).do_nothing
					if l_qh /= {NATURAL_32} 0 then
						l_cy___1 := ((create {P_GMP_STATIC}).gmpn_add_n (l_rp + l_qn, (l_rp + l_qn), a_dp, a_dn))
					else
						l_cy___1 := (0).to_natural_32
					end
					if l_cy___1.to_boolean then
						l_tmp___11 := (create {P_GMP_STATIC}).gmpn_sub_1 (a_qp, (l_tp + 1), l_qn, (1).to_natural_32)
						l_qh := l_qh - l_tmp___11
					elseif ((create {P_GMP_STATIC}).gmpn_cmp (l_rp, a_np, a_nn)) > 0 then
						l_tmp___11 := (create {P_GMP_STATIC}).gmpn_sub_1 (a_qp, (l_tp + 1), l_qn, (1).to_natural_32)
						l_qh := l_qh - l_tmp___11
					else
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (a_qp, (l_tp + 1), l_qn)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
					end
				end
			end
			from
			until
				(l_break)
			loop
				l_break := False
				if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
					(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
				end
				l_break := True
			end
			l_break := False
			Result := l_qh
		end

	gmpn_mu_div_q_itch (a_nn, a_dn: INTEGER_32; a_mua_k: INTEGER_32): INTEGER_32
		local
			l_qn: INTEGER_32
			l_itch1: INTEGER_32
			l_itch2: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_qn := a_nn - a_dn
			if l_qn >= a_dn then
				l_itch1 := (create {P_MU_DIV_QR_STATIC}).gmpn_mu_div_qr_itch (l_qn, a_dn, a_mua_k)
				l_itch2 := (create {P_MU_DIVAPPR_Q_STATIC}).gmpn_mu_divappr_q_itch (2 * a_dn + 1, a_dn, a_mua_k)
				if l_itch1 > l_itch2 then
					l_tmp := l_itch1
				else
					l_tmp := l_itch2
				end
				Result := l_tmp
			else
				l_itch1 := (create {P_MU_DIVAPPR_Q_STATIC}).gmpn_mu_divappr_q_itch (2 * l_qn + 2, l_qn + 1, a_mua_k)
				Result := l_itch1
			end
		end

end
