class
	P_REDC_2_STATIC

inherit
	CE_UTILITIES
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	gmpn_addmul_2 (a_rp, a_up: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_vp: CE_POINTER [NATURAL_32]): NATURAL_32
		require
			not a_rp.is_void
			not a_vp.is_void
		do
			a_rp[a_n] := (create {P_GMP_STATIC}).gmpn_addmul_1 (a_rp, a_up, a_n, a_vp[0])
			Result := ((create {P_GMP_STATIC}).gmpn_addmul_1 (a_rp + 1, a_up, a_n, a_vp[1]))
		end

	gmpn_redc_2 (a_rp, a_up, a_mp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_mip: CE_POINTER [NATURAL_32])
		local
			l_mip: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_up: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_q: CE_ARRAY [NATURAL_32]
			l_j: INTEGER_32
			l_upn: NATURAL_32
			l_cy: NATURAL_32
			l__ph: CE_ARRAY [NATURAL_32]
			l__pl: CE_ARRAY [NATURAL_32]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_mip.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_up.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_q.make (<<2>>)
			create {CE_NATURAL_32_ARRAY} l__ph.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__pl.make (<<1>>)

			l_mip.item := a_mip
			l_up.item := a_up
			if ((a_n).bit_and (1)) /= 0 then
				l_up.item[0] := (create {P_GMP_STATIC}).gmpn_addmul_1 (l_up.item, a_mp, a_n, (l_up.item[0] * l_mip.item[0]).bit_and ({NATURAL_32} 4_294_967_295))
				l_up.item := l_up.item + 1
			end
			l_j := a_n - 2
			from
			until
				not (not (l_return) and then (l_j >= 0))
			loop
				from
				until
					(l_break)
				loop
					l_break := False
					asm339 (l__pl, l__ph, l_mip, l_up)
					l_q[1] := (l__ph.item + (l_mip.item[0] * l_up.item[1])) + (l_mip.item[1] * l_up.item[0])
					l_q[0] := l__pl.item
					l_break := True
				end
				l_break := False
				l_upn := l_up.item[a_n]
				l_up.item[1] := gmpn_addmul_2 (l_up.item, a_mp, a_n, create {CE_NATURAL_32_POINTER}.make_cast (l_q))
				l_up.item[0] := l_up.item[a_n]
				l_up.item[a_n] := l_upn
				l_up.item := l_up.item + (2)
				l_j := l_j - (2)
			end
			l_cy := (create {P_GMP_STATIC}).gmpn_add_n (a_rp, l_up.item, (l_up.item - a_n), a_n)
			if l_cy /= {NATURAL_32} 0 then
				(create {P_GMP_STATIC}).gmpn_sub_n (a_rp, a_rp, a_mp, a_n).do_nothing
			end
		end

end
