class
	P_TOOM3_SQR_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpn_toom3_sqr (a_pp, a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		local
			l_n: INTEGER_32
			l_s: INTEGER_32
			l_cy: NATURAL_32
			l_vinf0: NATURAL_32
			l_gp: CE_POINTER [NATURAL_32]
			l_as1: CE_POINTER [NATURAL_32]
			l_asm1: CE_POINTER [NATURAL_32]
			l_as2: CE_POINTER [NATURAL_32]
			l_tmp___0: NATURAL_32
			l_break: BOOLEAN
		do
			l_n := ((a_an + 2).to_natural_32 // {NATURAL_32} 3).to_integer_32
			l_s := a_an - 2 * l_n
			l_as1 := (a_scratch + 4 * l_n) + 4
			l_asm1 := (a_scratch + 2 * l_n) + 2
			l_as2 := (a_pp + l_n) + 1
			l_gp := a_scratch
			l_cy := (create {P_GMP_STATIC}).gmpn_add (l_gp, a_ap, l_n, a_ap + 2 * l_n, l_s)
			l_as1[l_n] := l_cy + ((create {P_GMP_STATIC}).gmpn_add_n (l_as1, l_gp, a_ap + l_n, l_n))
			if l_cy = {NATURAL_32} 0 then
				if ((create {P_GMP_STATIC}).gmpn_cmp (l_gp, a_ap + l_n, l_n)) < 0 then
					(create {P_GMP_STATIC}).gmpn_sub_n (l_asm1, a_ap + l_n, l_gp, l_n).do_nothing
					l_asm1[l_n] := (0).to_natural_32
				else
					l_tmp___0 := (create {P_GMP_STATIC}).gmpn_sub_n (l_asm1, l_gp, a_ap + l_n, l_n)
					l_cy := l_cy - l_tmp___0
					l_asm1[l_n] := l_cy
				end
			else
				l_tmp___0 := (create {P_GMP_STATIC}).gmpn_sub_n (l_asm1, l_gp, a_ap + l_n, l_n)
				l_cy := l_cy - l_tmp___0
				l_asm1[l_n] := l_cy
			end
			l_cy := (create {P_GMP_STATIC}).gmpn_add_n (l_as2, a_ap + 2 * l_n, l_as1, l_s)
			if l_s /= l_n then
				l_cy := (create {P_GMP_STATIC}).gmpn_add_1 (l_as2 + l_s, (l_as1 + l_s), l_n - l_s, l_cy)
			end
			l_cy := l_cy + (l_as1[l_n])
			l_cy := {NATURAL_32} 2 * l_cy + ((create {P_GMP_STATIC}).gmpn_lshift (l_as2, l_as2, l_n, {NATURAL_32} 1))
			l_cy := l_cy - ((create {P_GMP_STATIC}).gmpn_sub_n (l_as2, l_as2, a_ap, l_n))
			l_as2[l_n] := l_cy
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_TOOM2_SQR_STATIC}).gmpn_toom2_sqr (a_scratch, l_asm1, l_n + 1, (a_scratch + 5 * l_n) + 5)
				l_break := True
			end
			l_break := False
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_TOOM2_SQR_STATIC}).gmpn_toom2_sqr ((a_scratch + 2 * l_n) + 1, l_as2, l_n + 1, (a_scratch + 5 * l_n) + 5)
				l_break := True
			end
			l_break := False
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_TOOM2_SQR_STATIC}).gmpn_toom2_sqr (a_pp + 4 * l_n, a_ap + 2 * l_n, l_s, (a_scratch + 5 * l_n) + 5)
				l_break := True
			end
			l_break := False
			l_vinf0 := (a_pp + 4 * l_n)[0]
			l_cy := (a_pp + 4 * l_n)[1]
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_TOOM2_SQR_STATIC}).gmpn_toom2_sqr (a_pp + 2 * l_n, l_as1, l_n + 1, (a_scratch + 5 * l_n) + 5)
				l_break := True
			end
			l_break := False;
			(a_pp + 4 * l_n)[1] := l_cy
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_TOOM2_SQR_STATIC}).gmpn_toom2_sqr (a_pp, a_ap, l_n, (a_scratch + 5 * l_n) + 5)
				l_break := True
			end
			l_break := False;
			(create {P_TOOM_INTERPOLATE_5PTS_STATIC}).gmpn_toom_interpolate_5pts (a_pp, (a_scratch + 2 * l_n) + 1, a_scratch, l_n, l_s + l_s, 0, l_vinf0)
		end

end
