class
	P_TOOM44_MUL_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpn_toom44_mul (a_pp, a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		require
			not a_pp.is_void
		local
			l_n: INTEGER_32
			l_s: INTEGER_32
			l_t: INTEGER_32
			l_cy: NATURAL_32
			l_flags: NATURAL_32
			l_break: BOOLEAN
		do
			l_n := ((a_an + 3)).bit_shift_right (2)
			l_s := a_an - 3 * l_n
			l_t := a_bn - 3 * l_n
			l_flags := ((1).bit_and (((create {P_TOOM_EVAL_DGR3_PM2_STATIC}).gmpn_toom_eval_dgr3_pm2 (a_pp, (a_pp + l_n) + 1, a_ap, l_n, l_s, (a_scratch + 8 * l_n) + 5)))).to_natural_32
			l_flags := ((l_flags).bit_xor (((1).bit_and (((create {P_TOOM_EVAL_DGR3_PM2_STATIC}).gmpn_toom_eval_dgr3_pm2 ((a_pp + 4 * l_n) + 2, (a_pp + 2 * l_n) + 2, a_bp, l_n, l_t, (a_scratch + 8 * l_n) + 5)))).to_natural_32))
			from
			until
				(l_break)
			loop
				l_break := False
				if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n + 1 >= 77 then
						if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 182 then
								gmpn_toom44_mul (a_scratch, a_pp, l_n + 1, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
							else
								(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_scratch, a_pp, l_n + 1, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
							end
						else
							(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_scratch, a_pp, l_n + 1, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
						end
					else
						(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_scratch, a_pp, l_n + 1, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
					end
				else
					(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_scratch, a_pp, l_n + 1, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
				end
				l_break := True
			end
			l_break := False
			from
			until
				(l_break)
			loop
				l_break := False
				if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n + 1 >= 77 then
						if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 182 then
								gmpn_toom44_mul ((a_scratch + 2 * l_n) + 1, ((a_pp + l_n) + 1), l_n + 1, ((a_pp + 2 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
							else
								(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul ((a_scratch + 2 * l_n) + 1, ((a_pp + l_n) + 1), l_n + 1, ((a_pp + 2 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
							end
						else
							(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul ((a_scratch + 2 * l_n) + 1, ((a_pp + l_n) + 1), l_n + 1, ((a_pp + 2 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
						end
					else
						(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul ((a_scratch + 2 * l_n) + 1, ((a_pp + l_n) + 1), l_n + 1, ((a_pp + 2 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
					end
				else
					(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul ((a_scratch + 2 * l_n) + 1, ((a_pp + l_n) + 1), l_n + 1, ((a_pp + 2 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
				end
				l_break := True
			end
			l_break := False
			l_cy := (create {P_GMP_STATIC}).gmpn_lshift (a_pp, a_ap, l_n, {NATURAL_32} 1)
			l_cy := l_cy + ((create {P_GMP_STATIC}).gmpn_add_n (a_pp, a_pp, a_ap + l_n, l_n))
			l_cy := {NATURAL_32} 2 * l_cy + ((create {P_GMP_STATIC}).gmpn_lshift (a_pp, a_pp, l_n, {NATURAL_32} 1))
			l_cy := l_cy + ((create {P_GMP_STATIC}).gmpn_add_n (a_pp, a_pp, a_ap + 2 * l_n, l_n))
			l_cy := {NATURAL_32} 2 * l_cy + ((create {P_GMP_STATIC}).gmpn_lshift (a_pp, a_pp, l_n, {NATURAL_32} 1))
			a_pp[l_n] := l_cy + ((create {P_GMP_STATIC}).gmpn_add (a_pp, a_pp, l_n, a_ap + 3 * l_n, l_s))
			l_cy := (create {P_GMP_STATIC}).gmpn_lshift ((a_pp + 4 * l_n) + 2, a_bp, l_n, {NATURAL_32} 1)
			l_cy := l_cy + ((create {P_GMP_STATIC}).gmpn_add_n ((a_pp + 4 * l_n) + 2, ((a_pp + 4 * l_n) + 2), a_bp + l_n, l_n))
			l_cy := {NATURAL_32} 2 * l_cy + ((create {P_GMP_STATIC}).gmpn_lshift ((a_pp + 4 * l_n) + 2, ((a_pp + 4 * l_n) + 2), l_n, {NATURAL_32} 1))
			l_cy := l_cy + ((create {P_GMP_STATIC}).gmpn_add_n ((a_pp + 4 * l_n) + 2, ((a_pp + 4 * l_n) + 2), a_bp + 2 * l_n, l_n))
			l_cy := {NATURAL_32} 2 * l_cy + ((create {P_GMP_STATIC}).gmpn_lshift ((a_pp + 4 * l_n) + 2, ((a_pp + 4 * l_n) + 2), l_n, {NATURAL_32} 1));
			((a_pp + 4 * l_n) + 2)[l_n] := l_cy + ((create {P_GMP_STATIC}).gmpn_add ((a_pp + 4 * l_n) + 2, ((a_pp + 4 * l_n) + 2), l_n, a_bp + 3 * l_n, l_t))
			from
			until
				(l_break)
			loop
				l_break := False
				if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n + 1 >= 77 then
						if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 182 then
								gmpn_toom44_mul ((a_scratch + 4 * l_n) + 2, a_pp, l_n + 1, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
							else
								(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul ((a_scratch + 4 * l_n) + 2, a_pp, l_n + 1, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
							end
						else
							(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul ((a_scratch + 4 * l_n) + 2, a_pp, l_n + 1, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
						end
					else
						(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul ((a_scratch + 4 * l_n) + 2, a_pp, l_n + 1, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
					end
				else
					(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul ((a_scratch + 4 * l_n) + 2, a_pp, l_n + 1, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
				end
				l_break := True
			end
			l_break := False
			l_flags := ((l_flags).bit_or (((2).bit_and (((create {P_TOOM_EVAL_DGR3_PM1_STATIC}).gmpn_toom_eval_dgr3_pm1 (a_pp, (a_pp + l_n) + 1, a_ap, l_n, l_s, (a_scratch + 8 * l_n) + 5)))).to_natural_32))
			l_flags := ((l_flags).bit_xor (((2).bit_and (((create {P_TOOM_EVAL_DGR3_PM1_STATIC}).gmpn_toom_eval_dgr3_pm1 ((a_pp + 4 * l_n) + 2, (a_pp + 2 * l_n) + 2, a_bp, l_n, l_t, (a_scratch + 8 * l_n) + 5)))).to_natural_32))
			from
			until
				(l_break)
			loop
				l_break := False
				if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n + 1 >= 77 then
						if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 182 then
								gmpn_toom44_mul ((a_scratch + 6 * l_n) + 3, ((a_pp + l_n) + 1), l_n + 1, ((a_pp + 2 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
							else
								(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul ((a_scratch + 6 * l_n) + 3, ((a_pp + l_n) + 1), l_n + 1, ((a_pp + 2 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
							end
						else
							(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul ((a_scratch + 6 * l_n) + 3, ((a_pp + l_n) + 1), l_n + 1, ((a_pp + 2 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
						end
					else
						(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul ((a_scratch + 6 * l_n) + 3, ((a_pp + l_n) + 1), l_n + 1, ((a_pp + 2 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
					end
				else
					(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul ((a_scratch + 6 * l_n) + 3, ((a_pp + l_n) + 1), l_n + 1, ((a_pp + 2 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
				end
				l_break := True
			end
			l_break := False
			from
			until
				(l_break)
			loop
				l_break := False
				if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n + 1 >= 77 then
						if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 182 then
								gmpn_toom44_mul (a_pp + 2 * l_n, a_pp, l_n + 1, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
							else
								(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp + 2 * l_n, a_pp, l_n + 1, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
							end
						else
							(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp + 2 * l_n, a_pp, l_n + 1, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
						end
					else
						(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp + 2 * l_n, a_pp, l_n + 1, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
					end
				else
					(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp + 2 * l_n, a_pp, l_n + 1, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
				end
				l_break := True
			end
			l_break := False
			from
			until
				(l_break)
			loop
				l_break := False
				if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n >= 77 then
						if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n >= 182 then
								gmpn_toom44_mul (a_pp, a_ap, l_n, a_bp, l_n, (a_scratch + 8 * l_n) + 5)
							else
								(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp, a_ap, l_n, a_bp, l_n, (a_scratch + 8 * l_n) + 5)
							end
						else
							(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp, a_ap, l_n, a_bp, l_n, (a_scratch + 8 * l_n) + 5)
						end
					else
						(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp, a_ap, l_n, a_bp, l_n, (a_scratch + 8 * l_n) + 5)
					end
				else
					(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp, a_ap, l_n, a_bp, l_n, (a_scratch + 8 * l_n) + 5)
				end
				l_break := True
			end
			l_break := False
			if l_s > l_t then
				(create {P_MUL_STATIC}).gmpn_mul (a_pp + 6 * l_n, a_ap + 3 * l_n, l_s, a_bp + 3 * l_n, l_t).do_nothing
			else
				from
				until
					(l_break)
				loop
					l_break := False
					if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						if l_s >= 77 then
							if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
								if l_s >= 182 then
									gmpn_toom44_mul (a_pp + 6 * l_n, a_ap + 3 * l_n, l_s, a_bp + 3 * l_n, l_s, (a_scratch + 8 * l_n) + 5)
								else
									(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp + 6 * l_n, a_ap + 3 * l_n, l_s, a_bp + 3 * l_n, l_s, (a_scratch + 8 * l_n) + 5)
								end
							else
								(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp + 6 * l_n, a_ap + 3 * l_n, l_s, a_bp + 3 * l_n, l_s, (a_scratch + 8 * l_n) + 5)
							end
						else
							(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp + 6 * l_n, a_ap + 3 * l_n, l_s, a_bp + 3 * l_n, l_s, (a_scratch + 8 * l_n) + 5)
						end
					else
						(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp + 6 * l_n, a_ap + 3 * l_n, l_s, a_bp + 3 * l_n, l_s, (a_scratch + 8 * l_n) + 5)
					end
					l_break := True
				end
				l_break := False
			end
			(create {P_TOOM_INTERPOLATE_7PTS_STATIC}).gmpn_toom_interpolate_7pts (a_pp, l_n, l_flags, (a_scratch + 2 * l_n) + 1, (a_scratch + 6 * l_n) + 3, a_scratch, (a_scratch + 4 * l_n) + 2, l_s + l_t, (a_scratch + 8 * l_n) + 5)
		end

end
