class
	P_TOOM52_MUL_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpn_toom52_mul (a_pp, a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		require
			not a_pp.is_void
		local
			l_n: INTEGER_32
			l_s: INTEGER_32
			l_t: INTEGER_32
			l_flags: NATURAL_32
			l_tmp: NATURAL_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___2: CE_POINTER [NATURAL_32]
			l___dst___0: CE_POINTER [NATURAL_32]
			l___n___0: INTEGER_32
			l_tmp___6: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
		do
			if 2 * a_an >= 5 * a_bn then
				l_tmp := (a_an - 1).to_natural_32 // {NATURAL_32} 5
			else
				l_tmp := (((a_bn - 1)).bit_shift_right (1)).to_natural_32
			end
			l_n := ({NATURAL_32} 1 + l_tmp).to_integer_32
			l_s := a_an - 4 * l_n
			l_t := a_bn - l_n
			l_flags := ((2).bit_and (((create {P_TOOM_EVAL_PM2_STATIC}).gmpn_toom_eval_pm2 ((a_pp + 3 * l_n) + 3, (a_scratch + 4 * l_n) + 4, {NATURAL_32} 4, a_ap, l_n, l_s, (a_scratch + 3 * l_n) + 3)))).to_natural_32
			if l_t = l_n then
				a_pp[l_n] := (create {P_GMP_STATIC}).gmpn_add_n (a_pp, a_bp, a_bp + l_n, l_n)
				if ((create {P_GMP_STATIC}).gmpn_cmp (a_bp, a_bp + l_n, l_n)) < 0 then
					(create {P_GMP_STATIC}).gmpn_sub_n ((a_scratch + 2 * l_n) + 2, a_bp + l_n, a_bp, l_n).do_nothing
					l_flags := ((l_flags).bit_xor ({NATURAL_32} 1))
				else
					(create {P_GMP_STATIC}).gmpn_sub_n ((a_scratch + 2 * l_n) + 2, a_bp, a_bp + l_n, l_n).do_nothing
				end
			else
				a_pp[l_n] := (create {P_GMP_STATIC}).gmpn_add (a_pp, a_bp, l_n, a_bp + l_n, l_t)
				if ((create {P_GMP_IMPL_STATIC}).mpn_zero_p (a_bp + l_t, l_n - l_t)).to_boolean then
					if ((create {P_GMP_STATIC}).gmpn_cmp (a_bp, a_bp + l_n, l_t)) < 0 then
						(create {P_GMP_STATIC}).gmpn_sub_n ((a_scratch + 2 * l_n) + 2, a_bp + l_n, a_bp, l_t).do_nothing
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_n - l_t /= 0 then
								l___dst := ((a_scratch + 2 * l_n) + 2) + l_t
								l___n := l_n - l_t
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___2 := l___dst
									l___dst := l___dst + 1
									l_tmp___2.item := (0).to_natural_32
									l___n := l___n - 1
									if not l___n.to_boolean then
										l_break := True
									end
								end
								l_break := False
							end
							l_break := True
						end
						l_break := False
						l_flags := ((l_flags).bit_xor ({NATURAL_32} 1))
					else
						(create {P_GMP_STATIC}).gmpn_sub ((a_scratch + 2 * l_n) + 2, a_bp, l_n, a_bp + l_n, l_t).do_nothing
					end
				else
					(create {P_GMP_STATIC}).gmpn_sub ((a_scratch + 2 * l_n) + 2, a_bp, l_n, a_bp + l_n, l_t).do_nothing
				end
			end
			(create {P_GMP_STATIC}).gmpn_add ((a_pp + 2 * l_n) + 2, a_pp, l_n + 1, a_bp + l_n, l_t).do_nothing
			if ((l_flags).bit_and ({NATURAL_32} 1)).to_boolean then
				((a_pp + l_n) + 1)[l_n] := (create {P_GMP_STATIC}).gmpn_add ((a_pp + l_n) + 1, ((a_scratch + 2 * l_n) + 2), l_n, a_bp + l_n, l_t)
				l_flags := ((l_flags).bit_xor ({NATURAL_32} 2))
			else
				((a_pp + l_n) + 1)[l_n] := (0).to_natural_32
				if l_t = l_n then
					if ((create {P_GMP_STATIC}).gmpn_cmp (((a_scratch + 2 * l_n) + 2), a_bp + l_n, l_n)) < 0 then
						(create {P_GMP_STATIC}).gmpn_sub_n ((a_pp + l_n) + 1, a_bp + l_n, ((a_scratch + 2 * l_n) + 2), l_n).do_nothing
						l_flags := ((l_flags).bit_xor ({NATURAL_32} 2))
					else
						(create {P_GMP_STATIC}).gmpn_sub_n ((a_pp + l_n) + 1, ((a_scratch + 2 * l_n) + 2), a_bp + l_n, l_n).do_nothing
					end
				elseif ((create {P_GMP_IMPL_STATIC}).mpn_zero_p ((((a_scratch + 2 * l_n) + 2) + l_t), l_n - l_t)).to_boolean then
					if ((create {P_GMP_STATIC}).gmpn_cmp (((a_scratch + 2 * l_n) + 2), a_bp + l_n, l_t)) < 0 then
						(create {P_GMP_STATIC}).gmpn_sub_n ((a_pp + l_n) + 1, a_bp + l_n, ((a_scratch + 2 * l_n) + 2), l_t).do_nothing
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_n - l_t /= 0 then
								l___dst___0 := ((a_pp + l_n) + 1) + l_t
								l___n___0 := l_n - l_t
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___6 := l___dst___0
									l___dst___0 := l___dst___0 + 1
									l_tmp___6.item := (0).to_natural_32
									l___n___0 := l___n___0 - 1
									if not l___n___0.to_boolean then
										l_break := True
									end
								end
								l_break := False
							end
							l_break := True
						end
						l_break := False
						l_flags := ((l_flags).bit_xor ({NATURAL_32} 2))
					else
						(create {P_GMP_STATIC}).gmpn_sub ((a_pp + l_n) + 1, ((a_scratch + 2 * l_n) + 2), l_n, a_bp + l_n, l_t).do_nothing
					end
				else
					(create {P_GMP_STATIC}).gmpn_sub ((a_pp + l_n) + 1, ((a_scratch + 2 * l_n) + 2), l_n, a_bp + l_n, l_t).do_nothing
				end
			end
			l_flags := ((l_flags).bit_xor (((1).bit_and (((create {P_TOOM_EVAL_PM1_STATIC}).gmpn_toom_eval_pm1 ((a_pp + 4 * l_n) + 4, (a_scratch + 3 * l_n) + 3, {NATURAL_32} 4, a_ap, l_n, l_s, a_scratch)))).to_natural_32));
			(create {P_MUL_STATIC}).gmpn_mul (a_scratch, ((a_scratch + 3 * l_n) + 3), l_n + 1, ((a_scratch + 2 * l_n) + 2), l_n).do_nothing;
			(create {P_MUL_N_STATIC}).gmpn_mul_n ((a_scratch + 2 * l_n) + 1, ((a_scratch + 4 * l_n) + 4), ((a_pp + l_n) + 1), l_n + 1);
			(create {P_MUL_N_STATIC}).gmpn_mul_n ((a_scratch + 4 * l_n) + 2, ((a_pp + 3 * l_n) + 3), ((a_pp + 2 * l_n) + 2), l_n + 1);
			(create {P_MUL_N_STATIC}).gmpn_mul_n (a_pp + 2 * l_n, ((a_pp + 4 * l_n) + 4), a_pp, l_n + 1)
			if l_s > l_t then
				(create {P_MUL_STATIC}).gmpn_mul (a_pp + 5 * l_n, a_ap + 4 * l_n, l_s, a_bp + l_n, l_t).do_nothing
			else
				(create {P_MUL_STATIC}).gmpn_mul (a_pp + 5 * l_n, a_bp + l_n, l_t, a_ap + 4 * l_n, l_s).do_nothing
			end
			(create {P_MUL_N_STATIC}).gmpn_mul_n (a_pp, a_ap, a_bp, l_n);
			(create {P_TOOM_INTERPOLATE_6PTS_STATIC}).gmpn_toom_interpolate_6pts (a_pp, l_n, l_flags, a_scratch, (a_scratch + 2 * l_n) + 1, (a_scratch + 4 * l_n) + 2, l_t + l_s)
		end

end
