class
	P_TOOM_INTERPOLATE_12PTS_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	DO_mpn_sublsh_n___0 (a_dst, a_src: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_s: NATURAL_32; a_ws: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l___cy: NATURAL_32
		do
			l___cy := (create {P_GMP_STATIC}).gmpn_lshift (a_ws, a_src, a_n, a_s)
			Result := (l___cy + ((create {P_GMP_STATIC}).gmpn_sub_n (a_dst, a_dst, a_ws, a_n)))
		end

	gmpn_toom_interpolate_12pts (a_pp, a_r1, a_r3, a_r5: CE_POINTER [NATURAL_32]; a_n, a_spt: INTEGER_32; a_half: INTEGER_32; a_wsi: CE_POINTER [NATURAL_32])
		local
			l_spt: CE_ARRAY [INTEGER_32]
			l_n: CE_ARRAY [INTEGER_32]
			l_r3: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_pp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_r1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_r5: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_wsi: CE_POINTER [NATURAL_32]
			l_cy: CE_ARRAY [NATURAL_32]
			l_n3: CE_ARRAY [INTEGER_32]
			l_n3p1: INTEGER_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___cy: CE_ARRAY [NATURAL_32]
			l___ptr_dummy___1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___2: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___3: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___cy___0: CE_ARRAY [NATURAL_32]
			l___ptr_dummy___4: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___5: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___cy___1: CE_ARRAY [NATURAL_32]
			l___ptr_dummy___6: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___7: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l___cy___2: CE_ARRAY [NATURAL_32]
			l___ptr_dummy___8: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___9: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___mp_ptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			l_tmp___2: NATURAL_32
			l___ptr_dummy___10: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___11: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___12: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_spt.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_n.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_r3.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_pp.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_r1.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_r5.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_n3.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l___cy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___1.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___2.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___3.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l___cy___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___4.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___5.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l___cy___1.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___6.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___7.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l___cy___2.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___8.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___9.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___10.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___11.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___12.make (<<1>>)

			l_spt.item := a_spt
			l_n.item := a_n
			l_r3.item := a_r3
			l_pp.item := a_pp
			l_r1.item := a_r1
			l_r5.item := a_r5
			l_wsi := a_wsi
			l_n3.item := 3 * l_n.item
			l_n3p1 := l_n3.item + 1
			if a_half /= 0 then
				l_cy.item := (create {P_GMP_STATIC}).gmpn_sub_n (l_r3.item, l_r3.item, (l_pp.item + 11 * l_n.item), l_spt.item)
				from
				until
					(l_break)
				loop
					l_break := False
					asm177 (l___ptr_dummy, l_r3, l_spt, l_cy)
					l_break := True
				end
				l_break := False
				l_cy.item := DO_mpn_sublsh_n___0 (l_pp.item + 7 * l_n.item, (l_pp.item + 11 * l_n.item), l_spt.item, {NATURAL_32} 10, l_wsi)
				from
				until
					(l_break)
				loop
					l_break := False
					asm178 (l___ptr_dummy___0, l_pp, l_n, l_spt, l_cy)
					l_break := True
				end
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						asm179 (l___ptr_dummy___1, l_r5, l_pp, l_n)
						l_break := True
					end
					l_break := False
					l___cy.item := DO_mpn_sublsh_n___0 (l_r5.item, ((l_pp.item + 11 * l_n.item) + 1), l_spt.item - 1, {NATURAL_32} 30, l_wsi)
					from
					until
						(l_break)
					loop
						l_break := False
						asm180 (l___ptr_dummy___2, l_r5, l_spt, l___cy)
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
				l_cy.item := DO_mpn_sublsh_n___0 (l_r1.item, (l_pp.item + 11 * l_n.item), l_spt.item, {NATURAL_32} 20, l_wsi)
				from
				until
					(l_break)
				loop
					l_break := False
					asm181 (l___ptr_dummy___3, l_r1, l_spt, l_cy)
					l_break := True
				end
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						asm182 (l___ptr_dummy___4, l_pp, l_n3, l_n)
						l_break := True
					end
					l_break := False
					l___cy___0.item := DO_mpn_sublsh_n___0 (l_pp.item + l_n3.item, ((l_pp.item + 11 * l_n.item) + 1), l_spt.item - 1, {NATURAL_32} 28, l_wsi)
					from
					until
						(l_break)
					loop
						l_break := False
						asm183 (l___ptr_dummy___5, l_pp, l_n3, l_spt, l___cy___0)
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
			end
			(l_pp.item + l_n3.item)[l_n3.item] := (l_pp.item + l_n3.item)[l_n3.item] - (DO_mpn_sublsh_n___0 ((l_pp.item + l_n3.item) + l_n.item, l_pp.item, 2 * l_n.item, {NATURAL_32} 20, l_wsi))
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					asm184 (l___ptr_dummy___6, l_r1, l_n, l_pp)
					l_break := True
				end
				l_break := False
				l___cy___1.item := DO_mpn_sublsh_n___0 (l_r1.item + l_n.item, (l_pp.item + 1), 2 * l_n.item - 1, {NATURAL_32} 28, l_wsi)
				from
				until
					(l_break)
				loop
					l_break := False
					asm185 (l___ptr_dummy___7, l_r1, l_n, l___cy___1)
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False;
			(create {P_GMP_STATIC}).gmpn_add_n (l_wsi, l_r1.item, (l_pp.item + l_n3.item), l_n3p1).do_nothing;
			(create {P_GMP_STATIC}).gmpn_sub_n (l_pp.item + l_n3.item, (l_pp.item + l_n3.item), l_r1.item, l_n3p1).do_nothing
			from
			until
				(l_break)
			loop
				l_break := False
				l___mp_ptr_swap__tmp := l_r1.item
				l_r1.item := l_wsi
				l_wsi := l___mp_ptr_swap__tmp
				l_break := True
			end
			l_break := False
			l_r5.item[l_n3.item] := l_r5.item[l_n3.item] - (DO_mpn_sublsh_n___0 (l_r5.item + l_n.item, l_pp.item, 2 * l_n.item, {NATURAL_32} 10, l_wsi))
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					asm186 (l___ptr_dummy___8, l_pp, l_n)
					l_break := True
				end
				l_break := False
				l___cy___2.item := DO_mpn_sublsh_n___0 ((l_pp.item + 7 * l_n.item) + l_n.item, (l_pp.item + 1), 2 * l_n.item - 1, {NATURAL_32} 30, l_wsi)
				from
				until
					(l_break)
				loop
					l_break := False
					asm187 (l___ptr_dummy___9, l_pp, l_n, l___cy___2)
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False;
			(create {P_GMP_STATIC}).gmpn_sub_n (l_wsi, l_r5.item, (l_pp.item + 7 * l_n.item), l_n3p1).do_nothing;
			(create {P_GMP_STATIC}).gmpn_add_n (l_pp.item + 7 * l_n.item, (l_pp.item + 7 * l_n.item), l_r5.item, l_n3p1).do_nothing
			from
			until
				(l_break)
			loop
				l_break := False
				l___mp_ptr_swap__tmp___0 := l_r5.item
				l_r5.item := l_wsi
				l_wsi := l___mp_ptr_swap__tmp___0
				l_break := True
			end
			l_break := False
			l_r3.item[l_n3.item] := l_r3.item[l_n3.item] - ((create {P_GMP_STATIC}).gmpn_sub_n (l_r3.item + l_n.item, (l_r3.item + l_n.item), l_pp.item, 2 * l_n.item));
			(create {P_GMP_STATIC}).gmpn_submul_1 (l_pp.item + l_n3.item, l_r5.item, l_n3p1, (257).to_natural_32).do_nothing;
			(create {P_GMP_IMPL_STATIC}).gmpn_divexact_1 (l_pp.item + l_n3.item, (l_pp.item + l_n3.item), l_n3p1, ({NATURAL_32} 2_835).bit_shift_left (2))
			if (((l_pp.item + l_n3.item)[l_n3.item]).bit_and ((({NATURAL_32} 4_294_967_295).bit_shift_left (29)))) /= {NATURAL_32} 0 then
				(l_pp.item + l_n3.item)[l_n3.item] := ((l_pp.item + l_n3.item)[l_n3.item]).bit_or ((({NATURAL_32} 4_294_967_295).bit_shift_left (30)))
			end
			(create {P_GMP_STATIC}).gmpn_addmul_1 (l_r5.item, (l_pp.item + l_n3.item), l_n3p1, (60).to_natural_32).do_nothing
			l_tmp___2 := (create {P_GMP_IMPL_STATIC}).gmpn_bdiv_dbm1c (l_r5.item, l_r5.item, l_n3p1, {NATURAL_32} 16_843_009, (0).to_natural_32)
			DO_mpn_sublsh_n___0 (l_pp.item + 7 * l_n.item, l_r3.item, l_n3p1, {NATURAL_32} 5, l_wsi).do_nothing;
			(create {P_GMP_STATIC}).gmpn_submul_1 (l_r1.item, (l_pp.item + 7 * l_n.item), l_n3p1, (100).to_natural_32).do_nothing
			DO_mpn_sublsh_n___0 (l_r1.item, l_r3.item, l_n3p1, {NATURAL_32} 9, l_wsi).do_nothing;
			(create {P_GMP_IMPL_STATIC}).gmpn_divexact_1 (l_r1.item, l_r1.item, l_n3p1, (42_525).to_natural_32);
			(create {P_GMP_STATIC}).gmpn_submul_1 (l_pp.item + 7 * l_n.item, l_r1.item, l_n3p1, (225).to_natural_32).do_nothing;
			(create {P_GMP_IMPL_STATIC}).gmpn_divexact_1 (l_pp.item + 7 * l_n.item, (l_pp.item + 7 * l_n.item), l_n3p1, ({NATURAL_32} 9).bit_shift_left (2));
			(create {P_GMP_STATIC}).gmpn_sub_n (l_r3.item, l_r3.item, (l_pp.item + 7 * l_n.item), l_n3p1).do_nothing;
			(create {P_GMP_STATIC}).gmpn_sub_n (l_pp.item + l_n3.item, (l_pp.item + 7 * l_n.item), (l_pp.item + l_n3.item), l_n3p1).do_nothing;
			(create {P_GMP_STATIC}).gmpn_rshift (l_pp.item + l_n3.item, (l_pp.item + l_n3.item), l_n3p1, {NATURAL_32} 1).do_nothing;
			(create {P_GMP_STATIC}).gmpn_sub_n (l_pp.item + 7 * l_n.item, (l_pp.item + 7 * l_n.item), (l_pp.item + l_n3.item), l_n3p1).do_nothing;
			(create {P_GMP_STATIC}).gmpn_add_n (l_r5.item, l_r5.item, l_r1.item, l_n3p1).do_nothing;
			(create {P_GMP_STATIC}).gmpn_rshift (l_r5.item, l_r5.item, l_n3p1, {NATURAL_32} 1).do_nothing;
			(create {P_GMP_STATIC}).gmpn_sub_n (l_r3.item, l_r3.item, l_r1.item, l_n3p1).do_nothing;
			(create {P_GMP_STATIC}).gmpn_sub_n (l_r1.item, l_r1.item, l_r5.item, l_n3p1).do_nothing
			l_cy.item := (create {P_GMP_STATIC}).gmpn_add_n (l_pp.item + l_n.item, (l_pp.item + l_n.item), l_r5.item, l_n.item)
			l_cy.item := (create {P_GMP_STATIC}).gmpn_add_1 (l_pp.item + 2 * l_n.item, (l_r5.item + l_n.item), l_n.item, l_cy.item)
			l_cy.item := l_r5.item[l_n3.item] + ((create {P_GMP_IMPL_STATIC}).gmpn_add_nc (l_pp.item + l_n3.item, (l_pp.item + l_n3.item), (l_r5.item + 2 * l_n.item), l_n.item, l_cy.item))
			from
			until
				(l_break)
			loop
				l_break := False
				asm188 (l___ptr_dummy___10, l_pp, l_n3, l_n, l_cy)
				l_break := True
			end
			l_break := False
			l_pp.item[2 * l_n3.item] := l_pp.item[2 * l_n3.item] + ((create {P_GMP_STATIC}).gmpn_add_n (l_pp.item + 5 * l_n.item, (l_pp.item + 5 * l_n.item), l_r3.item, l_n.item))
			l_cy.item := (create {P_GMP_STATIC}).gmpn_add_1 (l_pp.item + 2 * l_n3.item, (l_r3.item + l_n.item), l_n.item, l_pp.item[2 * l_n3.item])
			l_cy.item := l_r3.item[l_n3.item] + ((create {P_GMP_IMPL_STATIC}).gmpn_add_nc (l_pp.item + 7 * l_n.item, (l_pp.item + 7 * l_n.item), (l_r3.item + 2 * l_n.item), l_n.item, l_cy.item))
			from
			until
				(l_break)
			loop
				l_break := False
				asm189 (l___ptr_dummy___11, l_pp, l_n, l_cy)
				l_break := True
			end
			l_break := False
			l_pp.item[10 * l_n.item] := l_pp.item[10 * l_n.item] + ((create {P_GMP_STATIC}).gmpn_add_n (l_pp.item + 9 * l_n.item, (l_pp.item + 9 * l_n.item), l_r1.item, l_n.item))
			if a_half.to_boolean then
				l_cy.item := (create {P_GMP_STATIC}).gmpn_add_1 (l_pp.item + 10 * l_n.item, (l_r1.item + l_n.item), l_n.item, l_pp.item[10 * l_n.item])
				if (builtin_expect ((l_spt.item > l_n.item).to_integer, 1)).to_boolean then
					l_cy.item := l_r1.item[l_n3.item] + ((create {P_GMP_IMPL_STATIC}).gmpn_add_nc (l_pp.item + 11 * l_n.item, (l_pp.item + 11 * l_n.item), (l_r1.item + 2 * l_n.item), l_n.item, l_cy.item))
					from
					until
						(l_break)
					loop
						l_break := False
						asm190 (l___ptr_dummy___12, l_pp, l_n3, l_cy)
						l_break := True
					end
					l_break := False
				else
					(create {P_GMP_IMPL_STATIC}).gmpn_add_nc (l_pp.item + 11 * l_n.item, (l_pp.item + 11 * l_n.item), (l_r1.item + 2 * l_n.item), l_spt.item, l_cy.item).do_nothing
				end
			else
				(create {P_GMP_STATIC}).gmpn_add_1 (l_pp.item + 10 * l_n.item, (l_r1.item + l_n.item), l_spt.item, l_pp.item[10 * l_n.item]).do_nothing
			end
		end

end
