class
	P_COVEYOU_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	ran_type___8: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("coveyou"), {NATURAL_32} 4_294_967_294, {NATURAL_32} 2, (create {PD_RAN_STATE_T}.make).structure_size.to_natural_32, ran_set___8_address, ran_get___8_address, ran_get_double___8_address])
				>>)
		end

	gsl_rng_coveyou: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := ran_type___8.item
		end

feature {ANY} -- public routines

	ran_get___8 (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RAN_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate)
			l_state.item.x := (l_state.item.x * (l_state.item.x + {NATURAL_32} 1)).bit_and ({NATURAL_32} 4_294_967_295)
			Result := (l_state.item.x)
		end

	ran_get_double___8 (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_state: CE_POINTER [PD_RAN_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate)
			Result := ((ran_get___8 (create {CE_VOID_POINTER}.make_cast (l_state))).to_real_64 / 4294967296.0)
		end

	ran_set___8 (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_RAN_STATE_T]
			l_diff: NATURAL_32
		do
			l_state := create {CE_CLASS_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate)
			l_diff := (a_s \\ {NATURAL_32} 4 - {NATURAL_32} 2) \\ {NATURAL_32} 4_294_967_295
			if l_diff.to_boolean then
				l_state.item.x := ((a_s - l_diff)).bit_and ({NATURAL_32} 4_294_967_295)
			else
				l_state.item.x := (a_s).bit_and ({NATURAL_32} 4_294_967_295)
			end
		end

feature {ANY} -- routine addresses

	ran_get___8_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran_get___8)
		end

	ran_get_double___8_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran_get_double___8)
		end

	ran_set___8_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran_set___8)
		end

end
