class
	P_DOGLEG_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	scaled_enorm___0 (a_d, a_f: CE_POINTER [PD_GSL_VECTOR]): REAL_64
		require
			not a_f.is_void
		local
			l_e2: REAL_64
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_fi: REAL_64
			l_di: REAL_64
			l_u: REAL_64
		do
			l_e2 := (0).to_double
			l_n := a_f.item.size
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_fi := (a_f.item.gsl_vector_get (l_i))
				l_di := (a_d.item.gsl_vector_get (l_i))
				l_u := l_di * l_fi
				l_e2 := l_e2 + (l_u * l_u)
				l_i := l_i + 1
			end
			Result := (sqrt (l_e2))
		end

	scaled_enorm___1 (a_d, a_f: CE_POINTER [PD_GSL_VECTOR]): REAL_64
		require
			not a_f.is_void
		local
			l_e2: REAL_64
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_fi: REAL_64
			l_di: REAL_64
			l_u: REAL_64
		do
			l_e2 := (0).to_double
			l_n := a_f.item.size
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_fi := (a_f.item.gsl_vector_get (l_i))
				l_di := (a_d.item.gsl_vector_get (l_i))
				l_u := l_di * l_fi
				l_e2 := l_e2 + (l_u * l_u)
				l_i := l_i + 1
			end
			Result := (sqrt (l_e2))
		end

end
