class
	P_FISHMAN2X_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	ran_type___2: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("fishman2x"), {NATURAL_32} 2_147_483_646, {NATURAL_32} 0, (create {PD_RAN_STATE_T_26__2}.make).structure_size.to_natural_32, ran_set___2_address, ran_get___2_address, ran_get_double___2_address])
				>>)
		end

	gsl_rng_fishman2x: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := ran_type___2.item
		end

feature {ANY} -- public routines

	ran_get___2 (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RAN_STATE_T_26__2]
			l_y: INTEGER_32
			l_r___3: INTEGER_32
		do
			l_state := create {CE_CLASS_POINTER [PD_RAN_STATE_T_26__2]}.make_cast (a_vstate)
			l_r___3 := ({NATURAL_32} 3_399 * (l_state.item.x // {NATURAL_32} 44_488)).to_integer_32
			l_y := ({NATURAL_32} 48_271 * (l_state.item.x \\ {NATURAL_32} 44_488) - l_r___3.to_natural_32).to_integer_32
			if l_y < 0 then
				l_y := (l_y.to_natural_32 + {NATURAL_32} 2_147_483_647).to_integer_32
			end
			l_state.item.x := l_y.to_natural_32
			l_r___3 := ({NATURAL_32} 3_791 * (l_state.item.y // {NATURAL_32} 52_774)).to_integer_32
			l_y := ({NATURAL_32} 40_692 * (l_state.item.y \\ {NATURAL_32} 52_774) - l_r___3.to_natural_32).to_integer_32
			if l_y < 0 then
				l_y := (l_y.to_natural_32 + {NATURAL_32} 2_147_483_399).to_integer_32
			end
			l_state.item.y := l_y.to_natural_32
			if l_state.item.x > l_state.item.y then
				l_state.item.z := l_state.item.x - l_state.item.y
			else
				l_state.item.z := ({NATURAL_32} 2_147_483_647 + l_state.item.x) - l_state.item.y
			end
			Result := (l_state.item.z)
		end

	ran_get_double___2 (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_state: CE_POINTER [PD_RAN_STATE_T_26__2]
		do
			l_state := create {CE_CLASS_POINTER [PD_RAN_STATE_T_26__2]}.make_cast (a_vstate)
			Result := ((ran_get___2 (create {CE_VOID_POINTER}.make_cast (l_state))).to_real_64 / 2147483647.0)
		end

	ran_set___2 (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RAN_STATE_T_26__2]
		do
			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_RAN_STATE_T_26__2]}.make_cast (a_vstate)
			if l_s \\ {NATURAL_32} 2_147_483_647 = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			elseif l_s \\ {NATURAL_32} 2_147_483_399 = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.x := l_s \\ {NATURAL_32} 2_147_483_647
			l_state.item.y := l_s \\ {NATURAL_32} 2_147_483_399
			if l_state.item.x > l_state.item.y then
				l_state.item.z := l_state.item.x - l_state.item.y
			else
				l_state.item.z := ({NATURAL_32} 2_147_483_647 + l_state.item.x) - l_state.item.y
			end
		end

feature {ANY} -- routine addresses

	ran_get___2_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran_get___2)
		end

	ran_get_double___2_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran_get_double___2)
		end

	ran_set___2_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran_set___2)
		end

end
