class
	P_GUMBEL2_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_cdf_gumbel2_P (a_x, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_P___2: REAL_64
			l_u: REAL_64
		do
			if a_x = (0).to_double then
				l_P___2 := (0).to_double
			else
				l_u := (pow (a_x, a_a___5))
				l_P___2 := exp (-a_b___0 / l_u)
			end
			Result := l_P___2
		end

	gsl_cdf_gumbel2_Q (a_x, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_Q___1: REAL_64
			l_u: REAL_64
		do
			if a_x = (0).to_double then
				l_Q___1 := (1).to_double
			else
				l_u := (pow (a_x, a_a___5))
				l_Q___1 := -(expm1 (-a_b___0 / l_u))
			end
			Result := l_Q___1
		end

end
