class
	P_INTEG_EVAL_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	integ_eval (a_ai, a_bi, a_ci, a_di, a_xi, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_r1___1: REAL_64
			l_r2___0: REAL_64
			l_r12: REAL_64
			l_bterm: REAL_64
			l_cterm: REAL_64
			l_dterm: REAL_64
		do
			l_r1___1 := a_a___5 - a_xi
			l_r2___0 := a_b___0 - a_xi
			l_r12 := l_r1___1 + l_r2___0
			l_bterm := (0.5 * a_bi) * l_r12
			l_cterm := ((1.0 / 3.0) * a_ci) * ((l_r1___1 * l_r1___1 + l_r2___0 * l_r2___0) + l_r1___1 * l_r2___0)
			l_dterm := ((0.25 * a_di) * l_r12) * (l_r1___1 * l_r1___1 + l_r2___0 * l_r2___0)
			Result := ((a_b___0 - a_a___5) * (((a_ai + l_bterm) + l_cterm) + l_dterm))
		end

end
