class
	P_LOG1P_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_log1p (a_x: REAL_64): REAL_64
		local
			l_y: REAL_64
			l_z: REAL_64
		do
			l_y := ((1).to_double + a_x)
			l_z := l_y - (1).to_double
			Result := ((log (l_y)) - ((l_z - a_x) / l_y))
		end

end
