class
	P_MAKE_REP_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	nybble: CE_STATIC [CE_ARRAY [CE_ARRAY [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_ARRAY_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("0000%/0/"),
					ce_string ("0001%/0/"),
					ce_string ("0010%/0/"),
					ce_string ("0011%/0/"),
					ce_string ("0100%/0/"),
					ce_string ("0101%/0/"),
					ce_string ("0110%/0/"),
					ce_string ("0111%/0/"),
					ce_string ("1000%/0/"),
					ce_string ("1001%/0/"),
					ce_string ("1010%/0/"),
					ce_string ("1011%/0/"),
					ce_string ("1100%/0/"),
					ce_string ("1101%/0/"),
					ce_string ("1110%/0/"),
					ce_string ("1111%/0/")
				>>)
		end

feature {ANY} -- public routines

	sprint_byte (a_i: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		require
			not a_s.is_void
		local
			l_c___1: CE_POINTER [INTEGER_8]
		do
			l_c___1 := nybble.item[(((a_i).bit_and (240))).bit_shift_right (4)]
			a_s[0] := l_c___1[0]
			a_s[1] := l_c___1[1]
			a_s[2] := l_c___1[2]
			a_s[3] := l_c___1[3]
			l_c___1 := nybble.item[(a_i).bit_and (15)]
			a_s[4] := l_c___1[0]
			a_s[5] := l_c___1[1]
			a_s[6] := l_c___1[2]
			a_s[7] := l_c___1[3]
		end

	determine_ieee_type (a_non_zero, a_exponent, a_max_exponent: INTEGER_32): INTEGER_32
		do
			if a_exponent = a_max_exponent then
				if a_non_zero.to_boolean then
					Result := 1
				else
					Result := 2
				end
			elseif a_exponent = 0 then
				if a_non_zero.to_boolean then
					Result := 4
				else
					Result := 5
				end
			else
				Result := 3
			end
		end

end
