class
	P_MT_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	UPPER_MASK: CE_STATIC [NATURAL_32]
		once ("PROCESS")
			Result.item := {NATURAL_32} 2_147_483_648
		end

	LOWER_MASK: CE_STATIC [NATURAL_32]
		once ("PROCESS")
			Result.item := {NATURAL_32} 2_147_483_647
		end

	mt_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("mt19937"), {NATURAL_32} 4_294_967_295, {NATURAL_32} 0, (create {PD_MT_STATE_T}.make).structure_size.to_natural_32, mt_set_address, mt_get_address, mt_get_double_address])
				>>)
		end

	mt_1999_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("mt19937_1999"), {NATURAL_32} 4_294_967_295, {NATURAL_32} 0, (create {PD_MT_STATE_T}.make).structure_size.to_natural_32, mt_1999_set_address, mt_get_address, mt_get_double_address])
				>>)
		end

	mt_1998_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("mt19937_1998"), {NATURAL_32} 4_294_967_295, {NATURAL_32} 0, (create {PD_MT_STATE_T}.make).structure_size.to_natural_32, mt_1998_set_address, mt_get_address, mt_get_double_address])
				>>)
		end

	gsl_rng_mt19937: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := mt_type.item
		end

	gsl_rng_mt19937_1999: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := mt_1999_type.item
		end

	gsl_rng_mt19937_1998: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := mt_1998_type.item
		end

	gsl_rng_default: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := mt_type.item
		end

	gsl_rng_default_seed: CE_STATIC [NATURAL_32]
		once ("PROCESS")
			Result.item := {NATURAL_32} 0
		end

feature {ANY} -- public routines

	mt_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_MT_STATE_T]
			l_k: NATURAL_32
			l_mt: CE_POINTER [NATURAL_32]
			l_kk: INTEGER_32
			l_y: NATURAL_32
			l_tmp: NATURAL_32
			l_y___0: NATURAL_32
			l_tmp___0: NATURAL_32
			l_y___1: NATURAL_32
			l_tmp___1: NATURAL_32
		do
			l_state := create {CE_CLASS_POINTER [PD_MT_STATE_T]}.make_cast (a_vstate)
			l_mt := l_state.item.mt
			if l_state.item.mti >= 624 then
				l_kk := 0
				from
				until
					not (l_kk < 227)
				loop
					l_y := (((l_mt[l_kk]).bit_and (UPPER_MASK.item))).bit_or (((l_mt[(l_kk + 1)]).bit_and (LOWER_MASK.item)))
					if ((l_y).bit_and ({NATURAL_32} 1)).to_boolean then
						l_tmp := {NATURAL_32} 2_567_483_615
					else
						l_tmp := {NATURAL_32} 0
					end
					l_mt[l_kk] := (((l_mt[(l_kk + 397)]).bit_xor (((l_y).bit_shift_right (1))))).bit_xor (l_tmp)
					l_kk := l_kk + 1
				end
				from
				until
					not (l_kk < 623)
				loop
					l_y___0 := (((l_mt[l_kk]).bit_and (UPPER_MASK.item))).bit_or (((l_mt[(l_kk + 1)]).bit_and (LOWER_MASK.item)))
					if ((l_y___0).bit_and ({NATURAL_32} 1)).to_boolean then
						l_tmp___0 := {NATURAL_32} 2_567_483_615
					else
						l_tmp___0 := {NATURAL_32} 0
					end
					l_mt[l_kk] := (((l_mt[(l_kk + -227)]).bit_xor (((l_y___0).bit_shift_right (1))))).bit_xor (l_tmp___0)
					l_kk := l_kk + 1
				end
				l_y___1 := (((l_mt[623]).bit_and (UPPER_MASK.item))).bit_or (((l_mt[0]).bit_and (LOWER_MASK.item)))
				if ((l_y___1).bit_and ({NATURAL_32} 1)).to_boolean then
					l_tmp___1 := {NATURAL_32} 2_567_483_615
				else
					l_tmp___1 := {NATURAL_32} 0
				end
				l_mt[623] := (((l_mt[396]).bit_xor (((l_y___1).bit_shift_right (1))))).bit_xor (l_tmp___1)
				l_state.item.mti := 0
			end
			l_k := l_mt[l_state.item.mti]
			l_k := (l_k).bit_xor (((l_k).bit_shift_right (11)))
			l_k := (l_k).bit_xor (((((l_k).bit_shift_left (7))).bit_and ({NATURAL_32} 2_636_928_640)))
			l_k := (l_k).bit_xor (((((l_k).bit_shift_left (15))).bit_and ({NATURAL_32} 4_022_730_752)))
			l_k := (l_k).bit_xor (((l_k).bit_shift_right (18)))
			l_state.item.mti := (l_state.item.mti) + 1
			Result := l_k
		end

	mt_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((mt_get (a_vstate)).to_real_64 / 4294967296.0)
		end

	mt_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_MT_STATE_T]
			l_i: INTEGER_32
		do
			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_MT_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 4_357
			end
			l_state.item.mt[0] := (l_s).bit_and ({NATURAL_32} 4_294_967_295)
			l_i := 1
			from
			until
				not (l_i < 624)
			loop
				l_state.item.mt[l_i] := {NATURAL_32} 1_812_433_253 * ((l_state.item.mt[l_i - 1]).bit_xor (((l_state.item.mt[l_i - 1]).bit_shift_right (30)))) + l_i.to_natural_32
				l_state.item.mt[l_i] := (l_state.item.mt[l_i]).bit_and (({NATURAL_32} 4_294_967_295))
				l_i := l_i + 1
			end
			l_state.item.mti := l_i
		end

	mt_1999_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_MT_STATE_T]
			l_i: INTEGER_32
		do
			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_MT_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 4_357
			end
			l_i := 0
			from
			until
				not (l_i < 624)
			loop
				l_state.item.mt[l_i] := (l_s).bit_and ({NATURAL_32} 4_294_901_760)
				l_s := (({NATURAL_32} 69_069 * l_s + {NATURAL_32} 1)).bit_and ({NATURAL_32} 4_294_967_295)
				l_state.item.mt[l_i] := (l_state.item.mt[l_i]).bit_or (((((l_s).bit_and ({NATURAL_32} 4_294_901_760))).bit_shift_right (16)))
				l_s := (({NATURAL_32} 69_069 * l_s + {NATURAL_32} 1)).bit_and ({NATURAL_32} 4_294_967_295)
				l_i := l_i + 1
			end
			l_state.item.mti := l_i
		end

	mt_1998_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_MT_STATE_T]
			l_i: INTEGER_32
		do
			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_MT_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 4_357
			end
			l_state.item.mt[0] := (l_s).bit_and ({NATURAL_32} 4_294_967_295)
			l_i := 1
			from
			until
				not (l_i < 624)
			loop
				l_state.item.mt[l_i] := ({NATURAL_32} 69_069 * l_state.item.mt[l_i - 1]).bit_and ({NATURAL_32} 4_294_967_295)
				l_i := l_i + 1
			end
			l_state.item.mti := l_i
		end

feature {ANY} -- routine addresses

	mt_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent mt_get)
		end

	mt_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent mt_get_double)
		end

	mt_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent mt_set)
		end

	mt_1999_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent mt_1999_set)
		end

	mt_1998_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent mt_1998_set)
		end

end
