class
	P_QRNG_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_STRING_STATIC

feature {ANY} -- public routines

	gsl_qrng_alloc (a_T: CE_POINTER [PD_GSL_QRNG_TYPE]; a_dimension: NATURAL_32): CE_POINTER [PD_GSL_QRNG]
		local
			l_q___3: CE_POINTER [PD_GSL_QRNG]
			l_return, l_break: BOOLEAN
		do
			l_q___3 := create {CE_CLASS_POINTER [PD_GSL_QRNG]}.make_cast ((malloc ((create {PD_GSL_QRNG}.make).structure_size.to_natural_32)))
			if l_q___3.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("allocation failed for qrng struct"), ce_string ("qrng.c"), 19, 8)
					Result := (create {CE_CLASS_POINTER [PD_GSL_QRNG]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_q___3.item.dimension := a_dimension
				l_q___3.item.state_size := (a_T.item.state_size).natural_32_item ([a_dimension])
				l_q___3.item.state := malloc (l_q___3.item.state_size)
				if (l_q___3.item.state).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_q___3))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("allocation failed for qrng state"), ce_string ("qrng.c"), 30, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_QRNG]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_q___3.item.type := a_T;
				(a_T.item.init_state).call ([l_q___3.item.state, l_q___3.item.dimension])
				Result := l_q___3
			end
		end

	gsl_qrng_clone (a_q___3: CE_POINTER [PD_GSL_QRNG]): CE_POINTER [PD_GSL_QRNG]
		local
			l_r___3: CE_POINTER [PD_GSL_QRNG]
			l_return, l_break: BOOLEAN
		do
			l_r___3 := create {CE_CLASS_POINTER [PD_GSL_QRNG]}.make_cast ((malloc ((create {PD_GSL_QRNG}.make).structure_size.to_natural_32)))
			if l_r___3.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for rng struct"), ce_string ("qrng.c"), 70, 8)
					Result := (create {CE_CLASS_POINTER [PD_GSL_QRNG]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_r___3.item.dimension := a_q___3.item.dimension
				l_r___3.item.state_size := a_q___3.item.state_size
				l_r___3.item.state := malloc (l_r___3.item.state_size)
				if (l_r___3.item.state).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_r___3))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for rng state"), ce_string ("qrng.c"), 81, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_QRNG]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_r___3.item.type := a_q___3.item.type
				memcpy (l_r___3.item.state, a_q___3.item.state, a_q___3.item.state_size).do_nothing
				Result := l_r___3
			end
		end

	gsl_qrng_free (a_q___3: CE_POINTER [PD_GSL_QRNG])
		local
			l_return: BOOLEAN
		do
			if a_q___3.is_void then
				l_return := True
			end
			if not l_return then
				if not (a_q___3.item.state).is_void then
					free (a_q___3.item.state)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_q___3))
			end
		end

end
