class
	PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- routine addresses

	vector_bfgs_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [REAL_64]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_step_size, a_tol: REAL_64): INTEGER_32
				do
					Result := a_fdf.item.vector_bfgs_set (a_vstate, a_x, a_f, a_gradient, a_step_size, a_tol)
				end)
		end

	conjugate_pr_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [REAL_64]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_step_size, a_tol: REAL_64): INTEGER_32
				do
					Result := a_fdf.item.conjugate_pr_set (a_vstate, a_x, a_f, a_gradient, a_step_size, a_tol)
				end)
		end

	steepest_descent_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [REAL_64]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_step_size, a_tol: REAL_64): INTEGER_32
				do
					Result := a_fdf.item.steepest_descent_set (a_vstate, a_x, a_f, a_gradient, a_step_size, a_tol)
				end)
		end

	conjugate_fr_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [REAL_64]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_step_size, a_tol: REAL_64): INTEGER_32
				do
					Result := a_fdf.item.conjugate_fr_set (a_vstate, a_x, a_f, a_gradient, a_step_size, a_tol)
				end)
		end

	vector_bfgs2_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [REAL_64]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_step_size, a_tol: REAL_64): INTEGER_32
				do
					Result := a_fdf.item.vector_bfgs2_set (a_vstate, a_x, a_f, a_gradient, a_step_size, a_tol)
				end)
		end

end
