class
	PD_GSL_WAVELET_TYPE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} name.make
			create init.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	init: CE_ROUTINE assign set_init

feature {ANY} -- field setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_init (a_init: CE_ROUTINE)
		do
			init := a_init
			update_memory_field ("init")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			init := a_other.init
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				init.is_equal (a_other.init)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("init")
				>>)
			init_structure_info
		end

end
